// Begin of spicy_init (from "<root>")
// Compiled by HILTI version 1.13.0-dev.2

#include <hilti/rt/compiler-setup.h>

#include <spicy/rt/libspicy.h>
#include <hilti/rt/libhilti.h>
#include <zeek/spicy/runtime-support.h>

extern const char* __hlt_ldap_hlto_scope;

namespace zeek::spicy::rt {
    extern void register_spicy_module_begin(const std::string& name, const std::string& description);
    extern void register_spicy_module_end();
}

namespace __hlt_ldap::spicy_init {
    extern void zeek_preinit();
    extern void __preinit_module();
    extern void __register_module();
}

HILTI_PRE_INIT(__hlt_ldap::spicy_init::__register_module)

extern void __hlt_ldap::spicy_init::__preinit_module() { __hlt_ldap::spicy_init::zeek_preinit(); }

extern void __hlt_ldap::spicy_init::__register_module() {
    ::hilti::rt::detail::registerModule({ "spicy_init", __hlt_ldap_hlto_scope, nullptr, nullptr, nullptr, nullptr});
    __preinit_module();
}

extern void __hlt_ldap::spicy_init::zeek_preinit() {
    ::zeek::spicy::rt::register_spicy_module_begin("Zeek::LDAP"s, "LDAP analyzer"s);
    ::zeek::spicy::rt::register_protocol_analyzer("LDAP_TCP"s, ::hilti::rt::Protocol{::hilti::rt::Protocol::TCP}, ::hilti::rt::Vector<::zeek::spicy::rt::PortRange>({}), "LDAP::Messages"s, "LDAP::Messages"s, ""s, std::string(__hlt_ldap_hlto_scope));
    ::zeek::spicy::rt::register_protocol_analyzer("LDAP_UDP"s, ::hilti::rt::Protocol{::hilti::rt::Protocol::UDP}, ::hilti::rt::Vector<::zeek::spicy::rt::PortRange>({}), "LDAP::Messages"s, "LDAP::Messages"s, ""s, std::string(__hlt_ldap_hlto_scope));
    ::zeek::spicy::rt::install_handler("LDAP::message"s);
    ::zeek::spicy::rt::install_handler("LDAP::bind_request"s);
    ::zeek::spicy::rt::install_handler("LDAP::search_request"s);
    ::zeek::spicy::rt::install_handler("LDAP::search_result_entry"s);
    ::zeek::spicy::rt::install_handler("LDAP::extended_request"s);
    ::zeek::spicy::rt::install_handler("LDAP::extended_response"s);
    ::zeek::spicy::rt::install_handler("LDAP::starttls"s);

    // Creating Zeek type LDAP::ProtocolOpcode;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_LDAP_ProtocolOpcode;
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("BIND_REQUEST"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("BIND_RESPONSE"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("UNBIND_REQUEST"sv, ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("SEARCH_REQUEST"sv, ::hilti::rt::integer::safe<std::int64_t>{3}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("SEARCH_RESULT_ENTRY"sv, ::hilti::rt::integer::safe<std::int64_t>{4}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("SEARCH_RESULT_DONE"sv, ::hilti::rt::integer::safe<std::int64_t>{5}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("MODIFY_REQUEST"sv, ::hilti::rt::integer::safe<std::int64_t>{6}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("MODIFY_RESPONSE"sv, ::hilti::rt::integer::safe<std::int64_t>{7}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("ADD_REQUEST"sv, ::hilti::rt::integer::safe<std::int64_t>{8}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("ADD_RESPONSE"sv, ::hilti::rt::integer::safe<std::int64_t>{9}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("DEL_REQUEST"sv, ::hilti::rt::integer::safe<std::int64_t>{10}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("DEL_RESPONSE"sv, ::hilti::rt::integer::safe<std::int64_t>{11}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("MOD_DN_REQUEST"sv, ::hilti::rt::integer::safe<std::int64_t>{12}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("MOD_DN_RESPONSE"sv, ::hilti::rt::integer::safe<std::int64_t>{13}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("COMPARE_REQUEST"sv, ::hilti::rt::integer::safe<std::int64_t>{14}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("COMPARE_RESPONSE"sv, ::hilti::rt::integer::safe<std::int64_t>{15}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("ABANDON_REQUEST"sv, ::hilti::rt::integer::safe<std::int64_t>{16}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("SEARCH_RESULT_REFERENCE"sv, ::hilti::rt::integer::safe<std::int64_t>{19}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("EXTENDED_REQUEST"sv, ::hilti::rt::integer::safe<std::int64_t>{23}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("EXTENDED_RESPONSE"sv, ::hilti::rt::integer::safe<std::int64_t>{24}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("INTERMEDIATE_RESPONSE"sv, ::hilti::rt::integer::safe<std::int64_t>{25}));
    __labels_LDAP_ProtocolOpcode.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_LDAP_ProtocolOpcode = ::zeek::spicy::rt::create_enum_type("LDAP"s, "ProtocolOpcode"s, __labels_LDAP_ProtocolOpcode);
    ::zeek::spicy::rt::register_type("LDAP"s, "ProtocolOpcode"s, __type_LDAP_ProtocolOpcode);

    // Creating Zeek type LDAP::ResultCode;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_LDAP_ResultCode;
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("SUCCESS"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("OPERATIONS_ERROR"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("PROTOCOL_ERROR"sv, ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("TIME_LIMIT_EXCEEDED"sv, ::hilti::rt::integer::safe<std::int64_t>{3}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("SIZE_LIMIT_EXCEEDED"sv, ::hilti::rt::integer::safe<std::int64_t>{4}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("COMPARE_FALSE"sv, ::hilti::rt::integer::safe<std::int64_t>{5}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("COMPARE_TRUE"sv, ::hilti::rt::integer::safe<std::int64_t>{6}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("AUTH_METHOD_NOT_SUPPORTED"sv, ::hilti::rt::integer::safe<std::int64_t>{7}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("STRONGER_AUTH_REQUIRED"sv, ::hilti::rt::integer::safe<std::int64_t>{8}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("PARTIAL_RESULTS"sv, ::hilti::rt::integer::safe<std::int64_t>{9}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("REFERRAL"sv, ::hilti::rt::integer::safe<std::int64_t>{10}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("ADMIN_LIMIT_EXCEEDED"sv, ::hilti::rt::integer::safe<std::int64_t>{11}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("UNAVAILABLE_CRITICAL_EXTENSION"sv, ::hilti::rt::integer::safe<std::int64_t>{12}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("CONFIDENTIALITY_REQUIRED"sv, ::hilti::rt::integer::safe<std::int64_t>{13}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("SASL_BIND_IN_PROGRESS"sv, ::hilti::rt::integer::safe<std::int64_t>{14}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("NO_SUCH_ATTRIBUTE"sv, ::hilti::rt::integer::safe<std::int64_t>{16}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("UNDEFINED_ATTRIBUTE_TYPE"sv, ::hilti::rt::integer::safe<std::int64_t>{17}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("INAPPROPRIATE_MATCHING"sv, ::hilti::rt::integer::safe<std::int64_t>{18}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("CONSTRAINT_VIOLATION"sv, ::hilti::rt::integer::safe<std::int64_t>{19}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("ATTRIBUTE_OR_VALUE_EXISTS"sv, ::hilti::rt::integer::safe<std::int64_t>{20}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("INVALID_ATTRIBUTE_SYNTAX"sv, ::hilti::rt::integer::safe<std::int64_t>{21}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("NO_SUCH_OBJECT"sv, ::hilti::rt::integer::safe<std::int64_t>{32}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("ALIAS_PROBLEM"sv, ::hilti::rt::integer::safe<std::int64_t>{33}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("INVALID_DNSYNTAX"sv, ::hilti::rt::integer::safe<std::int64_t>{34}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("ALIAS_DEREFERENCING_PROBLEM"sv, ::hilti::rt::integer::safe<std::int64_t>{36}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("INAPPROPRIATE_AUTHENTICATION"sv, ::hilti::rt::integer::safe<std::int64_t>{48}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("INVALID_CREDENTIALS"sv, ::hilti::rt::integer::safe<std::int64_t>{49}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("INSUFFICIENT_ACCESS_RIGHTS"sv, ::hilti::rt::integer::safe<std::int64_t>{50}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("BUSY"sv, ::hilti::rt::integer::safe<std::int64_t>{51}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("UNAVAILABLE"sv, ::hilti::rt::integer::safe<std::int64_t>{52}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("UNWILLING_TO_PERFORM"sv, ::hilti::rt::integer::safe<std::int64_t>{53}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("LOOP_DETECT"sv, ::hilti::rt::integer::safe<std::int64_t>{54}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("SORT_CONTROL_MISSING"sv, ::hilti::rt::integer::safe<std::int64_t>{60}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("OFFSET_RANGE_ERROR"sv, ::hilti::rt::integer::safe<std::int64_t>{61}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("NAMING_VIOLATION"sv, ::hilti::rt::integer::safe<std::int64_t>{64}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("OBJECT_CLASS_VIOLATION"sv, ::hilti::rt::integer::safe<std::int64_t>{65}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("NOT_ALLOWED_ON_NON_LEAF"sv, ::hilti::rt::integer::safe<std::int64_t>{66}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("NOT_ALLOWED_ON_RDN"sv, ::hilti::rt::integer::safe<std::int64_t>{67}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("ENTRY_ALREADY_EXISTS"sv, ::hilti::rt::integer::safe<std::int64_t>{68}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("OBJECT_CLASS_MODS_PROHIBITED"sv, ::hilti::rt::integer::safe<std::int64_t>{69}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("RESULTS_TOO_LARGE"sv, ::hilti::rt::integer::safe<std::int64_t>{70}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("AFFECTS_MULTIPLE_DSAS"sv, ::hilti::rt::integer::safe<std::int64_t>{71}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("CONTROL_ERROR"sv, ::hilti::rt::integer::safe<std::int64_t>{76}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("OTHER"sv, ::hilti::rt::integer::safe<std::int64_t>{80}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("SERVER_DOWN"sv, ::hilti::rt::integer::safe<std::int64_t>{81}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("LOCAL_ERROR"sv, ::hilti::rt::integer::safe<std::int64_t>{82}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("ENCODING_ERROR"sv, ::hilti::rt::integer::safe<std::int64_t>{83}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("DECODING_ERROR"sv, ::hilti::rt::integer::safe<std::int64_t>{84}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("TIMEOUT"sv, ::hilti::rt::integer::safe<std::int64_t>{85}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("AUTH_UNKNOWN"sv, ::hilti::rt::integer::safe<std::int64_t>{86}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("FILTER_ERROR"sv, ::hilti::rt::integer::safe<std::int64_t>{87}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("USER_CANCELED"sv, ::hilti::rt::integer::safe<std::int64_t>{88}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("PARAM_ERROR"sv, ::hilti::rt::integer::safe<std::int64_t>{89}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("NO_MEMORY"sv, ::hilti::rt::integer::safe<std::int64_t>{90}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("CONNECT_ERROR"sv, ::hilti::rt::integer::safe<std::int64_t>{91}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("NOT_SUPPORTED"sv, ::hilti::rt::integer::safe<std::int64_t>{92}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("CONTROL_NOT_FOUND"sv, ::hilti::rt::integer::safe<std::int64_t>{93}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("NO_RESULTS_RETURNED"sv, ::hilti::rt::integer::safe<std::int64_t>{94}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("MORE_RESULTS_TO_RETURN"sv, ::hilti::rt::integer::safe<std::int64_t>{95}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("CLIENT_LOOP"sv, ::hilti::rt::integer::safe<std::int64_t>{96}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("REFERRAL_LIMIT_EXCEEDED"sv, ::hilti::rt::integer::safe<std::int64_t>{97}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("INVALID_RESPONSE"sv, ::hilti::rt::integer::safe<std::int64_t>{100}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("AMBIGUOUS_RESPONSE"sv, ::hilti::rt::integer::safe<std::int64_t>{101}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("TLS_NOT_SUPPORTED"sv, ::hilti::rt::integer::safe<std::int64_t>{112}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("INTERMEDIATE_RESPONSE"sv, ::hilti::rt::integer::safe<std::int64_t>{113}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("UNKNOWN_TYPE"sv, ::hilti::rt::integer::safe<std::int64_t>{114}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("LCUP_INVALID_DATA"sv, ::hilti::rt::integer::safe<std::int64_t>{115}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("LCUP_UNSUPPORTED_SCHEME"sv, ::hilti::rt::integer::safe<std::int64_t>{116}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("LCUP_RELOAD_REQUIRED"sv, ::hilti::rt::integer::safe<std::int64_t>{117}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("CANCELED"sv, ::hilti::rt::integer::safe<std::int64_t>{118}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("NO_SUCH_OPERATION"sv, ::hilti::rt::integer::safe<std::int64_t>{119}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("TOO_LATE"sv, ::hilti::rt::integer::safe<std::int64_t>{120}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("CANNOT_CANCEL"sv, ::hilti::rt::integer::safe<std::int64_t>{121}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("ASSERTION_FAILED"sv, ::hilti::rt::integer::safe<std::int64_t>{122}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("AUTHORIZATION_DENIED"sv, ::hilti::rt::integer::safe<std::int64_t>{123}));
    __labels_LDAP_ResultCode.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_LDAP_ResultCode = ::zeek::spicy::rt::create_enum_type("LDAP"s, "ResultCode"s, __labels_LDAP_ResultCode);
    ::zeek::spicy::rt::register_type("LDAP"s, "ResultCode"s, __type_LDAP_ResultCode);

    // Creating Zeek type LDAP::BindAuthType;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_LDAP_BindAuthType;
    __labels_LDAP_BindAuthType.emplace_back(std::make_tuple("BIND_AUTH_SIMPLE"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_LDAP_BindAuthType.emplace_back(std::make_tuple("BIND_AUTH_SASL"sv, ::hilti::rt::integer::safe<std::int64_t>{3}));
    __labels_LDAP_BindAuthType.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_LDAP_BindAuthType = ::zeek::spicy::rt::create_enum_type("LDAP"s, "BindAuthType"s, __labels_LDAP_BindAuthType);
    ::zeek::spicy::rt::register_type("LDAP"s, "BindAuthType"s, __type_LDAP_BindAuthType);

    // Creating Zeek type LDAP::SearchScope;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_LDAP_SearchScope;
    __labels_LDAP_SearchScope.emplace_back(std::make_tuple("SEARCH_BASE"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_LDAP_SearchScope.emplace_back(std::make_tuple("SEARCH_SINGLE"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_LDAP_SearchScope.emplace_back(std::make_tuple("SEARCH_TREE"sv, ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_LDAP_SearchScope.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_LDAP_SearchScope = ::zeek::spicy::rt::create_enum_type("LDAP"s, "SearchScope"s, __labels_LDAP_SearchScope);
    ::zeek::spicy::rt::register_type("LDAP"s, "SearchScope"s, __type_LDAP_SearchScope);

    // Creating Zeek type LDAP::SearchDerefAlias;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_LDAP_SearchDerefAlias;
    __labels_LDAP_SearchDerefAlias.emplace_back(std::make_tuple("DEREF_NEVER"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_LDAP_SearchDerefAlias.emplace_back(std::make_tuple("DEREF_IN_SEARCHING"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_LDAP_SearchDerefAlias.emplace_back(std::make_tuple("DEREF_FINDING_BASE"sv, ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_LDAP_SearchDerefAlias.emplace_back(std::make_tuple("DEREF_ALWAYS"sv, ::hilti::rt::integer::safe<std::int64_t>{3}));
    __labels_LDAP_SearchDerefAlias.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_LDAP_SearchDerefAlias = ::zeek::spicy::rt::create_enum_type("LDAP"s, "SearchDerefAlias"s, __labels_LDAP_SearchDerefAlias);
    ::zeek::spicy::rt::register_type("LDAP"s, "SearchDerefAlias"s, __type_LDAP_SearchDerefAlias);

    // Creating Zeek type ASN1::ASN1Type;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_ASN1_ASN1Type;
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("Boolean"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("Integer"sv, ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("BitString"sv, ::hilti::rt::integer::safe<std::int64_t>{3}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("OctetString"sv, ::hilti::rt::integer::safe<std::int64_t>{4}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("NullVal"sv, ::hilti::rt::integer::safe<std::int64_t>{5}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("ObjectIdentifier"sv, ::hilti::rt::integer::safe<std::int64_t>{6}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("ObjectDescriptor"sv, ::hilti::rt::integer::safe<std::int64_t>{7}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("InstanceOf"sv, ::hilti::rt::integer::safe<std::int64_t>{8}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("Real"sv, ::hilti::rt::integer::safe<std::int64_t>{9}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("Enumerated"sv, ::hilti::rt::integer::safe<std::int64_t>{10}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("EmbeddedPDV"sv, ::hilti::rt::integer::safe<std::int64_t>{11}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("UTF8String"sv, ::hilti::rt::integer::safe<std::int64_t>{12}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("RelativeOID"sv, ::hilti::rt::integer::safe<std::int64_t>{13}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("Sequence"sv, ::hilti::rt::integer::safe<std::int64_t>{16}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("Set"sv, ::hilti::rt::integer::safe<std::int64_t>{17}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("NumericString"sv, ::hilti::rt::integer::safe<std::int64_t>{18}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("PrintableString"sv, ::hilti::rt::integer::safe<std::int64_t>{19}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("TeletextString"sv, ::hilti::rt::integer::safe<std::int64_t>{20}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("VideotextString"sv, ::hilti::rt::integer::safe<std::int64_t>{21}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("IA5String"sv, ::hilti::rt::integer::safe<std::int64_t>{22}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("UTCTime"sv, ::hilti::rt::integer::safe<std::int64_t>{23}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("GeneralizedTime"sv, ::hilti::rt::integer::safe<std::int64_t>{24}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("GraphicString"sv, ::hilti::rt::integer::safe<std::int64_t>{25}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("VisibleString"sv, ::hilti::rt::integer::safe<std::int64_t>{26}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("GeneralString"sv, ::hilti::rt::integer::safe<std::int64_t>{27}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("UniversalString"sv, ::hilti::rt::integer::safe<std::int64_t>{28}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("CharacterString"sv, ::hilti::rt::integer::safe<std::int64_t>{29}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("BMPString"sv, ::hilti::rt::integer::safe<std::int64_t>{30}));
    __labels_ASN1_ASN1Type.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_ASN1_ASN1Type = ::zeek::spicy::rt::create_enum_type("ASN1"s, "ASN1Type"s, __labels_ASN1_ASN1Type);
    ::zeek::spicy::rt::register_type("ASN1"s, "ASN1Type"s, __type_ASN1_ASN1Type);

    // Creating Zeek type ASN1::ASN1Class;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_ASN1_ASN1Class;
    __labels_ASN1_ASN1Class.emplace_back(std::make_tuple("Universal"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_ASN1_ASN1Class.emplace_back(std::make_tuple("Application"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_ASN1_ASN1Class.emplace_back(std::make_tuple("ContextSpecific"sv, ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_ASN1_ASN1Class.emplace_back(std::make_tuple("Private"sv, ::hilti::rt::integer::safe<std::int64_t>{3}));
    __labels_ASN1_ASN1Class.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_ASN1_ASN1Class = ::zeek::spicy::rt::create_enum_type("ASN1"s, "ASN1Class"s, __labels_ASN1_ASN1Class);
    ::zeek::spicy::rt::register_type("ASN1"s, "ASN1Class"s, __type_ASN1_ASN1Class);

    // Creating Zeek type spicy::AddressFamily;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_AddressFamily;
    __labels_spicy_AddressFamily.emplace_back(std::make_tuple("IPv4"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_AddressFamily.emplace_back(std::make_tuple("IPv6"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_AddressFamily.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_AddressFamily = ::zeek::spicy::rt::create_enum_type("spicy"s, "AddressFamily"s, __labels_spicy_AddressFamily);
    ::zeek::spicy::rt::register_type("spicy"s, "AddressFamily"s, __type_spicy_AddressFamily);

    // Creating Zeek type spicy::BitOrder;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_BitOrder;
    __labels_spicy_BitOrder.emplace_back(std::make_tuple("LSB0"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_BitOrder.emplace_back(std::make_tuple("MSB0"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_BitOrder.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_BitOrder = ::zeek::spicy::rt::create_enum_type("spicy"s, "BitOrder"s, __labels_spicy_BitOrder);
    ::zeek::spicy::rt::register_type("spicy"s, "BitOrder"s, __type_spicy_BitOrder);

    // Creating Zeek type spicy::ByteOrder;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_ByteOrder;
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple("Little"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple("Big"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple("Network"sv, ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple("Host"sv, ::hilti::rt::integer::safe<std::int64_t>{3}));
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_ByteOrder = ::zeek::spicy::rt::create_enum_type("spicy"s, "ByteOrder"s, __labels_spicy_ByteOrder);
    ::zeek::spicy::rt::register_type("spicy"s, "ByteOrder"s, __type_spicy_ByteOrder);

    // Creating Zeek type spicy::Charset;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_Charset;
    __labels_spicy_Charset.emplace_back(std::make_tuple("ASCII"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_Charset.emplace_back(std::make_tuple("UTF8"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_Charset.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_Charset = ::zeek::spicy::rt::create_enum_type("spicy"s, "Charset"s, __labels_spicy_Charset);
    ::zeek::spicy::rt::register_type("spicy"s, "Charset"s, __type_spicy_Charset);

    // Creating Zeek type spicy::DecodeErrorStrategy;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_DecodeErrorStrategy;
    __labels_spicy_DecodeErrorStrategy.emplace_back(std::make_tuple("IGNORE"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_DecodeErrorStrategy.emplace_back(std::make_tuple("REPLACE"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_DecodeErrorStrategy.emplace_back(std::make_tuple("STRICT"sv, ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_spicy_DecodeErrorStrategy.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_DecodeErrorStrategy = ::zeek::spicy::rt::create_enum_type("spicy"s, "DecodeErrorStrategy"s, __labels_spicy_DecodeErrorStrategy);
    ::zeek::spicy::rt::register_type("spicy"s, "DecodeErrorStrategy"s, __type_spicy_DecodeErrorStrategy);

    // Creating Zeek type spicy::Protocol;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_Protocol;
    __labels_spicy_Protocol.emplace_back(std::make_tuple("TCP"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_Protocol.emplace_back(std::make_tuple("UDP"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_Protocol.emplace_back(std::make_tuple("ICMP"sv, ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_spicy_Protocol.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_Protocol = ::zeek::spicy::rt::create_enum_type("spicy"s, "Protocol"s, __labels_spicy_Protocol);
    ::zeek::spicy::rt::register_type("spicy"s, "Protocol"s, __type_spicy_Protocol);

    // Creating Zeek type spicy::RealType;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_RealType;
    __labels_spicy_RealType.emplace_back(std::make_tuple("IEEE754_Single"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_RealType.emplace_back(std::make_tuple("IEEE754_Double"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_RealType.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_RealType = ::zeek::spicy::rt::create_enum_type("spicy"s, "RealType"s, __labels_spicy_RealType);
    ::zeek::spicy::rt::register_type("spicy"s, "RealType"s, __type_spicy_RealType);

    // Creating Zeek type spicy::ReassemblerPolicy;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_ReassemblerPolicy;
    __labels_spicy_ReassemblerPolicy.emplace_back(std::make_tuple("First"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_ReassemblerPolicy.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_ReassemblerPolicy = ::zeek::spicy::rt::create_enum_type("spicy"s, "ReassemblerPolicy"s, __labels_spicy_ReassemblerPolicy);
    ::zeek::spicy::rt::register_type("spicy"s, "ReassemblerPolicy"s, __type_spicy_ReassemblerPolicy);

    // Creating Zeek type spicy::Side;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_Side;
    __labels_spicy_Side.emplace_back(std::make_tuple("Left"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_Side.emplace_back(std::make_tuple("Right"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_Side.emplace_back(std::make_tuple("Both"sv, ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_spicy_Side.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_Side = ::zeek::spicy::rt::create_enum_type("spicy"s, "Side"s, __labels_spicy_Side);
    ::zeek::spicy::rt::register_type("spicy"s, "Side"s, __type_spicy_Side);

    // Creating Zeek type spicy::Direction;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_Direction;
    __labels_spicy_Direction.emplace_back(std::make_tuple("Forward"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_Direction.emplace_back(std::make_tuple("Backward"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_Direction.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_Direction = ::zeek::spicy::rt::create_enum_type("spicy"s, "Direction"s, __labels_spicy_Direction);
    ::zeek::spicy::rt::register_type("spicy"s, "Direction"s, __type_spicy_Direction);
    ::zeek::spicy::rt::register_spicy_module_end();
}

