// Begin of spicy_init (from "<root>")
// Compiled by HILTI version 1.13.0-dev.2

#include <hilti/rt/compiler-setup.h>

#include <spicy/rt/libspicy.h>
#include <hilti/rt/libhilti.h>
#include <zeek/spicy/runtime-support.h>

extern const char* __hlt_websocket_hlto_scope;

namespace zeek::spicy::rt {
    extern void register_spicy_module_begin(const std::string& name, const std::string& description);
    extern void register_spicy_module_end();
}

namespace __hlt_websocket::spicy_init {
    extern void zeek_preinit();
    extern void __preinit_module();
    extern void __register_module();
}

HILTI_PRE_INIT(__hlt_websocket::spicy_init::__register_module)

extern void __hlt_websocket::spicy_init::__preinit_module() { __hlt_websocket::spicy_init::zeek_preinit(); }

extern void __hlt_websocket::spicy_init::__register_module() {
    ::hilti::rt::detail::registerModule({ "spicy_init", __hlt_websocket_hlto_scope, nullptr, nullptr, nullptr, nullptr});
    __preinit_module();
}

extern void __hlt_websocket::spicy_init::zeek_preinit() {
    ::zeek::spicy::rt::register_spicy_module_begin("Zeek::WebSocket"s, "webSocket analyzer"s);
    ::zeek::spicy::rt::register_protocol_analyzer("spicy::WebSocket"s, ::hilti::rt::Protocol{::hilti::rt::Protocol::TCP}, ::hilti::rt::Vector<::zeek::spicy::rt::PortRange>({}), "WebSocket::Messages"s, "WebSocket::Messages"s, ""s, std::string(__hlt_websocket_hlto_scope));
    ::zeek::spicy::rt::install_handler("websocket_message"s);
    ::zeek::spicy::rt::install_handler("websocket_frame"s);
    ::zeek::spicy::rt::install_handler("websocket_close"s);
    ::zeek::spicy::rt::install_handler("websocket_frame_data"s);

    // Creating Zeek type spicy::AddressFamily;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_AddressFamily;
    __labels_spicy_AddressFamily.emplace_back(std::make_tuple("IPv4"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_AddressFamily.emplace_back(std::make_tuple("IPv6"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_AddressFamily.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_AddressFamily = ::zeek::spicy::rt::create_enum_type("spicy"s, "AddressFamily"s, __labels_spicy_AddressFamily);
    ::zeek::spicy::rt::register_type("spicy"s, "AddressFamily"s, __type_spicy_AddressFamily);

    // Creating Zeek type spicy::BitOrder;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_BitOrder;
    __labels_spicy_BitOrder.emplace_back(std::make_tuple("LSB0"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_BitOrder.emplace_back(std::make_tuple("MSB0"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_BitOrder.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_BitOrder = ::zeek::spicy::rt::create_enum_type("spicy"s, "BitOrder"s, __labels_spicy_BitOrder);
    ::zeek::spicy::rt::register_type("spicy"s, "BitOrder"s, __type_spicy_BitOrder);

    // Creating Zeek type spicy::ByteOrder;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_ByteOrder;
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple("Little"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple("Big"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple("Network"sv, ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple("Host"sv, ::hilti::rt::integer::safe<std::int64_t>{3}));
    __labels_spicy_ByteOrder.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_ByteOrder = ::zeek::spicy::rt::create_enum_type("spicy"s, "ByteOrder"s, __labels_spicy_ByteOrder);
    ::zeek::spicy::rt::register_type("spicy"s, "ByteOrder"s, __type_spicy_ByteOrder);

    // Creating Zeek type spicy::Charset;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_Charset;
    __labels_spicy_Charset.emplace_back(std::make_tuple("ASCII"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_Charset.emplace_back(std::make_tuple("UTF8"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_Charset.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_Charset = ::zeek::spicy::rt::create_enum_type("spicy"s, "Charset"s, __labels_spicy_Charset);
    ::zeek::spicy::rt::register_type("spicy"s, "Charset"s, __type_spicy_Charset);

    // Creating Zeek type spicy::DecodeErrorStrategy;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_DecodeErrorStrategy;
    __labels_spicy_DecodeErrorStrategy.emplace_back(std::make_tuple("IGNORE"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_DecodeErrorStrategy.emplace_back(std::make_tuple("REPLACE"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_DecodeErrorStrategy.emplace_back(std::make_tuple("STRICT"sv, ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_spicy_DecodeErrorStrategy.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_DecodeErrorStrategy = ::zeek::spicy::rt::create_enum_type("spicy"s, "DecodeErrorStrategy"s, __labels_spicy_DecodeErrorStrategy);
    ::zeek::spicy::rt::register_type("spicy"s, "DecodeErrorStrategy"s, __type_spicy_DecodeErrorStrategy);

    // Creating Zeek type spicy::Protocol;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_Protocol;
    __labels_spicy_Protocol.emplace_back(std::make_tuple("TCP"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_Protocol.emplace_back(std::make_tuple("UDP"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_Protocol.emplace_back(std::make_tuple("ICMP"sv, ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_spicy_Protocol.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_Protocol = ::zeek::spicy::rt::create_enum_type("spicy"s, "Protocol"s, __labels_spicy_Protocol);
    ::zeek::spicy::rt::register_type("spicy"s, "Protocol"s, __type_spicy_Protocol);

    // Creating Zeek type spicy::RealType;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_RealType;
    __labels_spicy_RealType.emplace_back(std::make_tuple("IEEE754_Single"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_RealType.emplace_back(std::make_tuple("IEEE754_Double"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_RealType.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_RealType = ::zeek::spicy::rt::create_enum_type("spicy"s, "RealType"s, __labels_spicy_RealType);
    ::zeek::spicy::rt::register_type("spicy"s, "RealType"s, __type_spicy_RealType);

    // Creating Zeek type spicy::ReassemblerPolicy;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_ReassemblerPolicy;
    __labels_spicy_ReassemblerPolicy.emplace_back(std::make_tuple("First"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_ReassemblerPolicy.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_ReassemblerPolicy = ::zeek::spicy::rt::create_enum_type("spicy"s, "ReassemblerPolicy"s, __labels_spicy_ReassemblerPolicy);
    ::zeek::spicy::rt::register_type("spicy"s, "ReassemblerPolicy"s, __type_spicy_ReassemblerPolicy);

    // Creating Zeek type spicy::Side;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_Side;
    __labels_spicy_Side.emplace_back(std::make_tuple("Left"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_Side.emplace_back(std::make_tuple("Right"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_Side.emplace_back(std::make_tuple("Both"sv, ::hilti::rt::integer::safe<std::int64_t>{2}));
    __labels_spicy_Side.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_Side = ::zeek::spicy::rt::create_enum_type("spicy"s, "Side"s, __labels_spicy_Side);
    ::zeek::spicy::rt::register_type("spicy"s, "Side"s, __type_spicy_Side);

    // Creating Zeek type spicy::Direction;
    ::hilti::rt::Vector<std::tuple<std::string, ::hilti::rt::integer::safe<int64_t>>> __labels_spicy_Direction;
    __labels_spicy_Direction.emplace_back(std::make_tuple("Forward"sv, ::hilti::rt::integer::safe<std::int64_t>{0}));
    __labels_spicy_Direction.emplace_back(std::make_tuple("Backward"sv, ::hilti::rt::integer::safe<std::int64_t>{1}));
    __labels_spicy_Direction.emplace_back(std::make_tuple("Undef"sv, ::hilti::rt::integer::safe<std::int64_t>{-1}));
    ::zeek::TypePtr __type_spicy_Direction = ::zeek::spicy::rt::create_enum_type("spicy"s, "Direction"s, __labels_spicy_Direction);
    ::zeek::spicy::rt::register_type("spicy"s, "Direction"s, __type_spicy_Direction);
    ::zeek::spicy::rt::register_spicy_module_end();
}

