// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 11 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"

namespace hilti { namespace detail { class Parser; } }

#include <hilti/compiler/context.h>
#include <hilti/compiler/detail/parser/driver.h>
#include <hilti/ast/builder/all.h>

#line 41 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"


#include <hilti/compiler/detail/parser/scanner.h>

#undef yylex
#define yylex driver->scanner()->lex

static hilti::Meta toMeta(hilti::detail::parser::location l) {
    return hilti::Meta(hilti::Location(*l.begin.filename, l.begin.line, l.end.line, l.begin.column,
                                       (l.end.column > 0 ? l.end.column - 1 : 0)));
}

static hilti::QualifiedType* iteratorForType(hilti::Builder* builder, hilti::QualifiedType* t, hilti::Meta m) {
    if ( auto iter = t->type()->iteratorType() )
        return iter;
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not iterable", *t), m.location());
        return builder->qualifiedType(builder->typeError(), hilti::Constness::Const);
        }
}

static hilti::QualifiedType* viewForType(hilti::Builder* builder, hilti::QualifiedType* t, hilti::Meta m) {
    if ( auto v = t->type()->viewType() )
        return v;
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not viewable", *t), m.location());
        return builder->qualifiedType(builder->typeError(), hilti::Constness::Const);
        }
}

#define __loc__ toMeta(yylhs.location)

#define YYLLOC_DEFAULT(Current, Rhs, N)                                                                                \
do {                                                                                                                   \
    bool done = false;                                                                                                 \
    for ( int i = 1; i <= N; i++ ) {                                                                                   \
        if ( YYRHSLOC(Rhs, i).begin.line != YYRHSLOC(Rhs, i).end.line ||                                               \
             YYRHSLOC(Rhs, i).begin.column != YYRHSLOC(Rhs, i).end.column ) {                                          \
            (Current).begin = YYRHSLOC(Rhs, i).begin;                                                                  \
            (Current).end = YYRHSLOC(Rhs, N).end;                                                                      \
            done = true;                                                                                               \
            break;                                                                                                     \
        }                                                                                                              \
    }                                                                                                                  \
    if ( ! done )                                                                                                      \
        (Current).begin = (Current).end = YYRHSLOC(Rhs, 0).end;                                                        \
} while ( false )

static int _field_width = 0;


#line 101 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"


#include "__parser.h"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 29 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
namespace hilti { namespace detail { namespace parser {
#line 199 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"

  /// Build a parser object.
  Parser::Parser (Driver* driver_yyarg, Builder* builder_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      builder (builder_yyarg)
  {}

  Parser::~Parser ()
  {}

  Parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------.
  | symbol.  |
  `---------*/

  // basic_symbol.
  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value ()
    , location (that.location)
  {
    switch (this->kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.copy< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.copy< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.copy< hilti::Attribute* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.copy< hilti::AttributeSet* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.copy< hilti::Ctor* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.copy< hilti::Declaration* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.copy< hilti::Declarations > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_no_or_error: // expr_no_or_error
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.copy< hilti::Expression* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_case_exprs: // case_exprs
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.copy< hilti::Expressions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.copy< hilti::Function* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.copy< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_qtype: // qtype
        value.copy< hilti::QualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.copy< hilti::Statement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.copy< hilti::Statements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param_type: // func_param_type
      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
        value.copy< hilti::UnqualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.copy< hilti::ctor::map::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.copy< hilti::ctor::map::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.copy< hilti::ctor::struct_::Field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.copy< hilti::ctor::struct_::Fields > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.copy< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.copy< hilti::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.copy< hilti::statement::switch_::Case* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.copy< hilti::statement::switch_::Cases > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.copy< hilti::statement::try_::Catch* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.copy< hilti::statement::try_::Catches > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.copy< hilti::type::bitfield::BitRange* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.copy< hilti::type::bitfield::BitRanges > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.copy< hilti::type::enum_::Label* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.copy< hilti::type::enum_::Labels > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.copy< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.copy< hilti::type::function::Parameter* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.copy< hilti::type::function::Parameters > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.copy< hilti::type::tuple::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.copy< hilti::type::tuple::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.copy< std::pair<Declarations, Statements> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.copy< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.copy< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        value.copy< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

  }




  template <typename Base>
  Parser::symbol_kind_type
  Parser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  template <typename Base>
  bool
  Parser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  Parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    switch (this->kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.move< bool > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.move< double > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< hilti::AttributeSet* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.move< hilti::Declaration* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.move< hilti::Declarations > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_no_or_error: // expr_no_or_error
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.move< hilti::Expression* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_case_exprs: // case_exprs
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< hilti::Expressions > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.move< hilti::Function* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.move< hilti::ID > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_qtype: // qtype
        value.move< hilti::QualifiedType* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< hilti::Statements > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_func_param_type: // func_param_type
      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
        value.move< hilti::UnqualifiedType* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< hilti::ctor::map::Elements > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< hilti::ctor::struct_::Fields > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::parameter::Kind > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.move< hilti::statement::switch_::Cases > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.move< hilti::statement::try_::Catch* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.move< hilti::statement::try_::Catches > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.move< hilti::type::bitfield::BitRange* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.move< hilti::type::bitfield::BitRanges > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< hilti::type::enum_::Labels > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.move< hilti::type::function::Flavor > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.move< hilti::type::function::Parameters > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< hilti::type::tuple::Elements > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<Declarations, Statements> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        value.move< uint64_t > (YY_MOVE (s.value));
        break;

      default:
        break;
    }

    location = YY_MOVE (s.location);
  }

  // by_kind.
  Parser::by_kind::by_kind () YY_NOEXCEPT
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  Parser::by_kind::by_kind (by_kind&& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  Parser::by_kind::by_kind (const by_kind& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {}

  Parser::by_kind::by_kind (token_kind_type t) YY_NOEXCEPT
    : kind_ (yytranslate_ (t))
  {}



  void
  Parser::by_kind::clear () YY_NOEXCEPT
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  Parser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  Parser::symbol_kind_type
  Parser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }


  Parser::symbol_kind_type
  Parser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }



  // by_state.
  Parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  Parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  Parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  Parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  Parser::symbol_kind_type
  Parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  Parser::stack_symbol_type::stack_symbol_type ()
  {}

  Parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.YY_MOVE_OR_COPY< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.YY_MOVE_OR_COPY< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.YY_MOVE_OR_COPY< hilti::Attribute* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.YY_MOVE_OR_COPY< hilti::AttributeSet* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.YY_MOVE_OR_COPY< hilti::Ctor* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.YY_MOVE_OR_COPY< hilti::Declaration* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.YY_MOVE_OR_COPY< hilti::Declarations > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_no_or_error: // expr_no_or_error
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.YY_MOVE_OR_COPY< hilti::Expression* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_case_exprs: // case_exprs
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.YY_MOVE_OR_COPY< hilti::Expressions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.YY_MOVE_OR_COPY< hilti::Function* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.YY_MOVE_OR_COPY< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_qtype: // qtype
        value.YY_MOVE_OR_COPY< hilti::QualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.YY_MOVE_OR_COPY< hilti::Statement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.YY_MOVE_OR_COPY< hilti::Statements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param_type: // func_param_type
      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
        value.YY_MOVE_OR_COPY< hilti::UnqualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.YY_MOVE_OR_COPY< hilti::ctor::map::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.YY_MOVE_OR_COPY< hilti::ctor::map::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.YY_MOVE_OR_COPY< hilti::ctor::struct_::Field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.YY_MOVE_OR_COPY< hilti::ctor::struct_::Fields > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.YY_MOVE_OR_COPY< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.YY_MOVE_OR_COPY< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.YY_MOVE_OR_COPY< hilti::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.YY_MOVE_OR_COPY< hilti::statement::switch_::Case* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.YY_MOVE_OR_COPY< hilti::statement::switch_::Cases > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.YY_MOVE_OR_COPY< hilti::statement::try_::Catch* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.YY_MOVE_OR_COPY< hilti::statement::try_::Catches > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.YY_MOVE_OR_COPY< hilti::type::bitfield::BitRange* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.YY_MOVE_OR_COPY< hilti::type::bitfield::BitRanges > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.YY_MOVE_OR_COPY< hilti::type::enum_::Label* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.YY_MOVE_OR_COPY< hilti::type::enum_::Labels > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.YY_MOVE_OR_COPY< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.YY_MOVE_OR_COPY< hilti::type::function::Parameter* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.YY_MOVE_OR_COPY< hilti::type::function::Parameters > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.YY_MOVE_OR_COPY< hilti::type::tuple::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.YY_MOVE_OR_COPY< hilti::type::tuple::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.YY_MOVE_OR_COPY< std::pair<Declarations, Statements> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.YY_MOVE_OR_COPY< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        value.YY_MOVE_OR_COPY< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  Parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.move< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.move< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< hilti::AttributeSet* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.move< hilti::Declaration* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.move< hilti::Declarations > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_no_or_error: // expr_no_or_error
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.move< hilti::Expression* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_case_exprs: // case_exprs
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< hilti::Expressions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.move< hilti::Function* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.move< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_qtype: // qtype
        value.move< hilti::QualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< hilti::Statements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param_type: // func_param_type
      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
        value.move< hilti::UnqualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< hilti::ctor::map::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< hilti::ctor::struct_::Fields > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.move< hilti::statement::switch_::Cases > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.move< hilti::statement::try_::Catch* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.move< hilti::statement::try_::Catches > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.move< hilti::type::bitfield::BitRange* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.move< hilti::type::bitfield::BitRanges > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< hilti::type::enum_::Labels > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.move< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.move< hilti::type::function::Parameters > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< hilti::type::tuple::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<Declarations, Statements> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        value.move< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.copy< bool > (that.value);
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.copy< double > (that.value);
        break;

      case symbol_kind::S_attribute: // attribute
        value.copy< hilti::Attribute* > (that.value);
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.copy< hilti::AttributeSet* > (that.value);
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.copy< hilti::Ctor* > (that.value);
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.copy< hilti::Declaration* > (that.value);
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.copy< hilti::Declarations > (that.value);
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_no_or_error: // expr_no_or_error
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.copy< hilti::Expression* > (that.value);
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_case_exprs: // case_exprs
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.copy< hilti::Expressions > (that.value);
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.copy< hilti::Function* > (that.value);
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.copy< hilti::ID > (that.value);
        break;

      case symbol_kind::S_qtype: // qtype
        value.copy< hilti::QualifiedType* > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.copy< hilti::Statement* > (that.value);
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.copy< hilti::Statements > (that.value);
        break;

      case symbol_kind::S_func_param_type: // func_param_type
      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
        value.copy< hilti::UnqualifiedType* > (that.value);
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.copy< hilti::ctor::map::Element* > (that.value);
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.copy< hilti::ctor::map::Elements > (that.value);
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.copy< hilti::ctor::struct_::Field* > (that.value);
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.copy< hilti::ctor::struct_::Fields > (that.value);
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.copy< hilti::declaration::Linkage > (that.value);
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (that.value);
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.copy< hilti::parameter::Kind > (that.value);
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.copy< hilti::statement::switch_::Case* > (that.value);
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.copy< hilti::statement::switch_::Cases > (that.value);
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.copy< hilti::statement::try_::Catch* > (that.value);
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.copy< hilti::statement::try_::Catches > (that.value);
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.copy< hilti::type::bitfield::BitRange* > (that.value);
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.copy< hilti::type::bitfield::BitRanges > (that.value);
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.copy< hilti::type::enum_::Label* > (that.value);
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.copy< hilti::type::enum_::Labels > (that.value);
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.copy< hilti::type::function::Flavor > (that.value);
        break;

      case symbol_kind::S_func_param: // func_param
        value.copy< hilti::type::function::Parameter* > (that.value);
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.copy< hilti::type::function::Parameters > (that.value);
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.copy< hilti::type::tuple::Element* > (that.value);
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.copy< hilti::type::tuple::Elements > (that.value);
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.copy< std::pair<Declarations, Statements> > (that.value);
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.copy< std::string > (that.value);
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.copy< std::vector<std::string> > (that.value);
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        value.copy< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
        value.move< bool > (that.value);
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.move< double > (that.value);
        break;

      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute* > (that.value);
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< hilti::AttributeSet* > (that.value);
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor* > (that.value);
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        value.move< hilti::Declaration* > (that.value);
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        value.move< hilti::Declarations > (that.value);
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_no_or_error: // expr_no_or_error
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.move< hilti::Expression* > (that.value);
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_case_exprs: // case_exprs
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< hilti::Expressions > (that.value);
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        value.move< hilti::Function* > (that.value);
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        value.move< hilti::ID > (that.value);
        break;

      case symbol_kind::S_qtype: // qtype
        value.move< hilti::QualifiedType* > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement* > (that.value);
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< hilti::Statements > (that.value);
        break;

      case symbol_kind::S_func_param_type: // func_param_type
      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
        value.move< hilti::UnqualifiedType* > (that.value);
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element* > (that.value);
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< hilti::ctor::map::Elements > (that.value);
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field* > (that.value);
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< hilti::ctor::struct_::Fields > (that.value);
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (that.value);
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (that.value);
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::parameter::Kind > (that.value);
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case* > (that.value);
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        value.move< hilti::statement::switch_::Cases > (that.value);
        break;

      case symbol_kind::S_try_catch: // try_catch
        value.move< hilti::statement::try_::Catch* > (that.value);
        break;

      case symbol_kind::S_try_catches: // try_catches
        value.move< hilti::statement::try_::Catches > (that.value);
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.move< hilti::type::bitfield::BitRange* > (that.value);
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.move< hilti::type::bitfield::BitRanges > (that.value);
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label* > (that.value);
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< hilti::type::enum_::Labels > (that.value);
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        value.move< hilti::type::function::Flavor > (that.value);
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter* > (that.value);
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        value.move< hilti::type::function::Parameters > (that.value);
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element* > (that.value);
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< hilti::type::tuple::Elements > (that.value);
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<Declarations, Statements> > (that.value);
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (that.value);
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (that.value);
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        value.move< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  Parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  Parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  Parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  Parser::yypop_ (int n) YY_NOEXCEPT
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Parser::debug_level_type
  Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  Parser::state_type
  Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  Parser::yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  Parser::yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Parser::operator() ()
  {
    return parse ();
  }

  int
  Parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    // User initialization code.
#line 22 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
{
    yyla.location.begin.filename = yyla.location.end.filename = driver->currentFile();
}

#line 2007 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, &yyla.location, driver));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_CBOOL: // "bool value"
        yylhs.value.emplace< bool > ();
        break;

      case symbol_kind::S_CUREAL: // "real value"
        yylhs.value.emplace< double > ();
        break;

      case symbol_kind::S_attribute: // attribute
        yylhs.value.emplace< hilti::Attribute* > ();
        break;

      case symbol_kind::S_opt_attributes: // opt_attributes
        yylhs.value.emplace< hilti::AttributeSet* > ();
        break;

      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        yylhs.value.emplace< hilti::Ctor* > ();
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_struct_field: // struct_field
      case symbol_kind::S_union_field: // union_field
        yylhs.value.emplace< hilti::Declaration* > ();
        break;

      case symbol_kind::S_struct_fields: // struct_fields
      case symbol_kind::S_opt_union_fields: // opt_union_fields
      case symbol_kind::S_union_fields: // union_fields
        yylhs.value.emplace< hilti::Declarations > ();
        break;

      case symbol_kind::S_opt_func_default_expr: // opt_func_default_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_no_or_error: // expr_no_or_error
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        yylhs.value.emplace< hilti::Expression* > ();
        break;

      case symbol_kind::S_opt_type_arguments: // opt_type_arguments
      case symbol_kind::S_case_exprs: // case_exprs
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        yylhs.value.emplace< hilti::Expressions > ();
        break;

      case symbol_kind::S_function_with_body: // function_with_body
      case symbol_kind::S_method_with_body: // method_with_body
      case symbol_kind::S_hook_with_body: // hook_with_body
      case symbol_kind::S_function_without_body: // function_without_body
        yylhs.value.emplace< hilti::Function* > ();
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_function_id: // function_id
      case symbol_kind::S_scoped_function_id: // scoped_function_id
        yylhs.value.emplace< hilti::ID > ();
        break;

      case symbol_kind::S_qtype: // qtype
        yylhs.value.emplace< hilti::QualifiedType* > ();
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        yylhs.value.emplace< hilti::Statement* > ();
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        yylhs.value.emplace< hilti::Statements > ();
        break;

      case symbol_kind::S_func_param_type: // func_param_type
      case symbol_kind::S_base_type_no_attrs: // base_type_no_attrs
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_function_type: // function_type
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_union_type: // union_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
        yylhs.value.emplace< hilti::UnqualifiedType* > ();
        break;

      case symbol_kind::S_map_elem: // map_elem
        yylhs.value.emplace< hilti::ctor::map::Element* > ();
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        yylhs.value.emplace< hilti::ctor::map::Elements > ();
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        yylhs.value.emplace< hilti::ctor::struct_::Field* > ();
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        yylhs.value.emplace< hilti::ctor::struct_::Fields > ();
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        yylhs.value.emplace< hilti::declaration::Linkage > ();
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        yylhs.value.emplace< hilti::function::CallingConvention > ();
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        yylhs.value.emplace< hilti::parameter::Kind > ();
        break;

      case symbol_kind::S_switch_case: // switch_case
        yylhs.value.emplace< hilti::statement::switch_::Case* > ();
        break;

      case symbol_kind::S_opt_switch_cases: // opt_switch_cases
      case symbol_kind::S_switch_cases: // switch_cases
        yylhs.value.emplace< hilti::statement::switch_::Cases > ();
        break;

      case symbol_kind::S_try_catch: // try_catch
        yylhs.value.emplace< hilti::statement::try_::Catch* > ();
        break;

      case symbol_kind::S_try_catches: // try_catches
        yylhs.value.emplace< hilti::statement::try_::Catches > ();
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        yylhs.value.emplace< hilti::type::bitfield::BitRange* > ();
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        yylhs.value.emplace< hilti::type::bitfield::BitRanges > ();
        break;

      case symbol_kind::S_enum_label: // enum_label
        yylhs.value.emplace< hilti::type::enum_::Label* > ();
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        yylhs.value.emplace< hilti::type::enum_::Labels > ();
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
      case symbol_kind::S_func_flavor: // func_flavor
        yylhs.value.emplace< hilti::type::function::Flavor > ();
        break;

      case symbol_kind::S_func_param: // func_param
        yylhs.value.emplace< hilti::type::function::Parameter* > ();
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_struct_params: // opt_struct_params
        yylhs.value.emplace< hilti::type::function::Parameters > ();
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        yylhs.value.emplace< hilti::type::tuple::Element* > ();
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        yylhs.value.emplace< hilti::type::tuple::Elements > ();
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        yylhs.value.emplace< std::pair<Declarations, Statements> > ();
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_SCOPED_FINALIZE: // "scoped ~finally"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        yylhs.value.emplace< std::string > ();
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        yylhs.value.emplace< std::vector<std::string> > ();
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
        yylhs.value.emplace< uint64_t > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // module: "module" local_id '{' global_scope_items '}'
#line 288 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { auto uid = declaration::module::UID(yystack_[3].value.as < hilti::ID > (), hilti::rt::filesystem::path(*driver->currentFile()));
                                                   auto m = builder->declarationModule(uid, {}, std::move(yystack_[1].value.as < std::pair<Declarations, Statements> > ().first), std::move(yystack_[1].value.as < std::pair<Declarations, Statements> > ().second), __loc__);
                                                   driver->setDestinationModule(std::move(m));
                                                 }
#line 2388 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 3: // local_id: "identifier"
#line 296 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { std::string name(yystack_[0].value.as < std::string > ());

                                                   if ( ! driver->builder()->options().skip_validation ) {
                                                       if ( name.find('-') != std::string::npos )
                                                           hilti::logger().error(util::fmt("Invalid ID '%s': cannot contain '-'", name), __loc__.location());
                                                       if ( name.substr(0, 2) == "__" && name != "__str__" )
                                                           hilti::logger().error(util::fmt("Invalid ID '%s': cannot start with '__'", name), __loc__.location());
                                                   }

                                                   yylhs.value.as < hilti::ID > () = hilti::ID(std::move(name));
                                                 }
#line 2404 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 4: // scoped_id: local_id
#line 308 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = std::move(yystack_[0].value.as < hilti::ID > ()); }
#line 2410 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 5: // scoped_id: "scoped identifier"
#line 309 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[0].value.as < std::string > ()); }
#line 2416 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 6: // $@1: %empty
#line 311 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                { driver->enableDottedIDMode(); }
#line 2422 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 7: // $@2: %empty
#line 313 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                { driver->disableDottedIDMode(); }
#line 2428 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 8: // dotted_id: $@1 "dotted identifier" $@2
#line 313 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                   { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[1].value.as < std::string > ()); }
#line 2434 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 9: // global_scope_items: global_scope_items global_scope_decl
#line 319 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::pair<Declarations, Statements> > () = std::move(yystack_[1].value.as < std::pair<Declarations, Statements> > ()); yylhs.value.as < std::pair<Declarations, Statements> > ().first.push_back(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2440 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 10: // global_scope_items: global_scope_items stmt
#line 321 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::pair<Declarations, Statements> > () = std::move(yystack_[1].value.as < std::pair<Declarations, Statements> > ()); yylhs.value.as < std::pair<Declarations, Statements> > ().second.push_back(yystack_[0].value.as < hilti::Statement* > ()); }
#line 2446 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 11: // global_scope_items: %empty
#line 322 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::pair<Declarations, Statements> > () = {}; }
#line 2452 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 12: // global_scope_decl: type_decl
#line 326 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2458 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 13: // global_scope_decl: constant_decl
#line 327 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2464 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 14: // global_scope_decl: global_decl
#line 328 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2470 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 15: // global_scope_decl: function_decl
#line 329 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2476 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 16: // global_scope_decl: import_decl
#line 330 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2482 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 17: // global_scope_decl: property_decl
#line 331 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2488 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 18: // type_decl: opt_linkage "type" scoped_id '=' qtype opt_attributes ';'
#line 334 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationType(std::move(yystack_[4].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), std::move(yystack_[6].value.as < hilti::declaration::Linkage > ()), __loc__); }
#line 2494 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 19: // constant_decl: opt_linkage "const" scoped_id '=' expr ';'
#line 337 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationConstant(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression* > (), yystack_[5].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2500 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 20: // constant_decl: opt_linkage "const" type scoped_id '=' expr ';'
#line 339 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationConstant(yystack_[3].value.as < hilti::ID > (), builder->qualifiedType(yystack_[4].value.as < hilti::UnqualifiedType* > (), Constness::Const), yystack_[1].value.as < hilti::Expression* > (), yystack_[6].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2506 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 21: // local_decl: "local" local_id '=' expr ';'
#line 342 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression* > (), __loc__); }
#line 2512 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 22: // local_decl: "local" qtype local_id opt_type_arguments ';'
#line 343 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                            { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::QualifiedType* > (), yystack_[1].value.as < hilti::Expressions > (), {}, __loc__); }
#line 2518 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 23: // local_decl: "local" qtype local_id '=' expr ';'
#line 345 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[4].value.as < hilti::QualifiedType* > (), yystack_[1].value.as < hilti::Expression* > (), __loc__); }
#line 2524 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 24: // local_decl: "local" "auto" local_id '=' expr ';'
#line 347 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression* > (), __loc__); }
#line 2530 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 25: // local_init_decl: "local" qtype local_id '=' expr
#line 352 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::QualifiedType* > (), yystack_[0].value.as < hilti::Expression* > (), __loc__); }
#line 2536 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 26: // local_init_decl: "local" "auto" local_id '=' expr
#line 354 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[2].value.as < hilti::ID > (), yystack_[0].value.as < hilti::Expression* > (), __loc__); }
#line 2542 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 27: // global_decl: opt_linkage "global" scoped_id '=' expr ';'
#line 358 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationGlobalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression* > (), yystack_[5].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2548 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 28: // global_decl: opt_linkage "global" qtype scoped_id opt_type_arguments ';'
#line 360 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationGlobalVariable(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::QualifiedType* > (), yystack_[1].value.as < hilti::Expressions > (), {}, yystack_[5].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2554 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 29: // global_decl: opt_linkage "global" qtype scoped_id '=' expr ';'
#line 362 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationGlobalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[4].value.as < hilti::QualifiedType* > (), yystack_[1].value.as < hilti::Expression* > (), yystack_[6].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2560 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 30: // global_decl: opt_linkage "global" "auto" scoped_id '=' expr ';'
#line 364 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationGlobalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression* > (), yystack_[6].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2566 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 31: // opt_type_arguments: '(' opt_exprs ')'
#line 368 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = std::move(yystack_[1].value.as < hilti::Expressions > ()); }
#line 2572 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 32: // opt_type_arguments: %empty
#line 369 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{}; }
#line 2578 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 33: // function_decl: opt_linkage "function" function_with_body
#line 372 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationFunction(yystack_[0].value.as < hilti::Function* > (), yystack_[2].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2584 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 34: // function_decl: opt_linkage "hook" hook_with_body
#line 373 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                             { yylhs.value.as < hilti::Declaration* > () = builder->declarationFunction(yystack_[0].value.as < hilti::Function* > (), yystack_[2].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2590 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 35: // function_decl: "method" method_with_body
#line 376 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationFunction(yystack_[0].value.as < hilti::Function* > (), hilti::declaration::Linkage::Struct, __loc__); }
#line 2596 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 36: // function_decl: "declare" opt_linkage function_without_body ';'
#line 378 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationFunction(yystack_[1].value.as < hilti::Function* > (), yystack_[2].value.as < hilti::declaration::Linkage > (), __loc__); }
#line 2602 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 37: // import_decl: "import" local_id ';'
#line 381 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationImportedModule(std::move(yystack_[1].value.as < hilti::ID > ()), std::string(".hlt"), __loc__); }
#line 2608 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 38: // import_decl: "import" local_id "from" dotted_id ';'
#line 382 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                   { yylhs.value.as < hilti::Declaration* > () = builder->declarationImportedModule(std::move(yystack_[3].value.as < hilti::ID > ()), std::string(".hlt"), std::move(yystack_[1].value.as < hilti::ID > ()), __loc__); }
#line 2614 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 39: // property_decl: "property" ';'
#line 386 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationProperty(ID(std::move(yystack_[1].value.as < std::string > ())), __loc__); }
#line 2620 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 40: // property_decl: "property" '=' expr ';'
#line 387 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationProperty(ID(std::move(yystack_[3].value.as < std::string > ())), std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 2626 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 41: // opt_linkage: "public"
#line 389 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Public; }
#line 2632 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 42: // opt_linkage: "private"
#line 390 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 2638 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 43: // opt_linkage: "init"
#line 391 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Init; }
#line 2644 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 44: // opt_linkage: "preinit"
#line 392 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::PreInit; }
#line 2650 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 45: // opt_linkage: %empty
#line 393 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 2656 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 46: // function_id: local_id
#line 397 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = std::move(yystack_[0].value.as < hilti::ID > ()); }
#line 2662 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 47: // function_id: "~finally"
#line 398 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = hilti::ID("~finally"); }
#line 2668 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 48: // scoped_function_id: function_id
#line 401 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = std::move(yystack_[0].value.as < hilti::ID > ()); }
#line 2674 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 49: // scoped_function_id: "scoped identifier"
#line 402 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[0].value.as < std::string > ()); }
#line 2680 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 50: // scoped_function_id: "scoped ~finally"
#line 403 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[0].value.as < std::string > ()); }
#line 2686 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 51: // function_with_body: opt_func_cc qtype scoped_function_id '(' opt_func_params ')' opt_attributes braced_block
#line 407 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 {
                                                    auto ftype = builder->typeFunction(yystack_[6].value.as < hilti::QualifiedType* > (), yystack_[3].value.as < hilti::type::function::Parameters > (), type::function::Flavor::Standard, __loc__);
                                                    yylhs.value.as < hilti::Function* > () = builder->function(yystack_[5].value.as < hilti::ID > (), ftype->as<type::Function>(), yystack_[0].value.as < hilti::Statement* > (), yystack_[7].value.as < hilti::function::CallingConvention > (), yystack_[1].value.as < hilti::AttributeSet* > (), __loc__);
                                                 }
#line 2695 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 52: // method_with_body: opt_func_cc qtype scoped_function_id '(' opt_func_params ')' opt_attributes braced_block
#line 414 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 {
                                                    auto ftype = builder->typeFunction(yystack_[6].value.as < hilti::QualifiedType* > (), yystack_[3].value.as < hilti::type::function::Parameters > (), type::function::Flavor::Method, __loc__);
                                                    yylhs.value.as < hilti::Function* > () = builder->function(yystack_[5].value.as < hilti::ID > (), ftype->as<type::Function>(), yystack_[0].value.as < hilti::Statement* > (), yystack_[7].value.as < hilti::function::CallingConvention > (), yystack_[1].value.as < hilti::AttributeSet* > (), __loc__);
                                                 }
#line 2704 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 53: // hook_with_body: opt_func_cc qtype scoped_function_id '(' opt_func_params ')' opt_attributes braced_block
#line 421 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 {
                                                    auto ftype = builder->typeFunction(yystack_[6].value.as < hilti::QualifiedType* > (), yystack_[3].value.as < hilti::type::function::Parameters > (), type::function::Flavor::Hook, __loc__);
                                                    yylhs.value.as < hilti::Function* > () = builder->function(yystack_[5].value.as < hilti::ID > (), ftype->as<type::Function>(), yystack_[0].value.as < hilti::Statement* > (), yystack_[7].value.as < hilti::function::CallingConvention > (), yystack_[1].value.as < hilti::AttributeSet* > (), __loc__);
                                                 }
#line 2713 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 54: // function_without_body: opt_func_flavor opt_func_cc qtype scoped_function_id '(' opt_func_params ')' opt_attributes
#line 428 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 {
                                                    auto ftype = builder->typeFunction(yystack_[5].value.as < hilti::QualifiedType* > (), yystack_[2].value.as < hilti::type::function::Parameters > (), yystack_[7].value.as < hilti::type::function::Flavor > (), __loc__);
                                                    yylhs.value.as < hilti::Function* > () = builder->function(yystack_[4].value.as < hilti::ID > (), std::move(ftype), {}, yystack_[6].value.as < hilti::function::CallingConvention > (), yystack_[0].value.as < hilti::AttributeSet* > (), __loc__);
                                                 }
#line 2722 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 55: // opt_func_flavor: func_flavor
#line 433 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Flavor > () = yystack_[0].value.as < hilti::type::function::Flavor > (); }
#line 2728 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 56: // opt_func_flavor: %empty
#line 434 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Flavor > () = hilti::type::function::Flavor::Standard; }
#line 2734 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 57: // func_flavor: "method"
#line 436 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Flavor > () = hilti::type::function::Flavor::Method; }
#line 2740 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 58: // func_flavor: "hook"
#line 437 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Flavor > () = hilti::type::function::Flavor::Hook; }
#line 2746 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 59: // opt_func_cc: "extern"
#line 439 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::function::CallingConvention > () = hilti::function::CallingConvention::Extern; }
#line 2752 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 60: // opt_func_cc: "extern-no-suspend"
#line 440 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::function::CallingConvention > () = hilti::function::CallingConvention::ExternNoSuspend; }
#line 2758 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 61: // opt_func_cc: %empty
#line 441 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::function::CallingConvention > () = hilti::function::CallingConvention::Standard; }
#line 2764 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 62: // opt_func_params: func_params
#line 443 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Parameters > () = std::move(yystack_[0].value.as < hilti::type::function::Parameters > ()); }
#line 2770 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 63: // opt_func_params: %empty
#line 444 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Parameters > () = hilti::type::function::Parameters(); }
#line 2776 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 64: // func_params: func_params ',' func_param
#line 446 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                         { yylhs.value.as < hilti::type::function::Parameters > () = std::move(yystack_[2].value.as < hilti::type::function::Parameters > ()); yylhs.value.as < hilti::type::function::Parameters > ().push_back(yystack_[0].value.as < hilti::type::function::Parameter* > ()); }
#line 2782 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 65: // func_params: func_param
#line 447 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Parameters > () = hilti::type::function::Parameters{yystack_[0].value.as < hilti::type::function::Parameter* > ()}; }
#line 2788 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 66: // func_param: opt_func_param_kind func_param_type local_id opt_func_default_expr opt_attributes
#line 450 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Parameter* > () = builder->declarationParameter(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::UnqualifiedType* > (), yystack_[4].value.as < hilti::parameter::Kind > (), yystack_[1].value.as < hilti::Expression* > (), yystack_[0].value.as < hilti::AttributeSet* > (), __loc__); }
#line 2794 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 67: // func_param_type: type
#line 453 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 2800 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 68: // func_param_type: "auto"
#line 454 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeAuto(__loc__); }
#line 2806 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 69: // opt_func_param_kind: "copy"
#line 458 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::parameter::Kind > () = hilti::parameter::Kind::Copy; }
#line 2812 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 70: // opt_func_param_kind: "inout"
#line 459 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::parameter::Kind > () = hilti::parameter::Kind::InOut; }
#line 2818 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 71: // opt_func_param_kind: %empty
#line 460 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::parameter::Kind > () = hilti::parameter::Kind::In; }
#line 2824 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 72: // opt_func_default_expr: '=' expr
#line 463 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 2830 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 73: // opt_func_default_expr: %empty
#line 464 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = {}; }
#line 2836 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 74: // block: braced_block
#line 469 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = std::move(yystack_[0].value.as < hilti::Statement* > ()); }
#line 2842 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 75: // block: stmt
#line 470 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementBlock({yystack_[0].value.as < hilti::Statement* > ()}, __loc__); }
#line 2848 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 76: // braced_block: '{' opt_stmts '}'
#line 473 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementBlock(std::move(yystack_[1].value.as < hilti::Statements > ()), __loc__); }
#line 2854 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 77: // opt_stmts: stmts
#line 475 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statements > () = std::move(yystack_[0].value.as < hilti::Statements > ()); }
#line 2860 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 78: // opt_stmts: %empty
#line 476 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statements > () = hilti::Statements(); }
#line 2866 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 79: // stmts: stmts stmt
#line 478 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statements > () = std::move(yystack_[1].value.as < hilti::Statements > ()); yylhs.value.as < hilti::Statements > ().push_back(yystack_[0].value.as < hilti::Statement* > ()); }
#line 2872 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 80: // stmts: stmt
#line 479 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statements > () = hilti::Statements{std::move(yystack_[0].value.as < hilti::Statement* > ())}; }
#line 2878 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 81: // stmt: stmt_expr ';'
#line 481 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = std::move(yystack_[1].value.as < hilti::Statement* > ()); }
#line 2884 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 82: // stmt: stmt_decl
#line 482 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = std::move(yystack_[0].value.as < hilti::Statement* > ()); }
#line 2890 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 83: // stmt: "return" ';'
#line 483 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementReturn(__loc__); }
#line 2896 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 84: // stmt: "return" expr ';'
#line 484 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementReturn(std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 2902 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 85: // stmt: "throw" expr ';'
#line 485 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementThrow(std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 2908 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 86: // stmt: "throw" ';'
#line 486 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementThrow(__loc__); }
#line 2914 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 87: // stmt: "yield" ';'
#line 487 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementYield(__loc__); }
#line 2920 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 88: // stmt: "break" ';'
#line 488 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementBreak(__loc__); }
#line 2926 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 89: // stmt: "continue" ';'
#line 489 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementContinue(__loc__); }
#line 2932 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 90: // stmt: "if" '(' expr ')' block opt_else_block
#line 491 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementIf(std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 2938 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 91: // stmt: "if" '(' local_init_decl ')' block opt_else_block
#line 493 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementIf(std::move(yystack_[3].value.as < hilti::Declaration* > ()), {}, std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 2944 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 92: // stmt: "if" '(' local_init_decl ';' expr ')' block opt_else_block
#line 495 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementIf(std::move(yystack_[5].value.as < hilti::Declaration* > ()), std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 2950 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 93: // stmt: "while" '(' local_init_decl ';' expr ')' block opt_else_block
#line 497 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementWhile(std::move(yystack_[5].value.as < hilti::Declaration* > ()), std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 2956 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 94: // stmt: "while" '(' expr ')' block opt_else_block
#line 499 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementWhile(std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 2962 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 95: // stmt: "while" '(' local_init_decl ')' block opt_else_block
#line 501 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementWhile(std::move(yystack_[3].value.as < hilti::Declaration* > ()), {}, std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 2968 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 96: // stmt: "for" '(' local_id "in" expr ')' block
#line 503 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementFor(std::move(yystack_[4].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 2974 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 97: // stmt: "switch" '(' expr ')' '{' opt_switch_cases '}'
#line 505 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementSwitch(std::move(yystack_[4].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::statement::switch_::Cases > ()), __loc__); }
#line 2980 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 98: // stmt: "switch" '(' local_init_decl ')' '{' opt_switch_cases '}'
#line 507 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementSwitch(std::move(yystack_[4].value.as < hilti::Declaration* > ()), std::move(yystack_[1].value.as < hilti::statement::switch_::Cases > ()), __loc__); }
#line 2986 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 99: // stmt: "try" block try_catches
#line 509 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementTry(std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::statement::try_::Catches > ()), __loc__); }
#line 2992 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 100: // stmt: "assert" expr ';'
#line 510 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementAssert(std::move(yystack_[1].value.as < hilti::Expression* > ()), {}, __loc__); }
#line 2998 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 101: // stmt: "assert-exception" expr_no_or_error ':' expr ';'
#line 512 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementAssert(hilti::statement::assert::Exception(), std::move(yystack_[3].value.as < hilti::Expression* > ()), {}, std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 3004 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 102: // stmt: "assert-exception" expr_no_or_error ';'
#line 514 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementAssert(hilti::statement::assert::Exception(), std::move(yystack_[1].value.as < hilti::Expression* > ()), {}, {}, __loc__); }
#line 3010 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 103: // stmt: "add" expr ';'
#line 516 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { auto op = yystack_[1].value.as < hilti::Expression* > ()->tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'add' must be used with index expression only");

                                                   auto expr = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Add, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement* > () = builder->statementExpression(std::move(expr), __loc__);
                                                 }
#line 3022 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 104: // stmt: "delete" expr ';'
#line 524 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { auto op = yystack_[1].value.as < hilti::Expression* > ()->tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'delete' must be used with index expressions only");

                                                   auto expr = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Delete, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement* > () = builder->statementExpression(std::move(expr), __loc__);
                                                 }
#line 3034 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 105: // stmt: "unset" expr ';'
#line 532 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { auto op = yystack_[1].value.as < hilti::Expression* > ()->tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Member) )
                                                        error(yylhs.location, "'unset' must be used with member expressions only");

                                                   auto expr = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Unset, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement* > () = builder->statementExpression(std::move(expr), __loc__);
                                                 }
#line 3046 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 106: // opt_else_block: "else" block
#line 542 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = std::move(yystack_[0].value.as < hilti::Statement* > ()); }
#line 3052 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 107: // opt_else_block: %empty
#line 543 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = {}; }
#line 3058 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 108: // opt_switch_cases: switch_cases
#line 546 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::switch_::Cases > () = std::move(yystack_[0].value.as < hilti::statement::switch_::Cases > ()); }
#line 3064 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 109: // opt_switch_cases: %empty
#line 547 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::switch_::Cases > () = {}; }
#line 3070 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 110: // switch_cases: switch_cases switch_case
#line 549 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::switch_::Cases > () = std::move(yystack_[1].value.as < hilti::statement::switch_::Cases > ()); yylhs.value.as < hilti::statement::switch_::Cases > ().push_back(std::move(yystack_[0].value.as < hilti::statement::switch_::Case* > ())); }
#line 3076 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 111: // switch_cases: switch_case
#line 550 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::switch_::Cases > () = hilti::statement::switch_::Cases({std::move(yystack_[0].value.as < hilti::statement::switch_::Case* > ())}); }
#line 3082 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 112: // switch_case: "case" case_exprs ':' block
#line 552 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                      { yylhs.value.as < hilti::statement::switch_::Case* > () = builder->statementSwitchCase(std::move(yystack_[2].value.as < hilti::Expressions > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3088 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 113: // switch_case: "default" ':' block
#line 553 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::switch_::Case* > () = builder->statementSwitchCase(hilti::statement::switch_::Default(), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3094 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 114: // case_exprs: case_exprs ',' expr_no_or_error
#line 555 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = std::move(yystack_[2].value.as < hilti::Expressions > ()); yylhs.value.as < hilti::Expressions > ().push_back(std::move(yystack_[0].value.as < hilti::Expression* > ())); }
#line 3100 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 115: // case_exprs: expr_no_or_error
#line 556 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[0].value.as < hilti::Expression* > ())}; }
#line 3106 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 116: // try_catches: try_catches try_catch
#line 558 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::try_::Catches > () = std::move(yystack_[1].value.as < hilti::statement::try_::Catches > ()); yylhs.value.as < hilti::statement::try_::Catches > ().push_back(std::move(yystack_[0].value.as < hilti::statement::try_::Catch* > ())); }
#line 3112 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 117: // try_catches: try_catch
#line 559 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::try_::Catches > () = hilti::statement::try_::Catches({ std::move(yystack_[0].value.as < hilti::statement::try_::Catch* > ()) }); }
#line 3118 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 118: // try_catch: "catch" '(' func_param_type local_id ')' block
#line 562 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::try_::Catch* > () = builder->statementTryCatch(builder->declarationParameter(yystack_[2].value.as < hilti::ID > (), yystack_[3].value.as < hilti::UnqualifiedType* > (), parameter::Kind::In, {}, {}, __loc__), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3124 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 119: // try_catch: "catch" block
#line 563 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::try_::Catch* > () = builder->statementTryCatch(std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3130 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 120: // stmt_decl: local_decl
#line 565 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementDeclaration(yystack_[0].value.as < hilti::Declaration* > (), __loc__); }
#line 3136 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 121: // stmt_decl: type_decl
#line 566 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementDeclaration(yystack_[0].value.as < hilti::Declaration* > (), __loc__); }
#line 3142 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 122: // stmt_decl: constant_decl
#line 567 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementDeclaration(yystack_[0].value.as < hilti::Declaration* > (), __loc__); }
#line 3148 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 123: // stmt_expr: expr
#line 570 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementExpression(yystack_[0].value.as < hilti::Expression* > (), __loc__); }
#line 3154 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 124: // base_type_no_attrs: "any"
#line 575 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeAny(__loc__); }
#line 3160 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 125: // base_type_no_attrs: "addr"
#line 576 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeAddress(__loc__); }
#line 3166 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 126: // base_type_no_attrs: "bool"
#line 577 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeBool(__loc__); }
#line 3172 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 127: // base_type_no_attrs: "bytes"
#line 578 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeBytes(__loc__); }
#line 3178 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 128: // base_type_no_attrs: "error"
#line 579 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeError(__loc__); }
#line 3184 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 129: // base_type_no_attrs: "interval"
#line 580 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeInterval(__loc__); }
#line 3190 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 130: // base_type_no_attrs: "net"
#line 581 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeNetwork(__loc__); }
#line 3196 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 131: // base_type_no_attrs: "port"
#line 582 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typePort(__loc__); }
#line 3202 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 132: // base_type_no_attrs: "real"
#line 583 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeReal(__loc__); }
#line 3208 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 133: // base_type_no_attrs: "regexp"
#line 584 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeRegExp(__loc__); }
#line 3214 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 134: // base_type_no_attrs: "stream"
#line 585 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeStream(__loc__); }
#line 3220 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 135: // base_type_no_attrs: "string"
#line 586 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeString(__loc__); }
#line 3226 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 136: // base_type_no_attrs: "time"
#line 587 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeTime(__loc__); }
#line 3232 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 137: // base_type_no_attrs: "void"
#line 588 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeVoid(__loc__); }
#line 3238 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 138: // base_type_no_attrs: "int" type_param_begin "unsigned integer value" type_param_end
#line 590 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSignedInteger(yystack_[1].value.as < uint64_t > (), __loc__); }
#line 3244 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 139: // base_type_no_attrs: "int" type_param_begin '*' type_param_end
#line 591 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSignedInteger(hilti::type::Wildcard(), __loc__); }
#line 3250 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 140: // base_type_no_attrs: "uint" type_param_begin "unsigned integer value" type_param_end
#line 592 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeUnsignedInteger(yystack_[1].value.as < uint64_t > (), __loc__); }
#line 3256 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 141: // base_type_no_attrs: "uint" type_param_begin '*' type_param_end
#line 593 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeUnsignedInteger(hilti::type::Wildcard(), __loc__); }
#line 3262 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 142: // base_type_no_attrs: "optional" type_param_begin qtype type_param_end
#line 595 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeOptional(yystack_[1].value.as < hilti::QualifiedType* > (), __loc__); }
#line 3268 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 143: // base_type_no_attrs: "result" type_param_begin qtype type_param_end
#line 596 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeResult(yystack_[1].value.as < hilti::QualifiedType* > (), __loc__); }
#line 3274 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 144: // base_type_no_attrs: "view" type_param_begin qtype type_param_end
#line 597 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = viewForType(builder, std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__)->type(); }
#line 3280 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 145: // base_type_no_attrs: "iterator" type_param_begin qtype type_param_end
#line 598 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = iteratorForType(builder, std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__)->type(); }
#line 3286 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 146: // base_type_no_attrs: "strong_ref" type_param_begin qtype type_param_end
#line 599 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeStrongReference(yystack_[1].value.as < hilti::QualifiedType* > (), __loc__); }
#line 3292 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 147: // base_type_no_attrs: "strong_ref" type_param_begin '*' type_param_end
#line 600 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeStrongReference(hilti::type::Wildcard(), __loc__); }
#line 3298 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 148: // base_type_no_attrs: "value_ref" type_param_begin qtype type_param_end
#line 601 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeValueReference(yystack_[1].value.as < hilti::QualifiedType* > (), __loc__); }
#line 3304 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 149: // base_type_no_attrs: "value_ref" type_param_begin '*' type_param_end
#line 602 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeValueReference(hilti::type::Wildcard(), __loc__); }
#line 3310 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 150: // base_type_no_attrs: "weak_ref" type_param_begin qtype type_param_end
#line 603 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeWeakReference(yystack_[1].value.as < hilti::QualifiedType* > (), __loc__); }
#line 3316 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 151: // base_type_no_attrs: "weak_ref" type_param_begin '*' type_param_end
#line 604 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeWeakReference(hilti::type::Wildcard(), __loc__); }
#line 3322 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 152: // base_type_no_attrs: "list" type_param_begin '*' type_param_end
#line 606 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeList(hilti::type::Wildcard(), __loc__); }
#line 3328 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 153: // base_type_no_attrs: "list" type_param_begin qtype type_param_end
#line 607 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeList(std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__); }
#line 3334 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 154: // base_type_no_attrs: "vector" type_param_begin '*' type_param_end
#line 608 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeVector(hilti::type::Wildcard(), __loc__); }
#line 3340 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 155: // base_type_no_attrs: "vector" type_param_begin qtype type_param_end
#line 609 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeVector(std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__); }
#line 3346 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 156: // base_type_no_attrs: "set" type_param_begin '*' type_param_end
#line 610 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSet(hilti::type::Wildcard(), __loc__); }
#line 3352 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 157: // base_type_no_attrs: "set" type_param_begin qtype type_param_end
#line 611 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSet(std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__); }
#line 3358 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 158: // base_type_no_attrs: "map" type_param_begin '*' type_param_end
#line 612 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeMap(hilti::type::Wildcard(), __loc__); }
#line 3364 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 159: // base_type_no_attrs: "map" type_param_begin qtype ',' qtype type_param_end
#line 613 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeMap(std::move(yystack_[3].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__); }
#line 3370 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 160: // base_type_no_attrs: "exception"
#line 615 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeException(__loc__); }
#line 3376 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 161: // base_type_no_attrs: '[' "exception" ':' type ']'
#line 616 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeException(std::move(yystack_[1].value.as < hilti::UnqualifiedType* > ()), __loc__); }
#line 3382 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 162: // base_type_no_attrs: "library type" '(' "string value" ')'
#line 618 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeLibrary(std::move(yystack_[1].value.as < std::string > ()), __loc__); }
#line 3388 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 163: // base_type_no_attrs: tuple_type
#line 620 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3394 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 164: // base_type_no_attrs: struct_type
#line 621 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3400 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 165: // base_type_no_attrs: union_type
#line 622 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3406 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 166: // base_type_no_attrs: enum_type
#line 623 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3412 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 167: // base_type_no_attrs: bitfield_type
#line 624 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3418 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 168: // base_type: base_type_no_attrs
#line 627 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = yystack_[0].value.as < hilti::UnqualifiedType* > (); }
#line 3424 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 169: // type: base_type
#line 630 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3430 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 170: // type: function_type
#line 631 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3436 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 171: // type: scoped_id
#line 632 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeName(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 3442 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 172: // qtype: type
#line 635 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = builder->qualifiedType(std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()), Constness::Mutable, __loc__); }
#line 3448 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 173: // qtype: "const" type
#line 636 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = builder->qualifiedType(std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()), Constness::Const, __loc__); }
#line 3454 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 174: // qtype: "auto"
#line 637 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = builder->qualifiedType(builder->typeAuto(__loc__), Constness::Const, __loc__); }
#line 3460 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 175: // type_param_begin: '<'
#line 642 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
              { driver->disableExpressionMode(); }
#line 3466 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 176: // type_param_end: '>'
#line 646 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
              { driver->enableExpressionMode(); }
#line 3472 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 177: // function_type: opt_func_flavor "function" '(' opt_func_params ')' "->" qtype
#line 649 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeFunction(yystack_[0].value.as < hilti::QualifiedType* > (), yystack_[3].value.as < hilti::type::function::Parameters > (), yystack_[6].value.as < hilti::type::function::Flavor > (), __loc__); }
#line 3478 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 178: // tuple_type: "tuple" type_param_begin '*' type_param_end
#line 652 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeTuple(hilti::type::Wildcard(), __loc__); }
#line 3484 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 179: // tuple_type: "tuple" type_param_begin tuple_type_elems type_param_end
#line 653 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeTuple(std::move(yystack_[1].value.as < hilti::type::tuple::Elements > ()), __loc__); }
#line 3490 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 180: // tuple_type_elems: tuple_type_elems ',' tuple_type_elem
#line 658 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::tuple::Elements > () = std::move(yystack_[2].value.as < hilti::type::tuple::Elements > ()); yylhs.value.as < hilti::type::tuple::Elements > ().push_back(std::move(yystack_[0].value.as < hilti::type::tuple::Element* > ())); }
#line 3496 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 181: // tuple_type_elems: tuple_type_elem
#line 659 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::tuple::Elements > () = hilti::type::tuple::Elements{std::move(yystack_[0].value.as < hilti::type::tuple::Element* > ())}; }
#line 3502 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 182: // tuple_type_elem: qtype
#line 663 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < hilti::type::tuple::Element* > () = builder->typeTupleElement(hilti::ID(), std::move(yystack_[0].value.as < hilti::QualifiedType* > ()), __loc__); }
#line 3508 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 183: // tuple_type_elem: local_id ':' qtype
#line 664 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < hilti::type::tuple::Element* > () = builder->typeTupleElement(std::move(yystack_[2].value.as < hilti::ID > ()), std::move(yystack_[0].value.as < hilti::QualifiedType* > ()), __loc__); }
#line 3514 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 184: // struct_type: "struct" opt_struct_params '{' struct_fields '}'
#line 667 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                   { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeStruct(std::move(yystack_[3].value.as < hilti::type::function::Parameters > ()), std::move(yystack_[1].value.as < hilti::Declarations > ()), __loc__); }
#line 3520 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 185: // opt_struct_params: '(' opt_func_params ')'
#line 670 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Parameters > () = std::move(yystack_[1].value.as < hilti::type::function::Parameters > ()); }
#line 3526 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 186: // opt_struct_params: %empty
#line 671 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Parameters > () = hilti::type::function::Parameters{}; }
#line 3532 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 187: // struct_fields: struct_fields struct_field
#line 673 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declarations > () = std::move(yystack_[1].value.as < hilti::Declarations > ()); yylhs.value.as < hilti::Declarations > ().push_back(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 3538 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 188: // struct_fields: %empty
#line 674 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declarations > () = hilti::Declarations{}; }
#line 3544 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 189: // struct_field: qtype local_id opt_attributes ';'
#line 676 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < hilti::Declaration* > () = builder->declarationField(std::move(yystack_[2].value.as < hilti::ID > ()), std::move(yystack_[3].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 3550 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 190: // struct_field: func_flavor opt_func_cc qtype function_id '(' opt_func_params ')' opt_attributes ';'
#line 677 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                                                     {
                                                   auto ftype = builder->typeFunction(std::move(yystack_[6].value.as < hilti::QualifiedType* > ()), std::move(yystack_[3].value.as < hilti::type::function::Parameters > ()), yystack_[8].value.as < hilti::type::function::Flavor > (), __loc__);
                                                   yylhs.value.as < hilti::Declaration* > () = builder->declarationField(std::move(yystack_[5].value.as < hilti::ID > ()), yystack_[7].value.as < hilti::function::CallingConvention > (), std::move(ftype), yystack_[1].value.as < hilti::AttributeSet* > (), __loc__);
                                                   }
#line 3559 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 191: // struct_field: func_flavor opt_func_cc qtype function_id '(' opt_func_params ')' opt_attributes braced_block
#line 681 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                                                              {
                                                   auto ftype = builder->typeFunction(std::move(yystack_[6].value.as < hilti::QualifiedType* > ()), std::move(yystack_[3].value.as < hilti::type::function::Parameters > ()), yystack_[8].value.as < hilti::type::function::Flavor > (), __loc__);
                                                   auto func = builder->function(yystack_[5].value.as < hilti::ID > (), std::move(ftype), std::move(yystack_[0].value.as < hilti::Statement* > ()), yystack_[7].value.as < hilti::function::CallingConvention > (), {});
                                                   yylhs.value.as < hilti::Declaration* > () = builder->declarationField(yystack_[5].value.as < hilti::ID > (), std::move(func), yystack_[1].value.as < hilti::AttributeSet* > (), __loc__);
                                                   }
#line 3569 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 192: // union_type: "union" opt_attributes '{' opt_union_fields '}'
#line 688 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeUnion(std::move(yystack_[1].value.as < hilti::Declarations > ()), __loc__); }
#line 3575 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 193: // opt_union_fields: union_fields
#line 690 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declarations > () = yystack_[0].value.as < hilti::Declarations > (); }
#line 3581 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 194: // opt_union_fields: %empty
#line 691 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declarations > () = hilti::Declarations{}; }
#line 3587 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 195: // union_fields: union_fields ',' union_field
#line 693 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declarations > () = std::move(yystack_[2].value.as < hilti::Declarations > ()); yylhs.value.as < hilti::Declarations > ().push_back(std::move(yystack_[0].value.as < hilti::Declaration* > ())); }
#line 3593 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 196: // union_fields: union_field
#line 694 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declarations > () = hilti::Declarations{}; yylhs.value.as < hilti::Declarations > ().push_back(std::move(yystack_[0].value.as < hilti::Declaration* > ())); }
#line 3599 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 197: // union_field: qtype local_id opt_attributes
#line 696 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < hilti::Declaration* > () = builder->declarationField(std::move(yystack_[1].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::QualifiedType* > ()), std::move(yystack_[0].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 3605 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 198: // enum_type: "enum" '{' enum_labels '}'
#line 698 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeEnum(std::move(yystack_[1].value.as < hilti::type::enum_::Labels > ()), __loc__); }
#line 3611 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 199: // enum_type: "enum" '<' '*' '>'
#line 699 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeEnum(type::Wildcard(), __loc__); }
#line 3617 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 200: // enum_labels: enum_labels ',' enum_label
#line 701 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Labels > () = std::move(yystack_[2].value.as < hilti::type::enum_::Labels > ()); yylhs.value.as < hilti::type::enum_::Labels > ().push_back(std::move(yystack_[0].value.as < hilti::type::enum_::Label* > ())); }
#line 3623 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 201: // enum_labels: enum_labels ','
#line 702 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Labels > () = std::move(yystack_[1].value.as < hilti::type::enum_::Labels > ()); }
#line 3629 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 202: // enum_labels: enum_label
#line 703 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Labels > () = hilti::type::enum_::Labels(); yylhs.value.as < hilti::type::enum_::Labels > ().push_back(std::move(yystack_[0].value.as < hilti::type::enum_::Label* > ())); }
#line 3635 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 203: // enum_label: local_id
#line 706 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Label* > () = builder->typeEnumLabel(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 3641 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 204: // enum_label: local_id '=' "unsigned integer value"
#line 707 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Label* > () = builder->typeEnumLabel(std::move(yystack_[2].value.as < hilti::ID > ()), yystack_[0].value.as < uint64_t > (), __loc__); }
#line 3647 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 205: // $@3: %empty
#line 711 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { _field_width = yystack_[1].value.as < uint64_t > (); }
#line 3653 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 206: // bitfield_type: "bitfield" '(' "unsigned integer value" ')' $@3 '{' opt_bitfield_bit_ranges '}'
#line 713 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeBitfield(yystack_[5].value.as < uint64_t > (), yystack_[1].value.as < hilti::type::bitfield::BitRanges > (), {}, __loc__); }
#line 3659 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 207: // opt_bitfield_bit_ranges: bitfield_bit_ranges
#line 717 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRanges > () = std::move(yystack_[0].value.as < hilti::type::bitfield::BitRanges > ()); }
#line 3665 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 208: // opt_bitfield_bit_ranges: %empty
#line 718 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRanges > () = type::bitfield::BitRanges(); }
#line 3671 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 209: // bitfield_bit_ranges: bitfield_bit_ranges bitfield_bit_range
#line 722 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRanges > () = std::move(yystack_[1].value.as < hilti::type::bitfield::BitRanges > ()); yylhs.value.as < hilti::type::bitfield::BitRanges > ().push_back(std::move(yystack_[0].value.as < hilti::type::bitfield::BitRange* > ()));  }
#line 3677 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 210: // bitfield_bit_ranges: bitfield_bit_range
#line 723 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRanges > () = type::bitfield::BitRanges(); yylhs.value.as < hilti::type::bitfield::BitRanges > ().push_back(std::move(yystack_[0].value.as < hilti::type::bitfield::BitRange* > ())); }
#line 3683 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 211: // bitfield_bit_range: local_id ':' "unsigned integer value" ".." "unsigned integer value" opt_attributes ';'
#line 727 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRange* > () = builder->typeBitfieldBitRange(std::move(yystack_[6].value.as < hilti::ID > ()), yystack_[4].value.as < uint64_t > (), yystack_[2].value.as < uint64_t > (), _field_width, std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 3689 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 212: // bitfield_bit_range: local_id ':' "unsigned integer value" opt_attributes ';'
#line 729 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRange* > () = builder->typeBitfieldBitRange(std::move(yystack_[4].value.as < hilti::ID > ()), yystack_[2].value.as < uint64_t > (), yystack_[2].value.as < uint64_t > (), _field_width, std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 3695 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 213: // expr: expr_0
#line 732 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3701 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 214: // expr_no_or_error: expr_1
#line 736 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3707 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 215: // opt_exprs: exprs
#line 738 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = std::move(yystack_[0].value.as < hilti::Expressions > ()); }
#line 3713 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 216: // opt_exprs: %empty
#line 739 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions(); }
#line 3719 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 217: // exprs: exprs ',' expr
#line 741 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = std::move(yystack_[2].value.as < hilti::Expressions > ()); yylhs.value.as < hilti::Expressions > ().push_back(std::move(yystack_[0].value.as < hilti::Expression* > ())); }
#line 3725 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 218: // exprs: expr
#line 742 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[0].value.as < hilti::Expression* > ())}; }
#line 3731 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 219: // expr_0: expr_1
#line 744 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3737 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 220: // expr_0: expr_1 ':' expr
#line 745 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionConditionTest(std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 3743 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 221: // expr_1: expr_2 '=' expr_1
#line 748 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionAssign(std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 3749 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 222: // expr_1: expr_2 "-=" expr_1
#line 749 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::DifferenceAssign, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3755 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 223: // expr_1: expr_2 "+=" expr_1
#line 750 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::SumAssign, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3761 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 224: // expr_1: expr_2 "*=" expr_1
#line 751 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::MultipleAssign, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3767 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 225: // expr_1: expr_2 "/=" expr_1
#line 752 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::DivisionAssign, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3773 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 226: // expr_1: expr_2 '?' expr_1 ':' expr
#line 753 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionTernary(std::move(yystack_[4].value.as < hilti::Expression* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 3779 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 227: // expr_1: expr_2
#line 754 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3785 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 228: // expr_2: expr_2 "||" expr_3
#line 756 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionLogicalOr(std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 3791 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 229: // expr_2: expr_3
#line 757 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3797 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 230: // expr_3: expr_3 "&&" expr_4
#line 759 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionLogicalAnd(std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 3803 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 231: // expr_3: expr_4
#line 760 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3809 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 232: // expr_4: expr_4 "==" expr_5
#line 762 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Equal, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3815 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 233: // expr_4: expr_4 "!=" expr_5
#line 763 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Unequal, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3821 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 234: // expr_4: expr_5
#line 764 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3827 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 235: // expr_5: expr_5 '<' expr_6
#line 766 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Lower, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3833 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 236: // expr_5: expr_5 '>' expr_6
#line 767 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Greater, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3839 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 237: // expr_5: expr_5 ">=" expr_6
#line 768 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::GreaterEqual, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3845 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 238: // expr_5: expr_5 "<=" expr_6
#line 769 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::LowerEqual, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3851 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 239: // expr_5: expr_6
#line 770 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3857 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 240: // expr_6: expr_6 '|' expr_7
#line 772 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::BitOr, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3863 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 241: // expr_6: expr_7
#line 773 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3869 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 242: // expr_7: expr_7 '^' expr_8
#line 775 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::BitXor, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3875 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 243: // expr_7: expr_8
#line 776 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3881 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 244: // expr_8: expr_8 '&' expr_9
#line 778 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::BitAnd, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3887 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 245: // expr_8: expr_9
#line 779 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3893 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 246: // expr_9: expr_9 "<<" expr_a
#line 781 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::ShiftLeft, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3899 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 247: // expr_9: expr_9 ">>" expr_a
#line 782 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::ShiftRight, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3905 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 248: // expr_9: expr_a
#line 783 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3911 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 249: // expr_a: expr_a '+' expr_b
#line 785 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Sum, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3917 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 250: // expr_a: expr_a '-' expr_b
#line 786 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Difference, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3923 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 251: // expr_a: expr_b
#line 787 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3929 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 252: // expr_b: expr_b '%' expr_c
#line 789 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Modulo, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3935 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 253: // expr_b: expr_b '*' expr_c
#line 790 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Multiple, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3941 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 254: // expr_b: expr_b '/' expr_c
#line 791 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Division, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3947 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 255: // expr_b: expr_b "**" expr_c
#line 792 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Power, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3953 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 256: // expr_b: expr_c
#line 793 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3959 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 257: // expr_c: '!' expr_c
#line 795 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionLogicalNot(std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 3965 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 258: // expr_c: '*' expr_c
#line 796 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Deref, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3971 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 259: // expr_c: '~' expr_c
#line 797 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Negate, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3977 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 260: // expr_c: '|' expr_c '|'
#line 798 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Size, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 3983 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 261: // expr_c: "--" expr_c
#line 799 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::DecrPrefix, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3989 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 262: // expr_c: "++" expr_c
#line 800 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::IncrPrefix, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 3995 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 263: // expr_c: expr_d
#line 801 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4001 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 264: // expr_d: expr_d '(' opt_exprs ')'
#line 803 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Call, {std::move(yystack_[3].value.as < hilti::Expression* > ()), builder->expressionCtor(builder->ctorTuple(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__))}, __loc__); }
#line 4007 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 265: // expr_d: expr_d '.' member_expr
#line 804 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Member, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4013 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 266: // expr_d: expr_d '.' member_expr '(' opt_exprs ')'
#line 805 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                         { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::MemberCall, {std::move(yystack_[5].value.as < hilti::Expression* > ()), std::move(yystack_[3].value.as < hilti::Expression* > ()), builder->expressionCtor(builder->ctorTuple(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__))}, __loc__); }
#line 4019 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 267: // expr_d: expr_d '[' expr ']'
#line 806 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Index, {std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4025 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 268: // expr_d: expr_d "?." member_expr
#line 807 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::HasMember, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4031 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 269: // expr_d: expr_d "in" expr_d
#line 808 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4037 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 270: // expr_d: expr_d "!in" expr_d
#line 809 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionLogicalNot(builder->expressionUnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__)); }
#line 4043 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 271: // expr_d: expr_d "--"
#line 810 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::DecrPostfix, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4049 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 272: // expr_d: expr_d "++"
#line 811 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::IncrPostfix, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4055 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 273: // expr_d: expr_d ".?" member_expr
#line 812 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::TryMember, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4061 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 274: // expr_d: expr_e
#line 813 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4067 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 275: // expr_e: "begin" '(' expr ')'
#line 815 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Begin, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4073 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 276: // expr_e: "cast" type_param_begin qtype type_param_end '(' expr ')'
#line 816 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Cast, {std::move(yystack_[1].value.as < hilti::Expression* > ()), builder->expressionType(std::move(yystack_[4].value.as < hilti::QualifiedType* > ()))}, __loc__); }
#line 4079 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 277: // expr_e: "end" '(' expr ')'
#line 817 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::End, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4085 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 278: // expr_e: "move" '(' expr ')'
#line 818 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionMove(std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 4091 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 279: // expr_e: "pack" tuple_expr
#line 819 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                  { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Pack, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4097 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 280: // expr_e: "unpack" type_param_begin qtype type_param_end tuple_expr
#line 820 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Unpack, {builder->expressionType(std::move(yystack_[2].value.as < hilti::QualifiedType* > ())), std::move(yystack_[0].value.as < hilti::Expression* > ()), builder->expressionCtor(builder->ctorBool(false), __loc__)}, __loc__); }
#line 4103 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 281: // expr_e: "new" expr
#line 821 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::New, {std::move(yystack_[0].value.as < hilti::Expression* > ()), builder->expressionCtor(builder->ctorTuple({}, __loc__))}, __loc__); }
#line 4109 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 282: // expr_e: "new" qtype
#line 822 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::New, {builder->expressionType(std::move(yystack_[0].value.as < hilti::QualifiedType* > ())), builder->expressionCtor(builder->ctorTuple({}, __loc__))}, __loc__); }
#line 4115 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 283: // expr_e: "new" qtype '(' opt_exprs ')'
#line 823 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::New, {builder->expressionType(std::move(yystack_[3].value.as < hilti::QualifiedType* > ())), builder->expressionCtor(builder->ctorTuple(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__))}, __loc__); }
#line 4121 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 284: // expr_e: "typeinfo" '(' expr ')'
#line 824 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionTypeInfo(std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 4127 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 285: // expr_e: "typeinfo" '(' base_type ')'
#line 825 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionTypeInfo(builder->expressionType(builder->qualifiedType(std::move(yystack_[1].value.as < hilti::UnqualifiedType* > ()), Constness::Mutable)), __loc__); }
#line 4133 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 286: // expr_e: expr_f
#line 826 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4139 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 287: // expr_f: ctor
#line 828 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionCtor(std::move(yystack_[0].value.as < hilti::Ctor* > ()), __loc__); }
#line 4145 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 288: // expr_f: ctor_expr
#line 829 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4151 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 289: // expr_f: '-' expr_f
#line 830 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::SignNeg, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4157 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 290: // expr_f: '[' expr "for" local_id "in" expr ']'
#line 832 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionListComprehension(std::move(yystack_[1].value.as < hilti::Expression* > ()), std::move(yystack_[5].value.as < hilti::Expression* > ()), std::move(yystack_[3].value.as < hilti::ID > ()), {},  __loc__); }
#line 4163 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 291: // expr_f: '[' expr "for" local_id "in" expr "if" expr ']'
#line 834 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionListComprehension(std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[7].value.as < hilti::Expression* > ()), std::move(yystack_[5].value.as < hilti::ID > ()), std::move(yystack_[1].value.as < hilti::Expression* > ()),  __loc__); }
#line 4169 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 292: // expr_f: expr_g
#line 835 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4175 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 293: // expr_g: '(' expr ')'
#line 837 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionGrouping(std::move(yystack_[1].value.as < hilti::Expression* > ())); }
#line 4181 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 294: // expr_g: scoped_id
#line 838 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionName(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 4187 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 295: // expr_g: "$$"
#line 839 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionName(std::move("__dd"), __loc__);}
#line 4193 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 296: // expr_g: "scope"
#line 840 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionKeyword(hilti::expression::keyword::Kind::Scope, __loc__); }
#line 4199 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 297: // member_expr: local_id
#line 843 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionMember(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 4205 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 298: // member_expr: "error"
#line 844 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionMember(ID("error"), __loc__); }
#line 4211 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 299: // ctor: "bool value"
#line 848 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorBool(yystack_[0].value.as < bool > (), __loc__); }
#line 4217 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 300: // ctor: "bytes value"
#line 849 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorBytes(std::move(yystack_[0].value.as < std::string > ()), __loc__); }
#line 4223 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 301: // ctor: "string value"
#line 850 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorString(yystack_[0].value.as < std::string > (), false, __loc__); }
#line 4229 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 302: // ctor: "unsigned integer value"
#line 851 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorUnsignedInteger(yystack_[0].value.as < uint64_t > (), 64, __loc__); }
#line 4235 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 303: // ctor: '+' "unsigned integer value"
#line 852 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { if ( yystack_[0].value.as < uint64_t > () > static_cast<uint64_t>(std::numeric_limits<int64_t>::max()) )
                                                    logger().error("integer constant out of range", __loc__.location());

                                                   yylhs.value.as < hilti::Ctor* > () = builder->ctorSignedInteger(yystack_[0].value.as < uint64_t > (), 64, __loc__);
                                                 }
#line 4245 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 304: // ctor: "real value"
#line 857 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorReal(yystack_[0].value.as < double > (), __loc__); }
#line 4251 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 305: // ctor: '+' "real value"
#line 858 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorReal(yystack_[0].value.as < double > (), __loc__);; }
#line 4257 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 306: // ctor: "Null"
#line 859 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorNull(__loc__); }
#line 4263 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 307: // ctor: "address value"
#line 861 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorAddress(hilti::rt::Address(yystack_[0].value.as < std::string > ()), __loc__); }
#line 4269 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 308: // ctor: "address value" '/' "unsigned integer value"
#line 862 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorNetwork(hilti::rt::Network(yystack_[2].value.as < std::string > (), yystack_[0].value.as < uint64_t > ()), __loc__); }
#line 4275 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 309: // ctor: "port value"
#line 863 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorPort(hilti::rt::Port(yystack_[0].value.as < std::string > ()), __loc__); }
#line 4281 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 310: // ctor: "optional" '(' expr ')'
#line 868 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorOptional(std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 4287 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 311: // ctor: "default" type_param_begin type type_param_end '(' opt_exprs ')'
#line 870 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorDefault(std::move(yystack_[4].value.as < hilti::UnqualifiedType* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 4293 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 312: // ctor: list
#line 871 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 4299 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 313: // ctor: map
#line 872 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 4305 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 314: // ctor: regexp
#line 873 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 4311 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 315: // ctor: set
#line 874 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 4317 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 316: // ctor: struct_
#line 875 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 4323 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 317: // ctor: tuple
#line 876 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 4329 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 318: // ctor_expr: "interval" '(' expr ')'
#line 879 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("interval", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4335 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 319: // ctor_expr: "interval_ns" '(' expr ')'
#line 880 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("interval_ns", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4341 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 320: // ctor_expr: "time" '(' expr ')'
#line 881 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("time", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4347 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 321: // ctor_expr: "time_ns" '(' expr ')'
#line 882 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("time_ns", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4353 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 322: // ctor_expr: "stream" '(' expr ')'
#line 883 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("stream", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4359 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 323: // ctor_expr: "error" '(' expr ')'
#line 884 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("error", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4365 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 324: // ctor_expr: "int8" '(' expr ')'
#line 885 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("int8", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4371 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 325: // ctor_expr: "int16" '(' expr ')'
#line 886 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("int16", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4377 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 326: // ctor_expr: "int32" '(' expr ')'
#line 887 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("int32", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4383 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 327: // ctor_expr: "int64" '(' expr ')'
#line 888 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("int64", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4389 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 328: // ctor_expr: "uint8" '(' expr ')'
#line 889 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("uint8", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4395 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 329: // ctor_expr: "uint16" '(' expr ')'
#line 890 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("uint16", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4401 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 330: // ctor_expr: "uint32" '(' expr ')'
#line 891 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("uint32", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4407 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 331: // ctor_expr: "uint64" '(' expr ')'
#line 892 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("uint64", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 4413 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 332: // ctor_expr: "port" '(' expr ',' expr ')'
#line 893 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("port", {std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4419 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 333: // tuple: '(' opt_tuple_elems1 ')'
#line 896 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorTuple(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 4425 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 334: // opt_tuple_elems1: tuple_elem
#line 899 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[0].value.as < hilti::Expression* > ())}; }
#line 4431 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 335: // opt_tuple_elems1: tuple_elem ',' opt_tuple_elems2
#line 900 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[2].value.as < hilti::Expression* > ())}; yylhs.value.as < hilti::Expressions > ().insert(yylhs.value.as < hilti::Expressions > ().end(), yystack_[0].value.as < hilti::Expressions > ().begin(), yystack_[0].value.as < hilti::Expressions > ().end()); }
#line 4437 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 336: // opt_tuple_elems1: %empty
#line 901 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions(); }
#line 4443 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 337: // opt_tuple_elems2: tuple_elem
#line 904 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{ std::move(yystack_[0].value.as < hilti::Expression* > ())}; }
#line 4449 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 338: // opt_tuple_elems2: tuple_elem ',' opt_tuple_elems2
#line 905 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[2].value.as < hilti::Expression* > ())}; yylhs.value.as < hilti::Expressions > ().insert(yylhs.value.as < hilti::Expressions > ().end(), yystack_[0].value.as < hilti::Expressions > ().begin(), yystack_[0].value.as < hilti::Expressions > ().end()); }
#line 4455 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 339: // opt_tuple_elems2: %empty
#line 906 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions(); }
#line 4461 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 340: // tuple_elem: expr
#line 909 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4467 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 341: // tuple_expr: tuple
#line 912 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionCtor(std::move(yystack_[0].value.as < hilti::Ctor* > ()), __loc__); }
#line 4473 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 342: // list: '[' opt_exprs ']'
#line 914 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorList(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 4479 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 343: // list: "list" '(' opt_exprs ')'
#line 915 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorList(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 4485 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 344: // list: "list" type_param_begin qtype type_param_end '(' opt_tuple_elems1 ')'
#line 917 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorList(std::move(yystack_[4].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 4491 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 345: // list: "vector" '(' opt_exprs ')'
#line 918 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorVector(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 4497 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 346: // list: "vector" type_param_begin qtype type_param_end '(' opt_tuple_elems1 ')'
#line 920 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorVector(std::move(yystack_[4].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 4503 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 347: // set: "set" '(' opt_exprs ')'
#line 922 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorSet(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 4509 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 348: // set: "set" type_param_begin qtype type_param_end '(' opt_tuple_elems1 ')'
#line 924 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorSet(std::move(yystack_[4].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 4515 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 349: // map: "map" '(' opt_map_elems ')'
#line 926 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorMap(std::move(yystack_[1].value.as < hilti::ctor::map::Elements > ()), __loc__); }
#line 4521 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 350: // map: "map" type_param_begin qtype ',' qtype type_param_end '(' opt_map_elems ')'
#line 928 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorMap(std::move(yystack_[6].value.as < hilti::QualifiedType* > ()), std::move(yystack_[4].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::ctor::map::Elements > ()), __loc__); }
#line 4527 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 351: // struct_: '[' struct_elems ']'
#line 930 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                             { yylhs.value.as < hilti::Ctor* > () = builder->ctorStruct(std::move(yystack_[1].value.as < hilti::ctor::struct_::Fields > ()), __loc__); }
#line 4533 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 352: // struct_elems: struct_elems ',' struct_elem
#line 932 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::struct_::Fields > () = std::move(yystack_[2].value.as < hilti::ctor::struct_::Fields > ()); yylhs.value.as < hilti::ctor::struct_::Fields > ().push_back(yystack_[0].value.as < hilti::ctor::struct_::Field* > ()); }
#line 4539 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 353: // struct_elems: struct_elem
#line 933 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::struct_::Fields > () = hilti::ctor::struct_::Fields{ std::move(yystack_[0].value.as < hilti::ctor::struct_::Field* > ()) }; }
#line 4545 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 354: // struct_elem: '$' local_id '=' expr
#line 935 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::struct_::Field* > () = builder->ctorStructField(std::move(yystack_[2].value.as < hilti::ID > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())); }
#line 4551 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 355: // regexp: re_patterns opt_attributes
#line 937 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                { yylhs.value.as < hilti::Ctor* > () = builder->ctorRegExp(std::move(yystack_[1].value.as < std::vector<std::string> > ()), std::move(yystack_[0].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 4557 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 356: // re_patterns: re_patterns '|' re_pattern_constant
#line 940 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::vector<std::string> > () = yystack_[2].value.as < std::vector<std::string> > (); yylhs.value.as < std::vector<std::string> > ().push_back(std::move(yystack_[0].value.as < std::string > ())); }
#line 4563 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 357: // re_patterns: re_pattern_constant
#line 941 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::vector<std::string> > () = std::vector<std::string>{std::move(yystack_[0].value.as < std::string > ())}; }
#line 4569 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 358: // $@4: %empty
#line 944 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                    { driver->enablePatternMode(); }
#line 4575 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 359: // $@5: %empty
#line 944 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                             { driver->disablePatternMode(); }
#line 4581 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 360: // re_pattern_constant: '/' $@4 "regular expression value" $@5 '/'
#line 945 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::string > () = std::move(yystack_[2].value.as < std::string > ()); }
#line 4587 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 361: // opt_map_elems: map_elems
#line 947 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Elements > () = std::move(yystack_[0].value.as < hilti::ctor::map::Elements > ()); }
#line 4593 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 362: // opt_map_elems: %empty
#line 948 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Elements > () = hilti::ctor::map::Elements(); }
#line 4599 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 363: // map_elems: map_elems ',' map_elem
#line 950 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Elements > () = std::move(yystack_[2].value.as < hilti::ctor::map::Elements > ()); yylhs.value.as < hilti::ctor::map::Elements > ().push_back(std::move(yystack_[0].value.as < hilti::ctor::map::Element* > ())); }
#line 4605 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 364: // map_elems: map_elem
#line 951 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Elements > () = hilti::ctor::map::Elements(); yylhs.value.as < hilti::ctor::map::Elements > ().push_back(std::move(yystack_[0].value.as < hilti::ctor::map::Element* > ())); }
#line 4611 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 365: // map_elem: expr_no_or_error ':' expr
#line 953 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Element* > () = builder->ctorMapElement(yystack_[2].value.as < hilti::Expression* > (), yystack_[0].value.as < hilti::Expression* > (), __loc__); }
#line 4617 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 366: // attribute: "attribute"
#line 956 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { if ( auto attr_kind = hilti::Attribute::tagToKind(yystack_[0].value.as < std::string > ()) )
                                                     yylhs.value.as < hilti::Attribute* > () = builder->attribute(*attr_kind, __loc__);
                                                   else
                                                     logger().error(hilti::util::fmt("invalid attribute '%s'", yystack_[0].value.as < std::string > ()), __loc__.location());
                                                 }
#line 4627 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 367: // attribute: "attribute" '=' expr
#line 961 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                 { if ( auto attr_kind = hilti::Attribute::tagToKind(yystack_[2].value.as < std::string > ()) )
                                                     yylhs.value.as < hilti::Attribute* > () = builder->attribute(*attr_kind, std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__);
                                                   else
                                                     logger().error(hilti::util::fmt("invalid attribute '%s'", yystack_[2].value.as < std::string > ()), __loc__.location());
                                                 }
#line 4637 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 368: // opt_attributes: opt_attributes attribute
#line 968 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                { if ( yystack_[0].value.as < hilti::Attribute* > () )
                                                    yystack_[1].value.as < hilti::AttributeSet* > ()->add(builder->context(), yystack_[0].value.as < hilti::Attribute* > ());

                                                  yylhs.value.as < hilti::AttributeSet* > () = yystack_[1].value.as < hilti::AttributeSet* > ();
                                                }
#line 4647 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;

  case 369: // opt_attributes: %empty
#line 973 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
                                                { yylhs.value.as < hilti::AttributeSet* > () = builder->attributeSet({}, __loc__); }
#line 4653 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"
    break;


#line 4657 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  Parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // Parser::context.
  Parser::context::context (const Parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  Parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    const int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        const int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        const int yychecklim = yylast_ - yyn + 1;
        const int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }






  int
  Parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  Parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short Parser::yypact_ninf_ = -642;

  const short Parser::yytable_ninf_ = -337;

  const short
  Parser::yypact_[] =
  {
     -72,    36,   117,  -642,   -83,  -642,  -642,  2171,  -642,    67,
    -642,  -642,   -86,  -642,  -642,  -642,  -642,  3701,  3701,  3701,
     -25,     0,   -24,  -642,    50,    84,   -24,  3701,  -642,    16,
      34,    70,    82,    36,  -642,   103,   112,   118,   126,   131,
     133,  -107,  5431,   -31,   187,  3701,   135,  1831,   144,   146,
    3701,   162,  -642,  -642,  -642,  3191,  -642,    -9,   164,   167,
     170,   171,  3361,  2511,   172,   173,   174,   178,   181,   -24,
    3701,    46,   182,   184,  -642,  3701,  3701,  1319,  3701,   239,
    4019,  -642,  3701,  3701,  -642,  -642,  -642,  1491,  1661,  -642,
    -642,  -642,  -642,  -642,   145,  -642,  -642,   185,  -642,  -642,
     183,   -36,   319,     4,   -40,   180,   177,   179,   142,    95,
     -77,  -642,   156,  -642,  -642,  -642,  -642,  -642,  -642,  -642,
    -642,  -642,  -642,  -642,   186,  -642,  3701,  -642,   331,   194,
     195,   -53,  -642,  3701,  -642,  -642,  5557,  -642,     6,  6061,
     196,  3701,  3701,    36,  3531,   -42,  3701,  3701,  3701,  3701,
    3701,  3701,  3701,  5557,  -642,  -642,   348,   198,  -642,  -642,
    6061,  -642,    45,  -642,  -642,  -642,   -24,  -642,   -24,   199,
     -24,   -24,  -642,  -642,   -24,  -642,   -24,  -642,   -24,   -24,
    -642,  -642,   202,  -642,   -24,   -24,  -642,   -24,   -24,  -642,
     -24,   -24,   301,   207,  -642,   296,  -642,  -642,  -642,  -642,
      36,  -642,  -642,  -642,  -642,  -642,  -642,  3701,  5557,  -642,
    -642,  -642,  5557,  -642,  3701,  -642,   208,   209,  -107,   -31,
      47,   211,    -9,   212,   213,    46,  1144,  4123,   216,  -642,
    3701,  3701,  -642,  -642,  -642,  3701,  -642,   219,  3701,  5557,
    3701,  3531,  3701,  3701,  -642,   221,  2681,  -642,  -642,     2,
     340,  -642,  -642,  2341,  3701,  3701,  3701,  3701,  5557,   225,
    3701,  5557,  3531,  -642,   224,   227,   231,  -642,    36,   318,
     223,   232,    66,  -642,   228,  -642,  -642,  -642,   380,  -642,
    -642,  6061,   187,  5683,   187,   261,  -642,  3701,  3701,  3701,
    3701,  3701,  3701,  3701,  3701,  3701,  3701,  3701,  3701,  3701,
    3701,  3701,  3701,  3701,  3701,  3701,  3701,  3701,  3701,  3701,
    3701,  3701,  3701,    32,  3871,  -642,  3871,  -642,    32,  3701,
    3701,    32,   237,   387,   260,  -642,  -642,  -642,  -642,  3701,
     259,   256,   266,   187,   256,  -642,   267,   268,   349,  5809,
      59,   269,  -642,  -642,   273,   275,   277,   278,   279,   280,
    -642,   281,   256,   285,   406,  -642,    36,   282,    18,  5557,
     418,    20,  4291,  5557,  4417,  5557,  4543,   -27,   288,  4669,
      19,    30,  4795,  5557,  4921,  5047,   284,  3701,   289,    90,
     287,   291,   283,  -642,   292,    74,   295,    20,  4291,  4543,
    4795,  3701,   297,  -642,   298,  -642,   303,   256,   305,   306,
     307,   308,   309,  -642,   300,  2851,  -642,  3021,   411,  -642,
     310,   311,   313,   314,   315,   316,   256,  -642,   321,   256,
      96,   322,  -642,  -642,  3701,   304,    36,  -642,  3701,   299,
    -642,  -642,  -642,   326,   261,  -642,  5557,   265,   327,   261,
    -642,  5557,   329,  -642,  -642,  -642,   431,  -642,  -642,  -642,
     325,    41,   -15,   -12,   324,   330,   333,   335,   320,   317,
     161,   115,   127,   -55,   -45,  -642,  -642,  -642,  -642,  -642,
    -642,  -642,   272,   388,  -642,   334,   336,   341,  -642,   338,
    -642,  -642,   351,  -642,  -642,   347,  -642,  5557,   352,  -642,
    -642,  3701,   483,    36,  3701,  2511,  2511,   354,   499,  -642,
    -642,  -642,  -642,  -642,  -642,  -642,   355,  3701,   357,   361,
      35,  -642,   353,   256,   256,   256,   359,   256,   256,   256,
     365,   256,   256,   256,   256,   256,   256,  -642,  -642,   369,
     370,  -642,  5935,  -642,   256,   368,  -642,    73,  -642,   256,
     256,  5173,   256,   256,   256,   256,   256,   256,   256,  6061,
     374,   -27,  3701,  3701,   375,  3701,  -642,  3701,  5557,  -642,
    -642,  -642,  -642,  -642,   376,  -642,   256,   373,   256,   256,
     378,  -642,  3701,  -642,   377,  -642,   384,   385,  -642,  -642,
    -642,  -642,  2001,  -642,  -642,  -642,  -642,  -642,  -642,  -642,
    -642,   146,  -642,   382,  3701,  2511,  2511,  -642,   381,  3701,
     467,  -642,  -642,   379,  3701,   391,    74,   393,  3701,    98,
      74,  5557,  3701,  -642,  -642,  3701,  3701,  -642,  3701,    74,
    3701,   397,   396,   401,   400,   489,   505,  -642,  -642,  3701,
     405,  -642,   544,  -642,    36,  -642,  -642,  -642,  -642,  -642,
    -642,  -642,  -642,  5557,  -642,  -642,  -642,  -642,  -642,  -642,
    -642,    -7,  -642,    36,  -642,  5302,  -642,  5557,  5557,  -642,
    -642,  -642,    36,   409,   407,  -642,  -642,  -642,  -642,  -642,
    -642,  -642,  -642,   402,  -642,   410,   413,   412,  -642,  -642,
    -642,   256,   -27,   414,  5557,   415,   417,  -642,   419,  3701,
     124,   124,    36,  -642,  3701,   420,   513,   522,  3701,  -642,
    3701,  -642,   423,  3701,   424,  3701,   427,  3701,   428,   430,
    -642,  -642,   432,  -642,   433,   435,   436,  2511,  3701,  3701,
    2511,  2511,  -642,  -642,  -642,   437,  -642,   440,  -642,  -642,
     256,  -642,   434,  -642,   157,    36,  -642,  -642,  -642,  -642,
    -642,  5557,  -642,   558,  -642,  -642,   439,   441,   256,  -642,
     442,  3701,   438,   443,   124,  -642,   447,   444,   445,  2511,
    -642,  -642,  -642,   -51,  -642,   448,   -27,   449,  -642,   450,
    -642,   -27,     8,  -642,  -642,   -27,  -642,  -642,  -642,  -642,
     534,  -642,  -642,    36,  -642,  3701,  -642,  5557,  -642,   597,
    -642,  5557,  3701,  -642,   452,  -642,   152,  -642,  2511,  -642,
    -642,  -642,  2511,  -642,   556,  3701,  -642,  -642,   453,  -642,
    -642,   455,  -642,   456,  -642,   457,   461,    36,  -642,  -642,
     597,    58,    12,  -642,   458,    31,  3701,  2511,  -642,  -642,
    -642,   460,  -642,  -642,  -642,   600,  -642,  -642,   462,  -642,
    -642,  -642,  -642,  -642,  -642,    31,    31,   597,   572,   -27,
    -642,  -642,   607,    21,   468,  -642,  -642,  -642,    22,     7,
    -642,  -642,  -642
  };

  const short
  Parser::yydefact_[] =
  {
       0,     0,     0,     3,     0,     1,    11,    45,     5,     0,
     301,   300,   307,   309,   304,   302,   299,     0,     0,     0,
       0,     0,     0,   306,     0,    45,     0,     0,   295,     0,
       0,     0,     0,     0,    43,     0,     0,     0,     0,     0,
       0,     0,    56,     0,    61,     0,     0,    56,     0,     0,
       0,     0,    44,    42,    41,     0,   296,     0,     0,     0,
       0,     0,     0,    45,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     2,   336,     0,   216,     0,     0,
       0,   358,     0,     0,     4,   294,     9,    12,    13,   120,
      14,    15,    16,    17,     0,    10,    82,     0,   123,   213,
     219,   227,   229,   231,   234,   239,   241,   243,   245,   248,
     251,   256,   263,   274,   286,   292,   287,   288,   317,   312,
     315,   313,   316,   314,   369,   357,     0,    39,     0,     0,
       0,     0,   214,     0,    88,   175,    56,    89,    56,    56,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   216,    56,   125,   124,     0,     0,   126,   127,
      56,   132,     0,   128,   160,    58,     0,   129,     0,     0,
       0,     0,    57,   130,     0,   131,     0,   133,     0,     0,
     134,   135,   186,   136,     0,     0,   369,     0,     0,   137,
       0,     0,     0,     4,   171,     0,    55,   168,   169,   172,
       0,   170,   163,   164,   165,   166,   167,   362,    56,    59,
      60,    35,    56,   261,     0,   174,   128,   129,     0,     0,
       0,   131,     0,   134,   136,     0,   216,   171,   282,   281,
       0,   336,   341,   279,   262,     0,    83,     0,   216,    56,
       0,     0,     0,     0,    86,     0,    45,   121,   122,     0,
       0,    74,    75,     0,     0,     0,     0,     0,    56,     0,
     216,    56,     0,    87,   340,     0,   334,   258,     0,   218,
       0,   215,     0,   353,     0,   305,   303,   289,     0,   257,
     259,    56,    61,    56,    61,     0,    81,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   271,     0,   272,     0,   216,
       0,     0,     0,   355,     0,   308,   103,   100,   102,     0,
       0,     0,     0,    61,     0,   104,     0,     0,     0,    56,
       0,     0,     6,    37,     0,     0,     0,     0,     0,     0,
     218,     0,     0,     0,     0,   173,     0,     0,     0,    56,
       0,    56,    56,    56,    56,    56,    56,    71,     0,    56,
       0,     0,    56,    56,    56,    56,     0,     0,     0,    32,
       0,     0,   361,   364,     0,     0,     0,    56,    56,    56,
      56,   216,     0,   340,     0,    84,     0,     0,     0,     0,
       0,     0,     0,    85,     0,    45,    80,    45,    99,   117,
       0,     0,     0,     0,     0,     0,     0,   105,     0,     0,
       0,     0,   293,   333,   339,     0,     0,   342,     0,     0,
     351,   260,   359,   171,     0,    33,    56,     0,   171,     0,
      34,    56,     0,   220,   225,   222,   228,   223,   224,   221,
       0,   230,   232,   233,   237,   238,   235,   236,   240,   242,
     244,   246,   247,   249,   250,   255,   253,   252,   254,   298,
     297,   268,   269,   270,   273,     0,     0,   265,   356,   366,
     368,    40,     0,   275,   176,     0,    36,    56,     0,   277,
     323,     0,     0,     0,     0,    45,    45,     0,     0,   325,
     326,   327,   324,   318,   319,   343,     0,     0,     0,   203,
       0,   202,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    69,    70,     0,
      62,    65,    56,   188,     0,     4,   182,     0,   181,     0,
       0,    56,     0,     0,     0,     0,     0,     0,     0,    56,
       0,    71,     0,   216,     0,     0,   349,     0,    56,    49,
      50,    47,    46,    48,     0,   278,     0,     0,     0,     0,
       0,   310,     0,   347,     0,   322,     0,     0,   320,   321,
      76,    79,    56,   119,   116,   285,   284,   329,   330,   331,
     328,     0,   345,     0,     0,    45,    45,   335,   337,     0,
       0,   217,   352,     0,     0,     0,     0,     0,     0,    32,
       0,    56,     0,   264,   267,   216,     0,   101,     0,     0,
     216,     0,     0,     0,     0,   107,   107,    38,     7,   336,
       0,   205,     0,   198,   201,   199,   138,   139,   145,   162,
     152,   153,   158,    56,   142,   147,   146,   143,   156,   157,
     185,    71,    68,     0,    67,    56,   178,    56,    56,   179,
     140,   141,     0,     0,   193,   196,   154,   155,   144,   149,
     148,   151,   150,     0,    21,     0,     0,     0,    22,   365,
     363,     0,    71,   153,    56,   157,   155,   283,     0,   336,
     109,   109,     0,   280,   336,     0,   107,   107,   339,   354,
       0,   360,     0,     0,     0,     0,     0,     0,     0,     0,
     369,   226,     0,   367,     0,     0,     0,    45,     0,     0,
      45,    45,    91,    90,     8,     0,    24,     0,   204,   200,
       0,    64,    73,   184,    61,     0,   187,   183,   180,   369,
     192,    56,   161,     0,    23,    31,     0,     0,     0,   332,
       0,     0,     0,     0,   108,   111,     0,     0,     0,    45,
      95,    94,   338,     0,    19,     0,    71,     0,    27,     0,
      28,    71,     0,   266,   276,    71,   311,    96,    26,    25,
     107,   106,   344,   208,   159,     0,   369,    56,   369,   197,
     195,    56,   362,   369,   159,   348,     0,   115,    45,    98,
     110,    97,    45,   346,   107,     0,   290,    20,     0,    30,
      29,     0,    18,     0,    92,     0,     0,   207,   210,    72,
      66,     0,     0,   177,     0,     0,     0,    45,   113,   118,
      93,     0,   369,   369,   369,     0,   206,   209,     0,   189,
     350,    52,   114,   112,   291,     0,     0,    54,   369,    71,
      51,    53,     0,     0,     0,   369,   212,   369,     0,     0,
     211,   190,   191
  };

  const short
  Parser::yypgoto_[] =
  {
    -642,  -642,    -1,   530,  -642,  -642,  -642,  -642,  -642,   618,
     619,  -642,  -155,  -642,    23,  -642,  -642,  -642,    64,  -194,
    -423,  -642,  -642,  -642,  -642,   490,   -26,  -277,  -538,  -642,
     -21,    49,  -642,  -642,  -398,  -641,  -642,  -642,     1,  -614,
     -57,  -642,  -119,  -642,  -642,   229,  -642,  -642,  -642,   383,
    -133,   640,   332,   577,  -642,  -642,  -642,   -20,  -642,  -642,
    -642,  -642,  -642,  -642,  -642,  -102,  -642,  -642,     9,  -642,
    -642,  -642,  -642,  -177,   155,   -16,  -148,  -642,  -642,   -18,
    -642,   358,   346,    17,   -60,   342,   339,   343,    25,    26,
     -19,   -58,  -642,   565,  -642,   -87,  -642,  -642,   -47,  -609,
     -48,  -414,    60,  -642,  -642,  -642,  -642,  -642,   226,  -642,
    -642,   337,  -642,  -642,  -139,  -642,    97,  -642,  -169
  };

  const short
  Parser::yydefgoto_[] =
  {
       0,     2,    84,    85,   497,   498,   724,     7,    86,   247,
     248,    89,   340,    90,   554,    91,    92,    93,   249,   563,
     564,   435,   211,   440,   332,   195,   196,   212,   529,   530,
     531,   653,   532,   786,   250,   251,   404,   405,   252,   722,
     753,   754,   755,   796,   408,   409,    96,    97,   197,   198,
     199,   536,   363,   485,   201,   202,   537,   538,   203,   368,
     655,   736,   204,   663,   664,   665,   205,   510,   511,   206,
     727,   816,   817,   818,    98,   380,   270,   271,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   471,   116,   117,   118,   265,
     597,   266,   233,   119,   120,   121,   122,   272,   273,   123,
     124,   125,   278,   603,   381,   382,   383,   480,   323
  };

  const short
  Parser::yytable_[] =
  {
       4,   132,   232,   131,   351,   436,   334,   441,    95,   583,
     598,   288,   723,   675,   479,   479,   527,   371,   805,   479,
     725,   342,     1,     3,     8,   298,   213,   355,   479,   479,
     309,   234,   145,   513,   539,     3,   527,   479,   479,     3,
     154,   193,   281,   155,   299,   215,   528,   152,   157,   158,
     298,   159,   309,   298,   135,   289,   487,   267,   296,   274,
     160,     3,   309,   279,   280,   290,   528,     6,   291,   299,
     161,    94,   299,   162,   165,   163,   164,     3,   559,   560,
     750,   310,   760,   761,   128,   758,   399,   469,   165,   138,
     396,   292,   311,   312,   166,   296,   172,   625,   626,   167,
     328,   297,   168,   310,   329,   169,   170,   420,   171,   806,
     172,   343,   418,   310,   311,   312,   293,     5,   173,   561,
     174,   300,   301,   207,   311,   312,   175,   294,   -63,   133,
     135,   176,   177,   178,   285,   561,   179,   135,   297,   180,
     181,   182,   338,   183,   747,   238,   300,   301,   434,   300,
     301,   184,   135,   134,   185,   353,    34,   246,   751,   186,
     861,   812,   187,   188,   189,   839,   814,   190,   191,   752,
     141,   475,   129,   130,   856,   860,   514,   540,   517,   192,
     541,   246,   140,   704,   841,   281,   633,   709,   142,   132,
     830,   634,    52,    53,    54,   356,   715,   696,   697,   379,
     260,   230,   229,   137,   850,   851,   357,   135,   135,   282,
     237,   283,   494,   284,   495,   209,   210,   245,   862,   126,
     127,   -55,   429,   313,   143,   259,   430,   314,   808,   658,
     264,   474,   269,   811,   477,   484,   144,   813,   454,   455,
     456,   457,   552,   570,   553,   209,   210,   406,   315,   594,
     707,   595,   553,   275,   276,   316,   472,   146,   473,   305,
     306,   317,   307,   308,     3,     8,   147,   425,     3,     8,
     444,   445,   148,   447,   448,   449,   450,   285,   305,   306,
     149,   324,   307,   308,   598,   150,   318,   151,   330,   214,
     465,   466,   467,   468,   307,   308,   336,   337,   230,   341,
     231,   344,   345,   346,   347,   348,   349,   350,   826,   827,
     319,   854,   470,   452,   453,   320,   235,   470,   240,   777,
     470,   241,   780,   781,   242,   243,   253,   254,   255,   321,
     461,   462,   256,   463,   464,   257,   262,   263,   286,   313,
     287,   295,   303,   314,   302,   304,   325,   326,   327,   335,
     322,     3,   354,   360,   136,   509,   367,   376,   139,   377,
     378,   804,   142,   150,   315,   235,   240,   242,   535,   386,
     391,   316,   395,   153,   403,   208,   407,   317,   417,   422,
     426,   269,   423,   427,   562,   392,   393,   424,   428,   239,
     394,   432,   431,   350,   479,   398,   400,   401,   402,   654,
     828,   258,   318,   261,   829,   677,   581,    81,   411,   412,
     413,   414,   415,   481,   483,   350,   673,   421,   484,   486,
     491,   508,   489,   490,   496,   600,   319,   516,   499,   843,
     500,   320,   501,   502,   503,   504,   505,   507,   533,   557,
     512,   549,   443,   551,   555,   321,   556,   407,   558,   654,
     565,   580,   571,   295,   572,   313,   599,   787,   573,   314,
     575,   576,   577,   578,   579,   585,   586,   712,   587,   588,
     589,   590,   716,   268,   350,   476,   592,   596,   604,   608,
     315,   611,   612,   304,   482,   303,     3,   316,   302,   613,
     616,   622,   623,   317,   302,   615,   614,   302,   358,   302,
     359,   618,   361,   362,   617,   628,   620,   627,   364,   629,
     365,   366,   631,   632,   639,   635,   369,   370,   318,   372,
     373,   643,   374,   375,   650,   657,   651,   674,   678,   684,
     682,   689,   550,   687,   690,   691,   694,   698,   700,   132,
     721,   772,   319,   703,   232,   705,   350,   320,   718,   701,
     387,   388,   717,   719,   389,   720,   721,   390,   726,   728,
     740,   321,   742,   741,   721,   743,   744,   745,   629,   689,
     789,   694,   194,   721,   749,   759,   764,   227,   766,   393,
     768,   770,   791,   601,   771,   721,   785,   773,   774,   775,
     783,   776,   782,   792,   799,   798,   793,   795,   801,   802,
     803,   807,   809,   810,   479,   562,   792,   721,   832,   562,
     833,   834,   836,   840,   835,   848,   849,   820,   562,   822,
     844,   852,   855,   857,   825,    87,    88,   838,   333,   734,
     731,   692,   708,   509,   756,   800,   410,   584,   738,   790,
     837,   451,   459,   729,   458,   277,   621,   460,   446,   624,
     762,   693,   732,   824,   680,   602,     0,   535,     0,   478,
       0,   739,   630,   845,   846,   847,   194,     0,     0,   194,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   853,
       0,     0,   200,   194,     0,     0,   858,   228,   859,     0,
     194,   757,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   676,   350,     0,
     679,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   688,     0,     0,
       0,     0,     0,   132,   788,   797,     0,   264,   194,     0,
       0,     0,   194,     0,     0,     0,     0,     0,     0,   695,
       0,     0,     0,     0,   699,     0,     0,     0,     0,   702,
       0,     0,     0,   706,     0,     0,     0,   711,     0,   194,
     350,   713,     0,   714,   132,   350,   331,     0,     0,     0,
       0,     0,   815,     0,   393,     0,     0,     0,   194,     0,
       0,   194,     0,   352,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   132,     0,
     842,   433,     0,   438,     0,   442,   815,     0,     0,     0,
     562,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   393,     0,     0,     0,   384,   393,
       0,     0,   385,   393,     0,   763,     0,     0,   765,     0,
     767,     0,   769,     0,     0,     0,     0,     0,     0,   194,
       0,     0,     0,   778,   779,     0,     0,     0,     0,   397,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   194,
       0,   194,   194,   194,   194,   194,   194,     0,   416,   194,
       0,   419,   194,   194,   194,   194,     0,     0,     0,     0,
       0,   488,     0,     0,     0,     0,     0,   194,   194,   194,
     194,     0,     0,   439,     0,     0,     0,     0,     0,   506,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     819,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     831,     0,     0,     0,   605,     0,   194,   607,     0,   609,
       0,   194,     0,     0,   574,     0,     0,     0,     0,   493,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   591,     0,     0,   593,     0,     0,   515,
       0,   518,   520,   521,   523,   524,   526,     0,     0,     0,
       0,     0,   543,   544,   546,   548,     0,   194,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   566,   567,   568,
     569,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   194,     0,     0,     0,     0,     0,     0,     0,
       0,   194,     0,     0,     0,     0,   606,     0,     0,   194,
       0,   610,     0,     0,     0,     0,     0,     0,   194,     0,
     636,   637,   638,     0,   640,   641,   642,     0,   644,   645,
     646,   647,   648,   649,     0,     0,     0,     0,     0,     0,
       0,   656,   227,     0,   659,     0,   660,   661,     0,   666,
     667,   668,   669,   670,   671,   672,     0,   619,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   194,     0,   683,     0,   685,   686,     3,     8,     0,
       0,     0,     0,    10,    11,     0,    12,    13,    14,    15,
      16,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    20,     0,   194,     0,     0,     0,     0,     0,    22,
       0,   662,     0,    23,     0,   194,     0,   194,   194,    26,
       0,     0,    28,     0,     0,     0,    29,     0,   681,    30,
     376,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   194,     0,     0,     0,     0,    35,
      36,    37,    38,    39,    40,     0,     0,     0,     0,     0,
      41,     0,    43,     0,     0,     0,    45,     0,     0,    46,
      47,     0,     0,     0,    48,     0,     0,    49,     0,    50,
      51,   710,     0,     0,     0,     0,     0,     0,   746,    56,
      57,     0,     0,    58,     0,     0,     0,    60,    61,     0,
       0,   194,     0,     0,     0,     0,     0,    64,     0,    65,
      66,    67,    68,   730,    69,     0,    71,     0,     0,     0,
       0,     0,     0,     0,     0,   735,     0,   737,    75,     0,
       0,     0,    76,    77,     0,     0,     0,   784,    78,     0,
       0,    79,    80,     0,    81,    82,    83,   194,   268,     0,
       0,   194,     3,     8,   748,   794,     0,     0,    10,    11,
       0,    12,    13,    14,    15,    16,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    20,     0,     0,     0,
       0,     0,     0,     0,    22,     0,     0,     0,    23,     0,
       0,     0,     0,     0,    26,     0,     0,    28,     0,     0,
       0,    29,     0,     0,    30,     0,     0,     0,     0,     0,
       0,   662,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    35,    36,    37,    38,    39,    40,
       0,     0,     0,     0,     0,    41,     0,    43,     0,     0,
       0,    45,     0,     0,    46,    47,     0,     0,     0,    48,
       0,     0,    49,     0,    50,    51,     0,   821,     0,     0,
       0,   823,     0,     0,    56,    57,     0,     0,    58,     0,
       0,     0,    60,    61,     0,     0,     0,     0,     0,     0,
       0,     0,    64,     0,    65,    66,    67,    68,     0,    69,
       0,    71,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    75,     0,     0,     0,    76,    77,     0,
       0,     0,     0,    78,     0,     0,    79,    80,     0,    81,
      82,    83,     0,   268,   -12,   -12,     0,     0,     0,   -12,
     -12,   -12,     0,   -12,   -12,   -12,   -12,   -12,   -12,   -12,
     -12,     0,     0,     0,     0,     0,     0,     0,   -12,     0,
       0,   -12,     0,     0,     0,     0,   -12,     0,     0,     0,
     -12,   -12,   -12,     0,     0,   -12,   -12,   -12,     0,   -12,
       0,     0,     0,   -12,     0,     0,   -12,     0,     0,     0,
       0,     0,     0,   -12,     0,   -12,     0,   -12,     0,   -12,
     -12,   -12,     0,   -12,     0,     0,   -12,   -12,   -12,   -12,
     -12,   -12,     0,     0,     0,     0,     0,   -12,   -12,   -12,
       0,   -12,     0,   -12,     0,     0,   -12,   -12,     0,     0,
       0,   -12,     0,     0,   -12,     0,   -12,   -12,     0,   -12,
     -12,   -12,     0,     0,     0,   -12,   -12,   -12,     0,     0,
     -12,     0,     0,   -12,   -12,   -12,     0,     0,     0,   -12,
     -12,     0,     0,   -12,   -12,     0,   -12,   -12,   -12,   -12,
       0,   -12,   -12,   -12,     0,     0,   -12,     0,     0,     0,
     -12,     0,   -12,     0,     0,   -12,     0,     0,     0,   -12,
     -12,     0,     0,     0,     0,   -12,     0,     0,   -12,   -12,
       0,   -12,   -12,   -12,   -13,   -13,     0,     0,     0,   -13,
     -13,   -13,     0,   -13,   -13,   -13,   -13,   -13,   -13,   -13,
     -13,     0,     0,     0,     0,     0,     0,     0,   -13,     0,
       0,   -13,     0,     0,     0,     0,   -13,     0,     0,     0,
     -13,   -13,   -13,     0,     0,   -13,   -13,   -13,     0,   -13,
       0,     0,     0,   -13,     0,     0,   -13,     0,     0,     0,
       0,     0,     0,   -13,     0,   -13,     0,   -13,     0,   -13,
     -13,   -13,     0,   -13,     0,     0,   -13,   -13,   -13,   -13,
     -13,   -13,     0,     0,     0,     0,     0,   -13,   -13,   -13,
       0,   -13,     0,   -13,     0,     0,   -13,   -13,     0,     0,
       0,   -13,     0,     0,   -13,     0,   -13,   -13,     0,   -13,
     -13,   -13,     0,     0,     0,   -13,   -13,   -13,     0,     0,
     -13,     0,     0,   -13,   -13,   -13,     0,     0,     0,   -13,
     -13,     0,     0,   -13,   -13,     0,   -13,   -13,   -13,   -13,
       0,   -13,   -13,   -13,     0,     0,   -13,     0,     0,     0,
     -13,     0,   -13,     0,     0,   -13,     0,     0,     0,   -13,
     -13,     0,     0,     0,     0,   -13,     0,     0,   -13,   -13,
       0,   -13,   -13,   -13,     3,     8,     0,     0,     0,     0,
      10,    11,     0,    12,    13,    14,    15,    16,     0,     0,
       0,   154,     0,     0,   155,     0,   215,     0,    20,   157,
     158,     0,   159,     0,     0,     0,    22,     0,     0,     0,
      23,   160,     0,     0,     0,     0,    26,     0,     0,    28,
       0,   161,     0,    29,   162,     0,   216,   164,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   165,
       0,     0,     0,     0,     0,   166,    35,    36,    37,    38,
     217,    40,     0,   168,     0,     0,   169,   218,     0,   219,
       0,   172,     0,    45,     0,     0,    46,    47,     0,   173,
       0,   220,     0,     0,    49,     0,    50,   221,     0,     0,
       0,     0,   176,   177,   178,     0,    56,   222,     0,     0,
     223,   181,   182,     0,   224,    61,     0,     0,     0,     0,
       0,     0,   184,     0,    64,   185,    65,    66,    67,    68,
     186,    69,     0,   225,   188,   189,     0,     0,   190,   191,
       0,     0,     0,     0,     0,    75,     0,     0,     0,    76,
     226,     0,     0,     0,     0,    78,     0,     0,    79,    80,
       0,    81,    82,    83,     3,     8,     0,     0,     0,     0,
      10,    11,     0,    12,    13,    14,    15,    16,     0,     0,
       0,   154,     0,     0,   155,     0,   652,     0,    20,   157,
     158,     0,   159,     0,     0,     0,    22,     0,     0,     0,
      23,     0,     0,     0,     0,     0,    26,     0,     0,    28,
       0,   161,     0,    29,   162,     0,   216,   164,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   165,
       0,     0,     0,     0,     0,   166,    35,    36,    37,    38,
     217,    40,     0,   168,     0,     0,   169,   218,     0,   219,
       0,   172,     0,    45,     0,     0,    46,    47,     0,   173,
       0,   220,     0,     0,    49,     0,    50,   221,     0,     0,
       0,     0,   176,   177,   178,     0,    56,   222,     0,     0,
     223,   181,   182,     0,   224,    61,     0,     0,     0,     0,
       0,     0,   184,     0,    64,   185,    65,    66,    67,    68,
     186,    69,     0,   225,   188,   189,     0,     0,   190,   191,
       0,     0,     0,     0,     0,    75,  -336,     0,     0,    76,
     226,     0,     0,     0,     0,    78,     0,     0,    79,    80,
       0,    81,    82,    83,     3,     8,     0,     0,     0,     9,
      10,    11,     0,    12,    13,    14,    15,    16,    17,    18,
      19,     0,     0,     0,     0,     0,     0,     0,    20,     0,
       0,    21,     0,     0,     0,     0,    22,     0,     0,     0,
      23,     0,    24,     0,     0,    25,    26,    27,     0,    28,
       0,     0,     0,    29,     0,     0,    30,     0,     0,     0,
       0,     0,     0,    31,     0,     0,     0,     0,     0,     0,
      32,    33,     0,    34,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,    41,    42,    43,
       0,    44,     0,    45,     0,     0,    46,    47,     0,     0,
       0,    48,     0,     0,    49,     0,    50,    51,     0,    52,
      53,    54,     0,     0,     0,    55,    56,    57,     0,     0,
      58,     0,     0,    59,    60,    61,     0,     0,     0,    62,
      63,     0,     0,     0,    64,     0,    65,    66,    67,    68,
       0,    69,    70,    71,     0,     0,    72,     0,     0,     0,
      73,     0,    74,     0,     0,    75,     0,     0,     0,    76,
      77,     0,     0,     0,     0,    78,     0,     0,    79,    80,
       0,    81,    82,    83,     3,     8,     0,     0,     0,     0,
      10,    11,     0,    12,    13,    14,    15,    16,     0,     0,
       0,   154,     0,     0,   155,     0,     0,     0,    20,   157,
     158,     0,   159,     0,     0,     0,    22,     0,     0,     0,
      23,     0,     0,     0,     0,     0,    26,     0,     0,    28,
       0,   161,     0,    29,   162,     0,   216,   164,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   166,    35,    36,    37,    38,
     217,    40,     0,   168,     0,     0,   169,   218,     0,   219,
       0,     0,     0,    45,     0,     0,    46,    47,     0,   173,
       0,   220,     0,     0,    49,     0,    50,   221,     0,     0,
       0,     0,   176,   177,   178,     0,    56,   222,     0,     0,
     223,   181,   182,     0,   224,    61,     0,     0,     0,     0,
       0,     0,   184,     0,    64,   185,    65,    66,    67,    68,
     186,    69,     0,   225,   188,   189,     0,     0,   190,   191,
       0,     0,     0,     0,     0,    75,     0,     0,     0,    76,
     226,     0,     0,     0,     0,    78,     0,     0,    79,    80,
       0,    81,    82,    83,     3,     8,     0,     0,     0,     0,
      10,    11,     0,    12,    13,    14,    15,    16,    17,    18,
      19,     0,     0,     0,     0,     0,     0,     0,    20,     0,
       0,    21,     0,     0,     0,     0,    22,     0,     0,     0,
      23,     0,    24,     0,     0,     0,    26,    27,     0,    28,
       0,     0,     0,    29,     0,     0,    30,     0,     0,     0,
       0,     0,     0,    31,     0,     0,     0,     0,     0,     0,
      32,     0,     0,    34,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,    41,    42,    43,
       0,     0,     0,    45,     0,     0,    46,    47,     0,     0,
       0,    48,     0,     0,    49,     0,    50,    51,     0,    52,
      53,    54,     0,     0,     0,    55,    56,    57,     0,     0,
      58,     0,     0,    59,    60,    61,     0,     0,     0,    62,
      63,     0,     0,     0,    64,     0,    65,    66,    67,    68,
       0,    69,    70,    71,     0,     0,    72,     0,     0,     0,
      73,   246,     0,     0,     0,    75,     0,     0,     0,    76,
      77,     0,     0,     0,     0,    78,     0,     0,    79,    80,
       0,    81,    82,    83,     3,     8,     0,     0,     0,     0,
      10,    11,     0,    12,    13,    14,    15,    16,    17,    18,
      19,     0,     0,     0,     0,     0,     0,     0,    20,     0,
       0,    21,     0,     0,     0,     0,    22,     0,     0,     0,
      23,     0,    24,     0,     0,     0,    26,    27,     0,    28,
       0,     0,     0,    29,     0,     0,    30,     0,     0,     0,
       0,     0,     0,    31,     0,     0,     0,     0,     0,     0,
      32,     0,     0,    34,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,    41,    42,    43,
       0,     0,     0,    45,     0,     0,    46,    47,     0,     0,
       0,    48,     0,     0,    49,     0,    50,    51,     0,    52,
      53,    54,     0,     0,     0,    55,    56,    57,     0,     0,
      58,     0,     0,    59,    60,    61,     0,     0,     0,    62,
      63,     0,     0,     0,    64,     0,    65,    66,    67,    68,
       0,    69,    70,    71,     0,     0,    72,     0,     0,     0,
      73,     0,   -78,     0,     0,    75,     0,     0,     0,    76,
      77,     0,     0,     0,     0,    78,     0,     0,    79,    80,
       0,    81,    82,    83,     3,     8,     0,     0,     0,     0,
      10,    11,     0,    12,    13,    14,    15,    16,    17,    18,
      19,     0,     0,     0,     0,     0,     0,     0,    20,     0,
       0,    21,     0,     0,     0,     0,    22,     0,     0,     0,
      23,     0,    24,     0,     0,     0,    26,    27,     0,    28,
       0,     0,     0,    29,     0,     0,    30,     0,     0,     0,
       0,     0,     0,    31,     0,     0,     0,     0,     0,     0,
      32,     0,     0,    34,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,    41,    42,    43,
       0,     0,     0,    45,     0,     0,    46,    47,     0,     0,
       0,    48,     0,     0,    49,     0,    50,    51,     0,    52,
      53,    54,     0,     0,     0,    55,    56,    57,     0,     0,
      58,     0,     0,    59,    60,    61,     0,     0,     0,    62,
      63,     0,     0,     0,    64,     0,    65,    66,    67,    68,
       0,    69,    70,    71,     0,     0,    72,     0,     0,     0,
      73,     0,   -77,     0,     0,    75,     0,     0,     0,    76,
      77,     0,     0,     0,     0,    78,     0,     0,    79,    80,
       0,    81,    82,    83,     3,     8,     0,     0,     0,     0,
      10,    11,     0,    12,    13,    14,    15,    16,    17,    18,
      19,     0,     0,     0,     0,     0,     0,     0,    20,     0,
       0,    21,     0,     0,     0,     0,    22,     0,     0,     0,
      23,     0,    24,     0,     0,     0,    26,    27,     0,    28,
       0,     0,     0,    29,     0,     0,    30,     0,     0,     0,
       0,     0,     0,    31,     0,     0,     0,     0,     0,     0,
      32,     0,     0,    34,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,    41,    42,    43,
       0,     0,     0,    45,     0,     0,    46,    47,     0,     0,
       0,    48,     0,     0,    49,     0,    50,    51,     0,    52,
      53,    54,     0,     0,     0,    55,    56,    57,     0,     0,
      58,     0,     0,    59,    60,    61,     0,     0,     0,    62,
      63,     0,     0,     0,    64,     0,    65,    66,    67,    68,
       0,    69,    70,    71,     0,     0,    72,     0,     0,     0,
      73,   246,     0,     0,     0,   582,     0,     0,     0,    76,
      77,     0,     0,     0,     0,    78,     0,     0,    79,    80,
       0,    81,    82,    83,     3,     8,     0,     0,     0,     0,
      10,    11,     0,    12,    13,    14,    15,    16,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    20,     0,
       0,     0,     0,     0,     0,     0,    22,     0,     0,     0,
      23,     0,     0,     0,     0,     0,    26,     0,     0,    28,
       0,     0,     0,    29,     0,     0,    30,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,    41,     0,    43,
       0,     0,     0,    45,     0,     0,    46,    47,     0,     0,
       0,    48,     0,     0,    49,     0,    50,    51,     0,     0,
       0,     0,     0,     0,     0,     0,    56,    57,     0,     0,
      58,     0,     0,     0,    60,    61,     0,     0,     0,     0,
       0,     0,     0,     0,    64,     0,    65,    66,    67,    68,
       0,    69,     0,    71,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   236,    75,     0,     0,     0,    76,
      77,     0,     0,     0,     0,    78,     0,     0,    79,    80,
       0,    81,    82,    83,     3,     8,     0,     0,     0,     0,
      10,    11,     0,    12,    13,    14,    15,    16,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    20,     0,
       0,     0,     0,     0,     0,     0,    22,     0,     0,     0,
      23,     0,     0,     0,     0,     0,    26,     0,     0,    28,
       0,     0,     0,    29,     0,     0,    30,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,    41,     0,    43,
       0,     0,     0,    45,     0,     0,    46,    47,     0,     0,
       0,    48,     0,     0,    49,     0,    50,    51,     0,     0,
       0,     0,     0,     0,     0,     0,    56,    57,     0,     0,
      58,     0,     0,     0,    60,    61,     0,     0,     0,     0,
       0,     0,     0,     0,    64,     0,    65,    66,    67,    68,
       0,    69,     0,    71,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   244,    75,     0,     0,     0,    76,
      77,     0,     0,     0,     0,    78,     0,     0,    79,    80,
       0,    81,    82,    83,     3,     8,     0,     0,     0,     0,
      10,    11,     0,    12,    13,    14,    15,    16,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    20,     0,
       0,     0,     0,     0,     0,     0,    22,     0,     0,     0,
      23,     0,     0,     0,     0,     0,    26,     0,     0,    28,
       0,     0,     0,    29,     0,     0,    30,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,    41,   339,    43,
       0,     0,     0,    45,     0,     0,    46,    47,     0,     0,
       0,    48,     0,     0,    49,     0,    50,    51,     0,     0,
       0,     0,     0,     0,     0,     0,    56,    57,     0,     0,
      58,     0,     0,     0,    60,    61,     0,     0,     0,     0,
       0,     0,     0,     0,    64,     0,    65,    66,    67,    68,
       0,    69,     0,    71,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    75,     0,     0,     0,    76,
      77,     0,     0,     0,     0,    78,     0,     0,    79,    80,
       0,    81,    82,    83,     3,     8,     0,     0,     0,     0,
      10,    11,     0,    12,    13,    14,    15,    16,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    20,     0,
       0,     0,     0,     0,     0,     0,    22,     0,     0,     0,
      23,     0,     0,     0,     0,     0,    26,     0,     0,    28,
       0,     0,     0,    29,     0,     0,    30,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,    41,     0,    43,
       0,     0,     0,    45,     0,     0,    46,    47,     0,     0,
       0,    48,     0,     0,    49,     0,    50,    51,     0,     0,
       0,     0,     0,     0,     0,     0,    56,    57,     0,     0,
      58,     0,     0,     0,    60,    61,     0,     0,     0,     0,
       0,     0,     0,     0,    64,     0,    65,    66,    67,    68,
       0,    69,     0,    71,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    75,     0,     0,     0,    76,
      77,     0,     0,     0,     0,    78,     0,     0,    79,    80,
       0,    81,    82,    83,     3,     8,     0,     0,     0,     0,
      10,    11,     0,    12,    13,    14,    15,    16,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    20,     0,
       0,     0,     0,     0,     0,     0,    22,     0,     0,     0,
      23,     0,     0,     0,     0,     0,    26,     0,     0,    28,
       0,     0,     0,    29,     0,     0,    30,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    35,    36,    37,    38,
      39,    40,     0,     0,     0,     0,     0,    41,     0,    43,
       0,     0,     0,     0,     0,     0,    46,    47,     0,     0,
       0,    48,     0,     0,    49,     0,     0,    51,     0,     0,
       0,     0,     0,     0,     0,     0,    56,    57,     0,     0,
      58,     0,     0,     0,    60,    61,     0,     0,     0,     0,
       0,     0,     0,     0,    64,     0,    65,    66,    67,    68,
       0,    69,     0,    71,     0,     0,     0,     0,     0,     0,
       0,     0,     3,     8,     0,    75,     0,     0,    10,    11,
      77,    12,    13,    14,    15,    16,     0,     0,    79,    80,
       0,    81,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    23,     0,
       0,     0,     0,     0,    26,     0,     0,    28,     0,     0,
       0,     0,     0,     0,    30,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    35,    36,    37,    38,    39,    40,
       0,     0,     0,     0,     0,    41,     0,    43,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    48,
       0,     0,     0,     0,     0,    51,     0,     0,     0,     0,
    -171,     0,     0,     0,    56,    57,     0,     0,    58,     0,
       0,     0,    60,    61,     0,  -171,     0,     0,     0,     0,
       0,     0,     0,     0,    65,    66,    67,    68,     0,     0,
       0,    71,     0,     0,     0,     0,     0,     0,     0,     0,
    -171,     0,     0,    75,     0,     0,     0,  -171,    77,     0,
       0,     0,     0,     0,     0,  -171,    79,    80,  -171,    81,
    -171,     0,  -171,     0,  -171,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -171,     0,     0,
       0,     0,     0,     0,  -171,  -171,     0,     0,     0,     0,
    -171,     0,  -171,     0,  -171,     0,     0,  -171,  -171,     0,
    -171,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -171,  -171,     0,     0,     0,     0,     0,     0,     0,     0,
    -171,     0,     0,  -171,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,     3,     8,  -171,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   154,     0,     0,   155,     0,   215,     0,     0,   157,
     158,     0,   159,     0,     0,     0,     0,     0,     0,     0,
       0,   160,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   161,     0,     0,   162,     0,   163,   164,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   165,
       0,     0,     0,     0,     0,   166,     0,     0,     0,     0,
     167,     0,     0,   168,     0,     0,   169,   170,     0,   171,
       0,   172,     0,     0,     0,     0,     0,     0,     0,   173,
       0,   174,     0,     0,     0,     0,     0,   175,     0,     0,
       0,     0,   176,   177,   178,     0,     0,   179,     0,     0,
     180,   181,   182,     0,   183,     0,     0,     0,     0,     0,
       3,     8,   184,     0,     0,   185,     0,     0,     0,     0,
     186,     0,     0,   187,   188,   189,     0,   154,   190,   191,
     155,     0,   215,     0,     0,   157,   158,     0,   159,   519,
     192,     0,     0,     0,     0,     0,     0,   160,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   161,     0,     0,
     162,     0,   163,   164,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   165,     0,     0,     0,     0,
       0,   166,     0,     0,     0,     0,   167,     0,     0,   168,
       0,     0,   169,   170,     0,   171,     0,   172,     0,     0,
       0,     0,     0,     0,     0,   173,     0,   174,     0,     0,
       0,     0,     0,   175,     0,     0,     0,     0,   176,   177,
     178,     0,     0,   179,     0,     0,   180,   181,   182,     0,
     183,     0,     0,     0,     0,     0,     3,     8,   184,     0,
       0,   185,     0,     0,     0,     0,   186,     0,     0,   187,
     188,   189,     0,   154,   190,   191,   155,     0,   215,     0,
       0,   157,   158,     0,   159,   522,   192,     0,     0,     0,
       0,     0,     0,   160,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   161,     0,     0,   162,     0,   163,   164,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   165,     0,     0,     0,     0,     0,   166,     0,     0,
       0,     0,   167,     0,     0,   168,     0,     0,   169,   170,
       0,   171,     0,   172,     0,     0,     0,     0,     0,     0,
       0,   173,     0,   174,     0,     0,     0,     0,     0,   175,
       0,     0,     0,     0,   176,   177,   178,     0,     0,   179,
       0,     0,   180,   181,   182,     0,   183,     0,     0,     0,
       0,     0,     3,     8,   184,     0,     0,   185,     0,     0,
       0,     0,   186,     0,     0,   187,   188,   189,     0,   154,
     190,   191,   155,     0,   215,     0,     0,   157,   158,     0,
     159,   525,   192,     0,     0,     0,     0,     0,     0,   160,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   161,
       0,     0,   162,     0,   163,   164,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   165,     0,     0,
       0,     0,     0,   166,     0,     0,     0,     0,   167,     0,
       0,   168,     0,     0,   169,   170,     0,   171,     0,   172,
       0,     0,     0,     0,     0,     0,     0,   173,     0,   174,
       0,     0,     0,     0,     0,   175,     0,     0,     0,     0,
     176,   177,   178,     0,     0,   179,     0,     0,   180,   181,
     182,     0,   183,     0,     0,     0,     0,     0,     3,     8,
     184,     0,     0,   185,     0,     0,     0,     0,   186,     0,
       0,   187,   188,   189,     0,   154,   190,   191,   155,     0,
     215,     0,     0,   157,   158,     0,   159,   534,   192,     0,
       0,     0,     0,     0,     0,   160,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   161,     0,     0,   162,     0,
     163,   164,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   165,     0,     0,     0,     0,     0,   166,
       0,     0,     0,     0,   167,     0,     0,   168,     0,     0,
     169,   170,     0,   171,     0,   172,     0,     0,     0,     0,
       0,     0,     0,   173,     0,   174,     0,     0,     0,     0,
       0,   175,     0,     0,     0,     0,   176,   177,   178,     0,
       0,   179,     0,     0,   180,   181,   182,     0,   183,     0,
       0,     0,     0,     0,     3,     8,   184,     0,     0,   185,
       0,     0,     0,     0,   186,     0,     0,   187,   188,   189,
       0,   154,   190,   191,   155,     0,   215,     0,     0,   157,
     158,     0,   159,   542,   192,     0,     0,     0,     0,     0,
       0,   160,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   161,     0,     0,   162,     0,   163,   164,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   165,
       0,     0,     0,     0,     0,   166,     0,     0,     0,     0,
     167,     0,     0,   168,     0,     0,   169,   170,     0,   171,
       0,   172,     0,     0,     0,     0,     0,     0,     0,   173,
       0,   174,     0,     0,     0,     0,     0,   175,     0,     0,
       0,     0,   176,   177,   178,     0,     0,   179,     0,     0,
     180,   181,   182,     0,   183,     0,     0,     0,     0,     0,
       3,     8,   184,     0,     0,   185,     0,     0,     0,     0,
     186,     0,     0,   187,   188,   189,     0,   154,   190,   191,
     155,     0,   215,     0,     0,   157,   158,     0,   159,   545,
     192,     0,     0,     0,     0,     0,     0,   160,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   161,     0,     0,
     162,     0,   163,   164,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   165,     0,     0,     0,     0,
       0,   166,     0,     0,     0,     0,   167,     0,     0,   168,
       0,     0,   169,   170,     0,   171,     0,   172,     0,     0,
       0,     0,     0,     0,     0,   173,     0,   174,     0,     0,
       0,     0,     0,   175,     0,     0,     0,     0,   176,   177,
     178,     0,     0,   179,     0,     0,   180,   181,   182,     0,
     183,     0,     0,     0,     0,     0,     3,     8,   184,     0,
       0,   185,     0,     0,     0,     0,   186,     0,     0,   187,
     188,   189,     0,   154,   190,   191,   155,     0,   215,     0,
       0,   157,   158,     0,   159,   547,   192,     0,     0,     0,
       0,     0,     0,   160,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   161,     0,     0,   162,     0,   163,   164,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   165,     0,     0,     0,     0,     0,   166,     0,     0,
       0,     0,   167,     0,     0,   168,     0,     0,   169,   170,
       0,   171,     0,   172,     0,     0,     0,     0,     0,     0,
       0,   173,     0,   174,     0,     0,     0,     0,     0,   175,
       0,     0,     0,     0,   176,   177,   178,     0,     0,   179,
       0,     0,   180,   181,   182,     0,   183,     0,     0,     0,
       0,     0,     0,     0,   184,     3,     8,   185,     0,     0,
       0,     0,   186,     0,     0,   187,   188,   189,     0,     0,
     190,   191,   154,     0,  -194,   155,     0,   215,     0,     0,
     157,   158,   192,   159,     0,     0,     0,     0,     0,     0,
       0,     0,   160,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   161,     0,     0,   162,     0,   163,   164,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     165,     0,     0,     0,     0,     0,   166,     0,     0,     0,
       0,   167,     0,     0,   168,     0,     0,   169,   170,     0,
     171,     0,   172,     0,     0,     0,     0,     0,     0,     0,
     173,     0,   174,     0,     0,     0,     0,     0,   175,     0,
       0,     0,     0,   176,   177,   178,     0,     0,   179,     0,
       0,   180,   181,   182,     0,   183,     0,     0,     0,     0,
       0,     0,     0,   184,     3,     8,   185,     0,     0,     0,
       0,   186,     0,     0,   187,   188,   189,     0,     0,   190,
     191,   154,     0,   733,   155,     0,   156,     0,     0,   157,
     158,   192,   159,     0,     0,     0,     0,     0,     0,     0,
       0,   160,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   161,     0,     0,   162,     0,   163,   164,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   165,
       0,     0,     0,     0,     0,   166,     0,     0,     0,     0,
     167,     0,     0,   168,     0,     0,   169,   170,     0,   171,
       0,   172,     0,     0,     0,     0,     0,     0,     0,   173,
       0,   174,     0,     0,     0,     0,     0,   175,     0,     0,
       0,     0,   176,   177,   178,     0,     0,   179,     0,     0,
     180,   181,   182,     0,   183,     0,     0,     0,     0,     0,
       3,     8,   184,     0,     0,   185,     0,     0,     0,     0,
     186,     0,     0,   187,   188,   189,     0,   154,   190,   191,
     155,     0,   215,     0,     0,   157,   158,     0,   159,     0,
     192,     0,     0,     0,     0,     0,     0,   160,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   161,     0,     0,
     162,     0,   163,   164,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   165,     0,     0,     0,     0,
       0,   166,     0,     0,     0,     0,   167,     0,     0,   168,
       0,     0,   169,   170,     0,   171,     0,   172,     0,     0,
       0,     0,     0,     0,     0,   173,     0,   174,     0,     0,
       0,     0,     0,   175,     0,     0,     0,     0,   176,   177,
     178,     0,     0,   179,     0,     0,   180,   181,   182,     0,
     183,     0,     0,     0,     0,     0,     3,     8,   184,     0,
       0,   185,     0,     0,     0,     0,   186,     0,     0,   187,
     188,   189,     0,   154,   190,   191,   155,     0,   437,     0,
       0,   157,   158,     0,   159,     0,   192,     0,     0,     0,
       0,     0,     0,   160,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   161,     0,     0,   162,     0,   163,   164,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   165,     0,     0,     0,     0,     0,   166,     0,     0,
       0,     0,   167,     0,     0,   168,     0,     0,   169,   170,
       0,   171,     0,   172,     0,     0,     0,     0,     0,     0,
       0,   173,     0,   174,     0,     0,     0,     0,     0,   175,
       0,     0,     0,     0,   176,   177,   178,     0,     0,   179,
       0,     0,   180,   181,   182,     0,   183,     0,     0,     0,
       0,     0,     3,     8,   184,     0,     0,   185,     0,     0,
       0,     0,   186,     0,     0,   187,   188,   189,     0,   154,
     190,   191,   155,     0,   492,     0,     0,   157,   158,     0,
     159,     0,   192,     0,     0,     0,     0,     0,     0,   160,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   161,
       0,     0,   162,     0,   163,   164,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   165,     0,     0,
       0,     0,     0,   166,     0,     0,     0,     0,   167,     0,
       0,   168,     0,     0,   169,   170,     0,   171,     0,   172,
       0,     0,     0,     0,     0,     0,     0,   173,     0,   174,
       0,     0,     0,     0,     0,   175,     0,     0,     0,     0,
     176,   177,   178,     0,     0,   179,     0,     0,   180,   181,
     182,     0,   183,     0,     0,     0,     0,     0,     3,     8,
     184,     0,     0,   185,     0,     0,     0,     0,   186,     0,
       0,   187,   188,   189,     0,   154,   190,   191,   155,     0,
     652,     0,     0,   157,   158,     0,   159,     0,   192,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   161,     0,     0,   162,     0,
     163,   164,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   165,     0,     0,     0,     0,     0,   166,
       0,     0,     0,     0,   167,     0,     0,   168,     0,     0,
     169,   170,     0,   171,     0,   172,     0,     0,     0,     0,
       0,     0,     0,   173,     0,   174,     0,     0,     0,     0,
       0,   175,     0,     0,     0,     0,   176,   177,   178,     0,
       0,   179,     0,     0,   180,   181,   182,     0,   183,     0,
       0,     0,     0,     0,     3,     8,   184,     0,     0,   185,
       0,     0,     0,     0,   186,     0,     0,   187,   188,   189,
       0,   154,   190,   191,   155,     0,     0,     0,     0,   157,
     158,     0,   159,     0,   192,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   161,     0,     0,   162,     0,   163,   164,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   165,
       0,     0,     0,     0,     0,   166,     0,     0,     0,     0,
     167,     0,     0,   168,     0,     0,   169,   170,     0,   171,
       0,   172,     0,     0,     0,     0,     0,     0,     0,   173,
       0,   174,     0,     0,     0,     0,     0,   175,     0,     0,
       0,     0,   176,   177,   178,     0,     0,   179,     0,     0,
     180,   181,   182,     0,   183,     0,     0,     0,     0,     0,
       0,     0,   184,     0,     0,   185,     0,     0,     0,     0,
     186,     0,     0,   187,   188,   189,     0,     0,   190,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     192
  };

  const short
  Parser::yycheck_[] =
  {
       1,    19,    49,    19,   152,   282,   139,   284,     7,   407,
     424,    47,   626,   551,     7,     7,    43,   186,    69,     7,
     629,    63,    94,     3,     4,    65,    45,   160,     7,     7,
     107,    50,    33,    15,    15,     3,    43,     7,     7,     3,
      20,    42,    40,    23,    84,    25,    73,   154,    28,    29,
      65,    31,   107,    65,   161,    91,   333,    76,    54,    78,
      40,     3,   107,    82,    83,   101,    73,   150,   104,    84,
      50,     7,    84,    53,    68,    55,    56,     3,     4,     5,
     689,   158,   696,   697,   170,   694,   241,    55,    68,    25,
     238,   127,   169,   170,    74,    54,    90,   495,   496,    79,
     153,    97,    82,   158,   157,    85,    86,   262,    88,   160,
      90,   153,   260,   158,   169,   170,   152,     0,    98,    61,
     100,   161,   162,   154,   169,   170,   106,   163,   155,   154,
     161,   111,   112,   113,   132,    61,   116,   161,    97,   119,
     120,   121,   143,   123,   682,   154,   161,   162,   281,   161,
     162,   131,   161,   153,   134,   156,    72,   150,    34,   139,
     153,   153,   142,   143,   144,   153,   780,   147,   148,    45,
     154,   319,    17,    18,   153,   153,   158,   158,   158,   159,
     150,   150,    27,   606,   825,    40,   151,   610,   154,   207,
     804,   156,   108,   109,   110,   150,   619,   595,   596,   200,
     154,   154,    47,   153,   845,   846,   161,   161,   161,    64,
      55,    66,   153,    68,   155,    58,    59,    62,   859,   152,
     153,    64,   156,    67,   154,    70,   160,    71,   766,   156,
      75,   318,    77,   771,   321,   162,   154,   775,   298,   299,
     300,   301,   152,   391,   154,    58,    59,   246,    92,   153,
     152,   155,   154,    14,    15,    99,   314,   154,   316,   117,
     118,   105,   167,   168,     3,     4,   154,   268,     3,     4,
     288,   289,   154,   291,   292,   293,   294,   132,   117,   118,
     154,   126,   167,   168,   698,   154,   130,   154,   133,   154,
     309,   310,   311,   312,   167,   168,   141,   142,   154,   144,
     154,   146,   147,   148,   149,   150,   151,   152,   156,   157,
     154,   849,   313,   296,   297,   159,   154,   318,   154,   717,
     321,   154,   720,   721,   154,   154,   154,   154,   154,   173,
     305,   306,   154,   307,   308,   154,   154,   153,   153,    67,
     157,    22,   165,    71,   164,   166,    15,   153,   153,   153,
     164,     3,   154,   154,    22,   356,   154,    56,    26,   152,
      64,   759,   154,   154,    92,   154,   154,   154,   369,   214,
     154,    99,   153,    41,   153,    43,    36,   105,   153,   155,
      62,   226,   155,   160,   385,   230,   231,   156,   156,    57,
     235,    11,   164,   238,     7,   240,   241,   242,   243,   532,
     798,    69,   130,    71,   802,   553,   405,   170,   253,   254,
     255,   256,   257,   153,   155,   260,   549,   262,   162,   153,
      71,    15,   155,   155,   155,   426,   154,     9,   155,   827,
     155,   159,   155,   155,   155,   155,   155,   152,   150,   156,
     158,   157,   287,   154,   157,   173,   155,    36,   156,   582,
     155,   151,   155,    22,   156,    67,   152,   734,   155,    71,
     155,   155,   155,   155,   155,   155,   155,   615,   155,   155,
     155,   155,   620,   174,   319,   320,   155,   155,   152,   152,
      92,   152,   157,   166,   329,   165,     3,    99,   164,   155,
     152,   492,   493,   105,   164,   154,   160,   164,   166,   164,
     168,   154,   170,   171,   153,     6,   154,   153,   176,   154,
     178,   179,   155,   152,   155,   162,   184,   185,   130,   187,
     188,   156,   190,   191,   155,   157,   156,   153,   153,   156,
     154,   154,   377,   155,   150,   150,   154,   156,    71,   557,
      51,   710,   154,   152,   591,   152,   391,   159,   152,   170,
     218,   219,   155,   152,   222,   155,    51,   225,   153,    15,
     151,   173,   160,   156,    51,   155,   153,   155,   154,   154,
     739,   154,    42,    51,   155,   155,   153,    47,   154,   424,
     153,   153,    24,   428,   154,    51,   152,   155,   155,   154,
     150,   155,   155,   154,   151,   157,   155,   155,   151,   155,
     155,   153,   153,   153,     7,   606,   154,    51,   155,   610,
     155,   155,   151,   155,   157,    15,   154,   786,   619,   788,
     160,    49,    15,   155,   793,     7,     7,   821,   138,   655,
     651,   582,   609,   634,   691,   754,   253,   408,   658,   741,
     817,   295,   303,   634,   302,    80,   491,   304,   290,   494,
     698,   591,   653,   792,   557,   429,    -1,   658,    -1,   322,
      -1,   662,   507,   832,   833,   834,   136,    -1,    -1,   139,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   848,
      -1,    -1,    42,   153,    -1,    -1,   855,    47,   857,    -1,
     160,   692,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   552,   553,    -1,
     555,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   572,    -1,    -1,
      -1,    -1,    -1,   751,   735,   751,    -1,   582,   208,    -1,
      -1,    -1,   212,    -1,    -1,    -1,    -1,    -1,    -1,   594,
      -1,    -1,    -1,    -1,   599,    -1,    -1,    -1,    -1,   604,
      -1,    -1,    -1,   608,    -1,    -1,    -1,   612,    -1,   239,
     615,   616,    -1,   618,   792,   620,   136,    -1,    -1,    -1,
      -1,    -1,   783,    -1,   629,    -1,    -1,    -1,   258,    -1,
      -1,   261,    -1,   153,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   826,    -1,
     826,   281,    -1,   283,    -1,   285,   817,    -1,    -1,    -1,
     821,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   689,    -1,    -1,    -1,   208,   694,
      -1,    -1,   212,   698,    -1,   700,    -1,    -1,   703,    -1,
     705,    -1,   707,    -1,    -1,    -1,    -1,    -1,    -1,   339,
      -1,    -1,    -1,   718,   719,    -1,    -1,    -1,    -1,   239,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,    -1,   258,   369,
      -1,   261,   372,   373,   374,   375,    -1,    -1,    -1,    -1,
      -1,   334,    -1,    -1,    -1,    -1,    -1,   387,   388,   389,
     390,    -1,    -1,   283,    -1,    -1,    -1,    -1,    -1,   352,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     785,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     805,    -1,    -1,    -1,   434,    -1,   436,   437,    -1,   439,
      -1,   441,    -1,    -1,   397,    -1,    -1,    -1,    -1,   339,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   416,    -1,    -1,   419,    -1,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,    -1,    -1,    -1,
      -1,    -1,   372,   373,   374,   375,    -1,   487,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   387,   388,   389,
     390,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   532,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   541,    -1,    -1,    -1,    -1,   436,    -1,    -1,   549,
      -1,   441,    -1,    -1,    -1,    -1,    -1,    -1,   558,    -1,
     513,   514,   515,    -1,   517,   518,   519,    -1,   521,   522,
     523,   524,   525,   526,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   534,   582,    -1,   537,    -1,   539,   540,    -1,   542,
     543,   544,   545,   546,   547,   548,    -1,   487,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   611,    -1,   566,    -1,   568,   569,     3,     4,    -1,
      -1,    -1,    -1,     9,    10,    -1,    12,    13,    14,    15,
      16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    27,    -1,   643,    -1,    -1,    -1,    -1,    -1,    35,
      -1,   541,    -1,    39,    -1,   655,    -1,   657,   658,    45,
      -1,    -1,    48,    -1,    -1,    -1,    52,    -1,   558,    55,
      56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   684,    -1,    -1,    -1,    -1,    75,
      76,    77,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,
      86,    -1,    88,    -1,    -1,    -1,    92,    -1,    -1,    95,
      96,    -1,    -1,    -1,   100,    -1,    -1,   103,    -1,   105,
     106,   611,    -1,    -1,    -1,    -1,    -1,    -1,   681,   115,
     116,    -1,    -1,   119,    -1,    -1,    -1,   123,   124,    -1,
      -1,   741,    -1,    -1,    -1,    -1,    -1,   133,    -1,   135,
     136,   137,   138,   643,   140,    -1,   142,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   655,    -1,   657,   154,    -1,
      -1,    -1,   158,   159,    -1,    -1,    -1,   730,   164,    -1,
      -1,   167,   168,    -1,   170,   171,   172,   787,   174,    -1,
      -1,   791,     3,     4,   684,   748,    -1,    -1,     9,    10,
      -1,    12,    13,    14,    15,    16,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    45,    -1,    -1,    48,    -1,    -1,
      -1,    52,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,   741,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    75,    76,    77,    78,    79,    80,
      -1,    -1,    -1,    -1,    -1,    86,    -1,    88,    -1,    -1,
      -1,    92,    -1,    -1,    95,    96,    -1,    -1,    -1,   100,
      -1,    -1,   103,    -1,   105,   106,    -1,   787,    -1,    -1,
      -1,   791,    -1,    -1,   115,   116,    -1,    -1,   119,    -1,
      -1,    -1,   123,   124,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   133,    -1,   135,   136,   137,   138,    -1,   140,
      -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   154,    -1,    -1,    -1,   158,   159,    -1,
      -1,    -1,    -1,   164,    -1,    -1,   167,   168,    -1,   170,
     171,   172,    -1,   174,     3,     4,    -1,    -1,    -1,     8,
       9,    10,    -1,    12,    13,    14,    15,    16,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,
      -1,    30,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      39,    40,    41,    -1,    -1,    44,    45,    46,    -1,    48,
      -1,    -1,    -1,    52,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,    86,    87,    88,
      -1,    90,    -1,    92,    -1,    -1,    95,    96,    -1,    -1,
      -1,   100,    -1,    -1,   103,    -1,   105,   106,    -1,   108,
     109,   110,    -1,    -1,    -1,   114,   115,   116,    -1,    -1,
     119,    -1,    -1,   122,   123,   124,    -1,    -1,    -1,   128,
     129,    -1,    -1,   132,   133,    -1,   135,   136,   137,   138,
      -1,   140,   141,   142,    -1,    -1,   145,    -1,    -1,    -1,
     149,    -1,   151,    -1,    -1,   154,    -1,    -1,    -1,   158,
     159,    -1,    -1,    -1,    -1,   164,    -1,    -1,   167,   168,
      -1,   170,   171,   172,     3,     4,    -1,    -1,    -1,     8,
       9,    10,    -1,    12,    13,    14,    15,    16,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,
      -1,    30,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      39,    40,    41,    -1,    -1,    44,    45,    46,    -1,    48,
      -1,    -1,    -1,    52,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    -1,    64,    -1,    66,    -1,    68,
      69,    70,    -1,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,    86,    87,    88,
      -1,    90,    -1,    92,    -1,    -1,    95,    96,    -1,    -1,
      -1,   100,    -1,    -1,   103,    -1,   105,   106,    -1,   108,
     109,   110,    -1,    -1,    -1,   114,   115,   116,    -1,    -1,
     119,    -1,    -1,   122,   123,   124,    -1,    -1,    -1,   128,
     129,    -1,    -1,   132,   133,    -1,   135,   136,   137,   138,
      -1,   140,   141,   142,    -1,    -1,   145,    -1,    -1,    -1,
     149,    -1,   151,    -1,    -1,   154,    -1,    -1,    -1,   158,
     159,    -1,    -1,    -1,    -1,   164,    -1,    -1,   167,   168,
      -1,   170,   171,   172,     3,     4,    -1,    -1,    -1,    -1,
       9,    10,    -1,    12,    13,    14,    15,    16,    -1,    -1,
      -1,    20,    -1,    -1,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      39,    40,    -1,    -1,    -1,    -1,    45,    -1,    -1,    48,
      -1,    50,    -1,    52,    53,    -1,    55,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    -1,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    -1,    -1,    85,    86,    -1,    88,
      -1,    90,    -1,    92,    -1,    -1,    95,    96,    -1,    98,
      -1,   100,    -1,    -1,   103,    -1,   105,   106,    -1,    -1,
      -1,    -1,   111,   112,   113,    -1,   115,   116,    -1,    -1,
     119,   120,   121,    -1,   123,   124,    -1,    -1,    -1,    -1,
      -1,    -1,   131,    -1,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,    -1,   147,   148,
      -1,    -1,    -1,    -1,    -1,   154,    -1,    -1,    -1,   158,
     159,    -1,    -1,    -1,    -1,   164,    -1,    -1,   167,   168,
      -1,   170,   171,   172,     3,     4,    -1,    -1,    -1,    -1,
       9,    10,    -1,    12,    13,    14,    15,    16,    -1,    -1,
      -1,    20,    -1,    -1,    23,    -1,    25,    -1,    27,    28,
      29,    -1,    31,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    48,
      -1,    50,    -1,    52,    53,    -1,    55,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    -1,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    -1,    -1,    85,    86,    -1,    88,
      -1,    90,    -1,    92,    -1,    -1,    95,    96,    -1,    98,
      -1,   100,    -1,    -1,   103,    -1,   105,   106,    -1,    -1,
      -1,    -1,   111,   112,   113,    -1,   115,   116,    -1,    -1,
     119,   120,   121,    -1,   123,   124,    -1,    -1,    -1,    -1,
      -1,    -1,   131,    -1,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,    -1,   147,   148,
      -1,    -1,    -1,    -1,    -1,   154,   155,    -1,    -1,   158,
     159,    -1,    -1,    -1,    -1,   164,    -1,    -1,   167,   168,
      -1,   170,   171,   172,     3,     4,    -1,    -1,    -1,     8,
       9,    10,    -1,    12,    13,    14,    15,    16,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,
      -1,    30,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      39,    -1,    41,    -1,    -1,    44,    45,    46,    -1,    48,
      -1,    -1,    -1,    52,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,    -1,
      69,    70,    -1,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,    86,    87,    88,
      -1,    90,    -1,    92,    -1,    -1,    95,    96,    -1,    -1,
      -1,   100,    -1,    -1,   103,    -1,   105,   106,    -1,   108,
     109,   110,    -1,    -1,    -1,   114,   115,   116,    -1,    -1,
     119,    -1,    -1,   122,   123,   124,    -1,    -1,    -1,   128,
     129,    -1,    -1,    -1,   133,    -1,   135,   136,   137,   138,
      -1,   140,   141,   142,    -1,    -1,   145,    -1,    -1,    -1,
     149,    -1,   151,    -1,    -1,   154,    -1,    -1,    -1,   158,
     159,    -1,    -1,    -1,    -1,   164,    -1,    -1,   167,   168,
      -1,   170,   171,   172,     3,     4,    -1,    -1,    -1,    -1,
       9,    10,    -1,    12,    13,    14,    15,    16,    -1,    -1,
      -1,    20,    -1,    -1,    23,    -1,    -1,    -1,    27,    28,
      29,    -1,    31,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    48,
      -1,    50,    -1,    52,    53,    -1,    55,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    74,    75,    76,    77,    78,
      79,    80,    -1,    82,    -1,    -1,    85,    86,    -1,    88,
      -1,    -1,    -1,    92,    -1,    -1,    95,    96,    -1,    98,
      -1,   100,    -1,    -1,   103,    -1,   105,   106,    -1,    -1,
      -1,    -1,   111,   112,   113,    -1,   115,   116,    -1,    -1,
     119,   120,   121,    -1,   123,   124,    -1,    -1,    -1,    -1,
      -1,    -1,   131,    -1,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,    -1,   147,   148,
      -1,    -1,    -1,    -1,    -1,   154,    -1,    -1,    -1,   158,
     159,    -1,    -1,    -1,    -1,   164,    -1,    -1,   167,   168,
      -1,   170,   171,   172,     3,     4,    -1,    -1,    -1,    -1,
       9,    10,    -1,    12,    13,    14,    15,    16,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,
      -1,    30,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      39,    -1,    41,    -1,    -1,    -1,    45,    46,    -1,    48,
      -1,    -1,    -1,    52,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,    -1,
      69,    -1,    -1,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,    86,    87,    88,
      -1,    -1,    -1,    92,    -1,    -1,    95,    96,    -1,    -1,
      -1,   100,    -1,    -1,   103,    -1,   105,   106,    -1,   108,
     109,   110,    -1,    -1,    -1,   114,   115,   116,    -1,    -1,
     119,    -1,    -1,   122,   123,   124,    -1,    -1,    -1,   128,
     129,    -1,    -1,    -1,   133,    -1,   135,   136,   137,   138,
      -1,   140,   141,   142,    -1,    -1,   145,    -1,    -1,    -1,
     149,   150,    -1,    -1,    -1,   154,    -1,    -1,    -1,   158,
     159,    -1,    -1,    -1,    -1,   164,    -1,    -1,   167,   168,
      -1,   170,   171,   172,     3,     4,    -1,    -1,    -1,    -1,
       9,    10,    -1,    12,    13,    14,    15,    16,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,
      -1,    30,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      39,    -1,    41,    -1,    -1,    -1,    45,    46,    -1,    48,
      -1,    -1,    -1,    52,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,    -1,
      69,    -1,    -1,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,    86,    87,    88,
      -1,    -1,    -1,    92,    -1,    -1,    95,    96,    -1,    -1,
      -1,   100,    -1,    -1,   103,    -1,   105,   106,    -1,   108,
     109,   110,    -1,    -1,    -1,   114,   115,   116,    -1,    -1,
     119,    -1,    -1,   122,   123,   124,    -1,    -1,    -1,   128,
     129,    -1,    -1,    -1,   133,    -1,   135,   136,   137,   138,
      -1,   140,   141,   142,    -1,    -1,   145,    -1,    -1,    -1,
     149,    -1,   151,    -1,    -1,   154,    -1,    -1,    -1,   158,
     159,    -1,    -1,    -1,    -1,   164,    -1,    -1,   167,   168,
      -1,   170,   171,   172,     3,     4,    -1,    -1,    -1,    -1,
       9,    10,    -1,    12,    13,    14,    15,    16,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,
      -1,    30,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      39,    -1,    41,    -1,    -1,    -1,    45,    46,    -1,    48,
      -1,    -1,    -1,    52,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,    -1,
      69,    -1,    -1,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,    86,    87,    88,
      -1,    -1,    -1,    92,    -1,    -1,    95,    96,    -1,    -1,
      -1,   100,    -1,    -1,   103,    -1,   105,   106,    -1,   108,
     109,   110,    -1,    -1,    -1,   114,   115,   116,    -1,    -1,
     119,    -1,    -1,   122,   123,   124,    -1,    -1,    -1,   128,
     129,    -1,    -1,    -1,   133,    -1,   135,   136,   137,   138,
      -1,   140,   141,   142,    -1,    -1,   145,    -1,    -1,    -1,
     149,    -1,   151,    -1,    -1,   154,    -1,    -1,    -1,   158,
     159,    -1,    -1,    -1,    -1,   164,    -1,    -1,   167,   168,
      -1,   170,   171,   172,     3,     4,    -1,    -1,    -1,    -1,
       9,    10,    -1,    12,    13,    14,    15,    16,    17,    18,
      19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,
      -1,    30,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      39,    -1,    41,    -1,    -1,    -1,    45,    46,    -1,    48,
      -1,    -1,    -1,    52,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,    -1,
      69,    -1,    -1,    72,    -1,    -1,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,    86,    87,    88,
      -1,    -1,    -1,    92,    -1,    -1,    95,    96,    -1,    -1,
      -1,   100,    -1,    -1,   103,    -1,   105,   106,    -1,   108,
     109,   110,    -1,    -1,    -1,   114,   115,   116,    -1,    -1,
     119,    -1,    -1,   122,   123,   124,    -1,    -1,    -1,   128,
     129,    -1,    -1,    -1,   133,    -1,   135,   136,   137,   138,
      -1,   140,   141,   142,    -1,    -1,   145,    -1,    -1,    -1,
     149,   150,    -1,    -1,    -1,   154,    -1,    -1,    -1,   158,
     159,    -1,    -1,    -1,    -1,   164,    -1,    -1,   167,   168,
      -1,   170,   171,   172,     3,     4,    -1,    -1,    -1,    -1,
       9,    10,    -1,    12,    13,    14,    15,    16,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    48,
      -1,    -1,    -1,    52,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,    86,    -1,    88,
      -1,    -1,    -1,    92,    -1,    -1,    95,    96,    -1,    -1,
      -1,   100,    -1,    -1,   103,    -1,   105,   106,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   115,   116,    -1,    -1,
     119,    -1,    -1,    -1,   123,   124,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   133,    -1,   135,   136,   137,   138,
      -1,   140,    -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   153,   154,    -1,    -1,    -1,   158,
     159,    -1,    -1,    -1,    -1,   164,    -1,    -1,   167,   168,
      -1,   170,   171,   172,     3,     4,    -1,    -1,    -1,    -1,
       9,    10,    -1,    12,    13,    14,    15,    16,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    48,
      -1,    -1,    -1,    52,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,    86,    -1,    88,
      -1,    -1,    -1,    92,    -1,    -1,    95,    96,    -1,    -1,
      -1,   100,    -1,    -1,   103,    -1,   105,   106,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   115,   116,    -1,    -1,
     119,    -1,    -1,    -1,   123,   124,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   133,    -1,   135,   136,   137,   138,
      -1,   140,    -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   153,   154,    -1,    -1,    -1,   158,
     159,    -1,    -1,    -1,    -1,   164,    -1,    -1,   167,   168,
      -1,   170,   171,   172,     3,     4,    -1,    -1,    -1,    -1,
       9,    10,    -1,    12,    13,    14,    15,    16,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    48,
      -1,    -1,    -1,    52,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,    86,    87,    88,
      -1,    -1,    -1,    92,    -1,    -1,    95,    96,    -1,    -1,
      -1,   100,    -1,    -1,   103,    -1,   105,   106,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   115,   116,    -1,    -1,
     119,    -1,    -1,    -1,   123,   124,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   133,    -1,   135,   136,   137,   138,
      -1,   140,    -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   154,    -1,    -1,    -1,   158,
     159,    -1,    -1,    -1,    -1,   164,    -1,    -1,   167,   168,
      -1,   170,   171,   172,     3,     4,    -1,    -1,    -1,    -1,
       9,    10,    -1,    12,    13,    14,    15,    16,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    48,
      -1,    -1,    -1,    52,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,    86,    -1,    88,
      -1,    -1,    -1,    92,    -1,    -1,    95,    96,    -1,    -1,
      -1,   100,    -1,    -1,   103,    -1,   105,   106,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   115,   116,    -1,    -1,
     119,    -1,    -1,    -1,   123,   124,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   133,    -1,   135,   136,   137,   138,
      -1,   140,    -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   154,    -1,    -1,    -1,   158,
     159,    -1,    -1,    -1,    -1,   164,    -1,    -1,   167,   168,
      -1,   170,   171,   172,     3,     4,    -1,    -1,    -1,    -1,
       9,    10,    -1,    12,    13,    14,    15,    16,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    48,
      -1,    -1,    -1,    52,    -1,    -1,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    75,    76,    77,    78,
      79,    80,    -1,    -1,    -1,    -1,    -1,    86,    -1,    88,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    -1,    -1,
      -1,   100,    -1,    -1,   103,    -1,    -1,   106,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   115,   116,    -1,    -1,
     119,    -1,    -1,    -1,   123,   124,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   133,    -1,   135,   136,   137,   138,
      -1,   140,    -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,    -1,   154,    -1,    -1,     9,    10,
     159,    12,    13,    14,    15,    16,    -1,    -1,   167,   168,
      -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    45,    -1,    -1,    48,    -1,    -1,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    75,    76,    77,    78,    79,    80,
      -1,    -1,    -1,    -1,    -1,    86,    -1,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
      -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,    -1,    -1,
       7,    -1,    -1,    -1,   115,   116,    -1,    -1,   119,    -1,
      -1,    -1,   123,   124,    -1,    22,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   135,   136,   137,   138,    -1,    -1,
      -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      47,    -1,    -1,   154,    -1,    -1,    -1,    54,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    62,   167,   168,    65,   170,
      67,    -1,    69,    -1,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    -1,    -1,
      -1,    -1,    -1,    -1,    91,    92,    -1,    -1,    -1,    -1,
      97,    -1,    99,    -1,   101,    -1,    -1,   104,   105,    -1,
     107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     117,   118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     127,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,     3,     4,   173,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    -1,    -1,    23,    -1,    25,    -1,    -1,    28,
      29,    -1,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    50,    -1,    -1,    53,    -1,    55,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,
      79,    -1,    -1,    82,    -1,    -1,    85,    86,    -1,    88,
      -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      -1,   100,    -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,
      -1,    -1,   111,   112,   113,    -1,    -1,   116,    -1,    -1,
     119,   120,   121,    -1,   123,    -1,    -1,    -1,    -1,    -1,
       3,     4,   131,    -1,    -1,   134,    -1,    -1,    -1,    -1,
     139,    -1,    -1,   142,   143,   144,    -1,    20,   147,   148,
      23,    -1,    25,    -1,    -1,    28,    29,    -1,    31,   158,
     159,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,    -1,
      53,    -1,    55,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,
      -1,    74,    -1,    -1,    -1,    -1,    79,    -1,    -1,    82,
      -1,    -1,    85,    86,    -1,    88,    -1,    90,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    98,    -1,   100,    -1,    -1,
      -1,    -1,    -1,   106,    -1,    -1,    -1,    -1,   111,   112,
     113,    -1,    -1,   116,    -1,    -1,   119,   120,   121,    -1,
     123,    -1,    -1,    -1,    -1,    -1,     3,     4,   131,    -1,
      -1,   134,    -1,    -1,    -1,    -1,   139,    -1,    -1,   142,
     143,   144,    -1,    20,   147,   148,    23,    -1,    25,    -1,
      -1,    28,    29,    -1,    31,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    50,    -1,    -1,    53,    -1,    55,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    68,    -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,
      -1,    -1,    79,    -1,    -1,    82,    -1,    -1,    85,    86,
      -1,    88,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    98,    -1,   100,    -1,    -1,    -1,    -1,    -1,   106,
      -1,    -1,    -1,    -1,   111,   112,   113,    -1,    -1,   116,
      -1,    -1,   119,   120,   121,    -1,   123,    -1,    -1,    -1,
      -1,    -1,     3,     4,   131,    -1,    -1,   134,    -1,    -1,
      -1,    -1,   139,    -1,    -1,   142,   143,   144,    -1,    20,
     147,   148,    23,    -1,    25,    -1,    -1,    28,    29,    -1,
      31,   158,   159,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,
      -1,    -1,    53,    -1,    55,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,
      -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,    79,    -1,
      -1,    82,    -1,    -1,    85,    86,    -1,    88,    -1,    90,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,   100,
      -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,    -1,    -1,
     111,   112,   113,    -1,    -1,   116,    -1,    -1,   119,   120,
     121,    -1,   123,    -1,    -1,    -1,    -1,    -1,     3,     4,
     131,    -1,    -1,   134,    -1,    -1,    -1,    -1,   139,    -1,
      -1,   142,   143,   144,    -1,    20,   147,   148,    23,    -1,
      25,    -1,    -1,    28,    29,    -1,    31,   158,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    50,    -1,    -1,    53,    -1,
      55,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    74,
      -1,    -1,    -1,    -1,    79,    -1,    -1,    82,    -1,    -1,
      85,    86,    -1,    88,    -1,    90,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    98,    -1,   100,    -1,    -1,    -1,    -1,
      -1,   106,    -1,    -1,    -1,    -1,   111,   112,   113,    -1,
      -1,   116,    -1,    -1,   119,   120,   121,    -1,   123,    -1,
      -1,    -1,    -1,    -1,     3,     4,   131,    -1,    -1,   134,
      -1,    -1,    -1,    -1,   139,    -1,    -1,   142,   143,   144,
      -1,    20,   147,   148,    23,    -1,    25,    -1,    -1,    28,
      29,    -1,    31,   158,   159,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    50,    -1,    -1,    53,    -1,    55,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,
      79,    -1,    -1,    82,    -1,    -1,    85,    86,    -1,    88,
      -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      -1,   100,    -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,
      -1,    -1,   111,   112,   113,    -1,    -1,   116,    -1,    -1,
     119,   120,   121,    -1,   123,    -1,    -1,    -1,    -1,    -1,
       3,     4,   131,    -1,    -1,   134,    -1,    -1,    -1,    -1,
     139,    -1,    -1,   142,   143,   144,    -1,    20,   147,   148,
      23,    -1,    25,    -1,    -1,    28,    29,    -1,    31,   158,
     159,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,    -1,
      53,    -1,    55,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,
      -1,    74,    -1,    -1,    -1,    -1,    79,    -1,    -1,    82,
      -1,    -1,    85,    86,    -1,    88,    -1,    90,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    98,    -1,   100,    -1,    -1,
      -1,    -1,    -1,   106,    -1,    -1,    -1,    -1,   111,   112,
     113,    -1,    -1,   116,    -1,    -1,   119,   120,   121,    -1,
     123,    -1,    -1,    -1,    -1,    -1,     3,     4,   131,    -1,
      -1,   134,    -1,    -1,    -1,    -1,   139,    -1,    -1,   142,
     143,   144,    -1,    20,   147,   148,    23,    -1,    25,    -1,
      -1,    28,    29,    -1,    31,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    50,    -1,    -1,    53,    -1,    55,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    68,    -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,
      -1,    -1,    79,    -1,    -1,    82,    -1,    -1,    85,    86,
      -1,    88,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    98,    -1,   100,    -1,    -1,    -1,    -1,    -1,   106,
      -1,    -1,    -1,    -1,   111,   112,   113,    -1,    -1,   116,
      -1,    -1,   119,   120,   121,    -1,   123,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   131,     3,     4,   134,    -1,    -1,
      -1,    -1,   139,    -1,    -1,   142,   143,   144,    -1,    -1,
     147,   148,    20,    -1,   151,    23,    -1,    25,    -1,    -1,
      28,    29,   159,    31,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    50,    -1,    -1,    53,    -1,    55,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      68,    -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,    -1,
      -1,    79,    -1,    -1,    82,    -1,    -1,    85,    86,    -1,
      88,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      98,    -1,   100,    -1,    -1,    -1,    -1,    -1,   106,    -1,
      -1,    -1,    -1,   111,   112,   113,    -1,    -1,   116,    -1,
      -1,   119,   120,   121,    -1,   123,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   131,     3,     4,   134,    -1,    -1,    -1,
      -1,   139,    -1,    -1,   142,   143,   144,    -1,    -1,   147,
     148,    20,    -1,   151,    23,    -1,    25,    -1,    -1,    28,
      29,   159,    31,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    50,    -1,    -1,    53,    -1,    55,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,
      79,    -1,    -1,    82,    -1,    -1,    85,    86,    -1,    88,
      -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      -1,   100,    -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,
      -1,    -1,   111,   112,   113,    -1,    -1,   116,    -1,    -1,
     119,   120,   121,    -1,   123,    -1,    -1,    -1,    -1,    -1,
       3,     4,   131,    -1,    -1,   134,    -1,    -1,    -1,    -1,
     139,    -1,    -1,   142,   143,   144,    -1,    20,   147,   148,
      23,    -1,    25,    -1,    -1,    28,    29,    -1,    31,    -1,
     159,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,    -1,
      53,    -1,    55,    56,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,
      -1,    74,    -1,    -1,    -1,    -1,    79,    -1,    -1,    82,
      -1,    -1,    85,    86,    -1,    88,    -1,    90,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    98,    -1,   100,    -1,    -1,
      -1,    -1,    -1,   106,    -1,    -1,    -1,    -1,   111,   112,
     113,    -1,    -1,   116,    -1,    -1,   119,   120,   121,    -1,
     123,    -1,    -1,    -1,    -1,    -1,     3,     4,   131,    -1,
      -1,   134,    -1,    -1,    -1,    -1,   139,    -1,    -1,   142,
     143,   144,    -1,    20,   147,   148,    23,    -1,    25,    -1,
      -1,    28,    29,    -1,    31,    -1,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    50,    -1,    -1,    53,    -1,    55,    56,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    68,    -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,
      -1,    -1,    79,    -1,    -1,    82,    -1,    -1,    85,    86,
      -1,    88,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    98,    -1,   100,    -1,    -1,    -1,    -1,    -1,   106,
      -1,    -1,    -1,    -1,   111,   112,   113,    -1,    -1,   116,
      -1,    -1,   119,   120,   121,    -1,   123,    -1,    -1,    -1,
      -1,    -1,     3,     4,   131,    -1,    -1,   134,    -1,    -1,
      -1,    -1,   139,    -1,    -1,   142,   143,   144,    -1,    20,
     147,   148,    23,    -1,    25,    -1,    -1,    28,    29,    -1,
      31,    -1,   159,    -1,    -1,    -1,    -1,    -1,    -1,    40,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,
      -1,    -1,    53,    -1,    55,    56,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,
      -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,    79,    -1,
      -1,    82,    -1,    -1,    85,    86,    -1,    88,    -1,    90,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,   100,
      -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,    -1,    -1,
     111,   112,   113,    -1,    -1,   116,    -1,    -1,   119,   120,
     121,    -1,   123,    -1,    -1,    -1,    -1,    -1,     3,     4,
     131,    -1,    -1,   134,    -1,    -1,    -1,    -1,   139,    -1,
      -1,   142,   143,   144,    -1,    20,   147,   148,    23,    -1,
      25,    -1,    -1,    28,    29,    -1,    31,    -1,   159,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    50,    -1,    -1,    53,    -1,
      55,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    74,
      -1,    -1,    -1,    -1,    79,    -1,    -1,    82,    -1,    -1,
      85,    86,    -1,    88,    -1,    90,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    98,    -1,   100,    -1,    -1,    -1,    -1,
      -1,   106,    -1,    -1,    -1,    -1,   111,   112,   113,    -1,
      -1,   116,    -1,    -1,   119,   120,   121,    -1,   123,    -1,
      -1,    -1,    -1,    -1,     3,     4,   131,    -1,    -1,   134,
      -1,    -1,    -1,    -1,   139,    -1,    -1,   142,   143,   144,
      -1,    20,   147,   148,    23,    -1,    -1,    -1,    -1,    28,
      29,    -1,    31,    -1,   159,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    50,    -1,    -1,    53,    -1,    55,    56,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    -1,    74,    -1,    -1,    -1,    -1,
      79,    -1,    -1,    82,    -1,    -1,    85,    86,    -1,    88,
      -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      -1,   100,    -1,    -1,    -1,    -1,    -1,   106,    -1,    -1,
      -1,    -1,   111,   112,   113,    -1,    -1,   116,    -1,    -1,
     119,   120,   121,    -1,   123,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   131,    -1,    -1,   134,    -1,    -1,    -1,    -1,
     139,    -1,    -1,   142,   143,   144,    -1,    -1,   147,   148,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     159
  };

  const short
  Parser::yystos_[] =
  {
       0,    94,   176,     3,   177,     0,   150,   182,     4,     8,
       9,    10,    12,    13,    14,    15,    16,    17,    18,    19,
      27,    30,    35,    39,    41,    44,    45,    46,    48,    52,
      55,    62,    69,    70,    72,    75,    76,    77,    78,    79,
      80,    86,    87,    88,    90,    92,    95,    96,   100,   103,
     105,   106,   108,   109,   110,   114,   115,   116,   119,   122,
     123,   124,   128,   129,   133,   135,   136,   137,   138,   140,
     141,   142,   145,   149,   151,   154,   158,   159,   164,   167,
     168,   170,   171,   172,   177,   178,   183,   184,   185,   186,
     188,   190,   191,   192,   193,   213,   221,   222,   249,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   271,   272,   273,   278,
     279,   280,   281,   284,   285,   286,   152,   153,   170,   249,
     249,   250,   254,   154,   153,   161,   227,   153,   193,   227,
     249,   154,   154,   154,   154,   177,   154,   154,   154,   154,
     154,   154,   154,   227,    20,    23,    25,    28,    29,    31,
      40,    50,    53,    55,    56,    68,    74,    79,    82,    85,
      86,    88,    90,    98,   100,   106,   111,   112,   113,   116,
     119,   120,   121,   123,   131,   134,   139,   142,   143,   144,
     147,   148,   159,   177,   178,   200,   201,   223,   224,   225,
     226,   229,   230,   233,   237,   241,   244,   154,   227,    58,
      59,   197,   202,   265,   154,    25,    55,    79,    86,    88,
     100,   106,   116,   119,   123,   142,   159,   178,   226,   249,
     154,   154,   273,   277,   265,   154,   153,   249,   154,   227,
     154,   154,   154,   154,   153,   249,   150,   184,   185,   193,
     209,   210,   213,   154,   154,   154,   154,   154,   227,   249,
     154,   227,   154,   153,   249,   274,   276,   265,   174,   249,
     251,   252,   282,   283,   265,    14,    15,   268,   287,   265,
     265,    40,    64,    66,    68,   132,   153,   157,    47,    91,
     101,   104,   127,   152,   163,    22,    54,    97,    65,    84,
     161,   162,   164,   165,   166,   117,   118,   167,   168,   107,
     158,   169,   170,    67,    71,    92,    99,   105,   130,   154,
     159,   173,   164,   293,   249,    15,   153,   153,   153,   157,
     249,   226,   199,   200,   225,   153,   249,   249,   177,    87,
     187,   249,    63,   153,   249,   249,   249,   249,   249,   249,
     249,   251,   226,   177,   154,   225,   150,   161,   227,   227,
     154,   227,   227,   227,   227,   227,   227,   154,   234,   227,
     227,   293,   227,   227,   227,   227,    56,   152,    64,   177,
     250,   289,   290,   291,   226,   226,   249,   227,   227,   227,
     227,   154,   249,   249,   249,   153,   251,   226,   249,   187,
     249,   249,   249,   153,   211,   212,   213,    36,   219,   220,
     224,   249,   249,   249,   249,   249,   226,   153,   251,   226,
     187,   249,   155,   155,   156,   177,    62,   160,   156,   156,
     160,   164,    11,   178,   225,   196,   202,    25,   178,   226,
     198,   202,   178,   249,   254,   254,   256,   254,   254,   254,
     254,   257,   258,   258,   259,   259,   259,   259,   260,   261,
     262,   263,   263,   264,   264,   265,   265,   265,   265,    55,
     177,   270,   266,   266,   270,   251,   249,   270,   286,     7,
     292,   153,   249,   155,   162,   228,   153,   202,   228,   155,
     155,    71,    25,   226,   153,   155,   155,   179,   180,   155,
     155,   155,   155,   155,   155,   155,   228,   152,    15,   177,
     242,   243,   158,    15,   158,   226,     9,   158,   226,   158,
     226,   226,   158,   226,   226,   158,   226,    43,    73,   203,
     204,   205,   207,   150,   158,   177,   226,   231,   232,    15,
     158,   150,   158,   226,   226,   158,   226,   158,   226,   157,
     249,   154,   152,   154,   189,   157,   155,   156,   156,     4,
       5,    61,   177,   194,   195,   155,   226,   226,   226,   226,
     251,   155,   156,   155,   228,   155,   155,   155,   155,   155,
     151,   213,   154,   209,   220,   155,   155,   155,   155,   155,
     155,   228,   155,   228,   153,   155,   155,   275,   276,   152,
     177,   249,   283,   288,   152,   178,   226,   178,   152,   178,
     226,   152,   157,   155,   160,   154,   152,   153,   154,   226,
     154,   249,   177,   177,   249,   209,   209,   153,     6,   154,
     249,   155,   152,   151,   156,   162,   228,   228,   228,   155,
     228,   228,   228,   156,   228,   228,   228,   228,   228,   228,
     155,   156,    25,   206,   225,   235,   228,   157,   156,   228,
     228,   228,   226,   238,   239,   240,   228,   228,   228,   228,
     228,   228,   228,   225,   153,   203,   249,   251,   153,   249,
     291,   226,   154,   228,   156,   228,   228,   155,   249,   154,
     150,   150,   206,   277,   154,   249,   209,   209,   156,   249,
      71,   170,   249,   152,   195,   152,   249,   152,   189,   195,
     226,   249,   251,   249,   249,   195,   251,   155,   152,   152,
     155,    51,   214,   214,   181,   274,   153,   245,    15,   243,
     226,   205,   177,   151,   201,   226,   236,   226,   232,   177,
     151,   156,   160,   155,   153,   155,   228,   203,   226,   155,
     274,    34,    45,   215,   216,   217,   215,   177,   274,   155,
     214,   214,   275,   249,   153,   249,   154,   249,   153,   249,
     153,   154,   293,   155,   155,   154,   155,   209,   249,   249,
     209,   209,   155,   150,   228,   152,   208,   202,   177,   293,
     240,    24,   154,   155,   228,   155,   218,   250,   157,   151,
     217,   151,   155,   155,   209,    69,   160,   153,   203,   153,
     153,   203,   153,   203,   214,   177,   246,   247,   248,   249,
     293,   226,   293,   226,   289,   293,   156,   157,   209,   209,
     214,   249,   155,   155,   155,   157,   151,   248,   194,   153,
     155,   210,   250,   209,   160,   293,   293,   293,    15,   154,
     210,   210,    49,   293,   203,    15,   153,   155,   293,   293,
     153,   153,   210
  };

  const short
  Parser::yyr1_[] =
  {
       0,   175,   176,   177,   178,   178,   180,   181,   179,   182,
     182,   182,   183,   183,   183,   183,   183,   183,   184,   185,
     185,   186,   186,   186,   186,   187,   187,   188,   188,   188,
     188,   189,   189,   190,   190,   190,   190,   191,   191,   192,
     192,   193,   193,   193,   193,   193,   194,   194,   195,   195,
     195,   196,   197,   198,   199,   200,   200,   201,   201,   202,
     202,   202,   203,   203,   204,   204,   205,   206,   206,   207,
     207,   207,   208,   208,   209,   209,   210,   211,   211,   212,
     212,   213,   213,   213,   213,   213,   213,   213,   213,   213,
     213,   213,   213,   213,   213,   213,   213,   213,   213,   213,
     213,   213,   213,   213,   213,   213,   214,   214,   215,   215,
     216,   216,   217,   217,   218,   218,   219,   219,   220,   220,
     221,   221,   221,   222,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   223,   223,
     223,   223,   223,   223,   223,   223,   223,   223,   224,   225,
     225,   225,   226,   226,   226,   227,   228,   229,   230,   230,
     231,   231,   232,   232,   233,   234,   234,   235,   235,   236,
     236,   236,   237,   238,   238,   239,   239,   240,   241,   241,
     242,   242,   242,   243,   243,   245,   244,   246,   246,   247,
     247,   248,   248,   249,   250,   251,   251,   252,   252,   253,
     253,   254,   254,   254,   254,   254,   254,   254,   255,   255,
     256,   256,   257,   257,   257,   258,   258,   258,   258,   258,
     259,   259,   260,   260,   261,   261,   262,   262,   262,   263,
     263,   263,   264,   264,   264,   264,   264,   265,   265,   265,
     265,   265,   265,   265,   266,   266,   266,   266,   266,   266,
     266,   266,   266,   266,   266,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   268,   268,   268,
     268,   268,   268,   269,   269,   269,   269,   270,   270,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   273,   274,   274,   274,   275,   275,   275,
     276,   277,   278,   278,   278,   278,   278,   279,   279,   280,
     280,   281,   282,   282,   283,   284,   285,   285,   287,   288,
     286,   289,   289,   290,   290,   291,   292,   292,   293,   293
  };

  const signed char
  Parser::yyr2_[] =
  {
       0,     2,     5,     1,     1,     1,     0,     0,     3,     2,
       2,     0,     1,     1,     1,     1,     1,     1,     7,     6,
       7,     5,     5,     6,     6,     5,     5,     6,     6,     7,
       7,     3,     0,     3,     3,     2,     4,     3,     5,     2,
       4,     1,     1,     1,     1,     0,     1,     1,     1,     1,
       1,     8,     8,     8,     8,     1,     0,     1,     1,     1,
       1,     0,     1,     0,     3,     1,     5,     1,     1,     1,
       1,     0,     2,     0,     1,     1,     3,     1,     0,     2,
       1,     2,     1,     2,     3,     3,     2,     2,     2,     2,
       6,     6,     8,     8,     6,     6,     7,     7,     7,     3,
       3,     5,     3,     3,     3,     3,     2,     0,     1,     0,
       2,     1,     4,     3,     3,     1,     2,     1,     6,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     6,
       1,     5,     4,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     7,     4,     4,
       3,     1,     1,     3,     5,     3,     0,     2,     0,     4,
       9,     9,     5,     1,     0,     3,     1,     3,     4,     4,
       3,     2,     1,     1,     3,     0,     8,     1,     0,     2,
       1,     7,     5,     1,     1,     1,     0,     3,     1,     1,
       3,     3,     3,     3,     3,     3,     5,     1,     3,     1,
       3,     1,     3,     3,     1,     3,     3,     3,     3,     1,
       3,     1,     3,     1,     3,     1,     3,     3,     1,     3,
       3,     1,     3,     3,     3,     3,     1,     2,     2,     2,
       3,     2,     2,     1,     4,     3,     6,     4,     3,     3,
       3,     2,     2,     3,     1,     4,     7,     4,     4,     2,
       5,     2,     2,     5,     4,     4,     1,     1,     1,     2,
       7,     9,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     2,     1,     1,     3,     1,
       4,     7,     1,     1,     1,     1,     1,     1,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     6,     3,     1,     3,     0,     1,     3,     0,
       1,     1,     3,     4,     7,     4,     7,     4,     7,     4,
       9,     3,     3,     1,     4,     2,     3,     1,     0,     0,
       5,     1,     0,     3,     1,     3,     1,     3,     2,     0
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const Parser::yytname_[] =
  {
  "\"<end of input>\"", "error", "\"invalid token\"", "\"identifier\"",
  "\"scoped identifier\"", "\"scoped ~finally\"", "\"dotted identifier\"",
  "\"attribute\"", "\"property\"", "\"string value\"", "\"bytes value\"",
  "\"regular expression value\"", "\"address value\"", "\"port value\"",
  "\"real value\"", "\"unsigned integer value\"", "\"bool value\"",
  "\"add\"", "\"assert\"", "\"assert-exception\"", "\"addr\"", "\"after\"",
  "\"&&\"", "\"any\"", "\"->\"", "\"auto\"", "\"at\"", "\"begin\"",
  "\"bitfield\"", "\"bool\"", "\"break\"", "\"bytes\"", "\"caddr\"",
  "\"callable\"", "\"case\"", "\"cast\"", "\"catch\"", "\"channel\"",
  "\"classifier\"", "\"Null\"", "\"const\"", "\"continue\"", "\"context\"",
  "\"copy\"", "\"declare\"", "\"default\"", "\"delete\"", "\"/=\"",
  "\"$$\"", "\"..\"", "\"real\"", "\"else\"", "\"end\"", "\"enum\"",
  "\"==\"", "\"error\"", "\"exception\"", "\"export\"", "\"extern\"",
  "\"extern-no-suspend\"", "\"file\"", "\"~finally\"", "\"for\"",
  "\"from\"", "\"function\"", "\">=\"", "\"global\"", "\"?.\"", "\"hook\"",
  "\"if\"", "\"import\"", "\"in\"", "\"init\"", "\"inout\"", "\"int\"",
  "\"int16\"", "\"int32\"", "\"int64\"", "\"int8\"", "\"interval\"",
  "\"interval_ns\"", "\"iosrc\"", "\"iterator\"", "\"const_iterator\"",
  "\"<=\"", "\"library type\"", "\"list\"", "\"local\"", "\"map\"",
  "\"match_token_state\"", "\"method\"", "\"-=\"", "\"--\"", "\"%\"",
  "\"module\"", "\"move\"", "\"new\"", "\"!=\"", "\"net\"", "\"!in\"",
  "\"optional\"", "\"||\"", "\"overlay\"", "\"pack\"", "\"+=\"", "\"++\"",
  "\"port\"", "\"**\"", "\"preinit\"", "\"private\"", "\"public\"",
  "\"strong_ref\"", "\"regexp\"", "\"result\"", "\"return\"", "\"scope\"",
  "\"set\"", "\"<<\"", "\">>\"", "\"stream\"", "\"string\"", "\"struct\"",
  "\"switch\"", "\"time\"", "\"time_ns\"", "\"timer\"", "\"timer_mgr\"",
  "\"*=\"", "\"throw\"", "\"try\"", "\".?\"", "\"tuple\"", "\"type\"",
  "\"typeinfo\"", "\"uint\"", "\"uint16\"", "\"uint32\"", "\"uint64\"",
  "\"uint8\"", "\"union\"", "\"unpack\"", "\"unset\"", "\"vector\"",
  "\"view\"", "\"void\"", "\"while\"", "\"with\"", "\"value_ref\"",
  "\"weak_ref\"", "\"yield\"", "'{'", "'}'", "'='", "';'", "'('", "')'",
  "','", "':'", "'*'", "'['", "']'", "'<'", "'>'", "'?'", "'|'", "'^'",
  "'&'", "'+'", "'-'", "'%'", "'/'", "'!'", "'~'", "'.'", "'$'", "$accept",
  "module", "local_id", "scoped_id", "dotted_id", "$@1", "$@2",
  "global_scope_items", "global_scope_decl", "type_decl", "constant_decl",
  "local_decl", "local_init_decl", "global_decl", "opt_type_arguments",
  "function_decl", "import_decl", "property_decl", "opt_linkage",
  "function_id", "scoped_function_id", "function_with_body",
  "method_with_body", "hook_with_body", "function_without_body",
  "opt_func_flavor", "func_flavor", "opt_func_cc", "opt_func_params",
  "func_params", "func_param", "func_param_type", "opt_func_param_kind",
  "opt_func_default_expr", "block", "braced_block", "opt_stmts", "stmts",
  "stmt", "opt_else_block", "opt_switch_cases", "switch_cases",
  "switch_case", "case_exprs", "try_catches", "try_catch", "stmt_decl",
  "stmt_expr", "base_type_no_attrs", "base_type", "type", "qtype",
  "type_param_begin", "type_param_end", "function_type", "tuple_type",
  "tuple_type_elems", "tuple_type_elem", "struct_type",
  "opt_struct_params", "struct_fields", "struct_field", "union_type",
  "opt_union_fields", "union_fields", "union_field", "enum_type",
  "enum_labels", "enum_label", "bitfield_type", "$@3",
  "opt_bitfield_bit_ranges", "bitfield_bit_ranges", "bitfield_bit_range",
  "expr", "expr_no_or_error", "opt_exprs", "exprs", "expr_0", "expr_1",
  "expr_2", "expr_3", "expr_4", "expr_5", "expr_6", "expr_7", "expr_8",
  "expr_9", "expr_a", "expr_b", "expr_c", "expr_d", "expr_e", "expr_f",
  "expr_g", "member_expr", "ctor", "ctor_expr", "tuple",
  "opt_tuple_elems1", "opt_tuple_elems2", "tuple_elem", "tuple_expr",
  "list", "set", "map", "struct_", "struct_elems", "struct_elem", "regexp",
  "re_patterns", "re_pattern_constant", "$@4", "$@5", "opt_map_elems",
  "map_elems", "map_elem", "attribute", "opt_attributes", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  Parser::yyrline_[] =
  {
       0,   287,   287,   296,   308,   309,   311,   313,   311,   318,
     320,   322,   326,   327,   328,   329,   330,   331,   333,   336,
     338,   342,   343,   344,   346,   351,   353,   357,   359,   361,
     363,   368,   369,   371,   373,   376,   377,   381,   382,   386,
     387,   389,   390,   391,   392,   393,   397,   398,   401,   402,
     403,   406,   413,   420,   427,   433,   434,   436,   437,   439,
     440,   441,   443,   444,   446,   447,   449,   453,   454,   458,
     459,   460,   463,   464,   469,   470,   473,   475,   476,   478,
     479,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   492,   494,   496,   498,   500,   502,   504,   506,   508,
     510,   511,   513,   516,   524,   532,   542,   543,   546,   547,
     549,   550,   552,   553,   555,   556,   558,   559,   561,   563,
     565,   566,   567,   570,   575,   576,   577,   578,   579,   580,
     581,   582,   583,   584,   585,   586,   587,   588,   590,   591,
     592,   593,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   606,   607,   608,   609,   610,   611,   612,   613,
     615,   616,   618,   620,   621,   622,   623,   624,   627,   630,
     631,   632,   635,   636,   637,   641,   645,   648,   652,   653,
     657,   659,   663,   664,   667,   670,   671,   673,   674,   676,
     677,   681,   687,   690,   691,   693,   694,   696,   698,   699,
     701,   702,   703,   706,   707,   711,   710,   716,   718,   721,
     723,   726,   728,   732,   736,   738,   739,   741,   742,   744,
     745,   748,   749,   750,   751,   752,   753,   754,   756,   757,
     759,   760,   762,   763,   764,   766,   767,   768,   769,   770,
     772,   773,   775,   776,   778,   779,   781,   782,   783,   785,
     786,   787,   789,   790,   791,   792,   793,   795,   796,   797,
     798,   799,   800,   801,   803,   804,   805,   806,   807,   808,
     809,   810,   811,   812,   813,   815,   816,   817,   818,   819,
     820,   821,   822,   823,   824,   825,   826,   828,   829,   830,
     831,   833,   835,   837,   838,   839,   840,   843,   844,   848,
     849,   850,   851,   852,   857,   858,   859,   861,   862,   863,
     868,   869,   871,   872,   873,   874,   875,   876,   879,   880,
     881,   882,   883,   884,   885,   886,   887,   888,   889,   890,
     891,   892,   893,   896,   899,   900,   901,   904,   905,   906,
     909,   912,   914,   915,   916,   918,   919,   922,   923,   926,
     927,   930,   932,   933,   935,   937,   939,   941,   944,   944,
     944,   947,   948,   950,   951,   953,   956,   961,   968,   973
  };

  void
  Parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  Parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  Parser::symbol_kind_type
  Parser::yytranslate_ (int t) YY_NOEXCEPT
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const unsigned char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   171,     2,     2,   174,   169,   166,     2,
     154,   155,   158,   167,   156,   168,   173,   170,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   157,   153,
     161,   152,   162,   163,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   159,     2,   160,   165,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   150,   164,   151,   172,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149
    };
    // Last valid token kind.
    const int code_max = 404;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return static_cast <symbol_kind_type> (translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

#line 29 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"
} } } // hilti::detail::parser
#line 6867 "/build/zeek/src/zeek/build/auxil/spicy/hilti/src/autogen/__parser.cc"

#line 975 "/build/zeek/src/zeek/auxil/spicy/hilti/toolchain/src/compiler/parser/parser.yy"


void hilti::detail::parser::Parser::error(const Parser::location_type& l, const std::string& m) {
    driver->error(m, toMeta(l));
}
