// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 11 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"

namespace spicy { namespace detail { class Parser; } }

#include <hilti/compiler/context.h>
#include <spicy/compiler/detail/parser/driver.h>
#include <spicy/ast/builder/builder.h>

#line 41 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"


#include <spicy/compiler/detail/parser/scanner.h>

#undef yylex
#define yylex driver->scanner()->lex

static hilti::Meta toMeta(spicy::detail::parser::location l) {
    return hilti::Meta(hilti::Location(*l.begin.filename, l.begin.line, l.end.line, l.begin.column,
                                       (l.end.column > 0 ? l.end.column - 1 : 0)));
}

static hilti::QualifiedType* iteratorForType(spicy::Builder* builder, hilti::QualifiedType* t, hilti::Meta m) {
    if ( auto iter = t->type()->iteratorType() )
        return iter;
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not iterable", *t), m.location());
        return builder->qualifiedType(builder->typeError(), hilti::Constness::Const);
        }
}

static hilti::QualifiedType* viewForType(spicy::Builder* builder, hilti::QualifiedType* t, hilti::Meta m) {
    if ( auto v = t->type()->viewType() )
        return v;
    else {
        hilti::logger().error(hilti::util::fmt("type '%s' is not viewable", *t), m.location());
        return builder->qualifiedType(builder->typeError(), hilti::Constness::Const);
        }
}

/**
 * Checks if an unsigned integer value can be represented as an int64_t.
 *
 * @param x value to check
 * @param positive if false, check if ``-x`` can be represented instead of ``x`` itself.
 * @param m location information to associate with error message.
 * @return *x* on success, or zero on failure as a temporary stand-in; in the
 * latter cases an error is reported, too
 */
static uint64_t check_int64_range(uint64_t x, bool positive, const hilti::Meta& m) {
    uint64_t max = (positive ? std::numeric_limits<int64_t>::max() : std::fabs(std::numeric_limits<int64_t>::min()));
    if ( x <= max )
        return x;

    hilti::logger().error("signed integer value out of range", m.location());
    return 0; // Return dummy value
}

#define __loc__ toMeta(yylhs.location)

#define YYLLOC_DEFAULT(Current, Rhs, N)                                                                                \
do {                                                                                                                   \
    bool done = false;                                                                                                 \
    for ( int i = 1; i <= N; i++ ) {                                                                                   \
        if ( YYRHSLOC(Rhs, i).begin.line != YYRHSLOC(Rhs, i).end.line ||                                               \
             YYRHSLOC(Rhs, i).begin.column != YYRHSLOC(Rhs, i).end.column ) {                                          \
            (Current).begin = YYRHSLOC(Rhs, i).begin;                                                                  \
            (Current).end = YYRHSLOC(Rhs, N).end;                                                                      \
            done = true;                                                                                               \
            break;                                                                                                     \
        }                                                                                                              \
    }                                                                                                                  \
    if ( ! done )                                                                                                      \
        (Current).begin = (Current).end = YYRHSLOC(Rhs, 0).end;                                                        \
} while ( false )

static int _field_width = 0;

// We keep a stack of doc strings here that's maintained during parsing. There
// would actually be a much nicer way of doing this through Bison's mid-action
// rules, but unfortunately those have a bug with Bison < 3.1 that prevents
// passing results back from a mid-action rule; see
// https://stackoverflow.com/questions/44811550/bison-c-mid-rule-value-lost-with-variants.
//
// Bison 3.1 fixes this and introduces a new, nicer typing syntax for
// mid-action rules as well; see
// https://www.gnu.org/software/bison/manual/html_node/Typed-Mid_002dRule-Actions.html#Typed-Mid_002dRule-Actions
// Unfortunately, we cannot rely on having 3.1 yet, because some of our
// supported platforms do not provide it. Once we can, we should get rid of
// this stack and move to that new syntax instead.
static std::vector<hilti::DocString> _docs;


#line 133 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"


#include "__parser.h"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 29 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
namespace spicy { namespace detail { namespace parser {
#line 231 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"

  /// Build a parser object.
  Parser::Parser (Driver* driver_yyarg, Builder* builder_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      builder (builder_yyarg)
  {}

  Parser::~Parser ()
  {}

  Parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------.
  | symbol.  |
  `---------*/

  // basic_symbol.
  template <typename Base>
  Parser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value ()
    , location (that.location)
  {
    switch (this->kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
      case symbol_kind::S_opt_skip: // opt_skip
      case symbol_kind::S_opt_skip_: // opt_skip_
        value.copy< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.copy< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        value.copy< hilti::Attribute* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        value.copy< hilti::AttributeSet* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_field_ctor: // unit_field_ctor
      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.copy< hilti::Ctor* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        value.copy< hilti::Declaration* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        value.copy< hilti::Declarations > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_opt_bitfield_range_value: // opt_bitfield_range_value
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_no_or_error: // expr_no_or_error
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.copy< hilti::Expression* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_case_exprs: // case_exprs
      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.copy< hilti::Expressions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        value.copy< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
      case symbol_kind::S_qtype: // qtype
      case symbol_kind::S_unit_field_base_type: // unit_field_base_type
        value.copy< hilti::QualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.copy< hilti::Statement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.copy< hilti::Statements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_no_ref: // type_no_ref
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        value.copy< hilti::UnqualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.copy< hilti::ctor::map::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.copy< hilti::ctor::map::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.copy< hilti::ctor::struct_::Field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.copy< hilti::ctor::struct_::Fields > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.copy< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        value.copy< hilti::declaration::Parameters > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.copy< hilti::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.copy< hilti::statement::switch_::Case* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        value.copy< hilti::statement::switch_::Cases > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.copy< hilti::type::bitfield::BitRange* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.copy< hilti::type::bitfield::BitRanges > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.copy< hilti::type::enum_::Label* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.copy< hilti::type::enum_::Labels > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        value.copy< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.copy< hilti::type::function::Parameter* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.copy< hilti::type::tuple::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.copy< hilti::type::tuple::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.copy< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        value.copy< spicy::declaration::Hook* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        value.copy< spicy::declaration::Hooks > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_scoped_id_in_container: // scoped_id_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
      case symbol_kind::S_unit_block: // unit_block
        value.copy< spicy::type::unit::Item* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
      case symbol_kind::S_opt_unit_block_else_items: // opt_unit_block_else_items
        value.copy< spicy::type::unit::Items > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        value.copy< spicy::type::unit::item::switch_::Case* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        value.copy< spicy::type::unit::item::switch_::Cases > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.copy< std::pair<hilti::Declarations, hilti::Statements> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_decl_type_and_init: // global_decl_type_and_init
        value.copy< std::pair<hilti::QualifiedType*, hilti::Expression*> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CERROR: // "error value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.copy< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.copy< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        value.copy< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

  }




  template <typename Base>
  Parser::symbol_kind_type
  Parser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  template <typename Base>
  bool
  Parser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  Parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    switch (this->kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
      case symbol_kind::S_opt_skip: // opt_skip
      case symbol_kind::S_opt_skip_: // opt_skip_
        value.move< bool > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.move< double > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< hilti::AttributeSet* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_field_ctor: // unit_field_ctor
      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        value.move< hilti::Declaration* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        value.move< hilti::Declarations > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_opt_bitfield_range_value: // opt_bitfield_range_value
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_no_or_error: // expr_no_or_error
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.move< hilti::Expression* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_case_exprs: // case_exprs
      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< hilti::Expressions > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        value.move< hilti::ID > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
      case symbol_kind::S_qtype: // qtype
      case symbol_kind::S_unit_field_base_type: // unit_field_base_type
        value.move< hilti::QualifiedType* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< hilti::Statements > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_no_ref: // type_no_ref
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        value.move< hilti::UnqualifiedType* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< hilti::ctor::map::Elements > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< hilti::ctor::struct_::Fields > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        value.move< hilti::declaration::Parameters > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::parameter::Kind > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        value.move< hilti::statement::switch_::Cases > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.move< hilti::type::bitfield::BitRange* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.move< hilti::type::bitfield::BitRanges > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< hilti::type::enum_::Labels > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        value.move< hilti::type::function::Flavor > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< hilti::type::tuple::Elements > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.move< int64_t > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        value.move< spicy::declaration::Hook* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        value.move< spicy::declaration::Hooks > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_scoped_id_in_container: // scoped_id_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
      case symbol_kind::S_unit_block: // unit_block
        value.move< spicy::type::unit::Item* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
      case symbol_kind::S_opt_unit_block_else_items: // opt_unit_block_else_items
        value.move< spicy::type::unit::Items > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        value.move< spicy::type::unit::item::switch_::Case* > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        value.move< spicy::type::unit::item::switch_::Cases > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<hilti::Declarations, hilti::Statements> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_global_decl_type_and_init: // global_decl_type_and_init
        value.move< std::pair<hilti::QualifiedType*, hilti::Expression*> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CERROR: // "error value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        value.move< uint64_t > (YY_MOVE (s.value));
        break;

      default:
        break;
    }

    location = YY_MOVE (s.location);
  }

  // by_kind.
  Parser::by_kind::by_kind () YY_NOEXCEPT
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  Parser::by_kind::by_kind (by_kind&& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  Parser::by_kind::by_kind (const by_kind& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {}

  Parser::by_kind::by_kind (token_kind_type t) YY_NOEXCEPT
    : kind_ (yytranslate_ (t))
  {}



  void
  Parser::by_kind::clear () YY_NOEXCEPT
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  Parser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  Parser::symbol_kind_type
  Parser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }


  Parser::symbol_kind_type
  Parser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }



  // by_state.
  Parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  Parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  Parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  Parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  Parser::symbol_kind_type
  Parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  Parser::stack_symbol_type::stack_symbol_type ()
  {}

  Parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
      case symbol_kind::S_opt_skip: // opt_skip
      case symbol_kind::S_opt_skip_: // opt_skip_
        value.YY_MOVE_OR_COPY< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.YY_MOVE_OR_COPY< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        value.YY_MOVE_OR_COPY< hilti::Attribute* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        value.YY_MOVE_OR_COPY< hilti::AttributeSet* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_field_ctor: // unit_field_ctor
      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.YY_MOVE_OR_COPY< hilti::Ctor* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        value.YY_MOVE_OR_COPY< hilti::Declaration* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        value.YY_MOVE_OR_COPY< hilti::Declarations > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_opt_bitfield_range_value: // opt_bitfield_range_value
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_no_or_error: // expr_no_or_error
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.YY_MOVE_OR_COPY< hilti::Expression* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_case_exprs: // case_exprs
      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.YY_MOVE_OR_COPY< hilti::Expressions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        value.YY_MOVE_OR_COPY< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
      case symbol_kind::S_qtype: // qtype
      case symbol_kind::S_unit_field_base_type: // unit_field_base_type
        value.YY_MOVE_OR_COPY< hilti::QualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.YY_MOVE_OR_COPY< hilti::Statement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.YY_MOVE_OR_COPY< hilti::Statements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_no_ref: // type_no_ref
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        value.YY_MOVE_OR_COPY< hilti::UnqualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.YY_MOVE_OR_COPY< hilti::ctor::map::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.YY_MOVE_OR_COPY< hilti::ctor::map::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.YY_MOVE_OR_COPY< hilti::ctor::struct_::Field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.YY_MOVE_OR_COPY< hilti::ctor::struct_::Fields > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.YY_MOVE_OR_COPY< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        value.YY_MOVE_OR_COPY< hilti::declaration::Parameters > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.YY_MOVE_OR_COPY< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.YY_MOVE_OR_COPY< hilti::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.YY_MOVE_OR_COPY< hilti::statement::switch_::Case* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        value.YY_MOVE_OR_COPY< hilti::statement::switch_::Cases > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.YY_MOVE_OR_COPY< hilti::type::bitfield::BitRange* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.YY_MOVE_OR_COPY< hilti::type::bitfield::BitRanges > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.YY_MOVE_OR_COPY< hilti::type::enum_::Label* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.YY_MOVE_OR_COPY< hilti::type::enum_::Labels > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        value.YY_MOVE_OR_COPY< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.YY_MOVE_OR_COPY< hilti::type::function::Parameter* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.YY_MOVE_OR_COPY< hilti::type::tuple::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.YY_MOVE_OR_COPY< hilti::type::tuple::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.YY_MOVE_OR_COPY< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        value.YY_MOVE_OR_COPY< spicy::declaration::Hook* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        value.YY_MOVE_OR_COPY< spicy::declaration::Hooks > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_scoped_id_in_container: // scoped_id_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
      case symbol_kind::S_unit_block: // unit_block
        value.YY_MOVE_OR_COPY< spicy::type::unit::Item* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
      case symbol_kind::S_opt_unit_block_else_items: // opt_unit_block_else_items
        value.YY_MOVE_OR_COPY< spicy::type::unit::Items > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        value.YY_MOVE_OR_COPY< spicy::type::unit::item::switch_::Case* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        value.YY_MOVE_OR_COPY< spicy::type::unit::item::switch_::Cases > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.YY_MOVE_OR_COPY< std::pair<hilti::Declarations, hilti::Statements> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_decl_type_and_init: // global_decl_type_and_init
        value.YY_MOVE_OR_COPY< std::pair<hilti::QualifiedType*, hilti::Expression*> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CERROR: // "error value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.YY_MOVE_OR_COPY< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        value.YY_MOVE_OR_COPY< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  Parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
      case symbol_kind::S_opt_skip: // opt_skip
      case symbol_kind::S_opt_skip_: // opt_skip_
        value.move< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.move< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< hilti::AttributeSet* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_field_ctor: // unit_field_ctor
      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        value.move< hilti::Declaration* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        value.move< hilti::Declarations > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_opt_bitfield_range_value: // opt_bitfield_range_value
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_no_or_error: // expr_no_or_error
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.move< hilti::Expression* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_case_exprs: // case_exprs
      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< hilti::Expressions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        value.move< hilti::ID > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
      case symbol_kind::S_qtype: // qtype
      case symbol_kind::S_unit_field_base_type: // unit_field_base_type
        value.move< hilti::QualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< hilti::Statements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_no_ref: // type_no_ref
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        value.move< hilti::UnqualifiedType* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< hilti::ctor::map::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< hilti::ctor::struct_::Fields > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        value.move< hilti::declaration::Parameters > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::parameter::Kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        value.move< hilti::statement::switch_::Cases > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.move< hilti::type::bitfield::BitRange* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.move< hilti::type::bitfield::BitRanges > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< hilti::type::enum_::Labels > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        value.move< hilti::type::function::Flavor > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< hilti::type::tuple::Elements > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.move< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        value.move< spicy::declaration::Hook* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        value.move< spicy::declaration::Hooks > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_scoped_id_in_container: // scoped_id_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
      case symbol_kind::S_unit_block: // unit_block
        value.move< spicy::type::unit::Item* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
      case symbol_kind::S_opt_unit_block_else_items: // opt_unit_block_else_items
        value.move< spicy::type::unit::Items > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        value.move< spicy::type::unit::item::switch_::Case* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        value.move< spicy::type::unit::item::switch_::Cases > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<hilti::Declarations, hilti::Statements> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_global_decl_type_and_init: // global_decl_type_and_init
        value.move< std::pair<hilti::QualifiedType*, hilti::Expression*> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CERROR: // "error value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        value.move< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
      case symbol_kind::S_opt_skip: // opt_skip
      case symbol_kind::S_opt_skip_: // opt_skip_
        value.copy< bool > (that.value);
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.copy< double > (that.value);
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        value.copy< hilti::Attribute* > (that.value);
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        value.copy< hilti::AttributeSet* > (that.value);
        break;

      case symbol_kind::S_unit_field_ctor: // unit_field_ctor
      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.copy< hilti::Ctor* > (that.value);
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        value.copy< hilti::Declaration* > (that.value);
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        value.copy< hilti::Declarations > (that.value);
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_opt_bitfield_range_value: // opt_bitfield_range_value
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_no_or_error: // expr_no_or_error
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.copy< hilti::Expression* > (that.value);
        break;

      case symbol_kind::S_case_exprs: // case_exprs
      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.copy< hilti::Expressions > (that.value);
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        value.copy< hilti::ID > (that.value);
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
      case symbol_kind::S_qtype: // qtype
      case symbol_kind::S_unit_field_base_type: // unit_field_base_type
        value.copy< hilti::QualifiedType* > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.copy< hilti::Statement* > (that.value);
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.copy< hilti::Statements > (that.value);
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_no_ref: // type_no_ref
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        value.copy< hilti::UnqualifiedType* > (that.value);
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.copy< hilti::ctor::map::Element* > (that.value);
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.copy< hilti::ctor::map::Elements > (that.value);
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.copy< hilti::ctor::struct_::Field* > (that.value);
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.copy< hilti::ctor::struct_::Fields > (that.value);
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.copy< hilti::declaration::Linkage > (that.value);
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        value.copy< hilti::declaration::Parameters > (that.value);
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.copy< hilti::function::CallingConvention > (that.value);
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.copy< hilti::parameter::Kind > (that.value);
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.copy< hilti::statement::switch_::Case* > (that.value);
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        value.copy< hilti::statement::switch_::Cases > (that.value);
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.copy< hilti::type::bitfield::BitRange* > (that.value);
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.copy< hilti::type::bitfield::BitRanges > (that.value);
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.copy< hilti::type::enum_::Label* > (that.value);
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.copy< hilti::type::enum_::Labels > (that.value);
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        value.copy< hilti::type::function::Flavor > (that.value);
        break;

      case symbol_kind::S_func_param: // func_param
        value.copy< hilti::type::function::Parameter* > (that.value);
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.copy< hilti::type::tuple::Element* > (that.value);
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.copy< hilti::type::tuple::Elements > (that.value);
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.copy< int64_t > (that.value);
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        value.copy< spicy::declaration::Hook* > (that.value);
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        value.copy< spicy::declaration::Hooks > (that.value);
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_scoped_id_in_container: // scoped_id_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
      case symbol_kind::S_unit_block: // unit_block
        value.copy< spicy::type::unit::Item* > (that.value);
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
      case symbol_kind::S_opt_unit_block_else_items: // opt_unit_block_else_items
        value.copy< spicy::type::unit::Items > (that.value);
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        value.copy< spicy::type::unit::item::switch_::Case* > (that.value);
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        value.copy< spicy::type::unit::item::switch_::Cases > (that.value);
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.copy< std::pair<hilti::Declarations, hilti::Statements> > (that.value);
        break;

      case symbol_kind::S_global_decl_type_and_init: // global_decl_type_and_init
        value.copy< std::pair<hilti::QualifiedType*, hilti::Expression*> > (that.value);
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CERROR: // "error value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.copy< std::string > (that.value);
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.copy< std::vector<std::string> > (that.value);
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        value.copy< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_CBOOL: // "bool value"
      case symbol_kind::S_opt_skip: // opt_skip
      case symbol_kind::S_opt_skip_: // opt_skip_
        value.move< bool > (that.value);
        break;

      case symbol_kind::S_CUREAL: // "real value"
        value.move< double > (that.value);
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        value.move< hilti::Attribute* > (that.value);
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        value.move< hilti::AttributeSet* > (that.value);
        break;

      case symbol_kind::S_unit_field_ctor: // unit_field_ctor
      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        value.move< hilti::Ctor* > (that.value);
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        value.move< hilti::Declaration* > (that.value);
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        value.move< hilti::Declarations > (that.value);
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_opt_bitfield_range_value: // opt_bitfield_range_value
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_no_or_error: // expr_no_or_error
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        value.move< hilti::Expression* > (that.value);
        break;

      case symbol_kind::S_case_exprs: // case_exprs
      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        value.move< hilti::Expressions > (that.value);
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        value.move< hilti::ID > (that.value);
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
      case symbol_kind::S_qtype: // qtype
      case symbol_kind::S_unit_field_base_type: // unit_field_base_type
        value.move< hilti::QualifiedType* > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        value.move< hilti::Statement* > (that.value);
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        value.move< hilti::Statements > (that.value);
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_no_ref: // type_no_ref
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        value.move< hilti::UnqualifiedType* > (that.value);
        break;

      case symbol_kind::S_map_elem: // map_elem
        value.move< hilti::ctor::map::Element* > (that.value);
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        value.move< hilti::ctor::map::Elements > (that.value);
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        value.move< hilti::ctor::struct_::Field* > (that.value);
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        value.move< hilti::ctor::struct_::Fields > (that.value);
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        value.move< hilti::declaration::Linkage > (that.value);
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        value.move< hilti::declaration::Parameters > (that.value);
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        value.move< hilti::function::CallingConvention > (that.value);
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        value.move< hilti::parameter::Kind > (that.value);
        break;

      case symbol_kind::S_switch_case: // switch_case
        value.move< hilti::statement::switch_::Case* > (that.value);
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        value.move< hilti::statement::switch_::Cases > (that.value);
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        value.move< hilti::type::bitfield::BitRange* > (that.value);
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        value.move< hilti::type::bitfield::BitRanges > (that.value);
        break;

      case symbol_kind::S_enum_label: // enum_label
        value.move< hilti::type::enum_::Label* > (that.value);
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        value.move< hilti::type::enum_::Labels > (that.value);
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        value.move< hilti::type::function::Flavor > (that.value);
        break;

      case symbol_kind::S_func_param: // func_param
        value.move< hilti::type::function::Parameter* > (that.value);
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        value.move< hilti::type::tuple::Element* > (that.value);
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        value.move< hilti::type::tuple::Elements > (that.value);
        break;

      case symbol_kind::S_const_sint: // const_sint
        value.move< int64_t > (that.value);
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        value.move< spicy::declaration::Hook* > (that.value);
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        value.move< spicy::declaration::Hooks > (that.value);
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_scoped_id_in_container: // scoped_id_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
      case symbol_kind::S_unit_block: // unit_block
        value.move< spicy::type::unit::Item* > (that.value);
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
      case symbol_kind::S_opt_unit_block_else_items: // opt_unit_block_else_items
        value.move< spicy::type::unit::Items > (that.value);
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        value.move< spicy::type::unit::item::switch_::Case* > (that.value);
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        value.move< spicy::type::unit::item::switch_::Cases > (that.value);
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        value.move< std::pair<hilti::Declarations, hilti::Statements> > (that.value);
        break;

      case symbol_kind::S_global_decl_type_and_init: // global_decl_type_and_init
        value.move< std::pair<hilti::QualifiedType*, hilti::Expression*> > (that.value);
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CERROR: // "error value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        value.move< std::string > (that.value);
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        value.move< std::vector<std::string> > (that.value);
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        value.move< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  Parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  Parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  Parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  Parser::yypop_ (int n) YY_NOEXCEPT
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Parser::debug_level_type
  Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  Parser::state_type
  Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  Parser::yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  Parser::yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Parser::operator() ()
  {
    return parse ();
  }

  int
  Parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    // User initialization code.
#line 22 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
{
    yyla.location.begin.filename = yyla.location.end.filename = driver->currentFile();
}

#line 2315 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, &yyla.location, driver));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_CBOOL: // "bool value"
      case symbol_kind::S_opt_skip: // opt_skip
      case symbol_kind::S_opt_skip_: // opt_skip_
        yylhs.value.emplace< bool > ();
        break;

      case symbol_kind::S_CUREAL: // "real value"
        yylhs.value.emplace< double > ();
        break;

      case symbol_kind::S_unit_hook_attribute: // unit_hook_attribute
      case symbol_kind::S_attribute: // attribute
        yylhs.value.emplace< hilti::Attribute* > ();
        break;

      case symbol_kind::S_opt_unit_hook_attributes: // opt_unit_hook_attributes
      case symbol_kind::S_opt_attributes: // opt_attributes
        yylhs.value.emplace< hilti::AttributeSet* > ();
        break;

      case symbol_kind::S_unit_field_ctor: // unit_field_ctor
      case symbol_kind::S_ctor: // ctor
      case symbol_kind::S_tuple: // tuple
      case symbol_kind::S_list: // list
      case symbol_kind::S_vector: // vector
      case symbol_kind::S_set: // set
      case symbol_kind::S_map: // map
      case symbol_kind::S_struct_: // struct_
      case symbol_kind::S_regexp: // regexp
        yylhs.value.emplace< hilti::Ctor* > ();
        break;

      case symbol_kind::S_global_scope_decl: // global_scope_decl
      case symbol_kind::S_type_decl: // type_decl
      case symbol_kind::S_constant_decl: // constant_decl
      case symbol_kind::S_local_decl: // local_decl
      case symbol_kind::S_local_init_decl: // local_init_decl
      case symbol_kind::S_global_decl: // global_decl
      case symbol_kind::S_function_decl: // function_decl
      case symbol_kind::S_import_decl: // import_decl
      case symbol_kind::S_property_decl: // property_decl
      case symbol_kind::S_hook_decl: // hook_decl
      case symbol_kind::S_struct_field: // struct_field
        yylhs.value.emplace< hilti::Declaration* > ();
        break;

      case symbol_kind::S_struct_fields: // struct_fields
        yylhs.value.emplace< hilti::Declarations > ();
        break;

      case symbol_kind::S_opt_init_expression: // opt_init_expression
      case symbol_kind::S_opt_bitfield_range_value: // opt_bitfield_range_value
      case symbol_kind::S_unit_field_repeat: // unit_field_repeat
      case symbol_kind::S_opt_unit_field_repeat: // opt_unit_field_repeat
      case symbol_kind::S_opt_unit_field_condition: // opt_unit_field_condition
      case symbol_kind::S_opt_unit_switch_expr: // opt_unit_switch_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_expr_no_or_error: // expr_no_or_error
      case symbol_kind::S_expr_0: // expr_0
      case symbol_kind::S_expr_1: // expr_1
      case symbol_kind::S_expr_2: // expr_2
      case symbol_kind::S_expr_3: // expr_3
      case symbol_kind::S_expr_4: // expr_4
      case symbol_kind::S_expr_5: // expr_5
      case symbol_kind::S_expr_6: // expr_6
      case symbol_kind::S_expr_7: // expr_7
      case symbol_kind::S_expr_8: // expr_8
      case symbol_kind::S_expr_9: // expr_9
      case symbol_kind::S_expr_a: // expr_a
      case symbol_kind::S_expr_b: // expr_b
      case symbol_kind::S_expr_c: // expr_c
      case symbol_kind::S_expr_d: // expr_d
      case symbol_kind::S_expr_e: // expr_e
      case symbol_kind::S_expr_f: // expr_f
      case symbol_kind::S_expr_g: // expr_g
      case symbol_kind::S_member_expr: // member_expr
      case symbol_kind::S_ctor_expr: // ctor_expr
      case symbol_kind::S_tuple_elem: // tuple_elem
      case symbol_kind::S_tuple_expr: // tuple_expr
        yylhs.value.emplace< hilti::Expression* > ();
        break;

      case symbol_kind::S_case_exprs: // case_exprs
      case symbol_kind::S_opt_unit_field_args: // opt_unit_field_args
      case symbol_kind::S_opt_unit_field_sinks: // opt_unit_field_sinks
      case symbol_kind::S_opt_exprs: // opt_exprs
      case symbol_kind::S_exprs: // exprs
      case symbol_kind::S_opt_tuple_elems1: // opt_tuple_elems1
      case symbol_kind::S_opt_tuple_elems2: // opt_tuple_elems2
        yylhs.value.emplace< hilti::Expressions > ();
        break;

      case symbol_kind::S_local_id: // local_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_dotted_id: // dotted_id
      case symbol_kind::S_opt_unit_field_id: // opt_unit_field_id
      case symbol_kind::S_unit_hook_id: // unit_hook_id
        yylhs.value.emplace< hilti::ID > ();
        break;

      case symbol_kind::S_func_result: // func_result
      case symbol_kind::S_opt_func_result: // opt_func_result
      case symbol_kind::S_qtype: // qtype
      case symbol_kind::S_unit_field_base_type: // unit_field_base_type
        yylhs.value.emplace< hilti::QualifiedType* > ();
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_braced_block: // braced_block
      case symbol_kind::S_stmt: // stmt
      case symbol_kind::S_opt_else_block: // opt_else_block
      case symbol_kind::S_stmt_decl: // stmt_decl
      case symbol_kind::S_stmt_expr: // stmt_expr
        yylhs.value.emplace< hilti::Statement* > ();
        break;

      case symbol_kind::S_opt_stmts: // opt_stmts
      case symbol_kind::S_stmts: // stmts
        yylhs.value.emplace< hilti::Statements > ();
        break;

      case symbol_kind::S_base_type_no_ref: // base_type_no_ref
      case symbol_kind::S_reference_type: // reference_type
      case symbol_kind::S_base_type: // base_type
      case symbol_kind::S_type: // type
      case symbol_kind::S_type_no_ref: // type_no_ref
      case symbol_kind::S_tuple_type: // tuple_type
      case symbol_kind::S_struct_type: // struct_type
      case symbol_kind::S_enum_type: // enum_type
      case symbol_kind::S_bitfield_type: // bitfield_type
      case symbol_kind::S_unit_type: // unit_type
        yylhs.value.emplace< hilti::UnqualifiedType* > ();
        break;

      case symbol_kind::S_map_elem: // map_elem
        yylhs.value.emplace< hilti::ctor::map::Element* > ();
        break;

      case symbol_kind::S_opt_map_elems: // opt_map_elems
      case symbol_kind::S_map_elems: // map_elems
        yylhs.value.emplace< hilti::ctor::map::Elements > ();
        break;

      case symbol_kind::S_struct_elem: // struct_elem
        yylhs.value.emplace< hilti::ctor::struct_::Field* > ();
        break;

      case symbol_kind::S_struct_elems: // struct_elems
        yylhs.value.emplace< hilti::ctor::struct_::Fields > ();
        break;

      case symbol_kind::S_opt_linkage: // opt_linkage
        yylhs.value.emplace< hilti::declaration::Linkage > ();
        break;

      case symbol_kind::S_opt_func_params: // opt_func_params
      case symbol_kind::S_func_params: // func_params
      case symbol_kind::S_opt_unit_params: // opt_unit_params
      case symbol_kind::S_opt_unit_hook_params: // opt_unit_hook_params
        yylhs.value.emplace< hilti::declaration::Parameters > ();
        break;

      case symbol_kind::S_opt_func_cc: // opt_func_cc
        yylhs.value.emplace< hilti::function::CallingConvention > ();
        break;

      case symbol_kind::S_opt_func_param_kind: // opt_func_param_kind
        yylhs.value.emplace< hilti::parameter::Kind > ();
        break;

      case symbol_kind::S_switch_case: // switch_case
        yylhs.value.emplace< hilti::statement::switch_::Case* > ();
        break;

      case symbol_kind::S_switch_cases: // switch_cases
        yylhs.value.emplace< hilti::statement::switch_::Cases > ();
        break;

      case symbol_kind::S_bitfield_bit_range: // bitfield_bit_range
        yylhs.value.emplace< hilti::type::bitfield::BitRange* > ();
        break;

      case symbol_kind::S_opt_bitfield_bit_ranges: // opt_bitfield_bit_ranges
      case symbol_kind::S_bitfield_bit_ranges: // bitfield_bit_ranges
        yylhs.value.emplace< hilti::type::bitfield::BitRanges > ();
        break;

      case symbol_kind::S_enum_label: // enum_label
        yylhs.value.emplace< hilti::type::enum_::Label* > ();
        break;

      case symbol_kind::S_enum_labels: // enum_labels
        yylhs.value.emplace< hilti::type::enum_::Labels > ();
        break;

      case symbol_kind::S_opt_func_flavor: // opt_func_flavor
        yylhs.value.emplace< hilti::type::function::Flavor > ();
        break;

      case symbol_kind::S_func_param: // func_param
        yylhs.value.emplace< hilti::type::function::Parameter* > ();
        break;

      case symbol_kind::S_tuple_type_elem: // tuple_type_elem
        yylhs.value.emplace< hilti::type::tuple::Element* > ();
        break;

      case symbol_kind::S_tuple_type_elems: // tuple_type_elems
        yylhs.value.emplace< hilti::type::tuple::Elements > ();
        break;

      case symbol_kind::S_const_sint: // const_sint
        yylhs.value.emplace< int64_t > ();
        break;

      case symbol_kind::S_unit_hook: // unit_hook
        yylhs.value.emplace< spicy::declaration::Hook* > ();
        break;

      case symbol_kind::S_opt_unit_item_hooks: // opt_unit_item_hooks
      case symbol_kind::S_unit_hooks: // unit_hooks
        yylhs.value.emplace< spicy::declaration::Hooks > ();
        break;

      case symbol_kind::S_unit_item: // unit_item
      case symbol_kind::S_unit_variable: // unit_variable
      case symbol_kind::S_unit_sink: // unit_sink
      case symbol_kind::S_unit_property: // unit_property
      case symbol_kind::S_unit_field: // unit_field
      case symbol_kind::S_unit_field_in_container: // unit_field_in_container
      case symbol_kind::S_scoped_id_in_container: // scoped_id_in_container
      case symbol_kind::S_unit_wide_hook: // unit_wide_hook
      case symbol_kind::S_unit_switch: // unit_switch
      case symbol_kind::S_unit_block: // unit_block
        yylhs.value.emplace< spicy::type::unit::Item* > ();
        break;

      case symbol_kind::S_unit_items: // unit_items
      case symbol_kind::S_opt_unit_items: // opt_unit_items
      case symbol_kind::S_opt_unit_block_else_items: // opt_unit_block_else_items
        yylhs.value.emplace< spicy::type::unit::Items > ();
        break;

      case symbol_kind::S_unit_switch_case: // unit_switch_case
        yylhs.value.emplace< spicy::type::unit::item::switch_::Case* > ();
        break;

      case symbol_kind::S_unit_switch_cases: // unit_switch_cases
        yylhs.value.emplace< spicy::type::unit::item::switch_::Cases > ();
        break;

      case symbol_kind::S_global_scope_items: // global_scope_items
        yylhs.value.emplace< std::pair<hilti::Declarations, hilti::Statements> > ();
        break;

      case symbol_kind::S_global_decl_type_and_init: // global_decl_type_and_init
        yylhs.value.emplace< std::pair<hilti::QualifiedType*, hilti::Expression*> > ();
        break;

      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_SCOPED_IDENT: // "scoped identifier"
      case symbol_kind::S_DOTTED_IDENT: // "dotted identifier"
      case symbol_kind::S_HOOK_IDENT: // "hook identifier"
      case symbol_kind::S_DOLLAR_IDENT: // "$-identifier"
      case symbol_kind::S_ATTRIBUTE: // "attribute"
      case symbol_kind::S_PROPERTY: // "property"
      case symbol_kind::S_PREPROCESSOR: // "preprocessor directive"
      case symbol_kind::S_CSTRING: // "string value"
      case symbol_kind::S_CBYTES: // "bytes value"
      case symbol_kind::S_CERROR: // "error value"
      case symbol_kind::S_CREGEXP: // "regular expression value"
      case symbol_kind::S_CADDRESS: // "address value"
      case symbol_kind::S_CPORT: // "port value"
      case symbol_kind::S_re_pattern_constant: // re_pattern_constant
        yylhs.value.emplace< std::string > ();
        break;

      case symbol_kind::S_re_patterns: // re_patterns
        yylhs.value.emplace< std::vector<std::string> > ();
        break;

      case symbol_kind::S_CUINTEGER: // "unsigned integer value"
      case symbol_kind::S_DOLLAR_NUMBER: // "$<N>"
      case symbol_kind::S_const_uint: // const_uint
        yylhs.value.emplace< uint64_t > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 4: // start_expr: expr
#line 331 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { driver->setDestinationExpression(std::move(yystack_[0].value.as < hilti::Expression* > ())); }
#line 2739 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 5: // $@1: %empty
#line 333 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { _docs.emplace_back(driver->docGetAndClear()); }
#line 2745 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 6: // module: MODULE local_id ';' $@1 global_scope_items
#line 334 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { auto uid = hilti::declaration::module::UID(yystack_[3].value.as < hilti::ID > (), hilti::rt::filesystem::path(*driver->currentFile()));
                                                   auto m = builder->declarationModule(uid, {}, std::move(yystack_[0].value.as < std::pair<hilti::Declarations, hilti::Statements> > ().first), std::move(yystack_[0].value.as < std::pair<hilti::Declarations, hilti::Statements> > ().second), __loc__);
                                                   m->setDocumentation(_docs.back());
                                                   driver->setDestinationModule(std::move(m));
                                                 }
#line 2755 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 7: // local_id: "identifier"
#line 343 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { std::string name(yystack_[0].value.as < std::string > ());

                                                   if ( ! driver->builder()->options().skip_validation ) {
                                                       if ( name.find('-') != std::string::npos)
                                                           hilti::logger().error(hilti::util::fmt("Invalid ID '%s': cannot contain '-'", name), __loc__.location());
                                                       if ( name.substr(0, 2) == "__" )
                                                           hilti::logger().error(hilti::util::fmt("Invalid ID '%s': cannot start with '__'", name), __loc__.location());
                                                   }

                                                   yylhs.value.as < hilti::ID > () = hilti::ID(std::move(name));
                                                 }
#line 2771 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 8: // scoped_id: local_id
#line 355 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = std::move(yystack_[0].value.as < hilti::ID > ()); }
#line 2777 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 9: // scoped_id: "scoped identifier"
#line 356 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[0].value.as < std::string > ()); }
#line 2783 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 10: // $@2: %empty
#line 358 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                { driver->enableDottedIDMode(); }
#line 2789 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 11: // $@3: %empty
#line 360 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                { driver->disableDottedIDMode(); }
#line 2795 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 12: // dotted_id: $@2 "dotted identifier" $@3
#line 360 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                   { yylhs.value.as < hilti::ID > () = hilti::ID(yystack_[1].value.as < std::string > ()); }
#line 2801 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 13: // global_scope_items: global_scope_items global_scope_decl
#line 366 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::pair<hilti::Declarations, hilti::Statements> > () = std::move(yystack_[1].value.as < std::pair<hilti::Declarations, hilti::Statements> > ()); yylhs.value.as < std::pair<hilti::Declarations, hilti::Statements> > ().first.push_back(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2807 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 14: // global_scope_items: global_scope_items stmt
#line 368 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::pair<hilti::Declarations, hilti::Statements> > () = std::move(yystack_[1].value.as < std::pair<hilti::Declarations, hilti::Statements> > ()); yylhs.value.as < std::pair<hilti::Declarations, hilti::Statements> > ().second.push_back(yystack_[0].value.as < hilti::Statement* > ()); }
#line 2813 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 15: // global_scope_items: %empty
#line 369 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::pair<hilti::Declarations, hilti::Statements> > () = {}; }
#line 2819 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 16: // global_scope_decl: type_decl
#line 373 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2825 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 17: // global_scope_decl: constant_decl
#line 374 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2831 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 18: // global_scope_decl: global_decl
#line 375 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2837 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 19: // global_scope_decl: function_decl
#line 376 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2843 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 20: // global_scope_decl: import_decl
#line 377 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2849 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 21: // global_scope_decl: property_decl
#line 378 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2855 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 22: // global_scope_decl: hook_decl
#line 379 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = std::move(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 2861 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 23: // $@4: %empty
#line 381 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { _docs.emplace_back(driver->docGetAndClear()); }
#line 2867 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 24: // type_decl: opt_linkage TYPE scoped_id '=' $@4 qtype opt_attributes ';'
#line 382 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { if ( auto u = yystack_[2].value.as < hilti::QualifiedType* > ()->type()->tryAs<type::Unit>(); u && yystack_[1].value.as < hilti::AttributeSet* > () && *yystack_[1].value.as < hilti::AttributeSet* > () ) {
                                                      u->setAttributes(builder->context(), yystack_[1].value.as < hilti::AttributeSet* > ());
                                                      yystack_[1].value.as < hilti::AttributeSet* > () = {}; // don't associate with declaration
                                                   }

                                                   // Type decls can have attributes, but only for certain types
                                                   if ( yystack_[1].value.as < hilti::AttributeSet* > () && ! yystack_[1].value.as < hilti::AttributeSet* > ()->attributes().empty() ) {
                                                      auto ty = yystack_[2].value.as < hilti::QualifiedType* > ()->type();
                                                      if ( ! (ty->isA<hilti::type::Struct>() || ty->isA<hilti::type::Enum>() || ty->isA<hilti::type::Bitfield>()) )
                                                          error(yystack_[1].location, "attributes are not allowed on type aliases");
                                                   }

                                                   yylhs.value.as < hilti::Declaration* > () = builder->declarationType(std::move(yystack_[5].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), std::move(yystack_[7].value.as < hilti::declaration::Linkage > ()), __loc__);
                                                   yylhs.value.as < hilti::Declaration* > ()->setDocumentation(_docs.back());
                                                   _docs.pop_back();
                                                 }
#line 2888 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 25: // $@5: %empty
#line 399 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { _docs.emplace_back(driver->docGetAndClear()); }
#line 2894 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 26: // constant_decl: opt_linkage CONST scoped_id $@5 '=' expr ';'
#line 400 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationConstant(yystack_[4].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression* > (), yystack_[6].value.as < hilti::declaration::Linkage > (), __loc__);
                                                   yylhs.value.as < hilti::Declaration* > ()->setDocumentation(_docs.back());
                                                   _docs.pop_back();
                                                 }
#line 2903 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 27: // $@6: %empty
#line 405 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { _docs.emplace_back(driver->docGetAndClear()); }
#line 2909 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 28: // constant_decl: opt_linkage CONST scoped_id $@6 ':' qtype '=' expr ';'
#line 406 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < hilti::Declaration* > () = builder->declarationConstant(yystack_[6].value.as < hilti::ID > (), yystack_[3].value.as < hilti::QualifiedType* > (), yystack_[1].value.as < hilti::Expression* > (), yystack_[8].value.as < hilti::declaration::Linkage > (), __loc__);
                                                   yylhs.value.as < hilti::Declaration* > ()->setDocumentation(_docs.back());
                                                   _docs.pop_back();
                                                 }
#line 2918 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 29: // local_decl: LOCAL scoped_id '=' expr ';'
#line 412 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression* > (), __loc__); }
#line 2924 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 30: // local_decl: LOCAL scoped_id ':' qtype ';'
#line 413 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::QualifiedType* > (), {}, __loc__); }
#line 2930 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 31: // local_decl: LOCAL scoped_id ':' qtype '=' expr ';'
#line 415 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[5].value.as < hilti::ID > (), yystack_[3].value.as < hilti::QualifiedType* > (), yystack_[1].value.as < hilti::Expression* > (), __loc__); }
#line 2936 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 32: // local_init_decl: LOCAL local_id ':' qtype '=' expr
#line 420 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[4].value.as < hilti::ID > (), yystack_[2].value.as < hilti::QualifiedType* > (), yystack_[0].value.as < hilti::Expression* > (), __loc__); }
#line 2942 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 33: // local_init_decl: LOCAL local_id '=' expr
#line 422 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationLocalVariable(yystack_[2].value.as < hilti::ID > (), yystack_[0].value.as < hilti::Expression* > (), __loc__); }
#line 2948 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 34: // $@7: %empty
#line 425 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { _docs.emplace_back(driver->docGetAndClear()); }
#line 2954 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 35: // global_decl: opt_linkage GLOBAL scoped_id $@7 '=' expr ';'
#line 426 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationGlobalVariable(yystack_[4].value.as < hilti::ID > (), yystack_[1].value.as < hilti::Expression* > (), yystack_[6].value.as < hilti::declaration::Linkage > (), __loc__);
                                                   yylhs.value.as < hilti::Declaration* > ()->setDocumentation(_docs.back());
                                                   _docs.pop_back();
                                                 }
#line 2963 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 36: // $@8: %empty
#line 431 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { _docs.emplace_back(driver->docGetAndClear()); }
#line 2969 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 37: // global_decl: opt_linkage GLOBAL scoped_id $@8 ':' global_decl_type_and_init
#line 432 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationGlobalVariable(yystack_[3].value.as < hilti::ID > (), yystack_[0].value.as < std::pair<hilti::QualifiedType*, hilti::Expression*> > ().first, yystack_[0].value.as < std::pair<hilti::QualifiedType*, hilti::Expression*> > ().second, yystack_[5].value.as < hilti::declaration::Linkage > (), __loc__);
                                                   yylhs.value.as < hilti::Declaration* > ()->setDocumentation(_docs.back());
                                                   _docs.pop_back();
                                                 }
#line 2978 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 38: // global_decl_type_and_init: qtype ';'
#line 439 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < std::pair<hilti::QualifiedType*, hilti::Expression*> > () = std::make_pair(yystack_[1].value.as < hilti::QualifiedType* > (), nullptr); }
#line 2984 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 39: // global_decl_type_and_init: qtype '=' expr ';'
#line 440 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < std::pair<hilti::QualifiedType*, hilti::Expression*> > () = std::make_pair(yystack_[3].value.as < hilti::QualifiedType* > (), yystack_[1].value.as < hilti::Expression* > ()); }
#line 2990 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 40: // $@9: %empty
#line 443 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { _docs.emplace_back(driver->docGetAndClear()); }
#line 2996 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 41: // function_decl: opt_linkage FUNCTION opt_func_flavor opt_func_cc scoped_id '(' opt_func_params ')' opt_func_result opt_attributes $@9 ';'
#line 444 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 {
                                                    auto ftype = builder->typeFunction(yystack_[3].value.as < hilti::QualifiedType* > (), yystack_[5].value.as < hilti::declaration::Parameters > (), yystack_[9].value.as < hilti::type::function::Flavor > (), __loc__);
                                                    auto func = builder->function(yystack_[7].value.as < hilti::ID > (), std::move(ftype), {}, yystack_[8].value.as < hilti::function::CallingConvention > (), yystack_[2].value.as < hilti::AttributeSet* > (), __loc__);
                                                    yylhs.value.as < hilti::Declaration* > () = builder->declarationFunction(std::move(func), yystack_[11].value.as < hilti::declaration::Linkage > (), __loc__);
                                                    yylhs.value.as < hilti::Declaration* > ()->setDocumentation(_docs.back());
                                                    _docs.pop_back();
                                                 }
#line 3008 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 42: // $@10: %empty
#line 453 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { _docs.emplace_back(driver->docGetAndClear()); }
#line 3014 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 43: // function_decl: opt_linkage FUNCTION opt_func_flavor opt_func_cc scoped_id '(' opt_func_params ')' opt_func_result opt_attributes $@10 braced_block
#line 454 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 {
                                                    auto ftype = builder->typeFunction(yystack_[3].value.as < hilti::QualifiedType* > (), yystack_[5].value.as < hilti::declaration::Parameters > (), yystack_[9].value.as < hilti::type::function::Flavor > (), __loc__);
                                                    auto func = builder->function(yystack_[7].value.as < hilti::ID > (), std::move(ftype), yystack_[0].value.as < hilti::Statement* > (), yystack_[8].value.as < hilti::function::CallingConvention > (), yystack_[2].value.as < hilti::AttributeSet* > (), __loc__);
                                                    yylhs.value.as < hilti::Declaration* > () = builder->declarationFunction(std::move(func), yystack_[11].value.as < hilti::declaration::Linkage > (), __loc__);
                                                    yylhs.value.as < hilti::Declaration* > ()->setDocumentation(_docs.back());
                                                    _docs.pop_back();
                                                 }
#line 3026 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 44: // import_decl: IMPORT local_id ';'
#line 463 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationImportedModule(std::move(yystack_[1].value.as < hilti::ID > ()), std::string(".spicy"), __loc__); }
#line 3032 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 45: // import_decl: IMPORT local_id FROM dotted_id ';'
#line 464 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                   { yylhs.value.as < hilti::Declaration* > () = builder->declarationImportedModule(std::move(yystack_[3].value.as < hilti::ID > ()), std::string(".spicy"), std::move(yystack_[1].value.as < hilti::ID > ()), __loc__); }
#line 3038 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 46: // property_decl: "property" ';'
#line 467 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationProperty(ID(std::move(yystack_[1].value.as < std::string > ())), __loc__); }
#line 3044 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 47: // property_decl: "property" '=' expr ';'
#line 468 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declaration* > () = builder->declarationProperty(ID(std::move(yystack_[3].value.as < std::string > ())), std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 3050 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 48: // hook_decl: ON unit_hook_id unit_hook
#line 471 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { ID unit = yystack_[1].value.as < hilti::ID > ().namespace_();
                                                   if ( unit.empty() )
                                                      error(yylhs.location, "hook requires unit namespace");

                                                   yylhs.value.as < hilti::Declaration* > () = builder->declarationUnitHook(std::move(yystack_[1].value.as < hilti::ID > ()), std::move(yystack_[0].value.as < spicy::declaration::Hook* > ()), __loc__);
                                                 }
#line 3061 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 49: // opt_linkage: PUBLIC
#line 479 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Public; }
#line 3067 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 50: // opt_linkage: PRIVATE
#line 480 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 3073 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 51: // opt_linkage: %empty
#line 481 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Linkage > () = hilti::declaration::Linkage::Private; }
#line 3079 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 52: // opt_func_flavor: %empty
#line 485 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Flavor > () = hilti::type::function::Flavor::Standard; }
#line 3085 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 53: // opt_func_cc: "string value"
#line 487 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { try {
                                                       yylhs.value.as < hilti::function::CallingConvention > () = hilti::function::calling_convention::from_string(yystack_[0].value.as < std::string > ());
                                                   } catch ( std::out_of_range& e ) {
                                                       error(yylhs.location, "unknown calling convention");
                                                   }
                                                 }
#line 3096 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 54: // opt_func_cc: %empty
#line 493 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::function::CallingConvention > () = hilti::function::CallingConvention::Standard; }
#line 3102 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 55: // opt_func_params: func_params
#line 497 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Parameters > () = std::move(yystack_[0].value.as < hilti::declaration::Parameters > ()); }
#line 3108 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 56: // opt_func_params: %empty
#line 498 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Parameters > () = hilti::type::function::Parameters{}; }
#line 3114 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 57: // func_params: func_params ',' func_param
#line 500 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Parameters > () = std::move(yystack_[2].value.as < hilti::declaration::Parameters > ()); yylhs.value.as < hilti::declaration::Parameters > ().push_back(yystack_[0].value.as < hilti::type::function::Parameter* > ()); }
#line 3120 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 58: // func_params: func_param
#line 501 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Parameters > () = hilti::type::function::Parameters{yystack_[0].value.as < hilti::type::function::Parameter* > ()}; }
#line 3126 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 59: // func_param: opt_func_param_kind local_id ':' type opt_init_expression
#line 504 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::function::Parameter* > () = builder->declarationParameter(yystack_[3].value.as < hilti::ID > (), yystack_[1].value.as < hilti::UnqualifiedType* > (), yystack_[4].value.as < hilti::parameter::Kind > (), yystack_[0].value.as < hilti::Expression* > (), {}, __loc__); }
#line 3132 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 60: // func_result: ':' qtype
#line 506 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = std::move(yystack_[0].value.as < hilti::QualifiedType* > ()); }
#line 3138 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 61: // opt_func_result: func_result
#line 508 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = std::move(yystack_[0].value.as < hilti::QualifiedType* > ()); }
#line 3144 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 62: // opt_func_result: %empty
#line 509 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = builder->qualifiedType(builder->typeVoid(), hilti::Constness::Const); }
#line 3150 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 63: // opt_func_param_kind: INOUT
#line 512 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::parameter::Kind > () = hilti::parameter::Kind::InOut; }
#line 3156 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 64: // opt_func_param_kind: %empty
#line 513 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::parameter::Kind > () = hilti::parameter::Kind::In; }
#line 3162 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 65: // opt_init_expression: '=' expr
#line 516 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3168 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 66: // opt_init_expression: %empty
#line 517 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = {}; }
#line 3174 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 67: // block: braced_block
#line 522 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = std::move(yystack_[0].value.as < hilti::Statement* > ()); }
#line 3180 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 68: // block: stmt
#line 523 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementBlock({yystack_[0].value.as < hilti::Statement* > ()}, __loc__); }
#line 3186 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 69: // braced_block: '{' opt_stmts '}'
#line 526 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementBlock(std::move(yystack_[1].value.as < hilti::Statements > ()), __loc__); }
#line 3192 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 70: // opt_stmts: stmts
#line 528 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statements > () = std::move(yystack_[0].value.as < hilti::Statements > ()); }
#line 3198 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 71: // opt_stmts: %empty
#line 529 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statements > () = hilti::Statements{}; }
#line 3204 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 72: // stmts: stmts stmt
#line 531 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statements > () = std::move(yystack_[1].value.as < hilti::Statements > ()); yylhs.value.as < hilti::Statements > ().push_back(yystack_[0].value.as < hilti::Statement* > ()); }
#line 3210 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 73: // stmts: stmt
#line 532 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statements > () = Statements{std::move(yystack_[0].value.as < hilti::Statement* > ())}; }
#line 3216 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 74: // stmt: stmt_expr ';'
#line 534 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = std::move(yystack_[1].value.as < hilti::Statement* > ()); }
#line 3222 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 75: // stmt: stmt_decl
#line 535 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = std::move(yystack_[0].value.as < hilti::Statement* > ()); }
#line 3228 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 76: // stmt: "assert" expr ';'
#line 536 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementAssert(std::move(yystack_[1].value.as < hilti::Expression* > ()), {}, __loc__); }
#line 3234 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 77: // stmt: "assert-exception" expr_no_or_error ':' expr ';'
#line 538 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementAssert(hilti::statement::assert::Exception(), std::move(yystack_[3].value.as < hilti::Expression* > ()), {}, std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 3240 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 78: // stmt: "assert-exception" expr_no_or_error ';'
#line 540 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementAssert(hilti::statement::assert::Exception(), std::move(yystack_[1].value.as < hilti::Expression* > ()), {}, {}, __loc__); }
#line 3246 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 79: // stmt: BREAK ';'
#line 541 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementBreak(__loc__); }
#line 3252 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 80: // stmt: CONTINUE ';'
#line 542 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementContinue(__loc__); }
#line 3258 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 81: // stmt: FOR '(' local_id IN expr ')' block
#line 544 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementFor(std::move(yystack_[4].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3264 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 82: // stmt: IF '(' expr ')' block opt_else_block
#line 546 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementIf(std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3270 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 83: // stmt: IF '(' local_init_decl ')' block opt_else_block
#line 548 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementIf(std::move(yystack_[3].value.as < hilti::Declaration* > ()), {}, std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3276 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 84: // stmt: IF '(' local_init_decl ';' expr ')' block opt_else_block
#line 550 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementIf(std::move(yystack_[5].value.as < hilti::Declaration* > ()), std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Statement* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3282 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 85: // stmt: PRINT opt_exprs ';'
#line 551 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementPrint(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 3288 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 86: // stmt: RETURN ';'
#line 552 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementReturn(__loc__); }
#line 3294 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 87: // stmt: RETURN expr ';'
#line 553 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementReturn(std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 3300 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 88: // stmt: STOP ';'
#line 554 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementStop(__loc__); }
#line 3306 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 89: // stmt: THROW expr ';'
#line 555 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementThrow(builder->exception(builder->typeName("~spicy_rt::ParseError"), yystack_[1].value.as < hilti::Expression* > (), __loc__), __loc__); }
#line 3312 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 90: // stmt: SWITCH '(' expr ')' '{' switch_cases '}'
#line 557 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementSwitch(std::move(yystack_[4].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::statement::switch_::Cases > ()), __loc__); }
#line 3318 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 91: // stmt: SWITCH '(' local_init_decl ')' '{' switch_cases '}'
#line 559 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementSwitch(std::move(yystack_[4].value.as < hilti::Declaration* > ()), std::move(yystack_[1].value.as < hilti::statement::switch_::Cases > ()), __loc__); }
#line 3324 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 92: // stmt: "confirm" ';'
#line 560 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementConfirm(__loc__); }
#line 3330 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 93: // stmt: "reject" ';'
#line 561 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementReject(__loc__); }
#line 3336 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 94: // stmt: WHILE '(' local_init_decl ';' expr ')' block
#line 563 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementWhile(std::move(yystack_[4].value.as < hilti::Declaration* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), nullptr, __loc__); }
#line 3342 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 95: // stmt: WHILE '(' expr ')' block
#line 565 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementWhile(std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), nullptr, __loc__); }
#line 3348 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 96: // stmt: WHILE '(' local_init_decl ')' block
#line 567 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementWhile(std::move(yystack_[2].value.as < hilti::Declaration* > ()), {}, std::move(yystack_[0].value.as < hilti::Statement* > ()), nullptr, __loc__); }
#line 3354 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 97: // stmt: ADD expr ';'
#line 569 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { auto op = yystack_[1].value.as < hilti::Expression* > ()->tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'add' must be used with index expression only");

                                                   auto expr = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Add, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement* > () = builder->statementExpression(std::move(expr), __loc__);
                                                 }
#line 3366 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 98: // stmt: DELETE expr ';'
#line 577 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { auto op = yystack_[1].value.as < hilti::Expression* > ()->tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Index) )
                                                        error(yylhs.location, "'delete' must be used with index expressions only");

                                                   auto expr = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Delete, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement* > () = builder->statementExpression(std::move(expr), __loc__);
                                                 }
#line 3378 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 99: // stmt: UNSET expr ';'
#line 585 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { auto op = yystack_[1].value.as < hilti::Expression* > ()->tryAs<hilti::expression::UnresolvedOperator>();
                                                   if ( ! (op && op->kind() == hilti::operator_::Kind::Member) )
                                                        error(yylhs.location, "'unset' must be used with member expressions only");

                                                   auto expr = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Unset, op->operands(), __loc__);
                                                   yylhs.value.as < hilti::Statement* > () = builder->statementExpression(std::move(expr), __loc__);
                                                 }
#line 3390 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 100: // opt_else_block: ELSE block
#line 596 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = std::move(yystack_[0].value.as < hilti::Statement* > ()); }
#line 3396 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 101: // opt_else_block: %empty
#line 597 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = {}; }
#line 3402 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 102: // switch_cases: switch_cases switch_case
#line 599 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::switch_::Cases > () = std::move(yystack_[1].value.as < hilti::statement::switch_::Cases > ()); yylhs.value.as < hilti::statement::switch_::Cases > ().push_back(std::move(yystack_[0].value.as < hilti::statement::switch_::Case* > ())); }
#line 3408 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 103: // switch_cases: switch_case
#line 600 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::switch_::Cases > () = hilti::statement::switch_::Cases({ std::move(yystack_[0].value.as < hilti::statement::switch_::Case* > ()) }); }
#line 3414 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 104: // switch_case: CASE case_exprs ':' block
#line 602 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                      { yylhs.value.as < hilti::statement::switch_::Case* > () = builder->statementSwitchCase(std::move(yystack_[2].value.as < hilti::Expressions > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3420 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 105: // switch_case: DEFAULT ':' block
#line 603 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::statement::switch_::Case* > () = builder->statementSwitchCase(hilti::statement::switch_::Default(), std::move(yystack_[0].value.as < hilti::Statement* > ()), __loc__); }
#line 3426 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 106: // case_exprs: case_exprs ',' expr_no_or_error
#line 605 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = std::move(yystack_[2].value.as < hilti::Expressions > ()); yylhs.value.as < hilti::Expressions > ().push_back(std::move(yystack_[0].value.as < hilti::Expression* > ())); }
#line 3432 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 107: // case_exprs: expr_no_or_error
#line 606 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[0].value.as < hilti::Expression* > ())}; }
#line 3438 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 108: // stmt_decl: local_decl
#line 608 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementDeclaration(yystack_[0].value.as < hilti::Declaration* > (), __loc__); }
#line 3444 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 109: // stmt_decl: type_decl
#line 609 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementDeclaration(yystack_[0].value.as < hilti::Declaration* > (), __loc__); }
#line 3450 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 110: // stmt_decl: constant_decl
#line 610 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementDeclaration(yystack_[0].value.as < hilti::Declaration* > (), __loc__); }
#line 3456 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 111: // stmt_expr: expr
#line 613 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Statement* > () = builder->statementExpression(yystack_[0].value.as < hilti::Expression* > (), __loc__); }
#line 3462 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 112: // base_type_no_ref: ANY
#line 618 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeAny(__loc__); }
#line 3468 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 113: // base_type_no_ref: ADDRESS
#line 619 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeAddress(__loc__); }
#line 3474 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 114: // base_type_no_ref: BOOL
#line 620 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeBool(__loc__); }
#line 3480 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 115: // base_type_no_ref: BYTES
#line 621 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeBytes(__loc__); }
#line 3486 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 116: // base_type_no_ref: __ERROR
#line 622 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeError(__loc__); }
#line 3492 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 117: // base_type_no_ref: INTERVAL
#line 623 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeInterval(__loc__); }
#line 3498 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 118: // base_type_no_ref: NETWORK
#line 624 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeNetwork(__loc__); }
#line 3504 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 119: // base_type_no_ref: PORT
#line 625 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typePort(__loc__); }
#line 3510 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 120: // base_type_no_ref: REAL
#line 626 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeReal(__loc__); }
#line 3516 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 121: // base_type_no_ref: REGEXP
#line 627 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeRegExp(__loc__); }
#line 3522 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 122: // base_type_no_ref: "stream"
#line 628 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeStream(__loc__); }
#line 3528 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 123: // base_type_no_ref: STRING
#line 629 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeString(__loc__); }
#line 3534 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 124: // base_type_no_ref: TIME
#line 630 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeTime(__loc__); }
#line 3540 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 125: // base_type_no_ref: VOID
#line 631 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeVoid(__loc__); }
#line 3546 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 126: // base_type_no_ref: INT8
#line 633 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSignedInteger(8, __loc__); }
#line 3552 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 127: // base_type_no_ref: INT16
#line 634 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSignedInteger(16, __loc__); }
#line 3558 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 128: // base_type_no_ref: INT32
#line 635 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSignedInteger(32, __loc__); }
#line 3564 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 129: // base_type_no_ref: INT64
#line 636 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSignedInteger(64, __loc__); }
#line 3570 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 130: // base_type_no_ref: UINT8
#line 637 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeUnsignedInteger(8, __loc__); }
#line 3576 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 131: // base_type_no_ref: UINT16
#line 638 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeUnsignedInteger(16, __loc__); }
#line 3582 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 132: // base_type_no_ref: UINT32
#line 639 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeUnsignedInteger(32, __loc__); }
#line 3588 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 133: // base_type_no_ref: UINT64
#line 640 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeUnsignedInteger(64, __loc__); }
#line 3594 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 134: // base_type_no_ref: CONST_ITERATOR type_param_begin qtype type_param_end
#line 642 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::UnqualifiedType* > () = iteratorForType(builder, std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__)->type(); }
#line 3600 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 135: // base_type_no_ref: ITERATOR type_param_begin qtype type_param_end
#line 643 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::UnqualifiedType* > () = iteratorForType(builder, std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__)->type(); }
#line 3606 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 136: // base_type_no_ref: OPTIONAL type_param_begin qtype type_param_end
#line 644 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeOptional(yystack_[1].value.as < hilti::QualifiedType* > (), __loc__); }
#line 3612 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 137: // base_type_no_ref: RESULT type_param_begin qtype type_param_end
#line 645 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeResult(yystack_[1].value.as < hilti::QualifiedType* > (), __loc__); }
#line 3618 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 138: // base_type_no_ref: VIEW type_param_begin qtype type_param_end
#line 646 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::UnqualifiedType* > () = viewForType(builder, std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__)->type(); }
#line 3624 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 139: // base_type_no_ref: MAP type_param_begin qtype ',' qtype type_param_end
#line 648 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                           { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeMap(std::move(yystack_[3].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__); }
#line 3630 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 140: // base_type_no_ref: SET type_param_begin qtype type_param_end
#line 649 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSet(std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__); }
#line 3636 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 141: // base_type_no_ref: VECTOR type_param_begin qtype type_param_end
#line 650 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeVector(std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__); }
#line 3642 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 142: // base_type_no_ref: SINK
#line 652 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeSink(__loc__); }
#line 3648 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 143: // base_type_no_ref: "library type" '(' "string value" ')'
#line 654 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeLibrary(std::move(yystack_[1].value.as < std::string > ()), __loc__); }
#line 3654 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 144: // base_type_no_ref: tuple_type
#line 656 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3660 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 145: // base_type_no_ref: struct_type
#line 657 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3666 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 146: // base_type_no_ref: enum_type
#line 658 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3672 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 147: // base_type_no_ref: bitfield_type
#line 659 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3678 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 148: // base_type_no_ref: unit_type
#line 660 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3684 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 149: // reference_type: qtype '&'
#line 665 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yystack_[1].value.as < hilti::QualifiedType* > ()->setSide(hilti::Side::LHS);
                                                   yystack_[1].value.as < hilti::QualifiedType* > ()->setConst(hilti::Constness::Mutable);
                                                   yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeStrongReference(std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__);
                                                 }
#line 3693 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 150: // base_type: base_type_no_ref
#line 670 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3699 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 151: // reference_type: qtype '&'
#line 671 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yystack_[1].value.as < hilti::QualifiedType* > ()->setSide(hilti::Side::LHS);
                                                   yystack_[1].value.as < hilti::QualifiedType* > ()->setConst(hilti::Constness::Mutable);
                                                   yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeStrongReference(std::move(yystack_[1].value.as < hilti::QualifiedType* > ()), __loc__);
                                                 }
#line 3708 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 152: // type: base_type
#line 677 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3714 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 153: // type: reference_type
#line 678 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3720 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 154: // type: scoped_id
#line 679 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeName(std::move(yystack_[0].value.as < hilti::ID > ())); }
#line 3726 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 155: // type_no_ref: base_type
#line 682 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()); }
#line 3732 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 156: // type_no_ref: scoped_id
#line 683 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeName(std::move(yystack_[0].value.as < hilti::ID > ())); }
#line 3738 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 157: // qtype: type_no_ref
#line 686 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = builder->qualifiedType(std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()), hilti::Constness::Mutable, __loc__); }
#line 3744 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 158: // qtype: CONST type_no_ref
#line 687 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = builder->qualifiedType(std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()), hilti::Constness::Const, __loc__); }
#line 3750 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 159: // qtype: reference_type
#line 688 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = builder->qualifiedType(std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()), hilti::Constness::Const, __loc__); }
#line 3756 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 160: // qtype: AUTO
#line 689 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::QualifiedType* > () = builder->qualifiedType(builder->typeAuto(__loc__), hilti::Constness::Const, __loc__); }
#line 3762 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 161: // type_param_begin: '<'
#line 694 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
              { driver->disableExpressionMode(); }
#line 3768 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 162: // type_param_end: '>'
#line 698 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
              { driver->enableExpressionMode(); }
#line 3774 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 163: // tuple_type: TUPLE type_param_begin '*' type_param_end
#line 700 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeTuple(hilti::type::Wildcard(), __loc__); }
#line 3780 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 164: // tuple_type: TUPLE type_param_begin tuple_type_elems type_param_end
#line 701 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                         { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeTuple(std::move(yystack_[1].value.as < hilti::type::tuple::Elements > ()), __loc__); }
#line 3786 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 165: // tuple_type_elems: tuple_type_elems ',' tuple_type_elem
#line 706 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::tuple::Elements > () = std::move(yystack_[2].value.as < hilti::type::tuple::Elements > ()); yylhs.value.as < hilti::type::tuple::Elements > ().push_back(std::move(yystack_[0].value.as < hilti::type::tuple::Element* > ())); }
#line 3792 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 166: // tuple_type_elems: tuple_type_elems ','
#line 707 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::tuple::Elements > () = std::move(yystack_[1].value.as < hilti::type::tuple::Elements > ()); }
#line 3798 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 167: // tuple_type_elems: tuple_type_elem
#line 708 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::tuple::Elements > () = hilti::type::tuple::Elements{std::move(yystack_[0].value.as < hilti::type::tuple::Element* > ())}; }
#line 3804 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 168: // tuple_type_elem: qtype
#line 712 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < hilti::type::tuple::Element* > () = builder->typeTupleElement(std::move(yystack_[0].value.as < hilti::QualifiedType* > ())); }
#line 3810 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 169: // tuple_type_elem: local_id ':' qtype
#line 713 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                  { yylhs.value.as < hilti::type::tuple::Element* > () = builder->typeTupleElement(std::move(yystack_[2].value.as < hilti::ID > ()), std::move(yystack_[0].value.as < hilti::QualifiedType* > ())); }
#line 3816 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 170: // struct_type: STRUCT '{' struct_fields '}'
#line 716 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeStruct(std::move(yystack_[1].value.as < hilti::Declarations > ()), __loc__); }
#line 3822 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 171: // struct_fields: struct_fields struct_field
#line 718 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declarations > () = std::move(yystack_[1].value.as < hilti::Declarations > ()); yylhs.value.as < hilti::Declarations > ().push_back(yystack_[0].value.as < hilti::Declaration* > ()); }
#line 3828 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 172: // struct_fields: %empty
#line 719 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Declarations > () = Declarations{}; }
#line 3834 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 173: // struct_field: local_id ':' qtype opt_attributes ';'
#line 721 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                      { yylhs.value.as < hilti::Declaration* > () = builder->declarationField(std::move(yystack_[4].value.as < hilti::ID > ()), std::move(yystack_[2].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 3840 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 174: // enum_type: ENUM '{' enum_labels '}'
#line 723 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeEnum(std::move(yystack_[1].value.as < hilti::type::enum_::Labels > ()), __loc__); }
#line 3846 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 175: // enum_labels: enum_labels ',' enum_label
#line 725 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Labels > () = std::move(yystack_[2].value.as < hilti::type::enum_::Labels > ()); yylhs.value.as < hilti::type::enum_::Labels > ().push_back(std::move(yystack_[0].value.as < hilti::type::enum_::Label* > ())); }
#line 3852 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 176: // enum_labels: enum_labels ','
#line 726 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Labels > () = std::move(yystack_[1].value.as < hilti::type::enum_::Labels > ()); }
#line 3858 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 177: // enum_labels: enum_label
#line 727 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Labels > () = hilti::type::enum_::Labels(); yylhs.value.as < hilti::type::enum_::Labels > ().push_back(std::move(yystack_[0].value.as < hilti::type::enum_::Label* > ())); }
#line 3864 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 178: // enum_label: local_id
#line 730 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Label* > () = builder->typeEnumLabel(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 3870 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 179: // enum_label: local_id '=' "unsigned integer value"
#line 731 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::enum_::Label* > () = builder->typeEnumLabel(std::move(yystack_[2].value.as < hilti::ID > ()), yystack_[0].value.as < uint64_t > (), __loc__); }
#line 3876 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 180: // $@11: %empty
#line 735 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { _field_width = yystack_[1].value.as < uint64_t > (); }
#line 3882 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 181: // bitfield_type: BITFIELD '(' "unsigned integer value" ')' $@11 '{' opt_bitfield_bit_ranges '}'
#line 737 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeBitfield(yystack_[5].value.as < uint64_t > (), yystack_[1].value.as < hilti::type::bitfield::BitRanges > (), {}, __loc__); }
#line 3888 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 182: // opt_bitfield_bit_ranges: bitfield_bit_ranges
#line 741 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRanges > () = std::move(yystack_[0].value.as < hilti::type::bitfield::BitRanges > ()); }
#line 3894 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 183: // opt_bitfield_bit_ranges: %empty
#line 742 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRanges > () = hilti::type::bitfield::BitRanges(); }
#line 3900 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 184: // bitfield_bit_ranges: bitfield_bit_ranges bitfield_bit_range
#line 746 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRanges > () = std::move(yystack_[1].value.as < hilti::type::bitfield::BitRanges > ()); yylhs.value.as < hilti::type::bitfield::BitRanges > ().push_back(std::move(yystack_[0].value.as < hilti::type::bitfield::BitRange* > ()));  }
#line 3906 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 185: // bitfield_bit_ranges: bitfield_bit_range
#line 747 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRanges > () = hilti::type::bitfield::BitRanges(); yylhs.value.as < hilti::type::bitfield::BitRanges > ().push_back(std::move(yystack_[0].value.as < hilti::type::bitfield::BitRange* > ())); }
#line 3912 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 186: // bitfield_bit_range: local_id ':' "unsigned integer value" DOTDOT "unsigned integer value" opt_bitfield_range_value opt_attributes ';'
#line 751 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRange* > () = builder->typeBitfieldBitRange(std::move(yystack_[7].value.as < hilti::ID > ()), yystack_[5].value.as < uint64_t > (), yystack_[3].value.as < uint64_t > (), _field_width, std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), __loc__); }
#line 3918 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 187: // bitfield_bit_range: local_id ':' "unsigned integer value" opt_bitfield_range_value opt_attributes ';'
#line 753 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::type::bitfield::BitRange* > () = builder->typeBitfieldBitRange(std::move(yystack_[5].value.as < hilti::ID > ()), yystack_[3].value.as < uint64_t > (), yystack_[3].value.as < uint64_t > (), _field_width, std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), __loc__); }
#line 3924 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 188: // opt_bitfield_range_value: '=' expr
#line 756 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 3930 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 189: // opt_bitfield_range_value: %empty
#line 757 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = {}; }
#line 3936 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 190: // unit_type: UNIT opt_unit_params '{' opt_unit_items '}'
#line 764 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::UnqualifiedType* > () = builder->typeUnit(std::move(yystack_[3].value.as < hilti::declaration::Parameters > ()), std::move(yystack_[1].value.as < spicy::type::unit::Items > ()), {}, __loc__); }
#line 3942 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 191: // opt_unit_params: '(' opt_func_params ')'
#line 767 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Parameters > () = std::move(yystack_[1].value.as < hilti::declaration::Parameters > ()); }
#line 3948 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 192: // opt_unit_params: %empty
#line 768 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Parameters > () = hilti::type::function::Parameters{}; }
#line 3954 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 193: // unit_items: unit_items unit_item
#line 770 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Items > () = std::move(yystack_[1].value.as < spicy::type::unit::Items > ()); yylhs.value.as < spicy::type::unit::Items > ().push_back(std::move(yystack_[0].value.as < spicy::type::unit::Item* > ())); }
#line 3960 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 194: // unit_items: unit_item
#line 771 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Items > () = spicy::type::unit::Items(); yylhs.value.as < spicy::type::unit::Items > ().push_back(yystack_[0].value.as < spicy::type::unit::Item* > ()); }
#line 3966 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 195: // opt_unit_items: unit_items
#line 773 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Items > () = std::move(yystack_[0].value.as < spicy::type::unit::Items > ());}
#line 3972 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 196: // opt_unit_items: %empty
#line 774 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Items > () = spicy::type::unit::Items{}; }
#line 3978 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 197: // unit_item: unit_field
#line 777 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = std::move(yystack_[0].value.as < spicy::type::unit::Item* > ()); }
#line 3984 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 198: // unit_item: unit_variable
#line 778 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = std::move(yystack_[0].value.as < spicy::type::unit::Item* > ()); }
#line 3990 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 199: // unit_item: unit_wide_hook
#line 779 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = std::move(yystack_[0].value.as < spicy::type::unit::Item* > ()); }
#line 3996 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 200: // unit_item: unit_property
#line 780 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = std::move(yystack_[0].value.as < spicy::type::unit::Item* > ()); }
#line 4002 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 201: // unit_item: unit_sink
#line 781 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = std::move(yystack_[0].value.as < spicy::type::unit::Item* > ()); }
#line 4008 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 202: // unit_item: unit_switch
#line 782 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = std::move(yystack_[0].value.as < spicy::type::unit::Item* > ()); }
#line 4014 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 203: // unit_item: unit_block
#line 783 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = std::move(yystack_[0].value.as < spicy::type::unit::Item* > ()); }
#line 4020 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 204: // unit_variable: VAR local_id ':' qtype opt_init_expression opt_attributes ';'
#line 788 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemVariable(std::move(yystack_[5].value.as < hilti::ID > ()), std::move(yystack_[3].value.as < hilti::QualifiedType* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 4026 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 205: // unit_sink: SINK local_id opt_attributes ';'
#line 790 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemSink(std::move(yystack_[2].value.as < hilti::ID > ()), std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 4032 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 206: // unit_property: "property" opt_attributes ';'
#line 792 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemProperty(ID(std::move(yystack_[2].value.as < std::string > ())), std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), false, __loc__); }
#line 4038 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 207: // unit_property: "property" '=' expr opt_attributes ';'
#line 794 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemProperty(ID(std::move(yystack_[4].value.as < std::string > ())), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), false, __loc__); }
#line 4044 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 208: // unit_property: "property" '=' base_type_no_ref ';'
#line 795 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                        { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemProperty(ID(std::move(yystack_[3].value.as < std::string > ())), builder->expressionType(builder->qualifiedType(std::move(yystack_[1].value.as < hilti::UnqualifiedType* > ()), hilti::Constness::Mutable)), {}, false, __loc__); }
#line 4050 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 209: // unit_field_base_type: base_type
#line 797 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                   {   if ( yystack_[0].value.as < hilti::UnqualifiedType* > ()->isA<hilti::type::Vector>() )
                                                         error(yylhs.location, "vector<T> syntax is no longer supported for parsing sequences; use T[] instead.");
                                                     yylhs.value.as < hilti::QualifiedType* > () = builder->qualifiedType(std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()), hilti::Constness::Mutable);
                                                 }
#line 4059 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 210: // unit_field: opt_unit_field_id ':' opt_skip unit_field_base_type opt_attributes opt_unit_field_condition opt_unit_field_sinks opt_unit_item_hooks
#line 803 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField(std::move(yystack_[7].value.as < hilti::ID > ()), std::move(yystack_[4].value.as < hilti::QualifiedType* > ()), yystack_[5].value.as < bool > (), {}, std::move(yystack_[1].value.as < hilti::Expressions > ()), std::move(yystack_[3].value.as < hilti::AttributeSet* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < spicy::declaration::Hooks > ()), __loc__); }
#line 4065 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 211: // unit_field: opt_unit_field_id ':' opt_skip unit_field_base_type unit_field_repeat opt_attributes opt_unit_field_condition opt_unit_field_sinks opt_unit_item_hooks
#line 805 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 {   auto typeField = builder->typeUnitItemUnresolvedField({}, std::move(yystack_[5].value.as < hilti::QualifiedType* > ()), false, {}, {}, {}, {}, {}, toMeta(yystack_[5].location));
                                                     yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField(std::move(yystack_[8].value.as < hilti::ID > ()), std::move(typeField), yystack_[6].value.as < bool > (), {}, std::move(yystack_[4].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), std::move(yystack_[3].value.as < hilti::AttributeSet* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < spicy::declaration::Hooks > ()), __loc__);
                                                 }
#line 4073 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 212: // unit_field: opt_unit_field_id ':' opt_skip unit_field_ctor opt_unit_field_repeat opt_attributes opt_unit_field_condition opt_unit_field_sinks opt_unit_item_hooks
#line 810 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField(std::move(yystack_[8].value.as < hilti::ID > ()), std::move(yystack_[5].value.as < hilti::Ctor* > ()), yystack_[6].value.as < bool > (), {}, std::move(yystack_[4].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), std::move(yystack_[3].value.as < hilti::AttributeSet* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < spicy::declaration::Hooks > ()), __loc__); }
#line 4079 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 213: // unit_field: opt_unit_field_id ':' opt_skip scoped_id opt_unit_field_args opt_attributes opt_unit_field_condition opt_unit_field_sinks opt_unit_item_hooks
#line 813 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField(std::move(yystack_[8].value.as < hilti::ID > ()), std::move(yystack_[5].value.as < hilti::ID > ()), yystack_[6].value.as < bool > (), std::move(yystack_[4].value.as < hilti::Expressions > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), std::move(yystack_[3].value.as < hilti::AttributeSet* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < spicy::declaration::Hooks > ()), __loc__); }
#line 4085 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 214: // unit_field: opt_unit_field_id ':' opt_skip scoped_id_in_container unit_field_repeat opt_attributes opt_unit_field_condition opt_unit_field_sinks opt_unit_item_hooks
#line 815 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField(std::move(yystack_[8].value.as < hilti::ID > ()), yystack_[5].value.as < spicy::type::unit::Item* > (), yystack_[6].value.as < bool > (), {}, std::move(yystack_[4].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), std::move(yystack_[3].value.as < hilti::AttributeSet* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < spicy::declaration::Hooks > ()), __loc__); }
#line 4091 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 215: // unit_field: opt_unit_field_id ':' opt_skip '(' unit_field_in_container ')' opt_unit_field_repeat opt_attributes opt_unit_field_condition opt_unit_field_sinks opt_unit_item_hooks
#line 817 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField(std::move(yystack_[10].value.as < hilti::ID > ()), std::move(yystack_[6].value.as < spicy::type::unit::Item* > ()), yystack_[8].value.as < bool > (), {}, std::move(yystack_[4].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), std::move(yystack_[3].value.as < hilti::AttributeSet* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < spicy::declaration::Hooks > ()), __loc__); }
#line 4097 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 216: // const_sint: "unsigned integer value"
#line 819 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < int64_t > () = check_int64_range(yystack_[0].value.as < uint64_t > (), true, __loc__); }
#line 4103 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 217: // const_sint: '+' "unsigned integer value"
#line 820 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < int64_t > () = check_int64_range(yystack_[0].value.as < uint64_t > (), true, __loc__); }
#line 4109 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 218: // const_sint: '-' "unsigned integer value"
#line 821 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < int64_t > () = -check_int64_range(yystack_[0].value.as < uint64_t > (), false, __loc__); }
#line 4115 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 219: // const_uint: "unsigned integer value"
#line 823 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < uint64_t > () = yystack_[0].value.as < uint64_t > (); }
#line 4121 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 220: // const_uint: '+' "unsigned integer value"
#line 824 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < uint64_t > () = yystack_[0].value.as < uint64_t > (); }
#line 4127 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 221: // unit_field_ctor: ctor
#line 827 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 4133 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 222: // unit_field_ctor: UINT8 '(' const_uint ')'
#line 828 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorUnsignedInteger(yystack_[1].value.as < uint64_t > (), 8, __loc__); }
#line 4139 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 223: // unit_field_ctor: UINT16 '(' const_uint ')'
#line 829 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorUnsignedInteger(yystack_[1].value.as < uint64_t > (), 16, __loc__); }
#line 4145 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 224: // unit_field_ctor: UINT32 '(' const_uint ')'
#line 830 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorUnsignedInteger(yystack_[1].value.as < uint64_t > (), 32, __loc__); }
#line 4151 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 225: // unit_field_ctor: UINT64 '(' const_uint ')'
#line 831 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorUnsignedInteger(yystack_[1].value.as < uint64_t > (), 64, __loc__); }
#line 4157 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 226: // unit_field_ctor: INT8 '(' const_sint ')'
#line 832 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorSignedInteger(yystack_[1].value.as < int64_t > (), 8, __loc__); }
#line 4163 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 227: // unit_field_ctor: INT16 '(' const_sint ')'
#line 833 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorSignedInteger(yystack_[1].value.as < int64_t > (), 16, __loc__); }
#line 4169 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 228: // unit_field_ctor: INT32 '(' const_sint ')'
#line 834 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorSignedInteger(yystack_[1].value.as < int64_t > (), 32, __loc__); }
#line 4175 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 229: // unit_field_ctor: INT64 '(' const_sint ')'
#line 835 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorSignedInteger(yystack_[1].value.as < int64_t > (), 64, __loc__); }
#line 4181 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 230: // unit_field_in_container: unit_field_ctor opt_unit_field_args opt_attributes
#line 839 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField({}, std::move(yystack_[2].value.as < hilti::Ctor* > ()), false, std::move(yystack_[1].value.as < hilti::Expressions > ()), {}, {}, std::move(yystack_[0].value.as < hilti::AttributeSet* > ()), {}, {}, __loc__); }
#line 4187 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 231: // unit_field_in_container: scoped_id opt_unit_field_args opt_attributes
#line 841 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField({}, std::move(yystack_[2].value.as < hilti::ID > ()), false, std::move(yystack_[1].value.as < hilti::Expressions > ()), {}, std::move(yystack_[0].value.as < hilti::AttributeSet* > ()), {}, {}, __loc__); }
#line 4193 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 232: // unit_field_in_container: scoped_id_in_container unit_field_repeat opt_attributes
#line 843 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField({}, yystack_[2].value.as < spicy::type::unit::Item* > (), false, {}, std::move(yystack_[1].value.as < hilti::Expression* > ()), {}, std::move(yystack_[0].value.as < hilti::AttributeSet* > ()), {}, {}, __loc__); }
#line 4199 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 233: // unit_field_in_container: unit_field_base_type opt_unit_field_args opt_attributes
#line 845 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField({}, yystack_[2].value.as < hilti::QualifiedType* > (), false, std::move(yystack_[1].value.as < hilti::Expressions > ()), {}, std::move(yystack_[0].value.as < hilti::AttributeSet* > ()), {}, {}, __loc__); }
#line 4205 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 234: // unit_field_in_container: unit_field_base_type unit_field_repeat opt_unit_field_args opt_attributes
#line 847 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 {   auto typeField = builder->typeUnitItemUnresolvedField({}, std::move(yystack_[3].value.as < hilti::QualifiedType* > ()), false, {}, {}, {}, {}, {}, toMeta(yystack_[3].location));
                                                     yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField({}, std::move(typeField), false, {}, std::move(yystack_[2].value.as < hilti::Expression* > ()), {}, std::move(yystack_[0].value.as < hilti::AttributeSet* > ()), {}, {}, __loc__);
                                                 }
#line 4213 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 235: // scoped_id_in_container: scoped_id opt_unit_field_args
#line 852 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnresolvedField({}, std::move(yystack_[1].value.as < hilti::ID > ()), false, std::move(yystack_[0].value.as < hilti::Expressions > ()), {}, {}, {}, {}, __loc__); }
#line 4219 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 236: // unit_wide_hook: ON unit_hook_id unit_hook
#line 854 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemUnitHook(std::move(yystack_[1].value.as < hilti::ID > ()), std::move(yystack_[0].value.as < spicy::declaration::Hook* > ()), __loc__); }
#line 4225 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 237: // opt_unit_field_id: local_id
#line 857 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = std::move(yystack_[0].value.as < hilti::ID > ()); }
#line 4231 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 238: // opt_unit_field_id: %empty
#line 858 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ID > () = {}; }
#line 4237 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 239: // $@12: %empty
#line 861 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
              { driver->enableNewKeywordMode(); }
#line 4243 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 240: // opt_skip: $@12 opt_skip_
#line 863 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
              { driver->disableNewKeywordMode(); yylhs.value.as < bool > () = yystack_[0].value.as < bool > (); }
#line 4249 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 241: // opt_skip_: SKIP
#line 866 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < bool > () = true; }
#line 4255 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 242: // opt_skip_: %empty
#line 867 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < bool > () = false; }
#line 4261 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 243: // opt_unit_field_args: '(' opt_exprs ')'
#line 870 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = std::move(yystack_[1].value.as < hilti::Expressions > ()); }
#line 4267 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 244: // opt_unit_field_args: %empty
#line 871 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions(); }
#line 4273 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 245: // unit_field_repeat: '[' expr ']'
#line 874 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[1].value.as < hilti::Expression* > ()); }
#line 4279 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 246: // unit_field_repeat: '[' ']'
#line 875 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->null(); }
#line 4285 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 247: // opt_unit_field_repeat: unit_field_repeat
#line 878 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4291 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 248: // opt_unit_field_repeat: %empty
#line 879 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = {}; }
#line 4297 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 249: // opt_unit_field_condition: IF '(' expr ')'
#line 882 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[1].value.as < hilti::Expression* > ()); }
#line 4303 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 250: // opt_unit_field_condition: %empty
#line 883 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = {}; }
#line 4309 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 251: // opt_unit_field_sinks: ARROW exprs
#line 886 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = std::move(yystack_[0].value.as < hilti::Expressions > ()); }
#line 4315 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 252: // opt_unit_field_sinks: %empty
#line 887 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions(); }
#line 4321 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 253: // opt_unit_item_hooks: unit_hooks
#line 890 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::declaration::Hooks > () = std::move(yystack_[0].value.as < spicy::declaration::Hooks > ()); }
#line 4327 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 254: // opt_unit_item_hooks: ';'
#line 891 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::declaration::Hooks > () = spicy::declaration::Hooks(); }
#line 4333 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 255: // unit_hooks: unit_hooks unit_hook
#line 893 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::declaration::Hooks > () = std::move(yystack_[1].value.as < spicy::declaration::Hooks > ()); yylhs.value.as < spicy::declaration::Hooks > ().push_back(std::move(yystack_[0].value.as < spicy::declaration::Hook* > ())); }
#line 4339 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 256: // unit_hooks: unit_hook
#line 894 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::declaration::Hooks > () = spicy::declaration::Hooks{std::move(yystack_[0].value.as < spicy::declaration::Hook* > ())}; }
#line 4345 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 257: // unit_hook: opt_unit_hook_params opt_unit_hook_attributes braced_block
#line 897 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::declaration::Hook* > () = builder->declarationHook(std::move(yystack_[2].value.as < hilti::declaration::Parameters > ()), std::move(yystack_[0].value.as < hilti::Statement* > ()), std::move(yystack_[1].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 4351 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 258: // opt_unit_hook_params: '(' opt_func_params ')'
#line 900 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Parameters > () = std::move(yystack_[1].value.as < hilti::declaration::Parameters > ()); }
#line 4357 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 259: // opt_unit_hook_params: %empty
#line 901 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::declaration::Parameters > () = hilti::type::function::Parameters{}; }
#line 4363 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 260: // opt_unit_hook_attributes: opt_unit_hook_attributes unit_hook_attribute
#line 905 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yystack_[1].value.as < hilti::AttributeSet* > ()->add(builder->context(), yystack_[0].value.as < hilti::Attribute* > ()); yylhs.value.as < hilti::AttributeSet* > () = std::move(yystack_[1].value.as < hilti::AttributeSet* > ()); }
#line 4369 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 261: // opt_unit_hook_attributes: %empty
#line 906 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::AttributeSet* > () = builder->attributeSet({}, __loc__); }
#line 4375 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 262: // $@13: %empty
#line 908 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
              { driver->enableHookIDMode(); }
#line 4381 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 263: // $@14: %empty
#line 910 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
              { driver->disableHookIDMode(); }
#line 4387 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 264: // unit_hook_id: $@13 "hook identifier" $@14
#line 910 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                               { yylhs.value.as < hilti::ID > () = hilti::ID(hilti::util::replace(yystack_[1].value.as < std::string > (), "%", "0x25_")); }
#line 4393 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 265: // unit_hook_attribute: FOREACH
#line 913 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Attribute* > () = builder->attribute(hilti::Attribute::Kind::Foreach, __loc__); }
#line 4399 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 266: // unit_hook_attribute: PRIORITY '=' expr
#line 914 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Attribute* > () = builder->attribute(hilti::Attribute::Kind::Priority, std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 4405 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 267: // unit_hook_attribute: "property"
#line 915 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { if ( auto attr_kind = hilti::Attribute::tagToKind(yystack_[0].value.as < std::string > ()) )
                                                     yylhs.value.as < hilti::Attribute* > () = builder->attribute(*attr_kind, __loc__);
                                                   else
                                                     hilti::logger().error(hilti::util::fmt("invalid attribute '%s'", yystack_[0].value.as < std::string > ()), __loc__.location());
                                                 }
#line 4415 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 268: // unit_hook_attribute: "attribute"
#line 920 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { if ( auto attr_kind = hilti::Attribute::tagToKind(yystack_[0].value.as < std::string > ()) )
                                                     yylhs.value.as < hilti::Attribute* > () = builder->attribute(*attr_kind, __loc__);
                                                   else
                                                     hilti::logger().error(hilti::util::fmt("invalid attribute '%s'", yystack_[0].value.as < std::string > ()), __loc__.location());
                                                 }
#line 4425 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 269: // unit_switch: SWITCH opt_unit_switch_expr '{' unit_switch_cases '}' opt_attributes opt_unit_field_condition ';'
#line 927 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemSwitch(std::move(yystack_[6].value.as < hilti::Expression* > ()), std::move(yystack_[4].value.as < spicy::type::unit::item::switch_::Cases > ()), std::move(yystack_[1].value.as < hilti::Expression* > ()), {}, std::move(yystack_[2].value.as < hilti::AttributeSet* > ()), __loc__); }
#line 4431 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 270: // opt_unit_switch_expr: '(' expr ')'
#line 929 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[1].value.as < hilti::Expression* > ()); }
#line 4437 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 271: // opt_unit_switch_expr: %empty
#line 930 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = {}; }
#line 4443 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 272: // unit_switch_cases: unit_switch_cases unit_switch_case
#line 934 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Cases > () = std::move(yystack_[1].value.as < spicy::type::unit::item::switch_::Cases > ()); yylhs.value.as < spicy::type::unit::item::switch_::Cases > ().push_back(std::move(yystack_[0].value.as < spicy::type::unit::item::switch_::Case* > ())); }
#line 4449 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 273: // unit_switch_cases: unit_switch_case
#line 935 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Cases > () = spicy::type::unit::item::switch_::Cases(); yylhs.value.as < spicy::type::unit::item::switch_::Cases > ().push_back(std::move(yystack_[0].value.as < spicy::type::unit::item::switch_::Case* > ())); }
#line 4455 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 274: // unit_switch_case: exprs ARROW '{' unit_items '}'
#line 938 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Case* > () = builder->typeUnitItemSwitchCase(yystack_[4].value.as < hilti::Expressions > (), yystack_[1].value.as < spicy::type::unit::Items > (), __loc__); }
#line 4461 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 275: // unit_switch_case: '*' ARROW '{' unit_items '}'
#line 939 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Case* > () = builder->typeUnitItemSwitchCase(yystack_[1].value.as < spicy::type::unit::Items > (), __loc__); }
#line 4467 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 276: // unit_switch_case: exprs ARROW unit_item
#line 940 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Case* > () = builder->typeUnitItemSwitchCase(yystack_[2].value.as < hilti::Expressions > (), {yystack_[0].value.as < spicy::type::unit::Item* > ()}, __loc__); }
#line 4473 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 277: // unit_switch_case: '*' ARROW unit_item
#line 941 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Case* > () = builder->typeUnitItemSwitchCase(type::unit::Items{yystack_[0].value.as < spicy::type::unit::Item* > ()}, __loc__); }
#line 4479 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 278: // unit_switch_case: ARROW unit_field
#line 942 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Case* > () = builder->typeUnitItemSwitchCase(yystack_[0].value.as < spicy::type::unit::Item* > (), __loc__); }
#line 4485 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 279: // unit_switch_case: ARROW unit_switch
#line 943 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::item::switch_::Case* > () = builder->typeUnitItemSwitchCase(yystack_[0].value.as < spicy::type::unit::Item* > (), __loc__); }
#line 4491 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 280: // opt_unit_block_else_items: ELSE '{' opt_unit_items '}'
#line 946 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Items > () = std::move(yystack_[1].value.as < spicy::type::unit::Items > ()); }
#line 4497 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 281: // opt_unit_block_else_items: %empty
#line 947 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Items > () = {}; }
#line 4503 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 282: // unit_block: IF '(' expr ')' '{' opt_unit_items '}' opt_unit_block_else_items ';'
#line 950 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < spicy::type::unit::Item* > () = builder->typeUnitItemBlock(std::move(yystack_[6].value.as < hilti::Expression* > ()), std::move(yystack_[3].value.as < spicy::type::unit::Items > ()), std::move(yystack_[1].value.as < spicy::type::unit::Items > ()), {}, __loc__); }
#line 4509 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 283: // $@15: %empty
#line 957 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
              { driver->enableExpressionMode(); }
#line 4515 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 284: // $@16: %empty
#line 959 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
              { driver->disableExpressionMode(); }
#line 4521 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 285: // expr: $@15 expr_0 $@16
#line 960 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[1].value.as < hilti::Expression* > ()); }
#line 4527 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 286: // expr_no_or_error: expr_1
#line 964 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4533 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 287: // opt_exprs: exprs
#line 966 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = std::move(yystack_[0].value.as < hilti::Expressions > ()); }
#line 4539 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 288: // opt_exprs: %empty
#line 967 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = Expressions(); }
#line 4545 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 289: // exprs: exprs ',' expr
#line 969 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = std::move(yystack_[2].value.as < hilti::Expressions > ()); yylhs.value.as < hilti::Expressions > ().push_back(std::move(yystack_[0].value.as < hilti::Expression* > ())); }
#line 4551 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 290: // exprs: expr
#line 970 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = Expressions{std::move(yystack_[0].value.as < hilti::Expression* > ())}; }
#line 4557 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 291: // expr_0: expr_1
#line 972 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4563 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 292: // expr_0: expr_1 ':' expr
#line 973 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionConditionTest(std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 4569 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 293: // expr_1: expr_2 '=' expr_1
#line 976 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionAssign(std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 4575 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 294: // expr_1: expr_2 MINUSASSIGN expr_1
#line 977 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::DifferenceAssign, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4581 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 295: // expr_1: expr_2 PLUSASSIGN expr_1
#line 978 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::SumAssign, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4587 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 296: // expr_1: expr_2 TIMESASSIGN expr_1
#line 979 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::MultipleAssign, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4593 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 297: // expr_1: expr_2 DIVIDEASSIGN expr_1
#line 980 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::DivisionAssign, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4599 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 298: // expr_1: expr_2 '?' expr_1 ':' expr
#line 981 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                   { yylhs.value.as < hilti::Expression* > () = builder->expressionTernary(std::move(yystack_[4].value.as < hilti::Expression* > ()), std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 4605 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 299: // expr_1: expr_2
#line 982 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4611 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 300: // expr_2: expr_2 OR expr_3
#line 984 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionLogicalOr(std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 4617 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 301: // expr_2: expr_3
#line 985 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4623 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 302: // expr_3: expr_3 AND expr_4
#line 987 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionLogicalAnd(std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 4629 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 303: // expr_3: expr_4
#line 988 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4635 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 304: // expr_4: expr_4 EQ expr_5
#line 990 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Equal, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4641 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 305: // expr_4: expr_4 NEQ expr_5
#line 991 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Unequal, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4647 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 306: // expr_4: expr_5
#line 992 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4653 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 307: // expr_5: expr_5 '<' expr_6
#line 994 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Lower, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4659 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 308: // expr_5: expr_5 '>' expr_6
#line 995 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Greater, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4665 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 309: // expr_5: expr_5 GEQ expr_6
#line 996 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::GreaterEqual, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4671 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 310: // expr_5: expr_5 LEQ expr_6
#line 997 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::LowerEqual, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4677 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 311: // expr_5: expr_6
#line 998 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4683 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 312: // expr_6: expr_6 '|' expr_7
#line 1000 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::BitOr, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4689 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 313: // expr_6: expr_7
#line 1001 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4695 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 314: // expr_7: expr_7 '^' expr_8
#line 1003 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::BitXor, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4701 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 315: // expr_7: expr_8
#line 1004 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4707 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 316: // expr_8: expr_8 '&' expr_9
#line 1006 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::BitAnd, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4713 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 317: // expr_8: expr_9
#line 1007 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4719 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 318: // expr_9: expr_9 SHIFTLEFT expr_a
#line 1009 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::ShiftLeft, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4725 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 319: // expr_9: expr_9 SHIFTRIGHT expr_a
#line 1010 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::ShiftRight, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4731 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 320: // expr_9: expr_a
#line 1011 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4737 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 321: // expr_a: expr_a '+' expr_b
#line 1013 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Sum, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4743 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 322: // expr_a: expr_a '-' expr_b
#line 1014 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Difference, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4749 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 323: // expr_a: expr_b
#line 1015 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4755 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 324: // expr_b: expr_b '%' expr_c
#line 1017 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Modulo, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4761 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 325: // expr_b: expr_b '*' expr_c
#line 1018 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Multiple, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4767 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 326: // expr_b: expr_b '/' expr_c
#line 1019 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Division, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4773 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 327: // expr_b: expr_b POW expr_c
#line 1020 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Power, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4779 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 328: // expr_b: expr_c
#line 1021 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4785 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 329: // expr_c: '!' expr_c
#line 1023 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionLogicalNot(std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__); }
#line 4791 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 330: // expr_c: '*' expr_c
#line 1024 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Deref, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4797 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 331: // expr_c: '~' expr_c
#line 1025 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Negate, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4803 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 332: // expr_c: '|' expr_c '|'
#line 1026 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Size, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4809 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 333: // expr_c: MINUSMINUS expr_c
#line 1027 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::DecrPrefix, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4815 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 334: // expr_c: PLUSPLUS expr_c
#line 1028 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::IncrPrefix, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4821 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 335: // expr_c: expr_d
#line 1029 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4827 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 336: // expr_d: expr_d '(' opt_exprs ')'
#line 1031 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Call, {std::move(yystack_[3].value.as < hilti::Expression* > ()), builder->expressionCtor(builder->ctorTuple(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__))}, __loc__); }
#line 4833 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 337: // expr_d: expr_d '.' member_expr
#line 1032 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Member, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4839 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 338: // expr_d: expr_d '.' member_expr '(' opt_exprs ')'
#line 1033 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                         { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::MemberCall, {std::move(yystack_[5].value.as < hilti::Expression* > ()), std::move(yystack_[3].value.as < hilti::Expression* > ()), builder->expressionCtor(builder->ctorTuple(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__))}, __loc__); }
#line 4845 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 339: // expr_d: expr_d '[' expr ']'
#line 1034 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Index, {std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4851 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 340: // expr_d: expr_d HASATTR member_expr
#line 1035 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::HasMember, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4857 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 341: // expr_d: expr_d IN expr_d
#line 1036 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4863 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 342: // expr_d: expr_d NOT_IN expr_d
#line 1037 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionLogicalNot(builder->expressionUnresolvedOperator(hilti::operator_::Kind::In, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__)); }
#line 4869 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 343: // expr_d: expr_d MINUSMINUS
#line 1038 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::DecrPostfix, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4875 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 344: // expr_d: expr_d PLUSPLUS
#line 1039 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::IncrPostfix, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4881 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 345: // expr_d: expr_d TRYATTR member_expr
#line 1040 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::TryMember, {std::move(yystack_[2].value.as < hilti::Expression* > ()), std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4887 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 346: // expr_d: expr_e
#line 1041 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4893 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 347: // expr_e: CAST type_param_begin qtype type_param_end '(' expr ')'
#line 1043 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Cast, {std::move(yystack_[1].value.as < hilti::Expression* > ()), builder->expressionType(std::move(yystack_[4].value.as < hilti::QualifiedType* > ()))}, __loc__); }
#line 4899 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 348: // expr_e: PACK tuple_expr
#line 1044 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Pack, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4905 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 349: // expr_e: UNPACK type_param_begin qtype type_param_end tuple_expr
#line 1045 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                                          { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Unpack, {builder->expressionType(std::move(yystack_[2].value.as < hilti::QualifiedType* > ())), std::move(yystack_[0].value.as < hilti::Expression* > ()), builder->expressionCtor(builder->ctorBool(true), __loc__)}, __loc__); }
#line 4911 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 350: // expr_e: BEGIN_ '(' expr ')'
#line 1046 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Begin, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4917 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 351: // expr_e: END_ '(' expr ')'
#line 1047 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::End, {std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 4923 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 352: // expr_e: NEW base_type_no_ref
#line 1048 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::New, {builder->expressionCtor(builder->ctorDefault(std::move(yystack_[0].value.as < hilti::UnqualifiedType* > ()))), builder->expressionCtor(builder->ctorTuple({}, __loc__))}, __loc__); }
#line 4929 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 353: // expr_e: NEW ctor
#line 1049 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::New, {builder->expressionCtor(std::move(yystack_[0].value.as < hilti::Ctor* > ()), __loc__),             builder->expressionCtor(builder->ctorTuple({}, __loc__))}, __loc__); }
#line 4935 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 354: // expr_e: NEW scoped_id
#line 1050 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::New, {builder->expressionName(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__), builder->expressionCtor(builder->ctorTuple({}, __loc__))}, __loc__); }
#line 4941 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 355: // expr_e: NEW scoped_id '(' opt_exprs ')'
#line 1051 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::New, {builder->expressionName(std::move(yystack_[3].value.as < hilti::ID > ()), __loc__), builder->expressionCtor(builder->ctorTuple(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__))}, __loc__); }
#line 4947 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 356: // expr_e: expr_f
#line 1052 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4953 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 357: // expr_f: ctor
#line 1054 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionCtor(std::move(yystack_[0].value.as < hilti::Ctor* > ()), __loc__); }
#line 4959 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 358: // expr_f: ctor_expr
#line 1055 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4965 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 359: // expr_f: '-' expr_f
#line 1056 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::SignNeg, {std::move(yystack_[0].value.as < hilti::Expression* > ())}, __loc__); }
#line 4971 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 360: // expr_f: '[' expr FOR local_id IN expr ']'
#line 1058 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionListComprehension(std::move(yystack_[1].value.as < hilti::Expression* > ()), std::move(yystack_[5].value.as < hilti::Expression* > ()), std::move(yystack_[3].value.as < hilti::ID > ()), {},  __loc__); }
#line 4977 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 361: // expr_f: '[' expr FOR local_id IN expr IF expr ']'
#line 1060 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionListComprehension(std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[7].value.as < hilti::Expression* > ()), std::move(yystack_[5].value.as < hilti::ID > ()), std::move(yystack_[1].value.as < hilti::Expression* > ()),  __loc__); }
#line 4983 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 362: // expr_f: expr_g
#line 1061 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 4989 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 363: // expr_g: '(' expr ')'
#line 1063 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionGrouping(std::move(yystack_[1].value.as < hilti::Expression* > ())); }
#line 4995 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 364: // expr_g: scoped_id
#line 1064 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionName(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 5001 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 365: // expr_g: DOLLARDOLLAR
#line 1065 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionName(std::move("__dd"), __loc__);}
#line 5007 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 366: // expr_g: "$<N>"
#line 1066 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { // $N -> $@[N] (with $@ being available internally only, not exposed to users)
                                                   auto captures = builder->expressionKeyword(hilti::expression::keyword::Kind::Captures, builder->qualifiedType(builder->typeName("~hilti::Captures"), hilti::Constness::Mutable), __loc__);
                                                   auto index = builder->expressionCtor(builder->ctorUnsignedInteger(yystack_[0].value.as < uint64_t > (), 64, __loc__), __loc__);
                                                   yylhs.value.as < hilti::Expression* > () = builder->expressionUnresolvedOperator(hilti::operator_::Kind::Index, {std::move(captures), std::move(index)}, __loc__);
                                                 }
#line 5017 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 367: // member_expr: local_id
#line 1072 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionMember(std::move(yystack_[0].value.as < hilti::ID > ()), __loc__); }
#line 5023 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 368: // member_expr: "stream"
#line 1073 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionMember(ID("stream"), __loc__); }
#line 5029 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 369: // ctor: "address value"
#line 1077 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorAddress(hilti::rt::Address(yystack_[0].value.as < std::string > ()), __loc__); }
#line 5035 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 370: // ctor: "address value" '/' "unsigned integer value"
#line 1078 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorNetwork(hilti::rt::Network(yystack_[2].value.as < std::string > (), yystack_[0].value.as < uint64_t > ()), __loc__); }
#line 5041 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 371: // ctor: "bool value"
#line 1079 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorBool(yystack_[0].value.as < bool > (), __loc__); }
#line 5047 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 372: // ctor: "bytes value"
#line 1080 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorBytes(std::move(yystack_[0].value.as < std::string > ()), __loc__); }
#line 5053 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 373: // ctor: "error value"
#line 1081 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorError(std::move(yystack_[0].value.as < std::string > ()), __loc__); }
#line 5059 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 374: // ctor: "port value"
#line 1082 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorPort(hilti::rt::Port(yystack_[0].value.as < std::string > ()), __loc__); }
#line 5065 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 375: // ctor: "null value"
#line 1083 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorNull(__loc__); }
#line 5071 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 376: // ctor: "string value"
#line 1084 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorString(yystack_[0].value.as < std::string > (), false, __loc__); }
#line 5077 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 377: // ctor: "unsigned integer value"
#line 1085 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorUnsignedInteger(yystack_[0].value.as < uint64_t > (), 64, __loc__); }
#line 5083 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 378: // ctor: '+' "unsigned integer value"
#line 1086 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { if ( yystack_[0].value.as < uint64_t > () > static_cast<uint64_t>(std::numeric_limits<int64_t>::max()) )
                                                    hilti::logger().error("integer constant out of range", __loc__.location());

                                                   yylhs.value.as < hilti::Ctor* > () = builder->ctorSignedInteger(yystack_[0].value.as < uint64_t > (), 64, __loc__);
                                                 }
#line 5093 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 379: // ctor: "real value"
#line 1091 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorReal(yystack_[0].value.as < double > (), __loc__); }
#line 5099 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 380: // ctor: '+' "real value"
#line 1092 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorReal(yystack_[0].value.as < double > (), __loc__);; }
#line 5105 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 381: // ctor: OPTIONAL '(' expr ')'
#line 1097 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorOptional(std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 5111 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 382: // ctor: RESULT '(' expr ')'
#line 1098 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorResult(std::move(yystack_[1].value.as < hilti::Expression* > ()), __loc__); }
#line 5117 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 383: // ctor: list
#line 1100 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 5123 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 384: // ctor: map
#line 1101 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 5129 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 385: // ctor: regexp
#line 1102 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 5135 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 386: // ctor: set
#line 1103 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 5141 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 387: // ctor: struct_
#line 1104 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 5147 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 388: // ctor: tuple
#line 1105 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 5153 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 389: // ctor: vector
#line 1106 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = std::move(yystack_[0].value.as < hilti::Ctor* > ()); }
#line 5159 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 390: // ctor_expr: INTERVAL '(' expr ')'
#line 1109 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("interval", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5165 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 391: // ctor_expr: INTERVAL_NS '(' expr ')'
#line 1110 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("interval_ns", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5171 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 392: // ctor_expr: TIME '(' expr ')'
#line 1111 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("time", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5177 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 393: // ctor_expr: TIME_NS '(' expr ')'
#line 1112 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("time_ns", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5183 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 394: // ctor_expr: "stream" '(' expr ')'
#line 1113 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("stream", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5189 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 395: // ctor_expr: INT8 '(' expr ')'
#line 1114 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("int8", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5195 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 396: // ctor_expr: INT16 '(' expr ')'
#line 1115 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("int16", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5201 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 397: // ctor_expr: INT32 '(' expr ')'
#line 1116 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("int32", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5207 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 398: // ctor_expr: INT64 '(' expr ')'
#line 1117 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("int64", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5213 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 399: // ctor_expr: UINT8 '(' expr ')'
#line 1118 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("uint8", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5219 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 400: // ctor_expr: UINT16 '(' expr ')'
#line 1119 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("uint16", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5225 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 401: // ctor_expr: UINT32 '(' expr ')'
#line 1120 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("uint32", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5231 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 402: // ctor_expr: UINT64 '(' expr ')'
#line 1121 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("uint64", { std::move(yystack_[1].value.as < hilti::Expression* > ()) }, __loc__); }
#line 5237 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 403: // ctor_expr: PORT '(' expr ',' expr ')'
#line 1122 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->namedCtor("port", {std::move(yystack_[3].value.as < hilti::Expression* > ()), std::move(yystack_[1].value.as < hilti::Expression* > ())}, __loc__); }
#line 5243 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 404: // tuple: '(' opt_tuple_elems1 ')'
#line 1125 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorTuple(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 5249 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 405: // tuple: TUPLE '(' opt_exprs ')'
#line 1126 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorTuple(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 5255 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 406: // opt_tuple_elems1: tuple_elem
#line 1129 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[0].value.as < hilti::Expression* > ())}; }
#line 5261 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 407: // opt_tuple_elems1: tuple_elem ',' opt_tuple_elems2
#line 1130 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[2].value.as < hilti::Expression* > ())}; yylhs.value.as < hilti::Expressions > ().insert(yylhs.value.as < hilti::Expressions > ().end(), yystack_[0].value.as < hilti::Expressions > ().begin(), yystack_[0].value.as < hilti::Expressions > ().end()); }
#line 5267 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 408: // opt_tuple_elems1: %empty
#line 1131 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions(); }
#line 5273 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 409: // opt_tuple_elems2: tuple_elem
#line 1134 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[0].value.as < hilti::Expression* > ())}; }
#line 5279 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 410: // opt_tuple_elems2: tuple_elem ',' opt_tuple_elems2
#line 1135 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[2].value.as < hilti::Expression* > ())}; yylhs.value.as < hilti::Expressions > ().insert(yylhs.value.as < hilti::Expressions > ().end(), yystack_[0].value.as < hilti::Expressions > ().begin(), yystack_[0].value.as < hilti::Expressions > ().end()); }
#line 5285 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 411: // opt_tuple_elems2: tuple_elem
#line 1136 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions{std::move(yystack_[0].value.as < hilti::Expression* > ())}; }
#line 5291 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 412: // opt_tuple_elems2: %empty
#line 1137 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expressions > () = hilti::Expressions(); }
#line 5297 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 413: // tuple_elem: expr
#line 1140 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = std::move(yystack_[0].value.as < hilti::Expression* > ()); }
#line 5303 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 414: // tuple_elem: NONE
#line 1141 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionCtor(builder->ctorNull(__loc__), __loc__); }
#line 5309 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 415: // tuple_expr: tuple
#line 1143 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Expression* > () = builder->expressionCtor(std::move(yystack_[0].value.as < hilti::Ctor* > ()), __loc__); }
#line 5315 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 416: // list: '[' opt_exprs ']'
#line 1145 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorList(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 5321 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 417: // list: LIST '(' opt_exprs ')'
#line 1146 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorList(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 5327 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 418: // list: LIST type_param_begin qtype type_param_end '(' opt_tuple_elems1 ')'
#line 1148 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorList(std::move(yystack_[4].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 5333 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 419: // vector: VECTOR '(' opt_exprs ')'
#line 1150 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorVector(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 5339 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 420: // vector: VECTOR type_param_begin qtype type_param_end '(' opt_tuple_elems1 ')'
#line 1152 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorVector(std::move(yystack_[4].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 5345 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 421: // set: SET '(' opt_exprs ')'
#line 1154 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorSet(std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 5351 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 422: // set: SET type_param_begin qtype type_param_end '(' opt_tuple_elems1 ')'
#line 1156 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorSet(std::move(yystack_[4].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::Expressions > ()), __loc__); }
#line 5357 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 423: // map: MAP '(' opt_map_elems ')'
#line 1158 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorMap(std::move(yystack_[1].value.as < hilti::ctor::map::Elements > ()), __loc__); }
#line 5363 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 424: // map: MAP type_param_begin qtype ',' qtype type_param_end '(' opt_map_elems ')'
#line 1160 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorMap(std::move(yystack_[6].value.as < hilti::QualifiedType* > ()), std::move(yystack_[4].value.as < hilti::QualifiedType* > ()), std::move(yystack_[1].value.as < hilti::ctor::map::Elements > ()), __loc__); }
#line 5369 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 425: // struct_: '[' struct_elems ']'
#line 1162 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorStruct(std::move(yystack_[1].value.as < hilti::ctor::struct_::Fields > ()), __loc__); }
#line 5375 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 426: // struct_elems: struct_elems ',' struct_elem
#line 1165 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::struct_::Fields > () = std::move(yystack_[2].value.as < hilti::ctor::struct_::Fields > ()); yylhs.value.as < hilti::ctor::struct_::Fields > ().push_back(yystack_[0].value.as < hilti::ctor::struct_::Field* > ()); }
#line 5381 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 427: // struct_elems: struct_elem
#line 1166 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::struct_::Fields > () = hilti::ctor::struct_::Fields{ std::move(yystack_[0].value.as < hilti::ctor::struct_::Field* > ()) }; }
#line 5387 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 428: // struct_elem: "$-identifier" '=' expr
#line 1168 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::struct_::Field* > () = builder->ctorStructField(hilti::ID(std::move(yystack_[2].value.as < std::string > ())), std::move(yystack_[0].value.as < hilti::Expression* > ())); }
#line 5393 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 429: // regexp: re_patterns
#line 1170 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::Ctor* > () = builder->ctorRegExp(std::move(yystack_[0].value.as < std::vector<std::string> > ()), {}, __loc__); }
#line 5399 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 430: // re_patterns: re_patterns '|' re_pattern_constant
#line 1173 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::vector<std::string> > () = yystack_[2].value.as < std::vector<std::string> > (); yylhs.value.as < std::vector<std::string> > ().push_back(std::move(yystack_[0].value.as < std::string > ())); }
#line 5405 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 431: // re_patterns: re_pattern_constant
#line 1174 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::vector<std::string> > () = std::vector<std::string>{std::move(yystack_[0].value.as < std::string > ())}; }
#line 5411 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 432: // $@17: %empty
#line 1177 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                    { driver->enablePatternMode(); }
#line 5417 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 433: // $@18: %empty
#line 1177 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                             { driver->disablePatternMode(); }
#line 5423 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 434: // re_pattern_constant: '/' $@17 "regular expression value" $@18 '/'
#line 1178 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < std::string > () = std::move(yystack_[2].value.as < std::string > ()); }
#line 5429 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 435: // opt_map_elems: map_elems
#line 1180 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Elements > () = std::move(yystack_[0].value.as < hilti::ctor::map::Elements > ()); }
#line 5435 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 436: // opt_map_elems: %empty
#line 1181 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Elements > () = hilti::ctor::map::Elements(); }
#line 5441 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 437: // map_elems: map_elems ',' map_elem
#line 1183 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Elements > () = std::move(yystack_[2].value.as < hilti::ctor::map::Elements > ()); yylhs.value.as < hilti::ctor::map::Elements > ().push_back(std::move(yystack_[0].value.as < hilti::ctor::map::Element* > ())); }
#line 5447 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 438: // map_elems: map_elem
#line 1184 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Elements > () = hilti::ctor::map::Elements(); yylhs.value.as < hilti::ctor::map::Elements > ().push_back(std::move(yystack_[0].value.as < hilti::ctor::map::Element* > ())); }
#line 5453 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 439: // map_elem: expr_no_or_error ':' expr
#line 1186 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                 { yylhs.value.as < hilti::ctor::map::Element* > () = builder->ctorMapElement(yystack_[2].value.as < hilti::Expression* > (), yystack_[0].value.as < hilti::Expression* > ()); }
#line 5459 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 440: // attribute: "attribute"
#line 1190 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                { if ( auto attr_kind = hilti::Attribute::tagToKind(yystack_[0].value.as < std::string > ()) )
                                                    yylhs.value.as < hilti::Attribute* > () = builder->attribute(*attr_kind, __loc__);
                                                  else {
                                                    hilti::logger().error(hilti::util::fmt("invalid attribute '%s'", yystack_[0].value.as < std::string > ()), __loc__.location());
                                                    yylhs.value.as < hilti::Attribute* > () = {};
                                                  }
                                                }
#line 5471 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 441: // attribute: "attribute" '=' expr
#line 1197 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                { if ( auto attr_kind = hilti::Attribute::tagToKind(yystack_[2].value.as < std::string > ()) )
                                                    yylhs.value.as < hilti::Attribute* > () = builder->attribute(*attr_kind, std::move(yystack_[0].value.as < hilti::Expression* > ()), __loc__);
                                                  else {
                                                    hilti::logger().error(hilti::util::fmt("invalid attribute '%s'", yystack_[2].value.as < std::string > ()), __loc__.location());
                                                    yylhs.value.as < hilti::Attribute* > () = {};
                                                  }
                                                }
#line 5483 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 442: // opt_attributes: opt_attributes attribute
#line 1206 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                { if ( yystack_[0].value.as < hilti::Attribute* > () )
                                                    yystack_[1].value.as < hilti::AttributeSet* > ()->add(builder->context(), yystack_[0].value.as < hilti::Attribute* > ());

                                                  yylhs.value.as < hilti::AttributeSet* > () = yystack_[1].value.as < hilti::AttributeSet* > ();
                                                }
#line 5493 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;

  case 443: // opt_attributes: %empty
#line 1211 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
                                                { yylhs.value.as < hilti::AttributeSet* > () = builder->attributeSet({}, __loc__); }
#line 5499 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"
    break;


#line 5503 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  Parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // Parser::context.
  Parser::context::context (const Parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  Parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    const int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        const int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        const int yychecklim = yylast_ - yyn + 1;
        const int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }






  int
  Parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  Parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short Parser::yypact_ninf_ = -730;

  const short Parser::yytable_ninf_ = -413;

  const short
  Parser::yypact_[] =
  {
      90,   -20,  -730,   123,   109,  -730,  -730,  -730,  1221,  -730,
    -730,    -8,  -730,  -730,  -730,  -730,   -24,  -730,  -730,  -730,
    -730,  -730,  -730,     8,    89,  -730,   117,   143,   150,   159,
     203,   226,   245,    -3,   122,  1221,  1535,   261,   -64,  1221,
     266,   305,   126,   308,   315,   325,   331,   333,   343,   353,
     359,    89,   135,   -16,  1221,   345,  1980,    26,  1221,  -730,
    1221,  1221,  -730,  -730,  -730,   184,   -15,   378,    23,   -26,
     260,   307,   356,   367,   328,   154,  -730,   455,  -730,  -730,
    -730,  -730,  -730,  -730,  -730,  -730,  -730,  -730,  -730,  -730,
     358,  -730,  -730,   490,  -730,  -730,  2324,  -730,  -730,  -730,
    -730,  -730,  -730,  -730,   365,  2324,  1221,  2324,  -730,  -730,
    -730,   376,  -730,  -730,  -730,   386,  -730,  -730,  -730,  -730,
    -730,  -730,    89,    89,   379,   122,  -730,   169,  -730,  -730,
     208,   126,  -730,  -730,  -730,   387,  -730,   277,  -730,  -730,
    -730,  -730,   394,   135,    89,  -730,   -16,    26,   395,  -730,
    -730,  -730,  -730,  -730,  -730,  -730,  -730,  -730,  -730,  -730,
    -730,  -730,   365,  2324,  -730,  -730,  -730,   365,  -730,  -730,
    -730,  -730,  2324,   365,  2324,  -730,   396,   397,   398,  -730,
    -730,  -730,  -730,   403,   489,   390,   401,   -53,  -730,   393,
     545,  -730,  -730,  -730,  -730,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
    1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,  1221,
      27,  1843,  -730,  1843,  -730,    27,   365,  -730,    27,   392,
    -730,  -730,   409,  -730,  2420,    89,    89,    89,    89,    89,
      89,  -730,  -730,  -730,  -730,  -730,   299,   412,   414,   415,
     418,   429,   432,   434,  -730,   435,   299,   438,  -730,   437,
     441,  -730,   119,   577,   109,  2324,  2324,   585,  2324,  2324,
    2324,  2324,  -730,  2098,    56,   444,  2324,  2324,  -730,   365,
     447,   448,   450,   451,   299,   452,   456,   458,   460,   461,
     462,   464,   468,   299,   469,   299,  -730,  -730,   -13,  -730,
     109,  -730,  -730,   600,  -730,  -730,  -730,  -730,  -730,  -730,
     378,  -730,  -730,  -730,   472,    23,   -26,   -26,   260,   260,
     260,   260,   307,   356,   367,   328,   328,   154,   154,  -730,
    -730,  -730,  -730,  -730,  -730,  -730,   467,   605,  -730,   473,
     465,   476,  -730,  2215,  -730,  -730,  2324,  2324,  2324,   183,
    -730,   479,  -730,  -730,  -730,  -730,  -730,  -730,  -730,  -730,
     480,  -730,  -730,  1221,  2324,   481,   483,   192,  -730,   299,
     299,   482,   237,   299,   299,   299,    12,   453,   485,   484,
     180,  -730,  -730,   487,   493,  -730,   109,   459,   299,   299,
     496,  -730,  -730,  -730,  -730,   491,  -730,  -730,  -730,  -730,
    -730,  -730,  -730,  -730,   -64,  -730,   498,  -730,   346,  -730,
     567,  -730,  -730,   495,  -730,  -730,  -730,   365,   352,  -730,
    1221,  -730,   504,   505,  -730,   510,   514,   109,   499,  -730,
     518,  -730,  -730,   519,   520,   522,   527,   529,  -730,  -730,
     528,  -730,   890,  1061,  -730,  -730,  -730,  -730,  -730,  -730,
     239,  -730,  -730,   530,  -730,   274,   299,   299,  -730,   -16,
    -730,  -730,   299,  -730,   652,   109,  -730,  -730,  -730,  -730,
    2324,  -730,  -730,   531,  -730,   534,  -730,  -730,  2324,  2324,
    -730,  -730,   610,   537,   532,   538,  -730,   109,   539,   109,
    -730,   459,   536,  -730,  -730,  -730,  -730,  -730,  -730,   542,
    -730,  -730,   544,  -730,  -730,   547,   -16,  -730,   -16,   -13,
    -730,  -730,  -730,   549,  -730,  -730,   548,   317,   555,  -730,
    -730,   556,   109,   614,   -19,   357,   554,   702,   562,  -730,
     563,  -730,   614,  -730,  -730,   564,   565,   614,   499,  -730,
     499,   499,  -730,  2324,  -730,  -730,   566,   568,   571,   560,
    -730,  -730,   299,  2324,   484,  -730,  -730,  2324,  2657,    36,
    -730,   554,  -730,  -730,   561,   569,  -730,  -730,  -730,  -730,
     572,   573,  -730,   -22,  -730,   575,  -730,  -730,  -730,  -730,
    -730,   647,   109,   -91,   574,  -730,  -730,  -730,  2324,    56,
    -730,  -730,  -730,  -730,  -730,   576,   578,  -730,  -730,   -51,
     579,   582,   706,   586,   580,   299,  -730,  -730,  1221,   109,
     587,   484,   584,   588,   590,   592,   484,   595,  -730,   598,
    -730,  -730,   596,  -730,    42,   597,    67,  2324,  1689,   611,
    -730,  -730,  -730,  -730,  -730,   602,  -730,   372,  -730,  2556,
    2556,   603,   747,   607,   225,   601,    10,  -730,   604,   606,
    -730,  2556,  2556,   608,   609,  -730,   499,   612,   613,  -730,
    -730,   616,   615,   619,   109,  -730,    47,  -730,  -730,  -730,
      55,  -730,   621,  -730,  -730,    22,   734,    92,  -730,     7,
     -38,   618,   626,   628,   629,   631,   633,   635,   636,  1381,
     637,  -730,   627,   627,   627,  -730,  -730,  -730,   630,  -730,
     639,  -730,  2324,   640,  2164,  -730,  -730,    98,   714,  -730,
    -730,   716,  -730,  -730,  -730,  -730,  -730,  -730,  -730,  -730,
    -730,   645,  -730,  -730,    52,    52,   643,  -730,  -730,  -730,
    2324,   648,  -730,  2324,  2324,  -730,   752,  -730,  -730,  -730,
    -730,  -730,  -730,   459,  -730,  -730,   279,  -730,  -730,   375,
    -730,     2,     2,     2,     2,    20,    20,    20,    20,   651,
     -72,   651,   646,   627,   365,   641,   642,  -730,    58,  -730,
    -730,  -730,  -730,  2556,  -730,   100,  2556,   649,  2464,  -730,
    2556,  -730,  -730,  -730,   658,  -730,  1221,   659,     3,  -730,
      73,  2556,   660,   105,    56,   662,  -730,   253,   484,   -11,
     656,    31,  -730,    66,    31,  -730,    60,  -730,   794,   795,
     663,   664,   665,   666,  -730,   796,   667,   668,   669,   670,
     641,  -730,   651,  -730,   627,  -730,   671,    75,  -730,   661,
     230,   674,   798,   247,   249,  -730,  -730,   777,  -730,  -730,
    -730,  -730,  -730,   -23,  -730,  2556,  -730,  -730,  -730,  -730,
    -730,  -730,   676,  -730,  -730,  -730,    65,   811,  -730,  -730,
     780,   112,   683,   209,  -730,  -730,  -730,  -730,  -730,  -730,
    -730,  -730,  -730,  -730,  -730,  -730,   824,   824,  -730,   824,
    -730,   824,  -730,   798,  -730,   798,  -730,  -730,   284,   798,
     798,  -730,  -730,  2556,  1221,  -730,   685,   686,   687,  -730,
     688,  -730,    69,   684,   691,  -730,  -730,  -730,   824,   251,
     284,   284,   690,   401,  -730,  -730,   189,  -730,   284,   284,
    -730,  -730,  -730,  2324,  -730,  -730,  -730,  -730,  -730,   459,
    -730,   798,  -730,  -730,  -730,  -730,  -730,  -730,   484,    24,
      77,   689,   284,   695,   692,  -730,  -730,  -730,  -730,  -730
  };

  const short
  Parser::yydefact_[] =
  {
       0,     0,   283,     0,     0,     2,     3,     4,     0,     1,
       7,     0,     9,   376,   372,   373,   369,   374,   379,   377,
     366,   371,   375,     0,     0,   365,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   283,     0,     0,     0,   283,     0,   432,
       0,     0,     8,   364,   284,   291,   299,   301,   303,   306,
     311,   313,   315,   317,   320,   323,   328,   335,   346,   356,
     362,   357,   358,   388,   383,   389,   386,   384,   387,   385,
     429,   431,     5,     0,   283,   161,     0,   283,   283,   283,
     283,   283,   283,   283,   283,     0,   436,     0,   333,   113,
     112,     0,   114,   115,   120,     0,   116,   127,   128,   129,
     126,   117,     0,     0,     0,     0,   118,     0,   119,   121,
       0,     0,   142,   122,   123,     0,   124,     0,   131,   132,
     133,   130,   192,     0,     0,   125,   283,   283,   354,   352,
     144,   145,   146,   147,   148,   353,   283,   415,   348,   334,
     283,   283,   283,     0,   283,   283,   283,   283,   283,   283,
     283,   283,     0,   283,     0,   414,   413,     0,   406,   330,
     380,   378,   359,     0,   290,     0,   287,     0,   427,     0,
       0,   329,   331,   285,   283,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   343,     0,   344,     0,   283,   283,     0,     0,
      15,   370,     0,   160,     0,     0,     0,     0,     0,     0,
       0,   156,   150,   159,   155,   157,     0,     0,     0,     0,
       0,     0,     0,     0,   290,     0,     0,     0,   286,     0,
     435,   438,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   172,     0,    56,     0,     0,     0,   413,   283,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   363,   404,   283,   283,
       0,   416,   283,     0,   425,   332,   433,   292,   297,   294,
     300,   295,   296,   293,     0,   302,   304,   305,   309,   310,
     307,   308,   312,   314,   316,   318,   319,   321,   322,   327,
     325,   324,   326,   368,   367,   340,   341,   342,   345,     0,
       0,   337,   430,   283,   350,   158,     0,     0,     0,   149,
     162,     0,   351,   396,   397,   398,   395,   390,   391,   417,
       0,   283,   423,     0,     0,     0,   178,     0,   177,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     8,   168,
       0,   167,    63,     0,    55,    58,     0,   196,     0,     0,
       0,   381,   283,   382,   421,     0,   394,   392,   393,   405,
     400,   401,   402,   399,     0,   419,     0,   407,   409,   428,
       0,   289,   426,     0,   283,   336,   339,   283,     0,   283,
       0,   283,     0,     0,   283,     0,     0,     0,     0,   262,
     283,    50,    49,   283,     0,     0,     0,     0,   283,   283,
       0,    13,    16,    17,   108,    18,    19,    20,    21,    22,
       0,    14,    75,     0,   111,     0,     0,     0,   283,   283,
     439,   437,     0,   180,     0,   176,   174,   135,   134,   143,
       0,   136,   137,   140,   170,     0,   171,   163,     0,   166,
     164,   191,    64,     0,   443,     0,   262,     0,   271,     0,
     237,   195,     0,   194,   198,   201,   200,   197,   199,     0,
     202,   203,   141,   138,   355,     0,   283,   349,   283,   283,
     283,   434,   298,     0,    46,   283,     0,     0,     0,    79,
      80,     0,     0,   283,     0,     0,   259,     0,     0,    86,
       0,    88,   283,    92,    93,     0,     0,   283,     0,    52,
       0,     0,    74,     0,   140,   141,     0,     0,     0,     0,
     179,   175,     0,     0,   169,   165,    57,     0,   283,     0,
     283,   259,   443,   283,     0,     0,   193,   190,   239,   403,
       0,     0,   410,     0,   338,     0,    76,    78,   283,    97,
      98,     0,     0,     0,     0,    10,    44,   283,     0,    56,
      48,   261,   263,    85,    87,     0,     0,    89,    99,     0,
       0,    25,    54,    34,     0,     0,   347,   418,   436,   183,
     139,   443,   154,   153,   152,    66,     0,     0,   443,   440,
     206,   442,     0,   236,     0,     0,   283,     0,     0,   242,
     422,   420,   283,   360,    47,     0,   283,     0,   283,   283,
     283,     0,     0,     0,     0,     0,     0,   264,     0,     0,
     283,   283,   283,     0,     0,    53,     0,     0,     0,    23,
     139,     0,     0,     0,   182,   185,     0,   283,    59,   208,
       0,   283,     0,   205,   270,   238,     0,   283,   273,     0,
      66,   127,   128,   129,   126,   131,   132,   133,   130,   283,
     244,   209,   443,   248,     0,   221,   241,   240,     0,    77,
       0,   283,     0,     0,   283,   109,   110,     0,   101,    67,
      68,   101,    45,    11,    29,    30,   283,   258,   268,   267,
     265,     0,   257,   260,     0,     0,     0,    96,    95,   283,
       0,     0,   283,     0,     0,   424,     0,   181,   184,   173,
      65,   207,   441,   196,   278,   279,   238,   443,   272,   238,
     443,     0,     0,     0,     0,     0,     0,     0,     0,   244,
     244,   244,     0,     0,   283,   443,   283,   443,   250,   247,
     443,   443,   361,   283,    33,     0,   283,     0,   283,    73,
     283,    83,    82,    12,     0,   283,     0,     0,     0,   103,
       0,   283,     0,     0,    56,     0,    37,     0,   443,   189,
       0,   238,   277,   250,   238,   276,     0,   216,     0,     0,
       0,     0,     0,     0,   219,     0,     0,     0,     0,     0,
     443,   443,   244,   443,   248,   443,     0,   250,   246,     0,
     250,     0,   252,   250,   250,    81,   283,   101,    69,    72,
     100,    31,   266,     0,   107,   283,    91,   102,    90,    94,
      26,   283,     0,    35,    38,   283,     0,     0,   283,   443,
     281,   238,     0,   238,   204,   217,   218,   227,   228,   229,
     226,   220,   223,   224,   225,   222,   231,   233,   443,   230,
     443,   232,   243,   252,   245,   252,   283,   283,   259,   252,
     252,    32,    84,   283,     0,   105,     0,    62,     0,    24,
     189,   188,     0,     0,     0,   275,   269,   274,   234,   250,
     259,   259,     0,   251,   254,   210,   253,   256,   259,   259,
     104,   106,    28,     0,    61,   443,    39,   443,   187,   196,
     282,   252,   213,   211,   249,   255,   212,   214,    60,    40,
       0,     0,   259,     0,     0,   186,   280,   215,    41,    43
  };

  const short
  Parser::yypgoto_[] =
  {
    -730,  -730,  -730,  -730,  -730,    -4,   145,  -730,  -730,  -730,
    -730,  -730,   502,  -730,   506,  -730,  -730,  -730,  -152,  -730,
    -730,  -730,  -730,  -730,  -730,  -730,  -730,  -730,  -730,   508,
    -730,  -730,  -579,  -730,   366,  -730,  -730,  -730,   172,  -623,
    -635,  -730,  -730,  -337,  -690,   128,  -319,  -730,  -730,  -730,
     -33,   297,  -493,  -730,   624,   -83,   168,   202,  -730,  -730,
     382,  -730,  -730,  -730,  -730,  -730,   399,  -730,  -730,  -730,
    -730,   191,   -34,  -730,  -730,  -365,  -729,  -475,  -730,  -730,
    -730,   173,   190,  -303,  -304,   178,  -730,   179,  -730,  -730,
    -730,  -730,  -730,  -667,  -641,    45,  -478,  -532,  -550,  -730,
    -518,  -730,  -730,   384,  -730,  -730,  -730,   196,  -730,  -730,
     195,  -730,  -730,     5,  -730,  -730,  -416,  -102,  -621,  -730,
      44,  -730,   677,   675,   329,   240,   672,   673,   678,   322,
     324,   -12,   256,  -730,   817,  -730,   212,   -35,  -730,   -29,
    -179,   371,  -286,   478,  -730,  -730,  -730,  -730,  -730,  -730,
     581,  -730,  -730,   657,  -730,  -730,   268,  -730,   524,  -730,
    -536
  };

  const short
  Parser::yydefgoto_[] =
  {
       0,     3,     6,     5,   230,    62,    63,   641,   642,   783,
     343,   441,   705,   734,   706,   653,   654,   444,   583,   445,
     657,   658,   796,   446,   943,   944,   447,   448,   449,   707,
     602,   656,   383,   384,   385,   924,   925,   386,   668,   708,
     709,   777,   778,   710,   781,   788,   789,   843,   452,   453,
     242,   243,   244,   615,   245,   379,   269,   351,   150,   380,
     381,   151,   376,   476,   152,   367,   368,   153,   549,   663,
     664,   665,   859,   154,   275,   491,   492,   493,   494,   495,
     496,   692,   497,   810,   816,   693,   762,   694,   498,   499,
     628,   629,   697,   765,   769,   770,   832,   888,   915,   916,
     917,   591,   646,   526,   527,   647,   723,   500,   564,   677,
     678,   904,   501,   254,     8,   193,   257,   185,   186,    64,
     258,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,   335,    81,    82,    83,
     177,   407,   178,   158,    84,    85,    86,    87,    88,   187,
     188,    89,    90,    91,   190,   413,   259,   260,   261,   621,
     559
  };

  const short
  Parser::yytable_[] =
  {
      11,   155,   255,   149,   517,   679,   451,     7,   590,   157,
     645,   722,   408,   246,   800,    10,   566,   711,   718,   719,
     807,   782,   256,   108,   262,    10,   624,   159,   727,   728,
      10,   195,   619,   183,    10,   749,   205,   857,   814,   786,
     484,   585,   179,   623,   619,   632,   189,   787,   191,   192,
     619,   767,    65,   771,   206,   619,   679,   638,   176,   -64,
     283,   639,   184,   619,   614,   288,   619,    46,   619,   720,
       4,   294,   196,   619,   619,   666,   203,   619,   175,   764,
     284,   175,   670,   619,   197,   619,   198,   146,   786,   293,
     766,   295,   820,   821,   823,   675,   787,   650,   485,   232,
     303,   651,   247,   248,   249,   250,   251,   252,   253,   786,
     304,   667,    10,   199,   204,    10,   721,   787,   349,   822,
     675,   484,   825,     9,   339,   831,   382,   893,   486,   586,
     894,   207,   208,   831,   200,   691,  -408,   538,   858,  -412,
      92,   633,   831,   488,    93,   333,   487,   892,   104,   201,
     835,   278,   488,   837,    95,   878,   768,   840,   846,    94,
     302,   280,   808,   809,   704,   281,   282,   474,   849,   285,
     286,   287,   489,   289,   290,   291,   292,   390,   -42,   485,
     815,   148,   369,   370,   620,   372,   373,   374,   375,  -288,
     673,  -149,    96,   388,   389,   739,   691,  -259,  -253,   307,
     941,   105,   107,   741,   329,   330,   331,   332,   864,   486,
     163,   803,    10,   899,   806,   852,   334,   928,   484,   172,
     174,   334,   895,   408,   334,   945,   676,   487,   848,   827,
     541,   830,   340,   488,   833,   834,     1,     2,   619,   308,
     309,   241,   311,   312,   313,   314,    95,   747,  -259,   836,
     241,   676,   241,   489,   851,   619,   349,   619,   216,   619,
     366,   349,   856,   455,   456,   457,   913,   905,    97,   378,
     920,   802,   364,   106,   805,   349,   485,   162,   538,    95,
     547,   462,    10,    95,   876,   877,   173,   879,   484,   881,
     265,   266,    95,   268,    98,  -259,   410,   831,   270,   271,
     539,    99,   540,   278,   409,   273,   486,   411,   241,   949,
     100,   276,   277,   217,   831,   513,   831,   241,   831,   241,
     156,   218,   219,   902,   487,   862,    95,   570,   528,   571,
     488,  -149,  -149,   479,   194,  -149,  -149,  -149,   350,  -149,
     589,  -149,   908,  -259,   909,   465,   485,   466,   454,   883,
     489,   910,   885,   911,   101,   889,   890,   918,   919,   161,
     932,   933,   180,   181,   907,    95,   460,   779,   936,   937,
     844,   541,   475,   715,   716,   157,   486,   102,    10,   241,
     595,   349,   483,   490,   484,   599,   566,   552,   566,   939,
     470,   940,   947,   349,   487,   554,   103,   505,   935,   942,
     488,   854,   855,   346,   202,   270,   347,   273,   348,   349,
     241,   241,   156,   241,   241,   241,   241,   160,   241,   512,
     489,   241,   241,   524,   516,   209,   518,   543,   167,   521,
     349,   931,   914,   801,    95,   589,   861,   338,   530,   863,
     341,   839,   485,   535,   536,   318,   319,   320,   321,   811,
     812,   813,   817,   818,   819,   349,   161,   350,   360,   164,
     605,   366,    10,   546,   278,   577,   165,   578,   484,   847,
     611,   847,   486,   210,   616,   378,   166,   336,   921,   337,
     212,   213,   167,   562,   168,   565,   395,   490,   214,   215,
     487,   241,   241,   241,   169,   404,   488,   406,  -409,   509,
     514,   515,    10,    12,   170,   644,   587,   588,   231,   241,
     171,   278,   211,   278,   278,   573,   489,  -288,   581,   220,
     575,   701,   702,   229,   221,   617,   485,   263,   584,   804,
     267,   220,   316,   317,   325,   326,   221,   596,   327,   328,
     264,   272,   600,   222,   680,   274,   279,   300,   296,   297,
     223,   298,   299,   301,   302,   222,   486,   224,   305,   306,
      59,   344,   223,   618,   352,   622,   353,   354,   625,   224,
     355,   467,   468,   525,   487,   471,   472,   473,   637,   477,
     488,   356,   480,   635,   357,   225,   358,   359,   361,   362,
     502,   503,   643,   695,   363,   365,   371,   225,   387,   391,
     489,   392,   393,   394,   396,   662,   226,   183,   397,  -238,
     398,   350,   399,   400,   401,   241,   402,   227,   226,   775,
     403,   405,   414,   241,   241,   415,   228,   417,   416,   227,
     458,   459,   464,   463,   469,   478,   510,   698,   228,   481,
     349,   700,   506,   703,   454,   454,   482,   793,   504,   508,
     797,   798,   519,   520,   695,   726,   454,   454,   544,   545,
     662,   522,   826,   511,   548,   523,  -288,   529,   531,   220,
     550,   490,   740,   532,   221,   533,   742,   534,   542,   537,
     382,   558,   506,   601,   553,   603,   604,   557,   241,   560,
     563,   567,   568,   222,   278,   508,   576,   582,   241,   569,
     223,   574,   612,   579,   580,   589,   774,   224,   592,   454,
     593,   594,   597,   598,   609,   626,   636,   655,   606,   627,
     607,   784,   608,   634,   630,   631,   640,   696,   648,   659,
     649,   652,   -27,   241,   792,   225,   -36,   795,   608,   490,
    -156,   667,   490,   669,  -159,   490,  -155,   671,   672,   674,
     699,   712,   713,   717,   610,   714,   226,   729,   724,   730,
     725,   732,   746,   733,   780,   736,   780,   227,   735,   751,
     799,   829,   241,   690,   737,   743,   228,   752,   454,   753,
     754,   454,   755,   454,   756,   454,   757,   758,   764,   766,
     842,   773,   776,   772,   785,   791,   454,   490,   824,   794,
     490,   731,   764,  -235,   838,   828,   841,   660,   850,   845,
     853,   860,   865,   866,   871,   867,   868,   869,   870,   872,
     873,   874,   875,   882,   884,   886,   887,   780,   897,   900,
     903,   906,   619,   922,   759,   926,   923,   858,   929,   930,
     938,   891,   934,   948,   946,   442,   704,   241,   556,   443,
     454,   450,   750,   790,   613,   738,   896,   490,   345,   490,
     898,   555,   760,   901,   551,   744,   927,   761,   763,   880,
     561,   745,   748,   182,   310,   241,   661,   315,   241,   241,
     572,   322,   507,   323,   412,     0,   342,   461,     0,   324,
     -16,   912,     0,   -16,   -16,     0,     0,     0,   454,   -16,
       0,   -16,   -16,   -16,     0,   -16,   -16,   -16,   -16,   -16,
     -16,   -16,   -16,   -16,   -16,     0,     0,     0,     0,     0,
       0,   -16,     0,   -16,     0,   490,     0,   -16,     0,   -16,
       0,   -16,     0,     0,     0,   -16,     0,   -16,     0,     0,
       0,   -16,     0,     0,     0,     0,     0,     0,   -16,     0,
       0,   -16,     0,   -16,     0,     0,     0,   -16,   -16,     0,
       0,     0,   -16,   -16,   -16,   -16,   -16,   -16,     0,     0,
       0,     0,   -16,   -16,   -16,     0,     0,     0,   -16,     0,
       0,     0,     0,   -16,     0,     0,     0,   -16,   -16,     0,
     -16,     0,   -16,   -16,     0,   -16,     0,   -16,   -16,     0,
     -16,   -16,   -16,     0,     0,     0,     0,   -16,   -16,     0,
       0,   -16,   -16,   -16,   -16,   -16,   -16,     0,     0,     0,
       0,   -16,   -16,     0,   -16,   -16,   -16,   -16,     0,   -16,
     -16,     0,   -16,     0,     0,   -16,     0,     0,     0,     0,
       0,   -16,     0,     0,     0,     0,     0,     0,     0,   -16,
     -16,   -16,   -16,     0,     0,   -16,     0,     0,   -16,   -16,
     -16,   -17,     0,     0,   -17,   -17,     0,     0,   241,     0,
     -17,     0,   -17,   -17,   -17,     0,   -17,   -17,   -17,   -17,
     -17,   -17,   -17,   -17,   -17,   -17,     0,     0,     0,     0,
       0,     0,   -17,     0,   -17,     0,     0,     0,   -17,     0,
     -17,     0,   -17,     0,     0,     0,   -17,     0,   -17,     0,
       0,     0,   -17,     0,     0,     0,     0,     0,     0,   -17,
       0,     0,   -17,     0,   -17,     0,     0,     0,   -17,   -17,
       0,     0,     0,   -17,   -17,   -17,   -17,   -17,   -17,     0,
       0,     0,     0,   -17,   -17,   -17,     0,     0,     0,   -17,
       0,     0,     0,     0,   -17,     0,     0,     0,   -17,   -17,
       0,   -17,     0,   -17,   -17,     0,   -17,     0,   -17,   -17,
       0,   -17,   -17,   -17,     0,     0,     0,     0,   -17,   -17,
       0,     0,   -17,   -17,   -17,   -17,   -17,   -17,     0,     0,
       0,     0,   -17,   -17,     0,   -17,   -17,   -17,   -17,     0,
     -17,   -17,     0,   -17,     0,     0,   -17,     0,     0,     0,
       0,     0,   -17,     0,     0,     0,     0,     0,     0,     0,
     -17,   -17,   -17,   -17,    10,    12,   -17,     0,     0,   -17,
     -17,   -17,    13,    14,    15,     0,    16,    17,    18,    19,
      20,    21,    22,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    23,     0,     0,     0,     0,     0,    24,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    25,     0,
       0,     0,    26,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    27,    28,    29,    30,    31,    32,     0,
       0,     0,     0,    33,     0,    34,     0,     0,     0,    35,
       0,     0,     0,     0,    36,     0,     0,     0,     0,    37,
       0,    38,     0,    39,    40,     0,     0,     0,     0,     0,
       0,    41,     0,    42,     0,     0,     0,     0,     0,    43,
       0,     0,     0,     0,     0,     0,    44,    45,     0,     0,
       0,     0,    46,     0,     0,    47,    48,    49,    50,     0,
      51,     0,     0,    52,     0,     0,     0,     0,     0,     0,
       0,     0,    53,     0,     0,     0,     0,     0,     0,     0,
      54,    55,    56,    57,    10,    12,    58,     0,     0,    59,
      60,    61,    13,    14,    15,     0,    16,    17,    18,    19,
       0,    21,    22,     0,     0,     0,   109,     0,   110,     0,
       0,   111,     0,   112,     0,   113,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     114,     0,     0,   115,     0,   116,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   681,   682,   683,   684,   121,     0,   122,
     123,     0,   124,    33,     0,   125,     0,     0,     0,     0,
       0,     0,     0,   126,     0,   175,     0,     0,     0,   127,
       0,     0,     0,     0,   128,     0,     0,     0,     0,     0,
     129,   130,     0,   131,     0,     0,   132,     0,     0,   133,
     134,   135,     0,     0,     0,     0,   136,     0,     0,     0,
       0,     0,   137,     0,     0,   685,   686,   687,   688,   142,
       0,     0,     0,   143,   144,   145,     0,     0,     0,     0,
       0,     0,   146,  -408,     0,     0,     0,     0,    10,    12,
       0,    55,     0,   147,     0,     0,    13,    14,    15,    59,
      16,    17,    18,    19,     0,    21,    22,     0,     0,     0,
     109,     0,   110,     0,     0,   111,     0,   112,     0,   113,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   114,     0,     0,   115,     0,   116,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   117,   118,   119,
     120,   121,     0,   122,   123,     0,   124,    33,     0,   125,
       0,     0,     0,     0,     0,     0,     0,   126,     0,     0,
       0,     0,     0,   127,     0,     0,     0,     0,   128,     0,
       0,     0,     0,     0,   129,   130,     0,   131,     0,     0,
     132,     0,     0,   133,   134,   135,     0,     0,     0,     0,
     136,     0,     0,     0,     0,     0,   137,     0,     0,   138,
     139,   140,   141,   142,     0,     0,     0,   143,   144,   145,
       0,     0,     0,     0,     0,     0,   146,     0,     0,     0,
       0,     0,    10,    12,     0,    55,     0,   147,     0,     0,
      13,    14,    15,    59,    16,    17,    18,    19,     0,    21,
      22,     0,     0,     0,   109,     0,   110,     0,     0,   111,
       0,   112,     0,   113,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   114,     0,
       0,   115,     0,   116,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   681,   682,   683,   684,   121,     0,   122,   123,     0,
     124,    33,     0,   125,     0,     0,     0,     0,     0,     0,
       0,   126,     0,     0,     0,     0,     0,   127,     0,     0,
       0,     0,   128,     0,     0,     0,     0,     0,   129,   130,
       0,   131,     0,     0,   132,     0,     0,   133,   134,   135,
       0,     0,     0,     0,   136,     0,     0,     0,     0,     0,
     137,     0,     0,   685,   686,   687,   688,   142,     0,     0,
       0,   143,   144,   145,     0,     0,     0,     0,     0,     0,
     689,     0,     0,     0,     0,     0,    10,    12,     0,    55,
       0,   147,     0,     0,    13,    14,    15,    59,    16,    17,
      18,    19,    20,    21,    22,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    23,     0,     0,     0,     0,     0,
      24,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      25,     0,     0,     0,    26,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    27,    28,    29,    30,    31,
      32,     0,     0,     0,     0,    33,     0,    34,     0,     0,
       0,     0,     0,     0,     0,     0,    36,     0,     0,     0,
       0,    37,     0,    38,     0,     0,    40,     0,     0,     0,
       0,     0,     0,    41,     0,    42,     0,     0,     0,     0,
       0,    43,     0,     0,     0,     0,     0,     0,    44,    45,
       0,     0,     0,     0,    46,     0,     0,    47,    48,    49,
      50,     0,    51,    10,    12,    52,     0,     0,     0,     0,
       0,    13,    14,    15,    53,    16,    17,    18,    19,    20,
      21,    22,     0,    55,    56,    57,     0,     0,     0,     0,
       0,    59,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    25,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    27,    28,    29,    30,    31,    32,     0,     0,
       0,     0,    33,     0,    34,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    37,     0,
       0,     0,     0,    40,     0,     0,     0,     0,     0,     0,
      41,     0,    42,     0,     0,     0,     0,     0,    43,     0,
       0,    10,    12,     0,     0,    44,    45,     0,     0,     0,
       0,    46,     0,     0,    47,    48,    49,    50,     0,     0,
       0,     0,    52,   109,     0,   110,     0,   233,   111,     0,
     112,    53,   113,     0,     0,     0,     0,   234,     0,     0,
      55,    56,    57,     0,     0,     0,     0,   114,    59,     0,
     115,     0,   116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     117,   118,   119,   120,   121,     0,   122,   123,     0,   124,
       0,     0,   235,     0,     0,     0,   419,   420,   421,     0,
     126,     0,     0,     0,     0,     0,   236,   422,     0,     0,
       0,   128,     0,   -51,     0,   423,     0,   129,   237,   424,
     238,     0,     0,   132,     0,    -6,   133,   134,   135,     0,
       0,     0,   425,   136,   418,     0,     0,     0,     0,   239,
       0,   426,   138,   139,   140,   141,   142,   419,   420,   421,
     240,   144,   145,     0,     0,     0,     0,   428,   422,     0,
       0,     0,     0,     0,   -51,     0,   423,   377,     0,     0,
     424,     0,     0,     0,     0,     0,     0,     0,     0,   430,
       0,   431,   432,   425,     0,   433,   -51,     0,   -51,     0,
       0,   434,   426,   427,     0,   435,   436,   437,   438,     0,
       0,     0,     0,     0,     0,     0,   -51,     0,   428,     0,
       0,     0,     0,     0,   439,     0,     0,     0,     0,   440,
       0,     0,   429,     0,     0,     0,     0,     0,     0,   -71,
     430,     0,   431,   432,     0,     0,   433,    10,    12,     0,
       0,     0,   434,     0,     0,     0,   435,   436,   437,   438,
       0,     0,     0,     0,     0,     0,     0,   -51,     0,   109,
       0,   110,     0,   233,   111,   439,   112,     0,   113,     0,
     440,     0,     0,   234,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   114,     0,     0,   115,     0,   116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   117,   118,   119,   120,
     121,     0,   122,   123,     0,   124,     0,     0,   235,     0,
       0,     0,     0,     0,     0,     0,   126,     0,     0,     0,
       0,     0,   236,    10,    12,     0,     0,   128,     0,     0,
       0,     0,     0,   129,   237,     0,   238,     0,     0,   132,
       0,     0,   133,   134,   135,   109,     0,   110,     0,   136,
     111,     0,   112,     0,   113,   239,     0,     0,   138,   139,
     140,   141,   142,     0,     0,     0,   240,   144,   145,   114,
       0,     0,   115,     0,   116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   419,   420,   421,     0,
       0,     0,   117,   118,   119,   120,   121,   422,   122,   123,
       0,   124,     0,   -51,   235,   423,     0,     0,     0,   424,
       0,     0,   126,     0,     0,     0,     0,     0,   236,     0,
       0,     0,   425,   128,     0,     0,     0,     0,     0,   129,
     237,   426,   238,     0,     0,   132,     0,     0,   133,   134,
     135,     0,     0,     0,     0,   136,     0,   428,     0,     0,
       0,   239,     0,     0,   138,   139,   140,   141,   142,     0,
       0,     0,   240,   144,   145,     0,     0,     0,     0,   430,
       0,   431,   432,     0,     0,   433,     0,     0,   419,   420,
     421,   434,     0,     0,     0,   435,   436,   437,   438,   422,
       0,     0,     0,     0,     0,   -51,   -51,   423,     0,     0,
       0,   424,     0,     0,   439,     0,     0,     0,     0,   440,
       0,     0,     0,     0,   425,     0,     0,     0,     0,   -70,
       0,     0,     0,   426,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   428,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   430,     0,   431,   432,     0,     0,   433,     0,     0,
       0,     0,     0,   434,     0,     0,     0,   435,   436,   437,
     438,     0,   109,     0,   110,     0,     0,   111,   -51,   112,
       0,   113,     0,     0,     0,     0,   439,     0,     0,     0,
       0,   440,     0,     0,     0,     0,   114,     0,     0,   115,
     704,   116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   117,
     118,   119,   120,   121,     0,   122,   123,     0,   124,     0,
       0,   235,     0,     0,     0,     0,     0,     0,     0,   126,
       0,     0,     0,     0,     0,   236,     0,     0,     0,     0,
     128,     0,     0,     0,     0,     0,   129,   237,     0,   238,
       0,     0,   132,     0,     0,   133,   134,   135,     0,     0,
       0,     0,   136,     0,     0,     0,     0,     0,   239,     0,
       0,   138,   139,   140,   141,   142,     0,     0,     0,   240,
     144,   145
  };

  const short
  Parser::yycheck_[] =
  {
       4,    36,   104,    36,   420,   626,   343,     2,   526,    38,
     589,   646,   298,    96,   743,     3,   491,   640,     8,     9,
      18,   711,   105,    35,   107,     3,   562,    39,   651,   652,
       3,    46,     8,     7,     3,    28,    62,    48,    18,    36,
       9,    60,    54,   561,     8,    67,    58,    44,    60,    61,
       8,   692,     8,   694,    80,     8,   677,   148,    53,     3,
     162,   152,    57,     8,   557,   167,     8,   131,     8,    59,
      90,   173,    87,     8,     8,   611,    53,     8,    94,   151,
     163,    94,   618,     8,    99,     8,   101,   151,    36,   172,
     162,   174,   759,   760,   761,    28,    44,   148,    67,    94,
     153,   152,    97,    98,    99,   100,   101,   102,   103,    36,
     163,   149,     3,   128,    91,     3,   106,    44,   156,   760,
      28,     9,   763,     0,   226,    67,    70,   150,    97,   148,
     153,   157,   158,    67,   149,   628,   152,    39,   149,   152,
     148,   163,    67,   121,   168,   118,   115,   837,   151,   164,
     773,   146,   121,   776,   157,   822,   692,   780,   155,   151,
     153,   156,   160,   161,   154,   160,   161,   155,   791,   164,
     165,   166,   141,   168,   169,   170,   171,   279,   154,    67,
     160,    36,   265,   266,   148,   268,   269,   270,   271,   163,
     148,     8,    24,   276,   277,   148,   689,     8,     9,   194,
     929,    33,    34,   148,   216,   217,   218,   219,   148,    97,
      42,   747,     3,   148,   750,   794,   220,   148,     9,    51,
      52,   225,   845,   509,   228,   148,   159,   115,   155,   765,
     132,   767,   227,   121,   770,   771,   146,   147,     8,   195,
     196,    96,   198,   199,   200,   201,   157,   155,    59,   149,
     105,   159,   107,   141,   149,     8,   156,     8,   104,     8,
     264,   156,   798,   346,   347,   348,   887,   155,   151,   273,
     893,   746,   153,   151,   749,   156,    67,   151,    39,   157,
     459,   364,     3,   157,   820,   821,   151,   823,     9,   825,
     122,   123,   157,   125,   151,   106,   300,    67,   130,   131,
      61,   151,    63,   298,   299,   137,    97,   302,   163,   944,
     151,   143,   144,   159,    67,   417,    67,   172,    67,   174,
     151,   167,   168,   859,   115,   803,   157,   506,   430,   508,
     121,   148,   149,   153,   150,   152,   153,   154,   158,   156,
     151,   158,   878,   154,   880,   153,    67,   155,   343,   827,
     141,   883,   830,   885,   151,   833,   834,   889,   890,   151,
     910,   911,    17,    18,   155,   157,   361,   704,   918,   919,
     786,   132,   376,   148,   149,   404,    97,   151,     3,   234,
     532,   156,   386,   387,     9,   537,   861,   470,   863,   925,
     153,   927,   942,   156,   115,   478,   151,   392,   916,   931,
     121,   148,   149,   235,    26,   237,   238,   239,   240,   156,
     265,   266,   151,   268,   269,   270,   271,   151,   273,   414,
     141,   276,   277,   427,   419,   165,   421,   153,   151,   424,
     156,   909,   148,   154,   157,   151,   801,   225,   433,   804,
     228,   778,    67,   438,   439,   205,   206,   207,   208,   752,
     753,   754,   756,   757,   758,   156,   151,   158,   256,   151,
     543,   465,     3,   458,   459,   148,   151,   150,     9,   788,
     553,   790,    97,   166,   557,   479,   151,   221,   894,   223,
     113,   114,   151,   487,   151,   489,   284,   491,   160,   161,
     115,   346,   347,   348,   151,   293,   121,   295,   152,   153,
     148,   149,     3,     4,   151,   588,   149,   150,    18,   364,
     151,   506,   156,   508,   509,   510,   141,   152,   522,    64,
     515,   149,   150,   165,    69,   558,    67,   151,   523,   154,
     151,    64,   203,   204,   212,   213,    69,   532,   214,   215,
     154,   154,   537,    88,   627,   151,   151,    58,   152,   152,
      95,   153,   149,   163,   153,    88,    97,   102,   165,    14,
     168,   152,    95,   558,   152,   560,   152,   152,   563,   102,
     152,   369,   370,   428,   115,   373,   374,   375,   582,   377,
     121,   152,   380,   578,   152,   130,   152,   152,   150,   152,
     388,   389,   587,   628,   153,    18,    11,   130,   154,   152,
     141,   153,   152,   152,   152,   609,   151,     7,   152,   150,
     152,   158,   152,   152,   152,   470,   152,   162,   151,   702,
     152,   152,   150,   478,   479,   152,   171,   151,   163,   162,
     151,   151,   149,   152,   152,   150,    69,   632,   171,   152,
     156,   636,   151,   638,   639,   640,   153,   730,   152,   151,
     733,   734,   148,   148,   689,   650,   651,   652,   456,   457,
     664,   151,   764,   168,   462,   151,   148,   148,   148,    64,
      18,   675,   667,   151,    69,   148,   671,   148,   148,   151,
      70,   149,   151,   538,   150,   540,   541,   150,   543,   151,
     151,   155,   150,    88,   689,   151,   148,    83,   553,   152,
      95,   152,   557,   148,   148,   151,   701,   102,     6,   704,
     148,   148,   148,   148,   154,   154,    69,    11,   152,   150,
     152,   716,   151,   148,   152,   152,   152,   116,   152,   149,
     152,   152,   150,   588,   729,   130,   150,   732,   151,   743,
     156,   149,   746,   148,   156,   749,   156,   149,   152,   152,
     148,   148,     5,   152,   552,   148,   151,   149,   154,   150,
     154,   149,    28,   150,    50,   150,    50,   162,   152,   151,
      18,   766,   627,   628,   155,   154,   171,   151,   773,   151,
     151,   776,   151,   778,   151,   780,   151,   151,   151,   162,
     785,   152,   152,   163,   149,   152,   791,   801,   152,   151,
     804,   656,   151,   162,   155,   163,   148,   605,   148,   150,
     148,   155,    18,    18,    18,   152,   152,   152,   152,   152,
     152,   152,   152,   152,   163,   151,    28,    50,   152,    18,
      50,   148,     8,   148,   689,   148,   150,   149,   154,   148,
     923,   836,   152,   148,   155,   343,   154,   702,   482,   343,
     845,   343,   680,   725,   557,   664,   851,   861,   234,   863,
     855,   479,   689,   858,   465,   675,   900,   689,   689,   824,
     486,   675,   677,    56,   197,   730,   608,   202,   733,   734,
     509,   209,   404,   210,   303,    -1,   229,   363,    -1,   211,
       0,   886,    -1,     3,     4,    -1,    -1,    -1,   893,     9,
      -1,    11,    12,    13,    -1,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    -1,    -1,    -1,    -1,    -1,
      -1,    31,    -1,    33,    -1,   929,    -1,    37,    -1,    39,
      -1,    41,    -1,    -1,    -1,    45,    -1,    47,    -1,    -1,
      -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,
      -1,    61,    -1,    63,    -1,    -1,    -1,    67,    68,    -1,
      -1,    -1,    72,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    -1,    82,    83,    84,    -1,    -1,    -1,    88,    -1,
      -1,    -1,    -1,    93,    -1,    -1,    -1,    97,    98,    -1,
     100,    -1,   102,   103,    -1,   105,    -1,   107,   108,    -1,
     110,   111,   112,    -1,    -1,    -1,    -1,   117,   118,    -1,
      -1,   121,   122,   123,   124,   125,   126,    -1,    -1,    -1,
      -1,   131,   132,    -1,   134,   135,   136,   137,    -1,   139,
     140,    -1,   142,    -1,    -1,   145,    -1,    -1,    -1,    -1,
      -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   159,
     160,   161,   162,    -1,    -1,   165,    -1,    -1,   168,   169,
     170,     0,    -1,    -1,     3,     4,    -1,    -1,   923,    -1,
       9,    -1,    11,    12,    13,    -1,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    -1,    -1,    -1,    -1,
      -1,    -1,    31,    -1,    33,    -1,    -1,    -1,    37,    -1,
      39,    -1,    41,    -1,    -1,    -1,    45,    -1,    47,    -1,
      -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    58,
      -1,    -1,    61,    -1,    63,    -1,    -1,    -1,    67,    68,
      -1,    -1,    -1,    72,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    -1,    82,    83,    84,    -1,    -1,    -1,    88,
      -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    97,    98,
      -1,   100,    -1,   102,   103,    -1,   105,    -1,   107,   108,
      -1,   110,   111,   112,    -1,    -1,    -1,    -1,   117,   118,
      -1,    -1,   121,   122,   123,   124,   125,   126,    -1,    -1,
      -1,    -1,   131,   132,    -1,   134,   135,   136,   137,    -1,
     139,   140,    -1,   142,    -1,    -1,   145,    -1,    -1,    -1,
      -1,    -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     159,   160,   161,   162,     3,     4,   165,    -1,    -1,   168,
     169,   170,    11,    12,    13,    -1,    15,    16,    17,    18,
      19,    20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    31,    -1,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,    -1,
      -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    72,    73,    74,    75,    76,    77,    -1,
      -1,    -1,    -1,    82,    -1,    84,    -1,    -1,    -1,    88,
      -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,    98,
      -1,   100,    -1,   102,   103,    -1,    -1,    -1,    -1,    -1,
      -1,   110,    -1,   112,    -1,    -1,    -1,    -1,    -1,   118,
      -1,    -1,    -1,    -1,    -1,    -1,   125,   126,    -1,    -1,
      -1,    -1,   131,    -1,    -1,   134,   135,   136,   137,    -1,
     139,    -1,    -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     159,   160,   161,   162,     3,     4,   165,    -1,    -1,   168,
     169,   170,    11,    12,    13,    -1,    15,    16,    17,    18,
      -1,    20,    21,    -1,    -1,    -1,    25,    -1,    27,    -1,
      -1,    30,    -1,    32,    -1,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      49,    -1,    -1,    52,    -1,    54,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    72,    73,    74,    75,    76,    -1,    78,
      79,    -1,    81,    82,    -1,    84,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    92,    -1,    94,    -1,    -1,    -1,    98,
      -1,    -1,    -1,    -1,   103,    -1,    -1,    -1,    -1,    -1,
     109,   110,    -1,   112,    -1,    -1,   115,    -1,    -1,   118,
     119,   120,    -1,    -1,    -1,    -1,   125,    -1,    -1,    -1,
      -1,    -1,   131,    -1,    -1,   134,   135,   136,   137,   138,
      -1,    -1,    -1,   142,   143,   144,    -1,    -1,    -1,    -1,
      -1,    -1,   151,   152,    -1,    -1,    -1,    -1,     3,     4,
      -1,   160,    -1,   162,    -1,    -1,    11,    12,    13,   168,
      15,    16,    17,    18,    -1,    20,    21,    -1,    -1,    -1,
      25,    -1,    27,    -1,    -1,    30,    -1,    32,    -1,    34,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    49,    -1,    -1,    52,    -1,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    72,    73,    74,
      75,    76,    -1,    78,    79,    -1,    81,    82,    -1,    84,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,    -1,
      -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,   103,    -1,
      -1,    -1,    -1,    -1,   109,   110,    -1,   112,    -1,    -1,
     115,    -1,    -1,   118,   119,   120,    -1,    -1,    -1,    -1,
     125,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,   134,
     135,   136,   137,   138,    -1,    -1,    -1,   142,   143,   144,
      -1,    -1,    -1,    -1,    -1,    -1,   151,    -1,    -1,    -1,
      -1,    -1,     3,     4,    -1,   160,    -1,   162,    -1,    -1,
      11,    12,    13,   168,    15,    16,    17,    18,    -1,    20,
      21,    -1,    -1,    -1,    25,    -1,    27,    -1,    -1,    30,
      -1,    32,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,
      -1,    52,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    72,    73,    74,    75,    76,    -1,    78,    79,    -1,
      81,    82,    -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    92,    -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,
      -1,    -1,   103,    -1,    -1,    -1,    -1,    -1,   109,   110,
      -1,   112,    -1,    -1,   115,    -1,    -1,   118,   119,   120,
      -1,    -1,    -1,    -1,   125,    -1,    -1,    -1,    -1,    -1,
     131,    -1,    -1,   134,   135,   136,   137,   138,    -1,    -1,
      -1,   142,   143,   144,    -1,    -1,    -1,    -1,    -1,    -1,
     151,    -1,    -1,    -1,    -1,    -1,     3,     4,    -1,   160,
      -1,   162,    -1,    -1,    11,    12,    13,   168,    15,    16,
      17,    18,    19,    20,    21,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,    -1,    -1,
      37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      47,    -1,    -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    72,    73,    74,    75,    76,
      77,    -1,    -1,    -1,    -1,    82,    -1,    84,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,
      -1,    98,    -1,   100,    -1,    -1,   103,    -1,    -1,    -1,
      -1,    -1,    -1,   110,    -1,   112,    -1,    -1,    -1,    -1,
      -1,   118,    -1,    -1,    -1,    -1,    -1,    -1,   125,   126,
      -1,    -1,    -1,    -1,   131,    -1,    -1,   134,   135,   136,
     137,    -1,   139,     3,     4,   142,    -1,    -1,    -1,    -1,
      -1,    11,    12,    13,   151,    15,    16,    17,    18,    19,
      20,    21,    -1,   160,   161,   162,    -1,    -1,    -1,    -1,
      -1,   168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    72,    73,    74,    75,    76,    77,    -1,    -1,
      -1,    -1,    82,    -1,    84,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,
      -1,    -1,    -1,   103,    -1,    -1,    -1,    -1,    -1,    -1,
     110,    -1,   112,    -1,    -1,    -1,    -1,    -1,   118,    -1,
      -1,     3,     4,    -1,    -1,   125,   126,    -1,    -1,    -1,
      -1,   131,    -1,    -1,   134,   135,   136,   137,    -1,    -1,
      -1,    -1,   142,    25,    -1,    27,    -1,    29,    30,    -1,
      32,   151,    34,    -1,    -1,    -1,    -1,    39,    -1,    -1,
     160,   161,   162,    -1,    -1,    -1,    -1,    49,   168,    -1,
      52,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      72,    73,    74,    75,    76,    -1,    78,    79,    -1,    81,
      -1,    -1,    84,    -1,    -1,    -1,    22,    23,    24,    -1,
      92,    -1,    -1,    -1,    -1,    -1,    98,    33,    -1,    -1,
      -1,   103,    -1,    39,    -1,    41,    -1,   109,   110,    45,
     112,    -1,    -1,   115,    -1,     0,   118,   119,   120,    -1,
      -1,    -1,    58,   125,     9,    -1,    -1,    -1,    -1,   131,
      -1,    67,   134,   135,   136,   137,   138,    22,    23,    24,
     142,   143,   144,    -1,    -1,    -1,    -1,    83,    33,    -1,
      -1,    -1,    -1,    -1,    39,    -1,    41,   159,    -1,    -1,
      45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,
      -1,   107,   108,    58,    -1,   111,    61,    -1,    63,    -1,
      -1,   117,    67,    68,    -1,   121,   122,   123,   124,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,    83,    -1,
      -1,    -1,    -1,    -1,   140,    -1,    -1,    -1,    -1,   145,
      -1,    -1,    97,    -1,    -1,    -1,    -1,    -1,    -1,   155,
     105,    -1,   107,   108,    -1,    -1,   111,     3,     4,    -1,
      -1,    -1,   117,    -1,    -1,    -1,   121,   122,   123,   124,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   132,    -1,    25,
      -1,    27,    -1,    29,    30,   140,    32,    -1,    34,    -1,
     145,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    49,    -1,    -1,    52,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    72,    73,    74,    75,
      76,    -1,    78,    79,    -1,    81,    -1,    -1,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    92,    -1,    -1,    -1,
      -1,    -1,    98,     3,     4,    -1,    -1,   103,    -1,    -1,
      -1,    -1,    -1,   109,   110,    -1,   112,    -1,    -1,   115,
      -1,    -1,   118,   119,   120,    25,    -1,    27,    -1,   125,
      30,    -1,    32,    -1,    34,   131,    -1,    -1,   134,   135,
     136,   137,   138,    -1,    -1,    -1,   142,   143,   144,    49,
      -1,    -1,    52,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    -1,
      -1,    -1,    72,    73,    74,    75,    76,    33,    78,    79,
      -1,    81,    -1,    39,    84,    41,    -1,    -1,    -1,    45,
      -1,    -1,    92,    -1,    -1,    -1,    -1,    -1,    98,    -1,
      -1,    -1,    58,   103,    -1,    -1,    -1,    -1,    -1,   109,
     110,    67,   112,    -1,    -1,   115,    -1,    -1,   118,   119,
     120,    -1,    -1,    -1,    -1,   125,    -1,    83,    -1,    -1,
      -1,   131,    -1,    -1,   134,   135,   136,   137,   138,    -1,
      -1,    -1,   142,   143,   144,    -1,    -1,    -1,    -1,   105,
      -1,   107,   108,    -1,    -1,   111,    -1,    -1,    22,    23,
      24,   117,    -1,    -1,    -1,   121,   122,   123,   124,    33,
      -1,    -1,    -1,    -1,    -1,    39,   132,    41,    -1,    -1,
      -1,    45,    -1,    -1,   140,    -1,    -1,    -1,    -1,   145,
      -1,    -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,   155,
      -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,    -1,   107,   108,    -1,    -1,   111,    -1,    -1,
      -1,    -1,    -1,   117,    -1,    -1,    -1,   121,   122,   123,
     124,    -1,    25,    -1,    27,    -1,    -1,    30,   132,    32,
      -1,    34,    -1,    -1,    -1,    -1,   140,    -1,    -1,    -1,
      -1,   145,    -1,    -1,    -1,    -1,    49,    -1,    -1,    52,
     154,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    72,
      73,    74,    75,    76,    -1,    78,    79,    -1,    81,    -1,
      -1,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,
      -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,    -1,
     103,    -1,    -1,    -1,    -1,    -1,   109,   110,    -1,   112,
      -1,    -1,   115,    -1,    -1,   118,   119,   120,    -1,    -1,
      -1,    -1,   125,    -1,    -1,    -1,    -1,    -1,   131,    -1,
      -1,   134,   135,   136,   137,   138,    -1,    -1,    -1,   142,
     143,   144
  };

  const short
  Parser::yystos_[] =
  {
       0,   146,   147,   173,    90,   175,   174,   285,   286,     0,
       3,   177,     4,    11,    12,    13,    15,    16,    17,    18,
      19,    20,    21,    31,    37,    47,    51,    72,    73,    74,
      75,    76,    77,    82,    84,    88,    93,    98,   100,   102,
     103,   110,   112,   118,   125,   126,   131,   134,   135,   136,
     137,   139,   142,   151,   159,   160,   161,   162,   165,   168,
     169,   170,   177,   178,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   309,   310,   311,   316,   317,   318,   319,   320,   323,
     324,   325,   148,   168,   151,   157,   228,   151,   151,   151,
     151,   151,   151,   151,   151,   228,   151,   228,   303,    25,
      27,    30,    32,    34,    49,    52,    54,    72,    73,    74,
      75,    76,    78,    79,    81,    84,    92,    98,   103,   109,
     110,   112,   115,   118,   119,   120,   125,   131,   134,   135,
     136,   137,   138,   142,   143,   144,   151,   162,   178,   222,
     230,   233,   236,   239,   245,   309,   151,   311,   315,   303,
     151,   151,   151,   228,   151,   151,   151,   151,   151,   151,
     151,   151,   228,   151,   228,    94,   285,   312,   314,   303,
      17,    18,   306,     7,   285,   289,   290,   321,   322,   303,
     326,   303,   303,   287,   150,    46,    87,    99,   101,   128,
     149,   164,    26,    53,    91,    62,    80,   157,   158,   165,
     166,   156,   113,   114,   160,   161,   104,   159,   167,   168,
      64,    69,    88,    95,   102,   130,   151,   162,   171,   165,
     176,    18,   285,    29,    39,    84,    98,   110,   112,   131,
     142,   178,   222,   223,   224,   226,   227,   285,   285,   285,
     285,   285,   285,   285,   285,   289,   227,   288,   292,   328,
     329,   330,   227,   151,   154,   228,   228,   151,   228,   228,
     228,   228,   154,   228,   151,   246,   228,   228,   285,   151,
     285,   285,   285,   289,   227,   285,   285,   285,   289,   285,
     285,   285,   285,   227,   289,   227,   152,   152,   153,   149,
      58,   163,   153,   153,   163,   165,    14,   285,   292,   292,
     294,   292,   292,   292,   292,   295,   296,   296,   297,   297,
     297,   297,   298,   299,   300,   301,   301,   302,   302,   303,
     303,   303,   303,   118,   177,   308,   304,   304,   308,   289,
     285,   308,   325,   182,   152,   226,   228,   228,   228,   156,
     158,   229,   152,   152,   152,   152,   152,   152,   152,   152,
     229,   150,   152,   153,   153,    18,   177,   237,   238,   227,
     227,    11,   227,   227,   227,   227,   234,   159,   177,   227,
     231,   232,    70,   204,   205,   206,   209,   154,   227,   227,
     289,   152,   153,   152,   152,   229,   152,   152,   152,   152,
     152,   152,   152,   152,   229,   152,   229,   313,   314,   285,
     177,   285,   322,   327,   150,   152,   163,   151,     9,    22,
      23,    24,    33,    41,    45,    58,    67,    68,    83,    97,
     105,   107,   108,   111,   117,   121,   122,   123,   124,   140,
     145,   183,   184,   186,   189,   191,   195,   198,   199,   200,
     201,   215,   220,   221,   285,   227,   227,   227,   151,   151,
     285,   330,   227,   152,   149,   153,   155,   229,   229,   152,
     153,   229,   229,   229,   155,   177,   235,   229,   150,   153,
     229,   152,   153,   177,     9,    67,    97,   115,   121,   141,
     177,   247,   248,   249,   250,   251,   252,   254,   260,   261,
     279,   284,   229,   229,   152,   285,   151,   315,   151,   153,
      69,   168,   285,   289,   148,   149,   285,   288,   285,   148,
     148,   285,   151,   151,   177,   178,   275,   276,   289,   148,
     285,   148,   151,   148,   148,   285,   285,   151,    39,    61,
      63,   132,   148,   153,   229,   229,   285,   312,   229,   240,
      18,   238,   227,   150,   227,   232,   206,   150,   149,   332,
     151,   275,   177,   151,   280,   177,   249,   155,   150,   152,
     312,   312,   313,   285,   152,   285,   148,   148,   150,   148,
     148,   177,    83,   190,   285,    60,   148,   149,   150,   151,
     272,   273,     6,   148,   148,   190,   285,   148,   148,   190,
     285,   178,   202,   178,   178,   227,   152,   152,   151,   154,
     229,   227,   178,   223,   224,   225,   227,   222,   285,     8,
     148,   331,   285,   272,   332,   285,   154,   150,   262,   263,
     152,   152,    67,   163,   148,   285,    69,   177,   148,   152,
     152,   179,   180,   285,   227,   204,   274,   277,   152,   152,
     148,   152,   152,   187,   188,    11,   203,   192,   193,   149,
     229,   328,   177,   241,   242,   243,   332,   149,   210,   148,
     332,   149,   152,   148,   152,    28,   159,   281,   282,   290,
     227,    72,    73,    74,    75,   134,   135,   136,   137,   151,
     178,   224,   253,   257,   259,   309,   116,   264,   285,   148,
     285,   149,   150,   285,   154,   184,   186,   201,   211,   212,
     215,   211,   148,     5,   148,   148,   149,   152,     8,     9,
      59,   106,   212,   278,   154,   154,   285,   211,   211,   149,
     150,   178,   149,   150,   185,   152,   150,   155,   243,   148,
     285,   148,   285,   154,   254,   279,    28,   155,   282,    28,
     210,   151,   151,   151,   151,   151,   151,   151,   151,   178,
     253,   257,   258,   259,   151,   265,   162,   266,   332,   266,
     267,   266,   163,   152,   285,   227,   152,   213,   214,   215,
      50,   216,   216,   181,   285,   149,    36,    44,   217,   218,
     217,   152,   285,   227,   151,   285,   194,   227,   227,    18,
     248,   154,   249,   332,   154,   249,   332,    18,   160,   161,
     255,   255,   255,   255,    18,   160,   256,   256,   256,   256,
     265,   265,   266,   265,   152,   266,   289,   332,   163,   285,
     332,    67,   268,   332,   332,   211,   149,   211,   155,   215,
     211,   148,   285,   219,   288,   150,   155,   218,   155,   211,
     148,   149,   204,   148,   148,   149,   332,    48,   149,   244,
     155,   247,   268,   247,   148,    18,    18,   152,   152,   152,
     152,    18,   152,   152,   152,   152,   332,   332,   265,   332,
     267,   332,   152,   268,   163,   268,   151,    28,   269,   268,
     268,   285,   216,   150,   153,   211,   285,   152,   285,   148,
      18,   285,   332,    50,   283,   155,   148,   155,   332,   332,
     269,   269,   285,   290,   148,   270,   271,   272,   269,   269,
     211,   288,   148,   150,   207,   208,   148,   244,   148,   154,
     148,   268,   270,   270,   152,   272,   270,   270,   227,   332,
     332,   248,   269,   196,   197,   148,   155,   270,   148,   212
  };

  const short
  Parser::yyr1_[] =
  {
       0,   172,   173,   173,   174,   176,   175,   177,   178,   178,
     180,   181,   179,   182,   182,   182,   183,   183,   183,   183,
     183,   183,   183,   185,   184,   187,   186,   188,   186,   189,
     189,   189,   190,   190,   192,   191,   193,   191,   194,   194,
     196,   195,   197,   195,   198,   198,   199,   199,   200,   201,
     201,   201,   202,   203,   203,   204,   204,   205,   205,   206,
     207,   208,   208,   209,   209,   210,   210,   211,   211,   212,
     213,   213,   214,   214,   215,   215,   215,   215,   215,   215,
     215,   215,   215,   215,   215,   215,   215,   215,   215,   215,
     215,   215,   215,   215,   215,   215,   215,   215,   215,   215,
     216,   216,   217,   217,   218,   218,   219,   219,   220,   220,
     220,   221,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   223,
     224,   223,   225,   225,   225,   226,   226,   227,   227,   227,
     227,   228,   229,   230,   230,   231,   231,   231,   232,   232,
     233,   234,   234,   235,   236,   237,   237,   237,   238,   238,
     240,   239,   241,   241,   242,   242,   243,   243,   244,   244,
     245,   246,   246,   247,   247,   248,   248,   249,   249,   249,
     249,   249,   249,   249,   250,   251,   252,   252,   252,   253,
     254,   254,   254,   254,   254,   254,   255,   255,   255,   256,
     256,   257,   257,   257,   257,   257,   257,   257,   257,   257,
     258,   258,   258,   258,   258,   259,   260,   261,   261,   263,
     262,   264,   264,   265,   265,   266,   266,   267,   267,   268,
     268,   269,   269,   270,   270,   271,   271,   272,   273,   273,
     274,   274,   276,   277,   275,   278,   278,   278,   278,   279,
     280,   280,   281,   281,   282,   282,   282,   282,   282,   282,
     283,   283,   284,   286,   287,   285,   288,   289,   289,   290,
     290,   291,   291,   292,   292,   292,   292,   292,   292,   292,
     293,   293,   294,   294,   295,   295,   295,   296,   296,   296,
     296,   296,   297,   297,   298,   298,   299,   299,   300,   300,
     300,   301,   301,   301,   302,   302,   302,   302,   302,   303,
     303,   303,   303,   303,   303,   303,   304,   304,   304,   304,
     304,   304,   304,   304,   304,   304,   304,   305,   305,   305,
     305,   305,   305,   305,   305,   305,   305,   306,   306,   306,
     306,   306,   306,   307,   307,   307,   307,   308,   308,   309,
     309,   309,   309,   309,   309,   309,   309,   309,   309,   309,
     309,   309,   309,   309,   309,   309,   309,   309,   309,   309,
     310,   310,   310,   310,   310,   310,   310,   310,   310,   310,
     310,   310,   310,   310,   311,   311,   312,   312,   312,   313,
     313,   313,   313,   314,   314,   315,   316,   316,   316,   317,
     317,   318,   318,   319,   319,   320,   321,   321,   322,   323,
     324,   324,   326,   327,   325,   328,   328,   329,   329,   330,
     331,   331,   332,   332
  };

  const signed char
  Parser::yyr2_[] =
  {
       0,     2,     2,     2,     1,     0,     5,     1,     1,     1,
       0,     0,     3,     2,     2,     0,     1,     1,     1,     1,
       1,     1,     1,     0,     8,     0,     7,     0,     9,     5,
       5,     7,     6,     4,     0,     7,     0,     6,     2,     4,
       0,    12,     0,    12,     3,     5,     2,     4,     3,     1,
       1,     0,     0,     1,     0,     1,     0,     3,     1,     5,
       2,     1,     0,     1,     0,     2,     0,     1,     1,     3,
       1,     0,     2,     1,     2,     1,     3,     5,     3,     2,
       2,     7,     6,     6,     8,     3,     2,     3,     2,     3,
       7,     7,     2,     2,     7,     5,     5,     3,     3,     3,
       2,     0,     2,     1,     4,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     4,     4,     4,     4,     6,
       4,     4,     1,     4,     1,     1,     1,     1,     1,     2,
       1,     2,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     4,     4,     3,     2,     1,     1,     3,
       4,     2,     0,     5,     4,     3,     2,     1,     1,     3,
       0,     8,     1,     0,     2,     1,     8,     6,     2,     0,
       5,     3,     0,     2,     1,     1,     0,     1,     1,     1,
       1,     1,     1,     1,     7,     4,     3,     5,     4,     1,
       8,     9,     9,     9,     9,    11,     1,     2,     2,     1,
       2,     1,     4,     4,     4,     4,     4,     4,     4,     4,
       3,     3,     3,     3,     4,     2,     3,     1,     0,     0,
       2,     1,     0,     3,     0,     3,     2,     1,     0,     4,
       0,     2,     0,     1,     1,     2,     1,     3,     3,     0,
       2,     0,     0,     0,     3,     1,     3,     1,     1,     8,
       3,     0,     2,     1,     5,     5,     3,     3,     2,     2,
       4,     0,     9,     0,     0,     3,     1,     1,     0,     3,
       1,     1,     3,     3,     3,     3,     3,     3,     5,     1,
       3,     1,     3,     1,     3,     3,     1,     3,     3,     3,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     3,
       1,     3,     3,     1,     3,     3,     3,     3,     1,     2,
       2,     2,     3,     2,     2,     1,     4,     3,     6,     4,
       3,     3,     3,     2,     2,     3,     1,     7,     2,     5,
       4,     4,     2,     2,     2,     5,     1,     1,     1,     2,
       7,     9,     1,     3,     1,     1,     1,     1,     1,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       2,     4,     4,     1,     1,     1,     1,     1,     1,     1,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     6,     3,     4,     1,     3,     0,     1,
       3,     1,     0,     1,     1,     1,     3,     4,     7,     4,
       7,     4,     7,     4,     9,     3,     3,     1,     3,     1,
       3,     1,     0,     0,     5,     1,     0,     3,     1,     3,
       1,     3,     2,     0
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const Parser::yytname_[] =
  {
  "\"<end of input>\"", "error", "\"invalid token\"", "\"identifier\"",
  "\"scoped identifier\"", "\"dotted identifier\"", "\"hook identifier\"",
  "\"$-identifier\"", "\"attribute\"", "\"property\"",
  "\"preprocessor directive\"", "\"string value\"", "\"bytes value\"",
  "\"error value\"", "\"regular expression value\"", "\"address value\"",
  "\"port value\"", "\"real value\"", "\"unsigned integer value\"",
  "\"$<N>\"", "\"bool value\"", "\"null value\"", "\"assert\"",
  "\"assert-exception\"", "ADD", "ADDRESS", "AND", "ANY", "ARROW", "AUTO",
  "BITFIELD", "BEGIN_", "BOOL", "BREAK", "BYTES", "CADDR", "CASE", "CAST",
  "CATCH", "CONST", "CONSTANT", "CONTINUE", "DEBUG_", "DECLARE", "DEFAULT",
  "DELETE", "DIVIDEASSIGN", "DOLLARDOLLAR", "DOTDOT", "REAL", "ELSE",
  "END_", "ENUM", "EQ", "__ERROR", "EXCEPTION", "EXPORT", "FILE", "FOR",
  "FOREACH", "FROM", "FUNCTION", "GEQ", "GLOBAL", "HASATTR",
  "HOOK_COMPOSE", "HOOK_PARSE", "IF", "IMPORT", "IN", "INOUT", "INT",
  "INT16", "INT32", "INT64", "INT8", "INTERVAL", "INTERVAL_NS", "ITERATOR",
  "CONST_ITERATOR", "LEQ", "\"library type\"", "LIST", "LOCAL", "MAP",
  "MARK", "CAPTURES", "MINUSASSIGN", "MINUSMINUS", "MOD", "MODULE", "NEQ",
  "NETWORK", "NEW", "NONE", "NOT_IN", "OBJECT", "ON", "OPTIONAL", "OR",
  "PACK", "PLUSASSIGN", "PLUSPLUS", "PORT", "POW", "PRINT", "PRIORITY",
  "PRIVATE", "PUBLIC", "REGEXP", "RESULT", "RETURN", "SET", "SHIFTLEFT",
  "SHIFTRIGHT", "SINK", "SKIP", "STOP", "\"stream\"", "STRING", "STRUCT",
  "SWITCH", "\"confirm\"", "\"reject\"", "THROW", "TIME", "TIME_NS",
  "TIMER", "TIMESASSIGN", "TRY", "TRYATTR", "TUPLE", "TYPE", "UINT",
  "UINT16", "UINT32", "UINT64", "UINT8", "UNIT", "UNPACK", "UNSET", "VAR",
  "VECTOR", "VIEW", "VOID", "WHILE", "START_MODULE", "START_EXPRESSION",
  "';'", "'='", "':'", "'('", "')'", "','", "'{'", "'}'", "'&'", "'<'",
  "'>'", "'*'", "'+'", "'-'", "'['", "']'", "'?'", "'|'", "'^'", "'%'",
  "'/'", "'!'", "'~'", "'.'", "$accept", "start", "start_expr", "module",
  "$@1", "local_id", "scoped_id", "dotted_id", "$@2", "$@3",
  "global_scope_items", "global_scope_decl", "type_decl", "$@4",
  "constant_decl", "$@5", "$@6", "local_decl", "local_init_decl",
  "global_decl", "$@7", "$@8", "global_decl_type_and_init",
  "function_decl", "$@9", "$@10", "import_decl", "property_decl",
  "hook_decl", "opt_linkage", "opt_func_flavor", "opt_func_cc",
  "opt_func_params", "func_params", "func_param", "func_result",
  "opt_func_result", "opt_func_param_kind", "opt_init_expression", "block",
  "braced_block", "opt_stmts", "stmts", "stmt", "opt_else_block",
  "switch_cases", "switch_case", "case_exprs", "stmt_decl", "stmt_expr",
  "base_type_no_ref", "reference_type", "base_type", "type", "type_no_ref",
  "qtype", "type_param_begin", "type_param_end", "tuple_type",
  "tuple_type_elems", "tuple_type_elem", "struct_type", "struct_fields",
  "struct_field", "enum_type", "enum_labels", "enum_label",
  "bitfield_type", "$@11", "opt_bitfield_bit_ranges",
  "bitfield_bit_ranges", "bitfield_bit_range", "opt_bitfield_range_value",
  "unit_type", "opt_unit_params", "unit_items", "opt_unit_items",
  "unit_item", "unit_variable", "unit_sink", "unit_property",
  "unit_field_base_type", "unit_field", "const_sint", "const_uint",
  "unit_field_ctor", "unit_field_in_container", "scoped_id_in_container",
  "unit_wide_hook", "opt_unit_field_id", "opt_skip", "$@12", "opt_skip_",
  "opt_unit_field_args", "unit_field_repeat", "opt_unit_field_repeat",
  "opt_unit_field_condition", "opt_unit_field_sinks",
  "opt_unit_item_hooks", "unit_hooks", "unit_hook", "opt_unit_hook_params",
  "opt_unit_hook_attributes", "unit_hook_id", "$@13", "$@14",
  "unit_hook_attribute", "unit_switch", "opt_unit_switch_expr",
  "unit_switch_cases", "unit_switch_case", "opt_unit_block_else_items",
  "unit_block", "expr", "$@15", "$@16", "expr_no_or_error", "opt_exprs",
  "exprs", "expr_0", "expr_1", "expr_2", "expr_3", "expr_4", "expr_5",
  "expr_6", "expr_7", "expr_8", "expr_9", "expr_a", "expr_b", "expr_c",
  "expr_d", "expr_e", "expr_f", "expr_g", "member_expr", "ctor",
  "ctor_expr", "tuple", "opt_tuple_elems1", "opt_tuple_elems2",
  "tuple_elem", "tuple_expr", "list", "vector", "set", "map", "struct_",
  "struct_elems", "struct_elem", "regexp", "re_patterns",
  "re_pattern_constant", "$@17", "$@18", "opt_map_elems", "map_elems",
  "map_elem", "attribute", "opt_attributes", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  Parser::yyrline_[] =
  {
       0,   327,   327,   328,   331,   333,   333,   343,   355,   356,
     358,   360,   358,   365,   367,   369,   373,   374,   375,   376,
     377,   378,   379,   381,   381,   399,   399,   405,   405,   412,
     413,   414,   419,   421,   425,   425,   431,   431,   439,   440,
     443,   442,   453,   452,   463,   464,   467,   468,   471,   479,
     480,   481,   485,   487,   493,   497,   498,   500,   501,   503,
     506,   508,   509,   512,   513,   516,   517,   522,   523,   526,
     528,   529,   531,   532,   534,   535,   536,   537,   539,   541,
     542,   543,   545,   547,   549,   551,   552,   553,   554,   555,
     556,   558,   560,   561,   562,   564,   566,   569,   577,   585,
     596,   597,   599,   600,   602,   603,   605,   606,   608,   609,
     610,   613,   618,   619,   620,   621,   622,   623,   624,   625,
     626,   627,   628,   629,   630,   631,   633,   634,   635,   636,
     637,   638,   639,   640,   642,   643,   644,   645,   646,   648,
     649,   650,   652,   654,   656,   657,   658,   659,   660,   665,
     670,   671,   677,   678,   679,   682,   683,   686,   687,   688,
     689,   693,   697,   700,   701,   705,   707,   708,   712,   713,
     716,   718,   719,   721,   723,   725,   726,   727,   730,   731,
     735,   734,   740,   742,   745,   747,   750,   752,   756,   757,
     763,   767,   768,   770,   771,   773,   774,   777,   778,   779,
     780,   781,   782,   783,   787,   790,   792,   793,   795,   797,
     802,   804,   809,   812,   814,   816,   819,   820,   821,   823,
     824,   827,   828,   829,   830,   831,   832,   833,   834,   835,
     838,   840,   842,   844,   846,   852,   854,   857,   858,   861,
     861,   866,   867,   870,   871,   874,   875,   878,   879,   882,
     883,   886,   887,   890,   891,   893,   894,   896,   900,   901,
     904,   906,   908,   910,   908,   913,   914,   915,   920,   926,
     929,   930,   933,   935,   938,   939,   940,   941,   942,   943,
     946,   947,   949,   957,   959,   957,   964,   966,   967,   969,
     970,   972,   973,   976,   977,   978,   979,   980,   981,   982,
     984,   985,   987,   988,   990,   991,   992,   994,   995,   996,
     997,   998,  1000,  1001,  1003,  1004,  1006,  1007,  1009,  1010,
    1011,  1013,  1014,  1015,  1017,  1018,  1019,  1020,  1021,  1023,
    1024,  1025,  1026,  1027,  1028,  1029,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,  1039,  1040,  1041,  1043,  1044,  1045,
    1046,  1047,  1048,  1049,  1050,  1051,  1052,  1054,  1055,  1056,
    1057,  1059,  1061,  1063,  1064,  1065,  1066,  1072,  1073,  1077,
    1078,  1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1091,
    1092,  1097,  1098,  1100,  1101,  1102,  1103,  1104,  1105,  1106,
    1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,
    1119,  1120,  1121,  1122,  1125,  1126,  1129,  1130,  1131,  1134,
    1135,  1136,  1137,  1140,  1141,  1143,  1145,  1146,  1147,  1150,
    1151,  1154,  1155,  1158,  1159,  1162,  1165,  1166,  1168,  1170,
    1172,  1174,  1177,  1177,  1177,  1180,  1181,  1183,  1184,  1186,
    1190,  1197,  1206,  1211
  };

  void
  Parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  Parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  Parser::symbol_kind_type
  Parser::yytranslate_ (int t) YY_NOEXCEPT
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const unsigned char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   169,     2,     2,     2,   167,   156,     2,
     151,   152,   159,   160,   153,   161,   171,   168,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   150,   148,
     157,   149,   158,   164,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   162,     2,   163,   166,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   154,   165,   155,   170,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147
    };
    // Last valid token kind.
    const int code_max = 402;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return static_cast <symbol_kind_type> (translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

#line 29 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"
} } } // spicy::detail::parser
#line 7092 "/build/zeek/src/zeek/build/auxil/spicy/spicy/src/autogen/__parser.cc"

#line 1213 "/build/zeek/src/zeek/auxil/spicy/spicy/toolchain/src/compiler/parser/parser.yy"


void spicy::detail::parser::Parser::error(const Parser::location_type& l, const std::string& m) {
    driver->error(m, toMeta(l));
}
