// Begin of LDAP (from "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy")
// Compiled by HILTI version 1.13.0-dev.2

#include <hilti/rt/compiler-setup.h>

#include <spicy/rt/libspicy.h>
#include <hilti/rt/libhilti.h>

extern const char* __hlt_ldap_hlto_scope;

namespace __hlt_ldap::ASN1 {
    struct ASN1BitString;
    struct ASN1Tag;
    struct LengthType;
    struct ASN1Header;
    struct ASN1SubMessages;
    struct ASN1Message;
    struct ASN1Body;
    struct ASN1ObjectIdentifier;
    struct ASN1OctetString;
}

namespace __hlt_ldap::LDAP {
    struct Ctx;
    struct GSS_SPNEGO_negTokenInit;
    struct GSS_SPNEGO_Init;
    struct GSS_SPNEGO_negTokenResp;
    struct GSS_SPNEGO_Subsequent;
    struct Result;
    struct SaslCredentials;
    struct ServerSaslCreds;
    struct UnbindRequest;
    struct SearchResultEntry;
    struct SearchResultDone;
    struct SearchRequest;
    struct NotImplemented;
    struct ModifyResponse;
    struct ModifyRequest;
    struct ModDNResponse;
    struct Message;
    struct ExtendedResponseEntry;
    struct ExtendedResponse;
    struct ExtendedRequest;
    struct DelResponse;
    struct DelRequest;
    struct CompareResponse;
    struct BindResponse;
    struct BindRequest;
    struct AddResponse;
    struct AbandonRequest;
    struct AttributeSelection;
    struct AttributeValueAssertion;
    struct DecodedAttributeValue;
    struct EncryptedMessage;
    struct KrbWrapToken;
    struct SaslMsKrb5Stripper;
    struct TlsForward;
    struct MessageDispatch;
    struct MaybeEncrypted;
    struct Messages;
    struct SubstringFilter;
    struct SearchFilter;
    struct ParseNestedNot;
    struct ParseNestedAndOr;
}

namespace __hlt_ldap::ASN1 {
    HILTI_RT_ENUM_WITH_DEFAULT(ASN1Class, Undef, Universal = 0, Application = 1, ContextSpecific = 2, Private = 3, Undef = -1);;
    HILTI_RT_ENUM_WITH_DEFAULT(ASN1Type, Undef, Boolean = 1, Integer = 2, BitString = 3, OctetString = 4, NullVal = 5, ObjectIdentifier = 6, ObjectDescriptor = 7, InstanceOf = 8, Real = 9, Enumerated = 10, EmbeddedPDV = 11, UTF8String = 12, RelativeOID = 13, Sequence = 16, Set = 17, NumericString = 18, PrintableString = 19, TeletextString = 20, VideotextString = 21, IA5String = 22, UTCTime = 23, GeneralizedTime = 24, GraphicString = 25, VisibleString = 26, GeneralString = 27, UniversalString = 28, CharacterString = 29, BMPString = 30, Undef = -1);;
}

namespace __hlt_ldap::LDAP {
    HILTI_RT_ENUM_WITH_DEFAULT(BindAuthType, Undef, BIND_AUTH_SIMPLE = 0, BIND_AUTH_SASL = 3, Undef = -1);;
    HILTI_RT_ENUM_WITH_DEFAULT(MessageMode, Undef, MS_KRB5 = 1, TLS = 2, MAYBE_ENCRYPTED = 3, CLEARTEXT = 4, ENCRYPTED = 5, Undef = -1);;
    HILTI_RT_ENUM_WITH_DEFAULT(ProtocolOpcode, Undef, BIND_REQUEST = 0, BIND_RESPONSE = 1, UNBIND_REQUEST = 2, SEARCH_REQUEST = 3, SEARCH_RESULT_ENTRY = 4, SEARCH_RESULT_DONE = 5, MODIFY_REQUEST = 6, MODIFY_RESPONSE = 7, ADD_REQUEST = 8, ADD_RESPONSE = 9, DEL_REQUEST = 10, DEL_RESPONSE = 11, MOD_DN_REQUEST = 12, MOD_DN_RESPONSE = 13, COMPARE_REQUEST = 14, COMPARE_RESPONSE = 15, ABANDON_REQUEST = 16, SEARCH_RESULT_REFERENCE = 19, EXTENDED_REQUEST = 23, EXTENDED_RESPONSE = 24, INTERMEDIATE_RESPONSE = 25, Undef = -1);;
    HILTI_RT_ENUM_WITH_DEFAULT(ResultCode, Undef, SUCCESS = 0, OPERATIONS_ERROR = 1, PROTOCOL_ERROR = 2, TIME_LIMIT_EXCEEDED = 3, SIZE_LIMIT_EXCEEDED = 4, COMPARE_FALSE = 5, COMPARE_TRUE = 6, AUTH_METHOD_NOT_SUPPORTED = 7, STRONGER_AUTH_REQUIRED = 8, PARTIAL_RESULTS = 9, REFERRAL = 10, ADMIN_LIMIT_EXCEEDED = 11, UNAVAILABLE_CRITICAL_EXTENSION = 12, CONFIDENTIALITY_REQUIRED = 13, SASL_BIND_IN_PROGRESS = 14, NO_SUCH_ATTRIBUTE = 16, UNDEFINED_ATTRIBUTE_TYPE = 17, INAPPROPRIATE_MATCHING = 18, CONSTRAINT_VIOLATION = 19, ATTRIBUTE_OR_VALUE_EXISTS = 20, INVALID_ATTRIBUTE_SYNTAX = 21, NO_SUCH_OBJECT = 32, ALIAS_PROBLEM = 33, INVALID_DNSYNTAX = 34, ALIAS_DEREFERENCING_PROBLEM = 36, INAPPROPRIATE_AUTHENTICATION = 48, INVALID_CREDENTIALS = 49, INSUFFICIENT_ACCESS_RIGHTS = 50, BUSY = 51, UNAVAILABLE = 52, UNWILLING_TO_PERFORM = 53, LOOP_DETECT = 54, SORT_CONTROL_MISSING = 60, OFFSET_RANGE_ERROR = 61, NAMING_VIOLATION = 64, OBJECT_CLASS_VIOLATION = 65, NOT_ALLOWED_ON_NON_LEAF = 66, NOT_ALLOWED_ON_RDN = 67, ENTRY_ALREADY_EXISTS = 68, OBJECT_CLASS_MODS_PROHIBITED = 69, RESULTS_TOO_LARGE = 70, AFFECTS_MULTIPLE_DSAS = 71, CONTROL_ERROR = 76, OTHER = 80, SERVER_DOWN = 81, LOCAL_ERROR = 82, ENCODING_ERROR = 83, DECODING_ERROR = 84, TIMEOUT = 85, AUTH_UNKNOWN = 86, FILTER_ERROR = 87, USER_CANCELED = 88, PARAM_ERROR = 89, NO_MEMORY = 90, CONNECT_ERROR = 91, NOT_SUPPORTED = 92, CONTROL_NOT_FOUND = 93, NO_RESULTS_RETURNED = 94, MORE_RESULTS_TO_RETURN = 95, CLIENT_LOOP = 96, REFERRAL_LIMIT_EXCEEDED = 97, INVALID_RESPONSE = 100, AMBIGUOUS_RESPONSE = 101, TLS_NOT_SUPPORTED = 112, INTERMEDIATE_RESPONSE = 113, UNKNOWN_TYPE = 114, LCUP_INVALID_DATA = 115, LCUP_UNSUPPORTED_SCHEME = 116, LCUP_RELOAD_REQUIRED = 117, CANCELED = 118, NO_SUCH_OPERATION = 119, TOO_LATE = 120, CANNOT_CANCEL = 121, ASSERTION_FAILED = 122, AUTHORIZATION_DENIED = 123, Undef = -1);;
    HILTI_RT_ENUM_WITH_DEFAULT(SearchDerefAlias, Undef, DEREF_NEVER = 0, DEREF_IN_SEARCHING = 1, DEREF_FINDING_BASE = 2, DEREF_ALWAYS = 3, Undef = -1);;
    HILTI_RT_ENUM_WITH_DEFAULT(SearchScope, Undef, SEARCH_BASE = 0, SEARCH_SINGLE = 1, SEARCH_TREE = 2, Undef = -1);;
    HILTI_RT_ENUM_WITH_DEFAULT(FilterType, Undef, FILTER_AND = 0, FILTER_OR = 1, FILTER_NOT = 2, FILTER_EQ = 3, FILTER_SUBSTR = 4, FILTER_GE = 5, FILTER_LE = 6, FILTER_PRESENT = 7, FILTER_APPROX = 8, FILTER_EXT = 9, FILTER_INVALID = 254, Undef = -1);;
}

namespace __hlt_ldap::ASN1 {
    struct ASN1BitString : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ASN1BitString> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1BitString>::self(this); }
        std::optional<::hilti::rt::Bytes> value_bits{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1BitString_32_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::integer::safe<uint64_t> __p_len{};
        ::hilti::rt::Bool __p_constructed{};
        ASN1BitString();
        ASN1BitString(const ASN1BitString&) = default;
        ASN1BitString(ASN1BitString&&) = default;
        ASN1BitString& operator=(const ASN1BitString&) = default;
        ASN1BitString& operator=(ASN1BitString&&) = default;
        ASN1BitString(std::optional<std::optional<::hilti::rt::Bytes>> value_bits);
        ASN1BitString(const ::hilti::rt::integer::safe<uint64_t>& __p_len, const ::hilti::rt::Bool& __p_constructed);
        template<typename F> void __visit(F _) const { _("value_bits", value_bits); }
    };

    struct ASN1Tag : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ASN1Tag> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1Tag>::self(this); }
        std::optional<::hilti::rt::Bitfield<ASN1::ASN1Type, ::hilti::rt::Bool, ASN1::ASN1Class, ::hilti::rt::integer::safe<uint8_t>>> _anon_46{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1Tag_35_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ASN1Tag();
        ASN1Tag(const ASN1Tag&) = default;
        ASN1Tag(ASN1Tag&&) = default;
        ASN1Tag& operator=(const ASN1Tag&) = default;
        ASN1Tag& operator=(ASN1Tag&&) = default;
        ASN1Tag(std::optional<std::optional<::hilti::rt::Bitfield<ASN1::ASN1Type, ::hilti::rt::Bool, ASN1::ASN1Class, ::hilti::rt::integer::safe<uint8_t>>>> _anon_46);
        template<typename F> void __visit(F _) const { _("<anon>", _anon_46); }
    };

    struct LengthType : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<LengthType> {
        auto __self() { return ::hilti::rt::ValueReference<LengthType>::self(this); }
        ::hilti::rt::integer::safe<uint64_t> len{};
        ::hilti::rt::integer::safe<uint8_t> tag_len{};
        std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>> data{};
        void __on__anon_44();
        void __on__anon_45(const ::hilti::rt::integer::safe<uint64_t>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_152_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__LengthType_35_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        LengthType();
        LengthType(const LengthType&) = default;
        LengthType(LengthType&&) = default;
        LengthType& operator=(const LengthType&) = default;
        LengthType& operator=(LengthType&&) = default;
        LengthType(std::optional<::hilti::rt::integer::safe<uint64_t>> len, std::optional<::hilti::rt::integer::safe<uint8_t>> tag_len, std::optional<std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> data);
        template<typename F> void __visit(F _) const { _("len", len); _("tag_len", tag_len); _("data", data); }
    };

    struct ASN1Header : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ASN1Header> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1Header>::self(this); }
        std::optional<::hilti::rt::ValueReference<ASN1Tag>> tag{};
        std::optional<::hilti::rt::ValueReference<LengthType>> len{};
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<ASN1Header>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_ASN1__ASN1Header_35_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ASN1Header();
        ASN1Header(const ASN1Header&) = default;
        ASN1Header(ASN1Header&&) = default;
        ASN1Header& operator=(const ASN1Header&) = default;
        ASN1Header& operator=(ASN1Header&&) = default;
        ASN1Header(std::optional<std::optional<::hilti::rt::ValueReference<ASN1Tag>>> tag, std::optional<std::optional<::hilti::rt::ValueReference<LengthType>>> len);
        template<typename F> void __visit(F _) const { _("tag", tag); _("len", len); }
    };

    struct ASN1SubMessages : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ASN1SubMessages> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1SubMessages>::self(this); }
        std::optional<::hilti::rt::Vector<ASN1Message>> submessages{};
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<ASN1SubMessages>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_submessages_33_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<ASN1Message>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1SubMessages_33_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::integer::safe<uint64_t> __p_msgLen{};
        ASN1SubMessages();
        ASN1SubMessages(const ASN1SubMessages&) = default;
        ASN1SubMessages(ASN1SubMessages&&) = default;
        ASN1SubMessages& operator=(const ASN1SubMessages&) = default;
        ASN1SubMessages& operator=(ASN1SubMessages&&) = default;
        ASN1SubMessages(std::optional<std::optional<::hilti::rt::Vector<ASN1Message>>> submessages);
        ASN1SubMessages(const ::hilti::rt::integer::safe<uint64_t>& __p_msgLen);
        template<typename F> void __visit(F _) const { _("submessages", submessages); }
    };

    struct ASN1Message : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ASN1Message> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1Message>::self(this); }
        ::hilti::rt::integer::safe<int32_t> application_id{};
        std::optional<::hilti::rt::ValueReference<ASN1Header>> head{};
        std::optional<::hilti::rt::ValueReference<ASN1Body>> body{};
        std::optional<::hilti::rt::Bytes> application_data{};
        void __on_application_data(const ::hilti::rt::Bytes& __dd);
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<ASN1Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_161_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1Message_34_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::Bool __p_recursive{};
        ASN1Message();
        ASN1Message(const ASN1Message&) = default;
        ASN1Message(ASN1Message&&) = default;
        ASN1Message& operator=(const ASN1Message&) = default;
        ASN1Message& operator=(ASN1Message&&) = default;
        ASN1Message(std::optional<::hilti::rt::integer::safe<int32_t>> application_id, std::optional<std::optional<::hilti::rt::ValueReference<ASN1Header>>> head, std::optional<std::optional<::hilti::rt::ValueReference<ASN1Body>>> body, std::optional<std::optional<::hilti::rt::Bytes>> application_data);
        ASN1Message(const ::hilti::rt::Bool& __p_recursive);
        template<typename F> void __visit(F _) const { _("application_id", application_id); _("head", head); _("body", body); _("application_data", application_data); }
    };

    struct ASN1Body : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ASN1Body> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1Body>::self(this); }
        std::optional<::hilti::rt::Bool> bool_value{};
        std::optional<::hilti::rt::integer::safe<int64_t>> num_value{};
        std::optional<::hilti::rt::Bytes> null_value{};
        std::optional<::hilti::rt::ValueReference<ASN1BitString>> bitstr_value{};
        std::optional<std::string> str_value{};
        std::optional<::hilti::rt::ValueReference<ASN1SubMessages>> seq{};
        std::optional<::hilti::rt::Bytes> unimplemented_value{};
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<ASN1Body>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_154_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1Body_32_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<ASN1Header> __p_head{};
        ::hilti::rt::Bool __p_recursive{};
        ASN1Body();
        ASN1Body(const ASN1Body&) = default;
        ASN1Body(ASN1Body&&) = default;
        ASN1Body& operator=(const ASN1Body&) = default;
        ASN1Body& operator=(ASN1Body&&) = default;
        ASN1Body(std::optional<std::optional<::hilti::rt::Bool>> bool_value, std::optional<std::optional<::hilti::rt::integer::safe<int64_t>>> num_value, std::optional<std::optional<::hilti::rt::Bytes>> null_value, std::optional<std::optional<::hilti::rt::ValueReference<ASN1BitString>>> bitstr_value, std::optional<std::optional<std::string>> str_value, std::optional<std::optional<::hilti::rt::ValueReference<ASN1SubMessages>>> seq, std::optional<std::optional<::hilti::rt::Bytes>> unimplemented_value);
        ASN1Body(const ::hilti::rt::ValueReference<ASN1Header>& __p_head, const ::hilti::rt::Bool& __p_recursive);
        template<typename F> void __visit(F _) const { _("bool_value", bool_value); _("num_value", num_value); _("null_value", null_value); _("bitstr_value", bitstr_value); _("str_value", str_value); _("seq", seq); _("unimplemented_value", unimplemented_value); }
    };

    struct ASN1ObjectIdentifier : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ASN1ObjectIdentifier> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1ObjectIdentifier>::self(this); }
        ::hilti::rt::Bytes oidbytes{};
        ::hilti::rt::integer::safe<uint64_t> temp{};
        std::string oidstring{};
        void __on__anon_48(const ::hilti::rt::integer::safe<uint8_t>& __dd);
        std::optional<::hilti::rt::Vector<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> sublist{};
        void __on_sublist_foreach(const ::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>& __dd, ::hilti::rt::Bool& __stop);
        std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>> _anon_50{};
        std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>> _anon_49{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_sublist_34_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1ObjectIdentifier_34_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::integer::safe<uint64_t> __p_len{};
        ASN1ObjectIdentifier();
        ASN1ObjectIdentifier(const ASN1ObjectIdentifier&) = default;
        ASN1ObjectIdentifier(ASN1ObjectIdentifier&&) = default;
        ASN1ObjectIdentifier& operator=(const ASN1ObjectIdentifier&) = default;
        ASN1ObjectIdentifier& operator=(ASN1ObjectIdentifier&&) = default;
        ASN1ObjectIdentifier(std::optional<::hilti::rt::Bytes> oidbytes, std::optional<::hilti::rt::integer::safe<uint64_t>> temp, std::optional<std::string> oidstring, std::optional<std::optional<::hilti::rt::Vector<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>>> sublist, std::optional<std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> _anon_50, std::optional<std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> _anon_49);
        ASN1ObjectIdentifier(const ::hilti::rt::integer::safe<uint64_t>& __p_len);
        template<typename F> void __visit(F _) const { _("oidbytes", oidbytes); _("temp", temp); _("oidstring", oidstring); _("sublist", sublist); _("<anon>", _anon_50); _("<anon>", _anon_49); }
    };

    struct ASN1OctetString : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ASN1OctetString> {
        auto __self() { return ::hilti::rt::ValueReference<ASN1OctetString>::self(this); }
        std::optional<::hilti::rt::Bytes> value{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_ASN1__ASN1OctetString_32_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::integer::safe<uint64_t> __p_len{};
        ::hilti::rt::Bool __p_constructed{};
        ASN1OctetString();
        ASN1OctetString(const ASN1OctetString&) = default;
        ASN1OctetString(ASN1OctetString&&) = default;
        ASN1OctetString& operator=(const ASN1OctetString&) = default;
        ASN1OctetString& operator=(ASN1OctetString&&) = default;
        ASN1OctetString(std::optional<std::optional<::hilti::rt::Bytes>> value);
        ASN1OctetString(const ::hilti::rt::integer::safe<uint64_t>& __p_len, const ::hilti::rt::Bool& __p_constructed);
        template<typename F> void __visit(F _) const { _("value", value); }
    };

}

namespace __hlt_ldap::LDAP {
    struct Ctx : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<Ctx> {
        auto __self() { return ::hilti::rt::ValueReference<Ctx>::self(this); }
        LDAP::MessageMode messageMode{};
        std::string saslMechanism{};
        ::hilti::rt::Bool startTlsRequested{};
        Ctx();
        Ctx(const Ctx&) = default;
        Ctx(Ctx&&) = default;
        Ctx& operator=(const Ctx&) = default;
        Ctx& operator=(Ctx&&) = default;
        Ctx(std::optional<LDAP::MessageMode> messageMode, std::optional<std::string> saslMechanism, std::optional<::hilti::rt::Bool> startTlsRequested);
        template<typename F> void __visit(F _) const { _("messageMode", messageMode); _("saslMechanism", saslMechanism); _("startTlsRequested", startTlsRequested); }
    };

    struct GSS_SPNEGO_negTokenInit : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<GSS_SPNEGO_negTokenInit> {
        auto __self() { return ::hilti::rt::ValueReference<GSS_SPNEGO_negTokenInit>::self(this); }
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>> oidHeader{};
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1ObjectIdentifier>> oid{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__GSS_SPNEGO_negTokenInit_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        GSS_SPNEGO_negTokenInit();
        GSS_SPNEGO_negTokenInit(const GSS_SPNEGO_negTokenInit&) = default;
        GSS_SPNEGO_negTokenInit(GSS_SPNEGO_negTokenInit&&) = default;
        GSS_SPNEGO_negTokenInit& operator=(const GSS_SPNEGO_negTokenInit&) = default;
        GSS_SPNEGO_negTokenInit& operator=(GSS_SPNEGO_negTokenInit&&) = default;
        GSS_SPNEGO_negTokenInit(std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> oidHeader, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1ObjectIdentifier>>> oid);
        template<typename F> void __visit(F _) const { _("oidHeader", oidHeader); _("oid", oid); }
    };

    struct GSS_SPNEGO_Init : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<GSS_SPNEGO_Init> {
        auto __self() { return ::hilti::rt::ValueReference<GSS_SPNEGO_Init>::self(this); }
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>> credentialsHeader{};
        std::optional<::hilti::rt::integer::safe<uint8_t>> spnegoInitByte{};
        std::optional<::hilti::rt::integer::safe<uint8_t>> spnegoChoiceByte{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_62_lha_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_62_lha_3_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__GSS_SPNEGO_Init_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        GSS_SPNEGO_Init();
        GSS_SPNEGO_Init(const GSS_SPNEGO_Init&) = default;
        GSS_SPNEGO_Init(GSS_SPNEGO_Init&&) = default;
        GSS_SPNEGO_Init& operator=(const GSS_SPNEGO_Init&) = default;
        GSS_SPNEGO_Init& operator=(GSS_SPNEGO_Init&&) = default;
        GSS_SPNEGO_Init(std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> credentialsHeader, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> spnegoInitByte, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> spnegoChoiceByte);
        template<typename F> void __visit(F _) const { _("credentialsHeader", credentialsHeader); _("spnegoInitByte", spnegoInitByte); _("spnegoChoiceByte", spnegoChoiceByte); }
    };

    struct GSS_SPNEGO_negTokenResp : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<GSS_SPNEGO_negTokenResp> {
        auto __self() { return ::hilti::rt::ValueReference<GSS_SPNEGO_negTokenResp>::self(this); }
        ::hilti::rt::Bool accepted{};
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> supportedMech{};
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>> seq{};
        void __on_seq(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd);
        std::optional<std::string> supportedMechOid{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_76_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__GSS_SPNEGO_negTokenResp_7_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        GSS_SPNEGO_negTokenResp();
        GSS_SPNEGO_negTokenResp(const GSS_SPNEGO_negTokenResp&) = default;
        GSS_SPNEGO_negTokenResp(GSS_SPNEGO_negTokenResp&&) = default;
        GSS_SPNEGO_negTokenResp& operator=(const GSS_SPNEGO_negTokenResp&) = default;
        GSS_SPNEGO_negTokenResp& operator=(GSS_SPNEGO_negTokenResp&&) = default;
        GSS_SPNEGO_negTokenResp(std::optional<::hilti::rt::Bool> accepted, std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>> supportedMech, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>>> seq, std::optional<std::optional<std::string>> supportedMechOid);
        template<typename F> void __visit(F _) const { _("accepted", accepted); _("supportedMech", supportedMech); _("seq", seq); _("supportedMechOid", supportedMechOid); }
    };

    struct GSS_SPNEGO_Subsequent : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<GSS_SPNEGO_Subsequent> {
        auto __self() { return ::hilti::rt::ValueReference<GSS_SPNEGO_Subsequent>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint8_t>> spnegoChoiceByte{};
        std::optional<::hilti::rt::ValueReference<GSS_SPNEGO_negTokenResp>> negTokenResp{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_68_lha_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__GSS_SPNEGO_Subsequent_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        GSS_SPNEGO_Subsequent();
        GSS_SPNEGO_Subsequent(const GSS_SPNEGO_Subsequent&) = default;
        GSS_SPNEGO_Subsequent(GSS_SPNEGO_Subsequent&&) = default;
        GSS_SPNEGO_Subsequent& operator=(const GSS_SPNEGO_Subsequent&) = default;
        GSS_SPNEGO_Subsequent& operator=(GSS_SPNEGO_Subsequent&&) = default;
        GSS_SPNEGO_Subsequent(std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> spnegoChoiceByte, std::optional<std::optional<::hilti::rt::ValueReference<GSS_SPNEGO_negTokenResp>>> negTokenResp);
        template<typename F> void __visit(F _) const { _("spnegoChoiceByte", spnegoChoiceByte); _("negTokenResp", negTokenResp); }
    };

    struct Result : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<Result> {
        auto __self() { return ::hilti::rt::ValueReference<Result>::self(this); }
        std::optional<LDAP::ResultCode> code{};
        std::optional<std::string> matchedDN{};
        std::optional<std::string> diagnosticMessage{};
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<Result>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_LDAP__Result_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        Result();
        Result(const Result&) = default;
        Result(Result&&) = default;
        Result& operator=(const Result&) = default;
        Result& operator=(Result&&) = default;
        Result(std::optional<std::optional<LDAP::ResultCode>> code, std::optional<std::optional<std::string>> matchedDN, std::optional<std::optional<std::string>> diagnosticMessage);
        template<typename F> void __visit(F _) const { _("code", code); _("matchedDN", matchedDN); _("diagnosticMessage", diagnosticMessage); }
    };

    struct SaslCredentials : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<SaslCredentials> {
        auto __self() { return ::hilti::rt::ValueReference<SaslCredentials>::self(this); }
        std::optional<std::string> mechanism{};
        std::optional<::hilti::rt::ValueReference<GSS_SPNEGO_Init>> gss_spnego{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_66_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__SaslCredentials_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        SaslCredentials();
        SaslCredentials(const SaslCredentials&) = default;
        SaslCredentials(SaslCredentials&&) = default;
        SaslCredentials& operator=(const SaslCredentials&) = default;
        SaslCredentials& operator=(SaslCredentials&&) = default;
        SaslCredentials(std::optional<std::optional<std::string>> mechanism, std::optional<std::optional<::hilti::rt::ValueReference<GSS_SPNEGO_Init>>> gss_spnego);
        template<typename F> void __visit(F _) const { _("mechanism", mechanism); _("gss_spnego", gss_spnego); }
    };

    struct ServerSaslCreds : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ServerSaslCreds> {
        auto __self() { return ::hilti::rt::ValueReference<ServerSaslCreds>::self(this); }
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>> serverSaslCreds{};
        std::optional<::hilti::rt::Bytes> payload{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__ServerSaslCreds_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ServerSaslCreds();
        ServerSaslCreds(const ServerSaslCreds&) = default;
        ServerSaslCreds(ServerSaslCreds&&) = default;
        ServerSaslCreds& operator=(const ServerSaslCreds&) = default;
        ServerSaslCreds& operator=(ServerSaslCreds&&) = default;
        ServerSaslCreds(std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> serverSaslCreds, std::optional<std::optional<::hilti::rt::Bytes>> payload);
        template<typename F> void __visit(F _) const { _("serverSaslCreds", serverSaslCreds); _("payload", payload); }
    };

    struct UnbindRequest : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<UnbindRequest> {
        auto __self() { return ::hilti::rt::ValueReference<UnbindRequest>::self(this); }
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__UnbindRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        UnbindRequest();
        UnbindRequest(const UnbindRequest&) = default;
        UnbindRequest(UnbindRequest&&) = default;
        UnbindRequest& operator=(const UnbindRequest&) = default;
        UnbindRequest& operator=(UnbindRequest&&) = default;
        UnbindRequest(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { }
    };

    struct SearchResultEntry : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<SearchResultEntry> {
        auto __self() { return ::hilti::rt::ValueReference<SearchResultEntry>::self(this); }
        std::optional<std::string> objectName{};
        void __on_objectName(const std::string& __dd);
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>> attributes{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__SearchResultEntry_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        SearchResultEntry();
        SearchResultEntry(const SearchResultEntry&) = default;
        SearchResultEntry(SearchResultEntry&&) = default;
        SearchResultEntry& operator=(const SearchResultEntry&) = default;
        SearchResultEntry& operator=(SearchResultEntry&&) = default;
        SearchResultEntry(std::optional<std::optional<std::string>> objectName, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>>> attributes);
        SearchResultEntry(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { _("objectName", objectName); _("attributes", attributes); }
    };

    struct SearchResultDone : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<SearchResultDone> {
        auto __self() { return ::hilti::rt::ValueReference<SearchResultDone>::self(this); }
        void __on__anon_35(const ::hilti::rt::ValueReference<Result>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__SearchResultDone_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        SearchResultDone();
        SearchResultDone(const SearchResultDone&) = default;
        SearchResultDone(SearchResultDone&&) = default;
        SearchResultDone& operator=(const SearchResultDone&) = default;
        SearchResultDone& operator=(SearchResultDone&&) = default;
        SearchResultDone(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { }
    };

    struct SearchRequest : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<SearchRequest> {
        auto __self() { return ::hilti::rt::ValueReference<SearchRequest>::self(this); }
        std::optional<std::string> baseObject{};
        void __on_baseObject(const std::string& __dd);
        std::optional<LDAP::SearchScope> scope{};
        void __on_scope(const LDAP::SearchScope& __dd);
        std::optional<LDAP::SearchDerefAlias> deref{};
        std::optional<::hilti::rt::integer::safe<int64_t>> sizeLimit{};
        std::optional<::hilti::rt::integer::safe<int64_t>> timeLimit{};
        std::optional<::hilti::rt::Bool> typesOnly{};
        std::optional<std::string> filter{};
        std::optional<::hilti::rt::Vector<std::string>> attributes{};
        void __on_0x25_done();
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<SearchRequest>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_LDAP__SearchRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        SearchRequest();
        SearchRequest(const SearchRequest&) = default;
        SearchRequest(SearchRequest&&) = default;
        SearchRequest& operator=(const SearchRequest&) = default;
        SearchRequest& operator=(SearchRequest&&) = default;
        SearchRequest(std::optional<std::optional<std::string>> baseObject, std::optional<std::optional<LDAP::SearchScope>> scope, std::optional<std::optional<LDAP::SearchDerefAlias>> deref, std::optional<std::optional<::hilti::rt::integer::safe<int64_t>>> sizeLimit, std::optional<std::optional<::hilti::rt::integer::safe<int64_t>>> timeLimit, std::optional<std::optional<::hilti::rt::Bool>> typesOnly, std::optional<std::optional<std::string>> filter, std::optional<std::optional<::hilti::rt::Vector<std::string>>> attributes);
        SearchRequest(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { _("baseObject", baseObject); _("scope", scope); _("deref", deref); _("sizeLimit", sizeLimit); _("timeLimit", timeLimit); _("typesOnly", typesOnly); _("filter", filter); _("attributes", attributes); }
    };

    struct NotImplemented : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<NotImplemented> {
        auto __self() { return ::hilti::rt::ValueReference<NotImplemented>::self(this); }
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__NotImplemented_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        NotImplemented();
        NotImplemented(const NotImplemented&) = default;
        NotImplemented(NotImplemented&&) = default;
        NotImplemented& operator=(const NotImplemented&) = default;
        NotImplemented& operator=(NotImplemented&&) = default;
        NotImplemented(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { }
    };

    struct ModifyResponse : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ModifyResponse> {
        auto __self() { return ::hilti::rt::ValueReference<ModifyResponse>::self(this); }
        void __on__anon_36(const ::hilti::rt::ValueReference<Result>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__ModifyResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        ModifyResponse();
        ModifyResponse(const ModifyResponse&) = default;
        ModifyResponse(ModifyResponse&&) = default;
        ModifyResponse& operator=(const ModifyResponse&) = default;
        ModifyResponse& operator=(ModifyResponse&&) = default;
        ModifyResponse(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { }
    };

    struct ModifyRequest : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ModifyRequest> {
        auto __self() { return ::hilti::rt::ValueReference<ModifyRequest>::self(this); }
        std::optional<std::string> objectName{};
        void __on_objectName(const std::string& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__ModifyRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        ModifyRequest();
        ModifyRequest(const ModifyRequest&) = default;
        ModifyRequest(ModifyRequest&&) = default;
        ModifyRequest& operator=(const ModifyRequest&) = default;
        ModifyRequest& operator=(ModifyRequest&&) = default;
        ModifyRequest(std::optional<std::optional<std::string>> objectName);
        ModifyRequest(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { _("objectName", objectName); }
    };

    struct ModDNResponse : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ModDNResponse> {
        auto __self() { return ::hilti::rt::ValueReference<ModDNResponse>::self(this); }
        void __on__anon_39(const ::hilti::rt::ValueReference<Result>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__ModDNResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        ModDNResponse();
        ModDNResponse(const ModDNResponse&) = default;
        ModDNResponse(ModDNResponse&&) = default;
        ModDNResponse& operator=(const ModDNResponse&) = default;
        ModDNResponse& operator=(ModDNResponse&&) = default;
        ModDNResponse(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { }
    };

    struct Message : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<Message> {
        auto __self() { return ::hilti::rt::ValueReference<Message>::self(this); }
        ::hilti::rt::integer::safe<int64_t> messageID{};
        LDAP::ProtocolOpcode opcode{};
        ::hilti::rt::ValueReference<Result> unsetResultDefault{};
        ::hilti::rt::StrongReference<Result> result_{};
        std::string obj{};
        std::string arg{};
        ::hilti::rt::integer::safe<uint64_t> seqHeaderLen{};
        ::hilti::rt::integer::safe<uint64_t> msgLen{};
        ::hilti::rt::integer::safe<uint64_t> opLen{};
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>> seqHeader{};
        void __on_seqHeader(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd);
        void __on__anon_19();
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>> messageID_header{};
        void __on__anon_53(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Body>& __dd);
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>> protocolOp{};
        void __on_protocolOp(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd);
        std::optional<::hilti::rt::ValueReference<BindRequest>> BIND_REQUEST{};
        std::optional<::hilti::rt::ValueReference<BindResponse>> BIND_RESPONSE{};
        std::optional<::hilti::rt::ValueReference<UnbindRequest>> UNBIND_REQUEST{};
        std::optional<::hilti::rt::ValueReference<SearchRequest>> SEARCH_REQUEST{};
        std::optional<::hilti::rt::ValueReference<SearchResultEntry>> SEARCH_RESULT_ENTRY{};
        std::optional<::hilti::rt::ValueReference<SearchResultDone>> SEARCH_RESULT_DONE{};
        std::optional<::hilti::rt::ValueReference<ModifyRequest>> MODIFY_REQUEST{};
        std::optional<::hilti::rt::ValueReference<ModifyResponse>> MODIFY_RESPONSE{};
        std::optional<::hilti::rt::ValueReference<AddResponse>> ADD_RESPONSE{};
        std::optional<::hilti::rt::ValueReference<DelRequest>> DEL_REQUEST{};
        std::optional<::hilti::rt::ValueReference<DelResponse>> DEL_RESPONSE{};
        std::optional<::hilti::rt::ValueReference<ModDNResponse>> MOD_DN_RESPONSE{};
        std::optional<::hilti::rt::ValueReference<CompareResponse>> COMPARE_RESPONSE{};
        std::optional<::hilti::rt::ValueReference<AbandonRequest>> ABANDON_REQUEST{};
        std::optional<::hilti::rt::ValueReference<NotImplemented>> ADD_REQUEST{};
        std::optional<::hilti::rt::ValueReference<NotImplemented>> COMPARE_REQUEST{};
        std::optional<::hilti::rt::ValueReference<ExtendedRequest>> EXTENDED_REQUEST{};
        std::optional<::hilti::rt::ValueReference<ExtendedResponse>> EXTENDED_RESPONSE{};
        std::optional<::hilti::rt::ValueReference<NotImplemented>> INTERMEDIATE_RESPONSE{};
        std::optional<::hilti::rt::ValueReference<NotImplemented>> MOD_DN_REQUEST{};
        std::optional<::hilti::rt::ValueReference<NotImplemented>> SEARCH_RESULT_REFERENCE{};
        void __on_0x25_done();
        std::optional<::hilti::rt::stream::SafeConstIterator> __position_update{};
        ::hilti::rt::integer::safe<uint64_t> __offset{};
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_54_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__Message_5_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Ctx> __p_ctx{};
        Message();
        Message(const Message&) = default;
        Message(Message&&) = default;
        Message& operator=(const Message&) = default;
        Message& operator=(Message&&) = default;
        Message(std::optional<::hilti::rt::integer::safe<int64_t>> messageID, std::optional<LDAP::ProtocolOpcode> opcode, std::optional<::hilti::rt::ValueReference<Result>> unsetResultDefault, std::optional<::hilti::rt::StrongReference<Result>> result_, std::optional<std::string> obj, std::optional<std::string> arg, std::optional<::hilti::rt::integer::safe<uint64_t>> seqHeaderLen, std::optional<::hilti::rt::integer::safe<uint64_t>> msgLen, std::optional<::hilti::rt::integer::safe<uint64_t>> opLen, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> seqHeader, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> messageID_header, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> protocolOp, std::optional<std::optional<::hilti::rt::ValueReference<BindRequest>>> BIND_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<BindResponse>>> BIND_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<UnbindRequest>>> UNBIND_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<SearchRequest>>> SEARCH_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<SearchResultEntry>>> SEARCH_RESULT_ENTRY, std::optional<std::optional<::hilti::rt::ValueReference<SearchResultDone>>> SEARCH_RESULT_DONE, std::optional<std::optional<::hilti::rt::ValueReference<ModifyRequest>>> MODIFY_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<ModifyResponse>>> MODIFY_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<AddResponse>>> ADD_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<DelRequest>>> DEL_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<DelResponse>>> DEL_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<ModDNResponse>>> MOD_DN_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<CompareResponse>>> COMPARE_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<AbandonRequest>>> ABANDON_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<NotImplemented>>> ADD_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<NotImplemented>>> COMPARE_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<ExtendedRequest>>> EXTENDED_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<ExtendedResponse>>> EXTENDED_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<NotImplemented>>> INTERMEDIATE_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<NotImplemented>>> MOD_DN_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<NotImplemented>>> SEARCH_RESULT_REFERENCE);
        Message(::hilti::rt::StrongReference<Ctx> __p_ctx);
        template<typename F> void __visit(F _) const { _("messageID", messageID); _("opcode", opcode); _("unsetResultDefault", unsetResultDefault); _("result_", result_); _("obj", obj); _("arg", arg); _("seqHeaderLen", seqHeaderLen); _("msgLen", msgLen); _("opLen", opLen); _("seqHeader", seqHeader); _("messageID_header", messageID_header); _("protocolOp", protocolOp); _("BIND_REQUEST", BIND_REQUEST); _("BIND_RESPONSE", BIND_RESPONSE); _("UNBIND_REQUEST", UNBIND_REQUEST); _("SEARCH_REQUEST", SEARCH_REQUEST); _("SEARCH_RESULT_ENTRY", SEARCH_RESULT_ENTRY); _("SEARCH_RESULT_DONE", SEARCH_RESULT_DONE); _("MODIFY_REQUEST", MODIFY_REQUEST); _("MODIFY_RESPONSE", MODIFY_RESPONSE); _("ADD_RESPONSE", ADD_RESPONSE); _("DEL_REQUEST", DEL_REQUEST); _("DEL_RESPONSE", DEL_RESPONSE); _("MOD_DN_RESPONSE", MOD_DN_RESPONSE); _("COMPARE_RESPONSE", COMPARE_RESPONSE); _("ABANDON_REQUEST", ABANDON_REQUEST); _("ADD_REQUEST", ADD_REQUEST); _("COMPARE_REQUEST", COMPARE_REQUEST); _("EXTENDED_REQUEST", EXTENDED_REQUEST); _("EXTENDED_RESPONSE", EXTENDED_RESPONSE); _("INTERMEDIATE_RESPONSE", INTERMEDIATE_RESPONSE); _("MOD_DN_REQUEST", MOD_DN_REQUEST); _("SEARCH_RESULT_REFERENCE", SEARCH_RESULT_REFERENCE); }
    };

    struct ExtendedResponseEntry : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ExtendedResponseEntry> {
        auto __self() { return ::hilti::rt::ValueReference<ExtendedResponseEntry>::self(this); }
        void __on__anon_60(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__ExtendedResponseEntry_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<ExtendedResponse> __p_r{};
        ExtendedResponseEntry();
        ExtendedResponseEntry(const ExtendedResponseEntry&) = default;
        ExtendedResponseEntry(ExtendedResponseEntry&&) = default;
        ExtendedResponseEntry& operator=(const ExtendedResponseEntry&) = default;
        ExtendedResponseEntry& operator=(ExtendedResponseEntry&&) = default;
        ExtendedResponseEntry(::hilti::rt::ValueReference<ExtendedResponse>& __p_r);
        template<typename F> void __visit(F _) const { }
    };

    struct ExtendedResponse : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ExtendedResponse> {
        auto __self() { return ::hilti::rt::ValueReference<ExtendedResponse>::self(this); }
        ::hilti::rt::Bytes responseName{};
        ::hilti::rt::Bytes responseValue{};
        void __on__anon_41(const ::hilti::rt::ValueReference<Result>& __dd);
        void __on_0x25_done();
        std::optional<::hilti::rt::stream::SafeConstIterator> __position_update{};
        ::hilti::rt::integer::safe<uint64_t> __offset{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__ExtendedResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        ::hilti::rt::WeakReference<Ctx> __p_ctx{};
        ExtendedResponse();
        ExtendedResponse(const ExtendedResponse&) = default;
        ExtendedResponse(ExtendedResponse&&) = default;
        ExtendedResponse& operator=(const ExtendedResponse&) = default;
        ExtendedResponse& operator=(ExtendedResponse&&) = default;
        ExtendedResponse(std::optional<::hilti::rt::Bytes> responseName, std::optional<::hilti::rt::Bytes> responseValue);
        ExtendedResponse(::hilti::rt::ValueReference<Message>& __p_message, ::hilti::rt::StrongReference<Ctx> __p_ctx);
        template<typename F> void __visit(F _) const { _("responseName", responseName); _("responseValue", responseValue); }
    };

    struct ExtendedRequest : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<ExtendedRequest> {
        auto __self() { return ::hilti::rt::ValueReference<ExtendedRequest>::self(this); }
        ::hilti::rt::Bytes requestValue{};
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>> header{};
        std::optional<std::string> requestName{};
        void __on_requestName(const std::string& __dd);
        void __on__anon_59(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd);
        void __on_0x25_done();
        std::optional<::hilti::rt::stream::SafeConstIterator> __position_update{};
        ::hilti::rt::integer::safe<uint64_t> __offset{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__ExtendedRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        ::hilti::rt::WeakReference<Ctx> __p_ctx{};
        ExtendedRequest();
        ExtendedRequest(const ExtendedRequest&) = default;
        ExtendedRequest(ExtendedRequest&&) = default;
        ExtendedRequest& operator=(const ExtendedRequest&) = default;
        ExtendedRequest& operator=(ExtendedRequest&&) = default;
        ExtendedRequest(std::optional<::hilti::rt::Bytes> requestValue, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> header, std::optional<std::optional<std::string>> requestName);
        ExtendedRequest(::hilti::rt::ValueReference<Message>& __p_message, ::hilti::rt::StrongReference<Ctx> __p_ctx);
        template<typename F> void __visit(F _) const { _("requestValue", requestValue); _("header", header); _("requestName", requestName); }
    };

    struct DelResponse : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<DelResponse> {
        auto __self() { return ::hilti::rt::ValueReference<DelResponse>::self(this); }
        void __on__anon_38(const ::hilti::rt::ValueReference<Result>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__DelResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        DelResponse();
        DelResponse(const DelResponse&) = default;
        DelResponse(DelResponse&&) = default;
        DelResponse& operator=(const DelResponse&) = default;
        DelResponse& operator=(DelResponse&&) = default;
        DelResponse(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { }
    };

    struct DelRequest : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<DelRequest> {
        auto __self() { return ::hilti::rt::ValueReference<DelRequest>::self(this); }
        std::optional<std::string> objectName{};
        void __on_objectName(const std::string& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__DelRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        DelRequest();
        DelRequest(const DelRequest&) = default;
        DelRequest(DelRequest&&) = default;
        DelRequest& operator=(const DelRequest&) = default;
        DelRequest& operator=(DelRequest&&) = default;
        DelRequest(std::optional<std::optional<std::string>> objectName);
        DelRequest(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { _("objectName", objectName); }
    };

    struct CompareResponse : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<CompareResponse> {
        auto __self() { return ::hilti::rt::ValueReference<CompareResponse>::self(this); }
        void __on__anon_40(const ::hilti::rt::ValueReference<Result>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__CompareResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        CompareResponse();
        CompareResponse(const CompareResponse&) = default;
        CompareResponse(CompareResponse&&) = default;
        CompareResponse& operator=(const CompareResponse&) = default;
        CompareResponse& operator=(CompareResponse&&) = default;
        CompareResponse(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { }
    };

    struct BindResponse : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<BindResponse> {
        auto __self() { return ::hilti::rt::ValueReference<BindResponse>::self(this); }
        void __on__anon_27(const ::hilti::rt::ValueReference<Result>& __dd);
        std::optional<::hilti::rt::Vector<ServerSaslCreds>> serverSaslCreds{};
        std::optional<::hilti::rt::ValueReference<GSS_SPNEGO_Subsequent>> gss_spnego{};
        void __on_gss_spnego(const ::hilti::rt::ValueReference<GSS_SPNEGO_Subsequent>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_serverSaslCreds_6_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<ServerSaslCreds>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__BindResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        ::hilti::rt::WeakReference<Ctx> __p_ctx{};
        BindResponse();
        BindResponse(const BindResponse&) = default;
        BindResponse(BindResponse&&) = default;
        BindResponse& operator=(const BindResponse&) = default;
        BindResponse& operator=(BindResponse&&) = default;
        BindResponse(std::optional<std::optional<::hilti::rt::Vector<ServerSaslCreds>>> serverSaslCreds, std::optional<std::optional<::hilti::rt::ValueReference<GSS_SPNEGO_Subsequent>>> gss_spnego);
        BindResponse(::hilti::rt::ValueReference<Message>& __p_message, ::hilti::rt::StrongReference<Ctx> __p_ctx);
        template<typename F> void __visit(F _) const { _("serverSaslCreds", serverSaslCreds); _("gss_spnego", gss_spnego); }
    };

    struct BindRequest : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<BindRequest> {
        auto __self() { return ::hilti::rt::ValueReference<BindRequest>::self(this); }
        std::optional<::hilti::rt::integer::safe<int64_t>> version{};
        std::optional<std::string> name{};
        void __on_name(const std::string& __dd);
        LDAP::BindAuthType authType{};
        ::hilti::rt::Bytes authData{};
        std::string simpleCreds{};
        void __on__anon_54(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd);
        std::optional<::hilti::rt::ValueReference<SaslCredentials>> saslCreds{};
        void __on_saslCreds(const ::hilti::rt::ValueReference<SaslCredentials>& __dd);
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__BindRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        ::hilti::rt::WeakReference<Ctx> __p_ctx{};
        BindRequest();
        BindRequest(const BindRequest&) = default;
        BindRequest(BindRequest&&) = default;
        BindRequest& operator=(const BindRequest&) = default;
        BindRequest& operator=(BindRequest&&) = default;
        BindRequest(std::optional<std::optional<::hilti::rt::integer::safe<int64_t>>> version, std::optional<std::optional<std::string>> name, std::optional<LDAP::BindAuthType> authType, std::optional<::hilti::rt::Bytes> authData, std::optional<std::string> simpleCreds, std::optional<std::optional<::hilti::rt::ValueReference<SaslCredentials>>> saslCreds);
        BindRequest(::hilti::rt::ValueReference<Message>& __p_message, ::hilti::rt::StrongReference<Ctx> __p_ctx);
        template<typename F> void __visit(F _) const { _("version", version); _("name", name); _("authType", authType); _("authData", authData); _("simpleCreds", simpleCreds); _("saslCreds", saslCreds); }
    };

    struct AddResponse : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<AddResponse> {
        auto __self() { return ::hilti::rt::ValueReference<AddResponse>::self(this); }
        void __on__anon_37(const ::hilti::rt::ValueReference<Result>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__AddResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        AddResponse();
        AddResponse(const AddResponse&) = default;
        AddResponse(AddResponse&&) = default;
        AddResponse& operator=(const AddResponse&) = default;
        AddResponse& operator=(AddResponse&&) = default;
        AddResponse(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { }
    };

    struct AbandonRequest : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<AbandonRequest> {
        auto __self() { return ::hilti::rt::ValueReference<AbandonRequest>::self(this); }
        std::optional<::hilti::rt::integer::safe<int64_t>> messageID{};
        void __on_messageID(const ::hilti::rt::integer::safe<int64_t>& __dd);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__AbandonRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Message> __p_message{};
        AbandonRequest();
        AbandonRequest(const AbandonRequest&) = default;
        AbandonRequest(AbandonRequest&&) = default;
        AbandonRequest& operator=(const AbandonRequest&) = default;
        AbandonRequest& operator=(AbandonRequest&&) = default;
        AbandonRequest(std::optional<std::optional<::hilti::rt::integer::safe<int64_t>>> messageID);
        AbandonRequest(::hilti::rt::ValueReference<Message>& __p_message);
        template<typename F> void __visit(F _) const { _("messageID", messageID); }
    };

    struct AttributeSelection : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<AttributeSelection> {
        auto __self() { return ::hilti::rt::ValueReference<AttributeSelection>::self(this); }
        ::hilti::rt::Vector<std::string> attributes{};
        void __on__anon_55(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd);
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<AttributeSelection>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_LDAP__AttributeSelection_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        AttributeSelection();
        AttributeSelection(const AttributeSelection&) = default;
        AttributeSelection(AttributeSelection&&) = default;
        AttributeSelection& operator=(const AttributeSelection&) = default;
        AttributeSelection& operator=(AttributeSelection&&) = default;
        AttributeSelection(std::optional<::hilti::rt::Vector<std::string>> attributes);
        template<typename F> void __visit(F _) const { _("attributes", attributes); }
    };

    struct AttributeValueAssertion : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<AttributeValueAssertion> {
        auto __self() { return ::hilti::rt::ValueReference<AttributeValueAssertion>::self(this); }
        std::string desc{};
        std::string val{};
        void __on__anon_56(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd);
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        AttributeValueAssertion();
        AttributeValueAssertion(const AttributeValueAssertion&) = default;
        AttributeValueAssertion(AttributeValueAssertion&&) = default;
        AttributeValueAssertion& operator=(const AttributeValueAssertion&) = default;
        AttributeValueAssertion& operator=(AttributeValueAssertion&&) = default;
        AttributeValueAssertion(std::optional<std::string> desc, std::optional<std::string> val);
        template<typename F> void __visit(F _) const { _("desc", desc); _("val", val); }
    };

    struct DecodedAttributeValue : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<DecodedAttributeValue> {
        auto __self() { return ::hilti::rt::ValueReference<DecodedAttributeValue>::self(this); }
        std::string assertionValueDecoded{};
        std::optional<::hilti::rt::integer::safe<uint8_t>> attributeDesc_len{};
        std::optional<::hilti::rt::Bytes> attributeDesc{};
        std::optional<::hilti::rt::integer::safe<uint8_t>> assertionValue_len{};
        std::optional<::hilti::rt::Bytes> assertionValue{};
        std::optional<::hilti::rt::integer::safe<uint8_t>> matchValue_len{};
        std::optional<::hilti::rt::Bytes> matchValue{};
        void __on_0x25_done();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__DecodedAttributeValue_8_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        LDAP::FilterType __p_fType;
        DecodedAttributeValue();
        DecodedAttributeValue(const DecodedAttributeValue&) = default;
        DecodedAttributeValue(DecodedAttributeValue&&) = default;
        DecodedAttributeValue& operator=(const DecodedAttributeValue&) = default;
        DecodedAttributeValue& operator=(DecodedAttributeValue&&) = default;
        DecodedAttributeValue(std::optional<std::string> assertionValueDecoded, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> attributeDesc_len, std::optional<std::optional<::hilti::rt::Bytes>> attributeDesc, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> assertionValue_len, std::optional<std::optional<::hilti::rt::Bytes>> assertionValue, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> matchValue_len, std::optional<std::optional<::hilti::rt::Bytes>> matchValue);
        DecodedAttributeValue(const LDAP::FilterType& __p_fType);
        template<typename F> void __visit(F _) const { _("assertionValueDecoded", assertionValueDecoded); _("attributeDesc_len", attributeDesc_len); _("attributeDesc", attributeDesc); _("assertionValue_len", assertionValue_len); _("assertionValue", assertionValue); _("matchValue_len", matchValue_len); _("matchValue", matchValue); }
    };

    struct EncryptedMessage : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<EncryptedMessage> {
        auto __self() { return ::hilti::rt::ValueReference<EncryptedMessage>::self(this); }
        std::optional<::hilti::rt::integer::safe<uint32_t>> len{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__EncryptedMessage_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        EncryptedMessage();
        EncryptedMessage(const EncryptedMessage&) = default;
        EncryptedMessage(EncryptedMessage&&) = default;
        EncryptedMessage& operator=(const EncryptedMessage&) = default;
        EncryptedMessage& operator=(EncryptedMessage&&) = default;
        EncryptedMessage(std::optional<std::optional<::hilti::rt::integer::safe<uint32_t>>> len);
        template<typename F> void __visit(F _) const { _("len", len); }
    };

    struct KrbWrapToken : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<KrbWrapToken> {
        auto __self() { return ::hilti::rt::ValueReference<KrbWrapToken>::self(this); }
        ::hilti::rt::integer::safe<uint64_t> trailer_ec{};
        ::hilti::rt::integer::safe<uint64_t> header_ec{};
        std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>> ctx_flags{};
        std::optional<::hilti::rt::integer::safe<uint16_t>> ec{};
        std::optional<::hilti::rt::integer::safe<uint16_t>> rrc{};
        void __on_rrc(const ::hilti::rt::integer::safe<uint16_t>& __dd);
        std::optional<::hilti::rt::integer::safe<uint64_t>> snd_seq{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__KrbWrapToken_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        KrbWrapToken();
        KrbWrapToken(const KrbWrapToken&) = default;
        KrbWrapToken(KrbWrapToken&&) = default;
        KrbWrapToken& operator=(const KrbWrapToken&) = default;
        KrbWrapToken& operator=(KrbWrapToken&&) = default;
        KrbWrapToken(std::optional<::hilti::rt::integer::safe<uint64_t>> trailer_ec, std::optional<::hilti::rt::integer::safe<uint64_t>> header_ec, std::optional<std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> ctx_flags, std::optional<std::optional<::hilti::rt::integer::safe<uint16_t>>> ec, std::optional<std::optional<::hilti::rt::integer::safe<uint16_t>>> rrc, std::optional<std::optional<::hilti::rt::integer::safe<uint64_t>>> snd_seq);
        template<typename F> void __visit(F _) const { _("trailer_ec", trailer_ec); _("header_ec", header_ec); _("ctx_flags", ctx_flags); _("ec", ec); _("rrc", rrc); _("snd_seq", snd_seq); }
    };

    struct SaslMsKrb5Stripper : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<SaslMsKrb5Stripper> {
        auto __self() { return ::hilti::rt::ValueReference<SaslMsKrb5Stripper>::self(this); }
        ::hilti::rt::integer::safe<uint64_t> switch_size{};
        std::optional<::hilti::rt::integer::safe<uint32_t>> len{};
        std::optional<::hilti::rt::integer::safe<uint16_t>> krb5_tok_id{};
        std::optional<::hilti::rt::ValueReference<KrbWrapToken>> krb_wrap_token{};
        void __on__anon_15();
        std::optional<::hilti::rt::stream::SafeConstIterator> __position_update{};
        ::hilti::rt::integer::safe<uint64_t> __offset{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_40_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse__anon_17_4_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<Message>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_41_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__SaslMsKrb5Stripper_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Ctx> __p_ctx{};
        SaslMsKrb5Stripper();
        SaslMsKrb5Stripper(const SaslMsKrb5Stripper&) = default;
        SaslMsKrb5Stripper(SaslMsKrb5Stripper&&) = default;
        SaslMsKrb5Stripper& operator=(const SaslMsKrb5Stripper&) = default;
        SaslMsKrb5Stripper& operator=(SaslMsKrb5Stripper&&) = default;
        SaslMsKrb5Stripper(std::optional<::hilti::rt::integer::safe<uint64_t>> switch_size, std::optional<std::optional<::hilti::rt::integer::safe<uint32_t>>> len, std::optional<std::optional<::hilti::rt::integer::safe<uint16_t>>> krb5_tok_id, std::optional<std::optional<::hilti::rt::ValueReference<KrbWrapToken>>> krb_wrap_token);
        SaslMsKrb5Stripper(::hilti::rt::StrongReference<Ctx> __p_ctx);
        template<typename F> void __visit(F _) const { _("switch_size", switch_size); _("len", len); _("krb5_tok_id", krb5_tok_id); _("krb_wrap_token", krb_wrap_token); }
    };

    struct TlsForward : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<TlsForward> {
        auto __self() { return ::hilti::rt::ValueReference<TlsForward>::self(this); }
        std::optional<::hilti::rt::Bytes> chunk{};
        void __on_chunk(const ::hilti::rt::Bytes& __dd);
        void __on_0x25_init();
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__TlsForward_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        TlsForward();
        TlsForward(const TlsForward&) = default;
        TlsForward(TlsForward&&) = default;
        TlsForward& operator=(const TlsForward&) = default;
        TlsForward& operator=(TlsForward&&) = default;
        TlsForward(std::optional<std::optional<::hilti::rt::Bytes>> chunk);
        template<typename F> void __visit(F _) const { _("chunk", chunk); }
    };

    struct MessageDispatch : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<MessageDispatch> {
        auto __self() { return ::hilti::rt::ValueReference<MessageDispatch>::self(this); }
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse2(::hilti::rt::ValueReference<MessageDispatch>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        auto __parse_switch_16_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__MessageDispatch_2_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Ctx> __p_ctx{};
        MessageDispatch();
        MessageDispatch(const MessageDispatch&) = default;
        MessageDispatch(MessageDispatch&&) = default;
        MessageDispatch& operator=(const MessageDispatch&) = default;
        MessageDispatch& operator=(MessageDispatch&&) = default;
        MessageDispatch(::hilti::rt::StrongReference<Ctx> __p_ctx);
        template<typename F> void __visit(F _) const { }
    };

    struct MaybeEncrypted : ::hilti::rt::trait::isStruct, hilti::rt::trait::hasParameters, ::hilti::rt::Controllable<MaybeEncrypted> {
        auto __self() { return ::hilti::rt::ValueReference<MaybeEncrypted>::self(this); }
        ::hilti::rt::stream::SafeConstIterator start{};
        ::hilti::rt::integer::safe<uint64_t> saslLen{};
        ::hilti::rt::Bytes mech{};
        std::optional<::hilti::rt::integer::safe<uint8_t>> first{};
        void __on_first(const ::hilti::rt::integer::safe<uint8_t>& __dd);
        std::optional<::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>> rem{};
        void __on_rem(const ::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>& __dd);
        void __on__anon_10(const ::hilti::rt::integer::safe<uint16_t>& __dd);
        void __on__anon_11();
        void __on_0x25_init();
        ::hilti::rt::stream::SafeConstIterator __begin{};
        std::optional<::hilti::rt::stream::SafeConstIterator> __position_update{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_rem_3_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__MaybeEncrypted_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ::hilti::rt::WeakReference<Ctx> __p_ctx{};
        MaybeEncrypted();
        MaybeEncrypted(const MaybeEncrypted&) = default;
        MaybeEncrypted(MaybeEncrypted&&) = default;
        MaybeEncrypted& operator=(const MaybeEncrypted&) = default;
        MaybeEncrypted& operator=(MaybeEncrypted&&) = default;
        MaybeEncrypted(std::optional<::hilti::rt::stream::SafeConstIterator> start, std::optional<::hilti::rt::integer::safe<uint64_t>> saslLen, std::optional<::hilti::rt::Bytes> mech, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> first, std::optional<std::optional<::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>>> rem);
        MaybeEncrypted(::hilti::rt::StrongReference<Ctx> __p_ctx);
        template<typename F> void __visit(F _) const { _("start", start); _("saslLen", saslLen); _("mech", mech); _("first", first); _("rem", rem); }
    };

    struct Messages : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<Messages> {
        auto __self() { return ::hilti::rt::ValueReference<Messages>::self(this); }
        ::hilti::rt::StrongReference<Ctx> __context{};
        inline static ::spicy::rt::Parser __parser{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        static auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse2(::hilti::rt::ValueReference<Messages>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View;
        static auto context_new() -> ::spicy::rt::UnitContext;
        auto __parse__anon_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<MessageDispatch>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__Messages_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        Messages();
        Messages(const Messages&) = default;
        Messages(Messages&&) = default;
        Messages& operator=(const Messages&) = default;
        Messages& operator=(Messages&&) = default;
        template<typename F> void __visit(F _) const { }
    };

    struct SubstringFilter : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<SubstringFilter> {
        auto __self() { return ::hilti::rt::ValueReference<SubstringFilter>::self(this); }
        std::string initial{};
        std::string final{};
        ::hilti::rt::Vector<std::string> anys{};
        std::optional<::hilti::rt::integer::safe<uint8_t>> attributeDesc_len{};
        std::optional<::hilti::rt::Bytes> attributeDesc{};
        std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>> header{};
        void __on__anon_34_foreach(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::Bool& __stop);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse__anon_34_8_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<__hlt_ldap::ASN1::ASN1Message>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__SubstringFilter_8_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        SubstringFilter();
        SubstringFilter(const SubstringFilter&) = default;
        SubstringFilter(SubstringFilter&&) = default;
        SubstringFilter& operator=(const SubstringFilter&) = default;
        SubstringFilter& operator=(SubstringFilter&&) = default;
        SubstringFilter(std::optional<std::string> initial, std::optional<std::string> final, std::optional<::hilti::rt::Vector<std::string>> anys, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> attributeDesc_len, std::optional<std::optional<::hilti::rt::Bytes>> attributeDesc, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> header);
        template<typename F> void __visit(F _) const { _("initial", initial); _("final", final); _("anys", anys); _("attributeDesc_len", attributeDesc_len); _("attributeDesc", attributeDesc); _("header", header); }
    };

    struct SearchFilter : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<SearchFilter> {
        auto __self() { return ::hilti::rt::ValueReference<SearchFilter>::self(this); }
        LDAP::FilterType filterType{};
        ::hilti::rt::Bytes filterBytes{};
        ::hilti::rt::integer::safe<uint64_t> filterLen{};
        std::string stringRepresentation{};
        void __on__anon_58(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd);
        std::optional<::hilti::rt::ValueReference<ParseNestedAndOr>> FILTER_AND{};
        std::optional<::hilti::rt::ValueReference<ParseNestedAndOr>> FILTER_OR{};
        std::optional<::hilti::rt::ValueReference<ParseNestedNot>> FILTER_NOT{};
        std::optional<::hilti::rt::ValueReference<DecodedAttributeValue>> FILTER_EQ{};
        std::optional<::hilti::rt::ValueReference<SubstringFilter>> FILTER_SUBSTR{};
        std::optional<::hilti::rt::ValueReference<DecodedAttributeValue>> FILTER_GE{};
        std::optional<::hilti::rt::ValueReference<DecodedAttributeValue>> FILTER_LE{};
        std::optional<::hilti::rt::ValueReference<DecodedAttributeValue>> FILTER_APPROX{};
        std::optional<::hilti::rt::ValueReference<DecodedAttributeValue>> FILTER_EXT{};
        std::optional<std::string> FILTER_PRESENT{};
        void __on_0x25_done();
        void __on_0x25_error(const std::string& __except);
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_switch_108_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__SearchFilter_8_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        SearchFilter();
        SearchFilter(const SearchFilter&) = default;
        SearchFilter(SearchFilter&&) = default;
        SearchFilter& operator=(const SearchFilter&) = default;
        SearchFilter& operator=(SearchFilter&&) = default;
        SearchFilter(std::optional<LDAP::FilterType> filterType, std::optional<::hilti::rt::Bytes> filterBytes, std::optional<::hilti::rt::integer::safe<uint64_t>> filterLen, std::optional<std::string> stringRepresentation, std::optional<std::optional<::hilti::rt::ValueReference<ParseNestedAndOr>>> FILTER_AND, std::optional<std::optional<::hilti::rt::ValueReference<ParseNestedAndOr>>> FILTER_OR, std::optional<std::optional<::hilti::rt::ValueReference<ParseNestedNot>>> FILTER_NOT, std::optional<std::optional<::hilti::rt::ValueReference<DecodedAttributeValue>>> FILTER_EQ, std::optional<std::optional<::hilti::rt::ValueReference<SubstringFilter>>> FILTER_SUBSTR, std::optional<std::optional<::hilti::rt::ValueReference<DecodedAttributeValue>>> FILTER_GE, std::optional<std::optional<::hilti::rt::ValueReference<DecodedAttributeValue>>> FILTER_LE, std::optional<std::optional<::hilti::rt::ValueReference<DecodedAttributeValue>>> FILTER_APPROX, std::optional<std::optional<::hilti::rt::ValueReference<DecodedAttributeValue>>> FILTER_EXT, std::optional<std::optional<std::string>> FILTER_PRESENT);
        template<typename F> void __visit(F _) const { _("filterType", filterType); _("filterBytes", filterBytes); _("filterLen", filterLen); _("stringRepresentation", stringRepresentation); _("FILTER_AND", FILTER_AND); _("FILTER_OR", FILTER_OR); _("FILTER_NOT", FILTER_NOT); _("FILTER_EQ", FILTER_EQ); _("FILTER_SUBSTR", FILTER_SUBSTR); _("FILTER_GE", FILTER_GE); _("FILTER_LE", FILTER_LE); _("FILTER_APPROX", FILTER_APPROX); _("FILTER_EXT", FILTER_EXT); _("FILTER_PRESENT", FILTER_PRESENT); }
    };

    struct ParseNestedNot : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ParseNestedNot> {
        auto __self() { return ::hilti::rt::ValueReference<ParseNestedNot>::self(this); }
        std::optional<::hilti::rt::ValueReference<SearchFilter>> searchfilter{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__ParseNestedNot_7_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ParseNestedNot();
        ParseNestedNot(const ParseNestedNot&) = default;
        ParseNestedNot(ParseNestedNot&&) = default;
        ParseNestedNot& operator=(const ParseNestedNot&) = default;
        ParseNestedNot& operator=(ParseNestedNot&&) = default;
        ParseNestedNot(std::optional<std::optional<::hilti::rt::ValueReference<SearchFilter>>> searchfilter);
        template<typename F> void __visit(F _) const { _("searchfilter", searchfilter); }
    };

    struct ParseNestedAndOr : ::hilti::rt::trait::isStruct, ::hilti::rt::Controllable<ParseNestedAndOr> {
        auto __self() { return ::hilti::rt::ValueReference<ParseNestedAndOr>::self(this); }
        std::optional<::hilti::rt::Vector<SearchFilter>> searchfilters{};
        auto __parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_searchfilters_6_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<SearchFilter>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        auto __parse_LDAP__ParseNestedAndOr_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>>;
        std::optional<::hilti::rt::RecoverableFailure> __error{};
        ParseNestedAndOr();
        ParseNestedAndOr(const ParseNestedAndOr&) = default;
        ParseNestedAndOr(ParseNestedAndOr&&) = default;
        ParseNestedAndOr& operator=(const ParseNestedAndOr&) = default;
        ParseNestedAndOr& operator=(ParseNestedAndOr&&) = default;
        ParseNestedAndOr(std::optional<std::optional<::hilti::rt::Vector<SearchFilter>>> searchfilters);
        template<typename F> void __visit(F _) const { _("searchfilters", searchfilters); }
    };

    const std::string GSSAPI_MECH_MS_KRB5 = "1.2.840.48018.1.2.2"s;
    const ::hilti::rt::Bytes __ctor__bytes_2 = "NTLMSSP"_b;
    const ::hilti::rt::Bytes __ctor__bytes = "\377"_b;
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AbandonRequest0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AbandonRequest0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AbandonRequest0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AbandonRequest0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AbandonRequest0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AbandonRequest0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AbandonRequest0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AbandonRequest0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AddResponse0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AddResponse0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AddResponse0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AddResponse0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AddResponse0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AddResponse0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AddResponse0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AddResponse0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AttributeSelection0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AttributeSelection0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AttributeSelection0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AttributeSelection0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AttributeSelection0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AttributeSelection0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AttributeSelection0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AttributeSelection0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AttributeValueAssertion0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AttributeValueAssertion0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AttributeValueAssertion0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AttributeValueAssertion0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AttributeValueAssertion0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AttributeValueAssertion0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AttributeValueAssertion0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40AttributeValueAssertion0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40BindRequest0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40BindRequest0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40BindRequest0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40BindRequest0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40BindRequest0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40BindRequest0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40BindRequest0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40BindRequest0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40BindResponse0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40BindResponse0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40BindResponse0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40BindResponse0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40BindResponse0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40BindResponse0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40BindResponse0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40BindResponse0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40CompareResponse0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40CompareResponse0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40CompareResponse0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40CompareResponse0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40CompareResponse0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40CompareResponse0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40CompareResponse0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40CompareResponse0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DecodedAttributeValue0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DecodedAttributeValue0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DecodedAttributeValue0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DecodedAttributeValue0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DecodedAttributeValue0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DecodedAttributeValue0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DecodedAttributeValue0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DecodedAttributeValue0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DelRequest0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DelRequest0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DelRequest0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DelRequest0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DelRequest0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DelRequest0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DelRequest0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DelRequest0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DelResponse0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DelResponse0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DelResponse0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DelResponse0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DelResponse0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DelResponse0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DelResponse0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40DelResponse0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40EncryptedMessage0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40EncryptedMessage0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40EncryptedMessage0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40EncryptedMessage0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40EncryptedMessage0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40EncryptedMessage0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40EncryptedMessage0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40EncryptedMessage0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedRequest0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedRequest0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedRequest0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedRequest0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedRequest0x25uses_offset = ::hilti::rt::Bool(true);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedRequest0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedRequest0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedRequest0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedResponse0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedResponse0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedResponse0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedResponse0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedResponse0x25uses_offset = ::hilti::rt::Bool(true);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedResponse0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedResponse0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedResponse0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedResponseEntry0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedResponseEntry0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedResponseEntry0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedResponseEntry0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedResponseEntry0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedResponseEntry0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedResponseEntry0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ExtendedResponseEntry0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_Init0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_Init0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_Init0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_Init0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_Init0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_Init0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_Init0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_Init0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_Subsequent0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_Subsequent0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_Subsequent0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_Subsequent0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_Subsequent0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_Subsequent0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_Subsequent0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_Subsequent0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_negTokenInit0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_negTokenInit0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_negTokenInit0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_negTokenInit0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_negTokenInit0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_negTokenInit0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_negTokenInit0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_negTokenInit0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_negTokenResp0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_negTokenResp0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_negTokenResp0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_negTokenResp0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_negTokenResp0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_negTokenResp0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_negTokenResp0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40GSS_SPNEGO_negTokenResp0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40KrbWrapToken0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40KrbWrapToken0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40KrbWrapToken0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40KrbWrapToken0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40KrbWrapToken0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40KrbWrapToken0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40KrbWrapToken0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40KrbWrapToken0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40MaybeEncrypted0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40MaybeEncrypted0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40MaybeEncrypted0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40MaybeEncrypted0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40MaybeEncrypted0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40MaybeEncrypted0x25uses_random_access = ::hilti::rt::Bool(true);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40MaybeEncrypted0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40MaybeEncrypted0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Message0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Message0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Message0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Message0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Message0x25uses_offset = ::hilti::rt::Bool(true);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Message0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Message0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Message0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40MessageDispatch0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40MessageDispatch0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40MessageDispatch0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40MessageDispatch0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40MessageDispatch0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40MessageDispatch0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40MessageDispatch0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40MessageDispatch0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Messages0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Messages0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Messages0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Messages0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Messages0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Messages0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Messages0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Messages0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModDNResponse0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModDNResponse0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModDNResponse0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModDNResponse0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModDNResponse0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModDNResponse0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModDNResponse0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModDNResponse0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModifyRequest0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModifyRequest0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModifyRequest0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModifyRequest0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModifyRequest0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModifyRequest0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModifyRequest0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModifyRequest0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModifyResponse0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModifyResponse0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModifyResponse0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModifyResponse0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModifyResponse0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModifyResponse0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModifyResponse0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ModifyResponse0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40NotImplemented0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40NotImplemented0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40NotImplemented0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40NotImplemented0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40NotImplemented0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40NotImplemented0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40NotImplemented0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40NotImplemented0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ParseNestedAndOr0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ParseNestedAndOr0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ParseNestedAndOr0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ParseNestedAndOr0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ParseNestedAndOr0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ParseNestedAndOr0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ParseNestedAndOr0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ParseNestedAndOr0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ParseNestedNot0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ParseNestedNot0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ParseNestedNot0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ParseNestedNot0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ParseNestedNot0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ParseNestedNot0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ParseNestedNot0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ParseNestedNot0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Result0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Result0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Result0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Result0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Result0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Result0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Result0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40Result0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SaslCredentials0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SaslCredentials0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SaslCredentials0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SaslCredentials0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SaslCredentials0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SaslCredentials0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SaslCredentials0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SaslCredentials0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SaslMsKrb5Stripper0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SaslMsKrb5Stripper0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SaslMsKrb5Stripper0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SaslMsKrb5Stripper0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SaslMsKrb5Stripper0x25uses_offset = ::hilti::rt::Bool(true);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SaslMsKrb5Stripper0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SaslMsKrb5Stripper0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SaslMsKrb5Stripper0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchFilter0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchFilter0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchFilter0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchFilter0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchFilter0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchFilter0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchFilter0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchFilter0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchRequest0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchRequest0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchRequest0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchRequest0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchRequest0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchRequest0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchRequest0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchRequest0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchResultDone0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchResultDone0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchResultDone0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchResultDone0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchResultDone0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchResultDone0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchResultDone0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchResultDone0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchResultEntry0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchResultEntry0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchResultEntry0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchResultEntry0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchResultEntry0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchResultEntry0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchResultEntry0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SearchResultEntry0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ServerSaslCreds0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ServerSaslCreds0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ServerSaslCreds0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ServerSaslCreds0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ServerSaslCreds0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ServerSaslCreds0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ServerSaslCreds0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40ServerSaslCreds0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SubstringFilter0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SubstringFilter0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SubstringFilter0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SubstringFilter0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SubstringFilter0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SubstringFilter0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SubstringFilter0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40SubstringFilter0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40TlsForward0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40TlsForward0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40TlsForward0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40TlsForward0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40TlsForward0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40TlsForward0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40TlsForward0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40TlsForward0x25uses_sync_advance = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40UnbindRequest0x25is_filter = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40UnbindRequest0x25supports_filters = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40UnbindRequest0x25supports_sinks = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40UnbindRequest0x25synchronization = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40UnbindRequest0x25uses_offset = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40UnbindRequest0x25uses_random_access = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40UnbindRequest0x25uses_stream = ::hilti::rt::Bool(false);
    const ::hilti::rt::Bool __feat0x25LDAP0x400x40UnbindRequest0x25uses_sync_advance = ::hilti::rt::Bool(false);
}

namespace __hlt_ldap::ASN1 {
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1BitString& x) -> std::ostream&;
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_ldap::ASN1::ASN1Class x, adl::tag) -> std::string;
}

namespace __hlt_ldap::ASN1 {
    inline auto operator<<(std::ostream& o, ASN1Class x) -> std::ostream&;
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_ldap::ASN1::ASN1Type x, adl::tag) -> std::string;
}

namespace __hlt_ldap::ASN1 {
    inline auto operator<<(std::ostream& o, ASN1Type x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1Tag& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::LengthType& x) -> std::ostream&;
    extern void __hook_LengthType___on__anon_44(::hilti::rt::ValueReference<__hlt_ldap::ASN1::LengthType>& __self);
    extern void __hook_LengthType___on__anon_45(const ::hilti::rt::integer::safe<uint64_t>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::ASN1::LengthType>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1Header& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1SubMessages& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1Message& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1Body& x) -> std::ostream&;
    extern void __hook_ASN1Message___on_application_data(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1ObjectIdentifier& x) -> std::ostream&;
    extern void __hook_ASN1ObjectIdentifier___on__anon_48(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1ObjectIdentifier>& __self);
    extern void __hook_ASN1ObjectIdentifier___on_sublist_foreach(const ::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1ObjectIdentifier>& __self);
    extern void __hook_ASN1ObjectIdentifier___on_0x25_done(::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1ObjectIdentifier>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_ldap::ASN1::ASN1OctetString& x) -> std::ostream&;
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_ldap::LDAP::BindAuthType x, adl::tag) -> std::string;
}

namespace __hlt_ldap::LDAP {
    inline auto operator<<(std::ostream& o, BindAuthType x) -> std::ostream&;
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_ldap::LDAP::MessageMode x, adl::tag) -> std::string;
}

namespace __hlt_ldap::LDAP {
    inline auto operator<<(std::ostream& o, MessageMode x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::Ctx& x) -> std::ostream&;
    Ctx::Ctx() {
        messageMode = LDAP::MessageMode::Undef;
    }

    Ctx::Ctx(std::optional<LDAP::MessageMode> messageMode, std::optional<std::string> saslMechanism, std::optional<::hilti::rt::Bool> startTlsRequested) : Ctx() {
        if ( messageMode ) this->messageMode = std::move(*messageMode);
        if ( saslMechanism ) this->saslMechanism = std::move(*saslMechanism);
        if ( startTlsRequested ) this->startTlsRequested = std::move(*startTlsRequested);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::GSS_SPNEGO_negTokenInit& x) -> std::ostream&;
    GSS_SPNEGO_negTokenInit::GSS_SPNEGO_negTokenInit() {
    }

    GSS_SPNEGO_negTokenInit::GSS_SPNEGO_negTokenInit(std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> oidHeader, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1ObjectIdentifier>>> oid) : GSS_SPNEGO_negTokenInit() {
        if ( oidHeader ) this->oidHeader = std::move(*oidHeader);
        if ( oid ) this->oid = std::move(*oid);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::GSS_SPNEGO_Init& x) -> std::ostream&;
    GSS_SPNEGO_Init::GSS_SPNEGO_Init() {
    }

    GSS_SPNEGO_Init::GSS_SPNEGO_Init(std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> credentialsHeader, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> spnegoInitByte, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> spnegoChoiceByte) : GSS_SPNEGO_Init() {
        if ( credentialsHeader ) this->credentialsHeader = std::move(*credentialsHeader);
        if ( spnegoInitByte ) this->spnegoInitByte = std::move(*spnegoInitByte);
        if ( spnegoChoiceByte ) this->spnegoChoiceByte = std::move(*spnegoChoiceByte);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::GSS_SPNEGO_negTokenResp& x) -> std::ostream&;
    extern void __hook_GSS_SPNEGO_negTokenResp___on_seq(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::GSS_SPNEGO_negTokenResp>& __self);
    GSS_SPNEGO_negTokenResp::GSS_SPNEGO_negTokenResp() {
    }

    GSS_SPNEGO_negTokenResp::GSS_SPNEGO_negTokenResp(std::optional<::hilti::rt::Bool> accepted, std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>> supportedMech, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>>> seq, std::optional<std::optional<std::string>> supportedMechOid) : GSS_SPNEGO_negTokenResp() {
        if ( accepted ) this->accepted = std::move(*accepted);
        if ( supportedMech ) this->supportedMech = std::move(*supportedMech);
        if ( seq ) this->seq = std::move(*seq);
        if ( supportedMechOid ) this->supportedMechOid = std::move(*supportedMechOid);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::GSS_SPNEGO_Subsequent& x) -> std::ostream&;
    GSS_SPNEGO_Subsequent::GSS_SPNEGO_Subsequent() {
    }

    GSS_SPNEGO_Subsequent::GSS_SPNEGO_Subsequent(std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> spnegoChoiceByte, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::GSS_SPNEGO_negTokenResp>>> negTokenResp) : GSS_SPNEGO_Subsequent() {
        if ( spnegoChoiceByte ) this->spnegoChoiceByte = std::move(*spnegoChoiceByte);
        if ( negTokenResp ) this->negTokenResp = std::move(*negTokenResp);
    }

    
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_ldap::LDAP::ProtocolOpcode x, adl::tag) -> std::string;
}

namespace __hlt_ldap::LDAP {
    inline auto operator<<(std::ostream& o, ProtocolOpcode x) -> std::ostream&;
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_ldap::LDAP::ResultCode x, adl::tag) -> std::string;
}

namespace __hlt_ldap::LDAP {
    inline auto operator<<(std::ostream& o, ResultCode x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::Result& x) -> std::ostream&;
    Result::Result() {
    }

    Result::Result(std::optional<std::optional<LDAP::ResultCode>> code, std::optional<std::optional<std::string>> matchedDN, std::optional<std::optional<std::string>> diagnosticMessage) : Result() {
        if ( code ) this->code = std::move(*code);
        if ( matchedDN ) this->matchedDN = std::move(*matchedDN);
        if ( diagnosticMessage ) this->diagnosticMessage = std::move(*diagnosticMessage);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::SaslCredentials& x) -> std::ostream&;
    SaslCredentials::SaslCredentials() {
    }

    SaslCredentials::SaslCredentials(std::optional<std::optional<std::string>> mechanism, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::GSS_SPNEGO_Init>>> gss_spnego) : SaslCredentials() {
        if ( mechanism ) this->mechanism = std::move(*mechanism);
        if ( gss_spnego ) this->gss_spnego = std::move(*gss_spnego);
    }

    
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_ldap::LDAP::SearchDerefAlias x, adl::tag) -> std::string;
}

namespace __hlt_ldap::LDAP {
    inline auto operator<<(std::ostream& o, SearchDerefAlias x) -> std::ostream&;
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_ldap::LDAP::SearchScope x, adl::tag) -> std::string;
}

namespace __hlt_ldap::LDAP {
    inline auto operator<<(std::ostream& o, SearchScope x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::ServerSaslCreds& x) -> std::ostream&;
    ServerSaslCreds::ServerSaslCreds() {
    }

    ServerSaslCreds::ServerSaslCreds(std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> serverSaslCreds, std::optional<std::optional<::hilti::rt::Bytes>> payload) : ServerSaslCreds() {
        if ( serverSaslCreds ) this->serverSaslCreds = std::move(*serverSaslCreds);
        if ( payload ) this->payload = std::move(*payload);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::UnbindRequest& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::Message& x) -> std::ostream&;
    UnbindRequest::UnbindRequest() {
    }

    UnbindRequest::UnbindRequest(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __p_message) : __p_message(std::move(__p_message)) {
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::SearchResultEntry& x) -> std::ostream&;
    extern void __hook_SearchResultEntry___on_objectName(const std::string& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchResultEntry>& __self);
    extern void __hook_SearchResultEntry___on_0x25_done(::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchResultEntry>& __self);
    SearchResultEntry::SearchResultEntry() {
    }

    SearchResultEntry::SearchResultEntry(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __p_message) : __p_message(std::move(__p_message)) {
    }

    SearchResultEntry::SearchResultEntry(std::optional<std::optional<std::string>> objectName, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>>> attributes) : SearchResultEntry() {
        if ( objectName ) this->objectName = std::move(*objectName);
        if ( attributes ) this->attributes = std::move(*attributes);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::SearchResultDone& x) -> std::ostream&;
    extern void __hook_SearchResultDone___on__anon_35(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchResultDone>& __self);
    SearchResultDone::SearchResultDone() {
    }

    SearchResultDone::SearchResultDone(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __p_message) : __p_message(std::move(__p_message)) {
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::SearchRequest& x) -> std::ostream&;
    extern void __hook_SearchRequest___on_baseObject(const std::string& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchRequest>& __self);
    extern void __hook_SearchRequest___on_scope(const LDAP::SearchScope& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchRequest>& __self);
    extern void __hook_SearchRequest___on_0x25_done(::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchRequest>& __self);
    SearchRequest::SearchRequest() {
    }

    SearchRequest::SearchRequest(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __p_message) : __p_message(std::move(__p_message)) {
    }

    SearchRequest::SearchRequest(std::optional<std::optional<std::string>> baseObject, std::optional<std::optional<LDAP::SearchScope>> scope, std::optional<std::optional<LDAP::SearchDerefAlias>> deref, std::optional<std::optional<::hilti::rt::integer::safe<int64_t>>> sizeLimit, std::optional<std::optional<::hilti::rt::integer::safe<int64_t>>> timeLimit, std::optional<std::optional<::hilti::rt::Bool>> typesOnly, std::optional<std::optional<std::string>> filter, std::optional<std::optional<::hilti::rt::Vector<std::string>>> attributes) : SearchRequest() {
        if ( baseObject ) this->baseObject = std::move(*baseObject);
        if ( scope ) this->scope = std::move(*scope);
        if ( deref ) this->deref = std::move(*deref);
        if ( sizeLimit ) this->sizeLimit = std::move(*sizeLimit);
        if ( timeLimit ) this->timeLimit = std::move(*timeLimit);
        if ( typesOnly ) this->typesOnly = std::move(*typesOnly);
        if ( filter ) this->filter = std::move(*filter);
        if ( attributes ) this->attributes = std::move(*attributes);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::NotImplemented& x) -> std::ostream&;
    NotImplemented::NotImplemented() {
    }

    NotImplemented::NotImplemented(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __p_message) : __p_message(std::move(__p_message)) {
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::ModifyResponse& x) -> std::ostream&;
    extern void __hook_ModifyResponse___on__anon_36(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::ModifyResponse>& __self);
    ModifyResponse::ModifyResponse() {
    }

    ModifyResponse::ModifyResponse(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __p_message) : __p_message(std::move(__p_message)) {
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::ModifyRequest& x) -> std::ostream&;
    extern void __hook_ModifyRequest___on_objectName(const std::string& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::ModifyRequest>& __self);
    ModifyRequest::ModifyRequest() {
    }

    ModifyRequest::ModifyRequest(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __p_message) : __p_message(std::move(__p_message)) {
    }

    ModifyRequest::ModifyRequest(std::optional<std::optional<std::string>> objectName) : ModifyRequest() {
        if ( objectName ) this->objectName = std::move(*objectName);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::ModDNResponse& x) -> std::ostream&;
    extern void __hook_ModDNResponse___on__anon_39(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::ModDNResponse>& __self);
    ModDNResponse::ModDNResponse() {
    }

    ModDNResponse::ModDNResponse(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __p_message) : __p_message(std::move(__p_message)) {
    }

    
    extern void __hook_Message___on_seqHeader(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __self);
    extern void __hook_Message___on__anon_19(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __self);
    extern void __hook_Message___on__anon_53(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Body>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __self);
    extern void __hook_Message___on_protocolOp(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::BindRequest& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::BindResponse& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::AddResponse& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::DelRequest& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::DelResponse& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::CompareResponse& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::AbandonRequest& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::ExtendedRequest& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::ExtendedResponse& x) -> std::ostream&;
    extern void __hook_Message___on_0x25_done(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __self);
    Message::Message() {
    }

    Message::Message(::hilti::rt::StrongReference<__hlt_ldap::LDAP::Ctx> __p_ctx) : __p_ctx(std::move(__p_ctx)) {
    {
        opcode = LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::Undef};
        result_ = ::hilti::rt::StrongReference<__hlt_ldap::LDAP::Result>((*__self()).unsetResultDefault);
        obj = ""s;
        arg = ""s;
    }
    }

    Message::Message(std::optional<::hilti::rt::integer::safe<int64_t>> messageID, std::optional<LDAP::ProtocolOpcode> opcode, std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>> unsetResultDefault, std::optional<::hilti::rt::StrongReference<__hlt_ldap::LDAP::Result>> result_, std::optional<std::string> obj, std::optional<std::string> arg, std::optional<::hilti::rt::integer::safe<uint64_t>> seqHeaderLen, std::optional<::hilti::rt::integer::safe<uint64_t>> msgLen, std::optional<::hilti::rt::integer::safe<uint64_t>> opLen, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> seqHeader, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> messageID_header, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> protocolOp, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::BindRequest>>> BIND_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::BindResponse>>> BIND_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::UnbindRequest>>> UNBIND_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchRequest>>> SEARCH_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchResultEntry>>> SEARCH_RESULT_ENTRY, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchResultDone>>> SEARCH_RESULT_DONE, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::ModifyRequest>>> MODIFY_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::ModifyResponse>>> MODIFY_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::AddResponse>>> ADD_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::DelRequest>>> DEL_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::DelResponse>>> DEL_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::ModDNResponse>>> MOD_DN_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::CompareResponse>>> COMPARE_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::AbandonRequest>>> ABANDON_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::NotImplemented>>> ADD_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::NotImplemented>>> COMPARE_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::ExtendedRequest>>> EXTENDED_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::ExtendedResponse>>> EXTENDED_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::NotImplemented>>> INTERMEDIATE_RESPONSE, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::NotImplemented>>> MOD_DN_REQUEST, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::NotImplemented>>> SEARCH_RESULT_REFERENCE) : Message() {
        if ( messageID ) this->messageID = std::move(*messageID);
        if ( opcode ) this->opcode = std::move(*opcode);
        if ( unsetResultDefault ) this->unsetResultDefault = std::move(*unsetResultDefault);
        if ( result_ ) this->result_ = std::move(*result_);
        if ( obj ) this->obj = std::move(*obj);
        if ( arg ) this->arg = std::move(*arg);
        if ( seqHeaderLen ) this->seqHeaderLen = std::move(*seqHeaderLen);
        if ( msgLen ) this->msgLen = std::move(*msgLen);
        if ( opLen ) this->opLen = std::move(*opLen);
        if ( seqHeader ) this->seqHeader = std::move(*seqHeader);
        if ( messageID_header ) this->messageID_header = std::move(*messageID_header);
        if ( protocolOp ) this->protocolOp = std::move(*protocolOp);
        if ( BIND_REQUEST ) this->BIND_REQUEST = std::move(*BIND_REQUEST);
        if ( BIND_RESPONSE ) this->BIND_RESPONSE = std::move(*BIND_RESPONSE);
        if ( UNBIND_REQUEST ) this->UNBIND_REQUEST = std::move(*UNBIND_REQUEST);
        if ( SEARCH_REQUEST ) this->SEARCH_REQUEST = std::move(*SEARCH_REQUEST);
        if ( SEARCH_RESULT_ENTRY ) this->SEARCH_RESULT_ENTRY = std::move(*SEARCH_RESULT_ENTRY);
        if ( SEARCH_RESULT_DONE ) this->SEARCH_RESULT_DONE = std::move(*SEARCH_RESULT_DONE);
        if ( MODIFY_REQUEST ) this->MODIFY_REQUEST = std::move(*MODIFY_REQUEST);
        if ( MODIFY_RESPONSE ) this->MODIFY_RESPONSE = std::move(*MODIFY_RESPONSE);
        if ( ADD_RESPONSE ) this->ADD_RESPONSE = std::move(*ADD_RESPONSE);
        if ( DEL_REQUEST ) this->DEL_REQUEST = std::move(*DEL_REQUEST);
        if ( DEL_RESPONSE ) this->DEL_RESPONSE = std::move(*DEL_RESPONSE);
        if ( MOD_DN_RESPONSE ) this->MOD_DN_RESPONSE = std::move(*MOD_DN_RESPONSE);
        if ( COMPARE_RESPONSE ) this->COMPARE_RESPONSE = std::move(*COMPARE_RESPONSE);
        if ( ABANDON_REQUEST ) this->ABANDON_REQUEST = std::move(*ABANDON_REQUEST);
        if ( ADD_REQUEST ) this->ADD_REQUEST = std::move(*ADD_REQUEST);
        if ( COMPARE_REQUEST ) this->COMPARE_REQUEST = std::move(*COMPARE_REQUEST);
        if ( EXTENDED_REQUEST ) this->EXTENDED_REQUEST = std::move(*EXTENDED_REQUEST);
        if ( EXTENDED_RESPONSE ) this->EXTENDED_RESPONSE = std::move(*EXTENDED_RESPONSE);
        if ( INTERMEDIATE_RESPONSE ) this->INTERMEDIATE_RESPONSE = std::move(*INTERMEDIATE_RESPONSE);
        if ( MOD_DN_REQUEST ) this->MOD_DN_REQUEST = std::move(*MOD_DN_REQUEST);
        if ( SEARCH_RESULT_REFERENCE ) this->SEARCH_RESULT_REFERENCE = std::move(*SEARCH_RESULT_REFERENCE);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::ExtendedResponseEntry& x) -> std::ostream&;
    extern void __hook_ExtendedResponseEntry___on__anon_60(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::ExtendedResponseEntry>& __self);
    ExtendedResponseEntry::ExtendedResponseEntry() {
    }

    ExtendedResponseEntry::ExtendedResponseEntry(::hilti::rt::ValueReference<__hlt_ldap::LDAP::ExtendedResponse>& __p_r) : __p_r(std::move(__p_r)) {
    }

    
    extern void __hook_ExtendedResponse___on__anon_41(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::ExtendedResponse>& __self);
    extern void __hook_ExtendedResponse___on_0x25_done(::hilti::rt::ValueReference<__hlt_ldap::LDAP::ExtendedResponse>& __self);
    ExtendedResponse::ExtendedResponse() {
    }

    ExtendedResponse::ExtendedResponse(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __p_message, ::hilti::rt::StrongReference<__hlt_ldap::LDAP::Ctx> __p_ctx) : __p_message(std::move(__p_message)), __p_ctx(std::move(__p_ctx)) {
    }

    ExtendedResponse::ExtendedResponse(std::optional<::hilti::rt::Bytes> responseName, std::optional<::hilti::rt::Bytes> responseValue) : ExtendedResponse() {
        if ( responseName ) this->responseName = std::move(*responseName);
        if ( responseValue ) this->responseValue = std::move(*responseValue);
    }

    
    extern void __hook_ExtendedRequest___on_requestName(const std::string& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::ExtendedRequest>& __self);
    extern void __hook_ExtendedRequest___on__anon_59(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::ExtendedRequest>& __self);
    extern void __hook_ExtendedRequest___on_0x25_done(::hilti::rt::ValueReference<__hlt_ldap::LDAP::ExtendedRequest>& __self);
    ExtendedRequest::ExtendedRequest() {
    }

    ExtendedRequest::ExtendedRequest(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __p_message, ::hilti::rt::StrongReference<__hlt_ldap::LDAP::Ctx> __p_ctx) : __p_message(std::move(__p_message)), __p_ctx(std::move(__p_ctx)) {
    }

    ExtendedRequest::ExtendedRequest(std::optional<::hilti::rt::Bytes> requestValue, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> header, std::optional<std::optional<std::string>> requestName) : ExtendedRequest() {
        if ( requestValue ) this->requestValue = std::move(*requestValue);
        if ( header ) this->header = std::move(*header);
        if ( requestName ) this->requestName = std::move(*requestName);
    }

    
    extern void __hook_DelResponse___on__anon_38(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::DelResponse>& __self);
    DelResponse::DelResponse() {
    }

    DelResponse::DelResponse(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __p_message) : __p_message(std::move(__p_message)) {
    }

    
    extern void __hook_DelRequest___on_objectName(const std::string& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::DelRequest>& __self);
    DelRequest::DelRequest() {
    }

    DelRequest::DelRequest(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __p_message) : __p_message(std::move(__p_message)) {
    }

    DelRequest::DelRequest(std::optional<std::optional<std::string>> objectName) : DelRequest() {
        if ( objectName ) this->objectName = std::move(*objectName);
    }

    
    extern void __hook_CompareResponse___on__anon_40(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::CompareResponse>& __self);
    CompareResponse::CompareResponse() {
    }

    CompareResponse::CompareResponse(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __p_message) : __p_message(std::move(__p_message)) {
    }

    
    extern void __hook_BindResponse___on__anon_27(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::BindResponse>& __self);
    extern void __hook_BindResponse___on_gss_spnego(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::GSS_SPNEGO_Subsequent>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::BindResponse>& __self);
    BindResponse::BindResponse() {
    }

    BindResponse::BindResponse(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __p_message, ::hilti::rt::StrongReference<__hlt_ldap::LDAP::Ctx> __p_ctx) : __p_message(std::move(__p_message)), __p_ctx(std::move(__p_ctx)) {
    }

    BindResponse::BindResponse(std::optional<std::optional<::hilti::rt::Vector<__hlt_ldap::LDAP::ServerSaslCreds>>> serverSaslCreds, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::GSS_SPNEGO_Subsequent>>> gss_spnego) : BindResponse() {
        if ( serverSaslCreds ) this->serverSaslCreds = std::move(*serverSaslCreds);
        if ( gss_spnego ) this->gss_spnego = std::move(*gss_spnego);
    }

    
    extern void __hook_BindRequest___on_name(const std::string& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::BindRequest>& __self);
    extern void __hook_BindRequest___on__anon_54(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::BindRequest>& __self);
    extern void __hook_BindRequest___on_saslCreds(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SaslCredentials>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::BindRequest>& __self);
    extern void __hook_BindRequest___on_0x25_done(::hilti::rt::ValueReference<__hlt_ldap::LDAP::BindRequest>& __self);
    BindRequest::BindRequest() {
    }

    BindRequest::BindRequest(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __p_message, ::hilti::rt::StrongReference<__hlt_ldap::LDAP::Ctx> __p_ctx) : __p_message(std::move(__p_message)), __p_ctx(std::move(__p_ctx)) {
    {
        authType = LDAP::BindAuthType{LDAP::BindAuthType::Undef};
        authData = ""_b;
        simpleCreds = ""s;
    }
    }

    BindRequest::BindRequest(std::optional<std::optional<::hilti::rt::integer::safe<int64_t>>> version, std::optional<std::optional<std::string>> name, std::optional<LDAP::BindAuthType> authType, std::optional<::hilti::rt::Bytes> authData, std::optional<std::string> simpleCreds, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::SaslCredentials>>> saslCreds) : BindRequest() {
        if ( version ) this->version = std::move(*version);
        if ( name ) this->name = std::move(*name);
        if ( authType ) this->authType = std::move(*authType);
        if ( authData ) this->authData = std::move(*authData);
        if ( simpleCreds ) this->simpleCreds = std::move(*simpleCreds);
        if ( saslCreds ) this->saslCreds = std::move(*saslCreds);
    }

    
    extern void __hook_AddResponse___on__anon_37(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::AddResponse>& __self);
    AddResponse::AddResponse() {
    }

    AddResponse::AddResponse(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __p_message) : __p_message(std::move(__p_message)) {
    }

    
    extern void __hook_AbandonRequest___on_messageID(const ::hilti::rt::integer::safe<int64_t>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::AbandonRequest>& __self);
    AbandonRequest::AbandonRequest() {
    }

    AbandonRequest::AbandonRequest(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __p_message) : __p_message(std::move(__p_message)) {
    }

    AbandonRequest::AbandonRequest(std::optional<std::optional<::hilti::rt::integer::safe<int64_t>>> messageID) : AbandonRequest() {
        if ( messageID ) this->messageID = std::move(*messageID);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::AttributeSelection& x) -> std::ostream&;
    extern void __hook_AttributeSelection___on__anon_55(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::AttributeSelection>& __self);
    AttributeSelection::AttributeSelection() {
    }

    AttributeSelection::AttributeSelection(std::optional<::hilti::rt::Vector<std::string>> attributes) : AttributeSelection() {
        if ( attributes ) this->attributes = std::move(*attributes);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::AttributeValueAssertion& x) -> std::ostream&;
    extern void __hook_AttributeValueAssertion___on__anon_56(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::AttributeValueAssertion>& __self);
    AttributeValueAssertion::AttributeValueAssertion() {
    {
        desc = ""s;
        val = ""s;
    }
    }

    AttributeValueAssertion::AttributeValueAssertion(std::optional<std::string> desc, std::optional<std::string> val) : AttributeValueAssertion() {
        if ( desc ) this->desc = std::move(*desc);
        if ( val ) this->val = std::move(*val);
    }

    
}

namespace hilti::rt::detail::adl {
    inline auto to_string(__hlt_ldap::LDAP::FilterType x, adl::tag) -> std::string;
}

namespace __hlt_ldap::LDAP {
    inline auto operator<<(std::ostream& o, FilterType x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::DecodedAttributeValue& x) -> std::ostream&;
    extern void __hook_DecodedAttributeValue___on_0x25_done(::hilti::rt::ValueReference<__hlt_ldap::LDAP::DecodedAttributeValue>& __self);
    DecodedAttributeValue::DecodedAttributeValue() {
        __p_fType = LDAP::FilterType::Undef;
    }

    DecodedAttributeValue::DecodedAttributeValue(const LDAP::FilterType& __p_fType) : __p_fType(std::move(__p_fType)) {
        assertionValueDecoded = ""s;
    }

    DecodedAttributeValue::DecodedAttributeValue(std::optional<std::string> assertionValueDecoded, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> attributeDesc_len, std::optional<std::optional<::hilti::rt::Bytes>> attributeDesc, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> assertionValue_len, std::optional<std::optional<::hilti::rt::Bytes>> assertionValue, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> matchValue_len, std::optional<std::optional<::hilti::rt::Bytes>> matchValue) : DecodedAttributeValue() {
        if ( assertionValueDecoded ) this->assertionValueDecoded = std::move(*assertionValueDecoded);
        if ( attributeDesc_len ) this->attributeDesc_len = std::move(*attributeDesc_len);
        if ( attributeDesc ) this->attributeDesc = std::move(*attributeDesc);
        if ( assertionValue_len ) this->assertionValue_len = std::move(*assertionValue_len);
        if ( assertionValue ) this->assertionValue = std::move(*assertionValue);
        if ( matchValue_len ) this->matchValue_len = std::move(*matchValue_len);
        if ( matchValue ) this->matchValue = std::move(*matchValue);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::EncryptedMessage& x) -> std::ostream&;
    EncryptedMessage::EncryptedMessage() {
    }

    EncryptedMessage::EncryptedMessage(std::optional<std::optional<::hilti::rt::integer::safe<uint32_t>>> len) : EncryptedMessage() {
        if ( len ) this->len = std::move(*len);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::KrbWrapToken& x) -> std::ostream&;
    extern void __hook_KrbWrapToken___on_rrc(const ::hilti::rt::integer::safe<uint16_t>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::KrbWrapToken>& __self);
    KrbWrapToken::KrbWrapToken() {
    }

    KrbWrapToken::KrbWrapToken(std::optional<::hilti::rt::integer::safe<uint64_t>> trailer_ec, std::optional<::hilti::rt::integer::safe<uint64_t>> header_ec, std::optional<std::optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>> ctx_flags, std::optional<std::optional<::hilti::rt::integer::safe<uint16_t>>> ec, std::optional<std::optional<::hilti::rt::integer::safe<uint16_t>>> rrc, std::optional<std::optional<::hilti::rt::integer::safe<uint64_t>>> snd_seq) : KrbWrapToken() {
        if ( trailer_ec ) this->trailer_ec = std::move(*trailer_ec);
        if ( header_ec ) this->header_ec = std::move(*header_ec);
        if ( ctx_flags ) this->ctx_flags = std::move(*ctx_flags);
        if ( ec ) this->ec = std::move(*ec);
        if ( rrc ) this->rrc = std::move(*rrc);
        if ( snd_seq ) this->snd_seq = std::move(*snd_seq);
    }

    
    extern void __hook_AbandonRequest___on_messageID_4353(const ::hilti::rt::integer::safe<int64_t>& __dd, ::hilti::rt::ValueReference<AbandonRequest>& __self);
    extern void __hook_AbandonRequest___on_messageID(const ::hilti::rt::integer::safe<int64_t>& __dd, ::hilti::rt::ValueReference<AbandonRequest>& __self);
    extern void __hook_AbandonRequest___on_messageID_4353(const ::hilti::rt::integer::safe<int64_t>& __dd, ::hilti::rt::ValueReference<AbandonRequest>& __self);
    extern void __hook_AddResponse___on__anon_37_9e3(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<AddResponse>& __self);
    extern void __hook_AddResponse___on__anon_37(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<AddResponse>& __self);
    extern void __hook_AddResponse___on__anon_37_9e3(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<AddResponse>& __self);
    extern void __hook_AttributeSelection___on__anon_55_d6d(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<AttributeSelection>& __self);
    extern void __hook_AttributeSelection___on__anon_55(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<AttributeSelection>& __self);
    extern void __hook_AttributeSelection___on__anon_55_d6d(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<AttributeSelection>& __self);
}

namespace hlt_ldap::LDAP::AttributeSelection {
    extern auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse2(::hilti::rt::ValueReference<__hlt_ldap::LDAP::AttributeSelection>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace __hlt_ldap::LDAP {
    extern void __hook_AttributeValueAssertion___on__anon_56_3ca9(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<AttributeValueAssertion>& __self);
    extern void __hook_AttributeValueAssertion___on__anon_56(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<AttributeValueAssertion>& __self);
    extern void __hook_AttributeValueAssertion___on__anon_56_3ca9(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<AttributeValueAssertion>& __self);
    extern void __hook_BindRequest___on__anon_54_a6d5(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<BindRequest>& __self);
    extern void __hook_BindRequest___on__anon_54(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<BindRequest>& __self);
    extern void __hook_BindRequest___on__anon_54_a6d5(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<BindRequest>& __self);
    extern void __hook_BindRequest___on_name_207c(const std::string& __dd, ::hilti::rt::ValueReference<BindRequest>& __self);
    extern void __hook_BindRequest___on_name(const std::string& __dd, ::hilti::rt::ValueReference<BindRequest>& __self);
    extern void __hook_BindRequest___on_name_207c(const std::string& __dd, ::hilti::rt::ValueReference<BindRequest>& __self);
    extern void __hook_BindRequest___on_saslCreds_7185(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SaslCredentials>& __dd, ::hilti::rt::ValueReference<BindRequest>& __self);
    extern void __hook_BindRequest___on_saslCreds(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SaslCredentials>& __dd, ::hilti::rt::ValueReference<BindRequest>& __self);
    extern void __hook_BindRequest___on_saslCreds_7185(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SaslCredentials>& __dd, ::hilti::rt::ValueReference<BindRequest>& __self);
    extern void __hook_BindResponse___on__anon_27_4af9(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<BindResponse>& __self);
    extern void __hook_BindResponse___on__anon_27(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<BindResponse>& __self);
    extern void __hook_BindResponse___on__anon_27_4af9(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<BindResponse>& __self);
    extern void __hook_BindResponse___on_gss_spnego_b76b(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::GSS_SPNEGO_Subsequent>& __dd, ::hilti::rt::ValueReference<BindResponse>& __self);
    extern void __hook_BindResponse___on_gss_spnego(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::GSS_SPNEGO_Subsequent>& __dd, ::hilti::rt::ValueReference<BindResponse>& __self);
    extern void __hook_BindResponse___on_gss_spnego_b76b(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::GSS_SPNEGO_Subsequent>& __dd, ::hilti::rt::ValueReference<BindResponse>& __self);
    extern void __hook_CompareResponse___on__anon_40_7606(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<CompareResponse>& __self);
    extern void __hook_CompareResponse___on__anon_40(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<CompareResponse>& __self);
    extern void __hook_CompareResponse___on__anon_40_7606(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<CompareResponse>& __self);
    extern auto bytes_sid_to_SID_repr(const ::hilti::rt::Bytes& bts) -> std::string;
    extern auto bytes_sid_to_hex_repr(const ::hilti::rt::Bytes& bts) -> std::string;
    extern auto uint32_to_hex_repr(const ::hilti::rt::Bytes& bts) -> std::string;
    extern auto utf16_guid_to_hex_repr(const ::hilti::rt::Bytes& bts) -> std::string;
    extern void __hook_DecodedAttributeValue___on_0x25_done_f3dc(::hilti::rt::ValueReference<DecodedAttributeValue>& __self);
    extern void __hook_DecodedAttributeValue___on_0x25_done(::hilti::rt::ValueReference<DecodedAttributeValue>& __self);
    extern void __hook_DecodedAttributeValue___on_0x25_done_f3dc(::hilti::rt::ValueReference<DecodedAttributeValue>& __self);
    extern void __hook_DelRequest___on_objectName_82c2(const std::string& __dd, ::hilti::rt::ValueReference<DelRequest>& __self);
    extern void __hook_DelRequest___on_objectName(const std::string& __dd, ::hilti::rt::ValueReference<DelRequest>& __self);
    extern void __hook_DelRequest___on_objectName_82c2(const std::string& __dd, ::hilti::rt::ValueReference<DelRequest>& __self);
    extern void __hook_DelResponse___on__anon_38_5462(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<DelResponse>& __self);
    extern void __hook_DelResponse___on__anon_38(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<DelResponse>& __self);
    extern void __hook_DelResponse___on__anon_38_5462(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<DelResponse>& __self);
    extern void __hook_ExtendedRequest___on_0x25_done_9c73(::hilti::rt::ValueReference<ExtendedRequest>& __self);
    extern void __hook_ExtendedRequest___on_0x25_done(::hilti::rt::ValueReference<ExtendedRequest>& __self);
    extern void __hook_ExtendedRequest___on_0x25_done_9c73(::hilti::rt::ValueReference<ExtendedRequest>& __self);
    extern void __hook_ExtendedRequest___on__anon_59_8e3a(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<ExtendedRequest>& __self);
    extern void __hook_ExtendedRequest___on__anon_59(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<ExtendedRequest>& __self);
    extern void __hook_ExtendedRequest___on__anon_59_8e3a(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<ExtendedRequest>& __self);
    extern void __hook_ExtendedRequest___on_requestName_af31(const std::string& __dd, ::hilti::rt::ValueReference<ExtendedRequest>& __self);
    extern void __hook_ExtendedRequest___on_requestName(const std::string& __dd, ::hilti::rt::ValueReference<ExtendedRequest>& __self);
    extern void __hook_ExtendedRequest___on_requestName_af31(const std::string& __dd, ::hilti::rt::ValueReference<ExtendedRequest>& __self);
    extern void __hook_ExtendedResponse___on_0x25_done_67ef(::hilti::rt::ValueReference<ExtendedResponse>& __self);
    extern void __hook_ExtendedResponse___on_0x25_done(::hilti::rt::ValueReference<ExtendedResponse>& __self);
    extern void __hook_ExtendedResponse___on_0x25_done_67ef(::hilti::rt::ValueReference<ExtendedResponse>& __self);
    extern void __hook_ExtendedResponse___on__anon_41_b437(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<ExtendedResponse>& __self);
    extern void __hook_ExtendedResponse___on__anon_41(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<ExtendedResponse>& __self);
    extern void __hook_ExtendedResponse___on__anon_41_b437(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<ExtendedResponse>& __self);
    extern void __hook_ExtendedResponseEntry___on__anon_60_1e96(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<ExtendedResponseEntry>& __self);
    extern void __hook_ExtendedResponseEntry___on__anon_60(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<ExtendedResponseEntry>& __self);
    extern void __hook_ExtendedResponseEntry___on__anon_60_1e96(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<ExtendedResponseEntry>& __self);
    extern void __hook_GSS_SPNEGO_negTokenResp___on_seq_ca80(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<GSS_SPNEGO_negTokenResp>& __self);
    extern void __hook_GSS_SPNEGO_negTokenResp___on_seq(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<GSS_SPNEGO_negTokenResp>& __self);
    extern void __hook_GSS_SPNEGO_negTokenResp___on_seq_ca80(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<GSS_SPNEGO_negTokenResp>& __self);
    extern void __hook_KrbWrapToken___on_rrc_c668(const ::hilti::rt::integer::safe<uint16_t>& __dd, ::hilti::rt::ValueReference<KrbWrapToken>& __self);
    extern void __hook_KrbWrapToken___on_rrc(const ::hilti::rt::integer::safe<uint16_t>& __dd, ::hilti::rt::ValueReference<KrbWrapToken>& __self);
    extern void __hook_KrbWrapToken___on_rrc_c668(const ::hilti::rt::integer::safe<uint16_t>& __dd, ::hilti::rt::ValueReference<KrbWrapToken>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::SaslMsKrb5Stripper& x) -> std::ostream&;
    extern void __hook_SaslMsKrb5Stripper___on__anon_15(::hilti::rt::ValueReference<__hlt_ldap::LDAP::SaslMsKrb5Stripper>& __self);
    SaslMsKrb5Stripper::SaslMsKrb5Stripper() {
    }

    SaslMsKrb5Stripper::SaslMsKrb5Stripper(::hilti::rt::StrongReference<__hlt_ldap::LDAP::Ctx> __p_ctx) : __p_ctx(std::move(__p_ctx)) {
    }

    SaslMsKrb5Stripper::SaslMsKrb5Stripper(std::optional<::hilti::rt::integer::safe<uint64_t>> switch_size, std::optional<std::optional<::hilti::rt::integer::safe<uint32_t>>> len, std::optional<std::optional<::hilti::rt::integer::safe<uint16_t>>> krb5_tok_id, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::KrbWrapToken>>> krb_wrap_token) : SaslMsKrb5Stripper() {
        if ( switch_size ) this->switch_size = std::move(*switch_size);
        if ( len ) this->len = std::move(*len);
        if ( krb5_tok_id ) this->krb5_tok_id = std::move(*krb5_tok_id);
        if ( krb_wrap_token ) this->krb_wrap_token = std::move(*krb_wrap_token);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::TlsForward& x) -> std::ostream&;
    extern void __hook_TlsForward___on_chunk(const ::hilti::rt::Bytes& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::TlsForward>& __self);
    extern void __hook_TlsForward___on_0x25_init(::hilti::rt::ValueReference<__hlt_ldap::LDAP::TlsForward>& __self);
    TlsForward::TlsForward() {
    }

    TlsForward::TlsForward(std::optional<std::optional<::hilti::rt::Bytes>> chunk) : TlsForward() {
        if ( chunk ) this->chunk = std::move(*chunk);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::MessageDispatch& x) -> std::ostream&;
    MessageDispatch::MessageDispatch() {
    }

    MessageDispatch::MessageDispatch(::hilti::rt::StrongReference<__hlt_ldap::LDAP::Ctx> __p_ctx) : __p_ctx(std::move(__p_ctx)) {
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::MaybeEncrypted& x) -> std::ostream&;
    extern void __hook_MaybeEncrypted___on_first(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::MaybeEncrypted>& __self);
    extern void __hook_MaybeEncrypted___on_rem(const ::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::MaybeEncrypted>& __self);
    extern void __hook_MaybeEncrypted___on__anon_10(const ::hilti::rt::integer::safe<uint16_t>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::MaybeEncrypted>& __self);
    extern void __hook_MaybeEncrypted___on__anon_11(::hilti::rt::ValueReference<__hlt_ldap::LDAP::MaybeEncrypted>& __self);
    extern void __hook_MaybeEncrypted___on_0x25_init(::hilti::rt::ValueReference<__hlt_ldap::LDAP::MaybeEncrypted>& __self);
    MaybeEncrypted::MaybeEncrypted() {
    }

    MaybeEncrypted::MaybeEncrypted(::hilti::rt::StrongReference<__hlt_ldap::LDAP::Ctx> __p_ctx) : __p_ctx(std::move(__p_ctx)) {
    }

    MaybeEncrypted::MaybeEncrypted(std::optional<::hilti::rt::stream::SafeConstIterator> start, std::optional<::hilti::rt::integer::safe<uint64_t>> saslLen, std::optional<::hilti::rt::Bytes> mech, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> first, std::optional<std::optional<::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>>> rem) : MaybeEncrypted() {
        if ( start ) this->start = std::move(*start);
        if ( saslLen ) this->saslLen = std::move(*saslLen);
        if ( mech ) this->mech = std::move(*mech);
        if ( first ) this->first = std::move(*first);
        if ( rem ) this->rem = std::move(*rem);
    }

    
    extern void __hook_MaybeEncrypted___on_0x25_init_bfd5(::hilti::rt::ValueReference<MaybeEncrypted>& __self);
    extern void __hook_MaybeEncrypted___on_0x25_init(::hilti::rt::ValueReference<MaybeEncrypted>& __self);
    extern void __hook_MaybeEncrypted___on_0x25_init_bfd5(::hilti::rt::ValueReference<MaybeEncrypted>& __self);
    extern void __hook_MaybeEncrypted___on__anon_10_c553(const ::hilti::rt::integer::safe<uint16_t>& __dd, ::hilti::rt::ValueReference<MaybeEncrypted>& __self);
    extern void __hook_MaybeEncrypted___on__anon_10(const ::hilti::rt::integer::safe<uint16_t>& __dd, ::hilti::rt::ValueReference<MaybeEncrypted>& __self);
    extern void __hook_MaybeEncrypted___on__anon_10_c553(const ::hilti::rt::integer::safe<uint16_t>& __dd, ::hilti::rt::ValueReference<MaybeEncrypted>& __self);
    extern void __hook_MaybeEncrypted___on__anon_11_20bc(::hilti::rt::ValueReference<MaybeEncrypted>& __self);
    extern void __hook_MaybeEncrypted___on__anon_11(::hilti::rt::ValueReference<MaybeEncrypted>& __self);
    extern void __hook_MaybeEncrypted___on__anon_11_20bc(::hilti::rt::ValueReference<MaybeEncrypted>& __self);
    extern void __hook_MaybeEncrypted___on_first_e725(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<MaybeEncrypted>& __self);
    extern void __hook_MaybeEncrypted___on_first(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<MaybeEncrypted>& __self);
    extern void __hook_MaybeEncrypted___on_first_e725(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<MaybeEncrypted>& __self);
    extern void __hook_MaybeEncrypted___on_rem_ec7f(const ::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>& __dd, ::hilti::rt::ValueReference<MaybeEncrypted>& __self);
    extern void __hook_MaybeEncrypted___on_rem(const ::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>& __dd, ::hilti::rt::ValueReference<MaybeEncrypted>& __self);
    extern void __hook_MaybeEncrypted___on_rem_ec7f(const ::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>& __dd, ::hilti::rt::ValueReference<MaybeEncrypted>& __self);
}

namespace spicy::rt {
    extern void accept_input();
}

namespace __hlt_ldap::LDAP {
    extern void __hook_Message___on_0x25_done_d8fb(::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on_0x25_done(::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on_0x25_done_d8fb(::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on__anon_19_9be7(::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on__anon_19(::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on__anon_19_9be7(::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on__anon_53_8657(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Body>& __dd, ::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on__anon_53(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Body>& __dd, ::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on__anon_53_8657(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Body>& __dd, ::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on_protocolOp_a679(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd, ::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on_protocolOp(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd, ::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on_protocolOp_a679(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd, ::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on_seqHeader_f2b5(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd, ::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on_seqHeader(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd, ::hilti::rt::ValueReference<Message>& __self);
    extern void __hook_Message___on_seqHeader_f2b5(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd, ::hilti::rt::ValueReference<Message>& __self);
}

namespace hlt_ldap::LDAP::Message {
    extern auto parse2(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace hlt_ldap::LDAP::MessageDispatch {
    extern auto parse2(::hilti::rt::ValueReference<__hlt_ldap::LDAP::MessageDispatch>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace __hlt_ldap::LDAP {
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::Messages& x) -> std::ostream&;
    Messages::Messages() {
    }

    
}

namespace hlt_ldap::LDAP::Messages {
    extern auto context_new() -> ::spicy::rt::UnitContext;
    extern auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse2(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Messages>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace __hlt_ldap::LDAP {
    extern void __hook_ModDNResponse___on__anon_39_5aa(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<ModDNResponse>& __self);
    extern void __hook_ModDNResponse___on__anon_39(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<ModDNResponse>& __self);
    extern void __hook_ModDNResponse___on__anon_39_5aa(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<ModDNResponse>& __self);
    extern void __hook_ModifyRequest___on_objectName_caf3(const std::string& __dd, ::hilti::rt::ValueReference<ModifyRequest>& __self);
    extern void __hook_ModifyRequest___on_objectName(const std::string& __dd, ::hilti::rt::ValueReference<ModifyRequest>& __self);
    extern void __hook_ModifyRequest___on_objectName_caf3(const std::string& __dd, ::hilti::rt::ValueReference<ModifyRequest>& __self);
    extern void __hook_ModifyResponse___on__anon_36_ce9(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<ModifyResponse>& __self);
    extern void __hook_ModifyResponse___on__anon_36(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<ModifyResponse>& __self);
    extern void __hook_ModifyResponse___on__anon_36_ce9(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<ModifyResponse>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::SubstringFilter& x) -> std::ostream&;
    extern void __hook_SubstringFilter___on__anon_34_foreach(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SubstringFilter>& __self);
    SubstringFilter::SubstringFilter() {
    }

    SubstringFilter::SubstringFilter(std::optional<std::string> initial, std::optional<std::string> final, std::optional<::hilti::rt::Vector<std::string>> anys, std::optional<std::optional<::hilti::rt::integer::safe<uint8_t>>> attributeDesc_len, std::optional<std::optional<::hilti::rt::Bytes>> attributeDesc, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>> header) : SubstringFilter() {
        if ( initial ) this->initial = std::move(*initial);
        if ( final ) this->final = std::move(*final);
        if ( anys ) this->anys = std::move(*anys);
        if ( attributeDesc_len ) this->attributeDesc_len = std::move(*attributeDesc_len);
        if ( attributeDesc ) this->attributeDesc = std::move(*attributeDesc);
        if ( header ) this->header = std::move(*header);
    }

    
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::SearchFilter& x) -> std::ostream&;
    extern void __hook_SearchFilter___on__anon_58(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchFilter>& __self);
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::ParseNestedAndOr& x) -> std::ostream&;
    extern auto operator<<(std::ostream& o, const __hlt_ldap::LDAP::ParseNestedNot& x) -> std::ostream&;
    extern void __hook_SearchFilter___on_0x25_done(::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchFilter>& __self);
    extern void __hook_SearchFilter___on_0x25_error(const std::string& __except, ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchFilter>& __self);
    SearchFilter::SearchFilter() {
    {
        filterType = LDAP::FilterType{LDAP::FilterType::Undef};
        filterBytes = ""_b;
        filterLen = ::hilti::rt::integer::safe<std::uint64_t>{0U};
        stringRepresentation = ""s;
    }
    }

    SearchFilter::SearchFilter(std::optional<LDAP::FilterType> filterType, std::optional<::hilti::rt::Bytes> filterBytes, std::optional<::hilti::rt::integer::safe<uint64_t>> filterLen, std::optional<std::string> stringRepresentation, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::ParseNestedAndOr>>> FILTER_AND, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::ParseNestedAndOr>>> FILTER_OR, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::ParseNestedNot>>> FILTER_NOT, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::DecodedAttributeValue>>> FILTER_EQ, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::SubstringFilter>>> FILTER_SUBSTR, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::DecodedAttributeValue>>> FILTER_GE, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::DecodedAttributeValue>>> FILTER_LE, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::DecodedAttributeValue>>> FILTER_APPROX, std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::DecodedAttributeValue>>> FILTER_EXT, std::optional<std::optional<std::string>> FILTER_PRESENT) : SearchFilter() {
        if ( filterType ) this->filterType = std::move(*filterType);
        if ( filterBytes ) this->filterBytes = std::move(*filterBytes);
        if ( filterLen ) this->filterLen = std::move(*filterLen);
        if ( stringRepresentation ) this->stringRepresentation = std::move(*stringRepresentation);
        if ( FILTER_AND ) this->FILTER_AND = std::move(*FILTER_AND);
        if ( FILTER_OR ) this->FILTER_OR = std::move(*FILTER_OR);
        if ( FILTER_NOT ) this->FILTER_NOT = std::move(*FILTER_NOT);
        if ( FILTER_EQ ) this->FILTER_EQ = std::move(*FILTER_EQ);
        if ( FILTER_SUBSTR ) this->FILTER_SUBSTR = std::move(*FILTER_SUBSTR);
        if ( FILTER_GE ) this->FILTER_GE = std::move(*FILTER_GE);
        if ( FILTER_LE ) this->FILTER_LE = std::move(*FILTER_LE);
        if ( FILTER_APPROX ) this->FILTER_APPROX = std::move(*FILTER_APPROX);
        if ( FILTER_EXT ) this->FILTER_EXT = std::move(*FILTER_EXT);
        if ( FILTER_PRESENT ) this->FILTER_PRESENT = std::move(*FILTER_PRESENT);
    }

    
    ParseNestedNot::ParseNestedNot() {
    }

    ParseNestedNot::ParseNestedNot(std::optional<std::optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchFilter>>> searchfilter) : ParseNestedNot() {
        if ( searchfilter ) this->searchfilter = std::move(*searchfilter);
    }

    
    ParseNestedAndOr::ParseNestedAndOr() {
    }

    ParseNestedAndOr::ParseNestedAndOr(std::optional<std::optional<::hilti::rt::Vector<__hlt_ldap::LDAP::SearchFilter>>> searchfilters) : ParseNestedAndOr() {
        if ( searchfilters ) this->searchfilters = std::move(*searchfilters);
    }

    
}

namespace hlt_ldap::LDAP::Result {
    extern auto parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse2(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
    extern auto parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace __hlt_ldap::LDAP {
    extern void __hook_SaslMsKrb5Stripper___on__anon_15_78ba(::hilti::rt::ValueReference<SaslMsKrb5Stripper>& __self);
    extern void __hook_SaslMsKrb5Stripper___on__anon_15(::hilti::rt::ValueReference<SaslMsKrb5Stripper>& __self);
    extern void __hook_SaslMsKrb5Stripper___on__anon_15_78ba(::hilti::rt::ValueReference<SaslMsKrb5Stripper>& __self);
    extern auto string_representation(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchFilter>& search_filter) -> std::string;
    extern void __hook_SearchFilter___on_0x25_done_2017(::hilti::rt::ValueReference<SearchFilter>& __self);
    extern void __hook_SearchFilter___on_0x25_done(::hilti::rt::ValueReference<SearchFilter>& __self);
    extern void __hook_SearchFilter___on_0x25_done_2017(::hilti::rt::ValueReference<SearchFilter>& __self);
    extern void __hook_SearchFilter___on_0x25_error_62fd(const std::string& __except, ::hilti::rt::ValueReference<SearchFilter>& __self);
    extern void __hook_SearchFilter___on_0x25_error(const std::string& __except, ::hilti::rt::ValueReference<SearchFilter>& __self);
    extern void __hook_SearchFilter___on_0x25_error_62fd(const std::string& __except, ::hilti::rt::ValueReference<SearchFilter>& __self);
    extern void __hook_SearchFilter___on__anon_58_c386(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<SearchFilter>& __self);
    extern void __hook_SearchFilter___on__anon_58(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<SearchFilter>& __self);
    extern void __hook_SearchFilter___on__anon_58_c386(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<SearchFilter>& __self);
    extern void __hook_SearchRequest___on_baseObject_d746(const std::string& __dd, ::hilti::rt::ValueReference<SearchRequest>& __self);
    extern void __hook_SearchRequest___on_baseObject(const std::string& __dd, ::hilti::rt::ValueReference<SearchRequest>& __self);
    extern void __hook_SearchRequest___on_baseObject_d746(const std::string& __dd, ::hilti::rt::ValueReference<SearchRequest>& __self);
    extern void __hook_SearchRequest___on_scope_c5f7(const LDAP::SearchScope& __dd, ::hilti::rt::ValueReference<SearchRequest>& __self);
    extern void __hook_SearchRequest___on_scope(const LDAP::SearchScope& __dd, ::hilti::rt::ValueReference<SearchRequest>& __self);
    extern void __hook_SearchRequest___on_scope_c5f7(const LDAP::SearchScope& __dd, ::hilti::rt::ValueReference<SearchRequest>& __self);
}

namespace hlt_ldap::LDAP::SearchRequest {
    extern auto parse2(::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchRequest>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable;
}

namespace __hlt_ldap::LDAP {
    extern void __hook_SearchResultDone___on__anon_35_25db(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<SearchResultDone>& __self);
    extern void __hook_SearchResultDone___on__anon_35(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<SearchResultDone>& __self);
    extern void __hook_SearchResultDone___on__anon_35_25db(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<SearchResultDone>& __self);
    extern void __hook_SearchResultEntry___on_objectName_642a(const std::string& __dd, ::hilti::rt::ValueReference<SearchResultEntry>& __self);
    extern void __hook_SearchResultEntry___on_objectName(const std::string& __dd, ::hilti::rt::ValueReference<SearchResultEntry>& __self);
    extern void __hook_SearchResultEntry___on_objectName_642a(const std::string& __dd, ::hilti::rt::ValueReference<SearchResultEntry>& __self);
    extern void __hook_SubstringFilter___on__anon_34_foreach_9818(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<SubstringFilter>& __self);
    extern void __hook_SubstringFilter___on__anon_34_foreach(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<SubstringFilter>& __self);
    extern void __hook_SubstringFilter___on__anon_34_foreach_9818(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<SubstringFilter>& __self);
    extern void __register_LDAP_AbandonRequest();
    extern void __register_LDAP_AddResponse();
    extern void __register_LDAP_AttributeSelection();
    extern void __register_LDAP_AttributeValueAssertion();
    extern void __register_LDAP_BindRequest();
    extern void __register_LDAP_BindResponse();
    extern void __register_LDAP_CompareResponse();
    extern void __register_LDAP_DecodedAttributeValue();
    extern void __register_LDAP_DelRequest();
    extern void __register_LDAP_DelResponse();
    extern void __register_LDAP_EncryptedMessage();
    extern void __register_LDAP_ExtendedRequest();
    extern void __register_LDAP_ExtendedResponse();
    extern void __register_LDAP_ExtendedResponseEntry();
    extern void __register_LDAP_GSS_SPNEGO_Init();
    extern void __register_LDAP_GSS_SPNEGO_Subsequent();
    extern void __register_LDAP_GSS_SPNEGO_negTokenInit();
    extern void __register_LDAP_GSS_SPNEGO_negTokenResp();
    extern void __register_LDAP_KrbWrapToken();
    extern void __register_LDAP_MaybeEncrypted();
    extern void __register_LDAP_Message();
    extern void __register_LDAP_MessageDispatch();
    extern void __register_LDAP_Messages();
    extern void __register_LDAP_ModDNResponse();
    extern void __register_LDAP_ModifyRequest();
    extern void __register_LDAP_ModifyResponse();
    extern void __register_LDAP_NotImplemented();
    extern void __register_LDAP_ParseNestedAndOr();
    extern void __register_LDAP_ParseNestedNot();
    extern void __register_LDAP_Result();
    extern void __register_LDAP_SaslCredentials();
    extern void __register_LDAP_SaslMsKrb5Stripper();
    extern void __register_LDAP_SearchFilter();
    extern void __register_LDAP_SearchRequest();
    extern void __register_LDAP_SearchResultDone();
    extern void __register_LDAP_SearchResultEntry();
    extern void __register_LDAP_ServerSaslCreds();
    extern void __register_LDAP_SubstringFilter();
    extern void __register_LDAP_TlsForward();
    extern void __register_LDAP_UnbindRequest();
    extern void __init_module();
    extern void __register_module();
}

namespace __hlt_ldap::type_info { namespace {
    extern const ::hilti::rt::TypeInfo __ti_LDAP__BindAuthType_namex2aLDAP__BindAuthTypex2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__BindAuthType_namex2aLDAP__BindAuthTypex2b = { "LDAP::BindAuthType", "LDAP::BindAuthType", new ::hilti::rt::type_info::Enum(std::vector<::hilti::rt::type_info::enum_::Label>({::hilti::rt::type_info::enum_::Label{ "BIND_AUTH_SIMPLE", 0 }, ::hilti::rt::type_info::enum_::Label{ "BIND_AUTH_SASL", 3 }, ::hilti::rt::type_info::enum_::Label{ "Undef", -1 }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__MessageMode_namex2aLDAP__MessageModex2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__MessageMode_namex2aLDAP__MessageModex2b = { "LDAP::MessageMode", "LDAP::MessageMode", new ::hilti::rt::type_info::Enum(std::vector<::hilti::rt::type_info::enum_::Label>({::hilti::rt::type_info::enum_::Label{ "MS_KRB5", 1 }, ::hilti::rt::type_info::enum_::Label{ "TLS", 2 }, ::hilti::rt::type_info::enum_::Label{ "MAYBE_ENCRYPTED", 3 }, ::hilti::rt::type_info::enum_::Label{ "CLEARTEXT", 4 }, ::hilti::rt::type_info::enum_::Label{ "ENCRYPTED", 5 }, ::hilti::rt::type_info::enum_::Label{ "Undef", -1 }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__Ctx_namex2aLDAP__Ctxx2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__Ctx_namex2aLDAP__Ctxx2b = { "LDAP::Ctx", "LDAP::Ctx", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "messageMode", &type_info::__ti_LDAP__MessageMode_namex2aLDAP__MessageModex2b, offsetof(LDAP::Ctx, messageMode), false, false }, ::hilti::rt::type_info::struct_::Field{ "saslMechanism", &::hilti::rt::type_info::string, offsetof(LDAP::Ctx, saslMechanism), false, false }, ::hilti::rt::type_info::struct_::Field{ "startTlsRequested", &::hilti::rt::type_info::bool_, offsetof(LDAP::Ctx, startTlsRequested), false, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__GSS_SPNEGO_negTokenInit_namex2aLDAP__GSS_SPNEGO_negTokenInitx2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ASN1__ASN1Header__value_refx2anamex2aASN1__ASN1Headerx2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Header_namex2aASN1__ASN1Headerx2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ASN1Tag__value_refx2anamex2aASN1__ASN1Tagx2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Tag_namex2aASN1__ASN1Tagx2b;
    extern const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_type___0__4_x28convertx31ASN1Typex2a__ddx2bx3e_constructed__5_x28convertx31cast_bool_x2a__ddx2bx3e_class__6__7_x28convertx31ASN1Classx2a__ddx2bx3e_x75_bitfieldx2a8_type__0_4_constructed_5_5_class_6_7_x2b;
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Type_namex2aASN1__ASN1Typex2b;
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Type_namex2aASN1__ASN1Typex2b = { "ASN1::ASN1Type", "ASN1::ASN1Type", new ::hilti::rt::type_info::Enum(std::vector<::hilti::rt::type_info::enum_::Label>({::hilti::rt::type_info::enum_::Label{ "Boolean", 1 }, ::hilti::rt::type_info::enum_::Label{ "Integer", 2 }, ::hilti::rt::type_info::enum_::Label{ "BitString", 3 }, ::hilti::rt::type_info::enum_::Label{ "OctetString", 4 }, ::hilti::rt::type_info::enum_::Label{ "NullVal", 5 }, ::hilti::rt::type_info::enum_::Label{ "ObjectIdentifier", 6 }, ::hilti::rt::type_info::enum_::Label{ "ObjectDescriptor", 7 }, ::hilti::rt::type_info::enum_::Label{ "InstanceOf", 8 }, ::hilti::rt::type_info::enum_::Label{ "Real", 9 }, ::hilti::rt::type_info::enum_::Label{ "Enumerated", 10 }, ::hilti::rt::type_info::enum_::Label{ "EmbeddedPDV", 11 }, ::hilti::rt::type_info::enum_::Label{ "UTF8String", 12 }, ::hilti::rt::type_info::enum_::Label{ "RelativeOID", 13 }, ::hilti::rt::type_info::enum_::Label{ "Sequence", 16 }, ::hilti::rt::type_info::enum_::Label{ "Set", 17 }, ::hilti::rt::type_info::enum_::Label{ "NumericString", 18 }, ::hilti::rt::type_info::enum_::Label{ "PrintableString", 19 }, ::hilti::rt::type_info::enum_::Label{ "TeletextString", 20 }, ::hilti::rt::type_info::enum_::Label{ "VideotextString", 21 }, ::hilti::rt::type_info::enum_::Label{ "IA5String", 22 }, ::hilti::rt::type_info::enum_::Label{ "UTCTime", 23 }, ::hilti::rt::type_info::enum_::Label{ "GeneralizedTime", 24 }, ::hilti::rt::type_info::enum_::Label{ "GraphicString", 25 }, ::hilti::rt::type_info::enum_::Label{ "VisibleString", 26 }, ::hilti::rt::type_info::enum_::Label{ "GeneralString", 27 }, ::hilti::rt::type_info::enum_::Label{ "UniversalString", 28 }, ::hilti::rt::type_info::enum_::Label{ "CharacterString", 29 }, ::hilti::rt::type_info::enum_::Label{ "BMPString", 30 }, ::hilti::rt::type_info::enum_::Label{ "Undef", -1 }})) };
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Class_namex2aASN1__ASN1Classx2b;
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Class_namex2aASN1__ASN1Classx2b = { "ASN1::ASN1Class", "ASN1::ASN1Class", new ::hilti::rt::type_info::Enum(std::vector<::hilti::rt::type_info::enum_::Label>({::hilti::rt::type_info::enum_::Label{ "Universal", 0 }, ::hilti::rt::type_info::enum_::Label{ "Application", 1 }, ::hilti::rt::type_info::enum_::Label{ "ContextSpecific", 2 }, ::hilti::rt::type_info::enum_::Label{ "Private", 3 }, ::hilti::rt::type_info::enum_::Label{ "Undef", -1 }})) };
    const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_type___0__4_x28convertx31ASN1Typex2a__ddx2bx3e_constructed__5_x28convertx31cast_bool_x2a__ddx2bx3e_class__6__7_x28convertx31ASN1Classx2a__ddx2bx3e_x75_bitfieldx2a8_type__0_4_constructed_5_5_class_6_7_x2b = { {}, "bitfield(8) { type_: 0..4 &convert=ASN1Type(__dd); constructed: 5 &convert=cast<bool>(__dd); class: 6..7 &convert=ASN1Class(__dd); }", new ::hilti::rt::type_info::Bitfield(std::vector<::hilti::rt::type_info::bitfield::Bits>({::hilti::rt::type_info::bitfield::Bits{ "type_", &type_info::__ti_ASN1__ASN1Type_namex2aASN1__ASN1Typex2b, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<ASN1::ASN1Type, ::hilti::rt::Bool, ASN1::ASN1Class, ::hilti::rt::integer::safe<uint8_t>>, 0>() }, ::hilti::rt::type_info::bitfield::Bits{ "constructed", &::hilti::rt::type_info::bool_, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<ASN1::ASN1Type, ::hilti::rt::Bool, ASN1::ASN1Class, ::hilti::rt::integer::safe<uint8_t>>, 1>() }, ::hilti::rt::type_info::bitfield::Bits{ "class", &type_info::__ti_ASN1__ASN1Class_namex2aASN1__ASN1Classx2b, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<ASN1::ASN1Type, ::hilti::rt::Bool, ASN1::ASN1Class, ::hilti::rt::integer::safe<uint8_t>>, 2>() }})) };
    extern const ::hilti::rt::TypeInfo __ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_hilti__RecoverableFailure_namex2ahilti__RecoverableFailurex2b;
    const ::hilti::rt::TypeInfo __ti_hilti__RecoverableFailure_namex2ahilti__RecoverableFailurex2b = { "hilti::RecoverableFailure", "hilti::RecoverableFailure", new ::hilti::rt::type_info::Exception() };
    const ::hilti::rt::TypeInfo __ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b = { {}, "optional<spicy::RecoverableFailure>", new ::hilti::rt::type_info::Optional(&type_info::__ti_hilti__RecoverableFailure_namex2ahilti__RecoverableFailurex2b, ::hilti::rt::type_info::Optional::accessor<::hilti::rt::RecoverableFailure>()) };
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Tag_namex2aASN1__ASN1Tagx2b = { "ASN1::ASN1Tag", "ASN1::ASN1Tag", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "_anon_46", &type_info::__ti_bitfieldx2a8x2b_x73_type___0__4_x28convertx31ASN1Typex2a__ddx2bx3e_constructed__5_x28convertx31cast_bool_x2a__ddx2bx3e_class__6__7_x28convertx31ASN1Classx2a__ddx2bx3e_x75_bitfieldx2a8_type__0_4_constructed_5_5_class_6_7_x2b, offsetof(ASN1::ASN1Tag, _anon_46), false, true, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bitfield<ASN1::ASN1Type, ::hilti::rt::Bool, ASN1::ASN1Class, ::hilti::rt::integer::safe<uint8_t>>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(ASN1::ASN1Tag, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_ASN1Tag__value_refx2anamex2aASN1__ASN1Tagx2bx2b = { {}, "value_ref<ASN1Tag>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_ASN1__ASN1Tag_namex2aASN1__ASN1Tagx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::ASN1::ASN1Tag>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_LengthType__value_refx2anamex2aASN1__LengthTypex2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_ASN1__LengthType_namex2aASN1__LengthTypex2b;
    extern const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_num__0__6x3e_islong__7x3e_x75_bitfieldx2a8_num_0_6_islong_7_7_x2b;
    const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_num__0__6x3e_islong__7x3e_x75_bitfieldx2a8_num_0_6_islong_7_7_x2b = { {}, "bitfield(8) { num: 0..6; islong: 7; }", new ::hilti::rt::type_info::Bitfield(std::vector<::hilti::rt::type_info::bitfield::Bits>({::hilti::rt::type_info::bitfield::Bits{ "num", &::hilti::rt::type_info::uint8, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>, 0>() }, ::hilti::rt::type_info::bitfield::Bits{ "islong", &::hilti::rt::type_info::uint8, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>, 1>() }})) };
    const ::hilti::rt::TypeInfo __ti_ASN1__LengthType_namex2aASN1__LengthTypex2b = { "ASN1::LengthType", "ASN1::LengthType", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "len", &::hilti::rt::type_info::uint64, offsetof(ASN1::LengthType, len), false, false }, ::hilti::rt::type_info::struct_::Field{ "tag_len", &::hilti::rt::type_info::uint8, offsetof(ASN1::LengthType, tag_len), false, false }, ::hilti::rt::type_info::struct_::Field{ "data", &type_info::__ti_bitfieldx2a8x2b_x73_num__0__6x3e_islong__7x3e_x75_bitfieldx2a8_num_0_6_islong_7_7_x2b, offsetof(ASN1::LengthType, data), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(ASN1::LengthType, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_LengthType__value_refx2anamex2aASN1__LengthTypex2bx2b = { {}, "value_ref<LengthType>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_ASN1__LengthType_namex2aASN1__LengthTypex2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::ASN1::LengthType>()) };
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Header_namex2aASN1__ASN1Headerx2b = { "ASN1::ASN1Header", "ASN1::ASN1Header", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "tag", &type_info::__ti_value_ref_ASN1Tag__value_refx2anamex2aASN1__ASN1Tagx2bx2b, offsetof(ASN1::ASN1Header, tag), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Tag>>() }, ::hilti::rt::type_info::struct_::Field{ "len", &type_info::__ti_value_ref_LengthType__value_refx2anamex2aASN1__LengthTypex2bx2b, offsetof(ASN1::ASN1Header, len), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::LengthType>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(ASN1::ASN1Header, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_ASN1__ASN1Header__value_refx2anamex2aASN1__ASN1Headerx2bx2b = { {}, "value_ref<ASN1::ASN1Header>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_ASN1__ASN1Header_namex2aASN1__ASN1Headerx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::ASN1::ASN1Header>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ASN1__ASN1ObjectIdentifier__value_refx2anamex2aASN1__ASN1ObjectIdentifierx2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1ObjectIdentifier_namex2aASN1__ASN1ObjectIdentifierx2b;
    extern const ::hilti::rt::TypeInfo __ti_vector_bitfieldx2a8x2b_x73_num__0__6x3e_more__7x3e_x75__vectorx2abitfieldx2a8_num_0_6_more_7_7_x2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_num__0__6x3e_more__7x3e_x75_bitfieldx2a8_num_0_6_more_7_7_x2b;
    const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_num__0__6x3e_more__7x3e_x75_bitfieldx2a8_num_0_6_more_7_7_x2b = { {}, "bitfield(8) { num: 0..6; more: 7; }", new ::hilti::rt::type_info::Bitfield(std::vector<::hilti::rt::type_info::bitfield::Bits>({::hilti::rt::type_info::bitfield::Bits{ "num", &::hilti::rt::type_info::uint8, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>, 0>() }, ::hilti::rt::type_info::bitfield::Bits{ "more", &::hilti::rt::type_info::uint8, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>, 1>() }})) };
    const ::hilti::rt::TypeInfo __ti_vector_bitfieldx2a8x2b_x73_num__0__6x3e_more__7x3e_x75__vectorx2abitfieldx2a8_num_0_6_more_7_7_x2bx2b = { {}, "vector<bitfield(8) { num: 0..6; more: 7; }>", new ::hilti::rt::type_info::Vector(&type_info::__ti_bitfieldx2a8x2b_x73_num__0__6x3e_more__7x3e_x75_bitfieldx2a8_num_0_6_more_7_7_x2b, ::hilti::rt::type_info::Vector::accessor<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>()) };
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1ObjectIdentifier_namex2aASN1__ASN1ObjectIdentifierx2b = { "ASN1::ASN1ObjectIdentifier", "ASN1::ASN1ObjectIdentifier", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "oidbytes", &::hilti::rt::type_info::bytes, offsetof(ASN1::ASN1ObjectIdentifier, oidbytes), false, false }, ::hilti::rt::type_info::struct_::Field{ "temp", &::hilti::rt::type_info::uint64, offsetof(ASN1::ASN1ObjectIdentifier, temp), false, false }, ::hilti::rt::type_info::struct_::Field{ "oidstring", &::hilti::rt::type_info::string, offsetof(ASN1::ASN1ObjectIdentifier, oidstring), false, false }, ::hilti::rt::type_info::struct_::Field{ "sublist", &type_info::__ti_vector_bitfieldx2a8x2b_x73_num__0__6x3e_more__7x3e_x75__vectorx2abitfieldx2a8_num_0_6_more_7_7_x2bx2b, offsetof(ASN1::ASN1ObjectIdentifier, sublist), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Vector<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>>() }, ::hilti::rt::type_info::struct_::Field{ "_anon_50", &type_info::__ti_bitfieldx2a8x2b_x73_num__0__6x3e_more__7x3e_x75_bitfieldx2a8_num_0_6_more_7_7_x2b, offsetof(ASN1::ASN1ObjectIdentifier, _anon_50), false, true, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>() }, ::hilti::rt::type_info::struct_::Field{ "_anon_49", &type_info::__ti_bitfieldx2a8x2b_x73_num__0__6x3e_more__7x3e_x75_bitfieldx2a8_num_0_6_more_7_7_x2b, offsetof(ASN1::ASN1ObjectIdentifier, _anon_49), false, true, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(ASN1::ASN1ObjectIdentifier, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_ASN1__ASN1ObjectIdentifier__value_refx2anamex2aASN1__ASN1ObjectIdentifierx2bx2b = { {}, "value_ref<ASN1::ASN1ObjectIdentifier>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_ASN1__ASN1ObjectIdentifier_namex2aASN1__ASN1ObjectIdentifierx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::ASN1::ASN1ObjectIdentifier>()) };
    const ::hilti::rt::TypeInfo __ti_LDAP__GSS_SPNEGO_negTokenInit_namex2aLDAP__GSS_SPNEGO_negTokenInitx2b = { "LDAP::GSS_SPNEGO_negTokenInit", "LDAP::GSS_SPNEGO_negTokenInit", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "oidHeader", &type_info::__ti_value_ref_ASN1__ASN1Header__value_refx2anamex2aASN1__ASN1Headerx2bx2b, offsetof(LDAP::GSS_SPNEGO_negTokenInit, oidHeader), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>() }, ::hilti::rt::type_info::struct_::Field{ "oid", &type_info::__ti_value_ref_ASN1__ASN1ObjectIdentifier__value_refx2anamex2aASN1__ASN1ObjectIdentifierx2bx2b, offsetof(LDAP::GSS_SPNEGO_negTokenInit, oid), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1ObjectIdentifier>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::GSS_SPNEGO_negTokenInit, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__GSS_SPNEGO_Init_namex2aLDAP__GSS_SPNEGO_Initx2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__GSS_SPNEGO_Init_namex2aLDAP__GSS_SPNEGO_Initx2b = { "LDAP::GSS_SPNEGO_Init", "LDAP::GSS_SPNEGO_Init", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "credentialsHeader", &type_info::__ti_value_ref_ASN1__ASN1Header__value_refx2anamex2aASN1__ASN1Headerx2bx2b, offsetof(LDAP::GSS_SPNEGO_Init, credentialsHeader), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>() }, ::hilti::rt::type_info::struct_::Field{ "spnegoInitByte", &::hilti::rt::type_info::uint8, offsetof(LDAP::GSS_SPNEGO_Init, spnegoInitByte), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint8_t>>() }, ::hilti::rt::type_info::struct_::Field{ "spnegoChoiceByte", &::hilti::rt::type_info::uint8, offsetof(LDAP::GSS_SPNEGO_Init, spnegoChoiceByte), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint8_t>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::GSS_SPNEGO_Init, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__GSS_SPNEGO_negTokenResp_namex2aLDAP__GSS_SPNEGO_negTokenRespx2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ASN1__ASN1Message__value_refx2anamex2aASN1__ASN1Messagex2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Message_namex2aASN1__ASN1Messagex2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ASN1Header__value_refx2anamex2aASN1__ASN1Headerx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_ASN1Header__value_refx2anamex2aASN1__ASN1Headerx2bx2b = { {}, "value_ref<ASN1Header>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_ASN1__ASN1Header_namex2aASN1__ASN1Headerx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::ASN1::ASN1Header>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ASN1Body__value_refx2anamex2aASN1__ASN1Bodyx2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Body_namex2aASN1__ASN1Bodyx2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ASN1BitString__value_refx2anamex2aASN1__ASN1BitStringx2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1BitString_namex2aASN1__ASN1BitStringx2b;
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1BitString_namex2aASN1__ASN1BitStringx2b = { "ASN1::ASN1BitString", "ASN1::ASN1BitString", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "value_bits", &::hilti::rt::type_info::bytes, offsetof(ASN1::ASN1BitString, value_bits), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(ASN1::ASN1BitString, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_ASN1BitString__value_refx2anamex2aASN1__ASN1BitStringx2bx2b = { {}, "value_ref<ASN1BitString>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_ASN1__ASN1BitString_namex2aASN1__ASN1BitStringx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::ASN1::ASN1BitString>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ASN1SubMessages__value_refx2anamex2aASN1__ASN1SubMessagesx2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_ASN1__ASN1SubMessages_namex2aASN1__ASN1SubMessagesx2b;
    extern const ::hilti::rt::TypeInfo __ti_vector_ASN1Message__vectorx2anamex2aASN1__ASN1Messagex2bx2b;
    const ::hilti::rt::TypeInfo __ti_vector_ASN1Message__vectorx2anamex2aASN1__ASN1Messagex2bx2b = { {}, "vector<ASN1Message>", new ::hilti::rt::type_info::Vector(&type_info::__ti_ASN1__ASN1Message_namex2aASN1__ASN1Messagex2b, ::hilti::rt::type_info::Vector::accessor<__hlt_ldap::ASN1::ASN1Message>()) };
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1SubMessages_namex2aASN1__ASN1SubMessagesx2b = { "ASN1::ASN1SubMessages", "ASN1::ASN1SubMessages", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "submessages", &type_info::__ti_vector_ASN1Message__vectorx2anamex2aASN1__ASN1Messagex2bx2b, offsetof(ASN1::ASN1SubMessages, submessages), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Vector<__hlt_ldap::ASN1::ASN1Message>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(ASN1::ASN1SubMessages, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_ASN1SubMessages__value_refx2anamex2aASN1__ASN1SubMessagesx2bx2b = { {}, "value_ref<ASN1SubMessages>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_ASN1__ASN1SubMessages_namex2aASN1__ASN1SubMessagesx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::ASN1::ASN1SubMessages>()) };
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Body_namex2aASN1__ASN1Bodyx2b = { "ASN1::ASN1Body", "ASN1::ASN1Body", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "bool_value", &::hilti::rt::type_info::bool_, offsetof(ASN1::ASN1Body, bool_value), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bool>() }, ::hilti::rt::type_info::struct_::Field{ "num_value", &::hilti::rt::type_info::int64, offsetof(ASN1::ASN1Body, num_value), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<int64_t>>() }, ::hilti::rt::type_info::struct_::Field{ "null_value", &::hilti::rt::type_info::bytes, offsetof(ASN1::ASN1Body, null_value), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "bitstr_value", &type_info::__ti_value_ref_ASN1BitString__value_refx2anamex2aASN1__ASN1BitStringx2bx2b, offsetof(ASN1::ASN1Body, bitstr_value), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1BitString>>() }, ::hilti::rt::type_info::struct_::Field{ "str_value", &::hilti::rt::type_info::string, offsetof(ASN1::ASN1Body, str_value), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<std::string>() }, ::hilti::rt::type_info::struct_::Field{ "seq", &type_info::__ti_value_ref_ASN1SubMessages__value_refx2anamex2aASN1__ASN1SubMessagesx2bx2b, offsetof(ASN1::ASN1Body, seq), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1SubMessages>>() }, ::hilti::rt::type_info::struct_::Field{ "unimplemented_value", &::hilti::rt::type_info::bytes, offsetof(ASN1::ASN1Body, unimplemented_value), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(ASN1::ASN1Body, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_ASN1Body__value_refx2anamex2aASN1__ASN1Bodyx2bx2b = { {}, "value_ref<ASN1Body>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_ASN1__ASN1Body_namex2aASN1__ASN1Bodyx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::ASN1::ASN1Body>()) };
    const ::hilti::rt::TypeInfo __ti_ASN1__ASN1Message_namex2aASN1__ASN1Messagex2b = { "ASN1::ASN1Message", "ASN1::ASN1Message", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "application_id", &::hilti::rt::type_info::int32, offsetof(ASN1::ASN1Message, application_id), false, false }, ::hilti::rt::type_info::struct_::Field{ "head", &type_info::__ti_value_ref_ASN1Header__value_refx2anamex2aASN1__ASN1Headerx2bx2b, offsetof(ASN1::ASN1Message, head), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>() }, ::hilti::rt::type_info::struct_::Field{ "body", &type_info::__ti_value_ref_ASN1Body__value_refx2anamex2aASN1__ASN1Bodyx2bx2b, offsetof(ASN1::ASN1Message, body), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Body>>() }, ::hilti::rt::type_info::struct_::Field{ "application_data", &::hilti::rt::type_info::bytes, offsetof(ASN1::ASN1Message, application_data), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(ASN1::ASN1Message, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_ASN1__ASN1Message__value_refx2anamex2aASN1__ASN1Messagex2bx2b = { {}, "value_ref<ASN1::ASN1Message>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_ASN1__ASN1Message_namex2aASN1__ASN1Messagex2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::ASN1::ASN1Message>()) };
    const ::hilti::rt::TypeInfo __ti_LDAP__GSS_SPNEGO_negTokenResp_namex2aLDAP__GSS_SPNEGO_negTokenRespx2b = { "LDAP::GSS_SPNEGO_negTokenResp", "LDAP::GSS_SPNEGO_negTokenResp", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "accepted", &::hilti::rt::type_info::bool_, offsetof(LDAP::GSS_SPNEGO_negTokenResp, accepted), false, false }, ::hilti::rt::type_info::struct_::Field{ "supportedMech", &type_info::__ti_value_ref_ASN1__ASN1Message__value_refx2anamex2aASN1__ASN1Messagex2bx2b, offsetof(LDAP::GSS_SPNEGO_negTokenResp, supportedMech), false, false }, ::hilti::rt::type_info::struct_::Field{ "seq", &type_info::__ti_value_ref_ASN1__ASN1Message__value_refx2anamex2aASN1__ASN1Messagex2bx2b, offsetof(LDAP::GSS_SPNEGO_negTokenResp, seq), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>>() }, ::hilti::rt::type_info::struct_::Field{ "supportedMechOid", &::hilti::rt::type_info::string, offsetof(LDAP::GSS_SPNEGO_negTokenResp, supportedMechOid), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<std::string>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::GSS_SPNEGO_negTokenResp, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__GSS_SPNEGO_Subsequent_namex2aLDAP__GSS_SPNEGO_Subsequentx2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_GSS_SPNEGO_negTokenResp__value_refx2anamex2aLDAP__GSS_SPNEGO_negTokenRespx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_GSS_SPNEGO_negTokenResp__value_refx2anamex2aLDAP__GSS_SPNEGO_negTokenRespx2bx2b = { {}, "value_ref<GSS_SPNEGO_negTokenResp>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__GSS_SPNEGO_negTokenResp_namex2aLDAP__GSS_SPNEGO_negTokenRespx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::GSS_SPNEGO_negTokenResp>()) };
    const ::hilti::rt::TypeInfo __ti_LDAP__GSS_SPNEGO_Subsequent_namex2aLDAP__GSS_SPNEGO_Subsequentx2b = { "LDAP::GSS_SPNEGO_Subsequent", "LDAP::GSS_SPNEGO_Subsequent", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "spnegoChoiceByte", &::hilti::rt::type_info::uint8, offsetof(LDAP::GSS_SPNEGO_Subsequent, spnegoChoiceByte), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint8_t>>() }, ::hilti::rt::type_info::struct_::Field{ "negTokenResp", &type_info::__ti_value_ref_GSS_SPNEGO_negTokenResp__value_refx2anamex2aLDAP__GSS_SPNEGO_negTokenRespx2bx2b, offsetof(LDAP::GSS_SPNEGO_Subsequent, negTokenResp), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::GSS_SPNEGO_negTokenResp>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::GSS_SPNEGO_Subsequent, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__ProtocolOpcode_namex2aLDAP__ProtocolOpcodex2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__ProtocolOpcode_namex2aLDAP__ProtocolOpcodex2b = { "LDAP::ProtocolOpcode", "LDAP::ProtocolOpcode", new ::hilti::rt::type_info::Enum(std::vector<::hilti::rt::type_info::enum_::Label>({::hilti::rt::type_info::enum_::Label{ "BIND_REQUEST", 0 }, ::hilti::rt::type_info::enum_::Label{ "BIND_RESPONSE", 1 }, ::hilti::rt::type_info::enum_::Label{ "UNBIND_REQUEST", 2 }, ::hilti::rt::type_info::enum_::Label{ "SEARCH_REQUEST", 3 }, ::hilti::rt::type_info::enum_::Label{ "SEARCH_RESULT_ENTRY", 4 }, ::hilti::rt::type_info::enum_::Label{ "SEARCH_RESULT_DONE", 5 }, ::hilti::rt::type_info::enum_::Label{ "MODIFY_REQUEST", 6 }, ::hilti::rt::type_info::enum_::Label{ "MODIFY_RESPONSE", 7 }, ::hilti::rt::type_info::enum_::Label{ "ADD_REQUEST", 8 }, ::hilti::rt::type_info::enum_::Label{ "ADD_RESPONSE", 9 }, ::hilti::rt::type_info::enum_::Label{ "DEL_REQUEST", 10 }, ::hilti::rt::type_info::enum_::Label{ "DEL_RESPONSE", 11 }, ::hilti::rt::type_info::enum_::Label{ "MOD_DN_REQUEST", 12 }, ::hilti::rt::type_info::enum_::Label{ "MOD_DN_RESPONSE", 13 }, ::hilti::rt::type_info::enum_::Label{ "COMPARE_REQUEST", 14 }, ::hilti::rt::type_info::enum_::Label{ "COMPARE_RESPONSE", 15 }, ::hilti::rt::type_info::enum_::Label{ "ABANDON_REQUEST", 16 }, ::hilti::rt::type_info::enum_::Label{ "SEARCH_RESULT_REFERENCE", 19 }, ::hilti::rt::type_info::enum_::Label{ "EXTENDED_REQUEST", 23 }, ::hilti::rt::type_info::enum_::Label{ "EXTENDED_RESPONSE", 24 }, ::hilti::rt::type_info::enum_::Label{ "INTERMEDIATE_RESPONSE", 25 }, ::hilti::rt::type_info::enum_::Label{ "Undef", -1 }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__ResultCode_namex2aLDAP__ResultCodex2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__ResultCode_namex2aLDAP__ResultCodex2b = { "LDAP::ResultCode", "LDAP::ResultCode", new ::hilti::rt::type_info::Enum(std::vector<::hilti::rt::type_info::enum_::Label>({::hilti::rt::type_info::enum_::Label{ "SUCCESS", 0 }, ::hilti::rt::type_info::enum_::Label{ "OPERATIONS_ERROR", 1 }, ::hilti::rt::type_info::enum_::Label{ "PROTOCOL_ERROR", 2 }, ::hilti::rt::type_info::enum_::Label{ "TIME_LIMIT_EXCEEDED", 3 }, ::hilti::rt::type_info::enum_::Label{ "SIZE_LIMIT_EXCEEDED", 4 }, ::hilti::rt::type_info::enum_::Label{ "COMPARE_FALSE", 5 }, ::hilti::rt::type_info::enum_::Label{ "COMPARE_TRUE", 6 }, ::hilti::rt::type_info::enum_::Label{ "AUTH_METHOD_NOT_SUPPORTED", 7 }, ::hilti::rt::type_info::enum_::Label{ "STRONGER_AUTH_REQUIRED", 8 }, ::hilti::rt::type_info::enum_::Label{ "PARTIAL_RESULTS", 9 }, ::hilti::rt::type_info::enum_::Label{ "REFERRAL", 10 }, ::hilti::rt::type_info::enum_::Label{ "ADMIN_LIMIT_EXCEEDED", 11 }, ::hilti::rt::type_info::enum_::Label{ "UNAVAILABLE_CRITICAL_EXTENSION", 12 }, ::hilti::rt::type_info::enum_::Label{ "CONFIDENTIALITY_REQUIRED", 13 }, ::hilti::rt::type_info::enum_::Label{ "SASL_BIND_IN_PROGRESS", 14 }, ::hilti::rt::type_info::enum_::Label{ "NO_SUCH_ATTRIBUTE", 16 }, ::hilti::rt::type_info::enum_::Label{ "UNDEFINED_ATTRIBUTE_TYPE", 17 }, ::hilti::rt::type_info::enum_::Label{ "INAPPROPRIATE_MATCHING", 18 }, ::hilti::rt::type_info::enum_::Label{ "CONSTRAINT_VIOLATION", 19 }, ::hilti::rt::type_info::enum_::Label{ "ATTRIBUTE_OR_VALUE_EXISTS", 20 }, ::hilti::rt::type_info::enum_::Label{ "INVALID_ATTRIBUTE_SYNTAX", 21 }, ::hilti::rt::type_info::enum_::Label{ "NO_SUCH_OBJECT", 32 }, ::hilti::rt::type_info::enum_::Label{ "ALIAS_PROBLEM", 33 }, ::hilti::rt::type_info::enum_::Label{ "INVALID_DNSYNTAX", 34 }, ::hilti::rt::type_info::enum_::Label{ "ALIAS_DEREFERENCING_PROBLEM", 36 }, ::hilti::rt::type_info::enum_::Label{ "INAPPROPRIATE_AUTHENTICATION", 48 }, ::hilti::rt::type_info::enum_::Label{ "INVALID_CREDENTIALS", 49 }, ::hilti::rt::type_info::enum_::Label{ "INSUFFICIENT_ACCESS_RIGHTS", 50 }, ::hilti::rt::type_info::enum_::Label{ "BUSY", 51 }, ::hilti::rt::type_info::enum_::Label{ "UNAVAILABLE", 52 }, ::hilti::rt::type_info::enum_::Label{ "UNWILLING_TO_PERFORM", 53 }, ::hilti::rt::type_info::enum_::Label{ "LOOP_DETECT", 54 }, ::hilti::rt::type_info::enum_::Label{ "SORT_CONTROL_MISSING", 60 }, ::hilti::rt::type_info::enum_::Label{ "OFFSET_RANGE_ERROR", 61 }, ::hilti::rt::type_info::enum_::Label{ "NAMING_VIOLATION", 64 }, ::hilti::rt::type_info::enum_::Label{ "OBJECT_CLASS_VIOLATION", 65 }, ::hilti::rt::type_info::enum_::Label{ "NOT_ALLOWED_ON_NON_LEAF", 66 }, ::hilti::rt::type_info::enum_::Label{ "NOT_ALLOWED_ON_RDN", 67 }, ::hilti::rt::type_info::enum_::Label{ "ENTRY_ALREADY_EXISTS", 68 }, ::hilti::rt::type_info::enum_::Label{ "OBJECT_CLASS_MODS_PROHIBITED", 69 }, ::hilti::rt::type_info::enum_::Label{ "RESULTS_TOO_LARGE", 70 }, ::hilti::rt::type_info::enum_::Label{ "AFFECTS_MULTIPLE_DSAS", 71 }, ::hilti::rt::type_info::enum_::Label{ "CONTROL_ERROR", 76 }, ::hilti::rt::type_info::enum_::Label{ "OTHER", 80 }, ::hilti::rt::type_info::enum_::Label{ "SERVER_DOWN", 81 }, ::hilti::rt::type_info::enum_::Label{ "LOCAL_ERROR", 82 }, ::hilti::rt::type_info::enum_::Label{ "ENCODING_ERROR", 83 }, ::hilti::rt::type_info::enum_::Label{ "DECODING_ERROR", 84 }, ::hilti::rt::type_info::enum_::Label{ "TIMEOUT", 85 }, ::hilti::rt::type_info::enum_::Label{ "AUTH_UNKNOWN", 86 }, ::hilti::rt::type_info::enum_::Label{ "FILTER_ERROR", 87 }, ::hilti::rt::type_info::enum_::Label{ "USER_CANCELED", 88 }, ::hilti::rt::type_info::enum_::Label{ "PARAM_ERROR", 89 }, ::hilti::rt::type_info::enum_::Label{ "NO_MEMORY", 90 }, ::hilti::rt::type_info::enum_::Label{ "CONNECT_ERROR", 91 }, ::hilti::rt::type_info::enum_::Label{ "NOT_SUPPORTED", 92 }, ::hilti::rt::type_info::enum_::Label{ "CONTROL_NOT_FOUND", 93 }, ::hilti::rt::type_info::enum_::Label{ "NO_RESULTS_RETURNED", 94 }, ::hilti::rt::type_info::enum_::Label{ "MORE_RESULTS_TO_RETURN", 95 }, ::hilti::rt::type_info::enum_::Label{ "CLIENT_LOOP", 96 }, ::hilti::rt::type_info::enum_::Label{ "REFERRAL_LIMIT_EXCEEDED", 97 }, ::hilti::rt::type_info::enum_::Label{ "INVALID_RESPONSE", 100 }, ::hilti::rt::type_info::enum_::Label{ "AMBIGUOUS_RESPONSE", 101 }, ::hilti::rt::type_info::enum_::Label{ "TLS_NOT_SUPPORTED", 112 }, ::hilti::rt::type_info::enum_::Label{ "INTERMEDIATE_RESPONSE", 113 }, ::hilti::rt::type_info::enum_::Label{ "UNKNOWN_TYPE", 114 }, ::hilti::rt::type_info::enum_::Label{ "LCUP_INVALID_DATA", 115 }, ::hilti::rt::type_info::enum_::Label{ "LCUP_UNSUPPORTED_SCHEME", 116 }, ::hilti::rt::type_info::enum_::Label{ "LCUP_RELOAD_REQUIRED", 117 }, ::hilti::rt::type_info::enum_::Label{ "CANCELED", 118 }, ::hilti::rt::type_info::enum_::Label{ "NO_SUCH_OPERATION", 119 }, ::hilti::rt::type_info::enum_::Label{ "TOO_LATE", 120 }, ::hilti::rt::type_info::enum_::Label{ "CANNOT_CANCEL", 121 }, ::hilti::rt::type_info::enum_::Label{ "ASSERTION_FAILED", 122 }, ::hilti::rt::type_info::enum_::Label{ "AUTHORIZATION_DENIED", 123 }, ::hilti::rt::type_info::enum_::Label{ "Undef", -1 }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__Result_namex2aLDAP__Resultx2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__Result_namex2aLDAP__Resultx2b = { "LDAP::Result", "LDAP::Result", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "code", &type_info::__ti_LDAP__ResultCode_namex2aLDAP__ResultCodex2b, offsetof(LDAP::Result, code), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<LDAP::ResultCode>() }, ::hilti::rt::type_info::struct_::Field{ "matchedDN", &::hilti::rt::type_info::string, offsetof(LDAP::Result, matchedDN), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<std::string>() }, ::hilti::rt::type_info::struct_::Field{ "diagnosticMessage", &::hilti::rt::type_info::string, offsetof(LDAP::Result, diagnosticMessage), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<std::string>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::Result, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__SaslCredentials_namex2aLDAP__SaslCredentialsx2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_GSS_SPNEGO_Init__value_refx2anamex2aLDAP__GSS_SPNEGO_Initx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_GSS_SPNEGO_Init__value_refx2anamex2aLDAP__GSS_SPNEGO_Initx2bx2b = { {}, "value_ref<GSS_SPNEGO_Init>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__GSS_SPNEGO_Init_namex2aLDAP__GSS_SPNEGO_Initx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::GSS_SPNEGO_Init>()) };
    const ::hilti::rt::TypeInfo __ti_LDAP__SaslCredentials_namex2aLDAP__SaslCredentialsx2b = { "LDAP::SaslCredentials", "LDAP::SaslCredentials", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "mechanism", &::hilti::rt::type_info::string, offsetof(LDAP::SaslCredentials, mechanism), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<std::string>() }, ::hilti::rt::type_info::struct_::Field{ "gss_spnego", &type_info::__ti_value_ref_GSS_SPNEGO_Init__value_refx2anamex2aLDAP__GSS_SPNEGO_Initx2bx2b, offsetof(LDAP::SaslCredentials, gss_spnego), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::GSS_SPNEGO_Init>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::SaslCredentials, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__SearchDerefAlias_namex2aLDAP__SearchDerefAliasx2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__SearchDerefAlias_namex2aLDAP__SearchDerefAliasx2b = { "LDAP::SearchDerefAlias", "LDAP::SearchDerefAlias", new ::hilti::rt::type_info::Enum(std::vector<::hilti::rt::type_info::enum_::Label>({::hilti::rt::type_info::enum_::Label{ "DEREF_NEVER", 0 }, ::hilti::rt::type_info::enum_::Label{ "DEREF_IN_SEARCHING", 1 }, ::hilti::rt::type_info::enum_::Label{ "DEREF_FINDING_BASE", 2 }, ::hilti::rt::type_info::enum_::Label{ "DEREF_ALWAYS", 3 }, ::hilti::rt::type_info::enum_::Label{ "Undef", -1 }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__SearchScope_namex2aLDAP__SearchScopex2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__SearchScope_namex2aLDAP__SearchScopex2b = { "LDAP::SearchScope", "LDAP::SearchScope", new ::hilti::rt::type_info::Enum(std::vector<::hilti::rt::type_info::enum_::Label>({::hilti::rt::type_info::enum_::Label{ "SEARCH_BASE", 0 }, ::hilti::rt::type_info::enum_::Label{ "SEARCH_SINGLE", 1 }, ::hilti::rt::type_info::enum_::Label{ "SEARCH_TREE", 2 }, ::hilti::rt::type_info::enum_::Label{ "Undef", -1 }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__ServerSaslCreds_namex2aLDAP__ServerSaslCredsx2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__ServerSaslCreds_namex2aLDAP__ServerSaslCredsx2b = { "LDAP::ServerSaslCreds", "LDAP::ServerSaslCreds", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "serverSaslCreds", &type_info::__ti_value_ref_ASN1__ASN1Header__value_refx2anamex2aASN1__ASN1Headerx2bx2b, offsetof(LDAP::ServerSaslCreds, serverSaslCreds), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>() }, ::hilti::rt::type_info::struct_::Field{ "payload", &::hilti::rt::type_info::bytes, offsetof(LDAP::ServerSaslCreds, payload), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::ServerSaslCreds, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__UnbindRequest_namex2aLDAP__UnbindRequestx2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__UnbindRequest_namex2aLDAP__UnbindRequestx2b = { "LDAP::UnbindRequest", "LDAP::UnbindRequest", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::UnbindRequest, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__SearchResultEntry_namex2aLDAP__SearchResultEntryx2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__SearchResultEntry_namex2aLDAP__SearchResultEntryx2b = { "LDAP::SearchResultEntry", "LDAP::SearchResultEntry", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "objectName", &::hilti::rt::type_info::string, offsetof(LDAP::SearchResultEntry, objectName), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<std::string>() }, ::hilti::rt::type_info::struct_::Field{ "attributes", &type_info::__ti_value_ref_ASN1__ASN1Message__value_refx2anamex2aASN1__ASN1Messagex2bx2b, offsetof(LDAP::SearchResultEntry, attributes), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::SearchResultEntry, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__SearchResultDone_namex2aLDAP__SearchResultDonex2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__SearchResultDone_namex2aLDAP__SearchResultDonex2b = { "LDAP::SearchResultDone", "LDAP::SearchResultDone", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::SearchResultDone, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__SearchRequest_namex2aLDAP__SearchRequestx2b;
    extern const ::hilti::rt::TypeInfo __ti_vector_string__vectorx2astringx2b;
    const ::hilti::rt::TypeInfo __ti_vector_string__vectorx2astringx2b = { {}, "vector<string>", new ::hilti::rt::type_info::Vector(&::hilti::rt::type_info::string, ::hilti::rt::type_info::Vector::accessor<std::string>()) };
    const ::hilti::rt::TypeInfo __ti_LDAP__SearchRequest_namex2aLDAP__SearchRequestx2b = { "LDAP::SearchRequest", "LDAP::SearchRequest", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "baseObject", &::hilti::rt::type_info::string, offsetof(LDAP::SearchRequest, baseObject), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<std::string>() }, ::hilti::rt::type_info::struct_::Field{ "scope", &type_info::__ti_LDAP__SearchScope_namex2aLDAP__SearchScopex2b, offsetof(LDAP::SearchRequest, scope), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<LDAP::SearchScope>() }, ::hilti::rt::type_info::struct_::Field{ "deref", &type_info::__ti_LDAP__SearchDerefAlias_namex2aLDAP__SearchDerefAliasx2b, offsetof(LDAP::SearchRequest, deref), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<LDAP::SearchDerefAlias>() }, ::hilti::rt::type_info::struct_::Field{ "sizeLimit", &::hilti::rt::type_info::int64, offsetof(LDAP::SearchRequest, sizeLimit), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<int64_t>>() }, ::hilti::rt::type_info::struct_::Field{ "timeLimit", &::hilti::rt::type_info::int64, offsetof(LDAP::SearchRequest, timeLimit), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<int64_t>>() }, ::hilti::rt::type_info::struct_::Field{ "typesOnly", &::hilti::rt::type_info::bool_, offsetof(LDAP::SearchRequest, typesOnly), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bool>() }, ::hilti::rt::type_info::struct_::Field{ "filter", &::hilti::rt::type_info::string, offsetof(LDAP::SearchRequest, filter), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<std::string>() }, ::hilti::rt::type_info::struct_::Field{ "attributes", &type_info::__ti_vector_string__vectorx2astringx2b, offsetof(LDAP::SearchRequest, attributes), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Vector<std::string>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::SearchRequest, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__NotImplemented_namex2aLDAP__NotImplementedx2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__NotImplemented_namex2aLDAP__NotImplementedx2b = { "LDAP::NotImplemented", "LDAP::NotImplemented", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::NotImplemented, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__ModifyResponse_namex2aLDAP__ModifyResponsex2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__ModifyResponse_namex2aLDAP__ModifyResponsex2b = { "LDAP::ModifyResponse", "LDAP::ModifyResponse", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::ModifyResponse, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__ModifyRequest_namex2aLDAP__ModifyRequestx2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__ModifyRequest_namex2aLDAP__ModifyRequestx2b = { "LDAP::ModifyRequest", "LDAP::ModifyRequest", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "objectName", &::hilti::rt::type_info::string, offsetof(LDAP::ModifyRequest, objectName), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<std::string>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::ModifyRequest, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__ModDNResponse_namex2aLDAP__ModDNResponsex2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__ModDNResponse_namex2aLDAP__ModDNResponsex2b = { "LDAP::ModDNResponse", "LDAP::ModDNResponse", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::ModDNResponse, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__Message_namex2aLDAP__Messagex2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_Result__value_refx2anamex2aLDAP__Resultx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_Result__value_refx2anamex2aLDAP__Resultx2bx2b = { {}, "value_ref<Result>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__Result_namex2aLDAP__Resultx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::Result>()) };
    extern const ::hilti::rt::TypeInfo __ti_strong_ref_Result__strong_refx2anamex2aLDAP__Resultx2bx2b;
    const ::hilti::rt::TypeInfo __ti_strong_ref_Result__strong_refx2anamex2aLDAP__Resultx2bx2b = { {}, "strong_ref<Result>", new ::hilti::rt::type_info::StrongReference(&type_info::__ti_LDAP__Result_namex2aLDAP__Resultx2b, ::hilti::rt::type_info::StrongReference::accessor<__hlt_ldap::LDAP::Result>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_BindRequest__value_refx2anamex2aLDAP__BindRequestx2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_LDAP__BindRequest_namex2aLDAP__BindRequestx2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_SaslCredentials__value_refx2anamex2aLDAP__SaslCredentialsx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_SaslCredentials__value_refx2anamex2aLDAP__SaslCredentialsx2bx2b = { {}, "value_ref<SaslCredentials>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__SaslCredentials_namex2aLDAP__SaslCredentialsx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::SaslCredentials>()) };
    const ::hilti::rt::TypeInfo __ti_LDAP__BindRequest_namex2aLDAP__BindRequestx2b = { "LDAP::BindRequest", "LDAP::BindRequest", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "version", &::hilti::rt::type_info::int64, offsetof(LDAP::BindRequest, version), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<int64_t>>() }, ::hilti::rt::type_info::struct_::Field{ "name", &::hilti::rt::type_info::string, offsetof(LDAP::BindRequest, name), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<std::string>() }, ::hilti::rt::type_info::struct_::Field{ "authType", &type_info::__ti_LDAP__BindAuthType_namex2aLDAP__BindAuthTypex2b, offsetof(LDAP::BindRequest, authType), false, false }, ::hilti::rt::type_info::struct_::Field{ "authData", &::hilti::rt::type_info::bytes, offsetof(LDAP::BindRequest, authData), false, false }, ::hilti::rt::type_info::struct_::Field{ "simpleCreds", &::hilti::rt::type_info::string, offsetof(LDAP::BindRequest, simpleCreds), false, false }, ::hilti::rt::type_info::struct_::Field{ "saslCreds", &type_info::__ti_value_ref_SaslCredentials__value_refx2anamex2aLDAP__SaslCredentialsx2bx2b, offsetof(LDAP::BindRequest, saslCreds), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::SaslCredentials>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::BindRequest, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_BindRequest__value_refx2anamex2aLDAP__BindRequestx2bx2b = { {}, "value_ref<BindRequest>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__BindRequest_namex2aLDAP__BindRequestx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::BindRequest>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_BindResponse__value_refx2anamex2aLDAP__BindResponsex2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_LDAP__BindResponse_namex2aLDAP__BindResponsex2b;
    extern const ::hilti::rt::TypeInfo __ti_vector_ServerSaslCreds__vectorx2anamex2aLDAP__ServerSaslCredsx2bx2b;
    const ::hilti::rt::TypeInfo __ti_vector_ServerSaslCreds__vectorx2anamex2aLDAP__ServerSaslCredsx2bx2b = { {}, "vector<ServerSaslCreds>", new ::hilti::rt::type_info::Vector(&type_info::__ti_LDAP__ServerSaslCreds_namex2aLDAP__ServerSaslCredsx2b, ::hilti::rt::type_info::Vector::accessor<__hlt_ldap::LDAP::ServerSaslCreds>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_GSS_SPNEGO_Subsequent__value_refx2anamex2aLDAP__GSS_SPNEGO_Subsequentx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_GSS_SPNEGO_Subsequent__value_refx2anamex2aLDAP__GSS_SPNEGO_Subsequentx2bx2b = { {}, "value_ref<GSS_SPNEGO_Subsequent>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__GSS_SPNEGO_Subsequent_namex2aLDAP__GSS_SPNEGO_Subsequentx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::GSS_SPNEGO_Subsequent>()) };
    const ::hilti::rt::TypeInfo __ti_LDAP__BindResponse_namex2aLDAP__BindResponsex2b = { "LDAP::BindResponse", "LDAP::BindResponse", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "serverSaslCreds", &type_info::__ti_vector_ServerSaslCreds__vectorx2anamex2aLDAP__ServerSaslCredsx2bx2b, offsetof(LDAP::BindResponse, serverSaslCreds), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Vector<__hlt_ldap::LDAP::ServerSaslCreds>>() }, ::hilti::rt::type_info::struct_::Field{ "gss_spnego", &type_info::__ti_value_ref_GSS_SPNEGO_Subsequent__value_refx2anamex2aLDAP__GSS_SPNEGO_Subsequentx2bx2b, offsetof(LDAP::BindResponse, gss_spnego), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::GSS_SPNEGO_Subsequent>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::BindResponse, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_BindResponse__value_refx2anamex2aLDAP__BindResponsex2bx2b = { {}, "value_ref<BindResponse>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__BindResponse_namex2aLDAP__BindResponsex2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::BindResponse>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_UnbindRequest__value_refx2anamex2aLDAP__UnbindRequestx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_UnbindRequest__value_refx2anamex2aLDAP__UnbindRequestx2bx2b = { {}, "value_ref<UnbindRequest>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__UnbindRequest_namex2aLDAP__UnbindRequestx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::UnbindRequest>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_SearchRequest__value_refx2anamex2aLDAP__SearchRequestx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_SearchRequest__value_refx2anamex2aLDAP__SearchRequestx2bx2b = { {}, "value_ref<SearchRequest>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__SearchRequest_namex2aLDAP__SearchRequestx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::SearchRequest>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_SearchResultEntry__value_refx2anamex2aLDAP__SearchResultEntryx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_SearchResultEntry__value_refx2anamex2aLDAP__SearchResultEntryx2bx2b = { {}, "value_ref<SearchResultEntry>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__SearchResultEntry_namex2aLDAP__SearchResultEntryx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::SearchResultEntry>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_SearchResultDone__value_refx2anamex2aLDAP__SearchResultDonex2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_SearchResultDone__value_refx2anamex2aLDAP__SearchResultDonex2bx2b = { {}, "value_ref<SearchResultDone>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__SearchResultDone_namex2aLDAP__SearchResultDonex2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::SearchResultDone>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ModifyRequest__value_refx2anamex2aLDAP__ModifyRequestx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_ModifyRequest__value_refx2anamex2aLDAP__ModifyRequestx2bx2b = { {}, "value_ref<ModifyRequest>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__ModifyRequest_namex2aLDAP__ModifyRequestx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::ModifyRequest>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ModifyResponse__value_refx2anamex2aLDAP__ModifyResponsex2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_ModifyResponse__value_refx2anamex2aLDAP__ModifyResponsex2bx2b = { {}, "value_ref<ModifyResponse>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__ModifyResponse_namex2aLDAP__ModifyResponsex2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::ModifyResponse>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_AddResponse__value_refx2anamex2aLDAP__AddResponsex2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_LDAP__AddResponse_namex2aLDAP__AddResponsex2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__AddResponse_namex2aLDAP__AddResponsex2b = { "LDAP::AddResponse", "LDAP::AddResponse", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::AddResponse, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_AddResponse__value_refx2anamex2aLDAP__AddResponsex2bx2b = { {}, "value_ref<AddResponse>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__AddResponse_namex2aLDAP__AddResponsex2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::AddResponse>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_DelRequest__value_refx2anamex2aLDAP__DelRequestx2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_LDAP__DelRequest_namex2aLDAP__DelRequestx2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__DelRequest_namex2aLDAP__DelRequestx2b = { "LDAP::DelRequest", "LDAP::DelRequest", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "objectName", &::hilti::rt::type_info::string, offsetof(LDAP::DelRequest, objectName), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<std::string>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::DelRequest, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_DelRequest__value_refx2anamex2aLDAP__DelRequestx2bx2b = { {}, "value_ref<DelRequest>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__DelRequest_namex2aLDAP__DelRequestx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::DelRequest>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_DelResponse__value_refx2anamex2aLDAP__DelResponsex2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_LDAP__DelResponse_namex2aLDAP__DelResponsex2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__DelResponse_namex2aLDAP__DelResponsex2b = { "LDAP::DelResponse", "LDAP::DelResponse", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::DelResponse, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_DelResponse__value_refx2anamex2aLDAP__DelResponsex2bx2b = { {}, "value_ref<DelResponse>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__DelResponse_namex2aLDAP__DelResponsex2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::DelResponse>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ModDNResponse__value_refx2anamex2aLDAP__ModDNResponsex2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_ModDNResponse__value_refx2anamex2aLDAP__ModDNResponsex2bx2b = { {}, "value_ref<ModDNResponse>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__ModDNResponse_namex2aLDAP__ModDNResponsex2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::ModDNResponse>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_CompareResponse__value_refx2anamex2aLDAP__CompareResponsex2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_LDAP__CompareResponse_namex2aLDAP__CompareResponsex2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__CompareResponse_namex2aLDAP__CompareResponsex2b = { "LDAP::CompareResponse", "LDAP::CompareResponse", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::CompareResponse, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_CompareResponse__value_refx2anamex2aLDAP__CompareResponsex2bx2b = { {}, "value_ref<CompareResponse>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__CompareResponse_namex2aLDAP__CompareResponsex2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::CompareResponse>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_AbandonRequest__value_refx2anamex2aLDAP__AbandonRequestx2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_LDAP__AbandonRequest_namex2aLDAP__AbandonRequestx2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__AbandonRequest_namex2aLDAP__AbandonRequestx2b = { "LDAP::AbandonRequest", "LDAP::AbandonRequest", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "messageID", &::hilti::rt::type_info::int64, offsetof(LDAP::AbandonRequest, messageID), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<int64_t>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::AbandonRequest, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_AbandonRequest__value_refx2anamex2aLDAP__AbandonRequestx2bx2b = { {}, "value_ref<AbandonRequest>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__AbandonRequest_namex2aLDAP__AbandonRequestx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::AbandonRequest>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_NotImplemented__value_refx2anamex2aLDAP__NotImplementedx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_NotImplemented__value_refx2anamex2aLDAP__NotImplementedx2bx2b = { {}, "value_ref<NotImplemented>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__NotImplemented_namex2aLDAP__NotImplementedx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::NotImplemented>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ExtendedRequest__value_refx2anamex2aLDAP__ExtendedRequestx2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_LDAP__ExtendedRequest_namex2aLDAP__ExtendedRequestx2b;
    extern const ::hilti::rt::TypeInfo __ti_optional_iterator_stream___optionalx2aiteratorx2astreamx2bx2b;
    const ::hilti::rt::TypeInfo __ti_optional_iterator_stream___optionalx2aiteratorx2astreamx2bx2b = { {}, "optional<iterator<stream>>", new ::hilti::rt::type_info::Optional(&::hilti::rt::type_info::stream_iterator, ::hilti::rt::type_info::Optional::accessor<::hilti::rt::stream::SafeConstIterator>()) };
    const ::hilti::rt::TypeInfo __ti_LDAP__ExtendedRequest_namex2aLDAP__ExtendedRequestx2b = { "LDAP::ExtendedRequest", "LDAP::ExtendedRequest", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "requestValue", &::hilti::rt::type_info::bytes, offsetof(LDAP::ExtendedRequest, requestValue), false, false }, ::hilti::rt::type_info::struct_::Field{ "header", &type_info::__ti_value_ref_ASN1__ASN1Header__value_refx2anamex2aASN1__ASN1Headerx2bx2b, offsetof(LDAP::ExtendedRequest, header), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>() }, ::hilti::rt::type_info::struct_::Field{ "requestName", &::hilti::rt::type_info::string, offsetof(LDAP::ExtendedRequest, requestName), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<std::string>() }, ::hilti::rt::type_info::struct_::Field{ "__position_update", &type_info::__ti_optional_iterator_stream___optionalx2aiteratorx2astreamx2bx2b, offsetof(LDAP::ExtendedRequest, __position_update), true, false }, ::hilti::rt::type_info::struct_::Field{ "__offset", &::hilti::rt::type_info::uint64, offsetof(LDAP::ExtendedRequest, __offset), true, false }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::ExtendedRequest, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_ExtendedRequest__value_refx2anamex2aLDAP__ExtendedRequestx2bx2b = { {}, "value_ref<ExtendedRequest>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__ExtendedRequest_namex2aLDAP__ExtendedRequestx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::ExtendedRequest>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ExtendedResponse__value_refx2anamex2aLDAP__ExtendedResponsex2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_LDAP__ExtendedResponse_namex2aLDAP__ExtendedResponsex2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__ExtendedResponse_namex2aLDAP__ExtendedResponsex2b = { "LDAP::ExtendedResponse", "LDAP::ExtendedResponse", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "responseName", &::hilti::rt::type_info::bytes, offsetof(LDAP::ExtendedResponse, responseName), false, false }, ::hilti::rt::type_info::struct_::Field{ "responseValue", &::hilti::rt::type_info::bytes, offsetof(LDAP::ExtendedResponse, responseValue), false, false }, ::hilti::rt::type_info::struct_::Field{ "__position_update", &type_info::__ti_optional_iterator_stream___optionalx2aiteratorx2astreamx2bx2b, offsetof(LDAP::ExtendedResponse, __position_update), true, false }, ::hilti::rt::type_info::struct_::Field{ "__offset", &::hilti::rt::type_info::uint64, offsetof(LDAP::ExtendedResponse, __offset), true, false }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::ExtendedResponse, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_ExtendedResponse__value_refx2anamex2aLDAP__ExtendedResponsex2bx2b = { {}, "value_ref<ExtendedResponse>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__ExtendedResponse_namex2aLDAP__ExtendedResponsex2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::ExtendedResponse>()) };
    const ::hilti::rt::TypeInfo __ti_LDAP__Message_namex2aLDAP__Messagex2b = { "LDAP::Message", "LDAP::Message", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "messageID", &::hilti::rt::type_info::int64, offsetof(LDAP::Message, messageID), false, false }, ::hilti::rt::type_info::struct_::Field{ "opcode", &type_info::__ti_LDAP__ProtocolOpcode_namex2aLDAP__ProtocolOpcodex2b, offsetof(LDAP::Message, opcode), false, false }, ::hilti::rt::type_info::struct_::Field{ "unsetResultDefault", &type_info::__ti_value_ref_Result__value_refx2anamex2aLDAP__Resultx2bx2b, offsetof(LDAP::Message, unsetResultDefault), false, false }, ::hilti::rt::type_info::struct_::Field{ "result_", &type_info::__ti_strong_ref_Result__strong_refx2anamex2aLDAP__Resultx2bx2b, offsetof(LDAP::Message, result_), false, false }, ::hilti::rt::type_info::struct_::Field{ "obj", &::hilti::rt::type_info::string, offsetof(LDAP::Message, obj), false, false }, ::hilti::rt::type_info::struct_::Field{ "arg", &::hilti::rt::type_info::string, offsetof(LDAP::Message, arg), false, false }, ::hilti::rt::type_info::struct_::Field{ "seqHeaderLen", &::hilti::rt::type_info::uint64, offsetof(LDAP::Message, seqHeaderLen), false, false }, ::hilti::rt::type_info::struct_::Field{ "msgLen", &::hilti::rt::type_info::uint64, offsetof(LDAP::Message, msgLen), false, false }, ::hilti::rt::type_info::struct_::Field{ "opLen", &::hilti::rt::type_info::uint64, offsetof(LDAP::Message, opLen), false, false }, ::hilti::rt::type_info::struct_::Field{ "seqHeader", &type_info::__ti_value_ref_ASN1__ASN1Header__value_refx2anamex2aASN1__ASN1Headerx2bx2b, offsetof(LDAP::Message, seqHeader), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>() }, ::hilti::rt::type_info::struct_::Field{ "messageID_header", &type_info::__ti_value_ref_ASN1__ASN1Header__value_refx2anamex2aASN1__ASN1Headerx2bx2b, offsetof(LDAP::Message, messageID_header), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>() }, ::hilti::rt::type_info::struct_::Field{ "protocolOp", &type_info::__ti_value_ref_ASN1__ASN1Header__value_refx2anamex2aASN1__ASN1Headerx2bx2b, offsetof(LDAP::Message, protocolOp), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>() }, ::hilti::rt::type_info::struct_::Field{ "BIND_REQUEST", &type_info::__ti_value_ref_BindRequest__value_refx2anamex2aLDAP__BindRequestx2bx2b, offsetof(LDAP::Message, BIND_REQUEST), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::BindRequest>>() }, ::hilti::rt::type_info::struct_::Field{ "BIND_RESPONSE", &type_info::__ti_value_ref_BindResponse__value_refx2anamex2aLDAP__BindResponsex2bx2b, offsetof(LDAP::Message, BIND_RESPONSE), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::BindResponse>>() }, ::hilti::rt::type_info::struct_::Field{ "UNBIND_REQUEST", &type_info::__ti_value_ref_UnbindRequest__value_refx2anamex2aLDAP__UnbindRequestx2bx2b, offsetof(LDAP::Message, UNBIND_REQUEST), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::UnbindRequest>>() }, ::hilti::rt::type_info::struct_::Field{ "SEARCH_REQUEST", &type_info::__ti_value_ref_SearchRequest__value_refx2anamex2aLDAP__SearchRequestx2bx2b, offsetof(LDAP::Message, SEARCH_REQUEST), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchRequest>>() }, ::hilti::rt::type_info::struct_::Field{ "SEARCH_RESULT_ENTRY", &type_info::__ti_value_ref_SearchResultEntry__value_refx2anamex2aLDAP__SearchResultEntryx2bx2b, offsetof(LDAP::Message, SEARCH_RESULT_ENTRY), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchResultEntry>>() }, ::hilti::rt::type_info::struct_::Field{ "SEARCH_RESULT_DONE", &type_info::__ti_value_ref_SearchResultDone__value_refx2anamex2aLDAP__SearchResultDonex2bx2b, offsetof(LDAP::Message, SEARCH_RESULT_DONE), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchResultDone>>() }, ::hilti::rt::type_info::struct_::Field{ "MODIFY_REQUEST", &type_info::__ti_value_ref_ModifyRequest__value_refx2anamex2aLDAP__ModifyRequestx2bx2b, offsetof(LDAP::Message, MODIFY_REQUEST), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::ModifyRequest>>() }, ::hilti::rt::type_info::struct_::Field{ "MODIFY_RESPONSE", &type_info::__ti_value_ref_ModifyResponse__value_refx2anamex2aLDAP__ModifyResponsex2bx2b, offsetof(LDAP::Message, MODIFY_RESPONSE), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::ModifyResponse>>() }, ::hilti::rt::type_info::struct_::Field{ "ADD_RESPONSE", &type_info::__ti_value_ref_AddResponse__value_refx2anamex2aLDAP__AddResponsex2bx2b, offsetof(LDAP::Message, ADD_RESPONSE), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::AddResponse>>() }, ::hilti::rt::type_info::struct_::Field{ "DEL_REQUEST", &type_info::__ti_value_ref_DelRequest__value_refx2anamex2aLDAP__DelRequestx2bx2b, offsetof(LDAP::Message, DEL_REQUEST), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::DelRequest>>() }, ::hilti::rt::type_info::struct_::Field{ "DEL_RESPONSE", &type_info::__ti_value_ref_DelResponse__value_refx2anamex2aLDAP__DelResponsex2bx2b, offsetof(LDAP::Message, DEL_RESPONSE), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::DelResponse>>() }, ::hilti::rt::type_info::struct_::Field{ "MOD_DN_RESPONSE", &type_info::__ti_value_ref_ModDNResponse__value_refx2anamex2aLDAP__ModDNResponsex2bx2b, offsetof(LDAP::Message, MOD_DN_RESPONSE), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::ModDNResponse>>() }, ::hilti::rt::type_info::struct_::Field{ "COMPARE_RESPONSE", &type_info::__ti_value_ref_CompareResponse__value_refx2anamex2aLDAP__CompareResponsex2bx2b, offsetof(LDAP::Message, COMPARE_RESPONSE), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::CompareResponse>>() }, ::hilti::rt::type_info::struct_::Field{ "ABANDON_REQUEST", &type_info::__ti_value_ref_AbandonRequest__value_refx2anamex2aLDAP__AbandonRequestx2bx2b, offsetof(LDAP::Message, ABANDON_REQUEST), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::AbandonRequest>>() }, ::hilti::rt::type_info::struct_::Field{ "ADD_REQUEST", &type_info::__ti_value_ref_NotImplemented__value_refx2anamex2aLDAP__NotImplementedx2bx2b, offsetof(LDAP::Message, ADD_REQUEST), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::NotImplemented>>() }, ::hilti::rt::type_info::struct_::Field{ "COMPARE_REQUEST", &type_info::__ti_value_ref_NotImplemented__value_refx2anamex2aLDAP__NotImplementedx2bx2b, offsetof(LDAP::Message, COMPARE_REQUEST), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::NotImplemented>>() }, ::hilti::rt::type_info::struct_::Field{ "EXTENDED_REQUEST", &type_info::__ti_value_ref_ExtendedRequest__value_refx2anamex2aLDAP__ExtendedRequestx2bx2b, offsetof(LDAP::Message, EXTENDED_REQUEST), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::ExtendedRequest>>() }, ::hilti::rt::type_info::struct_::Field{ "EXTENDED_RESPONSE", &type_info::__ti_value_ref_ExtendedResponse__value_refx2anamex2aLDAP__ExtendedResponsex2bx2b, offsetof(LDAP::Message, EXTENDED_RESPONSE), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::ExtendedResponse>>() }, ::hilti::rt::type_info::struct_::Field{ "INTERMEDIATE_RESPONSE", &type_info::__ti_value_ref_NotImplemented__value_refx2anamex2aLDAP__NotImplementedx2bx2b, offsetof(LDAP::Message, INTERMEDIATE_RESPONSE), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::NotImplemented>>() }, ::hilti::rt::type_info::struct_::Field{ "MOD_DN_REQUEST", &type_info::__ti_value_ref_NotImplemented__value_refx2anamex2aLDAP__NotImplementedx2bx2b, offsetof(LDAP::Message, MOD_DN_REQUEST), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::NotImplemented>>() }, ::hilti::rt::type_info::struct_::Field{ "SEARCH_RESULT_REFERENCE", &type_info::__ti_value_ref_NotImplemented__value_refx2anamex2aLDAP__NotImplementedx2bx2b, offsetof(LDAP::Message, SEARCH_RESULT_REFERENCE), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::NotImplemented>>() }, ::hilti::rt::type_info::struct_::Field{ "__position_update", &type_info::__ti_optional_iterator_stream___optionalx2aiteratorx2astreamx2bx2b, offsetof(LDAP::Message, __position_update), true, false }, ::hilti::rt::type_info::struct_::Field{ "__offset", &::hilti::rt::type_info::uint64, offsetof(LDAP::Message, __offset), true, false }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::Message, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__ExtendedResponseEntry_namex2aLDAP__ExtendedResponseEntryx2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__ExtendedResponseEntry_namex2aLDAP__ExtendedResponseEntryx2b = { "LDAP::ExtendedResponseEntry", "LDAP::ExtendedResponseEntry", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::ExtendedResponseEntry, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__AttributeSelection_namex2aLDAP__AttributeSelectionx2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__AttributeSelection_namex2aLDAP__AttributeSelectionx2b = { "LDAP::AttributeSelection", "LDAP::AttributeSelection", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "attributes", &type_info::__ti_vector_string__vectorx2astringx2b, offsetof(LDAP::AttributeSelection, attributes), false, false }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::AttributeSelection, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__AttributeValueAssertion_namex2aLDAP__AttributeValueAssertionx2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__AttributeValueAssertion_namex2aLDAP__AttributeValueAssertionx2b = { "LDAP::AttributeValueAssertion", "LDAP::AttributeValueAssertion", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "desc", &::hilti::rt::type_info::string, offsetof(LDAP::AttributeValueAssertion, desc), false, false }, ::hilti::rt::type_info::struct_::Field{ "val", &::hilti::rt::type_info::string, offsetof(LDAP::AttributeValueAssertion, val), false, false }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::AttributeValueAssertion, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__FilterType_namex2aLDAP__FilterTypex2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__FilterType_namex2aLDAP__FilterTypex2b = { "LDAP::FilterType", "LDAP::FilterType", new ::hilti::rt::type_info::Enum(std::vector<::hilti::rt::type_info::enum_::Label>({::hilti::rt::type_info::enum_::Label{ "FILTER_AND", 0 }, ::hilti::rt::type_info::enum_::Label{ "FILTER_OR", 1 }, ::hilti::rt::type_info::enum_::Label{ "FILTER_NOT", 2 }, ::hilti::rt::type_info::enum_::Label{ "FILTER_EQ", 3 }, ::hilti::rt::type_info::enum_::Label{ "FILTER_SUBSTR", 4 }, ::hilti::rt::type_info::enum_::Label{ "FILTER_GE", 5 }, ::hilti::rt::type_info::enum_::Label{ "FILTER_LE", 6 }, ::hilti::rt::type_info::enum_::Label{ "FILTER_PRESENT", 7 }, ::hilti::rt::type_info::enum_::Label{ "FILTER_APPROX", 8 }, ::hilti::rt::type_info::enum_::Label{ "FILTER_EXT", 9 }, ::hilti::rt::type_info::enum_::Label{ "FILTER_INVALID", 254 }, ::hilti::rt::type_info::enum_::Label{ "Undef", -1 }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__DecodedAttributeValue_namex2aLDAP__DecodedAttributeValuex2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__DecodedAttributeValue_namex2aLDAP__DecodedAttributeValuex2b = { "LDAP::DecodedAttributeValue", "LDAP::DecodedAttributeValue", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "assertionValueDecoded", &::hilti::rt::type_info::string, offsetof(LDAP::DecodedAttributeValue, assertionValueDecoded), false, false }, ::hilti::rt::type_info::struct_::Field{ "attributeDesc_len", &::hilti::rt::type_info::uint8, offsetof(LDAP::DecodedAttributeValue, attributeDesc_len), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint8_t>>() }, ::hilti::rt::type_info::struct_::Field{ "attributeDesc", &::hilti::rt::type_info::bytes, offsetof(LDAP::DecodedAttributeValue, attributeDesc), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "assertionValue_len", &::hilti::rt::type_info::uint8, offsetof(LDAP::DecodedAttributeValue, assertionValue_len), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint8_t>>() }, ::hilti::rt::type_info::struct_::Field{ "assertionValue", &::hilti::rt::type_info::bytes, offsetof(LDAP::DecodedAttributeValue, assertionValue), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "matchValue_len", &::hilti::rt::type_info::uint8, offsetof(LDAP::DecodedAttributeValue, matchValue_len), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint8_t>>() }, ::hilti::rt::type_info::struct_::Field{ "matchValue", &::hilti::rt::type_info::bytes, offsetof(LDAP::DecodedAttributeValue, matchValue), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::DecodedAttributeValue, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__EncryptedMessage_namex2aLDAP__EncryptedMessagex2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__EncryptedMessage_namex2aLDAP__EncryptedMessagex2b = { "LDAP::EncryptedMessage", "LDAP::EncryptedMessage", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "len", &::hilti::rt::type_info::uint32, offsetof(LDAP::EncryptedMessage, len), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint32_t>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::EncryptedMessage, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__KrbWrapToken_namex2aLDAP__KrbWrapTokenx2b;
    extern const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_send_by_acceptor__0x3e_sealed__1x3e_acceptor_subkey__2x3e_x75_bitfieldx2a8_send_by_acceptor_0_0_sealed_1_1_acceptor_subkey_2_2_x2b;
    const ::hilti::rt::TypeInfo __ti_bitfieldx2a8x2b_x73_send_by_acceptor__0x3e_sealed__1x3e_acceptor_subkey__2x3e_x75_bitfieldx2a8_send_by_acceptor_0_0_sealed_1_1_acceptor_subkey_2_2_x2b = { {}, "bitfield(8) { send_by_acceptor: 0; sealed: 1; acceptor_subkey: 2; }", new ::hilti::rt::type_info::Bitfield(std::vector<::hilti::rt::type_info::bitfield::Bits>({::hilti::rt::type_info::bitfield::Bits{ "send_by_acceptor", &::hilti::rt::type_info::uint8, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>, 0>() }, ::hilti::rt::type_info::bitfield::Bits{ "sealed", &::hilti::rt::type_info::uint8, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>, 1>() }, ::hilti::rt::type_info::bitfield::Bits{ "acceptor_subkey", &::hilti::rt::type_info::uint8, ::hilti::rt::bitfield::elementOffset<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>, 2>() }})) };
    const ::hilti::rt::TypeInfo __ti_LDAP__KrbWrapToken_namex2aLDAP__KrbWrapTokenx2b = { "LDAP::KrbWrapToken", "LDAP::KrbWrapToken", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "trailer_ec", &::hilti::rt::type_info::uint64, offsetof(LDAP::KrbWrapToken, trailer_ec), false, false }, ::hilti::rt::type_info::struct_::Field{ "header_ec", &::hilti::rt::type_info::uint64, offsetof(LDAP::KrbWrapToken, header_ec), false, false }, ::hilti::rt::type_info::struct_::Field{ "ctx_flags", &type_info::__ti_bitfieldx2a8x2b_x73_send_by_acceptor__0x3e_sealed__1x3e_acceptor_subkey__2x3e_x75_bitfieldx2a8_send_by_acceptor_0_0_sealed_1_1_acceptor_subkey_2_2_x2b, offsetof(LDAP::KrbWrapToken, ctx_flags), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>>() }, ::hilti::rt::type_info::struct_::Field{ "ec", &::hilti::rt::type_info::uint16, offsetof(LDAP::KrbWrapToken, ec), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint16_t>>() }, ::hilti::rt::type_info::struct_::Field{ "rrc", &::hilti::rt::type_info::uint16, offsetof(LDAP::KrbWrapToken, rrc), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint16_t>>() }, ::hilti::rt::type_info::struct_::Field{ "snd_seq", &::hilti::rt::type_info::uint64, offsetof(LDAP::KrbWrapToken, snd_seq), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint64_t>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::KrbWrapToken, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__SaslMsKrb5Stripper_namex2aLDAP__SaslMsKrb5Stripperx2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_KrbWrapToken__value_refx2anamex2aLDAP__KrbWrapTokenx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_KrbWrapToken__value_refx2anamex2aLDAP__KrbWrapTokenx2bx2b = { {}, "value_ref<KrbWrapToken>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__KrbWrapToken_namex2aLDAP__KrbWrapTokenx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::KrbWrapToken>()) };
    const ::hilti::rt::TypeInfo __ti_LDAP__SaslMsKrb5Stripper_namex2aLDAP__SaslMsKrb5Stripperx2b = { "LDAP::SaslMsKrb5Stripper", "LDAP::SaslMsKrb5Stripper", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "switch_size", &::hilti::rt::type_info::uint64, offsetof(LDAP::SaslMsKrb5Stripper, switch_size), false, false }, ::hilti::rt::type_info::struct_::Field{ "len", &::hilti::rt::type_info::uint32, offsetof(LDAP::SaslMsKrb5Stripper, len), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint32_t>>() }, ::hilti::rt::type_info::struct_::Field{ "krb5_tok_id", &::hilti::rt::type_info::uint16, offsetof(LDAP::SaslMsKrb5Stripper, krb5_tok_id), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint16_t>>() }, ::hilti::rt::type_info::struct_::Field{ "krb_wrap_token", &type_info::__ti_value_ref_KrbWrapToken__value_refx2anamex2aLDAP__KrbWrapTokenx2bx2b, offsetof(LDAP::SaslMsKrb5Stripper, krb_wrap_token), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::KrbWrapToken>>() }, ::hilti::rt::type_info::struct_::Field{ "__position_update", &type_info::__ti_optional_iterator_stream___optionalx2aiteratorx2astreamx2bx2b, offsetof(LDAP::SaslMsKrb5Stripper, __position_update), true, false }, ::hilti::rt::type_info::struct_::Field{ "__offset", &::hilti::rt::type_info::uint64, offsetof(LDAP::SaslMsKrb5Stripper, __offset), true, false }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::SaslMsKrb5Stripper, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__TlsForward_namex2aLDAP__TlsForwardx2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__TlsForward_namex2aLDAP__TlsForwardx2b = { "LDAP::TlsForward", "LDAP::TlsForward", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "chunk", &::hilti::rt::type_info::bytes, offsetof(LDAP::TlsForward, chunk), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::TlsForward, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__MessageDispatch_namex2aLDAP__MessageDispatchx2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__MessageDispatch_namex2aLDAP__MessageDispatchx2b = { "LDAP::MessageDispatch", "LDAP::MessageDispatch", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::MessageDispatch, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__MaybeEncrypted_namex2aLDAP__MaybeEncryptedx2b;
    extern const ::hilti::rt::TypeInfo __ti_vector_uint_8___vectorx2auint8x2b;
    const ::hilti::rt::TypeInfo __ti_vector_uint_8___vectorx2auint8x2b = { {}, "vector<uint<8>>", new ::hilti::rt::type_info::Vector(&::hilti::rt::type_info::uint8, ::hilti::rt::type_info::Vector::accessor<::hilti::rt::integer::safe<uint8_t>>()) };
    const ::hilti::rt::TypeInfo __ti_LDAP__MaybeEncrypted_namex2aLDAP__MaybeEncryptedx2b = { "LDAP::MaybeEncrypted", "LDAP::MaybeEncrypted", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "start", &::hilti::rt::type_info::stream_iterator, offsetof(LDAP::MaybeEncrypted, start), false, false }, ::hilti::rt::type_info::struct_::Field{ "saslLen", &::hilti::rt::type_info::uint64, offsetof(LDAP::MaybeEncrypted, saslLen), false, false }, ::hilti::rt::type_info::struct_::Field{ "mech", &::hilti::rt::type_info::bytes, offsetof(LDAP::MaybeEncrypted, mech), false, false }, ::hilti::rt::type_info::struct_::Field{ "first", &::hilti::rt::type_info::uint8, offsetof(LDAP::MaybeEncrypted, first), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint8_t>>() }, ::hilti::rt::type_info::struct_::Field{ "rem", &type_info::__ti_vector_uint_8___vectorx2auint8x2b, offsetof(LDAP::MaybeEncrypted, rem), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>>() }, ::hilti::rt::type_info::struct_::Field{ "__begin", &::hilti::rt::type_info::stream_iterator, offsetof(LDAP::MaybeEncrypted, __begin), true, false }, ::hilti::rt::type_info::struct_::Field{ "__position_update", &type_info::__ti_optional_iterator_stream___optionalx2aiteratorx2astreamx2bx2b, offsetof(LDAP::MaybeEncrypted, __position_update), true, false }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::MaybeEncrypted, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__Messages_namex2aLDAP__Messagesx2b;
    extern const ::hilti::rt::TypeInfo __ti_strong_ref_LDAP__Ctx__strong_refx2anamex2aLDAP__Ctxx2bx2b;
    const ::hilti::rt::TypeInfo __ti_strong_ref_LDAP__Ctx__strong_refx2anamex2aLDAP__Ctxx2bx2b = { {}, "strong_ref<LDAP::Ctx>", new ::hilti::rt::type_info::StrongReference(&type_info::__ti_LDAP__Ctx_namex2aLDAP__Ctxx2b, ::hilti::rt::type_info::StrongReference::accessor<__hlt_ldap::LDAP::Ctx>()) };
    const ::hilti::rt::TypeInfo __ti_LDAP__Messages_namex2aLDAP__Messagesx2b = { "LDAP::Messages", "LDAP::Messages", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "__context", &type_info::__ti_strong_ref_LDAP__Ctx__strong_refx2anamex2aLDAP__Ctxx2bx2b, offsetof(LDAP::Messages, __context), true, false }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::Messages, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__SubstringFilter_namex2aLDAP__SubstringFilterx2b;
    const ::hilti::rt::TypeInfo __ti_LDAP__SubstringFilter_namex2aLDAP__SubstringFilterx2b = { "LDAP::SubstringFilter", "LDAP::SubstringFilter", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "initial", &::hilti::rt::type_info::string, offsetof(LDAP::SubstringFilter, initial), false, false }, ::hilti::rt::type_info::struct_::Field{ "final", &::hilti::rt::type_info::string, offsetof(LDAP::SubstringFilter, final), false, false }, ::hilti::rt::type_info::struct_::Field{ "anys", &type_info::__ti_vector_string__vectorx2astringx2b, offsetof(LDAP::SubstringFilter, anys), false, false }, ::hilti::rt::type_info::struct_::Field{ "attributeDesc_len", &::hilti::rt::type_info::uint8, offsetof(LDAP::SubstringFilter, attributeDesc_len), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::integer::safe<uint8_t>>() }, ::hilti::rt::type_info::struct_::Field{ "attributeDesc", &::hilti::rt::type_info::bytes, offsetof(LDAP::SubstringFilter, attributeDesc), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Bytes>() }, ::hilti::rt::type_info::struct_::Field{ "header", &type_info::__ti_value_ref_ASN1__ASN1Header__value_refx2anamex2aASN1__ASN1Headerx2bx2b, offsetof(LDAP::SubstringFilter, header), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::SubstringFilter, __error), true, false }})) };
    extern const ::hilti::rt::TypeInfo __ti_LDAP__SearchFilter_namex2aLDAP__SearchFilterx2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ParseNestedAndOr__value_refx2anamex2aLDAP__ParseNestedAndOrx2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_LDAP__ParseNestedAndOr_namex2aLDAP__ParseNestedAndOrx2b;
    extern const ::hilti::rt::TypeInfo __ti_vector_SearchFilter__vectorx2anamex2aLDAP__SearchFilterx2bx2b;
    const ::hilti::rt::TypeInfo __ti_vector_SearchFilter__vectorx2anamex2aLDAP__SearchFilterx2bx2b = { {}, "vector<SearchFilter>", new ::hilti::rt::type_info::Vector(&type_info::__ti_LDAP__SearchFilter_namex2aLDAP__SearchFilterx2b, ::hilti::rt::type_info::Vector::accessor<__hlt_ldap::LDAP::SearchFilter>()) };
    const ::hilti::rt::TypeInfo __ti_LDAP__ParseNestedAndOr_namex2aLDAP__ParseNestedAndOrx2b = { "LDAP::ParseNestedAndOr", "LDAP::ParseNestedAndOr", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "searchfilters", &type_info::__ti_vector_SearchFilter__vectorx2anamex2aLDAP__SearchFilterx2bx2b, offsetof(LDAP::ParseNestedAndOr, searchfilters), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::Vector<__hlt_ldap::LDAP::SearchFilter>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::ParseNestedAndOr, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_ParseNestedAndOr__value_refx2anamex2aLDAP__ParseNestedAndOrx2bx2b = { {}, "value_ref<ParseNestedAndOr>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__ParseNestedAndOr_namex2aLDAP__ParseNestedAndOrx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::ParseNestedAndOr>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_ParseNestedNot__value_refx2anamex2aLDAP__ParseNestedNotx2bx2b;
    extern const ::hilti::rt::TypeInfo __ti_LDAP__ParseNestedNot_namex2aLDAP__ParseNestedNotx2b;
    extern const ::hilti::rt::TypeInfo __ti_value_ref_SearchFilter__value_refx2anamex2aLDAP__SearchFilterx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_SearchFilter__value_refx2anamex2aLDAP__SearchFilterx2bx2b = { {}, "value_ref<SearchFilter>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__SearchFilter_namex2aLDAP__SearchFilterx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::SearchFilter>()) };
    const ::hilti::rt::TypeInfo __ti_LDAP__ParseNestedNot_namex2aLDAP__ParseNestedNotx2b = { "LDAP::ParseNestedNot", "LDAP::ParseNestedNot", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "searchfilter", &type_info::__ti_value_ref_SearchFilter__value_refx2anamex2aLDAP__SearchFilterx2bx2b, offsetof(LDAP::ParseNestedNot, searchfilter), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchFilter>>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::ParseNestedNot, __error), true, false }})) };
    const ::hilti::rt::TypeInfo __ti_value_ref_ParseNestedNot__value_refx2anamex2aLDAP__ParseNestedNotx2bx2b = { {}, "value_ref<ParseNestedNot>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__ParseNestedNot_namex2aLDAP__ParseNestedNotx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::ParseNestedNot>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_DecodedAttributeValue__value_refx2anamex2aLDAP__DecodedAttributeValuex2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_DecodedAttributeValue__value_refx2anamex2aLDAP__DecodedAttributeValuex2bx2b = { {}, "value_ref<DecodedAttributeValue>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__DecodedAttributeValue_namex2aLDAP__DecodedAttributeValuex2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::DecodedAttributeValue>()) };
    extern const ::hilti::rt::TypeInfo __ti_value_ref_SubstringFilter__value_refx2anamex2aLDAP__SubstringFilterx2bx2b;
    const ::hilti::rt::TypeInfo __ti_value_ref_SubstringFilter__value_refx2anamex2aLDAP__SubstringFilterx2bx2b = { {}, "value_ref<SubstringFilter>", new ::hilti::rt::type_info::ValueReference(&type_info::__ti_LDAP__SubstringFilter_namex2aLDAP__SubstringFilterx2b, ::hilti::rt::type_info::ValueReference::accessor<__hlt_ldap::LDAP::SubstringFilter>()) };
    const ::hilti::rt::TypeInfo __ti_LDAP__SearchFilter_namex2aLDAP__SearchFilterx2b = { "LDAP::SearchFilter", "LDAP::SearchFilter", new ::hilti::rt::type_info::Struct(std::vector<::hilti::rt::type_info::struct_::Field>({::hilti::rt::type_info::struct_::Field{ "filterType", &type_info::__ti_LDAP__FilterType_namex2aLDAP__FilterTypex2b, offsetof(LDAP::SearchFilter, filterType), false, false }, ::hilti::rt::type_info::struct_::Field{ "filterBytes", &::hilti::rt::type_info::bytes, offsetof(LDAP::SearchFilter, filterBytes), false, false }, ::hilti::rt::type_info::struct_::Field{ "filterLen", &::hilti::rt::type_info::uint64, offsetof(LDAP::SearchFilter, filterLen), false, false }, ::hilti::rt::type_info::struct_::Field{ "stringRepresentation", &::hilti::rt::type_info::string, offsetof(LDAP::SearchFilter, stringRepresentation), false, false }, ::hilti::rt::type_info::struct_::Field{ "FILTER_AND", &type_info::__ti_value_ref_ParseNestedAndOr__value_refx2anamex2aLDAP__ParseNestedAndOrx2bx2b, offsetof(LDAP::SearchFilter, FILTER_AND), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::ParseNestedAndOr>>() }, ::hilti::rt::type_info::struct_::Field{ "FILTER_OR", &type_info::__ti_value_ref_ParseNestedAndOr__value_refx2anamex2aLDAP__ParseNestedAndOrx2bx2b, offsetof(LDAP::SearchFilter, FILTER_OR), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::ParseNestedAndOr>>() }, ::hilti::rt::type_info::struct_::Field{ "FILTER_NOT", &type_info::__ti_value_ref_ParseNestedNot__value_refx2anamex2aLDAP__ParseNestedNotx2bx2b, offsetof(LDAP::SearchFilter, FILTER_NOT), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::ParseNestedNot>>() }, ::hilti::rt::type_info::struct_::Field{ "FILTER_EQ", &type_info::__ti_value_ref_DecodedAttributeValue__value_refx2anamex2aLDAP__DecodedAttributeValuex2bx2b, offsetof(LDAP::SearchFilter, FILTER_EQ), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::DecodedAttributeValue>>() }, ::hilti::rt::type_info::struct_::Field{ "FILTER_SUBSTR", &type_info::__ti_value_ref_SubstringFilter__value_refx2anamex2aLDAP__SubstringFilterx2bx2b, offsetof(LDAP::SearchFilter, FILTER_SUBSTR), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::SubstringFilter>>() }, ::hilti::rt::type_info::struct_::Field{ "FILTER_GE", &type_info::__ti_value_ref_DecodedAttributeValue__value_refx2anamex2aLDAP__DecodedAttributeValuex2bx2b, offsetof(LDAP::SearchFilter, FILTER_GE), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::DecodedAttributeValue>>() }, ::hilti::rt::type_info::struct_::Field{ "FILTER_LE", &type_info::__ti_value_ref_DecodedAttributeValue__value_refx2anamex2aLDAP__DecodedAttributeValuex2bx2b, offsetof(LDAP::SearchFilter, FILTER_LE), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::DecodedAttributeValue>>() }, ::hilti::rt::type_info::struct_::Field{ "FILTER_APPROX", &type_info::__ti_value_ref_DecodedAttributeValue__value_refx2anamex2aLDAP__DecodedAttributeValuex2bx2b, offsetof(LDAP::SearchFilter, FILTER_APPROX), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::DecodedAttributeValue>>() }, ::hilti::rt::type_info::struct_::Field{ "FILTER_EXT", &type_info::__ti_value_ref_DecodedAttributeValue__value_refx2anamex2aLDAP__DecodedAttributeValuex2bx2b, offsetof(LDAP::SearchFilter, FILTER_EXT), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<::hilti::rt::ValueReference<__hlt_ldap::LDAP::DecodedAttributeValue>>() }, ::hilti::rt::type_info::struct_::Field{ "FILTER_PRESENT", &::hilti::rt::type_info::string, offsetof(LDAP::SearchFilter, FILTER_PRESENT), false, false, ::hilti::rt::type_info::struct_::Field::accessor_optional<std::string>() }, ::hilti::rt::type_info::struct_::Field{ "__error", &type_info::__ti_optional_spicy__RecoverableFailure__optionalx2anamex2ahilti__RecoverableFailurex2bx2b, offsetof(LDAP::SearchFilter, __error), true, false }})) };
} }

HILTI_PRE_INIT(__hlt_ldap::LDAP::__register_module)

inline void __hlt_ldap::ASN1::ASN1Message::__on_application_data(const ::hilti::rt::Bytes& __dd) {
    auto __self = ASN1::ASN1Message::__self();
    return __hlt_ldap::ASN1::__hook_ASN1Message___on_application_data(__dd, __self);
}

inline void __hlt_ldap::ASN1::ASN1ObjectIdentifier::__on_0x25_done() {
    auto __self = ASN1::ASN1ObjectIdentifier::__self();
    return __hlt_ldap::ASN1::__hook_ASN1ObjectIdentifier___on_0x25_done(__self);
}

inline void __hlt_ldap::ASN1::ASN1ObjectIdentifier::__on__anon_48(const ::hilti::rt::integer::safe<uint8_t>& __dd) {
    auto __self = ASN1::ASN1ObjectIdentifier::__self();
    return __hlt_ldap::ASN1::__hook_ASN1ObjectIdentifier___on__anon_48(__dd, __self);
}

inline void __hlt_ldap::ASN1::ASN1ObjectIdentifier::__on_sublist_foreach(const ::hilti::rt::Bitfield<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::integer::safe<uint8_t>>& __dd, ::hilti::rt::Bool& __stop) {
    auto __self = ASN1::ASN1ObjectIdentifier::__self();
    return __hlt_ldap::ASN1::__hook_ASN1ObjectIdentifier___on_sublist_foreach(__dd, __stop, __self);
}

inline void __hlt_ldap::ASN1::LengthType::__on__anon_44() {
    auto __self = ASN1::LengthType::__self();
    return __hlt_ldap::ASN1::__hook_LengthType___on__anon_44(__self);
}

inline void __hlt_ldap::ASN1::LengthType::__on__anon_45(const ::hilti::rt::integer::safe<uint64_t>& __dd) {
    auto __self = ASN1::LengthType::__self();
    return __hlt_ldap::ASN1::__hook_LengthType___on__anon_45(__dd, __self);
}

inline auto __hlt_ldap::ASN1::operator<<(std::ostream& o, ASN1Class x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

inline auto __hlt_ldap::ASN1::operator<<(std::ostream& o, ASN1Type x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

inline void __hlt_ldap::LDAP::AbandonRequest::__on_messageID(const ::hilti::rt::integer::safe<int64_t>& __dd) {
    auto __self = LDAP::AbandonRequest::__self();
    return __hlt_ldap::LDAP::__hook_AbandonRequest___on_messageID(__dd, __self);
}

auto __hlt_ldap::LDAP::AbandonRequest::__parse_LDAP__AbandonRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = AbandonRequest::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1070:23-1074:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __parsed_messageID;

        // Begin parsing production: Unit: ASN1__ASN1Message_28 -> Resolved_561 switch_141 (field 'messageID', id n/a, parser, args: (True));
        __parsed_messageID = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed_messageID).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message_28 -> Resolved_561 switch_141 (field 'messageID', id n/a, parser, args: (True));

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __dd = __parsed_messageID;
            ::hilti::rt::optional::valueOrInit((*__self).messageID) = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).num_value);
        }

        (*__self).__error = __error;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1071:3-1073:3");
        (*__self).__on_messageID(::hilti::rt::optional::value((*__self).messageID));
        __error = (*__self).__error;
    }

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::AbandonRequest::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = AbandonRequest::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1070:23-1074:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__AbandonRequest_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_ldap::LDAP::AddResponse::__on__anon_37(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd) {
    auto __self = LDAP::AddResponse::__self();
    return __hlt_ldap::LDAP::__hook_AddResponse___on__anon_37(__dd, __self);
}

auto __hlt_ldap::LDAP::AddResponse::__parse_LDAP__AddResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = AddResponse::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1014:20-1018:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result> __transient__anon_37;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:117:22-127:1");

    // Begin parsing production: Unit: LDAP__Result_10 -> Resolved_497 Resolved_497 Resolved_497;
    __transient__anon_37 = (__hlt_ldap::LDAP::Result());
    std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_37).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Unit: LDAP__Result_10 -> Resolved_497 Resolved_497 Resolved_497;

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1015:3-1017:3");
    (*__self).__on__anon_37(__transient__anon_37);
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::AddResponse::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = AddResponse::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1014:20-1018:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__AddResponse_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_ldap::LDAP::AttributeSelection::__on__anon_55(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd) {
    auto __self = LDAP::AttributeSelection::__self();
    return __hlt_ldap::LDAP::__hook_AttributeSelection___on__anon_55(__dd, __self);
}

auto __hlt_ldap::LDAP::AttributeSelection::__parse_LDAP__AttributeSelection_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = AttributeSelection::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:573:34-589:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __transient__anon_55;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");

    // Begin parsing production: Unit: ASN1__ASN1Message_12 -> Resolved_344 switch_89 (field '_anon_55', id n/a, parser, args: (True));
    __transient__anon_55 = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
    std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_55).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Unit: ASN1__ASN1Message_12 -> Resolved_344 switch_89 (field '_anon_55', id n/a, parser, args: (True));

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:579:3-588:3");
    (*__self).__on__anon_55(__transient__anon_55);
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::AttributeSelection::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = AttributeSelection::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:573:34-589:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__AttributeSelection_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

extern auto __hlt_ldap::LDAP::AttributeSelection::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:573:34-589:1");
    ::hilti::rt::ValueReference<__hlt_ldap::LDAP::AttributeSelection> __unit = ::hilti::rt::reference::make_value<__hlt_ldap::LDAP::AttributeSelection>((__hlt_ldap::LDAP::AttributeSelection()));
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:573:34-589:1");

    // Begin parsing production: Unit: LDAP__AttributeSelection_6 -> Resolved_343;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: LDAP__AttributeSelection_6 -> Resolved_343;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_ldap::LDAP::AttributeSelection::parse2(::hilti::rt::ValueReference<__hlt_ldap::LDAP::AttributeSelection>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:573:34-589:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:573:34-589:1");

    // Begin parsing production: Unit: LDAP__AttributeSelection_6 -> Resolved_343;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: LDAP__AttributeSelection_6 -> Resolved_343;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_ldap::LDAP::AttributeSelection::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:573:34-589:1");
    ::hilti::rt::ValueReference<__hlt_ldap::LDAP::AttributeSelection> __unit = ::hilti::rt::reference::make_value<__hlt_ldap::LDAP::AttributeSelection>((__hlt_ldap::LDAP::AttributeSelection()));
    ::spicy::rt::ParsedUnit::initialize((*__gunit), __unit, &type_info::__ti_LDAP__AttributeSelection_namex2aLDAP__AttributeSelectionx2b);
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:573:34-589:1");

    // Begin parsing production: Unit: LDAP__AttributeSelection_6 -> Resolved_343;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: LDAP__AttributeSelection_6 -> Resolved_343;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

inline void __hlt_ldap::LDAP::AttributeValueAssertion::__on__anon_56(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd) {
    auto __self = LDAP::AttributeValueAssertion::__self();
    return __hlt_ldap::LDAP::__hook_AttributeValueAssertion___on__anon_56(__dd, __self);
}

inline void __hlt_ldap::LDAP::BindRequest::__on_0x25_done() {
    auto __self = LDAP::BindRequest::__self();
    return __hlt_ldap::LDAP::__hook_BindRequest___on_0x25_done(__self);
}

inline void __hlt_ldap::LDAP::BindRequest::__on__anon_54(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd) {
    auto __self = LDAP::BindRequest::__self();
    return __hlt_ldap::LDAP::__hook_BindRequest___on__anon_54(__dd, __self);
}

inline void __hlt_ldap::LDAP::BindRequest::__on_name(const std::string& __dd) {
    auto __self = LDAP::BindRequest::__self();
    return __hlt_ldap::LDAP::__hook_BindRequest___on_name(__dd, __self);
}

inline void __hlt_ldap::LDAP::BindRequest::__on_saslCreds(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SaslCredentials>& __dd) {
    auto __self = LDAP::BindRequest::__self();
    return __hlt_ldap::LDAP::__hook_BindRequest___on_saslCreds(__dd, __self);
}

auto __hlt_ldap::LDAP::BindRequest::__parse_LDAP__BindRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = BindRequest::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:457:20-483:70");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __parsed_version;

        // Begin parsing production: Unit: ASN1__ASN1Message_10 -> Resolved_308 switch_78 (field 'version', id n/a, parser, args: (True));
        __parsed_version = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed_version).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message_10 -> Resolved_308 switch_78 (field 'version', id n/a, parser, args: (True));

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __dd = __parsed_version;
            ::hilti::rt::optional::valueOrInit((*__self).version) = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).num_value);
        }

    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __parsed_name;

        // Begin parsing production: Unit: ASN1__ASN1Message_10 -> Resolved_308 switch_78 (field 'version', id n/a, parser, args: (True));
        __parsed_name = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed_name).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message_10 -> Resolved_308 switch_78 (field 'version', id n/a, parser, args: (True));

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __dd = __parsed_name;
            ::hilti::rt::optional::valueOrInit((*__self).name) = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).str_value);
        }

        (*__self).__error = __error;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:459:3-461:3");
        (*__self).__on_name(::hilti::rt::optional::value((*__self).name));
        __error = (*__self).__error;
    }

    ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __transient__anon_54;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");

    // Begin parsing production: Unit: ASN1__ASN1Message_10 -> Resolved_308 switch_78 (field 'version', id n/a, parser, args: (True));
    __transient__anon_54 = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
    std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_54).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Unit: ASN1__ASN1Message_10 -> Resolved_308 switch_78 (field 'version', id n/a, parser, args: (True));

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:466:3-477:3");
    (*__self).__on__anon_54(__transient__anon_54);
    __error = (*__self).__error;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:403:24-411:1");
        if ( (((*__self).authType == LDAP::BindAuthType{LDAP::BindAuthType::BIND_AUTH_SASL})) && (((*__self).authData.size() > ::hilti::rt::integer::safe<std::uint64_t>{0U})) ) {
            ::hilti::rt::integer::safe<int64_t> __parse_lah = ::hilti::rt::integer::safe<std::int64_t>{0};
            ::hilti::rt::stream::SafeConstIterator __parse_lahe;
            ::hilti::rt::ValueReference<::hilti::rt::Stream> __parse_from = ::hilti::rt::Stream((*__self).authData);
            (*__parse_from).freeze();
            ::hilti::rt::stream::SafeConstIterator __parse_begin = (*__parse_from).begin();
            ::hilti::rt::stream::View __parse_cur = (*__parse_from).view();

            // Begin parsing production: Unit: LDAP__SaslCredentials_7 -> Resolved_307 switch_80;
            ::hilti::rt::optional::valueOrInit((*__self).saslCreds) = (__hlt_ldap::LDAP::SaslCredentials());
            std::tie(__parse_cur, __parse_lah, __parse_lahe, __error) = (*::hilti::rt::optional::value((*__self).saslCreds)).__parse_stage1(__parse_from, __parse_begin, __parse_cur, ::hilti::rt::Bool(false), __parse_lah, __parse_lahe, __error);
            // End parsing production: Unit: LDAP__SaslCredentials_7 -> Resolved_307 switch_80;

            (*__self).__error = __error;
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:478:3-482:3");
            (*__self).__on_saslCreds(::hilti::rt::optional::value((*__self).saslCreds));
            __error = (*__self).__error;
        }
    }

    ::hilti::rt::Result<::hilti::rt::Nothing> __requires = (((true) && (((*__self).authType != LDAP::BindAuthType{LDAP::BindAuthType::Undef}))) ? ::hilti::rt::make_result(::hilti::rt::Nothing{}) : ::hilti::rt::result::Error("&requires failed: (self?.authType &* (self.authType != BindAuthType::Undef))"));
    if ( ! (::hilti::rt::Bool(static_cast<bool>(__requires))) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:483:3-483:70");
        throw ::spicy::rt::ParseError(__requires.errorOrThrow(), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:483:3-483:70");
    }

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:457:20-483:70");
    (*__self).__on_0x25_done();
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::BindRequest::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = BindRequest::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:457:20-483:70");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__BindRequest_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_ldap::LDAP::BindResponse::__on__anon_27(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd) {
    auto __self = LDAP::BindResponse::__self();
    return __hlt_ldap::LDAP::__hook_BindResponse___on__anon_27(__dd, __self);
}

inline void __hlt_ldap::LDAP::BindResponse::__on_gss_spnego(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::GSS_SPNEGO_Subsequent>& __dd) {
    auto __self = LDAP::BindResponse::__self();
    return __hlt_ldap::LDAP::__hook_BindResponse___on_gss_spnego(__dd, __self);
}

auto __hlt_ldap::LDAP::BindResponse::__parse_LDAP__BindResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = BindResponse::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:490:21-532:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result> __transient__anon_27;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:117:22-127:1");

    // Begin parsing production: Unit: LDAP__Result_7 -> Resolved_327 Resolved_327 Resolved_327;
    __transient__anon_27 = (__hlt_ldap::LDAP::Result());
    std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_27).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Unit: LDAP__Result_7 -> Resolved_327 Resolved_327 Resolved_327;

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:491:3-507:3");
    (*__self).__on__anon_27(__transient__anon_27);
    __error = (*__self).__error;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:516:3-516:42");
        ::hilti::rt::integer::safe<uint64_t> __pre_container_offset = ::hilti::rt::integer::safe<std::uint64_t>{0U};

        // Begin parsing production: ForEach: serverSaslCreds_6 -> foreach: Resolved_338;
        std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_serverSaslCreds_6_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error, ::hilti::rt::optional::valueOrInit((*__self).serverSaslCreds));
        // End parsing production: ForEach: serverSaslCreds_6 -> foreach: Resolved_338;

        ::hilti::rt::integer::safe<uint64_t> __prev = ::hilti::rt::integer::safe<std::uint64_t>{0U};
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:413:30-421:1");
        if ( ((*__self->__p_ctx.derefAsValue()).saslMechanism == "GSS-SPNEGO"s) && (::hilti::rt::optional::value((*__self).serverSaslCreds).size() > ::hilti::rt::integer::safe<std::uint64_t>{0U}) ) {
            ::hilti::rt::integer::safe<int64_t> __parse_lah = ::hilti::rt::integer::safe<std::int64_t>{0};
            ::hilti::rt::stream::SafeConstIterator __parse_lahe;
            ::hilti::rt::ValueReference<::hilti::rt::Stream> __parse_from = ::hilti::rt::Stream(::hilti::rt::optional::value(::hilti::rt::optional::value((*__self).serverSaslCreds)[::hilti::rt::integer::safe<std::uint64_t>{0U}].payload));
            (*__parse_from).freeze();
            ::hilti::rt::stream::SafeConstIterator __parse_begin = (*__parse_from).begin();
            ::hilti::rt::stream::View __parse_cur = (*__parse_from).view();

            // Begin parsing production: Unit: LDAP__GSS_SPNEGO_Subsequent_7 -> switch_86_lha_2 Resolved_330 Resolved_340;
            ::hilti::rt::optional::valueOrInit((*__self).gss_spnego) = (__hlt_ldap::LDAP::GSS_SPNEGO_Subsequent());
            std::tie(__parse_cur, __parse_lah, __parse_lahe, __error) = (*::hilti::rt::optional::value((*__self).gss_spnego)).__parse_stage1(__parse_from, __parse_begin, __parse_cur, ::hilti::rt::Bool(false), __parse_lah, __parse_lahe, __error);
            // End parsing production: Unit: LDAP__GSS_SPNEGO_Subsequent_7 -> switch_86_lha_2 Resolved_330 Resolved_340;

            (*__self).__error = __error;
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:520:3-531:3");
            (*__self).__on_gss_spnego(::hilti::rt::optional::value((*__self).gss_spnego));
            __error = (*__self).__error;
        }
    }

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::BindResponse::__parse_serverSaslCreds_6_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<__hlt_ldap::LDAP::ServerSaslCreds>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_1;
    auto __self = BindResponse::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:516:3-516:42");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    while ( ! (::spicy::rt::detail::atEod(__data, __cur, (__lhs_1=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())))) ) {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_2;
        ::hilti::rt::stream::SafeConstIterator __old_begin = __cur.begin();
        ::hilti::rt::ValueReference<__hlt_ldap::LDAP::ServerSaslCreds> __elem;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:485:24-488:1");

        // Begin parsing production: Unit: LDAP__ServerSaslCreds_7 -> Resolved_328 payload_7 (container 'serverSaslCreds');
        __elem = (__hlt_ldap::LDAP::ServerSaslCreds());
        std::tie(__cur, __lah, __lahe, __error) = (*__elem).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: LDAP__ServerSaslCreds_7 -> Resolved_328 payload_7 (container 'serverSaslCreds');

        ::hilti::rt::Bool __stop = ::hilti::rt::Bool(false);
        if ( ! (__stop) ) {
        }

        if ( ! (__stop) ) {
            __dst.emplace_back((*__elem));
        }

        if ( __stop ) {
            break;
        }

        if ( (__cur.begin() == __old_begin) && (! (::spicy::rt::detail::atEod(__data, __cur, (__lhs_2=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))))) ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:516:3-516:42");
            throw ::spicy::rt::ParseError("loop body did not change input position, possible infinite loop"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:516:3-516:42");
        }
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::BindResponse::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = BindResponse::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:490:21-532:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__BindResponse_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_ldap::LDAP::CompareResponse::__on__anon_40(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd) {
    auto __self = LDAP::CompareResponse::__self();
    return __hlt_ldap::LDAP::__hook_CompareResponse___on__anon_40(__dd, __self);
}

auto __hlt_ldap::LDAP::CompareResponse::__parse_LDAP__CompareResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = CompareResponse::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1060:24-1064:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result> __transient__anon_40;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:117:22-127:1");

    // Begin parsing production: Unit: LDAP__Result_13 -> Resolved_548 Resolved_548 Resolved_548;
    __transient__anon_40 = (__hlt_ldap::LDAP::Result());
    std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_40).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Unit: LDAP__Result_13 -> Resolved_548 Resolved_548 Resolved_548;

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1061:3-1063:3");
    (*__self).__on__anon_40(__transient__anon_40);
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::CompareResponse::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = CompareResponse::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1060:24-1064:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__CompareResponse_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_ldap::LDAP::DecodedAttributeValue::__on_0x25_done() {
    auto __self = LDAP::DecodedAttributeValue::__self();
    return __hlt_ldap::LDAP::__hook_DecodedAttributeValue___on_0x25_done(__self);
}

auto __hlt_ldap::LDAP::DecodedAttributeValue::__parse_LDAP__DecodedAttributeValue_8_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = DecodedAttributeValue::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:819:30-862:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::integer::safe<uint8_t> __transient__anon_30;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:822:5-822:9");

    // Begin parsing production: Variable: _anon_30_8 -> uint<8>;
    ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "expecting 1 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:822:5-822:9"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
    std::tie(__transient__anon_30, __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Variable: _anon_30_8 -> uint<8>;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:823:22-823:26");

        // Begin parsing production: Variable: attributeDesc_len_15 -> uint<8>;
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "expecting 1 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:823:22-823:26"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(::hilti::rt::optional::valueOrInit((*__self).attributeDesc_len), __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: attributeDesc_len_15 -> uint<8>;
    }

    {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_3;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:824:18-824:22");

        // Begin parsing production: Variable: attributeDesc_15 -> bytes;
        ::hilti::rt::optional::valueOrInit((*__self).attributeDesc) = ::spicy::rt::detail::extractBytes(__data, __cur, ::hilti::rt::integer::safe<uint64_t>(::hilti::rt::optional::value((*__self).attributeDesc_len)), ::hilti::rt::Bool(false), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:824:3-824:52"sv, (__lhs_3=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        __cur = __cur.advance(::hilti::rt::integer::safe<uint64_t>(::hilti::rt::optional::value((*__self).attributeDesc_len)));
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: attributeDesc_15 -> bytes;
    }

    ::hilti::rt::integer::safe<uint8_t> __transient__anon_31;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:826:5-826:9");

    // Begin parsing production: Variable: _anon_31_8 -> uint<8>;
    ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "expecting 1 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:826:5-826:9"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
    std::tie(__transient__anon_31, __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Variable: _anon_31_8 -> uint<8>;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:827:23-827:27");

        // Begin parsing production: Variable: assertionValue_len_8 -> uint<8>;
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "expecting 1 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:827:23-827:27"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(::hilti::rt::optional::valueOrInit((*__self).assertionValue_len), __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: assertionValue_len_8 -> uint<8>;
    }

    {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_4;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:828:19-828:23");

        // Begin parsing production: Variable: assertionValue_8 -> bytes;
        ::hilti::rt::optional::valueOrInit((*__self).assertionValue) = ::spicy::rt::detail::extractBytes(__data, __cur, ::hilti::rt::integer::safe<uint64_t>(::hilti::rt::optional::value((*__self).assertionValue_len)), ::hilti::rt::Bool(false), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:828:3-828:54"sv, (__lhs_4=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        __cur = __cur.advance(::hilti::rt::integer::safe<uint64_t>(::hilti::rt::optional::value((*__self).assertionValue_len)));
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: assertionValue_8 -> bytes;
    }

    ::hilti::rt::integer::safe<uint8_t> __transient__anon_32;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:831:5-831:9");
    if ( __self->__p_fType == LDAP::FilterType{LDAP::FilterType::FILTER_EXT} ) {
        // Begin parsing production: Variable: _anon_32_8 -> uint<8>;
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "expecting 1 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:831:5-831:9"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(__transient__anon_32, __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: _anon_32_8 -> uint<8>;
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:832:19-832:23");
        if ( __self->__p_fType == LDAP::FilterType{LDAP::FilterType::FILTER_EXT} ) {
            // Begin parsing production: Variable: matchValue_len_8 -> uint<8>;
            ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "expecting 1 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:832:19-832:23"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
            std::tie(::hilti::rt::optional::valueOrInit((*__self).matchValue_len), __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }

            // End parsing production: Variable: matchValue_len_8 -> uint<8>;
        }
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:833:15-833:19");
        if ( __self->__p_fType == LDAP::FilterType{LDAP::FilterType::FILTER_EXT} ) {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_5;
            // Begin parsing production: Variable: matchValue_8 -> bytes;
            ::hilti::rt::optional::valueOrInit((*__self).matchValue) = ::spicy::rt::detail::extractBytes(__data, __cur, ::hilti::rt::integer::safe<uint64_t>(::hilti::rt::optional::value((*__self).matchValue_len)), ::hilti::rt::Bool(false), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:833:3-833:85"sv, (__lhs_5=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
            __cur = __cur.advance(::hilti::rt::integer::safe<uint64_t>(::hilti::rt::optional::value((*__self).matchValue_len)));
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }

            // End parsing production: Variable: matchValue_8 -> bytes;
        }
    }

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:819:30-862:1");
    (*__self).__on_0x25_done();
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::DecodedAttributeValue::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = DecodedAttributeValue::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:819:30-862:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__DecodedAttributeValue_8_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_ldap::LDAP::DelRequest::__on_objectName(const std::string& __dd) {
    auto __self = LDAP::DelRequest::__self();
    return __hlt_ldap::LDAP::__hook_DelRequest___on_objectName(__dd, __self);
}

auto __hlt_ldap::LDAP::DelRequest::__parse_LDAP__DelRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = DelRequest::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1024:19-1028:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __parsed_objectName;

        // Begin parsing production: Unit: ASN1__ASN1Message_24 -> Resolved_510 switch_129 (field 'objectName', id n/a, parser, args: (True));
        __parsed_objectName = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed_objectName).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message_24 -> Resolved_510 switch_129 (field 'objectName', id n/a, parser, args: (True));

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __dd = __parsed_objectName;
            ::hilti::rt::optional::valueOrInit((*__self).objectName) = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).str_value);
        }

        (*__self).__error = __error;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1025:3-1027:3");
        (*__self).__on_objectName(::hilti::rt::optional::value((*__self).objectName));
        __error = (*__self).__error;
    }

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::DelRequest::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = DelRequest::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1024:19-1028:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__DelRequest_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_ldap::LDAP::DelResponse::__on__anon_38(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd) {
    auto __self = LDAP::DelResponse::__self();
    return __hlt_ldap::LDAP::__hook_DelResponse___on__anon_38(__dd, __self);
}

auto __hlt_ldap::LDAP::DelResponse::__parse_LDAP__DelResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = DelResponse::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1030:20-1034:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result> __transient__anon_38;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:117:22-127:1");

    // Begin parsing production: Unit: LDAP__Result_11 -> Resolved_522 Resolved_522 Resolved_522;
    __transient__anon_38 = (__hlt_ldap::LDAP::Result());
    std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_38).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Unit: LDAP__Result_11 -> Resolved_522 Resolved_522 Resolved_522;

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1031:3-1033:3");
    (*__self).__on__anon_38(__transient__anon_38);
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::DelResponse::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = DelResponse::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1030:20-1034:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__DelResponse_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::LDAP::EncryptedMessage::__parse_LDAP__EncryptedMessage_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = EncryptedMessage::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:220:25-223:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:221:8-221:13");

        // Begin parsing production: Variable: len_7 -> uint<32>;
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{4U}, "expecting 4 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:221:8-221:13"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(::hilti::rt::optional::valueOrInit((*__self).len), __cur) = ::hilti::rt::integer::unpack<uint32_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: len_7 -> uint<32>;
    }

    ::hilti::rt::Bytes __transient__anon_13;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:222:3-222:30");

    // Begin parsing production: Skip: _anon_13_4 -> skip: _anon_13;
    ::hilti::rt::stream::View __limited_ = __cur.limit(::hilti::rt::integer::safe<uint64_t>(::hilti::rt::optional::value((*__self).len)));
    ::hilti::rt::stream::View __ncur = __cur.advance(::hilti::rt::integer::safe<uint64_t>(::hilti::rt::optional::value((*__self).len)));
    ::hilti::rt::integer::safe<uint64_t> __skip = ::hilti::rt::integer::safe<uint64_t>(::hilti::rt::optional::value((*__self).len));
    while ( __skip > ::hilti::rt::integer::safe<std::uint64_t>{0U} ) {
        ::spicy::rt::detail::waitForInput(__data, __limited_, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "not enough bytes for skipping"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:222:3-222:30"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        ::hilti::rt::integer::safe<uint64_t> __consume = (__limited_.size() <= __skip ? __limited_.size() : __skip);
        __limited_ = __limited_.advance(__consume);
        if ( __trim ) {
            (*__data).trim(__limited_.begin());
        }

        __skip = __skip - __consume;
    }

    if ( __limited_.offset() < __ncur.offset() ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:222:16-222:29");
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("&size amount not consumed: expected %lu bytes, but got %lu bytes"sv, ::hilti::rt::integer::safe<uint64_t>(::hilti::rt::optional::value((*__self).len)), __limited_.offset() - (__ncur.offset() - ::hilti::rt::integer::safe<uint64_t>(::hilti::rt::optional::value((*__self).len)))), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:222:16-222:29");
    }

    // End parsing production: Skip: _anon_13_4 -> skip: _anon_13;

    __cur = __ncur;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::EncryptedMessage::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = EncryptedMessage::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:220:25-223:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__EncryptedMessage_4_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_ldap::LDAP::ExtendedRequest::__on_0x25_done() {
    auto __self = LDAP::ExtendedRequest::__self();
    return __hlt_ldap::LDAP::__hook_ExtendedRequest___on_0x25_done(__self);
}

inline void __hlt_ldap::LDAP::ExtendedRequest::__on__anon_59(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd) {
    auto __self = LDAP::ExtendedRequest::__self();
    return __hlt_ldap::LDAP::__hook_ExtendedRequest___on__anon_59(__dd, __self);
}

inline void __hlt_ldap::LDAP::ExtendedRequest::__on_requestName(const std::string& __dd) {
    auto __self = LDAP::ExtendedRequest::__self();
    return __hlt_ldap::LDAP::__hook_ExtendedRequest___on_requestName(__dd, __self);
}

auto __hlt_ldap::LDAP::ExtendedRequest::__parse_LDAP__ExtendedRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ExtendedRequest::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1079:24-1101:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:198:26-201:1");

        // Begin parsing production: Unit: ASN1__ASN1Header_32 -> Resolved_573 Resolved_574;
        ::hilti::rt::optional::valueOrInit((*__self).header) = (__hlt_ldap::ASN1::ASN1Header());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).header)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Header_32 -> Resolved_573 Resolved_574;

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header> __dd = ::hilti::rt::optional::value((*__self).header);
            ::hilti::rt::Result<::hilti::rt::Nothing> __requires = (((::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).tag))._anon_46).value))) == ASN1::ASN1Class{ASN1::ASN1Class::ContextSpecific}) ? ::hilti::rt::make_result(::hilti::rt::Nothing{}) : ::hilti::rt::result::Error("&requires failed: ($$.tag._anon_46.class == ASN1::ASN1Class::ContextSpecific)"));
            if ( ! (::hilti::rt::Bool(static_cast<bool>(__requires))) ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1081:28-1081:87");
                throw ::spicy::rt::ParseError(__requires.errorOrThrow(), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1081:28-1081:87");
            }
        }

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
    }

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_6;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1082:16-1082:20");
        ::hilti::rt::Bytes __parsed_requestName;

        // Begin parsing production: Variable: requestName_6 -> bytes;
        __parsed_requestName = ::spicy::rt::detail::extractBytes(__data, __cur, (*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).header)).len)).len, ::hilti::rt::Bool(false), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1082:3-1084:3"sv, (__lhs_6=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        __cur = __cur.advance((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).header)).len)).len);
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: requestName_6 -> bytes;

        {
            ::hilti::rt::Bytes __dd = __parsed_requestName;
            ::hilti::rt::optional::valueOrInit((*__self).requestName) = __dd.decode(::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::ASCII}, ::hilti::rt::bytes::DecodeErrorStrategy{::hilti::rt::bytes::DecodeErrorStrategy::REPLACE});
        }

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1082:3-1084:3");
        (*__self).__on_requestName(::hilti::rt::optional::value((*__self).requestName));

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
    }

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __transient__anon_59;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
    if ( (*__self->__p_message.derefAsValue()).opLen > (*__self).__offset ) {
        // Begin parsing production: Unit: ASN1__ASN1Message_29 -> Resolved_572 switch_144 (field '_anon_59', id n/a, parser, args: (False));
        __transient__anon_59 = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(false)));
        std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_59).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message_29 -> Resolved_572 switch_144 (field '_anon_59', id n/a, parser, args: (False));

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __dd = __transient__anon_59;
            ::hilti::rt::Result<::hilti::rt::Nothing> __requires = (((::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).head)).tag))._anon_46).value))) == ASN1::ASN1Class{ASN1::ASN1Class::ContextSpecific}) ? ::hilti::rt::make_result(::hilti::rt::Nothing{}) : ::hilti::rt::result::Error("&requires failed: ($$.head.tag._anon_46.class == ASN1::ASN1Class::ContextSpecific)"));
            if ( ! (::hilti::rt::Bool(static_cast<bool>(__requires))) ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1088:7-1088:71");
                throw ::spicy::rt::ParseError(__requires.errorOrThrow(), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1088:7-1088:71");
            }
        }

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1087:3-1092:3");
        (*__self).__on__anon_59(__transient__anon_59);

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
    }

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1079:24-1101:1");
    (*__self).__on_0x25_done();

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::ExtendedRequest::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ExtendedRequest::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1079:24-1101:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    try {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__ExtendedRequest_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }
    catch ( const ::std::exception& __except ) {

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
        throw;
    }

    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;
    return __result;
}

inline void __hlt_ldap::LDAP::ExtendedResponse::__on_0x25_done() {
    auto __self = LDAP::ExtendedResponse::__self();
    return __hlt_ldap::LDAP::__hook_ExtendedResponse___on_0x25_done(__self);
}

inline void __hlt_ldap::LDAP::ExtendedResponse::__on__anon_41(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd) {
    auto __self = LDAP::ExtendedResponse::__self();
    return __hlt_ldap::LDAP::__hook_ExtendedResponse___on__anon_41(__dd, __self);
}

auto __hlt_ldap::LDAP::ExtendedResponse::__parse_LDAP__ExtendedResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ExtendedResponse::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1116:25-1133:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result> __transient__anon_41;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:117:22-127:1");

    // Begin parsing production: Unit: LDAP__Result_14 -> Resolved_597 Resolved_597 Resolved_597;
    __transient__anon_41 = (__hlt_ldap::LDAP::Result());
    std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_41).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Unit: LDAP__Result_14 -> Resolved_597 Resolved_597 Resolved_597;

    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1119:3-1121:3");
    (*__self).__on__anon_41(__transient__anon_41);

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    ::hilti::rt::ValueReference<__hlt_ldap::LDAP::ExtendedResponseEntry> __transient__anon_42;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1104:30-1113:1");
    if ( (*__self->__p_message.derefAsValue()).opLen > (*__self).__offset ) {
        // Begin parsing production: Unit: LDAP__ExtendedResponseEntry_7 -> Resolved_597 (field '_anon_42', id n/a, parser, args: (self));
        __transient__anon_42 = (__hlt_ldap::LDAP::ExtendedResponseEntry(__self));
        std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_42).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: LDAP__ExtendedResponseEntry_7 -> Resolved_597 (field '_anon_42', id n/a, parser, args: (self));
    }

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    ::hilti::rt::ValueReference<__hlt_ldap::LDAP::ExtendedResponseEntry> __transient__anon_43;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1104:30-1113:1");
    if ( (*__self->__p_message.derefAsValue()).opLen > (*__self).__offset ) {
        // Begin parsing production: Unit: LDAP__ExtendedResponseEntry_7 -> Resolved_597 (field '_anon_42', id n/a, parser, args: (self));
        __transient__anon_43 = (__hlt_ldap::LDAP::ExtendedResponseEntry(__self));
        std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_43).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: LDAP__ExtendedResponseEntry_7 -> Resolved_597 (field '_anon_42', id n/a, parser, args: (self));
    }

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1116:25-1133:1");
    (*__self).__on_0x25_done();

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::ExtendedResponse::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ExtendedResponse::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1116:25-1133:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    try {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__ExtendedResponse_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }
    catch ( const ::std::exception& __except ) {

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
        throw;
    }

    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;
    return __result;
}

inline void __hlt_ldap::LDAP::ExtendedResponseEntry::__on__anon_60(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd) {
    auto __self = LDAP::ExtendedResponseEntry::__self();
    return __hlt_ldap::LDAP::__hook_ExtendedResponseEntry___on__anon_60(__dd, __self);
}

auto __hlt_ldap::LDAP::ExtendedResponseEntry::__parse_LDAP__ExtendedResponseEntry_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ExtendedResponseEntry::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1104:30-1113:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __transient__anon_60;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");

    // Begin parsing production: Unit: ASN1__ASN1Message_30 -> Resolved_585 switch_147 (field '_anon_60', id n/a, parser, args: (False));
    __transient__anon_60 = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(false)));
    std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_60).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Unit: ASN1__ASN1Message_30 -> Resolved_585 switch_147 (field '_anon_60', id n/a, parser, args: (False));

    {
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __dd = __transient__anon_60;
        ::hilti::rt::Result<::hilti::rt::Nothing> __requires = (((::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).head)).tag))._anon_46).value))) == ASN1::ASN1Class{ASN1::ASN1Class::ContextSpecific}) ? ::hilti::rt::make_result(::hilti::rt::Nothing{}) : ::hilti::rt::result::Error("&requires failed: ($$.head.tag._anon_46.class == ASN1::ASN1Class::ContextSpecific)"));
        if ( ! (::hilti::rt::Bool(static_cast<bool>(__requires))) ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1105:30-1105:94");
            throw ::spicy::rt::ParseError(__requires.errorOrThrow(), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1105:30-1105:94");
        }
    }

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1105:3-1112:3");
    (*__self).__on__anon_60(__transient__anon_60);
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::ExtendedResponseEntry::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ExtendedResponseEntry::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1104:30-1113:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__ExtendedResponseEntry_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::LDAP::GSS_SPNEGO_Init::__parse_LDAP__GSS_SPNEGO_Init_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = GSS_SPNEGO_Init::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:380:24-401:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:198:26-201:1");

        // Begin parsing production: Unit: ASN1__ASN1Header_8 -> Resolved_261 Resolved_262;
        ::hilti::rt::optional::valueOrInit((*__self).credentialsHeader) = (__hlt_ldap::ASN1::ASN1Header());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).credentialsHeader)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Header_8 -> Resolved_261 Resolved_262;

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header> __dd = ::hilti::rt::optional::value((*__self).credentialsHeader);
            ::hilti::rt::Result<::hilti::rt::Nothing> __requires = (((::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).tag))._anon_46).value))) == ASN1::ASN1Type{ASN1::ASN1Type::OctetString}) ? ::hilti::rt::make_result(::hilti::rt::Nothing{}) : ::hilti::rt::result::Error("&requires failed: ($$.tag._anon_46.type_ == ASN1::ASN1Type::OctetString)"));
            if ( ! (::hilti::rt::Bool(static_cast<bool>(__requires))) ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:382:39-382:93");
                throw ::spicy::rt::ParseError(__requires.errorOrThrow(), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:382:39-382:93");
            }
        }

    }

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:394:5-394:38");

    // Begin parsing production: LookAhead: switch_62_lha_3 -> {Ctor: spnegoChoiceByte_11 -> uint8(161) (uint<8>) (id 1), Ctor: spnegoInitByte_6 -> uint8(96) (uint<8>) (id 2)}: switch_62_lha_2 | {Skip: ntlmSignature_12 -> skip:            Ctor: ntlmSignature_11 -> b"NTLMSSP" (const bytes) (id 3)}: switch_62_case_3;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_62_lha_3_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: LookAhead: switch_62_lha_3 -> {Ctor: spnegoChoiceByte_11 -> uint8(161) (uint<8>) (id 1), Ctor: spnegoInitByte_6 -> uint8(96) (uint<8>) (id 2)}: switch_62_lha_2 | {Skip: ntlmSignature_12 -> skip:            Ctor: ntlmSignature_11 -> b"NTLMSSP" (const bytes) (id 3)}: switch_62_case_3;

    ::hilti::rt::ValueReference<__hlt_ldap::ASN1::LengthType> __transient_spnegoLen;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:67:19-88:1");
        if ( ((*__self).spnegoInitByte.has_value()) || ((*__self).spnegoChoiceByte.has_value()) ) {
            // Begin parsing production: Unit: ASN1__LengthType_8 -> data_15 switch_61;
            __transient_spnegoLen = (__hlt_ldap::ASN1::LengthType());
            std::tie(__cur, __lah, __lahe, __error) = (*__transient_spnegoLen).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: ASN1__LengthType_8 -> data_15 switch_61;
        }
    }

    ::hilti::rt::ValueReference<__hlt_ldap::LDAP::GSS_SPNEGO_negTokenInit> __transient_spnegoInitial;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:370:32-376:1");
        if ( (*__self).spnegoInitByte.has_value() ) {
            // Begin parsing production: Unit: LDAP__GSS_SPNEGO_negTokenInit_7 -> Resolved_260 Resolved_264 _anon_23_7;
            __transient_spnegoInitial = (__hlt_ldap::LDAP::GSS_SPNEGO_negTokenInit());
            std::tie(__cur, __lah, __lahe, __error) = (*__transient_spnegoInitial).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__GSS_SPNEGO_negTokenInit_7 -> Resolved_260 Resolved_264 _anon_23_7;
        }
    }

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::GSS_SPNEGO_Init::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = GSS_SPNEGO_Init::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:380:24-401:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__GSS_SPNEGO_Init_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::LDAP::GSS_SPNEGO_Init::__parse_switch_62_lha_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = GSS_SPNEGO_Init::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:393:5-393:37");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    if ( ! (::hilti::rt::Bool(static_cast<bool>(__lah))) ) {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_7;
        if ( ::spicy::rt::detail::atEod(__data, __cur, (__lhs_7=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
            __lah = ::hilti::rt::integer::safe<std::int64_t>{-1};
        }
        else {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_8;::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_9;
            ::hilti::rt::stream::View __ocur = __cur;
            ::hilti::rt::integer::safe<uint8_t> __x;
            ::hilti::rt::Result<::hilti::rt::integer::safe<uint8_t>> __result;
            if ( ::spicy::rt::detail::waitForInputOrEod(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, (__lhs_8=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
                std::tie(__result, __cur) = std::make_tuple(::hilti::rt::Result<::hilti::rt::integer::safe<uint8_t>>(std::get<0>(::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow())), std::get<1>(::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow()));
            }

            ::hilti::rt::stream::View __ncur = __cur;
            __cur = __ocur;
            ::hilti::rt::stream::SafeConstIterator __literal = ((::hilti::rt::Bool(static_cast<bool>(__result))) && ((__ocur.offset() != __ncur.offset()) && (__result.valueOrThrow() == ::hilti::rt::integer::safe<std::uint8_t>{161U})) ? __ncur : __ocur).begin();
            if ( __literal != __cur.begin() ) {
                __lah = ::hilti::rt::integer::safe<std::int64_t>{1};
                __lahe = __literal;
            }

            ::spicy::rt::detail::printParserState("LDAP::GSS_SPNEGO_Init"sv, __data, std::optional<::hilti::rt::stream::SafeConstIterator>(__begin), __cur, __lah, __lahe, "default"sv, __trim, __error);
            ::hilti::rt::stream::View __ocur_2 = __cur;
            ::hilti::rt::integer::safe<uint8_t> __x_2;
            ::hilti::rt::Result<::hilti::rt::integer::safe<uint8_t>> __result_2;
            if ( ::spicy::rt::detail::waitForInputOrEod(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, (__lhs_9=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
                std::tie(__result_2, __cur) = std::make_tuple(::hilti::rt::Result<::hilti::rt::integer::safe<uint8_t>>(std::get<0>(::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow())), std::get<1>(::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow()));
            }

            ::hilti::rt::stream::View __ncur_2 = __cur;
            __cur = __ocur_2;
            ::hilti::rt::stream::SafeConstIterator __literal_2 = ((::hilti::rt::Bool(static_cast<bool>(__result_2))) && ((__ocur_2.offset() != __ncur_2.offset()) && (__result_2.valueOrThrow() == ::hilti::rt::integer::safe<std::uint8_t>{96U})) ? __ncur_2 : __ocur_2).begin();
            if ( ::hilti::rt::stream::SafeConstIterator i = __literal_2; (i != __cur.begin()) && (i >= __lahe) ) {
                if ( (__lah != ::hilti::rt::integer::safe<std::int64_t>{0}) && (i == __lahe) ) {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:393:5-393:37");
                    throw ::spicy::rt::ParseError("ambiguous look-ahead token match"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:393:5-393:37");
                }

                __lah = ::hilti::rt::integer::safe<std::int64_t>{2};
                __lahe = i;
            }

            ::spicy::rt::detail::printParserState("LDAP::GSS_SPNEGO_Init"sv, __data, std::optional<::hilti::rt::stream::SafeConstIterator>(__begin), __cur, __lah, __lahe, "default"sv, __trim, __error);
        }
    }

    if ( ::hilti::rt::integer::safe<int64_t> __x = __lah; __x == ::hilti::rt::integer::safe<std::int64_t>{2} ) {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:392:5-392:35");

        // Begin parsing production: Block: switch_62_case_1 -> spnegoInitByte_6;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:392:24-392:34");

            // Begin parsing production: Ctor: spnegoInitByte_6 -> uint8(96) (uint<8>);
            if ( ::hilti::rt::Bool(static_cast<bool>(__lah)) ) {
                if ( __lah != ::hilti::rt::integer::safe<std::int64_t>{2} ) {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:392:24-392:34");
                    throw ::spicy::rt::ParseError("unexpected token to consume"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:392:24-392:34");
                }

                __lah = ::hilti::rt::integer::safe<std::int64_t>{0};
                __cur = __cur.advance(__lahe);
                if ( __trim ) {
                    (*__data).trim(__cur.begin());
                }
            }
            else {
                ::hilti::rt::stream::View __ocur = __cur;
                ::hilti::rt::integer::safe<uint8_t> __x;
                ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "expecting 1 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:392:24-392:34"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
                std::tie(__x, __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
                if ( (__ocur.offset() == __cur.offset()) || (__x != ::hilti::rt::integer::safe<std::uint8_t>{96U}) ) {
                    __cur = __ocur;
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:392:24-392:34");
                    throw ::spicy::rt::ParseError("expecting uint8(96)"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:392:24-392:34");
                }
            }

            ::hilti::rt::optional::valueOrInit((*__self).spnegoInitByte) = ::hilti::rt::integer::safe<std::uint8_t>{96U};
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }

            // End parsing production: Ctor: spnegoInitByte_6 -> uint8(96) (uint<8>);
        }

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_62_case_1 -> spnegoInitByte_6;
    }

    else if ( __x == ::hilti::rt::integer::safe<std::int64_t>{1} ) {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:393:5-393:37");

        // Begin parsing production: Block: switch_62_case_2 -> spnegoChoiceByte_11;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:393:26-393:36");

            // Begin parsing production: Ctor: spnegoChoiceByte_11 -> uint8(161) (uint<8>);
            if ( ::hilti::rt::Bool(static_cast<bool>(__lah)) ) {
                if ( __lah != ::hilti::rt::integer::safe<std::int64_t>{1} ) {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:393:26-393:36");
                    throw ::spicy::rt::ParseError("unexpected token to consume"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:393:26-393:36");
                }

                __lah = ::hilti::rt::integer::safe<std::int64_t>{0};
                __cur = __cur.advance(__lahe);
                if ( __trim ) {
                    (*__data).trim(__cur.begin());
                }
            }
            else {
                ::hilti::rt::stream::View __ocur = __cur;
                ::hilti::rt::integer::safe<uint8_t> __x;
                ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "expecting 1 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:393:26-393:36"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
                std::tie(__x, __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
                if ( (__ocur.offset() == __cur.offset()) || (__x != ::hilti::rt::integer::safe<std::uint8_t>{161U}) ) {
                    __cur = __ocur;
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:393:26-393:36");
                    throw ::spicy::rt::ParseError("expecting uint8(161)"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:393:26-393:36");
                }
            }

            ::hilti::rt::optional::valueOrInit((*__self).spnegoChoiceByte) = ::hilti::rt::integer::safe<std::uint8_t>{161U};
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }

            // End parsing production: Ctor: spnegoChoiceByte_11 -> uint8(161) (uint<8>);
        }

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_62_case_2 -> spnegoChoiceByte_11;
    }

    else if ( __x == ::hilti::rt::integer::safe<std::int64_t>{-1} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:393:5-393:37");
        throw ::spicy::rt::ParseError("expected look-ahead token, but reached end-of-data"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:393:5-393:37");
    }

    else  {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:393:5-393:37");
        throw ::spicy::rt::ParseError("no expected look-ahead token found"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:393:5-393:37");
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::GSS_SPNEGO_Init::__parse_switch_62_lha_3_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = GSS_SPNEGO_Init::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:394:5-394:38");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    if ( ! (::hilti::rt::Bool(static_cast<bool>(__lah))) ) {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_10;
        if ( ::spicy::rt::detail::atEod(__data, __cur, (__lhs_10=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
            __lah = ::hilti::rt::integer::safe<std::int64_t>{-1};
        }
        else {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_11;::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_12;::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_13;
            ::hilti::rt::stream::SafeConstIterator __literal = ((::spicy::rt::detail::waitForInputOrEod(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{7U}, (__lhs_11=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())))) && (__cur.startsWith(__hlt_ldap::LDAP::__ctor__bytes_2)) ? __cur.begin() + ::hilti::rt::integer::safe<std::uint64_t>{7U} : __cur.begin());
            if ( __literal != __cur.begin() ) {
                __lah = ::hilti::rt::integer::safe<std::int64_t>{3};
                __lahe = __literal;
            }

            ::spicy::rt::detail::printParserState("LDAP::GSS_SPNEGO_Init"sv, __data, std::optional<::hilti::rt::stream::SafeConstIterator>(__begin), __cur, __lah, __lahe, "default"sv, __trim, __error);
            ::hilti::rt::stream::View __ocur = __cur;
            ::hilti::rt::integer::safe<uint8_t> __x;
            ::hilti::rt::Result<::hilti::rt::integer::safe<uint8_t>> __result;
            if ( ::spicy::rt::detail::waitForInputOrEod(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, (__lhs_12=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
                std::tie(__result, __cur) = std::make_tuple(::hilti::rt::Result<::hilti::rt::integer::safe<uint8_t>>(std::get<0>(::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow())), std::get<1>(::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow()));
            }

            ::hilti::rt::stream::View __ncur = __cur;
            __cur = __ocur;
            ::hilti::rt::stream::SafeConstIterator __literal_2 = ((::hilti::rt::Bool(static_cast<bool>(__result))) && ((__ocur.offset() != __ncur.offset()) && (__result.valueOrThrow() == ::hilti::rt::integer::safe<std::uint8_t>{161U})) ? __ncur : __ocur).begin();
            if ( ::hilti::rt::stream::SafeConstIterator i = __literal_2; (i != __cur.begin()) && (i >= __lahe) ) {
                if ( (__lah != ::hilti::rt::integer::safe<std::int64_t>{0}) && (i == __lahe) ) {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:394:5-394:38");
                    throw ::spicy::rt::ParseError("ambiguous look-ahead token match"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:394:5-394:38");
                }

                __lah = ::hilti::rt::integer::safe<std::int64_t>{1};
                __lahe = i;
            }

            ::spicy::rt::detail::printParserState("LDAP::GSS_SPNEGO_Init"sv, __data, std::optional<::hilti::rt::stream::SafeConstIterator>(__begin), __cur, __lah, __lahe, "default"sv, __trim, __error);
            ::hilti::rt::stream::View __ocur_2 = __cur;
            ::hilti::rt::integer::safe<uint8_t> __x_2;
            ::hilti::rt::Result<::hilti::rt::integer::safe<uint8_t>> __result_2;
            if ( ::spicy::rt::detail::waitForInputOrEod(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, (__lhs_13=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
                std::tie(__result_2, __cur) = std::make_tuple(::hilti::rt::Result<::hilti::rt::integer::safe<uint8_t>>(std::get<0>(::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow())), std::get<1>(::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow()));
            }

            ::hilti::rt::stream::View __ncur_2 = __cur;
            __cur = __ocur_2;
            ::hilti::rt::stream::SafeConstIterator __literal_3 = ((::hilti::rt::Bool(static_cast<bool>(__result_2))) && ((__ocur_2.offset() != __ncur_2.offset()) && (__result_2.valueOrThrow() == ::hilti::rt::integer::safe<std::uint8_t>{96U})) ? __ncur_2 : __ocur_2).begin();
            if ( ::hilti::rt::stream::SafeConstIterator i = __literal_3; (i != __cur.begin()) && (i >= __lahe) ) {
                if ( (__lah != ::hilti::rt::integer::safe<std::int64_t>{0}) && (i == __lahe) ) {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:394:5-394:38");
                    throw ::spicy::rt::ParseError("ambiguous look-ahead token match"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:394:5-394:38");
                }

                __lah = ::hilti::rt::integer::safe<std::int64_t>{2};
                __lahe = i;
            }

            ::spicy::rt::detail::printParserState("LDAP::GSS_SPNEGO_Init"sv, __data, std::optional<::hilti::rt::stream::SafeConstIterator>(__begin), __cur, __lah, __lahe, "default"sv, __trim, __error);
        }
    }

    if ( ::hilti::rt::integer::safe<int64_t> __x = __lah; __x == ::hilti::rt::integer::safe<std::int64_t>{1} || __x == ::hilti::rt::integer::safe<std::int64_t>{2} ) {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:393:5-393:37");

        // Begin parsing production: LookAhead: switch_62_lha_2 -> {Ctor: spnegoInitByte_6 -> uint8(96) (uint<8>) (id 2)}: switch_62_case_1 | {Ctor: spnegoChoiceByte_11 -> uint8(161) (uint<8>) (id 1)}: switch_62_case_2;
        std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_62_lha_2_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: LookAhead: switch_62_lha_2 -> {Ctor: spnegoInitByte_6 -> uint8(96) (uint<8>) (id 2)}: switch_62_case_1 | {Ctor: spnegoChoiceByte_11 -> uint8(161) (uint<8>) (id 1)}: switch_62_case_2;
    }

    else if ( __x == ::hilti::rt::integer::safe<std::int64_t>{3} ) {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:394:5-394:38");

        // Begin parsing production: Block: switch_62_case_3 -> ntlmSignature_12;
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::Bytes __transient_ntlmSignature;

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:394:8-394:38");

            // Begin parsing production: Skip: ntlmSignature_12 -> skip:            Ctor: ntlmSignature_11 -> b"NTLMSSP" (const bytes);
            if ( ::hilti::rt::Bool(static_cast<bool>(__lah)) ) {
                if ( __lah != ::hilti::rt::integer::safe<std::int64_t>{3} ) {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:394:28-394:37");
                    throw ::spicy::rt::ParseError("unexpected token to consume"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:394:28-394:37");
                }

                if ( __cur.sub(__cur.begin(), __lahe) != __hlt_ldap::LDAP::__ctor__bytes_2 ) {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:394:28-394:37");
                    throw ::spicy::rt::ParseError("unexpected data when consuming token"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:394:28-394:37");
                }

                __lah = ::hilti::rt::integer::safe<std::int64_t>{0};
                __cur = __cur.advance(__lahe);
                if ( __trim ) {
                    (*__data).trim(__cur.begin());
                }
            }
            else {
                ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_14;
                ::spicy::rt::detail::expectBytesLiteral(__data, __cur, __hlt_ldap::LDAP::__ctor__bytes_2, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:394:28-394:37"sv, (__lhs_14=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
                __cur = __cur.advance(::hilti::rt::integer::safe<std::uint64_t>{7U});
                if ( __trim ) {
                    (*__data).trim(__cur.begin());
                }
            }

            // End parsing production: Skip: ntlmSignature_12 -> skip:            Ctor: ntlmSignature_11 -> b"NTLMSSP" (const bytes);
        }

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_62_case_3 -> ntlmSignature_12;
    }

    else if ( __x == ::hilti::rt::integer::safe<std::int64_t>{-1} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:394:5-394:38");
        throw ::spicy::rt::ParseError("expected look-ahead token, but reached end-of-data"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:394:5-394:38");
    }

    else  {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:394:5-394:38");
        throw ::spicy::rt::ParseError("no expected look-ahead token found"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:394:5-394:38");
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::GSS_SPNEGO_Subsequent::__parse_LDAP__GSS_SPNEGO_Subsequent_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = GSS_SPNEGO_Subsequent::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:413:30-421:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:416:5-416:38");

    // Begin parsing production: LookAhead: switch_68_lha_2 -> {Ctor: spnegoChoiceByte_13 -> uint8(161) (uint<8>) (id 1)}: switch_68_case_1 | {Skip: ntmlSignature_12 -> skip:            Ctor: ntmlSignature_11 -> b"NTLMSSP" (const bytes) (id 3)}: switch_68_case_2;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_68_lha_2_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: LookAhead: switch_68_lha_2 -> {Ctor: spnegoChoiceByte_13 -> uint8(161) (uint<8>) (id 1)}: switch_68_case_1 | {Skip: ntmlSignature_12 -> skip:            Ctor: ntmlSignature_11 -> b"NTLMSSP" (const bytes) (id 3)}: switch_68_case_2;

    ::hilti::rt::ValueReference<__hlt_ldap::ASN1::LengthType> __transient_spnegoChoiceLen;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:67:19-88:1");
        if ( (*__self).spnegoChoiceByte.has_value() ) {
            // Begin parsing production: Unit: ASN1__LengthType_10 -> data_19 switch_69;
            __transient_spnegoChoiceLen = (__hlt_ldap::ASN1::LengthType());
            std::tie(__cur, __lah, __lahe, __error) = (*__transient_spnegoChoiceLen).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: ASN1__LengthType_10 -> data_19 switch_69;
        }
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:423:32-449:1");
        if ( (*__self).spnegoChoiceByte.has_value() ) {
            // Begin parsing production: Unit: LDAP__GSS_SPNEGO_negTokenResp_6 -> Resolved_283 switch_72;
            ::hilti::rt::optional::valueOrInit((*__self).negTokenResp) = (__hlt_ldap::LDAP::GSS_SPNEGO_negTokenResp());
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).negTokenResp)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__GSS_SPNEGO_negTokenResp_6 -> Resolved_283 switch_72;
        }
    }

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::GSS_SPNEGO_Subsequent::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = GSS_SPNEGO_Subsequent::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:413:30-421:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__GSS_SPNEGO_Subsequent_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::LDAP::GSS_SPNEGO_Subsequent::__parse_switch_68_lha_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = GSS_SPNEGO_Subsequent::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:416:5-416:38");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    if ( ! (::hilti::rt::Bool(static_cast<bool>(__lah))) ) {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_15;
        if ( ::spicy::rt::detail::atEod(__data, __cur, (__lhs_15=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
            __lah = ::hilti::rt::integer::safe<std::int64_t>{-1};
        }
        else {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_16;::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_17;
            ::hilti::rt::stream::SafeConstIterator __literal = ((::spicy::rt::detail::waitForInputOrEod(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{7U}, (__lhs_16=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())))) && (__cur.startsWith(__hlt_ldap::LDAP::__ctor__bytes_2)) ? __cur.begin() + ::hilti::rt::integer::safe<std::uint64_t>{7U} : __cur.begin());
            if ( __literal != __cur.begin() ) {
                __lah = ::hilti::rt::integer::safe<std::int64_t>{3};
                __lahe = __literal;
            }

            ::spicy::rt::detail::printParserState("LDAP::GSS_SPNEGO_Subsequent"sv, __data, std::optional<::hilti::rt::stream::SafeConstIterator>(__begin), __cur, __lah, __lahe, "default"sv, __trim, __error);
            ::hilti::rt::stream::View __ocur = __cur;
            ::hilti::rt::integer::safe<uint8_t> __x;
            ::hilti::rt::Result<::hilti::rt::integer::safe<uint8_t>> __result;
            if ( ::spicy::rt::detail::waitForInputOrEod(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, (__lhs_17=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
                std::tie(__result, __cur) = std::make_tuple(::hilti::rt::Result<::hilti::rt::integer::safe<uint8_t>>(std::get<0>(::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow())), std::get<1>(::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow()));
            }

            ::hilti::rt::stream::View __ncur = __cur;
            __cur = __ocur;
            ::hilti::rt::stream::SafeConstIterator __literal_2 = ((::hilti::rt::Bool(static_cast<bool>(__result))) && ((__ocur.offset() != __ncur.offset()) && (__result.valueOrThrow() == ::hilti::rt::integer::safe<std::uint8_t>{161U})) ? __ncur : __ocur).begin();
            if ( ::hilti::rt::stream::SafeConstIterator i = __literal_2; (i != __cur.begin()) && (i >= __lahe) ) {
                if ( (__lah != ::hilti::rt::integer::safe<std::int64_t>{0}) && (i == __lahe) ) {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:416:5-416:38");
                    throw ::spicy::rt::ParseError("ambiguous look-ahead token match"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:416:5-416:38");
                }

                __lah = ::hilti::rt::integer::safe<std::int64_t>{1};
                __lahe = i;
            }

            ::spicy::rt::detail::printParserState("LDAP::GSS_SPNEGO_Subsequent"sv, __data, std::optional<::hilti::rt::stream::SafeConstIterator>(__begin), __cur, __lah, __lahe, "default"sv, __trim, __error);
        }
    }

    if ( ::hilti::rt::integer::safe<int64_t> __x = __lah; __x == ::hilti::rt::integer::safe<std::int64_t>{1} ) {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:415:5-415:37");

        // Begin parsing production: Block: switch_68_case_1 -> spnegoChoiceByte_13;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:415:26-415:36");

            // Begin parsing production: Ctor: spnegoChoiceByte_13 -> uint8(161) (uint<8>);
            if ( ::hilti::rt::Bool(static_cast<bool>(__lah)) ) {
                if ( __lah != ::hilti::rt::integer::safe<std::int64_t>{1} ) {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:415:26-415:36");
                    throw ::spicy::rt::ParseError("unexpected token to consume"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:415:26-415:36");
                }

                __lah = ::hilti::rt::integer::safe<std::int64_t>{0};
                __cur = __cur.advance(__lahe);
                if ( __trim ) {
                    (*__data).trim(__cur.begin());
                }
            }
            else {
                ::hilti::rt::stream::View __ocur = __cur;
                ::hilti::rt::integer::safe<uint8_t> __x;
                ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "expecting 1 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:415:26-415:36"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
                std::tie(__x, __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
                if ( (__ocur.offset() == __cur.offset()) || (__x != ::hilti::rt::integer::safe<std::uint8_t>{161U}) ) {
                    __cur = __ocur;
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:415:26-415:36");
                    throw ::spicy::rt::ParseError("expecting uint8(161)"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:415:26-415:36");
                }
            }

            ::hilti::rt::optional::valueOrInit((*__self).spnegoChoiceByte) = ::hilti::rt::integer::safe<std::uint8_t>{161U};
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }

            // End parsing production: Ctor: spnegoChoiceByte_13 -> uint8(161) (uint<8>);
        }

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_68_case_1 -> spnegoChoiceByte_13;
    }

    else if ( __x == ::hilti::rt::integer::safe<std::int64_t>{3} ) {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:416:5-416:38");

        // Begin parsing production: Block: switch_68_case_2 -> ntmlSignature_12;
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::Bytes __transient_ntmlSignature;

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:416:8-416:38");

            // Begin parsing production: Skip: ntmlSignature_12 -> skip:            Ctor: ntmlSignature_11 -> b"NTLMSSP" (const bytes);
            if ( ::hilti::rt::Bool(static_cast<bool>(__lah)) ) {
                if ( __lah != ::hilti::rt::integer::safe<std::int64_t>{3} ) {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:416:28-416:37");
                    throw ::spicy::rt::ParseError("unexpected token to consume"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:416:28-416:37");
                }

                if ( __cur.sub(__cur.begin(), __lahe) != __hlt_ldap::LDAP::__ctor__bytes_2 ) {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:416:28-416:37");
                    throw ::spicy::rt::ParseError("unexpected data when consuming token"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:416:28-416:37");
                }

                __lah = ::hilti::rt::integer::safe<std::int64_t>{0};
                __cur = __cur.advance(__lahe);
                if ( __trim ) {
                    (*__data).trim(__cur.begin());
                }
            }
            else {
                ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_18;
                ::spicy::rt::detail::expectBytesLiteral(__data, __cur, __hlt_ldap::LDAP::__ctor__bytes_2, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:416:28-416:37"sv, (__lhs_18=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
                __cur = __cur.advance(::hilti::rt::integer::safe<std::uint64_t>{7U});
                if ( __trim ) {
                    (*__data).trim(__cur.begin());
                }
            }

            // End parsing production: Skip: ntmlSignature_12 -> skip:            Ctor: ntmlSignature_11 -> b"NTLMSSP" (const bytes);
        }

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_68_case_2 -> ntmlSignature_12;
    }

    else if ( __x == ::hilti::rt::integer::safe<std::int64_t>{-1} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:416:5-416:38");
        throw ::spicy::rt::ParseError("expected look-ahead token, but reached end-of-data"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:416:5-416:38");
    }

    else  {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:416:5-416:38");
        throw ::spicy::rt::ParseError("no expected look-ahead token found"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:416:5-416:38");
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::GSS_SPNEGO_negTokenInit::__parse_LDAP__GSS_SPNEGO_negTokenInit_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_19;
    auto __self = GSS_SPNEGO_negTokenInit::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:370:32-376:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:198:26-201:1");

        // Begin parsing production: Unit: ASN1__ASN1Header_7 -> Resolved_255 Resolved_256;
        ::hilti::rt::optional::valueOrInit((*__self).oidHeader) = (__hlt_ldap::ASN1::ASN1Header());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).oidHeader)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Header_7 -> Resolved_255 Resolved_256;

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header> __dd = ::hilti::rt::optional::value((*__self).oidHeader);
            ::hilti::rt::Result<::hilti::rt::Nothing> __requires = ((((::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).tag))._anon_46).value))) == ASN1::ASN1Class{ASN1::ASN1Class::Universal}) && ((::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).tag))._anon_46).value))) == ASN1::ASN1Type{ASN1::ASN1Type::ObjectIdentifier})) ? ::hilti::rt::make_result(::hilti::rt::Nothing{}) : ::hilti::rt::result::Error("&requires failed: ($$.tag.class == ASN1::ASN1Class::Universal &* $$.tag.type_ == ASN1::ASN1Type::ObjectIdentifier)"));
            if ( ! (::hilti::rt::Bool(static_cast<bool>(__requires))) ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:371:31-371:136");
                throw ::spicy::rt::ParseError(__requires.errorOrThrow(), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:371:31-371:136");
            }
        }

    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:169:29-193:1");

        // Begin parsing production: Unit: ASN1__ASN1ObjectIdentifier_7 -> _anon_48_7 sublist_7 (field 'oid', id n/a, parser, args: (self.oidHeader.len.len));
        ::hilti::rt::optional::valueOrInit((*__self).oid) = (__hlt_ldap::ASN1::ASN1ObjectIdentifier((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).oidHeader)).len)).len));
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).oid)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1ObjectIdentifier_7 -> _anon_48_7 sublist_7 (field 'oid', id n/a, parser, args: (self.oidHeader.len.len));

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1ObjectIdentifier> __dd = ::hilti::rt::optional::value((*__self).oid);
            ::hilti::rt::Result<::hilti::rt::Nothing> __requires = (((*::hilti::rt::optional::value((*__self).oid)).oidstring == "1.3.6.1.5.5.2"s) ? ::hilti::rt::make_result(::hilti::rt::Nothing{}) : ::hilti::rt::result::Error("&requires failed: (self.oid.oidstring == \"1.3.6.1.5.5.2\")"));
            if ( ! (::hilti::rt::Bool(static_cast<bool>(__requires))) ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:372:59-372:107");
                throw ::spicy::rt::ParseError(__requires.errorOrThrow(), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:372:59-372:107");
            }
        }

    }

    ::hilti::rt::Bytes __transient__anon_23;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:375:3-375:20");

    // Begin parsing production: Skip: _anon_23_6 -> skip: _anon_23;
    while ( ::spicy::rt::detail::waitForInputOrEod(__data, __cur, (__lhs_19=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
        __cur = __cur.advance(__cur.size());
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }
    }

    __cur = __cur.advance(__cur.size());
    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Skip: _anon_23_6 -> skip: _anon_23;

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::GSS_SPNEGO_negTokenInit::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = GSS_SPNEGO_negTokenInit::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:370:32-376:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__GSS_SPNEGO_negTokenInit_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_ldap::LDAP::GSS_SPNEGO_negTokenResp::__on_seq(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd) {
    auto __self = LDAP::GSS_SPNEGO_negTokenResp::__self();
    return __hlt_ldap::LDAP::__hook_GSS_SPNEGO_negTokenResp___on_seq(__dd, __self);
}

auto __hlt_ldap::LDAP::GSS_SPNEGO_negTokenResp::__parse_LDAP__GSS_SPNEGO_negTokenResp_7_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = GSS_SPNEGO_negTokenResp::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:423:32-449:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");

        // Begin parsing production: Unit: ASN1__ASN1Message_9 -> Resolved_295 switch_74 (field 'seq', id n/a, parser, args: (True));
        ::hilti::rt::optional::valueOrInit((*__self).seq) = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).seq)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message_9 -> Resolved_295 switch_74 (field 'seq', id n/a, parser, args: (True));

        (*__self).__error = __error;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:428:3-443:3");
        (*__self).__on_seq(::hilti::rt::optional::value((*__self).seq));
        __error = (*__self).__error;
    }

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:445:3-448:52");

    // Begin parsing production: Switch: switch_76 -> [True] -> switch_76_case_1 |  | * -> switch_76_default;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_76_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Switch: switch_76 -> [True] -> switch_76_case_1 |  | * -> switch_76_default;

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::GSS_SPNEGO_negTokenResp::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = GSS_SPNEGO_negTokenResp::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:423:32-449:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__GSS_SPNEGO_negTokenResp_7_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::LDAP::GSS_SPNEGO_negTokenResp::__parse_switch_76_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = GSS_SPNEGO_negTokenResp::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:445:3-448:52");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::debug::indent("spicy"sv);
    ::hilti::rt::integer::safe<int64_t> __parse_lah = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __parse_lahe;
    ::hilti::rt::ValueReference<::hilti::rt::Stream> __parse_from = ::hilti::rt::Stream(::hilti::rt::optional::value((*(*__self).supportedMech).application_data));
    (*__parse_from).freeze();
    ::hilti::rt::stream::SafeConstIterator __parse_begin = (*__parse_from).begin();
    ::hilti::rt::stream::View __parse_cur = (*__parse_from).view();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:445:3-448:52");
    if ( ::hilti::rt::Bool __x = true; __x == ::hilti::rt::Bool(true) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:446:5-446:82");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:446:5-446:82");

        // Begin parsing production: Block: switch_76_case_1 -> Resolved_294;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __parsed_supportedMechOid;

            // Begin parsing production: Unit: ASN1__ASN1Message_9 -> Resolved_295 switch_74 (field 'seq', id n/a, parser, args: (True));
            __parsed_supportedMechOid = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(false)));
            std::tie(__parse_cur, __parse_lah, __parse_lahe, __error) = (*__parsed_supportedMechOid).__parse_stage1(__parse_from, __parse_begin, __parse_cur, ::hilti::rt::Bool(false), __parse_lah, __parse_lahe, __error);
            // End parsing production: Unit: ASN1__ASN1Message_9 -> Resolved_295 switch_74 (field 'seq', id n/a, parser, args: (True));

            {
                ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __dd = __parsed_supportedMechOid;
                ::hilti::rt::optional::valueOrInit((*__self).supportedMechOid) = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).str_value);
            }

        }

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_76_case_1 -> Resolved_294;
    }

    else  {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:447:5-447:16");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:447:5-447:16");

        // Begin parsing production: Block: switch_76_default -> _anon_25_7;
        ::hilti::rt::debug::indent("spicy"sv);
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:447:12-447:15");

        // Begin parsing production: Variable: _anon_25_7 -> void;
        // End parsing production: Variable: _anon_25_7 -> void;

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_76_default -> _anon_25_7;
    }

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

inline void __hlt_ldap::LDAP::KrbWrapToken::__on_rrc(const ::hilti::rt::integer::safe<uint16_t>& __dd) {
    auto __self = LDAP::KrbWrapToken::__self();
    return __hlt_ldap::LDAP::__hook_KrbWrapToken___on_rrc(__dd, __self);
}

auto __hlt_ldap::LDAP::KrbWrapToken::__parse_LDAP__KrbWrapToken_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = KrbWrapToken::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:231:21-261:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::Result<std::tuple<::hilti::rt::integer::safe<uint8_t>, ::hilti::rt::stream::View>> __x_1;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:238:14-242:3");

        // Begin parsing production: Variable: ctx_flags_4 -> bitfield(8) { send_by_acceptor: 0; sealed: 1; acceptor_subkey: 2; };
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "expecting 1 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:238:14-242:3"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(::hilti::rt::optional::valueOrInit((*__self).ctx_flags), __cur) = (__x_1 = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}), ::hilti::rt::make_result(std::make_tuple(::hilti::rt::make_bitfield(::hilti::rt::integer::bits(std::get<0>(*__x_1), 0, 0, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::LSB0}), ::hilti::rt::integer::bits(std::get<0>(*__x_1), 1, 1, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::LSB0}), ::hilti::rt::integer::bits(std::get<0>(*__x_1), 2, 2, ::hilti::rt::integer::BitOrder{::hilti::rt::integer::BitOrder::LSB0}), ::hilti::rt::integer::noop(std::get<0>(*__x_1))), std::get<1>(*__x_1)))).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: ctx_flags_4 -> bitfield(8) { send_by_acceptor: 0; sealed: 1; acceptor_subkey: 2; };
    }

    ::hilti::rt::Bytes __transient_filler;

    {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_20;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:243:3-243:23");

        // Begin parsing production: Skip: filler_8 -> skip:            Ctor: filler_7 -> b"\xff" (const bytes);
        ::spicy::rt::detail::expectBytesLiteral(__data, __cur, __hlt_ldap::LDAP::__ctor__bytes, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:243:16-243:22"sv, (__lhs_20=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        __cur = __cur.advance(::hilti::rt::integer::safe<std::uint64_t>{1U});
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Skip: filler_8 -> skip:            Ctor: filler_7 -> b"\xff" (const bytes);
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:244:7-244:12");

        // Begin parsing production: Variable: ec_4 -> uint<16>;
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{2U}, "expecting 2 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:244:7-244:12"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(::hilti::rt::optional::valueOrInit((*__self).ec), __cur) = ::hilti::rt::integer::unpack<uint16_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: ec_4 -> uint<16>;
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:245:8-245:13");

        // Begin parsing production: Variable: rrc_4 -> uint<16>;
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{2U}, "expecting 2 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:245:8-245:13"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(::hilti::rt::optional::valueOrInit((*__self).rrc), __cur) = ::hilti::rt::integer::unpack<uint16_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: rrc_4 -> uint<16>;

        (*__self).__error = __error;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:245:3-257:3");
        (*__self).__on_rrc(::hilti::rt::optional::value((*__self).rrc));
        __error = (*__self).__error;
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:259:12-259:17");

        // Begin parsing production: Variable: snd_seq_4 -> uint<64>;
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{8U}, "expecting 8 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:259:12-259:17"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(::hilti::rt::optional::valueOrInit((*__self).snd_seq), __cur) = ::hilti::rt::integer::unpack<uint64_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: snd_seq_4 -> uint<64>;
    }

    ::hilti::rt::Bytes __transient_header_e;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:260:3-260:44");

        // Begin parsing production: Skip: header_e_4 -> skip: header_e;
        ::hilti::rt::stream::View __limited_ = __cur.limit((*__self).header_ec);
        ::hilti::rt::stream::View __ncur = __cur.advance((*__self).header_ec);
        ::hilti::rt::integer::safe<uint64_t> __skip = (*__self).header_ec;
        while ( __skip > ::hilti::rt::integer::safe<std::uint64_t>{0U} ) {
            ::spicy::rt::detail::waitForInput(__data, __limited_, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "not enough bytes for skipping"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:260:3-260:44"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
            ::hilti::rt::integer::safe<uint64_t> __consume = (__limited_.size() <= __skip ? __limited_.size() : __skip);
            __limited_ = __limited_.advance(__consume);
            if ( __trim ) {
                (*__data).trim(__limited_.begin());
            }

            __skip = __skip - __consume;
        }

        if ( __limited_.offset() < __ncur.offset() ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:260:24-260:43");
            throw ::spicy::rt::ParseError(::hilti::rt::fmt("&size amount not consumed: expected %lu bytes, but got %lu bytes"sv, (*__self).header_ec, __limited_.offset() - (__ncur.offset() - (*__self).header_ec)), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:260:24-260:43");
        }

        // End parsing production: Skip: header_e_4 -> skip: header_e;

        __cur = __ncur;
    }

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::KrbWrapToken::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = KrbWrapToken::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:231:21-261:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__KrbWrapToken_4_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_ldap::LDAP::MaybeEncrypted::__on_0x25_init() {
    auto __self = LDAP::MaybeEncrypted::__self();
    return __hlt_ldap::LDAP::__hook_MaybeEncrypted___on_0x25_init(__self);
}

inline void __hlt_ldap::LDAP::MaybeEncrypted::__on__anon_10(const ::hilti::rt::integer::safe<uint16_t>& __dd) {
    auto __self = LDAP::MaybeEncrypted::__self();
    return __hlt_ldap::LDAP::__hook_MaybeEncrypted___on__anon_10(__dd, __self);
}

inline void __hlt_ldap::LDAP::MaybeEncrypted::__on__anon_11() {
    auto __self = LDAP::MaybeEncrypted::__self();
    return __hlt_ldap::LDAP::__hook_MaybeEncrypted___on__anon_11(__self);
}

inline void __hlt_ldap::LDAP::MaybeEncrypted::__on_first(const ::hilti::rt::integer::safe<uint8_t>& __dd) {
    auto __self = LDAP::MaybeEncrypted::__self();
    return __hlt_ldap::LDAP::__hook_MaybeEncrypted___on_first(__dd, __self);
}

inline void __hlt_ldap::LDAP::MaybeEncrypted::__on_rem(const ::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>& __dd) {
    auto __self = LDAP::MaybeEncrypted::__self();
    return __hlt_ldap::LDAP::__hook_MaybeEncrypted___on_rem(__dd, __self);
}

auto __hlt_ldap::LDAP::MaybeEncrypted::__parse_LDAP__MaybeEncrypted_3_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = MaybeEncrypted::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:167:23-217:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:185:10-185:14");

        // Begin parsing production: Variable: first_3 -> uint<8>;
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "expecting 1 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:185:10-185:14"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(::hilti::rt::optional::valueOrInit((*__self).first), __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: first_3 -> uint<8>;

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:185:3-191:3");
        (*__self).__on_first(::hilti::rt::optional::value((*__self).first));

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
    }

        (*__self).__begin = __begin;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:198:3-200:3");
        ::hilti::rt::integer::safe<uint64_t> __pre_container_offset = ::hilti::rt::integer::safe<std::uint64_t>{0U};
        if ( ((*__self->__p_ctx.derefAsValue()).messageMode == LDAP::MessageMode{LDAP::MessageMode::ENCRYPTED}) && ((((*__self).mech.size() == ::hilti::rt::integer::safe<std::uint64_t>{0U}) || ((*__self).mech.startsWith("GSS"_b)))) ) {
            // Begin parsing production: Counter: rem_3 -> counter(3): _anon_9_3;
            std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_rem_3_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error, ::hilti::rt::optional::valueOrInit((*__self).rem));
            // End parsing production: Counter: rem_3 -> counter(3): _anon_9_3;

            ::hilti::rt::integer::safe<uint64_t> __prev = ::hilti::rt::integer::safe<std::uint64_t>{0U};
            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:198:3-200:3");
            (*__self).__on_rem(::hilti::rt::optional::value((*__self).rem));

                if ( (*__self).__position_update.has_value() ) {
                    __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }
    }

        (*__self).__begin = __begin;

    ::hilti::rt::integer::safe<uint16_t> __transient__anon_10;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:202:5-202:10");
    if ( (*__self).saslLen >= ::hilti::rt::integer::safe<std::uint64_t>{2U} ) {
        // Begin parsing production: Variable: _anon_10_3 -> uint<16>;
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{2U}, "expecting 2 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:202:5-202:10"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(__transient__anon_10, __cur) = ::hilti::rt::integer::unpack<uint16_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: _anon_10_3 -> uint<16>;

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:202:3-206:3");
        (*__self).__on__anon_10(__transient__anon_10);

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
    }

        (*__self).__begin = __begin;

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:209:5-209:8");

    // Begin parsing production: Variable: _anon_11_3 -> void;
    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Variable: _anon_11_3 -> void;

    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:209:3-213:3");
    (*__self).__on__anon_11();

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;

        (*__self).__begin = __begin;

    ::hilti::rt::ValueReference<__hlt_ldap::LDAP::MessageDispatch> __transient__anon_12;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:154:31-163:1");

    // Begin parsing production: Unit: LDAP__MessageDispatch_3 -> switch_28 (field '_anon_12', id n/a, parser, args: (ctx));
    __transient__anon_12 = (__hlt_ldap::LDAP::MessageDispatch(__self->__p_ctx.derefAsValue()));
    std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_12).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Unit: LDAP__MessageDispatch_3 -> switch_28 (field '_anon_12', id n/a, parser, args: (ctx));

        (*__self).__begin = __begin;

        (*__self).__begin = __begin;

    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::MaybeEncrypted::__parse_rem_3_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = MaybeEncrypted::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:198:3-200:3");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    for ( ::hilti::rt::integer::safe<uint64_t> __i = ::hilti::rt::integer::safe<std::uint64_t>{3U}; ::hilti::rt::Bool(static_cast<bool>(__i));  ) {
        __i--;
        ::hilti::rt::integer::safe<uint8_t> __elem;

            (*__self).__begin = __begin;

        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:198:8-198:12");

        // Begin parsing production: Variable: _anon_9_3 -> uint<8> (container 'rem');
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "expecting 1 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:198:8-198:12"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(__elem, __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: _anon_9_3 -> uint<8> (container 'rem');

        ::hilti::rt::Bool __stop = ::hilti::rt::Bool(false);
        if ( ! (__stop) ) {
            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

        if ( ! (__stop) ) {
            __dst.emplace_back(__elem);
        }

            (*__self).__begin = __begin;

        if ( __stop ) {
            break;
        }
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::MaybeEncrypted::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = MaybeEncrypted::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:167:23-217:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    try {

            __trim = ::hilti::rt::Bool(false);

        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();

            (*__self).__begin = __begin;

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:167:23-217:1");
        (*__self).__on_0x25_init();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__MaybeEncrypted_3_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }
    catch ( const ::std::exception& __except ) {

            (*__self).__begin = __begin;

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
        throw;
    }

    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;
    return __result;
}

inline void __hlt_ldap::LDAP::Message::__on_0x25_done() {
    auto __self = LDAP::Message::__self();
    return __hlt_ldap::LDAP::__hook_Message___on_0x25_done(__self);
}

inline void __hlt_ldap::LDAP::Message::__on__anon_19() {
    auto __self = LDAP::Message::__self();
    return __hlt_ldap::LDAP::__hook_Message___on__anon_19(__self);
}

inline void __hlt_ldap::LDAP::Message::__on__anon_53(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Body>& __dd) {
    auto __self = LDAP::Message::__self();
    return __hlt_ldap::LDAP::__hook_Message___on__anon_53(__dd, __self);
}

inline void __hlt_ldap::LDAP::Message::__on_protocolOp(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd) {
    auto __self = LDAP::Message::__self();
    return __hlt_ldap::LDAP::__hook_Message___on_protocolOp(__dd, __self);
}

inline void __hlt_ldap::LDAP::Message::__on_seqHeader(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd) {
    auto __self = LDAP::Message::__self();
    return __hlt_ldap::LDAP::__hook_Message___on_seqHeader(__dd, __self);
}

auto __hlt_ldap::LDAP::Message::__parse_LDAP__Message_5_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Message::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:295:23-359:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:198:26-201:1");

        // Begin parsing production: Unit: ASN1__ASN1Header_6 -> Resolved_212 Resolved_213;
        ::hilti::rt::optional::valueOrInit((*__self).seqHeader) = (__hlt_ldap::ASN1::ASN1Header());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).seqHeader)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Header_6 -> Resolved_212 Resolved_213;

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header> __dd = ::hilti::rt::optional::value((*__self).seqHeader);
            ::hilti::rt::Result<::hilti::rt::Nothing> __requires = ((((::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).tag))._anon_46).value))) == ASN1::ASN1Class{ASN1::ASN1Class::Universal}) && ((::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).tag))._anon_46).value))) == ASN1::ASN1Type{ASN1::ASN1Type::Sequence})) ? ::hilti::rt::make_result(::hilti::rt::Nothing{}) : ::hilti::rt::result::Error("&requires failed: ($$.tag.class == ASN1::ASN1Class::Universal &* $$.tag.type_ == ASN1::ASN1Type::Sequence)"));
            if ( ! (::hilti::rt::Bool(static_cast<bool>(__requires))) ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:306:31-306:128");
                throw ::spicy::rt::ParseError(__requires.errorOrThrow(), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:306:31-306:128");
            }
        }

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:306:3-308:3");
        (*__self).__on_seqHeader(::hilti::rt::optional::value((*__self).seqHeader));

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
    }

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:312:5-312:8");

    // Begin parsing production: Variable: _anon_19_5 -> void;
    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Variable: _anon_19_5 -> void;

    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:312:3-314:3");
    (*__self).__on__anon_19();

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:198:26-201:1");

        // Begin parsing production: Unit: ASN1__ASN1Header_6 -> Resolved_212 Resolved_213;
        ::hilti::rt::optional::valueOrInit((*__self).messageID_header) = (__hlt_ldap::ASN1::ASN1Header());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).messageID_header)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Header_6 -> Resolved_212 Resolved_213;

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header> __dd = ::hilti::rt::optional::value((*__self).messageID_header);
            ::hilti::rt::Result<::hilti::rt::Nothing> __requires = ((((::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).tag))._anon_46).value))) == ASN1::ASN1Class{ASN1::ASN1Class::Universal}) && ((::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).tag))._anon_46).value))) == ASN1::ASN1Type{ASN1::ASN1Type::Integer})) ? ::hilti::rt::make_result(::hilti::rt::Nothing{}) : ::hilti::rt::result::Error("&requires failed: ($$.tag.class == ASN1::ASN1Class::Universal &* $$.tag.type_ == ASN1::ASN1Type::Integer)"));
            if ( ! (::hilti::rt::Bool(static_cast<bool>(__requires))) ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:316:38-316:134");
                throw ::spicy::rt::ParseError(__requires.errorOrThrow(), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:316:38-316:134");
            }
        }

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
    }

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Body> __transient__anon_53;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:205:24-251:1");

    // Begin parsing production: Unit: ASN1__ASN1Body_6 -> switch_52 (field '_anon_53', id n/a, parser, args: (self.messageID_header, False));
    __transient__anon_53 = (__hlt_ldap::ASN1::ASN1Body(::hilti::rt::optional::value((*__self).messageID_header), ::hilti::rt::Bool(false)));
    std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_53).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Unit: ASN1__ASN1Body_6 -> switch_52 (field '_anon_53', id n/a, parser, args: (self.messageID_header, False));

    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:317:3-319:3");
    (*__self).__on__anon_53(__transient__anon_53);

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:198:26-201:1");

        // Begin parsing production: Unit: ASN1__ASN1Header_6 -> Resolved_212 Resolved_213;
        ::hilti::rt::optional::valueOrInit((*__self).protocolOp) = (__hlt_ldap::ASN1::ASN1Header());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).protocolOp)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Header_6 -> Resolved_212 Resolved_213;

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header> __dd = ::hilti::rt::optional::value((*__self).protocolOp);
            ::hilti::rt::Result<::hilti::rt::Nothing> __requires = (((::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).tag))._anon_46).value))) == ASN1::ASN1Class{ASN1::ASN1Class::Application}) ? ::hilti::rt::make_result(::hilti::rt::Nothing{}) : ::hilti::rt::result::Error("&requires failed: ($$.tag._anon_46.class == ASN1::ASN1Class::Application)"));
            if ( ! (::hilti::rt::Bool(static_cast<bool>(__requires))) ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:321:32-321:87");
                throw ::spicy::rt::ParseError(__requires.errorOrThrow(), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:321:32-321:87");
            }
        }

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:321:3-324:3");
        (*__self).__on_protocolOp(::hilti::rt::optional::value((*__self).protocolOp));

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
    }

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:326:3-351:21");

    // Begin parsing production: Switch: switch_54 -> [ProtocolOpcode::BIND_REQUEST] -> switch_54_case_1 | [ProtocolOpcode::BIND_RESPONSE] -> switch_54_case_2 | [ProtocolOpcode::UNBIND_REQUEST] -> switch_54_case_3 | [ProtocolOpcode::SEARCH_REQUEST] -> switch_54_case_4 | [ProtocolOpcode::SEARCH_RESULT_ENTRY] -> switch_54_case_5 | [ProtocolOpcode::SEARCH_RESULT_DONE] -> switch_54_case_6 | [ProtocolOpcode::MODIFY_REQUEST] -> switch_54_case_7 | [ProtocolOpcode::MODIFY_RESPONSE] -> switch_54_case_8 | [ProtocolOpcode::ADD_RESPONSE] -> switch_54_case_9 | [ProtocolOpcode::DEL_REQUEST] -> switch_54_case_10 | [ProtocolOpcode::DEL_RESPONSE] -> switch_54_case_11 | [ProtocolOpcode::MOD_DN_RESPONSE] -> switch_54_case_12 | [ProtocolOpcode::COMPARE_RESPONSE] -> switch_54_case_13 | [ProtocolOpcode::ABANDON_REQUEST] -> switch_54_case_14 | [ProtocolOpcode::ADD_REQUEST] -> switch_54_case_15 | [ProtocolOpcode::COMPARE_REQUEST] -> switch_54_case_16 | [ProtocolOpcode::EXTENDED_REQUEST] -> switch_54_case_17 | [ProtocolOpcode::EXTENDED_RESPONSE] -> switch_54_case_18 | [ProtocolOpcode::INTERMEDIATE_RESPONSE] -> switch_54_case_19 | [ProtocolOpcode::MOD_DN_REQUEST] -> switch_54_case_20 | [ProtocolOpcode::SEARCH_RESULT_REFERENCE] -> switch_54_case_21;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_54_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Switch: switch_54 -> [ProtocolOpcode::BIND_REQUEST] -> switch_54_case_1 | [ProtocolOpcode::BIND_RESPONSE] -> switch_54_case_2 | [ProtocolOpcode::UNBIND_REQUEST] -> switch_54_case_3 | [ProtocolOpcode::SEARCH_REQUEST] -> switch_54_case_4 | [ProtocolOpcode::SEARCH_RESULT_ENTRY] -> switch_54_case_5 | [ProtocolOpcode::SEARCH_RESULT_DONE] -> switch_54_case_6 | [ProtocolOpcode::MODIFY_REQUEST] -> switch_54_case_7 | [ProtocolOpcode::MODIFY_RESPONSE] -> switch_54_case_8 | [ProtocolOpcode::ADD_RESPONSE] -> switch_54_case_9 | [ProtocolOpcode::DEL_REQUEST] -> switch_54_case_10 | [ProtocolOpcode::DEL_RESPONSE] -> switch_54_case_11 | [ProtocolOpcode::MOD_DN_RESPONSE] -> switch_54_case_12 | [ProtocolOpcode::COMPARE_RESPONSE] -> switch_54_case_13 | [ProtocolOpcode::ABANDON_REQUEST] -> switch_54_case_14 | [ProtocolOpcode::ADD_REQUEST] -> switch_54_case_15 | [ProtocolOpcode::COMPARE_REQUEST] -> switch_54_case_16 | [ProtocolOpcode::EXTENDED_REQUEST] -> switch_54_case_17 | [ProtocolOpcode::EXTENDED_RESPONSE] -> switch_54_case_18 | [ProtocolOpcode::INTERMEDIATE_RESPONSE] -> switch_54_case_19 | [ProtocolOpcode::MOD_DN_REQUEST] -> switch_54_case_20 | [ProtocolOpcode::SEARCH_RESULT_REFERENCE] -> switch_54_case_21;

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:354:5-354:8");

    // Begin parsing production: Variable: _anon_20_5 -> void;
    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Variable: _anon_20_5 -> void;

    {
        ::hilti::rt::Result<::hilti::rt::Nothing> __requires = (((*__self).__offset >= (*__self).seqHeaderLen) ? ::hilti::rt::make_result(::hilti::rt::Nothing{}) : ::hilti::rt::result::Error("&requires failed: (self.offset() >= self.seqHeaderLen)"));
        if ( ! (::hilti::rt::Bool(static_cast<bool>(__requires))) ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:354:10-354:55");
            throw ::spicy::rt::ParseError(__requires.errorOrThrow(), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:354:10-354:55");
        }
    }

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:355:5-355:8");

    // Begin parsing production: Variable: _anon_21_5 -> void;
    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Variable: _anon_21_5 -> void;

    {
        ::hilti::rt::Result<::hilti::rt::Nothing> __requires = (((*__self).msgLen >= ((*__self).__offset - (*__self).seqHeaderLen)) ? ::hilti::rt::make_result(::hilti::rt::Nothing{}) : ::hilti::rt::result::Error("&requires failed: (self.msgLen >= (self.offset() - self.seqHeaderLen))"));
        if ( ! (::hilti::rt::Bool(static_cast<bool>(__requires))) ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:355:10-355:71");
            throw ::spicy::rt::ParseError(__requires.errorOrThrow(), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:355:10-355:71");
        }
    }

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    ::hilti::rt::Bytes __transient__anon_22;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:358:3-358:71");

    // Begin parsing production: Skip: _anon_22_5 -> skip: _anon_22;
    ::hilti::rt::stream::View __limited_ = __cur.limit((*__self).msgLen - ((*__self).__offset - (*__self).seqHeaderLen));
    ::hilti::rt::stream::View __ncur = __cur.advance((*__self).msgLen - ((*__self).__offset - (*__self).seqHeaderLen));
    ::hilti::rt::integer::safe<uint64_t> __skip = (*__self).msgLen - ((*__self).__offset - (*__self).seqHeaderLen);
    while ( __skip > ::hilti::rt::integer::safe<std::uint64_t>{0U} ) {
        ::spicy::rt::detail::waitForInput(__data, __limited_, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "not enough bytes for skipping"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:358:3-358:71"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        ::hilti::rt::integer::safe<uint64_t> __consume = (__limited_.size() <= __skip ? __limited_.size() : __skip);
        __limited_ = __limited_.advance(__consume);
        if ( __trim ) {
            (*__data).trim(__limited_.begin());
        }

        __skip = __skip - __consume;
    }

    if ( __limited_.offset() < __ncur.offset() ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:358:16-358:70");
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("&size amount not consumed: expected %lu bytes, but got %lu bytes"sv, (*__self).msgLen - ((*__self).__offset - (*__self).seqHeaderLen), __limited_.offset() - (__ncur.offset() - (*__self).msgLen - ((*__self).__offset - (*__self).seqHeaderLen))), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:358:16-358:70");
    }

    // End parsing production: Skip: _anon_22_5 -> skip: _anon_22;

    __cur = __ncur;

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:295:23-359:1");
    (*__self).__on_0x25_done();

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::Message::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Message::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:295:23-359:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    try {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__Message_5_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }
    catch ( const ::std::exception& __except ) {

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
        throw;
    }

    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;
    return __result;
}

auto __hlt_ldap::LDAP::Message::__parse_switch_54_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Message::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:326:3-351:21");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::debug::indent("spicy"sv);
    ::hilti::rt::stream::View __limited_field = __cur.limit((*__self).opLen);
    ::hilti::rt::stream::View __ncur = __cur.advance((*__self).opLen);
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:326:3-351:21");
    if ( LDAP::ProtocolOpcode __x = (*__self).opcode; __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::BIND_REQUEST} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:327:5-327:95");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:327:5-327:95");

        // Begin parsing production: Block: switch_54_case_1 -> Resolved_222;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:457:20-483:70");

            // Begin parsing production: Unit: LDAP__BindRequest_5 -> Resolved_221 Resolved_221 Resolved_221 Resolved_223 (field 'BIND_REQUEST', id n/a, parser, args: (self, ctx));
            ::hilti::rt::optional::valueOrInit((*__self).BIND_REQUEST) = (__hlt_ldap::LDAP::BindRequest(__self, __self->__p_ctx.derefAsValue()));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).BIND_REQUEST)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__BindRequest_5 -> Resolved_221 Resolved_221 Resolved_221 Resolved_223 (field 'BIND_REQUEST', id n/a, parser, args: (self, ctx));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_1 -> Resolved_222;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::BIND_RESPONSE} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:328:5-328:96");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:328:5-328:96");

        // Begin parsing production: Block: switch_54_case_2 -> Resolved_226;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:490:21-532:1");

            // Begin parsing production: Unit: LDAP__BindResponse_5 -> Resolved_227 serverSaslCreds_5 Resolved_229 (field 'BIND_RESPONSE', id n/a, parser, args: (self, ctx));
            ::hilti::rt::optional::valueOrInit((*__self).BIND_RESPONSE) = (__hlt_ldap::LDAP::BindResponse(__self, __self->__p_ctx.derefAsValue()));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).BIND_RESPONSE)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__BindResponse_5 -> Resolved_227 serverSaslCreds_5 Resolved_229 (field 'BIND_RESPONSE', id n/a, parser, args: (self, ctx));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_2 -> Resolved_226;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::UNBIND_REQUEST} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:329:5-329:92");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:329:5-329:92");

        // Begin parsing production: Block: switch_54_case_3 -> Resolved_231;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:538:22-540:1");

            // Begin parsing production: Unit: LDAP__UnbindRequest_5 ->  (field 'UNBIND_REQUEST', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).UNBIND_REQUEST) = (__hlt_ldap::LDAP::UnbindRequest(__self));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).UNBIND_REQUEST)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__UnbindRequest_5 ->  (field 'UNBIND_REQUEST', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_3 -> Resolved_231;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::SEARCH_REQUEST} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:330:5-330:92");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:330:5-330:92");

        // Begin parsing production: Block: switch_54_case_4 -> Resolved_232;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:950:29-965:1");

            // Begin parsing production: Unit: LDAP__SearchRequest_5 -> Resolved_221 Resolved_221 Resolved_221 Resolved_221 Resolved_221 Resolved_221 Resolved_233 Resolved_238 (field 'SEARCH_REQUEST', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).SEARCH_REQUEST) = (__hlt_ldap::LDAP::SearchRequest(__self));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).SEARCH_REQUEST)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__SearchRequest_5 -> Resolved_221 Resolved_221 Resolved_221 Resolved_221 Resolved_221 Resolved_221 Resolved_233 Resolved_238 (field 'SEARCH_REQUEST', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_4 -> Resolved_232;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::SEARCH_RESULT_ENTRY} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:331:5-331:96");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:331:5-331:96");

        // Begin parsing production: Block: switch_54_case_5 -> Resolved_239;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:967:26-973:1");

            // Begin parsing production: Unit: LDAP__SearchResultEntry_5 -> Resolved_221 Resolved_221 (field 'SEARCH_RESULT_ENTRY', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).SEARCH_RESULT_ENTRY) = (__hlt_ldap::LDAP::SearchResultEntry(__self));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).SEARCH_RESULT_ENTRY)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__SearchResultEntry_5 -> Resolved_221 Resolved_221 (field 'SEARCH_RESULT_ENTRY', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_5 -> Resolved_239;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::SEARCH_RESULT_DONE} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:332:5-332:95");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:332:5-332:95");

        // Begin parsing production: Block: switch_54_case_6 -> Resolved_240;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:975:25-979:1");

            // Begin parsing production: Unit: LDAP__SearchResultDone_5 -> Resolved_227 (field 'SEARCH_RESULT_DONE', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).SEARCH_RESULT_DONE) = (__hlt_ldap::LDAP::SearchResultDone(__self));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).SEARCH_RESULT_DONE)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__SearchResultDone_5 -> Resolved_227 (field 'SEARCH_RESULT_DONE', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_6 -> Resolved_240;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::MODIFY_REQUEST} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:333:5-333:92");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:333:5-333:92");

        // Begin parsing production: Block: switch_54_case_7 -> Resolved_241;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:990:22-996:1");

            // Begin parsing production: Unit: LDAP__ModifyRequest_5 -> Resolved_221 (field 'MODIFY_REQUEST', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).MODIFY_REQUEST) = (__hlt_ldap::LDAP::ModifyRequest(__self));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).MODIFY_REQUEST)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__ModifyRequest_5 -> Resolved_221 (field 'MODIFY_REQUEST', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_7 -> Resolved_241;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::MODIFY_RESPONSE} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:334:5-334:93");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:334:5-334:93");

        // Begin parsing production: Block: switch_54_case_8 -> Resolved_242;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:998:23-1002:1");

            // Begin parsing production: Unit: LDAP__ModifyResponse_5 -> Resolved_227 (field 'MODIFY_RESPONSE', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).MODIFY_RESPONSE) = (__hlt_ldap::LDAP::ModifyResponse(__self));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).MODIFY_RESPONSE)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__ModifyResponse_5 -> Resolved_227 (field 'MODIFY_RESPONSE', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_8 -> Resolved_242;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::ADD_RESPONSE} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:335:5-335:90");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:335:5-335:90");

        // Begin parsing production: Block: switch_54_case_9 -> Resolved_243;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1014:20-1018:1");

            // Begin parsing production: Unit: LDAP__AddResponse_5 -> Resolved_227 (field 'ADD_RESPONSE', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).ADD_RESPONSE) = (__hlt_ldap::LDAP::AddResponse(__self));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).ADD_RESPONSE)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__AddResponse_5 -> Resolved_227 (field 'ADD_RESPONSE', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_9 -> Resolved_243;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::DEL_REQUEST} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:336:5-336:89");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:336:5-336:89");

        // Begin parsing production: Block: switch_54_case_10 -> Resolved_244;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1024:19-1028:1");

            // Begin parsing production: Unit: LDAP__DelRequest_5 -> Resolved_221 (field 'DEL_REQUEST', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).DEL_REQUEST) = (__hlt_ldap::LDAP::DelRequest(__self));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).DEL_REQUEST)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__DelRequest_5 -> Resolved_221 (field 'DEL_REQUEST', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_10 -> Resolved_244;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::DEL_RESPONSE} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:337:5-337:90");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:337:5-337:90");

        // Begin parsing production: Block: switch_54_case_11 -> Resolved_245;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1030:20-1034:1");

            // Begin parsing production: Unit: LDAP__DelResponse_5 -> Resolved_227 (field 'DEL_RESPONSE', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).DEL_RESPONSE) = (__hlt_ldap::LDAP::DelResponse(__self));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).DEL_RESPONSE)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__DelResponse_5 -> Resolved_227 (field 'DEL_RESPONSE', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_11 -> Resolved_245;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::MOD_DN_RESPONSE} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:338:5-338:92");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:338:5-338:92");

        // Begin parsing production: Block: switch_54_case_12 -> Resolved_246;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1045:22-1049:1");

            // Begin parsing production: Unit: LDAP__ModDNResponse_5 -> Resolved_227 (field 'MOD_DN_RESPONSE', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).MOD_DN_RESPONSE) = (__hlt_ldap::LDAP::ModDNResponse(__self));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).MOD_DN_RESPONSE)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__ModDNResponse_5 -> Resolved_227 (field 'MOD_DN_RESPONSE', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_12 -> Resolved_246;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::COMPARE_RESPONSE} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:339:5-339:94");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:339:5-339:94");

        // Begin parsing production: Block: switch_54_case_13 -> Resolved_247;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1060:24-1064:1");

            // Begin parsing production: Unit: LDAP__CompareResponse_5 -> Resolved_227 (field 'COMPARE_RESPONSE', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).COMPARE_RESPONSE) = (__hlt_ldap::LDAP::CompareResponse(__self));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).COMPARE_RESPONSE)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__CompareResponse_5 -> Resolved_227 (field 'COMPARE_RESPONSE', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_13 -> Resolved_247;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::ABANDON_REQUEST} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:340:5-340:93");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:340:5-340:93");

        // Begin parsing production: Block: switch_54_case_14 -> Resolved_248;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1070:23-1074:1");

            // Begin parsing production: Unit: LDAP__AbandonRequest_5 -> Resolved_221 (field 'ABANDON_REQUEST', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).ABANDON_REQUEST) = (__hlt_ldap::LDAP::AbandonRequest(__self));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).ABANDON_REQUEST)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__AbandonRequest_5 -> Resolved_221 (field 'ABANDON_REQUEST', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_14 -> Resolved_248;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::ADD_REQUEST} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:344:5-344:93");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:344:5-344:93");

        // Begin parsing production: Block: switch_54_case_15 -> Resolved_249;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:453:23-455:1");

            // Begin parsing production: Unit: LDAP__NotImplemented_5 -> _anon_26_5 (field 'ADD_REQUEST', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).ADD_REQUEST) = (__hlt_ldap::LDAP::NotImplemented(__self));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).ADD_REQUEST)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__NotImplemented_5 -> _anon_26_5 (field 'ADD_REQUEST', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_15 -> Resolved_249;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::COMPARE_REQUEST} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:345:5-345:93");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:345:5-345:93");

        // Begin parsing production: Block: switch_54_case_16 -> Resolved_249;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:453:23-455:1");

            // Begin parsing production: Unit: LDAP__NotImplemented_5 -> _anon_26_5 (field 'ADD_REQUEST', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).COMPARE_REQUEST) = (__hlt_ldap::LDAP::NotImplemented(__self));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).COMPARE_REQUEST)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__NotImplemented_5 -> _anon_26_5 (field 'ADD_REQUEST', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_16 -> Resolved_249;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::EXTENDED_REQUEST} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:346:5-346:99");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:346:5-346:99");

        // Begin parsing production: Block: switch_54_case_17 -> Resolved_250;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1079:24-1101:1");

            // Begin parsing production: Unit: LDAP__ExtendedRequest_5 -> Resolved_211 requestName_5 Resolved_221 (field 'EXTENDED_REQUEST', id n/a, parser, args: (self, ctx));
            ::hilti::rt::optional::valueOrInit((*__self).EXTENDED_REQUEST) = (__hlt_ldap::LDAP::ExtendedRequest(__self, __self->__p_ctx.derefAsValue()));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).EXTENDED_REQUEST)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__ExtendedRequest_5 -> Resolved_211 requestName_5 Resolved_221 (field 'EXTENDED_REQUEST', id n/a, parser, args: (self, ctx));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_17 -> Resolved_250;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::EXTENDED_RESPONSE} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:347:5-347:100");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:347:5-347:100");

        // Begin parsing production: Block: switch_54_case_18 -> Resolved_251;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1116:25-1133:1");

            // Begin parsing production: Unit: LDAP__ExtendedResponse_5 -> Resolved_227 Resolved_252 Resolved_252 (field 'EXTENDED_RESPONSE', id n/a, parser, args: (self, ctx));
            ::hilti::rt::optional::valueOrInit((*__self).EXTENDED_RESPONSE) = (__hlt_ldap::LDAP::ExtendedResponse(__self, __self->__p_ctx.derefAsValue()));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).EXTENDED_RESPONSE)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__ExtendedResponse_5 -> Resolved_227 Resolved_252 Resolved_252 (field 'EXTENDED_RESPONSE', id n/a, parser, args: (self, ctx));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_18 -> Resolved_251;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::INTERMEDIATE_RESPONSE} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:348:5-348:93");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:348:5-348:93");

        // Begin parsing production: Block: switch_54_case_19 -> Resolved_249;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:453:23-455:1");

            // Begin parsing production: Unit: LDAP__NotImplemented_5 -> _anon_26_5 (field 'ADD_REQUEST', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).INTERMEDIATE_RESPONSE) = (__hlt_ldap::LDAP::NotImplemented(__self));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).INTERMEDIATE_RESPONSE)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__NotImplemented_5 -> _anon_26_5 (field 'ADD_REQUEST', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_19 -> Resolved_249;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::MOD_DN_REQUEST} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:349:5-349:93");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:349:5-349:93");

        // Begin parsing production: Block: switch_54_case_20 -> Resolved_249;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:453:23-455:1");

            // Begin parsing production: Unit: LDAP__NotImplemented_5 -> _anon_26_5 (field 'ADD_REQUEST', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).MOD_DN_REQUEST) = (__hlt_ldap::LDAP::NotImplemented(__self));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).MOD_DN_REQUEST)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__NotImplemented_5 -> _anon_26_5 (field 'ADD_REQUEST', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_20 -> Resolved_249;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else if ( __x == LDAP::ProtocolOpcode{LDAP::ProtocolOpcode::SEARCH_RESULT_REFERENCE} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:350:5-350:93");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:350:5-350:93");

        // Begin parsing production: Block: switch_54_case_21 -> Resolved_249;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:453:23-455:1");

            // Begin parsing production: Unit: LDAP__NotImplemented_5 -> _anon_26_5 (field 'ADD_REQUEST', id n/a, parser, args: (self));
            ::hilti::rt::optional::valueOrInit((*__self).SEARCH_RESULT_REFERENCE) = (__hlt_ldap::LDAP::NotImplemented(__self));
            std::tie(__limited_field, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).SEARCH_RESULT_REFERENCE)).__parse_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__NotImplemented_5 -> _anon_26_5 (field 'ADD_REQUEST', id n/a, parser, args: (self));

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __limited_field = __limited_field.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_54_case_21 -> Resolved_249;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else  {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:326:3-351:21");
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("no matching case in switch statement for value '%s'"sv, (*__self).opcode), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:326:3-351:21");
    }

    if ( __limited_field.offset() < __ncur.offset() ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:351:5-351:20");
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("&size amount not consumed: expected %lu bytes, but got %lu bytes"sv, (*__self).opLen, __limited_field.offset() - (__ncur.offset() - (*__self).opLen)), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:351:5-351:20");
    }

    __cur = __ncur;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

extern auto __hlt_ldap::LDAP::Message::parse2(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:295:23-359:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:295:23-359:1");

    // Begin parsing production: Unit: LDAP__Message_5 -> Resolved_211 _anon_19_5 Resolved_211 Resolved_214 Resolved_211 switch_54 _anon_20_5 _anon_21_5 _anon_22_5;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: LDAP__Message_5 -> Resolved_211 _anon_19_5 Resolved_211 Resolved_214 Resolved_211 switch_54 _anon_20_5 _anon_21_5 _anon_22_5;

        (*__unit).__offset = __ncur.begin().offset() - __ncur.begin().offset();

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

auto __hlt_ldap::LDAP::MessageDispatch::__parse_LDAP__MessageDispatch_2_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = MessageDispatch::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:154:31-163:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:155:3-162:4");

    // Begin parsing production: Switch: switch_16 -> [MessageMode::Undef] -> switch_16_case_1 | [MessageMode::MS_KRB5] -> switch_16_case_2 | [MessageMode::TLS] -> switch_16_case_3 | [MessageMode::MAYBE_ENCRYPTED] -> switch_16_case_4 | [MessageMode::CLEARTEXT] -> switch_16_case_5 | [MessageMode::ENCRYPTED] -> switch_16_case_6;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_16_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Switch: switch_16 -> [MessageMode::Undef] -> switch_16_case_1 | [MessageMode::MS_KRB5] -> switch_16_case_2 | [MessageMode::TLS] -> switch_16_case_3 | [MessageMode::MAYBE_ENCRYPTED] -> switch_16_case_4 | [MessageMode::CLEARTEXT] -> switch_16_case_5 | [MessageMode::ENCRYPTED] -> switch_16_case_6;

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::MessageDispatch::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = MessageDispatch::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:154:31-163:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__MessageDispatch_2_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::LDAP::MessageDispatch::__parse_switch_16_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = MessageDispatch::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:155:3-162:4");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::debug::indent("spicy"sv);
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:155:3-162:4");
    if ( LDAP::MessageMode __x = (*__self->__p_ctx.derefAsValue()).messageMode; __x == LDAP::MessageMode{LDAP::MessageMode::Undef} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:156:5-156:41");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:156:5-156:41");

        // Begin parsing production: Block: switch_16_case_1 -> Resolved_65;
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message> __transient__anon_3;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:295:23-359:1");

        // Begin parsing production: Unit: LDAP__Message_2 -> Resolved_66 _anon_19_2 Resolved_66 Resolved_69 Resolved_66 switch_20 _anon_20_2 _anon_21_2 _anon_22_2 (field '_anon_3', id n/a, parser, args: (ctx));
        __transient__anon_3 = (__hlt_ldap::LDAP::Message(__self->__p_ctx.derefAsValue()));
        std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_3).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: LDAP__Message_2 -> Resolved_66 _anon_19_2 Resolved_66 Resolved_69 Resolved_66 switch_20 _anon_20_2 _anon_21_2 _anon_22_2 (field '_anon_3', id n/a, parser, args: (ctx));

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_16_case_1 -> Resolved_65;
    }

    else if ( __x == LDAP::MessageMode{LDAP::MessageMode::MS_KRB5} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:157:5-157:54");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:157:5-157:54");

        // Begin parsing production: Block: switch_16_case_2 -> Resolved_108;
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SaslMsKrb5Stripper> __transient__anon_4;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:264:27-292:1");

        // Begin parsing production: Unit: LDAP__SaslMsKrb5Stripper_2 -> len_3 krb5_tok_id_2 switch_26 _anon_15_2 switch_27 trailer_e_2 (field '_anon_4', id n/a, parser, args: (ctx));
        __transient__anon_4 = (__hlt_ldap::LDAP::SaslMsKrb5Stripper(__self->__p_ctx.derefAsValue()));
        std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_4).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: LDAP__SaslMsKrb5Stripper_2 -> len_3 krb5_tok_id_2 switch_26 _anon_15_2 switch_27 trailer_e_2 (field '_anon_4', id n/a, parser, args: (ctx));

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_16_case_2 -> Resolved_108;
    }

    else if ( __x == LDAP::MessageMode{LDAP::MessageMode::TLS} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:158:5-158:37");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:158:5-158:37");

        // Begin parsing production: Block: switch_16_case_3 -> Resolved_110;
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::ValueReference<__hlt_ldap::LDAP::TlsForward> __transient__anon_5;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:226:19-229:1");

        // Begin parsing production: Unit: LDAP__TlsForward_2 -> chunk_2;
        __transient__anon_5 = (__hlt_ldap::LDAP::TlsForward());
        std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_5).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: LDAP__TlsForward_2 -> chunk_2;

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_16_case_3 -> Resolved_110;
    }

    else if ( __x == LDAP::MessageMode{LDAP::MessageMode::MAYBE_ENCRYPTED} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:159:5-159:58");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:159:5-159:58");

        // Begin parsing production: Block: switch_16_case_4 -> Resolved_111;
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::ValueReference<__hlt_ldap::LDAP::MaybeEncrypted> __transient__anon_6;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:167:23-217:1");

        // Begin parsing production: Unit: LDAP__MaybeEncrypted_2 -> first_2 rem_2 _anon_10_2 _anon_11_2 Resolved_64 (field '_anon_6', id n/a, parser, args: (ctx));
        __transient__anon_6 = (__hlt_ldap::LDAP::MaybeEncrypted(__self->__p_ctx.derefAsValue()));
        std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_6).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: LDAP__MaybeEncrypted_2 -> first_2 rem_2 _anon_10_2 _anon_11_2 Resolved_64 (field '_anon_6', id n/a, parser, args: (ctx));

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_16_case_4 -> Resolved_111;
    }

    else if ( __x == LDAP::MessageMode{LDAP::MessageMode::CLEARTEXT} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:160:5-160:45");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:160:5-160:45");

        // Begin parsing production: Block: switch_16_case_5 -> Resolved_65;
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message> __transient__anon_7;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:295:23-359:1");

        // Begin parsing production: Unit: LDAP__Message_2 -> Resolved_66 _anon_19_2 Resolved_66 Resolved_69 Resolved_66 switch_20 _anon_20_2 _anon_21_2 _anon_22_2 (field '_anon_3', id n/a, parser, args: (ctx));
        __transient__anon_7 = (__hlt_ldap::LDAP::Message(__self->__p_ctx.derefAsValue()));
        std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_7).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: LDAP__Message_2 -> Resolved_66 _anon_19_2 Resolved_66 Resolved_69 Resolved_66 switch_20 _anon_20_2 _anon_21_2 _anon_22_2 (field '_anon_3', id n/a, parser, args: (ctx));

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_16_case_5 -> Resolved_65;
    }

    else if ( __x == LDAP::MessageMode{LDAP::MessageMode::ENCRYPTED} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:161:5-161:49");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:161:5-161:49");

        // Begin parsing production: Block: switch_16_case_6 -> Resolved_112;
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::ValueReference<__hlt_ldap::LDAP::EncryptedMessage> __transient__anon_8;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:220:25-223:1");

        // Begin parsing production: Unit: LDAP__EncryptedMessage_2 -> len_4 _anon_13_2;
        __transient__anon_8 = (__hlt_ldap::LDAP::EncryptedMessage());
        std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_8).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: LDAP__EncryptedMessage_2 -> len_4 _anon_13_2;

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_16_case_6 -> Resolved_112;
    }

    else  {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:155:3-162:4");
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("no matching case in switch statement for value '%s'"sv, (*__self->__p_ctx.derefAsValue()).messageMode), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:155:3-162:4");
    }

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

extern auto __hlt_ldap::LDAP::MessageDispatch::parse2(::hilti::rt::ValueReference<__hlt_ldap::LDAP::MessageDispatch>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:154:31-163:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:154:31-163:1");

    // Begin parsing production: Unit: LDAP__MessageDispatch_2 -> switch_16;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: LDAP__MessageDispatch_2 -> switch_16;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

auto __hlt_ldap::LDAP::Messages::__parse_LDAP__Messages_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Messages::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:148:24-151:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::Vector<__hlt_ldap::LDAP::MessageDispatch> __transient__anon_2;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:150:3-150:38");
    ::hilti::rt::integer::safe<uint64_t> __pre_container_offset = ::hilti::rt::integer::safe<std::uint64_t>{0U};

    // Begin parsing production: While: _anon_2 -> while(<look-ahead-found>): Resolved_14;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse__anon_2_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error, __transient__anon_2);
    // End parsing production: While: _anon_2 -> while(<look-ahead-found>): Resolved_14;

    ::hilti::rt::integer::safe<uint64_t> __prev = ::hilti::rt::integer::safe<std::uint64_t>{0U};
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::Messages::__parse__anon_2_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<__hlt_ldap::LDAP::MessageDispatch>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Messages::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:150:3-150:38");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    while ( ::hilti::rt::Bool(true) ) {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_21;
        ::spicy::rt::detail::waitForInputOrEod(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, (__lhs_21=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        if ( ! (::hilti::rt::Bool(static_cast<bool>(__lah))) ) {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_22;
            if ( ::spicy::rt::detail::atEod(__data, __cur, (__lhs_22=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
                __lah = ::hilti::rt::integer::safe<std::int64_t>{-1};
            }
            else {
            }
        }

        if ( ::hilti::rt::integer::safe<int64_t> __x = __lah; __x == ::hilti::rt::integer::safe<std::int64_t>{-1} ) {
            break;
        }

        else  {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_23;
            ::hilti::rt::stream::SafeConstIterator __old_begin = __cur.begin();
            ::hilti::rt::ValueReference<__hlt_ldap::LDAP::MessageDispatch> __elem;
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:154:31-163:1");

            // Begin parsing production: Unit: LDAP__MessageDispatch -> switch_4 (field '_anon', id n/a, parser, args: (self.context())) (container '_anon_2');
            __elem = (__hlt_ldap::LDAP::MessageDispatch((*__self).__context));
            std::tie(__cur, __lah, __lahe, __error) = (*__elem).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__MessageDispatch -> switch_4 (field '_anon', id n/a, parser, args: (self.context())) (container '_anon_2');

            ::hilti::rt::Bool __stop = ::hilti::rt::Bool(false);
            if ( ! (__stop) ) {
            }

            if ( __stop ) {
                break;
            }

            if ( (__cur.begin() == __old_begin) && (! (::spicy::rt::detail::atEod(__data, __cur, (__lhs_23=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))))) ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:150:3-150:38");
                throw ::spicy::rt::ParseError("loop body did not change input position, possible infinite loop"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:150:3-150:38");
            }
        }
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::Messages::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Messages::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:148:24-151:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    try {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__Messages_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }
    catch ( const ::std::exception& __except ) {
        (*__self).__context = ::hilti::rt::StrongReference<__hlt_ldap::LDAP::Ctx>();
        throw;
    }

    (*__self).__context = ::hilti::rt::StrongReference<__hlt_ldap::LDAP::Ctx>();
    return __result;
}

extern auto __hlt_ldap::LDAP::Messages::context_new() -> ::spicy::rt::UnitContext {
    ::hilti::rt::detail::checkStack();
    return ::spicy::rt::detail::createContext(::hilti::rt::reference::make_strong<__hlt_ldap::LDAP::Ctx>(), &type_info::__ti_LDAP__Ctx_namex2aLDAP__Ctxx2b);
}

extern auto __hlt_ldap::LDAP::Messages::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:148:24-151:1");
    ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Messages> __unit = ::hilti::rt::reference::make_value<__hlt_ldap::LDAP::Messages>((__hlt_ldap::LDAP::Messages()));
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    ::spicy::rt::detail::setContext((*__unit).__context, std::optional<::spicy::rt::UnitContext>((__context ? ::hilti::rt::optional::value(__context) : (*__unit).context_new())), &type_info::__ti_LDAP__Ctx_namex2aLDAP__Ctxx2b);
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:148:24-151:1");

    // Begin parsing production: Unit: LDAP__Messages -> _anon_2;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: LDAP__Messages -> _anon_2;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_ldap::LDAP::Messages::parse2(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Messages>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:148:24-151:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    ::spicy::rt::detail::setContext((*__unit).__context, std::optional<::spicy::rt::UnitContext>((__context ? ::hilti::rt::optional::value(__context) : (*__unit).context_new())), &type_info::__ti_LDAP__Ctx_namex2aLDAP__Ctxx2b);
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:148:24-151:1");

    // Begin parsing production: Unit: LDAP__Messages -> _anon_2;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: LDAP__Messages -> _anon_2;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_ldap::LDAP::Messages::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:148:24-151:1");
    ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Messages> __unit = ::hilti::rt::reference::make_value<__hlt_ldap::LDAP::Messages>((__hlt_ldap::LDAP::Messages()));
    ::spicy::rt::ParsedUnit::initialize((*__gunit), __unit, &type_info::__ti_LDAP__Messages_namex2aLDAP__Messagesx2b);
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    ::spicy::rt::detail::setContext((*__unit).__context, std::optional<::spicy::rt::UnitContext>((__context ? ::hilti::rt::optional::value(__context) : (*__unit).context_new())), &type_info::__ti_LDAP__Ctx_namex2aLDAP__Ctxx2b);
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:148:24-151:1");

    // Begin parsing production: Unit: LDAP__Messages -> _anon_2;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: LDAP__Messages -> _anon_2;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

inline void __hlt_ldap::LDAP::ModDNResponse::__on__anon_39(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd) {
    auto __self = LDAP::ModDNResponse::__self();
    return __hlt_ldap::LDAP::__hook_ModDNResponse___on__anon_39(__dd, __self);
}

auto __hlt_ldap::LDAP::ModDNResponse::__parse_LDAP__ModDNResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ModDNResponse::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1045:22-1049:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result> __transient__anon_39;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:117:22-127:1");

    // Begin parsing production: Unit: LDAP__Result_12 -> Resolved_535 Resolved_535 Resolved_535;
    __transient__anon_39 = (__hlt_ldap::LDAP::Result());
    std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_39).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Unit: LDAP__Result_12 -> Resolved_535 Resolved_535 Resolved_535;

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1046:3-1048:3");
    (*__self).__on__anon_39(__transient__anon_39);
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::ModDNResponse::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ModDNResponse::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1045:22-1049:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__ModDNResponse_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_ldap::LDAP::ModifyRequest::__on_objectName(const std::string& __dd) {
    auto __self = LDAP::ModifyRequest::__self();
    return __hlt_ldap::LDAP::__hook_ModifyRequest___on_objectName(__dd, __self);
}

auto __hlt_ldap::LDAP::ModifyRequest::__parse_LDAP__ModifyRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ModifyRequest::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:990:22-996:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __parsed_objectName;

        // Begin parsing production: Unit: ASN1__ASN1Message_21 -> Resolved_472 switch_120 (field 'objectName', id n/a, parser, args: (True));
        __parsed_objectName = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed_objectName).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message_21 -> Resolved_472 switch_120 (field 'objectName', id n/a, parser, args: (True));

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __dd = __parsed_objectName;
            ::hilti::rt::optional::valueOrInit((*__self).objectName) = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).str_value);
        }

        (*__self).__error = __error;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:991:3-993:3");
        (*__self).__on_objectName(::hilti::rt::optional::value((*__self).objectName));
        __error = (*__self).__error;
    }

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::ModifyRequest::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ModifyRequest::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:990:22-996:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__ModifyRequest_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_ldap::LDAP::ModifyResponse::__on__anon_36(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd) {
    auto __self = LDAP::ModifyResponse::__self();
    return __hlt_ldap::LDAP::__hook_ModifyResponse___on__anon_36(__dd, __self);
}

auto __hlt_ldap::LDAP::ModifyResponse::__parse_LDAP__ModifyResponse_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ModifyResponse::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:998:23-1002:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result> __transient__anon_36;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:117:22-127:1");

    // Begin parsing production: Unit: LDAP__Result_9 -> Resolved_484 Resolved_484 Resolved_484;
    __transient__anon_36 = (__hlt_ldap::LDAP::Result());
    std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_36).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Unit: LDAP__Result_9 -> Resolved_484 Resolved_484 Resolved_484;

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:999:3-1001:3");
    (*__self).__on__anon_36(__transient__anon_36);
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::ModifyResponse::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ModifyResponse::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:998:23-1002:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__ModifyResponse_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::LDAP::NotImplemented::__parse_LDAP__NotImplemented_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_24;
    auto __self = NotImplemented::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:453:23-455:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::Bytes __transient__anon_26;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:454:3-454:20");

    // Begin parsing production: Skip: _anon_26_6 -> skip: _anon_26;
    while ( ::spicy::rt::detail::waitForInputOrEod(__data, __cur, (__lhs_24=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
        __cur = __cur.advance(__cur.size());
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }
    }

    __cur = __cur.advance(__cur.size());
    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Skip: _anon_26_6 -> skip: _anon_26;

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::NotImplemented::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = NotImplemented::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:453:23-455:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__NotImplemented_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::LDAP::ParseNestedAndOr::__parse_LDAP__ParseNestedAndOr_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ParseNestedAndOr::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:610:25-612:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:611:5-611:39");
        ::hilti::rt::integer::safe<uint64_t> __pre_container_offset = ::hilti::rt::integer::safe<std::uint64_t>{0U};

        // Begin parsing production: ForEach: searchfilters_6 -> foreach: Resolved_367;
        std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_searchfilters_6_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error, ::hilti::rt::optional::valueOrInit((*__self).searchfilters));
        // End parsing production: ForEach: searchfilters_6 -> foreach: Resolved_367;

        ::hilti::rt::integer::safe<uint64_t> __prev = ::hilti::rt::integer::safe<std::uint64_t>{0U};
    }

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::ParseNestedAndOr::__parse_searchfilters_6_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<__hlt_ldap::LDAP::SearchFilter>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_25;
    auto __self = ParseNestedAndOr::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:611:5-611:39");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    while ( ! (::spicy::rt::detail::atEod(__data, __cur, (__lhs_25=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())))) ) {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_26;
        ::hilti::rt::stream::SafeConstIterator __old_begin = __cur.begin();
        ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchFilter> __elem;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:891:21-948:1");

        // Begin parsing production: Unit: LDAP__SearchFilter_6 -> Resolved_368 switch_97 (container 'searchfilters');
        __elem = (__hlt_ldap::LDAP::SearchFilter());
        std::tie(__cur, __lah, __lahe, __error) = (*__elem).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: LDAP__SearchFilter_6 -> Resolved_368 switch_97 (container 'searchfilters');

        ::hilti::rt::Bool __stop = ::hilti::rt::Bool(false);
        if ( ! (__stop) ) {
        }

        if ( ! (__stop) ) {
            __dst.emplace_back((*__elem));
        }

        if ( __stop ) {
            break;
        }

        if ( (__cur.begin() == __old_begin) && (! (::spicy::rt::detail::atEod(__data, __cur, (__lhs_26=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))))) ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:611:5-611:39");
            throw ::spicy::rt::ParseError("loop body did not change input position, possible infinite loop"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:611:5-611:39");
        }
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::ParseNestedAndOr::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ParseNestedAndOr::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:610:25-612:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__ParseNestedAndOr_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::LDAP::ParseNestedNot::__parse_LDAP__ParseNestedNot_7_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ParseNestedNot::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:614:23-616:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:891:21-948:1");

        // Begin parsing production: Unit: LDAP__SearchFilter_7 -> Resolved_384 switch_101;
        ::hilti::rt::optional::valueOrInit((*__self).searchfilter) = (__hlt_ldap::LDAP::SearchFilter());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).searchfilter)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: LDAP__SearchFilter_7 -> Resolved_384 switch_101;
    }

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::ParseNestedNot::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ParseNestedNot::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:614:23-616:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__ParseNestedNot_7_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::LDAP::Result::__parse_LDAP__Result_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Result::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:117:22-127:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __parsed_code;

        // Begin parsing production: Unit: ASN1__ASN1Message -> Resolved_3 switch_2 (field 'code', id n/a, parser, args: (True));
        __parsed_code = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed_code).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message -> Resolved_3 switch_2 (field 'code', id n/a, parser, args: (True));

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __dd = __parsed_code;
            ::hilti::rt::optional::valueOrInit((*__self).code, LDAP::ResultCode{LDAP::ResultCode::Undef}) = ::hilti::rt::enum_::from_uint<LDAP::ResultCode>(static_cast<::hilti::rt::integer::safe<uint8_t>>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).num_value)));
        }

    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __parsed_matchedDN;

        // Begin parsing production: Unit: ASN1__ASN1Message -> Resolved_3 switch_2 (field 'code', id n/a, parser, args: (True));
        __parsed_matchedDN = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed_matchedDN).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message -> Resolved_3 switch_2 (field 'code', id n/a, parser, args: (True));

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __dd = __parsed_matchedDN;
            ::hilti::rt::optional::valueOrInit((*__self).matchedDN, ""s) = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).str_value);
        }

    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __parsed_diagnosticMessage;

        // Begin parsing production: Unit: ASN1__ASN1Message -> Resolved_3 switch_2 (field 'code', id n/a, parser, args: (True));
        __parsed_diagnosticMessage = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed_diagnosticMessage).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message -> Resolved_3 switch_2 (field 'code', id n/a, parser, args: (True));

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __dd = __parsed_diagnosticMessage;
            ::hilti::rt::optional::valueOrInit((*__self).diagnosticMessage, ""s) = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).str_value);
        }

    }

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::Result::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = Result::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:117:22-127:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__Result_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

extern auto __hlt_ldap::LDAP::Result::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:117:22-127:1");
    ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result> __unit = ::hilti::rt::reference::make_value<__hlt_ldap::LDAP::Result>((__hlt_ldap::LDAP::Result()));
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:117:22-127:1");

    // Begin parsing production: Unit: LDAP__Result -> Resolved_2 Resolved_2 Resolved_2;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: LDAP__Result -> Resolved_2 Resolved_2 Resolved_2;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_ldap::LDAP::Result::parse2(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:117:22-127:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:117:22-127:1");

    // Begin parsing production: Unit: LDAP__Result -> Resolved_2 Resolved_2 Resolved_2;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: LDAP__Result -> Resolved_2 Resolved_2 Resolved_2;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

extern auto __hlt_ldap::LDAP::Result::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:117:22-127:1");
    ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result> __unit = ::hilti::rt::reference::make_value<__hlt_ldap::LDAP::Result>((__hlt_ldap::LDAP::Result()));
    ::spicy::rt::ParsedUnit::initialize((*__gunit), __unit, &type_info::__ti_LDAP__Result_namex2aLDAP__Resultx2b);
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:117:22-127:1");

    // Begin parsing production: Unit: LDAP__Result -> Resolved_2 Resolved_2 Resolved_2;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: LDAP__Result -> Resolved_2 Resolved_2 Resolved_2;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

auto __hlt_ldap::LDAP::SaslCredentials::__parse_LDAP__SaslCredentials_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = SaslCredentials::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:403:24-411:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __parsed_mechanism;

        // Begin parsing production: Unit: ASN1__ASN1Message_7 -> Resolved_268 switch_64 (field 'mechanism', id n/a, parser, args: (False));
        __parsed_mechanism = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(false)));
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed_mechanism).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message_7 -> Resolved_268 switch_64 (field 'mechanism', id n/a, parser, args: (False));

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __dd = __parsed_mechanism;
            ::hilti::rt::optional::valueOrInit((*__self).mechanism) = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).str_value);
        }

    }

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:407:3-410:4");

    // Begin parsing production: Switch: switch_66 -> ["GSS-SPNEGO"] -> switch_66_case_1 |  | * -> switch_66_default;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_66_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Switch: switch_66 -> ["GSS-SPNEGO"] -> switch_66_case_1 |  | * -> switch_66_default;

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::SaslCredentials::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = SaslCredentials::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:403:24-411:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__SaslCredentials_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::LDAP::SaslCredentials::__parse_switch_66_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = SaslCredentials::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:407:3-410:4");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::debug::indent("spicy"sv);
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:407:3-410:4");
    if ( std::string __x = ::hilti::rt::optional::value((*__self).mechanism); __x == "GSS-SPNEGO"s ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:408:5-408:48");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:408:5-408:48");

        // Begin parsing production: Block: switch_66_case_1 -> Resolved_278;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:380:24-401:1");

            // Begin parsing production: Unit: LDAP__GSS_SPNEGO_Init_7 -> Resolved_268 switch_67_lha_3 Resolved_270 Resolved_279;
            ::hilti::rt::optional::valueOrInit((*__self).gss_spnego) = (__hlt_ldap::LDAP::GSS_SPNEGO_Init());
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).gss_spnego)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__GSS_SPNEGO_Init_7 -> Resolved_268 switch_67_lha_3 Resolved_270 Resolved_279;
        }

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_66_case_1 -> Resolved_278;
    }

    else  {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_27;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:409:5-409:27");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:409:5-409:27");

        // Begin parsing production: Block: switch_66_default -> _anon_24_6;
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::Bytes __transient__anon_24;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:409:10-409:27");

        // Begin parsing production: Skip: _anon_24_6 -> skip: _anon_24;
        while ( ::spicy::rt::detail::waitForInputOrEod(__data, __cur, (__lhs_27=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
            __cur = __cur.advance(__cur.size());
            if ( __trim ) {
                (*__data).trim(__cur.begin());
            }
        }

        __cur = __cur.advance(__cur.size());
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Skip: _anon_24_6 -> skip: _anon_24;

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_66_default -> _anon_24_6;
    }

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

inline void __hlt_ldap::LDAP::SaslMsKrb5Stripper::__on__anon_15() {
    auto __self = LDAP::SaslMsKrb5Stripper::__self();
    return __hlt_ldap::LDAP::__hook_SaslMsKrb5Stripper___on__anon_15(__self);
}

auto __hlt_ldap::LDAP::SaslMsKrb5Stripper::__parse_LDAP__SaslMsKrb5Stripper_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = SaslMsKrb5Stripper::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:264:27-292:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:271:8-271:13");

        // Begin parsing production: Variable: len_8 -> uint<32>;
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{4U}, "expecting 4 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:271:8-271:13"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(::hilti::rt::optional::valueOrInit((*__self).len), __cur) = ::hilti::rt::integer::unpack<uint32_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: len_8 -> uint<32>;

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
    }

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:272:16-272:21");

        // Begin parsing production: Variable: krb5_tok_id_4 -> uint<16>;
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{2U}, "expecting 2 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:272:16-272:21"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(::hilti::rt::optional::valueOrInit((*__self).krb5_tok_id), __cur) = ::hilti::rt::integer::unpack<uint16_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: krb5_tok_id_4 -> uint<16>;

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
    }

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:274:3-277:4");

    // Begin parsing production: Switch: switch_40 -> [1284] -> switch_40_case_1 |  | * -> switch_40_default;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_40_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Switch: switch_40 -> [1284] -> switch_40_case_1 |  | * -> switch_40_default;

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    ::hilti::rt::Bytes __transient__anon_15;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:279:3-283:3");

    // Begin parsing production: Skip: _anon_15_4 -> skip: _anon_15;
    ::hilti::rt::stream::View __limited_ = __cur.limit(::hilti::rt::integer::safe<std::uint64_t>{0U});
    ::hilti::rt::stream::View __ncur = __cur.advance(::hilti::rt::integer::safe<std::uint64_t>{0U});
    ::hilti::rt::integer::safe<uint64_t> __skip = ::hilti::rt::integer::safe<std::uint64_t>{0U};
    while ( __skip > ::hilti::rt::integer::safe<std::uint64_t>{0U} ) {
        ::spicy::rt::detail::waitForInput(__data, __limited_, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "not enough bytes for skipping"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:279:3-283:3"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        ::hilti::rt::integer::safe<uint64_t> __consume = (__limited_.size() <= __skip ? __limited_.size() : __skip);
        __limited_ = __limited_.advance(__consume);
        if ( __trim ) {
            (*__data).trim(__limited_.begin());
        }

        __skip = __skip - __consume;
    }

    if ( __limited_.offset() < __ncur.offset() ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:279:16-279:22");
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("&size amount not consumed: expected %lu bytes, but got %lu bytes"sv, ::hilti::rt::integer::safe<std::uint64_t>{0U}, __limited_.offset() - (__ncur.offset() - ::hilti::rt::integer::safe<std::uint64_t>{0U})), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:279:16-279:22");
    }

    // End parsing production: Skip: _anon_15_4 -> skip: _anon_15;

    __cur = __ncur;
    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:279:3-283:3");
    (*__self).__on__anon_15();

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:285:3-288:27");

    // Begin parsing production: Switch: switch_41 -> [True] -> switch_41_case_1 |  | * -> switch_41_default;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_41_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Switch: switch_41 -> [True] -> switch_41_case_1 |  | * -> switch_41_default;

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    ::hilti::rt::Bytes __transient_trailer_e;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:291:3-291:87");
        if ( (*__self).krb_wrap_token.has_value() ) {
            // Begin parsing production: Skip: trailer_e_4 -> skip: trailer_e;
            ::hilti::rt::stream::View __limited_ = __cur.limit((*::hilti::rt::optional::value((*__self).krb_wrap_token)).trailer_ec);
            ::hilti::rt::stream::View __ncur = __cur.advance((*::hilti::rt::optional::value((*__self).krb_wrap_token)).trailer_ec);
            if ( (*__self).krb_wrap_token.has_value() ) {
                ::hilti::rt::integer::safe<uint64_t> __skip = (*::hilti::rt::optional::value((*__self).krb_wrap_token)).trailer_ec;
                while ( __skip > ::hilti::rt::integer::safe<std::uint64_t>{0U} ) {
                    ::spicy::rt::detail::waitForInput(__data, __limited_, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "not enough bytes for skipping"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:291:3-291:87"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
                    ::hilti::rt::integer::safe<uint64_t> __consume = (__limited_.size() <= __skip ? __limited_.size() : __skip);
                    __limited_ = __limited_.advance(__consume);
                    if ( __trim ) {
                        (*__data).trim(__limited_.begin());
                    }

                    __skip = __skip - __consume;
                }
            }

            if ( __limited_.offset() < __ncur.offset() ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:291:25-291:60");
                throw ::spicy::rt::ParseError(::hilti::rt::fmt("&size amount not consumed: expected %lu bytes, but got %lu bytes"sv, (*::hilti::rt::optional::value((*__self).krb_wrap_token)).trailer_ec, __limited_.offset() - (__ncur.offset() - (*::hilti::rt::optional::value((*__self).krb_wrap_token)).trailer_ec)), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:291:25-291:60");
            }

            // End parsing production: Skip: trailer_e_4 -> skip: trailer_e;

            __cur = __ncur;
            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }
    }

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

        (*__self).__offset = __cur.begin().offset() - __begin.offset();

    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::SaslMsKrb5Stripper::__parse__anon_17_4_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<__hlt_ldap::LDAP::Message>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_28;
    auto __self = SaslMsKrb5Stripper::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:286:13-286:34");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    while ( ! (::spicy::rt::detail::atEod(__data, __cur, (__lhs_28=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())))) ) {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_29;
        ::hilti::rt::stream::SafeConstIterator __old_begin = __cur.begin();
        ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message> __elem;

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:295:23-359:1");

        // Begin parsing production: Unit: LDAP__Message_4 -> Resolved_168 _anon_19_4 Resolved_168 Resolved_171 Resolved_168 switch_45 _anon_20_4 _anon_21_4 _anon_22_4 (field '_anon_16', id n/a, parser, args: (ctx)) (container '_anon_17');
        __elem = (__hlt_ldap::LDAP::Message(__self->__p_ctx.derefAsValue()));
        std::tie(__cur, __lah, __lahe, __error) = (*__elem).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: LDAP__Message_4 -> Resolved_168 _anon_19_4 Resolved_168 Resolved_171 Resolved_168 switch_45 _anon_20_4 _anon_21_4 _anon_22_4 (field '_anon_16', id n/a, parser, args: (ctx)) (container '_anon_17');

        ::hilti::rt::Bool __stop = ::hilti::rt::Bool(false);
        if ( ! (__stop) ) {
        }

        if ( ! (__stop) ) {
            __dst.emplace_back((*__elem));
        }

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

        if ( __stop ) {
            break;
        }

        if ( (__cur.begin() == __old_begin) && (! (::spicy::rt::detail::atEod(__data, __cur, (__lhs_29=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))))) ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:286:13-286:34");
            throw ::spicy::rt::ParseError("loop body did not change input position, possible infinite loop"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:286:13-286:34");
        }
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::SaslMsKrb5Stripper::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = SaslMsKrb5Stripper::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:264:27-292:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    try {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__SaslMsKrb5Stripper_4_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }
    catch ( const ::std::exception& __except ) {

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

        (*__self).__error = __error;

            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

            if ( (*__self).__position_update.has_value() ) {
                __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
            }

        __error = (*__self).__error;
        throw;
    }

    (*__self).__error = __error;

        (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

        if ( (*__self).__position_update.has_value() ) {
            __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
            (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
        }

    __error = (*__self).__error;
    return __result;
}

auto __hlt_ldap::LDAP::SaslMsKrb5Stripper::__parse_switch_40_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = SaslMsKrb5Stripper::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:274:3-277:4");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::debug::indent("spicy"sv);
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:274:3-277:4");
    if ( ::hilti::rt::integer::safe<uint16_t> __x = ::hilti::rt::optional::value((*__self).krb5_tok_id); __x == ::hilti::rt::integer::safe<std::uint16_t>{1284U} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:275:5-275:43");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:275:5-275:43");

        // Begin parsing production: Block: switch_40_case_1 -> Resolved_166;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:231:21-261:1");

            // Begin parsing production: Unit: LDAP__KrbWrapToken_5 -> ctx_flags_5 filler_10 ec_5 rrc_5 snd_seq_5 header_e_5;
            ::hilti::rt::optional::valueOrInit((*__self).krb_wrap_token) = (__hlt_ldap::LDAP::KrbWrapToken());
            std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).krb_wrap_token)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
            // End parsing production: Unit: LDAP__KrbWrapToken_5 -> ctx_flags_5 filler_10 ec_5 rrc_5 snd_seq_5 header_e_5;

            (*__self).__error = __error;

                (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();

                if ( (*__self).__position_update.has_value() ) {
                    __cur = __cur.advance(::hilti::rt::optional::value((*__self).__position_update));
                    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>();
                }

            __error = (*__self).__error;
        }

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_40_case_1 -> Resolved_166;

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

    }

    else  {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:276:5-276:16");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:276:5-276:16");

        // Begin parsing production: Block: switch_40_default -> _anon_14_4;
        ::hilti::rt::debug::indent("spicy"sv);
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:276:12-276:15");

        // Begin parsing production: Variable: _anon_14_4 -> void;
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: _anon_14_4 -> void;

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_40_default -> _anon_14_4;

            (*__self).__offset = __cur.begin().offset() - __begin.offset();

    }

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::SaslMsKrb5Stripper::__parse_switch_41_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = SaslMsKrb5Stripper::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:285:3-288:27");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::debug::indent("spicy"sv);
    ::hilti::rt::stream::View __limited_field = __cur.limit((*__self).switch_size);
    ::hilti::rt::stream::View __ncur = __cur.advance((*__self).switch_size);
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:285:3-288:27");
    if ( ::hilti::rt::Bool __x = ((*__self).krb_wrap_token.has_value()) && (! (::hilti::rt::Bool(static_cast<bool>((::hilti::rt::optional::value(std::get<1>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).krb_wrap_token)).ctx_flags).value))))))); __x == ::hilti::rt::Bool(true) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:286:5-286:34");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:286:5-286:34");

        // Begin parsing production: Block: switch_41_case_1 -> _anon_17_4;
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::Vector<__hlt_ldap::LDAP::Message> __transient__anon_17;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:286:13-286:34");
        ::hilti::rt::integer::safe<uint64_t> __pre_container_offset = (*__self).__offset;

        // Begin parsing production: ForEach: _anon_17_4 -> foreach: Resolved_167;
        std::tie(__limited_field, __lah, __lahe, __error) = (*__self).__parse__anon_17_4_stage1(__data, __begin, __limited_field, __trim, __lah, __lahe, __error, __transient__anon_17);
        // End parsing production: ForEach: _anon_17_4 -> foreach: Resolved_167;

        ::hilti::rt::integer::safe<uint64_t> __prev = (*__self).__offset;

            (*__self).__offset = __pre_container_offset;

            (*__self).__offset = __prev;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_41_case_1 -> _anon_17_4;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    else  {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_30;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:287:5-287:27");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:287:5-287:27");

        // Begin parsing production: Block: switch_41_default -> _anon_18_4;
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::Bytes __transient__anon_18;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:287:10-287:27");

        // Begin parsing production: Skip: _anon_18_4 -> skip: _anon_18;
        while ( ::spicy::rt::detail::waitForInputOrEod(__data, __limited_field, (__lhs_30=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))) ) {
            __limited_field = __limited_field.advance(__limited_field.size());
            if ( __trim ) {
                (*__data).trim(__limited_field.begin());
            }
        }

        __limited_field = __limited_field.advance(__limited_field.size());
        if ( __trim ) {
            (*__data).trim(__limited_field.begin());
        }

        // End parsing production: Skip: _anon_18_4 -> skip: _anon_18;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_41_default -> _anon_18_4;

            (*__self).__offset = __limited_field.begin().offset() - __begin.offset();

    }

    if ( __limited_field.offset() < __ncur.offset() ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:288:5-288:26");
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("&size amount not consumed: expected %lu bytes, but got %lu bytes"sv, (*__self).switch_size, __limited_field.offset() - (__ncur.offset() - (*__self).switch_size)), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:288:5-288:26");
    }

    __cur = __ncur;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

inline void __hlt_ldap::LDAP::SearchFilter::__on_0x25_done() {
    auto __self = LDAP::SearchFilter::__self();
    return __hlt_ldap::LDAP::__hook_SearchFilter___on_0x25_done(__self);
}

inline void __hlt_ldap::LDAP::SearchFilter::__on_0x25_error(const std::string& __except) {
    auto __self = LDAP::SearchFilter::__self();
    return __hlt_ldap::LDAP::__hook_SearchFilter___on_0x25_error(__except, __self);
}

inline void __hlt_ldap::LDAP::SearchFilter::__on__anon_58(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd) {
    auto __self = LDAP::SearchFilter::__self();
    return __hlt_ldap::LDAP::__hook_SearchFilter___on__anon_58(__dd, __self);
}

auto __hlt_ldap::LDAP::SearchFilter::__parse_LDAP__SearchFilter_8_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = SearchFilter::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:891:21-948:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __transient__anon_58;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");

    // Begin parsing production: Unit: ASN1__ASN1Message_17 -> Resolved_413 switch_106 (field '_anon_58', id n/a, parser, args: (True));
    __transient__anon_58 = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
    std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_58).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Unit: ASN1__ASN1Message_17 -> Resolved_413 switch_106 (field '_anon_58', id n/a, parser, args: (True));

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:897:3-905:3");
    (*__self).__on__anon_58(__transient__anon_58);
    __error = (*__self).__error;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:907:3-935:4");

    // Begin parsing production: Switch: switch_108 -> [FilterType::FILTER_AND] -> switch_108_case_1 | [FilterType::FILTER_OR] -> switch_108_case_2 | [FilterType::FILTER_NOT] -> switch_108_case_3 | [FilterType::FILTER_EQ] -> switch_108_case_4 | [FilterType::FILTER_SUBSTR] -> switch_108_case_5 | [FilterType::FILTER_GE] -> switch_108_case_6 | [FilterType::FILTER_LE] -> switch_108_case_7 | [FilterType::FILTER_APPROX] -> switch_108_case_8 | [FilterType::FILTER_EXT] -> switch_108_case_9 | [FilterType::FILTER_PRESENT] -> switch_108_case_10;
    std::tie(__cur, __lah, __lahe, __error) = (*__self).__parse_switch_108_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Switch: switch_108 -> [FilterType::FILTER_AND] -> switch_108_case_1 | [FilterType::FILTER_OR] -> switch_108_case_2 | [FilterType::FILTER_NOT] -> switch_108_case_3 | [FilterType::FILTER_EQ] -> switch_108_case_4 | [FilterType::FILTER_SUBSTR] -> switch_108_case_5 | [FilterType::FILTER_GE] -> switch_108_case_6 | [FilterType::FILTER_LE] -> switch_108_case_7 | [FilterType::FILTER_APPROX] -> switch_108_case_8 | [FilterType::FILTER_EXT] -> switch_108_case_9 | [FilterType::FILTER_PRESENT] -> switch_108_case_10;

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:891:21-948:1");
    (*__self).__on_0x25_done();
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::SearchFilter::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = SearchFilter::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:891:21-948:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    try {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__SearchFilter_8_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }
    catch ( const ::std::exception& __except ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:891:21-948:1");
        (*__self).__on_0x25_error(::hilti::rt::exception::what(__except));
        throw;
    }

    return __result;
}

auto __hlt_ldap::LDAP::SearchFilter::__parse_switch_108_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = SearchFilter::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:907:3-935:4");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::debug::indent("spicy"sv);
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:907:3-935:4");
    if ( LDAP::FilterType __x = (*__self).filterType; __x == LDAP::FilterType{LDAP::FilterType::FILTER_AND} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:911:5-912:79");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:911:5-912:79");

        // Begin parsing production: Block: switch_108_case_1 -> Resolved_423;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:610:25-612:1");
            ::hilti::rt::integer::safe<int64_t> __parse_lah = ::hilti::rt::integer::safe<std::int64_t>{0};
            ::hilti::rt::stream::SafeConstIterator __parse_lahe;
            ::hilti::rt::ValueReference<::hilti::rt::Stream> __parse_from = ::hilti::rt::Stream((*__self).filterBytes);
            (*__parse_from).freeze();
            ::hilti::rt::stream::SafeConstIterator __parse_begin = (*__parse_from).begin();
            ::hilti::rt::stream::View __parse_cur = (*__parse_from).view();

            // Begin parsing production: Unit: LDAP__ParseNestedAndOr_8 -> searchfilters_8;
            ::hilti::rt::optional::valueOrInit((*__self).FILTER_AND) = (__hlt_ldap::LDAP::ParseNestedAndOr());
            std::tie(__parse_cur, __parse_lah, __parse_lahe, __error) = (*::hilti::rt::optional::value((*__self).FILTER_AND)).__parse_stage1(__parse_from, __parse_begin, __parse_cur, ::hilti::rt::Bool(false), __parse_lah, __parse_lahe, __error);
            // End parsing production: Unit: LDAP__ParseNestedAndOr_8 -> searchfilters_8;
        }

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_108_case_1 -> Resolved_423;
    }

    else if ( __x == LDAP::FilterType{LDAP::FilterType::FILTER_OR} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:913:5-914:79");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:913:5-914:79");

        // Begin parsing production: Block: switch_108_case_2 -> Resolved_423;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:610:25-612:1");
            ::hilti::rt::integer::safe<int64_t> __parse_lah = ::hilti::rt::integer::safe<std::int64_t>{0};
            ::hilti::rt::stream::SafeConstIterator __parse_lahe;
            ::hilti::rt::ValueReference<::hilti::rt::Stream> __parse_from = ::hilti::rt::Stream((*__self).filterBytes);
            (*__parse_from).freeze();
            ::hilti::rt::stream::SafeConstIterator __parse_begin = (*__parse_from).begin();
            ::hilti::rt::stream::View __parse_cur = (*__parse_from).view();

            // Begin parsing production: Unit: LDAP__ParseNestedAndOr_8 -> searchfilters_8;
            ::hilti::rt::optional::valueOrInit((*__self).FILTER_OR) = (__hlt_ldap::LDAP::ParseNestedAndOr());
            std::tie(__parse_cur, __parse_lah, __parse_lahe, __error) = (*::hilti::rt::optional::value((*__self).FILTER_OR)).__parse_stage1(__parse_from, __parse_begin, __parse_cur, ::hilti::rt::Bool(false), __parse_lah, __parse_lahe, __error);
            // End parsing production: Unit: LDAP__ParseNestedAndOr_8 -> searchfilters_8;
        }

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_108_case_2 -> Resolved_423;
    }

    else if ( __x == LDAP::FilterType{LDAP::FilterType::FILTER_NOT} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:915:5-916:79");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:915:5-916:79");

        // Begin parsing production: Block: switch_108_case_3 -> Resolved_424;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:614:23-616:1");
            ::hilti::rt::integer::safe<int64_t> __parse_lah = ::hilti::rt::integer::safe<std::int64_t>{0};
            ::hilti::rt::stream::SafeConstIterator __parse_lahe;
            ::hilti::rt::ValueReference<::hilti::rt::Stream> __parse_from = ::hilti::rt::Stream((*__self).filterBytes);
            (*__parse_from).freeze();
            ::hilti::rt::stream::SafeConstIterator __parse_begin = (*__parse_from).begin();
            ::hilti::rt::stream::View __parse_cur = (*__parse_from).view();

            // Begin parsing production: Unit: LDAP__ParseNestedNot_8 -> Resolved_411;
            ::hilti::rt::optional::valueOrInit((*__self).FILTER_NOT) = (__hlt_ldap::LDAP::ParseNestedNot());
            std::tie(__parse_cur, __parse_lah, __parse_lahe, __error) = (*::hilti::rt::optional::value((*__self).FILTER_NOT)).__parse_stage1(__parse_from, __parse_begin, __parse_cur, ::hilti::rt::Bool(false), __parse_lah, __parse_lahe, __error);
            // End parsing production: Unit: LDAP__ParseNestedNot_8 -> Resolved_411;
        }

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_108_case_3 -> Resolved_424;
    }

    else if ( __x == LDAP::FilterType{LDAP::FilterType::FILTER_EQ} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:920:5-921:79");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:920:5-921:79");

        // Begin parsing production: Block: switch_108_case_4 -> Resolved_425;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:819:30-862:1");
            ::hilti::rt::integer::safe<int64_t> __parse_lah = ::hilti::rt::integer::safe<std::int64_t>{0};
            ::hilti::rt::stream::SafeConstIterator __parse_lahe;
            ::hilti::rt::ValueReference<::hilti::rt::Stream> __parse_from = ::hilti::rt::Stream((*__self).filterBytes);
            (*__parse_from).freeze();
            ::hilti::rt::stream::SafeConstIterator __parse_begin = (*__parse_from).begin();
            ::hilti::rt::stream::View __parse_cur = (*__parse_from).view();

            // Begin parsing production: Unit: LDAP__DecodedAttributeValue_9 -> _anon_30_9 attributeDesc_len_17 attributeDesc_17 _anon_31_9 assertionValue_len_9 assertionValue_9 _anon_32_9 matchValue_len_9 matchValue_9 (field 'FILTER_EQ', id n/a, parser, args: (FilterType::FILTER_EQ));
            ::hilti::rt::optional::valueOrInit((*__self).FILTER_EQ) = (__hlt_ldap::LDAP::DecodedAttributeValue(LDAP::FilterType{LDAP::FilterType::FILTER_EQ}));
            std::tie(__parse_cur, __parse_lah, __parse_lahe, __error) = (*::hilti::rt::optional::value((*__self).FILTER_EQ)).__parse_stage1(__parse_from, __parse_begin, __parse_cur, ::hilti::rt::Bool(false), __parse_lah, __parse_lahe, __error);
            // End parsing production: Unit: LDAP__DecodedAttributeValue_9 -> _anon_30_9 attributeDesc_len_17 attributeDesc_17 _anon_31_9 assertionValue_len_9 assertionValue_9 _anon_32_9 matchValue_len_9 matchValue_9 (field 'FILTER_EQ', id n/a, parser, args: (FilterType::FILTER_EQ));
        }

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_108_case_4 -> Resolved_425;
    }

    else if ( __x == LDAP::FilterType{LDAP::FilterType::FILTER_SUBSTR} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:922:5-923:79");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:922:5-923:79");

        // Begin parsing production: Block: switch_108_case_5 -> Resolved_426;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:864:24-889:1");
            ::hilti::rt::integer::safe<int64_t> __parse_lah = ::hilti::rt::integer::safe<std::int64_t>{0};
            ::hilti::rt::stream::SafeConstIterator __parse_lahe;
            ::hilti::rt::ValueReference<::hilti::rt::Stream> __parse_from = ::hilti::rt::Stream((*__self).filterBytes);
            (*__parse_from).freeze();
            ::hilti::rt::stream::SafeConstIterator __parse_begin = (*__parse_from).begin();
            ::hilti::rt::stream::View __parse_cur = (*__parse_from).view();

            // Begin parsing production: Unit: LDAP__SubstringFilter_9 -> _anon_33_9 attributeDesc_len_18 attributeDesc_18 Resolved_413 _anon_34_9;
            ::hilti::rt::optional::valueOrInit((*__self).FILTER_SUBSTR) = (__hlt_ldap::LDAP::SubstringFilter());
            std::tie(__parse_cur, __parse_lah, __parse_lahe, __error) = (*::hilti::rt::optional::value((*__self).FILTER_SUBSTR)).__parse_stage1(__parse_from, __parse_begin, __parse_cur, ::hilti::rt::Bool(false), __parse_lah, __parse_lahe, __error);
            // End parsing production: Unit: LDAP__SubstringFilter_9 -> _anon_33_9 attributeDesc_len_18 attributeDesc_18 Resolved_413 _anon_34_9;
        }

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_108_case_5 -> Resolved_426;
    }

    else if ( __x == LDAP::FilterType{LDAP::FilterType::FILTER_GE} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:924:5-925:79");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:924:5-925:79");

        // Begin parsing production: Block: switch_108_case_6 -> Resolved_425;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:819:30-862:1");
            ::hilti::rt::integer::safe<int64_t> __parse_lah = ::hilti::rt::integer::safe<std::int64_t>{0};
            ::hilti::rt::stream::SafeConstIterator __parse_lahe;
            ::hilti::rt::ValueReference<::hilti::rt::Stream> __parse_from = ::hilti::rt::Stream((*__self).filterBytes);
            (*__parse_from).freeze();
            ::hilti::rt::stream::SafeConstIterator __parse_begin = (*__parse_from).begin();
            ::hilti::rt::stream::View __parse_cur = (*__parse_from).view();

            // Begin parsing production: Unit: LDAP__DecodedAttributeValue_9 -> _anon_30_9 attributeDesc_len_17 attributeDesc_17 _anon_31_9 assertionValue_len_9 assertionValue_9 _anon_32_9 matchValue_len_9 matchValue_9 (field 'FILTER_EQ', id n/a, parser, args: (FilterType::FILTER_EQ));
            ::hilti::rt::optional::valueOrInit((*__self).FILTER_GE) = (__hlt_ldap::LDAP::DecodedAttributeValue(LDAP::FilterType{LDAP::FilterType::FILTER_GE}));
            std::tie(__parse_cur, __parse_lah, __parse_lahe, __error) = (*::hilti::rt::optional::value((*__self).FILTER_GE)).__parse_stage1(__parse_from, __parse_begin, __parse_cur, ::hilti::rt::Bool(false), __parse_lah, __parse_lahe, __error);
            // End parsing production: Unit: LDAP__DecodedAttributeValue_9 -> _anon_30_9 attributeDesc_len_17 attributeDesc_17 _anon_31_9 assertionValue_len_9 assertionValue_9 _anon_32_9 matchValue_len_9 matchValue_9 (field 'FILTER_EQ', id n/a, parser, args: (FilterType::FILTER_EQ));
        }

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_108_case_6 -> Resolved_425;
    }

    else if ( __x == LDAP::FilterType{LDAP::FilterType::FILTER_LE} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:926:5-927:79");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:926:5-927:79");

        // Begin parsing production: Block: switch_108_case_7 -> Resolved_425;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:819:30-862:1");
            ::hilti::rt::integer::safe<int64_t> __parse_lah = ::hilti::rt::integer::safe<std::int64_t>{0};
            ::hilti::rt::stream::SafeConstIterator __parse_lahe;
            ::hilti::rt::ValueReference<::hilti::rt::Stream> __parse_from = ::hilti::rt::Stream((*__self).filterBytes);
            (*__parse_from).freeze();
            ::hilti::rt::stream::SafeConstIterator __parse_begin = (*__parse_from).begin();
            ::hilti::rt::stream::View __parse_cur = (*__parse_from).view();

            // Begin parsing production: Unit: LDAP__DecodedAttributeValue_9 -> _anon_30_9 attributeDesc_len_17 attributeDesc_17 _anon_31_9 assertionValue_len_9 assertionValue_9 _anon_32_9 matchValue_len_9 matchValue_9 (field 'FILTER_EQ', id n/a, parser, args: (FilterType::FILTER_EQ));
            ::hilti::rt::optional::valueOrInit((*__self).FILTER_LE) = (__hlt_ldap::LDAP::DecodedAttributeValue(LDAP::FilterType{LDAP::FilterType::FILTER_LE}));
            std::tie(__parse_cur, __parse_lah, __parse_lahe, __error) = (*::hilti::rt::optional::value((*__self).FILTER_LE)).__parse_stage1(__parse_from, __parse_begin, __parse_cur, ::hilti::rt::Bool(false), __parse_lah, __parse_lahe, __error);
            // End parsing production: Unit: LDAP__DecodedAttributeValue_9 -> _anon_30_9 attributeDesc_len_17 attributeDesc_17 _anon_31_9 assertionValue_len_9 assertionValue_9 _anon_32_9 matchValue_len_9 matchValue_9 (field 'FILTER_EQ', id n/a, parser, args: (FilterType::FILTER_EQ));
        }

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_108_case_7 -> Resolved_425;
    }

    else if ( __x == LDAP::FilterType{LDAP::FilterType::FILTER_APPROX} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:928:5-929:79");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:928:5-929:79");

        // Begin parsing production: Block: switch_108_case_8 -> Resolved_425;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:819:30-862:1");
            ::hilti::rt::integer::safe<int64_t> __parse_lah = ::hilti::rt::integer::safe<std::int64_t>{0};
            ::hilti::rt::stream::SafeConstIterator __parse_lahe;
            ::hilti::rt::ValueReference<::hilti::rt::Stream> __parse_from = ::hilti::rt::Stream((*__self).filterBytes);
            (*__parse_from).freeze();
            ::hilti::rt::stream::SafeConstIterator __parse_begin = (*__parse_from).begin();
            ::hilti::rt::stream::View __parse_cur = (*__parse_from).view();

            // Begin parsing production: Unit: LDAP__DecodedAttributeValue_9 -> _anon_30_9 attributeDesc_len_17 attributeDesc_17 _anon_31_9 assertionValue_len_9 assertionValue_9 _anon_32_9 matchValue_len_9 matchValue_9 (field 'FILTER_EQ', id n/a, parser, args: (FilterType::FILTER_EQ));
            ::hilti::rt::optional::valueOrInit((*__self).FILTER_APPROX) = (__hlt_ldap::LDAP::DecodedAttributeValue(LDAP::FilterType{LDAP::FilterType::FILTER_APPROX}));
            std::tie(__parse_cur, __parse_lah, __parse_lahe, __error) = (*::hilti::rt::optional::value((*__self).FILTER_APPROX)).__parse_stage1(__parse_from, __parse_begin, __parse_cur, ::hilti::rt::Bool(false), __parse_lah, __parse_lahe, __error);
            // End parsing production: Unit: LDAP__DecodedAttributeValue_9 -> _anon_30_9 attributeDesc_len_17 attributeDesc_17 _anon_31_9 assertionValue_len_9 assertionValue_9 _anon_32_9 matchValue_len_9 matchValue_9 (field 'FILTER_EQ', id n/a, parser, args: (FilterType::FILTER_EQ));
        }

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_108_case_8 -> Resolved_425;
    }

    else if ( __x == LDAP::FilterType{LDAP::FilterType::FILTER_EXT} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:930:5-931:79");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:930:5-931:79");

        // Begin parsing production: Block: switch_108_case_9 -> Resolved_425;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:819:30-862:1");
            ::hilti::rt::integer::safe<int64_t> __parse_lah = ::hilti::rt::integer::safe<std::int64_t>{0};
            ::hilti::rt::stream::SafeConstIterator __parse_lahe;
            ::hilti::rt::ValueReference<::hilti::rt::Stream> __parse_from = ::hilti::rt::Stream((*__self).filterBytes);
            (*__parse_from).freeze();
            ::hilti::rt::stream::SafeConstIterator __parse_begin = (*__parse_from).begin();
            ::hilti::rt::stream::View __parse_cur = (*__parse_from).view();

            // Begin parsing production: Unit: LDAP__DecodedAttributeValue_9 -> _anon_30_9 attributeDesc_len_17 attributeDesc_17 _anon_31_9 assertionValue_len_9 assertionValue_9 _anon_32_9 matchValue_len_9 matchValue_9 (field 'FILTER_EQ', id n/a, parser, args: (FilterType::FILTER_EQ));
            ::hilti::rt::optional::valueOrInit((*__self).FILTER_EXT) = (__hlt_ldap::LDAP::DecodedAttributeValue(LDAP::FilterType{LDAP::FilterType::FILTER_EXT}));
            std::tie(__parse_cur, __parse_lah, __parse_lahe, __error) = (*::hilti::rt::optional::value((*__self).FILTER_EXT)).__parse_stage1(__parse_from, __parse_begin, __parse_cur, ::hilti::rt::Bool(false), __parse_lah, __parse_lahe, __error);
            // End parsing production: Unit: LDAP__DecodedAttributeValue_9 -> _anon_30_9 attributeDesc_len_17 attributeDesc_17 _anon_31_9 assertionValue_len_9 assertionValue_9 _anon_32_9 matchValue_len_9 matchValue_9 (field 'FILTER_EQ', id n/a, parser, args: (FilterType::FILTER_EQ));
        }

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_108_case_9 -> Resolved_425;
    }

    else if ( __x == LDAP::FilterType{LDAP::FilterType::FILTER_PRESENT} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:932:5-934:79");
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:932:5-934:79");

        // Begin parsing production: Block: switch_108_case_10 -> Resolved_418;
        ::hilti::rt::debug::indent("spicy"sv);

        {
            __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:114:24-118:1");
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1OctetString> __parsed_FILTER_PRESENT;
            ::hilti::rt::integer::safe<int64_t> __parse_lah = ::hilti::rt::integer::safe<std::int64_t>{0};
            ::hilti::rt::stream::SafeConstIterator __parse_lahe;
            ::hilti::rt::ValueReference<::hilti::rt::Stream> __parse_from = ::hilti::rt::Stream((*__self).filterBytes);
            (*__parse_from).freeze();
            ::hilti::rt::stream::SafeConstIterator __parse_begin = (*__parse_from).begin();
            ::hilti::rt::stream::View __parse_cur = (*__parse_from).view();

            // Begin parsing production: Unit: ASN1__ASN1OctetString_17 -> value_17 (field 'str_value', id n/a, parser, args: (head.len.len, head.tag._anon_46.constructed));
            __parsed_FILTER_PRESENT = (__hlt_ldap::ASN1::ASN1OctetString((*__self).filterLen, ::hilti::rt::Bool(false)));
            std::tie(__parse_cur, __parse_lah, __parse_lahe, __error) = (*__parsed_FILTER_PRESENT).__parse_stage1(__parse_from, __parse_begin, __parse_cur, ::hilti::rt::Bool(false), __parse_lah, __parse_lahe, __error);
            // End parsing production: Unit: ASN1__ASN1OctetString_17 -> value_17 (field 'str_value', id n/a, parser, args: (head.len.len, head.tag._anon_46.constructed));

            {
                ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1OctetString> __dd = __parsed_FILTER_PRESENT;
                ::hilti::rt::optional::valueOrInit((*__self).FILTER_PRESENT) = ::hilti::rt::optional::value((*__dd).value).decode(::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::ASCII}, ::hilti::rt::bytes::DecodeErrorStrategy{::hilti::rt::bytes::DecodeErrorStrategy::REPLACE});
            }

        }

        ::hilti::rt::debug::dedent("spicy"sv);
        // End parsing production: Block: switch_108_case_10 -> Resolved_418;
    }

    else  {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:907:3-935:4");
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("no matching case in switch statement for value '%s'"sv, (*__self).filterType), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:907:3-935:4");
    }

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

inline void __hlt_ldap::LDAP::SearchRequest::__on_0x25_done() {
    auto __self = LDAP::SearchRequest::__self();
    return __hlt_ldap::LDAP::__hook_SearchRequest___on_0x25_done(__self);
}

inline void __hlt_ldap::LDAP::SearchRequest::__on_baseObject(const std::string& __dd) {
    auto __self = LDAP::SearchRequest::__self();
    return __hlt_ldap::LDAP::__hook_SearchRequest___on_baseObject(__dd, __self);
}

inline void __hlt_ldap::LDAP::SearchRequest::__on_scope(const LDAP::SearchScope& __dd) {
    auto __self = LDAP::SearchRequest::__self();
    return __hlt_ldap::LDAP::__hook_SearchRequest___on_scope(__dd, __self);
}

auto __hlt_ldap::LDAP::SearchRequest::__parse_LDAP__SearchRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = SearchRequest::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:950:29-965:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __parsed_baseObject;

        // Begin parsing production: Unit: ASN1__ASN1Message_18 -> Resolved_429 switch_110 (field 'baseObject', id n/a, parser, args: (True));
        __parsed_baseObject = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed_baseObject).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message_18 -> Resolved_429 switch_110 (field 'baseObject', id n/a, parser, args: (True));

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __dd = __parsed_baseObject;
            ::hilti::rt::optional::valueOrInit((*__self).baseObject) = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).str_value);
        }

        (*__self).__error = __error;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:951:3-953:3");
        (*__self).__on_baseObject(::hilti::rt::optional::value((*__self).baseObject));
        __error = (*__self).__error;
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __parsed_scope;

        // Begin parsing production: Unit: ASN1__ASN1Message_18 -> Resolved_429 switch_110 (field 'baseObject', id n/a, parser, args: (True));
        __parsed_scope = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed_scope).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message_18 -> Resolved_429 switch_110 (field 'baseObject', id n/a, parser, args: (True));

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __dd = __parsed_scope;
            ::hilti::rt::optional::valueOrInit((*__self).scope, LDAP::SearchScope{LDAP::SearchScope::Undef}) = ::hilti::rt::enum_::from_uint<LDAP::SearchScope>(static_cast<::hilti::rt::integer::safe<uint8_t>>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).num_value)));
        }

        (*__self).__error = __error;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:954:3-957:3");
        (*__self).__on_scope((*__self).scope.value_or(LDAP::SearchScope{LDAP::SearchScope::Undef}));
        __error = (*__self).__error;
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __parsed_deref;

        // Begin parsing production: Unit: ASN1__ASN1Message_18 -> Resolved_429 switch_110 (field 'baseObject', id n/a, parser, args: (True));
        __parsed_deref = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed_deref).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message_18 -> Resolved_429 switch_110 (field 'baseObject', id n/a, parser, args: (True));

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __dd = __parsed_deref;
            ::hilti::rt::optional::valueOrInit((*__self).deref, LDAP::SearchDerefAlias{LDAP::SearchDerefAlias::Undef}) = ::hilti::rt::enum_::from_uint<LDAP::SearchDerefAlias>(static_cast<::hilti::rt::integer::safe<uint8_t>>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).num_value)));
        }

    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __parsed_sizeLimit;

        // Begin parsing production: Unit: ASN1__ASN1Message_18 -> Resolved_429 switch_110 (field 'baseObject', id n/a, parser, args: (True));
        __parsed_sizeLimit = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed_sizeLimit).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message_18 -> Resolved_429 switch_110 (field 'baseObject', id n/a, parser, args: (True));

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __dd = __parsed_sizeLimit;
            ::hilti::rt::optional::valueOrInit((*__self).sizeLimit, ::hilti::rt::integer::safe<std::int64_t>{0}) = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).num_value);
        }

    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __parsed_timeLimit;

        // Begin parsing production: Unit: ASN1__ASN1Message_18 -> Resolved_429 switch_110 (field 'baseObject', id n/a, parser, args: (True));
        __parsed_timeLimit = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed_timeLimit).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message_18 -> Resolved_429 switch_110 (field 'baseObject', id n/a, parser, args: (True));

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __dd = __parsed_timeLimit;
            ::hilti::rt::optional::valueOrInit((*__self).timeLimit, ::hilti::rt::integer::safe<std::int64_t>{0}) = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).num_value);
        }

    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __parsed_typesOnly;

        // Begin parsing production: Unit: ASN1__ASN1Message_18 -> Resolved_429 switch_110 (field 'baseObject', id n/a, parser, args: (True));
        __parsed_typesOnly = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed_typesOnly).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message_18 -> Resolved_429 switch_110 (field 'baseObject', id n/a, parser, args: (True));

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __dd = __parsed_typesOnly;
            ::hilti::rt::optional::valueOrInit((*__self).typesOnly, ::hilti::rt::Bool(false)) = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).bool_value);
        }

    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:891:21-948:1");
        ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchFilter> __parsed_filter;

        // Begin parsing production: Unit: LDAP__SearchFilter_9 -> Resolved_428 switch_112;
        __parsed_filter = (__hlt_ldap::LDAP::SearchFilter());
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed_filter).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: LDAP__SearchFilter_9 -> Resolved_428 switch_112;

        {
            ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchFilter> __dd = __parsed_filter;
            ::hilti::rt::optional::valueOrInit((*__self).filter) = (*__dd).stringRepresentation;
        }

    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:573:34-589:1");
        ::hilti::rt::ValueReference<__hlt_ldap::LDAP::AttributeSelection> __parsed_attributes;

        // Begin parsing production: Unit: LDAP__AttributeSelection_7 -> Resolved_428;
        __parsed_attributes = (__hlt_ldap::LDAP::AttributeSelection());
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed_attributes).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: LDAP__AttributeSelection_7 -> Resolved_428;

        {
            ::hilti::rt::ValueReference<__hlt_ldap::LDAP::AttributeSelection> __dd = __parsed_attributes;
            ::hilti::rt::optional::valueOrInit((*__self).attributes) = (*__dd).attributes;
        }

    }

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:950:29-965:1");
    (*__self).__on_0x25_done();
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::SearchRequest::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = SearchRequest::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:950:29-965:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__SearchRequest_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

extern auto __hlt_ldap::LDAP::SearchRequest::parse2(::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchRequest>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::stream::View {
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:950:29-965:1");
    ::hilti::rt::stream::View __ncur = (__cur ? ::hilti::rt::optional::value(__cur) : (*__data).view());
    ::hilti::rt::integer::safe<int64_t> __lahead = ::hilti::rt::integer::safe<std::int64_t>{0};
    ::hilti::rt::stream::SafeConstIterator __lahead_end;
    std::optional<::hilti::rt::RecoverableFailure> __error = std::optional<::hilti::rt::RecoverableFailure>();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:950:29-965:1");

    // Begin parsing production: Unit: LDAP__SearchRequest_6 -> Resolved_428 Resolved_428 Resolved_428 Resolved_428 Resolved_428 Resolved_428 Resolved_439 Resolved_444;
    std::tie(__ncur, __lahead, __lahead_end, __error) = (*__unit).__parse_stage1(__data, __ncur.begin(), __ncur, ::hilti::rt::Bool(true), __lahead, __lahead_end, __error);
    // End parsing production: Unit: LDAP__SearchRequest_6 -> Resolved_428 Resolved_428 Resolved_428 Resolved_428 Resolved_428 Resolved_428 Resolved_439 Resolved_444;

    if ( __error.has_value() ) {
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("successful synchronization never confirmed: %s"sv, ::hilti::rt::exception::what(::hilti::rt::optional::value(__error))), ::hilti::rt::exception::where(::hilti::rt::optional::value(__error)));
    }

    return __ncur;
}

inline void __hlt_ldap::LDAP::SearchResultDone::__on__anon_35(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd) {
    auto __self = LDAP::SearchResultDone::__self();
    return __hlt_ldap::LDAP::__hook_SearchResultDone___on__anon_35(__dd, __self);
}

auto __hlt_ldap::LDAP::SearchResultDone::__parse_LDAP__SearchResultDone_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = SearchResultDone::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:975:25-979:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result> __transient__anon_35;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:117:22-127:1");

    // Begin parsing production: Unit: LDAP__Result_8 -> Resolved_459 Resolved_459 Resolved_459;
    __transient__anon_35 = (__hlt_ldap::LDAP::Result());
    std::tie(__cur, __lah, __lahe, __error) = (*__transient__anon_35).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
    // End parsing production: Unit: LDAP__Result_8 -> Resolved_459 Resolved_459 Resolved_459;

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:976:3-978:3");
    (*__self).__on__anon_35(__transient__anon_35);
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::SearchResultDone::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = SearchResultDone::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:975:25-979:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__SearchResultDone_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_ldap::LDAP::SearchResultEntry::__on_0x25_done() {
    auto __self = LDAP::SearchResultEntry::__self();
    return __hlt_ldap::LDAP::__hook_SearchResultEntry___on_0x25_done(__self);
}

inline void __hlt_ldap::LDAP::SearchResultEntry::__on_objectName(const std::string& __dd) {
    auto __self = LDAP::SearchResultEntry::__self();
    return __hlt_ldap::LDAP::__hook_SearchResultEntry___on_objectName(__dd, __self);
}

auto __hlt_ldap::LDAP::SearchResultEntry::__parse_LDAP__SearchResultEntry_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = SearchResultEntry::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:967:26-973:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __parsed_objectName;

        // Begin parsing production: Unit: ASN1__ASN1Message_19 -> Resolved_447 switch_114 (field 'objectName', id n/a, parser, args: (True));
        __parsed_objectName = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
        std::tie(__cur, __lah, __lahe, __error) = (*__parsed_objectName).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message_19 -> Resolved_447 switch_114 (field 'objectName', id n/a, parser, args: (True));

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __dd = __parsed_objectName;
            ::hilti::rt::optional::valueOrInit((*__self).objectName) = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).str_value);
        }

        (*__self).__error = __error;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:968:3-970:3");
        (*__self).__on_objectName(::hilti::rt::optional::value((*__self).objectName));
        __error = (*__self).__error;
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");

        // Begin parsing production: Unit: ASN1__ASN1Message_19 -> Resolved_447 switch_114 (field 'objectName', id n/a, parser, args: (True));
        ::hilti::rt::optional::valueOrInit((*__self).attributes) = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(true)));
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).attributes)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message_19 -> Resolved_447 switch_114 (field 'objectName', id n/a, parser, args: (True));
    }

    (*__self).__error = __error;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:967:26-973:1");
    (*__self).__on_0x25_done();
    __error = (*__self).__error;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::SearchResultEntry::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = SearchResultEntry::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:967:26-973:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__SearchResultEntry_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::LDAP::ServerSaslCreds::__parse_LDAP__ServerSaslCreds_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ServerSaslCreds::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:485:24-488:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:198:26-201:1");

        // Begin parsing production: Unit: ASN1__ASN1Header_13 -> Resolved_323 Resolved_324;
        ::hilti::rt::optional::valueOrInit((*__self).serverSaslCreds) = (__hlt_ldap::ASN1::ASN1Header());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).serverSaslCreds)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Header_13 -> Resolved_323 Resolved_324;

        {
            ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header> __dd = ::hilti::rt::optional::value((*__self).serverSaslCreds);
            ::hilti::rt::Result<::hilti::rt::Nothing> __requires = ((((::hilti::rt::optional::value(std::get<2>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).tag))._anon_46).value))) == ASN1::ASN1Class{ASN1::ASN1Class::ContextSpecific}) && ((::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).tag))._anon_46).value))) == ASN1::ASN1Type{::hilti::rt::integer::safe<std::uint64_t>{7U}})) ? ::hilti::rt::make_result(::hilti::rt::Nothing{}) : ::hilti::rt::result::Error("&requires failed: ($$.tag.class == ASN1::ASN1Class::ContextSpecific &* $$.tag.type_ == ASN1::ASN1Type(7))"));
            if ( ! (::hilti::rt::Bool(static_cast<bool>(__requires))) ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:486:37-486:133");
                throw ::spicy::rt::ParseError(__requires.errorOrThrow(), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:486:37-486:133");
            }
        }

    }

    {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_31;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:487:12-487:16");

        // Begin parsing production: Variable: payload_6 -> bytes;
        ::hilti::rt::optional::valueOrInit((*__self).payload) = ::spicy::rt::detail::extractBytes(__data, __cur, (*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).serverSaslCreds)).len)).len, ::hilti::rt::Bool(false), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:487:3-487:52"sv, (__lhs_31=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        __cur = __cur.advance((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).serverSaslCreds)).len)).len);
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: payload_6 -> bytes;
    }

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::ServerSaslCreds::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = ServerSaslCreds::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:485:24-488:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__ServerSaslCreds_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_ldap::LDAP::SubstringFilter::__on__anon_34_foreach(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::Bool& __stop) {
    auto __self = LDAP::SubstringFilter::__self();
    return __hlt_ldap::LDAP::__hook_SubstringFilter___on__anon_34_foreach(__dd, __stop, __self);
}

auto __hlt_ldap::LDAP::SubstringFilter::__parse_LDAP__SubstringFilter_8_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = SubstringFilter::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:864:24-889:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::integer::safe<uint8_t> __transient__anon_33;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:869:5-869:9");

    // Begin parsing production: Variable: _anon_33_8 -> uint<8>;
    ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "expecting 1 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:869:5-869:9"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
    std::tie(__transient__anon_33, __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
    if ( __trim ) {
        (*__data).trim(__cur.begin());
    }

    // End parsing production: Variable: _anon_33_8 -> uint<8>;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:870:22-870:26");

        // Begin parsing production: Variable: attributeDesc_len_16 -> uint<8>;
        ::spicy::rt::detail::waitForInput(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, "expecting 1 bytes for unpacking value"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:870:22-870:26"sv, ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>());
        std::tie(::hilti::rt::optional::valueOrInit((*__self).attributeDesc_len), __cur) = ::hilti::rt::integer::unpack<uint8_t>(__cur, ::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Network}).valueOrThrow();
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: attributeDesc_len_16 -> uint<8>;
    }

    {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_32;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:871:18-871:22");

        // Begin parsing production: Variable: attributeDesc_16 -> bytes;
        ::hilti::rt::optional::valueOrInit((*__self).attributeDesc) = ::spicy::rt::detail::extractBytes(__data, __cur, ::hilti::rt::integer::safe<uint64_t>(::hilti::rt::optional::value((*__self).attributeDesc_len)), ::hilti::rt::Bool(false), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:871:3-871:52"sv, (__lhs_32=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
        __cur = __cur.advance(::hilti::rt::integer::safe<uint64_t>(::hilti::rt::optional::value((*__self).attributeDesc_len)));
        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: attributeDesc_16 -> bytes;
    }

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:198:26-201:1");

        // Begin parsing production: Unit: ASN1__ASN1Header_19 -> Resolved_401 Resolved_402;
        ::hilti::rt::optional::valueOrInit((*__self).header) = (__hlt_ldap::ASN1::ASN1Header());
        std::tie(__cur, __lah, __lahe, __error) = (*::hilti::rt::optional::value((*__self).header)).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Header_19 -> Resolved_401 Resolved_402;
    }

    ::hilti::rt::Vector<__hlt_ldap::ASN1::ASN1Message> __transient__anon_34;
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:877:3-888:3");
    ::hilti::rt::integer::safe<uint64_t> __pre_container_offset = ::hilti::rt::integer::safe<std::uint64_t>{0U};

    // Begin parsing production: ForEach: _anon_34_8 -> foreach: Resolved_403;
    ::hilti::rt::stream::View __limited_ = __cur.limit((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).header)).len)).len);
    ::hilti::rt::stream::View __ncur = __cur.advance((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).header)).len)).len);
    std::tie(__limited_, __lah, __lahe, __error) = (*__self).__parse__anon_34_8_stage1(__data, __begin, __limited_, __trim, __lah, __lahe, __error, __transient__anon_34);
    if ( __limited_.offset() < __ncur.offset() ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:877:32-877:56");
        throw ::spicy::rt::ParseError(::hilti::rt::fmt("&size amount not consumed: expected %lu bytes, but got %lu bytes"sv, (*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).header)).len)).len, __limited_.offset() - (__ncur.offset() - (*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).header)).len)).len)), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:877:32-877:56");
    }

    // End parsing production: ForEach: _anon_34_8 -> foreach: Resolved_403;

    ::hilti::rt::integer::safe<uint64_t> __prev = ::hilti::rt::integer::safe<std::uint64_t>{0U};
    __cur = __ncur;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::SubstringFilter::__parse__anon_34_8_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error, ::hilti::rt::Vector<__hlt_ldap::ASN1::ASN1Message>& __dst) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_33;
    auto __self = SubstringFilter::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:877:3-888:3");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    while ( ! (::spicy::rt::detail::atEod(__data, __cur, (__lhs_33=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())))) ) {
        ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_34;
        ::hilti::rt::stream::SafeConstIterator __old_begin = __cur.begin();
        ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message> __elem;
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/asn1.spicy:264:27-279:1");

        // Begin parsing production: Unit: ASN1__ASN1Message_16 -> Resolved_400 switch_103 (field '_anon_57', id n/a, parser, args: (False)) (container '_anon_34');
        __elem = (__hlt_ldap::ASN1::ASN1Message(::hilti::rt::Bool(false)));
        std::tie(__cur, __lah, __lahe, __error) = (*__elem).__parse_stage1(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        // End parsing production: Unit: ASN1__ASN1Message_16 -> Resolved_400 switch_103 (field '_anon_57', id n/a, parser, args: (False)) (container '_anon_34');

        ::hilti::rt::Bool __stop = ::hilti::rt::Bool(false);
        if ( ! (__stop) ) {
            (*__self).__error = __error;
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:877:3-888:3");
            (*__self).__on__anon_34_foreach(__elem, __stop);
            __error = (*__self).__error;
        }

        if ( __stop ) {
            break;
        }

        if ( (__cur.begin() == __old_begin) && (! (::spicy::rt::detail::atEod(__data, __cur, (__lhs_34=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>()))))) ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:877:3-888:3");
            throw ::spicy::rt::ParseError("loop body did not change input position, possible infinite loop"sv, "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:877:3-888:3");
        }
    }

    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::SubstringFilter::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = SubstringFilter::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:864:24-889:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__SubstringFilter_8_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

inline void __hlt_ldap::LDAP::TlsForward::__on_0x25_init() {
    auto __self = LDAP::TlsForward::__self();
    return __hlt_ldap::LDAP::__hook_TlsForward___on_0x25_init(__self);
}

inline void __hlt_ldap::LDAP::TlsForward::__on_chunk(const ::hilti::rt::Bytes& __dd) {
    auto __self = LDAP::TlsForward::__self();
    return __hlt_ldap::LDAP::__hook_TlsForward___on_chunk(__dd, __self);
}

auto __hlt_ldap::LDAP::TlsForward::__parse_LDAP__TlsForward_4_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = TlsForward::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:226:19-229:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:228:10-228:14");

        // Begin parsing production: Variable: chunk_4 -> bytes;
        while ( ::hilti::rt::Bool(true) ) {
            ::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters> __lhs_35;
            ::hilti::rt::Bool more_data = ::spicy::rt::detail::waitForInputOrEod(__data, __cur, ::hilti::rt::integer::safe<std::uint64_t>{1U}, (__lhs_35=(::hilti::rt::StrongReference<::spicy::rt::filter::detail::Filters>())));
            if ( ::hilti::rt::Bool(static_cast<bool>(__cur.size())) ) {
                ::hilti::rt::optional::valueOrInit((*__self).chunk) = __cur.data();
                __cur = __cur.advance(__cur.size());
                if ( __trim ) {
                    (*__data).trim(__cur.begin());
                }

                (*__self).__error = __error;
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:228:3-228:29");
                (*__self).__on_chunk(::hilti::rt::optional::value((*__self).chunk));
                __error = (*__self).__error;
            }

            if ( ! (more_data) ) {
                break;
            }
        }

        if ( __trim ) {
            (*__data).trim(__cur.begin());
        }

        // End parsing production: Variable: chunk_4 -> bytes;
    }

    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::TlsForward::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = TlsForward::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:226:19-229:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        (*__self).__error = __error;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:226:19-229:1");
        (*__self).__on_0x25_init();
        __error = (*__self).__error;
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__TlsForward_4_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

auto __hlt_ldap::LDAP::UnbindRequest::__parse_LDAP__UnbindRequest_6_stage2(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = UnbindRequest::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:538:22-540:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;
    ::hilti::rt::debug::dedent("spicy"sv);
    __result = std::make_tuple(__cur, __lah, __lahe, __error);
    return __result;
}

auto __hlt_ldap::LDAP::UnbindRequest::__parse_stage1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const ::hilti::rt::stream::SafeConstIterator& __begin, ::hilti::rt::stream::View __cur, ::hilti::rt::Bool __trim, ::hilti::rt::integer::safe<int64_t> __lah, ::hilti::rt::stream::SafeConstIterator __lahe, std::optional<::hilti::rt::RecoverableFailure> __error) -> std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> {
    auto __self = UnbindRequest::__self();
    ::hilti::rt::detail::checkStack();
    __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:538:22-540:1");
    std::tuple<::hilti::rt::stream::View, ::hilti::rt::integer::safe<int64_t>, ::hilti::rt::stream::SafeConstIterator, std::optional<::hilti::rt::RecoverableFailure>> __result;

    {
        ::hilti::rt::debug::indent("spicy"sv);
        ::hilti::rt::stream::SafeConstIterator __begin = __cur.begin();
        ::hilti::rt::StrongReference<::hilti::rt::Stream> filtered = ::hilti::rt::StrongReference<::hilti::rt::Stream>();
        if ( ! (::hilti::rt::Bool(static_cast<bool>(filtered))) ) {
            __result = (*__self).__parse_LDAP__UnbindRequest_6_stage2(__data, __begin, __cur, __trim, __lah, __lahe, __error);
        }
    }

    return __result;
}

extern void __hlt_ldap::LDAP::__hook_AbandonRequest___on_messageID_4353(const ::hilti::rt::integer::safe<int64_t>& __dd, ::hilti::rt::ValueReference<AbandonRequest>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1072:5-1072:41");
    (*__self->__p_message.derefAsValue()).obj = ::hilti::rt::fmt("%d"s, (::hilti::rt::optional::value((*__self).messageID)));
}

extern void __hlt_ldap::LDAP::__hook_AddResponse___on__anon_37_9e3(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<AddResponse>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1016:5-1016:24");
    (*__self->__p_message.derefAsValue()).result_ = ::hilti::rt::StrongReference<__hlt_ldap::LDAP::Result>(__dd);
}

extern void __hlt_ldap::LDAP::__hook_AttributeSelection___on__anon_55_d6d(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<AttributeSelection>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:580:5-587:5");
    if ( (((::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).head)).tag))._anon_46).value))) == ASN1::ASN1Type{ASN1::ASN1Type::Sequence})) && (((*::hilti::rt::optional::value((*__dd).body)).seq.has_value())) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:582:7-586:7");
        for ( const auto& i : ::hilti::rt::optional::value((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).seq)).submessages) ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:583:9-585:9");
            if ( (*::hilti::rt::optional::value(i.body)).str_value.has_value() ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:584:11-584:53");
                (*__self).attributes.emplace_back(::hilti::rt::optional::value((*::hilti::rt::optional::value(i.body)).str_value));
            }
        }
    }
}

extern void __hlt_ldap::LDAP::__hook_AttributeValueAssertion___on__anon_56_3ca9(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<AttributeValueAssertion>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:596:5-605:5");
    if ( ((((::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).head)).tag))._anon_46).value))) == ASN1::ASN1Type{ASN1::ASN1Type::Sequence})) && (((*::hilti::rt::optional::value((*__dd).body)).seq.has_value()))) && ((::hilti::rt::optional::value((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).seq)).submessages).size() >= ::hilti::rt::integer::safe<std::uint64_t>{2U})) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:599:7-601:7");
        if ( (*::hilti::rt::optional::value(::hilti::rt::optional::value((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).seq)).submessages)[::hilti::rt::integer::safe<std::uint64_t>{0U}].body)).str_value.has_value() ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:600:9-600:61");
            (*__self).desc = ::hilti::rt::optional::value((*::hilti::rt::optional::value(::hilti::rt::optional::value((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).seq)).submessages)[::hilti::rt::integer::safe<std::uint64_t>{0U}].body)).str_value);
        }

          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:602:7-604:7");
        if ( (*::hilti::rt::optional::value(::hilti::rt::optional::value((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).seq)).submessages)[::hilti::rt::integer::safe<std::uint64_t>{1U}].body)).str_value.has_value() ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:603:9-603:60");
            (*__self).val = ::hilti::rt::optional::value((*::hilti::rt::optional::value(::hilti::rt::optional::value((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).seq)).submessages)[::hilti::rt::integer::safe<std::uint64_t>{1U}].body)).str_value);
        }
    }
}

extern void __hlt_ldap::LDAP::__hook_BindRequest___on__anon_54_a6d5(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<BindRequest>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:467:5-470:5");
    if ( true ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:468:7-468:72");
        (*__self).authType = ::hilti::rt::enum_::from_uint<LDAP::BindAuthType>(static_cast<::hilti::rt::integer::safe<uint8_t>>((*__dd).application_id));
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:469:7-469:41");
        (*__self).authData = ::hilti::rt::optional::value((*__dd).application_data);
    }

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:471:5-476:5");
    if ( (((*__self).authType == LDAP::BindAuthType{LDAP::BindAuthType::BIND_AUTH_SIMPLE})) && (((*__self).authData.size() > ::hilti::rt::integer::safe<std::uint64_t>{0U})) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:472:7-472:47");
        (*__self).simpleCreds = (*__self).authData.decode(::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::UTF8}, ::hilti::rt::bytes::DecodeErrorStrategy{::hilti::rt::bytes::DecodeErrorStrategy::REPLACE});
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:473:7-475:7");
        if ( ::hilti::rt::string::size((*__self).simpleCreds) > ::hilti::rt::integer::safe<std::uint64_t>{0U} ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:474:9-474:38");
            (*__self->__p_message.derefAsValue()).arg = (*__self).simpleCreds;
        }
    }
}

extern void __hlt_ldap::LDAP::__hook_BindRequest___on_name_207c(const std::string& __dd, ::hilti::rt::ValueReference<BindRequest>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:460:5-460:27");
    (*__self->__p_message.derefAsValue()).obj = ::hilti::rt::optional::value((*__self).name);
}

extern void __hlt_ldap::LDAP::__hook_BindRequest___on_saslCreds_7185(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SaslCredentials>& __dd, ::hilti::rt::ValueReference<BindRequest>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:480:5-480:42");
    (*__self->__p_message.derefAsValue()).arg = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).saslCreds)).mechanism);
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:481:5-481:48");
    (*__self->__p_ctx.derefAsValue()).saslMechanism = ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__self).saslCreds)).mechanism);
}

extern void __hlt_ldap::LDAP::__hook_BindResponse___on__anon_27_4af9(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<BindResponse>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:492:5-492:24");
    (*__self->__p_message.derefAsValue()).result_ = ::hilti::rt::StrongReference<__hlt_ldap::LDAP::Result>(__dd);
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:504:5-506:5");
    if ( (::hilti::rt::string::size((*__self->__p_ctx.derefAsValue()).saslMechanism) > ::hilti::rt::integer::safe<std::uint64_t>{0U}) && ((*__dd).code.value_or(LDAP::ResultCode{LDAP::ResultCode::Undef}) == LDAP::ResultCode{LDAP::ResultCode::SUCCESS}) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:505:7-505:52");
        (*__self->__p_ctx.derefAsValue()).messageMode = LDAP::MessageMode{LDAP::MessageMode::MAYBE_ENCRYPTED};
    }
}

extern void __hlt_ldap::LDAP::__hook_BindResponse___on_gss_spnego_b76b(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::GSS_SPNEGO_Subsequent>& __dd, ::hilti::rt::ValueReference<BindResponse>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:523:5-530:5");
    if ( (*__dd).negTokenResp.has_value() ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:524:7-524:36");
        ::hilti::rt::ValueReference<__hlt_ldap::LDAP::GSS_SPNEGO_negTokenResp> token = ::hilti::rt::optional::value((*__dd).negTokenResp);
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:525:7-529:7");
        if ( ((*token).accepted) && ((*token).supportedMechOid.has_value()) ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:526:9-528:9");
            if ( ::hilti::rt::optional::value((*token).supportedMechOid) == __hlt_ldap::LDAP::GSSAPI_MECH_MS_KRB5 ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:527:11-527:48");
                (*__self->__p_ctx.derefAsValue()).messageMode = LDAP::MessageMode{LDAP::MessageMode::MS_KRB5};
            }
        }
    }
}

extern void __hlt_ldap::LDAP::__hook_CompareResponse___on__anon_40_7606(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<CompareResponse>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1062:5-1062:24");
    (*__self->__p_message.derefAsValue()).result_ = ::hilti::rt::StrongReference<__hlt_ldap::LDAP::Result>(__dd);
}

extern void __hlt_ldap::LDAP::__hook_DecodedAttributeValue___on_0x25_done_f3dc(::hilti::rt::ValueReference<DecodedAttributeValue>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:836:5-860:5");
    if ( ::hilti::rt::Bytes __x = ::hilti::rt::optional::value((*__self).attributeDesc); __x == "DomainGuid"_b ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:841:9-841:80");
        (*__self).assertionValueDecoded = utf16_guid_to_hex_repr(::hilti::rt::optional::value((*__self).assertionValue));
    }

    else if ( __x == "objectSid"_b || __x == "AAC"_b ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:845:9-845:79");
        (*__self).assertionValueDecoded = bytes_sid_to_hex_repr(::hilti::rt::optional::value((*__self).assertionValue));
    }

    else if ( __x == "DomainSid"_b ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:849:9-849:79");
        (*__self).assertionValueDecoded = bytes_sid_to_SID_repr(::hilti::rt::optional::value((*__self).assertionValue));
    }

    else if ( __x == "NtVer"_b ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:853:9-853:76");
        (*__self).assertionValueDecoded = uint32_to_hex_repr(::hilti::rt::optional::value((*__self).assertionValue));
    }

    else  {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:858:9-858:65");
        (*__self).assertionValueDecoded = ::hilti::rt::optional::value((*__self).assertionValue).decode(::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::UTF8}, ::hilti::rt::bytes::DecodeErrorStrategy{::hilti::rt::bytes::DecodeErrorStrategy::REPLACE});
    }
}

extern void __hlt_ldap::LDAP::__hook_DelRequest___on_objectName_82c2(const std::string& __dd, ::hilti::rt::ValueReference<DelRequest>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1026:5-1026:33");
    (*__self->__p_message.derefAsValue()).obj = ::hilti::rt::optional::value((*__self).objectName);
}

extern void __hlt_ldap::LDAP::__hook_DelResponse___on__anon_38_5462(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<DelResponse>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1032:5-1032:24");
    (*__self->__p_message.derefAsValue()).result_ = ::hilti::rt::StrongReference<__hlt_ldap::LDAP::Result>(__dd);
}

extern void __hlt_ldap::LDAP::__hook_ExtendedRequest___on_0x25_done_9c73(::hilti::rt::ValueReference<ExtendedRequest>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1098:5-1099:35");
    if ( ::hilti::rt::optional::value((*__self).requestName) == "1.3.6.1.4.1.1466.20037"s ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1099:7-1099:34");
        (*__self->__p_ctx.derefAsValue()).startTlsRequested = ::hilti::rt::Bool(true);
    }
}

extern void __hlt_ldap::LDAP::__hook_ExtendedRequest___on__anon_59_8e3a(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<ExtendedRequest>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1091:5-1091:43");
    (*__self).requestValue = ::hilti::rt::optional::value((*__dd).application_data);
}

extern void __hlt_ldap::LDAP::__hook_ExtendedRequest___on_requestName_af31(const std::string& __dd, ::hilti::rt::ValueReference<ExtendedRequest>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1083:5-1083:20");
    (*__self->__p_message.derefAsValue()).obj = __dd;
}

extern void __hlt_ldap::LDAP::__hook_ExtendedResponseEntry___on__anon_60_1e96(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<ExtendedResponseEntry>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1106:5-1111:63");
    if ( (::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).head)).tag))._anon_46).value))) == ASN1::ASN1Type{::hilti::rt::integer::safe<std::uint64_t>{10U}} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1107:7-1107:42");
        (*__self->__p_r.derefAsValue()).responseName = ::hilti::rt::optional::value((*__dd).application_data);
    }
    else {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1108:10-1111:63");
        if ( (::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).head)).tag))._anon_46).value))) == ASN1::ASN1Type{::hilti::rt::integer::safe<std::uint64_t>{11U}} ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1109:7-1109:43");
            (*__self->__p_r.derefAsValue()).responseValue = ::hilti::rt::optional::value((*__dd).application_data);
        }
        else {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1111:7-1111:63");
            throw ::spicy::rt::ParseError(::hilti::rt::fmt("Unhandled extended response tag %s"s, ::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).head)).tag)), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1111:7-1111:63");
        }
    }
}

extern void __hlt_ldap::LDAP::__hook_ExtendedResponse___on_0x25_done_67ef(::hilti::rt::ValueReference<ExtendedResponse>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1130:5-1131:41");
    if ( ((*__self->__p_ctx.derefAsValue()).startTlsRequested) && ((*(*__self->__p_message.derefAsValue()).result_).code.value_or(LDAP::ResultCode{LDAP::ResultCode::Undef}) == LDAP::ResultCode{LDAP::ResultCode::SUCCESS}) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1131:7-1131:40");
        (*__self->__p_ctx.derefAsValue()).messageMode = LDAP::MessageMode{LDAP::MessageMode::TLS};
    }
}

extern void __hlt_ldap::LDAP::__hook_ExtendedResponse___on__anon_41_b437(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<ExtendedResponse>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1120:5-1120:24");
    (*__self->__p_message.derefAsValue()).result_ = ::hilti::rt::StrongReference<__hlt_ldap::LDAP::Result>(__dd);
}

extern void __hlt_ldap::LDAP::__hook_GSS_SPNEGO_negTokenResp___on_seq_ca80(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<GSS_SPNEGO_negTokenResp>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:429:5-442:5");
    for ( const auto& msg : ::hilti::rt::optional::value((*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).body)).seq)).submessages) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:431:7-441:7");
        if ( msg.application_id == ::hilti::rt::integer::safe<std::int32_t>{0} ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:432:9-432:63");
            (*__self).accepted = ::hilti::rt::optional::value(msg.application_data) == "\012\001\000"_b;
        }
        else {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:433:14-441:7");
            if ( msg.application_id == ::hilti::rt::integer::safe<std::int32_t>{1} ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:434:9-434:32");
                (*__self).supportedMech = msg;
            }
            else {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:435:14-441:7");
                if ( msg.application_id == ::hilti::rt::integer::safe<std::int32_t>{2} ) {
                }
                else {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:437:14-441:7");
                    if ( msg.application_id == ::hilti::rt::integer::safe<std::int32_t>{3} ) {
                    }
                    else {
                          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:440:9-440:66");
                        throw ::spicy::rt::ParseError(::hilti::rt::fmt("unhandled NegTokenResp id %s"s, msg.application_id), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:440:9-440:66");
                    }
                }
            }
        }
    }
}

extern void __hlt_ldap::LDAP::__hook_KrbWrapToken___on_rrc_c668(const ::hilti::rt::integer::safe<uint16_t>& __dd, ::hilti::rt::ValueReference<KrbWrapToken>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:247:5-256:5");
    if ( ::hilti::rt::optional::value((*__self).rrc) == ::hilti::rt::optional::value((*__self).ec) ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:248:7-248:30");
        (*__self).header_ec = ::hilti::rt::integer::safe<uint64_t>(::hilti::rt::optional::value((*__self).ec));
    }
    else {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:249:12-256:5");
        if ( ::hilti::rt::optional::value((*__self).rrc) == ::hilti::rt::integer::safe<std::uint16_t>{0U} ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:250:9-250:33");
            (*__self).trailer_ec = ::hilti::rt::integer::safe<uint64_t>(::hilti::rt::optional::value((*__self).ec));
        }
        else {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:252:7-255:64");
            if ( ! (::hilti::rt::Bool(static_cast<bool>((::hilti::rt::optional::value(std::get<1>(::hilti::rt::optional::value((*__self).ctx_flags).value)))))) ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:255:9-255:64");
                throw ::spicy::rt::ParseError(::hilti::rt::fmt("Unhandled rc %s and ec %s"s, ::hilti::rt::optional::value((*__self).ec), ::hilti::rt::optional::value((*__self).rrc)), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:255:9-255:64");
            }
        }
    }
}

extern void __hlt_ldap::LDAP::__hook_MaybeEncrypted___on_0x25_init_bfd5(::hilti::rt::ValueReference<MaybeEncrypted>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:179:5-179:29");
    (*__self).start = (*__self).__begin;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:182:5-182:62");
    (*__self).mech = ::hilti::rt::Bytes((*__self->__p_ctx.derefAsValue()).saslMechanism, ::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::UTF8});
}

extern void __hlt_ldap::LDAP::__hook_MaybeEncrypted___on__anon_10_c553(const ::hilti::rt::integer::safe<uint16_t>& __dd, ::hilti::rt::ValueReference<MaybeEncrypted>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:203:5-205:5");
    if ( __dd == ::hilti::rt::integer::safe<std::uint16_t>{1284U} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:204:7-204:44");
        (*__self->__p_ctx.derefAsValue()).messageMode = LDAP::MessageMode{LDAP::MessageMode::MS_KRB5};
    }
}

extern void __hlt_ldap::LDAP::__hook_MaybeEncrypted___on__anon_11_20bc(::hilti::rt::ValueReference<MaybeEncrypted>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:211:5-211:59");
    if ( ! ((*__self->__p_ctx.derefAsValue()).messageMode != LDAP::MessageMode{LDAP::MessageMode::MAYBE_ENCRYPTED}) ) {
        throw ::hilti::rt::AssertionFailure("failed expression '(*ctx).messageMode != MessageMode::MAYBE_ENCRYPTED'", "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:211:5-211:59");
    }

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:212:5-212:30");
    (*__self).__position_update = std::optional<::hilti::rt::stream::SafeConstIterator>((*__self).start);
}

extern void __hlt_ldap::LDAP::__hook_MaybeEncrypted___on_first_e725(const ::hilti::rt::integer::safe<uint8_t>& __dd, ::hilti::rt::ValueReference<MaybeEncrypted>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:186:5-190:5");
    if ( __dd == ::hilti::rt::integer::safe<std::uint8_t>{48U} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:187:7-187:46");
        (*__self->__p_ctx.derefAsValue()).messageMode = LDAP::MessageMode{LDAP::MessageMode::CLEARTEXT};
    }
    else {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:189:7-189:46");
        (*__self->__p_ctx.derefAsValue()).messageMode = LDAP::MessageMode{LDAP::MessageMode::ENCRYPTED};
    }
}

extern void __hlt_ldap::LDAP::__hook_MaybeEncrypted___on_rem_ec7f(const ::hilti::rt::Vector<::hilti::rt::integer::safe<uint8_t>>& __dd, ::hilti::rt::ValueReference<MaybeEncrypted>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:199:5-199:108");
    (*__self).saslLen = ((static_cast<uint64_t>(::hilti::rt::optional::value((*__self).first)) << ::hilti::rt::integer::safe<std::uint64_t>{24U})) + ((static_cast<uint64_t>(__dd[::hilti::rt::integer::safe<std::uint64_t>{0U}]) << ::hilti::rt::integer::safe<std::uint64_t>{16U})) + ((static_cast<uint64_t>(__dd[::hilti::rt::integer::safe<std::uint64_t>{1U}]) << ::hilti::rt::integer::safe<std::uint64_t>{8U})) + static_cast<uint64_t>(__dd[::hilti::rt::integer::safe<std::uint64_t>{2U}]);
}

extern void __hlt_ldap::LDAP::__hook_Message___on_0x25_done_d8fb(::hilti::rt::ValueReference<Message>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1145:3-1145:23");
    ::spicy::rt::accept_input();
}

extern void __hlt_ldap::LDAP::__hook_Message___on__anon_19_9be7(::hilti::rt::ValueReference<Message>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:313:5-313:37");
    (*__self).seqHeaderLen = (*__self).__offset;
}

extern void __hlt_ldap::LDAP::__hook_Message___on__anon_53_8657(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Body>& __dd, ::hilti::rt::ValueReference<Message>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:318:5-318:33");
    (*__self).messageID = ::hilti::rt::optional::value((*__dd).num_value);
}

extern void __hlt_ldap::LDAP::__hook_Message___on_protocolOp_a679(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd, ::hilti::rt::ValueReference<Message>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:322:5-322:65");
    (*__self).opcode = ::hilti::rt::enum_::from_uint<LDAP::ProtocolOpcode>(static_cast<::hilti::rt::integer::safe<uint8_t>>((::hilti::rt::optional::value(std::get<0>(::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).tag))._anon_46).value))).value()));
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:323:5-323:27");
    (*__self).opLen = (*::hilti::rt::optional::value((*__dd).len)).len;
}

extern void __hlt_ldap::LDAP::__hook_Message___on_seqHeader_f2b5(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Header>& __dd, ::hilti::rt::ValueReference<Message>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:307:5-307:28");
    (*__self).msgLen = (*::hilti::rt::optional::value((*__dd).len)).len;
}

extern void __hlt_ldap::LDAP::__hook_ModDNResponse___on__anon_39_5aa(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<ModDNResponse>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1047:5-1047:24");
    (*__self->__p_message.derefAsValue()).result_ = ::hilti::rt::StrongReference<__hlt_ldap::LDAP::Result>(__dd);
}

extern void __hlt_ldap::LDAP::__hook_ModifyRequest___on_objectName_caf3(const std::string& __dd, ::hilti::rt::ValueReference<ModifyRequest>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:992:5-992:33");
    (*__self->__p_message.derefAsValue()).obj = ::hilti::rt::optional::value((*__self).objectName);
}

extern void __hlt_ldap::LDAP::__hook_ModifyResponse___on__anon_36_ce9(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<ModifyResponse>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:1000:5-1000:24");
    (*__self->__p_message.derefAsValue()).result_ = ::hilti::rt::StrongReference<__hlt_ldap::LDAP::Result>(__dd);
}

extern void __hlt_ldap::LDAP::__hook_SaslMsKrb5Stripper___on__anon_15_78ba(::hilti::rt::ValueReference<SaslMsKrb5Stripper>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:280:5-280:53");
    (*__self).switch_size = ::hilti::rt::integer::safe<uint64_t>(::hilti::rt::optional::value((*__self).len)) - ((*__self).__offset - ::hilti::rt::integer::safe<std::uint64_t>{4U});
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:281:5-282:57");
    if ( (*__self).krb_wrap_token.has_value() ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:282:7-282:56");
        (*__self).switch_size -= (*::hilti::rt::optional::value((*__self).krb_wrap_token)).trailer_ec;
    }
}

extern void __hlt_ldap::LDAP::__hook_SearchFilter___on_0x25_done_2017(::hilti::rt::ValueReference<SearchFilter>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:941:5-941:59");
    (*__self).stringRepresentation = string_representation(__self);
}

extern void __hlt_ldap::LDAP::__hook_SearchFilter___on_0x25_error_62fd(const std::string& __except, ::hilti::rt::ValueReference<SearchFilter>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:945:5-945:54");
    (*__self).stringRepresentation = "FILTER_PARSING_ERROR"s;
}

extern void __hlt_ldap::LDAP::__hook_SearchFilter___on__anon_58_c386(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::ValueReference<SearchFilter>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:898:5-904:5");
    if ( true ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:899:7-899:72");
        (*__self).filterType = ::hilti::rt::enum_::from_uint<LDAP::FilterType>(static_cast<::hilti::rt::integer::safe<uint8_t>>((*__dd).application_id));
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:900:7-900:44");
        (*__self).filterBytes = ::hilti::rt::optional::value((*__dd).application_data);
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:901:7-901:38");
        (*__self).filterLen = (*::hilti::rt::optional::value((*::hilti::rt::optional::value((*__dd).head)).len)).len;
    }
    else {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:903:7-903:50");
        (*__self).filterType = LDAP::FilterType{LDAP::FilterType::FILTER_INVALID};
    }
}

extern void __hlt_ldap::LDAP::__hook_SearchRequest___on_baseObject_d746(const std::string& __dd, ::hilti::rt::ValueReference<SearchRequest>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:952:5-952:33");
    (*__self->__p_message.derefAsValue()).obj = ::hilti::rt::optional::value((*__self).baseObject);
}

extern void __hlt_ldap::LDAP::__hook_SearchRequest___on_scope_c5f7(const LDAP::SearchScope& __dd, ::hilti::rt::ValueReference<SearchRequest>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:956:5-956:35");
    (*__self->__p_message.derefAsValue()).arg = ::hilti::rt::fmt("%s"s, (*__self).scope.value_or(LDAP::SearchScope{LDAP::SearchScope::Undef}));
}

extern void __hlt_ldap::LDAP::__hook_SearchResultDone___on__anon_35_25db(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __dd, ::hilti::rt::ValueReference<SearchResultDone>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:977:5-977:24");
    (*__self->__p_message.derefAsValue()).result_ = ::hilti::rt::StrongReference<__hlt_ldap::LDAP::Result>(__dd);
}

extern void __hlt_ldap::LDAP::__hook_SearchResultEntry___on_objectName_642a(const std::string& __dd, ::hilti::rt::ValueReference<SearchResultEntry>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:969:5-969:33");
    (*__self->__p_message.derefAsValue()).obj = ::hilti::rt::optional::value((*__self).objectName);
}

extern void __hlt_ldap::LDAP::__hook_SubstringFilter___on__anon_34_foreach_9818(const ::hilti::rt::ValueReference<__hlt_ldap::ASN1::ASN1Message>& __dd, ::hilti::rt::Bool& __stop, ::hilti::rt::ValueReference<SubstringFilter>& __self) {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:878:5-878:46");
    std::string data = ::hilti::rt::optional::value((*__dd).application_data).decode(::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::UTF8}, ::hilti::rt::bytes::DecodeErrorStrategy{::hilti::rt::bytes::DecodeErrorStrategy::REPLACE});
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:879:5-887:5");
    if ( (*__dd).application_id == ::hilti::rt::integer::safe<std::int32_t>{0} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:880:7-880:25");
        (*__self).initial = data;
    }
    else {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:881:12-887:5");
        if ( (*__dd).application_id == ::hilti::rt::integer::safe<std::int32_t>{1} ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:882:7-882:31");
            (*__self).anys.emplace_back(data);
        }
        else {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:883:12-887:5");
            if ( (*__dd).application_id == ::hilti::rt::integer::safe<std::int32_t>{2} ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:884:7-884:23");
                (*__self).final = data;
            }
            else {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:886:7-886:62");
                throw ::spicy::rt::ParseError(::hilti::rt::fmt("invalid substring choice %s"s, (*__dd).application_id), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:886:7-886:62");
            }
        }
    }
}

extern void __hlt_ldap::LDAP::__init_module() {
    __hlt_ldap::LDAP::__register_LDAP_AbandonRequest();
    __hlt_ldap::LDAP::__register_LDAP_AddResponse();
    __hlt_ldap::LDAP::__register_LDAP_AttributeSelection();
    __hlt_ldap::LDAP::__register_LDAP_AttributeValueAssertion();
    __hlt_ldap::LDAP::__register_LDAP_BindRequest();
    __hlt_ldap::LDAP::__register_LDAP_BindResponse();
    __hlt_ldap::LDAP::__register_LDAP_CompareResponse();
    __hlt_ldap::LDAP::__register_LDAP_DecodedAttributeValue();
    __hlt_ldap::LDAP::__register_LDAP_DelRequest();
    __hlt_ldap::LDAP::__register_LDAP_DelResponse();
    __hlt_ldap::LDAP::__register_LDAP_EncryptedMessage();
    __hlt_ldap::LDAP::__register_LDAP_ExtendedRequest();
    __hlt_ldap::LDAP::__register_LDAP_ExtendedResponse();
    __hlt_ldap::LDAP::__register_LDAP_ExtendedResponseEntry();
    __hlt_ldap::LDAP::__register_LDAP_GSS_SPNEGO_Init();
    __hlt_ldap::LDAP::__register_LDAP_GSS_SPNEGO_Subsequent();
    __hlt_ldap::LDAP::__register_LDAP_GSS_SPNEGO_negTokenInit();
    __hlt_ldap::LDAP::__register_LDAP_GSS_SPNEGO_negTokenResp();
    __hlt_ldap::LDAP::__register_LDAP_KrbWrapToken();
    __hlt_ldap::LDAP::__register_LDAP_MaybeEncrypted();
    __hlt_ldap::LDAP::__register_LDAP_Message();
    __hlt_ldap::LDAP::__register_LDAP_MessageDispatch();
    __hlt_ldap::LDAP::__register_LDAP_Messages();
    __hlt_ldap::LDAP::__register_LDAP_ModDNResponse();
    __hlt_ldap::LDAP::__register_LDAP_ModifyRequest();
    __hlt_ldap::LDAP::__register_LDAP_ModifyResponse();
    __hlt_ldap::LDAP::__register_LDAP_NotImplemented();
    __hlt_ldap::LDAP::__register_LDAP_ParseNestedAndOr();
    __hlt_ldap::LDAP::__register_LDAP_ParseNestedNot();
    __hlt_ldap::LDAP::__register_LDAP_Result();
    __hlt_ldap::LDAP::__register_LDAP_SaslCredentials();
    __hlt_ldap::LDAP::__register_LDAP_SaslMsKrb5Stripper();
    __hlt_ldap::LDAP::__register_LDAP_SearchFilter();
    __hlt_ldap::LDAP::__register_LDAP_SearchRequest();
    __hlt_ldap::LDAP::__register_LDAP_SearchResultDone();
    __hlt_ldap::LDAP::__register_LDAP_SearchResultEntry();
    __hlt_ldap::LDAP::__register_LDAP_ServerSaslCreds();
    __hlt_ldap::LDAP::__register_LDAP_SubstringFilter();
    __hlt_ldap::LDAP::__register_LDAP_TlsForward();
    __hlt_ldap::LDAP::__register_LDAP_UnbindRequest();
}

extern void __hlt_ldap::LDAP::__register_LDAP_AbandonRequest() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_AddResponse() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_AttributeSelection() {
    ::hilti::rt::detail::checkStack();
    LDAP::AttributeSelection::__parser = ::spicy::rt::Parser("LDAP::AttributeSelection"sv, ::hilti::rt::Bool(true), hlt_ldap::LDAP::AttributeSelection::parse1, hlt_ldap::LDAP::AttributeSelection::parse2, hlt_ldap::LDAP::AttributeSelection::parse3, ::hilti::rt::Null(), &type_info::__ti_LDAP__AttributeSelection_namex2aLDAP__AttributeSelectionx2b, ""s, ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(LDAP::AttributeSelection::__parser, std::string(__hlt_ldap_hlto_scope), ::hilti::rt::StrongReference<__hlt_ldap::LDAP::AttributeSelection>());
}

extern void __hlt_ldap::LDAP::__register_LDAP_AttributeValueAssertion() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_BindRequest() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_BindResponse() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_CompareResponse() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_DecodedAttributeValue() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_DelRequest() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_DelResponse() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_EncryptedMessage() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_ExtendedRequest() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_ExtendedResponse() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_ExtendedResponseEntry() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_GSS_SPNEGO_Init() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_GSS_SPNEGO_Subsequent() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_GSS_SPNEGO_negTokenInit() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_GSS_SPNEGO_negTokenResp() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_KrbWrapToken() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_MaybeEncrypted() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_Message() {
    ::hilti::rt::detail::checkStack();
    LDAP::Message::__parser = ::spicy::rt::Parser("LDAP::Message"sv, ::hilti::rt::Bool(true), ::hilti::rt::Null(), hlt_ldap::LDAP::Message::parse2, ::hilti::rt::Null(), ::hilti::rt::Null(), &type_info::__ti_LDAP__Message_namex2aLDAP__Messagex2b, ""s, ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(LDAP::Message::__parser, std::string(__hlt_ldap_hlto_scope), ::hilti::rt::StrongReference<__hlt_ldap::LDAP::Message>());
}

extern void __hlt_ldap::LDAP::__register_LDAP_MessageDispatch() {
    ::hilti::rt::detail::checkStack();
    LDAP::MessageDispatch::__parser = ::spicy::rt::Parser("LDAP::MessageDispatch"sv, ::hilti::rt::Bool(true), ::hilti::rt::Null(), hlt_ldap::LDAP::MessageDispatch::parse2, ::hilti::rt::Null(), ::hilti::rt::Null(), &type_info::__ti_LDAP__MessageDispatch_namex2aLDAP__MessageDispatchx2b, ""s, ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(LDAP::MessageDispatch::__parser, std::string(__hlt_ldap_hlto_scope), ::hilti::rt::StrongReference<__hlt_ldap::LDAP::MessageDispatch>());
}

extern void __hlt_ldap::LDAP::__register_LDAP_Messages() {
    ::hilti::rt::detail::checkStack();
    LDAP::Messages::__parser = ::spicy::rt::Parser("LDAP::Messages"sv, ::hilti::rt::Bool(true), hlt_ldap::LDAP::Messages::parse1, hlt_ldap::LDAP::Messages::parse2, hlt_ldap::LDAP::Messages::parse3, hlt_ldap::LDAP::Messages::context_new, &type_info::__ti_LDAP__Messages_namex2aLDAP__Messagesx2b, ""s, ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(LDAP::Messages::__parser, std::string(__hlt_ldap_hlto_scope), ::hilti::rt::StrongReference<__hlt_ldap::LDAP::Messages>());
}

extern void __hlt_ldap::LDAP::__register_LDAP_ModDNResponse() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_ModifyRequest() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_ModifyResponse() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_NotImplemented() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_ParseNestedAndOr() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_ParseNestedNot() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_Result() {
    ::hilti::rt::detail::checkStack();
    LDAP::Result::__parser = ::spicy::rt::Parser("LDAP::Result"sv, ::hilti::rt::Bool(true), hlt_ldap::LDAP::Result::parse1, hlt_ldap::LDAP::Result::parse2, hlt_ldap::LDAP::Result::parse3, ::hilti::rt::Null(), &type_info::__ti_LDAP__Result_namex2aLDAP__Resultx2b, ""s, ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(LDAP::Result::__parser, std::string(__hlt_ldap_hlto_scope), ::hilti::rt::StrongReference<__hlt_ldap::LDAP::Result>());
}

extern void __hlt_ldap::LDAP::__register_LDAP_SaslCredentials() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_SaslMsKrb5Stripper() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_SearchFilter() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_SearchRequest() {
    ::hilti::rt::detail::checkStack();
    LDAP::SearchRequest::__parser = ::spicy::rt::Parser("LDAP::SearchRequest"sv, ::hilti::rt::Bool(true), ::hilti::rt::Null(), hlt_ldap::LDAP::SearchRequest::parse2, ::hilti::rt::Null(), ::hilti::rt::Null(), &type_info::__ti_LDAP__SearchRequest_namex2aLDAP__SearchRequestx2b, ""s, ::hilti::rt::Vector<::spicy::rt::MIMEType>({}), ::hilti::rt::Vector<::spicy::rt::ParserPort>({}));
    ::spicy::rt::detail::registerParser(LDAP::SearchRequest::__parser, std::string(__hlt_ldap_hlto_scope), ::hilti::rt::StrongReference<__hlt_ldap::LDAP::SearchRequest>());
}

extern void __hlt_ldap::LDAP::__register_LDAP_SearchResultDone() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_SearchResultEntry() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_ServerSaslCreds() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_SubstringFilter() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_TlsForward() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_LDAP_UnbindRequest() { ::hilti::rt::detail::checkStack(); }

extern void __hlt_ldap::LDAP::__register_module() { ::hilti::rt::detail::registerModule({ "LDAP", __hlt_ldap_hlto_scope, &__init_module, nullptr, nullptr, nullptr}); }

extern auto __hlt_ldap::LDAP::bytes_sid_to_SID_repr(const ::hilti::rt::Bytes& bts) -> std::string {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:663:3-666:3");
    if ( bts.size() != ::hilti::rt::integer::safe<std::uint64_t>{24U} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:665:5-665:31");
        return "SID_FORMAT_FAILED"s;
    }

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:668:3-668:19");
    std::string ret = "S-"s;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:669:3-669:16");
    ::hilti::rt::integer::safe<uint64_t> cnt = ::hilti::rt::integer::safe<std::uint64_t>{0U};
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:673:3-688:3");

    {
        auto __seq = ::hilti::rt::Vector<::hilti::rt::Vector<::hilti::rt::integer::safe<uint64_t>>>({::hilti::rt::Vector<::hilti::rt::integer::safe<uint64_t>>({::hilti::rt::integer::safe<std::uint64_t>{0U}}), ::hilti::rt::Vector<::hilti::rt::integer::safe<uint64_t>>({::hilti::rt::integer::safe<std::uint64_t>{2U}, ::hilti::rt::integer::safe<std::uint64_t>{3U}, ::hilti::rt::integer::safe<std::uint64_t>{4U}, ::hilti::rt::integer::safe<std::uint64_t>{5U}, ::hilti::rt::integer::safe<std::uint64_t>{6U}, ::hilti::rt::integer::safe<std::uint64_t>{7U}}), ::hilti::rt::Vector<::hilti::rt::integer::safe<uint64_t>>({::hilti::rt::integer::safe<std::uint64_t>{11U}, ::hilti::rt::integer::safe<std::uint64_t>{10U}, ::hilti::rt::integer::safe<std::uint64_t>{9U}, ::hilti::rt::integer::safe<std::uint64_t>{8U}}), ::hilti::rt::Vector<::hilti::rt::integer::safe<uint64_t>>({::hilti::rt::integer::safe<std::uint64_t>{15U}, ::hilti::rt::integer::safe<std::uint64_t>{14U}, ::hilti::rt::integer::safe<std::uint64_t>{13U}, ::hilti::rt::integer::safe<std::uint64_t>{12U}}), ::hilti::rt::Vector<::hilti::rt::integer::safe<uint64_t>>({::hilti::rt::integer::safe<std::uint64_t>{19U}, ::hilti::rt::integer::safe<std::uint64_t>{18U}, ::hilti::rt::integer::safe<std::uint64_t>{17U}, ::hilti::rt::integer::safe<std::uint64_t>{16U}}), ::hilti::rt::Vector<::hilti::rt::integer::safe<uint64_t>>({::hilti::rt::integer::safe<std::uint64_t>{23U}, ::hilti::rt::integer::safe<std::uint64_t>{22U}, ::hilti::rt::integer::safe<std::uint64_t>{21U}, ::hilti::rt::integer::safe<std::uint64_t>{20U}})});
        for ( const auto& i : ::hilti::rt::range(__seq) ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:674:5-674:35");
            ::hilti::rt::Bytes dec_val_rep = ""_b;
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:675:5-679:5");
            for ( const auto& j : i ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:676:7-676:35");
                ::hilti::rt::integer::safe<uint8_t> bt = *bts.at(j);
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:677:7-677:23");
                dec_val_rep.append(bt);
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:678:7-678:14");
                cnt += ::hilti::rt::integer::safe<std::uint64_t>{1U};
            }

              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:682:5-682:65");
            ret = ret + ::hilti::rt::fmt("%u"s, dec_val_rep.toUInt(::hilti::rt::ByteOrder{::hilti::rt::ByteOrder::Big}));
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:685:5-687:5");
            if ( cnt < ::hilti::rt::integer::safe<std::uint64_t>{23U} ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:686:7-686:21");
                ret = ret + "-"s;
            }
        }
    }

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:689:3-689:13");
    return ret;
}

extern auto __hlt_ldap::LDAP::bytes_sid_to_hex_repr(const ::hilti::rt::Bytes& bts) -> std::string {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:644:3-644:17");
    std::string ret = ""s;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:645:3-645:16");
    ::hilti::rt::integer::safe<uint64_t> cnt = ::hilti::rt::integer::safe<std::uint64_t>{0U};
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:647:3-655:3");
    while ( cnt < bts.size() ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:648:5-648:35");
        ::hilti::rt::integer::safe<uint8_t> bt = *bts.at(cnt);
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:649:5-649:27");
        ret = ret + ::hilti::rt::fmt("%02x"s, bt);
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:651:5-653:5");
        if ( cnt < bts.size() - ::hilti::rt::integer::safe<std::uint64_t>{1U} ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:652:7-652:21");
            ret = ret + ":"s;
        }

          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:654:5-654:12");
        cnt += ::hilti::rt::integer::safe<std::uint64_t>{1U};
    }

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:656:3-656:13");
    return ret;
}

inline auto __hlt_ldap::LDAP::operator<<(std::ostream& o, BindAuthType x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

inline auto __hlt_ldap::LDAP::operator<<(std::ostream& o, MessageMode x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::Ctx& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::GSS_SPNEGO_negTokenInit& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::GSS_SPNEGO_Init& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::GSS_SPNEGO_negTokenResp& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::GSS_SPNEGO_Subsequent& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

inline auto __hlt_ldap::LDAP::operator<<(std::ostream& o, ProtocolOpcode x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

inline auto __hlt_ldap::LDAP::operator<<(std::ostream& o, ResultCode x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::Result& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::SaslCredentials& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

inline auto __hlt_ldap::LDAP::operator<<(std::ostream& o, SearchDerefAlias x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

inline auto __hlt_ldap::LDAP::operator<<(std::ostream& o, SearchScope x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::ServerSaslCreds& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::UnbindRequest& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::Message& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::SearchResultEntry& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::SearchResultDone& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::SearchRequest& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::NotImplemented& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::ModifyResponse& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::ModifyRequest& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::ModDNResponse& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::BindRequest& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::BindResponse& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::AddResponse& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::DelRequest& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::DelResponse& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::CompareResponse& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::AbandonRequest& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::ExtendedRequest& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::ExtendedResponse& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::ExtendedResponseEntry& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::AttributeSelection& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::AttributeValueAssertion& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

inline auto __hlt_ldap::LDAP::operator<<(std::ostream& o, FilterType x) -> std::ostream& { o << ::hilti::rt::to_string(x); return o; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::DecodedAttributeValue& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::EncryptedMessage& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::KrbWrapToken& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::SaslMsKrb5Stripper& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::TlsForward& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::MessageDispatch& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::MaybeEncrypted& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::Messages& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::SubstringFilter& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::SearchFilter& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::ParseNestedAndOr& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::operator<<(std::ostream& o, const __hlt_ldap::LDAP::ParseNestedNot& x) -> std::ostream& { return o << ::hilti::rt::to_string(x);; }

extern auto __hlt_ldap::LDAP::string_representation(const ::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchFilter>& search_filter) -> std::string {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:711:5-711:23");
    std::string repr;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:713:5-813:5");
    if ( LDAP::FilterType fType = (*search_filter).filterType; fType == LDAP::FilterType{LDAP::FilterType::FILTER_NOT} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:718:9-718:83");
        repr = ::hilti::rt::fmt("(!%s)"s, (*::hilti::rt::optional::value((*::hilti::rt::optional::value((*search_filter).FILTER_NOT)).searchfilter)).stringRepresentation);
    }

    else if ( fType == LDAP::FilterType{LDAP::FilterType::FILTER_AND} || fType == LDAP::FilterType{LDAP::FilterType::FILTER_OR} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:722:9-722:42");
        ::hilti::rt::ValueReference<__hlt_ldap::LDAP::ParseNestedAndOr> nestedObj;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:723:9-723:29");
        std::string printChar = ""s;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:725:9-731:9");
        if ( fType == LDAP::FilterType{LDAP::FilterType::FILTER_AND} ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:726:11-726:25");
            printChar = "&"s;
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:727:11-727:46");
            nestedObj = ::hilti::rt::optional::value((*search_filter).FILTER_AND);
        }
        else {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:729:11-729:25");
            printChar = "|"s;
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:730:11-730:45");
            nestedObj = ::hilti::rt::optional::value((*search_filter).FILTER_OR);
        }

          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:753:9-753:20");
        ::hilti::rt::integer::safe<uint64_t> i = ::hilti::rt::integer::safe<std::uint64_t>{0U};
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:754:9-772:9");
        for ( const auto& searchFilter : ::hilti::rt::optional::value((*nestedObj).searchfilters) ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:755:11-770:11");
            if ( ::hilti::rt::integer::safe<uint64_t> __x = i; __x == ::hilti::rt::integer::safe<std::uint64_t>{0U} ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:757:15-762:15");
                repr = ::hilti::rt::fmt("(%s%s%s"s, printChar, searchFilter.stringRepresentation, (::hilti::rt::optional::value((*nestedObj).searchfilters).size() == ::hilti::rt::integer::safe<std::uint64_t>{1U} ? ")"s : ""s));
            }

            else if ( __x == ::hilti::rt::integer::safe<std::uint64_t>{1U} ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:765:15-765:67");
                repr = repr + searchFilter.stringRepresentation + ")"s;
            }

            else  {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:768:15-768:87");
                repr = ::hilti::rt::fmt("(%s"s, printChar) + repr + searchFilter.stringRepresentation + ")"s;
            }

              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:771:11-771:16");
            i += ::hilti::rt::integer::safe<std::uint64_t>{1U};
        }
    }

    else if ( fType == LDAP::FilterType{LDAP::FilterType::FILTER_EXT} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:780:9-782:68");
        repr = ::hilti::rt::fmt("(%s:%s:=%s)"s, (*::hilti::rt::optional::value((*search_filter).FILTER_EXT)).assertionValueDecoded, ::hilti::rt::optional::value((*::hilti::rt::optional::value((*search_filter).FILTER_EXT)).attributeDesc).decode(::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::UTF8}, ::hilti::rt::bytes::DecodeErrorStrategy{::hilti::rt::bytes::DecodeErrorStrategy::REPLACE}), ::hilti::rt::optional::value((*::hilti::rt::optional::value((*search_filter).FILTER_EXT)).matchValue));
    }

    else if ( fType == LDAP::FilterType{LDAP::FilterType::FILTER_APPROX} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:785:9-786:79");
        repr = ::hilti::rt::fmt("(%s~=%s)"s, ::hilti::rt::optional::value((*::hilti::rt::optional::value((*search_filter).FILTER_APPROX)).attributeDesc).decode(::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::UTF8}, ::hilti::rt::bytes::DecodeErrorStrategy{::hilti::rt::bytes::DecodeErrorStrategy::REPLACE}), (*::hilti::rt::optional::value((*search_filter).FILTER_APPROX)).assertionValueDecoded);
    }

    else if ( fType == LDAP::FilterType{LDAP::FilterType::FILTER_EQ} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:789:9-790:74");
        repr = ::hilti::rt::fmt("(%s=%s)"s, ::hilti::rt::optional::value((*::hilti::rt::optional::value((*search_filter).FILTER_EQ)).attributeDesc).decode(::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::UTF8}, ::hilti::rt::bytes::DecodeErrorStrategy{::hilti::rt::bytes::DecodeErrorStrategy::REPLACE}), (*::hilti::rt::optional::value((*search_filter).FILTER_EQ)).assertionValueDecoded);
    }

    else if ( fType == LDAP::FilterType{LDAP::FilterType::FILTER_GE} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:793:9-794:75");
        repr = ::hilti::rt::fmt("(%s>=%s)"s, ::hilti::rt::optional::value((*::hilti::rt::optional::value((*search_filter).FILTER_GE)).attributeDesc).decode(::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::UTF8}, ::hilti::rt::bytes::DecodeErrorStrategy{::hilti::rt::bytes::DecodeErrorStrategy::REPLACE}), (*::hilti::rt::optional::value((*search_filter).FILTER_GE)).assertionValueDecoded);
    }

    else if ( fType == LDAP::FilterType{LDAP::FilterType::FILTER_LE} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:797:9-798:75");
        repr = ::hilti::rt::fmt("(%s<=%s)"s, ::hilti::rt::optional::value((*::hilti::rt::optional::value((*search_filter).FILTER_LE)).attributeDesc).decode(::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::UTF8}, ::hilti::rt::bytes::DecodeErrorStrategy{::hilti::rt::bytes::DecodeErrorStrategy::REPLACE}), (*::hilti::rt::optional::value((*search_filter).FILTER_LE)).assertionValueDecoded);
    }

    else if ( fType == LDAP::FilterType{LDAP::FilterType::FILTER_SUBSTR} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:801:9-801:32");
        std::string anys = ""s;
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:802:9-803:76");
        if ( (*::hilti::rt::optional::value((*search_filter).FILTER_SUBSTR)).anys.size() > ::hilti::rt::integer::safe<std::uint64_t>{0U} ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:803:11-803:75");
            anys = "*"_b.join((*::hilti::rt::optional::value((*search_filter).FILTER_SUBSTR)).anys).decode(::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::UTF8}, ::hilti::rt::bytes::DecodeErrorStrategy{::hilti::rt::bytes::DecodeErrorStrategy::REPLACE}) + "*"s;
        }

          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:805:9-808:68");
        repr = ::hilti::rt::fmt("(%s=%s*%s%s)"s, ::hilti::rt::optional::value((*::hilti::rt::optional::value((*search_filter).FILTER_SUBSTR)).attributeDesc).decode(::hilti::rt::bytes::Charset{::hilti::rt::bytes::Charset::UTF8}, ::hilti::rt::bytes::DecodeErrorStrategy{::hilti::rt::bytes::DecodeErrorStrategy::REPLACE}), (*::hilti::rt::optional::value((*search_filter).FILTER_SUBSTR)).initial, anys, (*::hilti::rt::optional::value((*search_filter).FILTER_SUBSTR)).final);
    }

    else if ( fType == LDAP::FilterType{LDAP::FilterType::FILTER_PRESENT} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:811:9-811:54");
        repr = ::hilti::rt::fmt("(%s=*)"s, ::hilti::rt::optional::value((*search_filter).FILTER_PRESENT));
    }

    else  {
        throw ::hilti::rt::UnhandledSwitchCase(::hilti::rt::to_string_for_print(fType), "/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:713:5-813:5");
    }

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:815:5-815:16");
    return repr;
}

extern auto __hlt_ldap::LDAP::uint32_to_hex_repr(const ::hilti::rt::Bytes& bts) -> std::string {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:695:3-698:3");
    if ( bts.size() != ::hilti::rt::integer::safe<std::uint64_t>{4U} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:697:5-697:31");
        return "HEX_FORMAT_FAILED"s;
    }

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:701:3-701:19");
    std::string ret = "0x"s;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:702:3-705:3");

    {
        auto __seq = ::hilti::rt::Vector<::hilti::rt::integer::safe<uint64_t>>({::hilti::rt::integer::safe<std::uint64_t>{3U}, ::hilti::rt::integer::safe<std::uint64_t>{2U}, ::hilti::rt::integer::safe<std::uint64_t>{1U}, ::hilti::rt::integer::safe<std::uint64_t>{0U}});
        for ( const auto& i : ::hilti::rt::range(__seq) ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:703:5-703:33");
            ::hilti::rt::integer::safe<uint8_t> bt = *bts.at(i);
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:704:5-704:27");
            ret = ret + ::hilti::rt::fmt("%02x"s, bt);
        }
    }

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:706:3-706:13");
    return ret;
}

extern auto __hlt_ldap::LDAP::utf16_guid_to_hex_repr(const ::hilti::rt::Bytes& bts) -> std::string {
    ::hilti::rt::detail::checkStack();
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:625:3-628:3");
    if ( bts.size() != ::hilti::rt::integer::safe<std::uint64_t>{16U} ) {
          __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:627:5-627:32");
        return "GUID_FORMAT_FAILED"s;
    }

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:630:3-630:17");
    std::string ret = ""s;
      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:631:3-639:3");

    {
        auto __seq = ::hilti::rt::Vector<::hilti::rt::Vector<::hilti::rt::integer::safe<uint64_t>>>({::hilti::rt::Vector<::hilti::rt::integer::safe<uint64_t>>({::hilti::rt::integer::safe<std::uint64_t>{3U}, ::hilti::rt::integer::safe<std::uint64_t>{2U}, ::hilti::rt::integer::safe<std::uint64_t>{1U}, ::hilti::rt::integer::safe<std::uint64_t>{0U}}), ::hilti::rt::Vector<::hilti::rt::integer::safe<uint64_t>>({::hilti::rt::integer::safe<std::uint64_t>{5U}, ::hilti::rt::integer::safe<std::uint64_t>{4U}}), ::hilti::rt::Vector<::hilti::rt::integer::safe<uint64_t>>({::hilti::rt::integer::safe<std::uint64_t>{7U}, ::hilti::rt::integer::safe<std::uint64_t>{6U}}), ::hilti::rt::Vector<::hilti::rt::integer::safe<uint64_t>>({::hilti::rt::integer::safe<std::uint64_t>{8U}, ::hilti::rt::integer::safe<std::uint64_t>{9U}}), ::hilti::rt::Vector<::hilti::rt::integer::safe<uint64_t>>({::hilti::rt::integer::safe<std::uint64_t>{10U}, ::hilti::rt::integer::safe<std::uint64_t>{11U}, ::hilti::rt::integer::safe<std::uint64_t>{12U}, ::hilti::rt::integer::safe<std::uint64_t>{13U}, ::hilti::rt::integer::safe<std::uint64_t>{14U}, ::hilti::rt::integer::safe<std::uint64_t>{15U}})});
        for ( const auto& i : ::hilti::rt::range(__seq) ) {
              __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:632:5-638:5");
            for ( const auto& j : i ) {
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:633:7-633:35");
                ::hilti::rt::integer::safe<uint8_t> bt = *bts.at(j);
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:634:7-634:29");
                ret = ret + ::hilti::rt::fmt("%02x"s, bt);
                  __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:635:7-637:7");
                if ( ::hilti::rt::Set<::hilti::rt::integer::safe<uint64_t>>({::hilti::rt::integer::safe<std::uint64_t>{0U}, ::hilti::rt::integer::safe<std::uint64_t>{4U}, ::hilti::rt::integer::safe<std::uint64_t>{6U}, ::hilti::rt::integer::safe<std::uint64_t>{9U}}).contains(j) ) {
                      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:636:9-636:23");
                    ret = ret + "-"s;
                }
            }
        }
    }

      __location__("/build/zeek/src/zeek/src/analyzer/protocol/ldap/ldap.spicy:640:3-640:13");
    return ret;
}

inline auto hilti::rt::detail::adl::to_string(__hlt_ldap::ASN1::ASN1Class x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_ldap::ASN1::ASN1Class::Private: return "ASN1Class::Private";
        case __hlt_ldap::ASN1::ASN1Class::ContextSpecific: return "ASN1Class::ContextSpecific";
        case __hlt_ldap::ASN1::ASN1Class::Application: return "ASN1Class::Application";
        case __hlt_ldap::ASN1::ASN1Class::Universal: return "ASN1Class::Universal";
        case __hlt_ldap::ASN1::ASN1Class::Undef: return "ASN1Class::Undef";
        default: return ::hilti::rt::fmt("ASN1Class::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_ldap::ASN1::ASN1Type x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_ldap::ASN1::ASN1Type::BMPString: return "ASN1Type::BMPString";
        case __hlt_ldap::ASN1::ASN1Type::CharacterString: return "ASN1Type::CharacterString";
        case __hlt_ldap::ASN1::ASN1Type::UniversalString: return "ASN1Type::UniversalString";
        case __hlt_ldap::ASN1::ASN1Type::GeneralString: return "ASN1Type::GeneralString";
        case __hlt_ldap::ASN1::ASN1Type::VisibleString: return "ASN1Type::VisibleString";
        case __hlt_ldap::ASN1::ASN1Type::GraphicString: return "ASN1Type::GraphicString";
        case __hlt_ldap::ASN1::ASN1Type::GeneralizedTime: return "ASN1Type::GeneralizedTime";
        case __hlt_ldap::ASN1::ASN1Type::UTCTime: return "ASN1Type::UTCTime";
        case __hlt_ldap::ASN1::ASN1Type::IA5String: return "ASN1Type::IA5String";
        case __hlt_ldap::ASN1::ASN1Type::VideotextString: return "ASN1Type::VideotextString";
        case __hlt_ldap::ASN1::ASN1Type::TeletextString: return "ASN1Type::TeletextString";
        case __hlt_ldap::ASN1::ASN1Type::PrintableString: return "ASN1Type::PrintableString";
        case __hlt_ldap::ASN1::ASN1Type::NumericString: return "ASN1Type::NumericString";
        case __hlt_ldap::ASN1::ASN1Type::Set: return "ASN1Type::Set";
        case __hlt_ldap::ASN1::ASN1Type::Sequence: return "ASN1Type::Sequence";
        case __hlt_ldap::ASN1::ASN1Type::RelativeOID: return "ASN1Type::RelativeOID";
        case __hlt_ldap::ASN1::ASN1Type::UTF8String: return "ASN1Type::UTF8String";
        case __hlt_ldap::ASN1::ASN1Type::EmbeddedPDV: return "ASN1Type::EmbeddedPDV";
        case __hlt_ldap::ASN1::ASN1Type::Enumerated: return "ASN1Type::Enumerated";
        case __hlt_ldap::ASN1::ASN1Type::Real: return "ASN1Type::Real";
        case __hlt_ldap::ASN1::ASN1Type::InstanceOf: return "ASN1Type::InstanceOf";
        case __hlt_ldap::ASN1::ASN1Type::ObjectDescriptor: return "ASN1Type::ObjectDescriptor";
        case __hlt_ldap::ASN1::ASN1Type::ObjectIdentifier: return "ASN1Type::ObjectIdentifier";
        case __hlt_ldap::ASN1::ASN1Type::NullVal: return "ASN1Type::NullVal";
        case __hlt_ldap::ASN1::ASN1Type::OctetString: return "ASN1Type::OctetString";
        case __hlt_ldap::ASN1::ASN1Type::BitString: return "ASN1Type::BitString";
        case __hlt_ldap::ASN1::ASN1Type::Integer: return "ASN1Type::Integer";
        case __hlt_ldap::ASN1::ASN1Type::Boolean: return "ASN1Type::Boolean";
        case __hlt_ldap::ASN1::ASN1Type::Undef: return "ASN1Type::Undef";
        default: return ::hilti::rt::fmt("ASN1Type::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_ldap::LDAP::BindAuthType x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_ldap::LDAP::BindAuthType::BIND_AUTH_SASL: return "BindAuthType::BIND_AUTH_SASL";
        case __hlt_ldap::LDAP::BindAuthType::BIND_AUTH_SIMPLE: return "BindAuthType::BIND_AUTH_SIMPLE";
        case __hlt_ldap::LDAP::BindAuthType::Undef: return "BindAuthType::Undef";
        default: return ::hilti::rt::fmt("BindAuthType::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_ldap::LDAP::MessageMode x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_ldap::LDAP::MessageMode::ENCRYPTED: return "MessageMode::ENCRYPTED";
        case __hlt_ldap::LDAP::MessageMode::CLEARTEXT: return "MessageMode::CLEARTEXT";
        case __hlt_ldap::LDAP::MessageMode::MAYBE_ENCRYPTED: return "MessageMode::MAYBE_ENCRYPTED";
        case __hlt_ldap::LDAP::MessageMode::TLS: return "MessageMode::TLS";
        case __hlt_ldap::LDAP::MessageMode::MS_KRB5: return "MessageMode::MS_KRB5";
        case __hlt_ldap::LDAP::MessageMode::Undef: return "MessageMode::Undef";
        default: return ::hilti::rt::fmt("MessageMode::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_ldap::LDAP::ProtocolOpcode x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_ldap::LDAP::ProtocolOpcode::INTERMEDIATE_RESPONSE: return "ProtocolOpcode::INTERMEDIATE_RESPONSE";
        case __hlt_ldap::LDAP::ProtocolOpcode::EXTENDED_RESPONSE: return "ProtocolOpcode::EXTENDED_RESPONSE";
        case __hlt_ldap::LDAP::ProtocolOpcode::EXTENDED_REQUEST: return "ProtocolOpcode::EXTENDED_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::SEARCH_RESULT_REFERENCE: return "ProtocolOpcode::SEARCH_RESULT_REFERENCE";
        case __hlt_ldap::LDAP::ProtocolOpcode::ABANDON_REQUEST: return "ProtocolOpcode::ABANDON_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::COMPARE_RESPONSE: return "ProtocolOpcode::COMPARE_RESPONSE";
        case __hlt_ldap::LDAP::ProtocolOpcode::COMPARE_REQUEST: return "ProtocolOpcode::COMPARE_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::MOD_DN_RESPONSE: return "ProtocolOpcode::MOD_DN_RESPONSE";
        case __hlt_ldap::LDAP::ProtocolOpcode::MOD_DN_REQUEST: return "ProtocolOpcode::MOD_DN_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::DEL_RESPONSE: return "ProtocolOpcode::DEL_RESPONSE";
        case __hlt_ldap::LDAP::ProtocolOpcode::DEL_REQUEST: return "ProtocolOpcode::DEL_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::ADD_RESPONSE: return "ProtocolOpcode::ADD_RESPONSE";
        case __hlt_ldap::LDAP::ProtocolOpcode::ADD_REQUEST: return "ProtocolOpcode::ADD_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::MODIFY_RESPONSE: return "ProtocolOpcode::MODIFY_RESPONSE";
        case __hlt_ldap::LDAP::ProtocolOpcode::MODIFY_REQUEST: return "ProtocolOpcode::MODIFY_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::SEARCH_RESULT_DONE: return "ProtocolOpcode::SEARCH_RESULT_DONE";
        case __hlt_ldap::LDAP::ProtocolOpcode::SEARCH_RESULT_ENTRY: return "ProtocolOpcode::SEARCH_RESULT_ENTRY";
        case __hlt_ldap::LDAP::ProtocolOpcode::SEARCH_REQUEST: return "ProtocolOpcode::SEARCH_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::UNBIND_REQUEST: return "ProtocolOpcode::UNBIND_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::BIND_RESPONSE: return "ProtocolOpcode::BIND_RESPONSE";
        case __hlt_ldap::LDAP::ProtocolOpcode::BIND_REQUEST: return "ProtocolOpcode::BIND_REQUEST";
        case __hlt_ldap::LDAP::ProtocolOpcode::Undef: return "ProtocolOpcode::Undef";
        default: return ::hilti::rt::fmt("ProtocolOpcode::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_ldap::LDAP::ResultCode x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_ldap::LDAP::ResultCode::AUTHORIZATION_DENIED: return "ResultCode::AUTHORIZATION_DENIED";
        case __hlt_ldap::LDAP::ResultCode::ASSERTION_FAILED: return "ResultCode::ASSERTION_FAILED";
        case __hlt_ldap::LDAP::ResultCode::CANNOT_CANCEL: return "ResultCode::CANNOT_CANCEL";
        case __hlt_ldap::LDAP::ResultCode::TOO_LATE: return "ResultCode::TOO_LATE";
        case __hlt_ldap::LDAP::ResultCode::NO_SUCH_OPERATION: return "ResultCode::NO_SUCH_OPERATION";
        case __hlt_ldap::LDAP::ResultCode::CANCELED: return "ResultCode::CANCELED";
        case __hlt_ldap::LDAP::ResultCode::LCUP_RELOAD_REQUIRED: return "ResultCode::LCUP_RELOAD_REQUIRED";
        case __hlt_ldap::LDAP::ResultCode::LCUP_UNSUPPORTED_SCHEME: return "ResultCode::LCUP_UNSUPPORTED_SCHEME";
        case __hlt_ldap::LDAP::ResultCode::LCUP_INVALID_DATA: return "ResultCode::LCUP_INVALID_DATA";
        case __hlt_ldap::LDAP::ResultCode::UNKNOWN_TYPE: return "ResultCode::UNKNOWN_TYPE";
        case __hlt_ldap::LDAP::ResultCode::INTERMEDIATE_RESPONSE: return "ResultCode::INTERMEDIATE_RESPONSE";
        case __hlt_ldap::LDAP::ResultCode::TLS_NOT_SUPPORTED: return "ResultCode::TLS_NOT_SUPPORTED";
        case __hlt_ldap::LDAP::ResultCode::AMBIGUOUS_RESPONSE: return "ResultCode::AMBIGUOUS_RESPONSE";
        case __hlt_ldap::LDAP::ResultCode::INVALID_RESPONSE: return "ResultCode::INVALID_RESPONSE";
        case __hlt_ldap::LDAP::ResultCode::REFERRAL_LIMIT_EXCEEDED: return "ResultCode::REFERRAL_LIMIT_EXCEEDED";
        case __hlt_ldap::LDAP::ResultCode::CLIENT_LOOP: return "ResultCode::CLIENT_LOOP";
        case __hlt_ldap::LDAP::ResultCode::MORE_RESULTS_TO_RETURN: return "ResultCode::MORE_RESULTS_TO_RETURN";
        case __hlt_ldap::LDAP::ResultCode::NO_RESULTS_RETURNED: return "ResultCode::NO_RESULTS_RETURNED";
        case __hlt_ldap::LDAP::ResultCode::CONTROL_NOT_FOUND: return "ResultCode::CONTROL_NOT_FOUND";
        case __hlt_ldap::LDAP::ResultCode::NOT_SUPPORTED: return "ResultCode::NOT_SUPPORTED";
        case __hlt_ldap::LDAP::ResultCode::CONNECT_ERROR: return "ResultCode::CONNECT_ERROR";
        case __hlt_ldap::LDAP::ResultCode::NO_MEMORY: return "ResultCode::NO_MEMORY";
        case __hlt_ldap::LDAP::ResultCode::PARAM_ERROR: return "ResultCode::PARAM_ERROR";
        case __hlt_ldap::LDAP::ResultCode::USER_CANCELED: return "ResultCode::USER_CANCELED";
        case __hlt_ldap::LDAP::ResultCode::FILTER_ERROR: return "ResultCode::FILTER_ERROR";
        case __hlt_ldap::LDAP::ResultCode::AUTH_UNKNOWN: return "ResultCode::AUTH_UNKNOWN";
        case __hlt_ldap::LDAP::ResultCode::TIMEOUT: return "ResultCode::TIMEOUT";
        case __hlt_ldap::LDAP::ResultCode::DECODING_ERROR: return "ResultCode::DECODING_ERROR";
        case __hlt_ldap::LDAP::ResultCode::ENCODING_ERROR: return "ResultCode::ENCODING_ERROR";
        case __hlt_ldap::LDAP::ResultCode::LOCAL_ERROR: return "ResultCode::LOCAL_ERROR";
        case __hlt_ldap::LDAP::ResultCode::SERVER_DOWN: return "ResultCode::SERVER_DOWN";
        case __hlt_ldap::LDAP::ResultCode::OTHER: return "ResultCode::OTHER";
        case __hlt_ldap::LDAP::ResultCode::CONTROL_ERROR: return "ResultCode::CONTROL_ERROR";
        case __hlt_ldap::LDAP::ResultCode::AFFECTS_MULTIPLE_DSAS: return "ResultCode::AFFECTS_MULTIPLE_DSAS";
        case __hlt_ldap::LDAP::ResultCode::RESULTS_TOO_LARGE: return "ResultCode::RESULTS_TOO_LARGE";
        case __hlt_ldap::LDAP::ResultCode::OBJECT_CLASS_MODS_PROHIBITED: return "ResultCode::OBJECT_CLASS_MODS_PROHIBITED";
        case __hlt_ldap::LDAP::ResultCode::ENTRY_ALREADY_EXISTS: return "ResultCode::ENTRY_ALREADY_EXISTS";
        case __hlt_ldap::LDAP::ResultCode::NOT_ALLOWED_ON_RDN: return "ResultCode::NOT_ALLOWED_ON_RDN";
        case __hlt_ldap::LDAP::ResultCode::NOT_ALLOWED_ON_NON_LEAF: return "ResultCode::NOT_ALLOWED_ON_NON_LEAF";
        case __hlt_ldap::LDAP::ResultCode::OBJECT_CLASS_VIOLATION: return "ResultCode::OBJECT_CLASS_VIOLATION";
        case __hlt_ldap::LDAP::ResultCode::NAMING_VIOLATION: return "ResultCode::NAMING_VIOLATION";
        case __hlt_ldap::LDAP::ResultCode::OFFSET_RANGE_ERROR: return "ResultCode::OFFSET_RANGE_ERROR";
        case __hlt_ldap::LDAP::ResultCode::SORT_CONTROL_MISSING: return "ResultCode::SORT_CONTROL_MISSING";
        case __hlt_ldap::LDAP::ResultCode::LOOP_DETECT: return "ResultCode::LOOP_DETECT";
        case __hlt_ldap::LDAP::ResultCode::UNWILLING_TO_PERFORM: return "ResultCode::UNWILLING_TO_PERFORM";
        case __hlt_ldap::LDAP::ResultCode::UNAVAILABLE: return "ResultCode::UNAVAILABLE";
        case __hlt_ldap::LDAP::ResultCode::BUSY: return "ResultCode::BUSY";
        case __hlt_ldap::LDAP::ResultCode::INSUFFICIENT_ACCESS_RIGHTS: return "ResultCode::INSUFFICIENT_ACCESS_RIGHTS";
        case __hlt_ldap::LDAP::ResultCode::INVALID_CREDENTIALS: return "ResultCode::INVALID_CREDENTIALS";
        case __hlt_ldap::LDAP::ResultCode::INAPPROPRIATE_AUTHENTICATION: return "ResultCode::INAPPROPRIATE_AUTHENTICATION";
        case __hlt_ldap::LDAP::ResultCode::ALIAS_DEREFERENCING_PROBLEM: return "ResultCode::ALIAS_DEREFERENCING_PROBLEM";
        case __hlt_ldap::LDAP::ResultCode::INVALID_DNSYNTAX: return "ResultCode::INVALID_DNSYNTAX";
        case __hlt_ldap::LDAP::ResultCode::ALIAS_PROBLEM: return "ResultCode::ALIAS_PROBLEM";
        case __hlt_ldap::LDAP::ResultCode::NO_SUCH_OBJECT: return "ResultCode::NO_SUCH_OBJECT";
        case __hlt_ldap::LDAP::ResultCode::INVALID_ATTRIBUTE_SYNTAX: return "ResultCode::INVALID_ATTRIBUTE_SYNTAX";
        case __hlt_ldap::LDAP::ResultCode::ATTRIBUTE_OR_VALUE_EXISTS: return "ResultCode::ATTRIBUTE_OR_VALUE_EXISTS";
        case __hlt_ldap::LDAP::ResultCode::CONSTRAINT_VIOLATION: return "ResultCode::CONSTRAINT_VIOLATION";
        case __hlt_ldap::LDAP::ResultCode::INAPPROPRIATE_MATCHING: return "ResultCode::INAPPROPRIATE_MATCHING";
        case __hlt_ldap::LDAP::ResultCode::UNDEFINED_ATTRIBUTE_TYPE: return "ResultCode::UNDEFINED_ATTRIBUTE_TYPE";
        case __hlt_ldap::LDAP::ResultCode::NO_SUCH_ATTRIBUTE: return "ResultCode::NO_SUCH_ATTRIBUTE";
        case __hlt_ldap::LDAP::ResultCode::SASL_BIND_IN_PROGRESS: return "ResultCode::SASL_BIND_IN_PROGRESS";
        case __hlt_ldap::LDAP::ResultCode::CONFIDENTIALITY_REQUIRED: return "ResultCode::CONFIDENTIALITY_REQUIRED";
        case __hlt_ldap::LDAP::ResultCode::UNAVAILABLE_CRITICAL_EXTENSION: return "ResultCode::UNAVAILABLE_CRITICAL_EXTENSION";
        case __hlt_ldap::LDAP::ResultCode::ADMIN_LIMIT_EXCEEDED: return "ResultCode::ADMIN_LIMIT_EXCEEDED";
        case __hlt_ldap::LDAP::ResultCode::REFERRAL: return "ResultCode::REFERRAL";
        case __hlt_ldap::LDAP::ResultCode::PARTIAL_RESULTS: return "ResultCode::PARTIAL_RESULTS";
        case __hlt_ldap::LDAP::ResultCode::STRONGER_AUTH_REQUIRED: return "ResultCode::STRONGER_AUTH_REQUIRED";
        case __hlt_ldap::LDAP::ResultCode::AUTH_METHOD_NOT_SUPPORTED: return "ResultCode::AUTH_METHOD_NOT_SUPPORTED";
        case __hlt_ldap::LDAP::ResultCode::COMPARE_TRUE: return "ResultCode::COMPARE_TRUE";
        case __hlt_ldap::LDAP::ResultCode::COMPARE_FALSE: return "ResultCode::COMPARE_FALSE";
        case __hlt_ldap::LDAP::ResultCode::SIZE_LIMIT_EXCEEDED: return "ResultCode::SIZE_LIMIT_EXCEEDED";
        case __hlt_ldap::LDAP::ResultCode::TIME_LIMIT_EXCEEDED: return "ResultCode::TIME_LIMIT_EXCEEDED";
        case __hlt_ldap::LDAP::ResultCode::PROTOCOL_ERROR: return "ResultCode::PROTOCOL_ERROR";
        case __hlt_ldap::LDAP::ResultCode::OPERATIONS_ERROR: return "ResultCode::OPERATIONS_ERROR";
        case __hlt_ldap::LDAP::ResultCode::SUCCESS: return "ResultCode::SUCCESS";
        case __hlt_ldap::LDAP::ResultCode::Undef: return "ResultCode::Undef";
        default: return ::hilti::rt::fmt("ResultCode::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_ldap::LDAP::SearchDerefAlias x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_ldap::LDAP::SearchDerefAlias::DEREF_ALWAYS: return "SearchDerefAlias::DEREF_ALWAYS";
        case __hlt_ldap::LDAP::SearchDerefAlias::DEREF_FINDING_BASE: return "SearchDerefAlias::DEREF_FINDING_BASE";
        case __hlt_ldap::LDAP::SearchDerefAlias::DEREF_IN_SEARCHING: return "SearchDerefAlias::DEREF_IN_SEARCHING";
        case __hlt_ldap::LDAP::SearchDerefAlias::DEREF_NEVER: return "SearchDerefAlias::DEREF_NEVER";
        case __hlt_ldap::LDAP::SearchDerefAlias::Undef: return "SearchDerefAlias::Undef";
        default: return ::hilti::rt::fmt("SearchDerefAlias::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_ldap::LDAP::SearchScope x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_ldap::LDAP::SearchScope::SEARCH_TREE: return "SearchScope::SEARCH_TREE";
        case __hlt_ldap::LDAP::SearchScope::SEARCH_SINGLE: return "SearchScope::SEARCH_SINGLE";
        case __hlt_ldap::LDAP::SearchScope::SEARCH_BASE: return "SearchScope::SEARCH_BASE";
        case __hlt_ldap::LDAP::SearchScope::Undef: return "SearchScope::Undef";
        default: return ::hilti::rt::fmt("SearchScope::<unknown-%" PRIu64 ">", x.value());
    }
}

inline auto hilti::rt::detail::adl::to_string(__hlt_ldap::LDAP::FilterType x, adl::tag) -> std::string {
    switch ( x.value() ) {
        case __hlt_ldap::LDAP::FilterType::FILTER_INVALID: return "FilterType::FILTER_INVALID";
        case __hlt_ldap::LDAP::FilterType::FILTER_EXT: return "FilterType::FILTER_EXT";
        case __hlt_ldap::LDAP::FilterType::FILTER_APPROX: return "FilterType::FILTER_APPROX";
        case __hlt_ldap::LDAP::FilterType::FILTER_PRESENT: return "FilterType::FILTER_PRESENT";
        case __hlt_ldap::LDAP::FilterType::FILTER_LE: return "FilterType::FILTER_LE";
        case __hlt_ldap::LDAP::FilterType::FILTER_GE: return "FilterType::FILTER_GE";
        case __hlt_ldap::LDAP::FilterType::FILTER_SUBSTR: return "FilterType::FILTER_SUBSTR";
        case __hlt_ldap::LDAP::FilterType::FILTER_EQ: return "FilterType::FILTER_EQ";
        case __hlt_ldap::LDAP::FilterType::FILTER_NOT: return "FilterType::FILTER_NOT";
        case __hlt_ldap::LDAP::FilterType::FILTER_OR: return "FilterType::FILTER_OR";
        case __hlt_ldap::LDAP::FilterType::FILTER_AND: return "FilterType::FILTER_AND";
        case __hlt_ldap::LDAP::FilterType::Undef: return "FilterType::Undef";
        default: return ::hilti::rt::fmt("FilterType::<unknown-%" PRIu64 ">", x.value());
    }
}

extern auto hlt_ldap::LDAP::AttributeSelection::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_ldap::LDAP::AttributeSelection::parse1(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_ldap::LDAP::AttributeSelection::parse2(::hilti::rt::ValueReference<__hlt_ldap::LDAP::AttributeSelection>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_ldap::LDAP::AttributeSelection::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_ldap::LDAP::AttributeSelection::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__gunit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_ldap::LDAP::AttributeSelection::parse3(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_ldap::LDAP::Message::parse2(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Message>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_ldap::LDAP::Message::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_ldap::LDAP::MessageDispatch::parse2(::hilti::rt::ValueReference<__hlt_ldap::LDAP::MessageDispatch>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_ldap::LDAP::MessageDispatch::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_ldap::LDAP::Messages::context_new() -> ::spicy::rt::UnitContext { return __hlt_ldap::LDAP::Messages::context_new(); }

extern auto hlt_ldap::LDAP::Messages::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_ldap::LDAP::Messages::parse1(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_ldap::LDAP::Messages::parse2(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Messages>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_ldap::LDAP::Messages::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_ldap::LDAP::Messages::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__gunit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_ldap::LDAP::Messages::parse3(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_ldap::LDAP::Result::parse1(::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_ldap::LDAP::Result::parse1(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_ldap::LDAP::Result::parse2(::hilti::rt::ValueReference<__hlt_ldap::LDAP::Result>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_ldap::LDAP::Result::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_ldap::LDAP::Result::parse3(::hilti::rt::ValueReference<::spicy::rt::ParsedUnit>& __gunit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__gunit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_ldap::LDAP::Result::parse3(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

extern auto hlt_ldap::LDAP::SearchRequest::parse2(::hilti::rt::ValueReference<__hlt_ldap::LDAP::SearchRequest>& __unit, ::hilti::rt::ValueReference<::hilti::rt::Stream>& __data, const std::optional<::hilti::rt::stream::View>& __cur, const std::optional<::spicy::rt::UnitContext>& __context) -> ::hilti::rt::Resumable {
    auto args = std::make_tuple(::hilti::rt::resumable::detail::copyArg(__unit), ::hilti::rt::resumable::detail::copyArg(__data), ::hilti::rt::resumable::detail::copyArg(__cur), ::hilti::rt::resumable::detail::copyArg(__context));
    auto args_on_heap = std::make_shared<decltype(args)>(std::move(args));
    auto cb = [args_on_heap](::hilti::rt::resumable::Handle* r) -> ::hilti::rt::any {
        return __hlt_ldap::LDAP::SearchRequest::parse2(std::get<0>(*args_on_heap), std::get<1>(*args_on_heap), std::get<2>(*args_on_heap), std::get<3>(*args_on_heap));
    };

    auto r = std::make_unique<::hilti::rt::Resumable>(std::move(cb));
    r->run();
    return std::move(*r);
}

